;*---------------------------------------------------------------------*/
;*   A pratical implementation for the Scheme programming language     */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*   Copyright (c) 1992-1999 Manuel Serrano                            */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo-request@kaolin.unice.fr                                */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bigloo/cigloo0.2/Translate/type.sch         */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Nov 28 15:10:40 1995                          */
;*    Last change :  Mon Apr  8 17:35:41 1996 (serrano)                */
;*    -------------------------------------------------------------    */
;*    Type structures                                                  */
;*    -------------------------------------------------------------    */
;*    This file supposes Tools/union.sch already included.             */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    type                                                             */
;*---------------------------------------------------------------------*/
(define-union type

   ;; common fields
   (id c-name $)

   ;; simple type
   (define-node simple-t
      ids)    ;; just a list of identifier

   ;; pointer to
   (define-node pointer-t
      type)   ;; a pointer to ...

   ;; array of
   (define-node array-t
      type)   ;; an array of ...

   ;; struct/union
   (define-node struct-t
      tag
      class
      fields)

   ;; enum
   (define-node enum-t
      tag
      fields)

   ;; function
   (define-node function-t
      to
      from)

   ;; typedef-t
   (define-node typedef-t
      alias)
   )
