;*---------------------------------------------------------------------*/
;*   A pratical implementation for the Scheme programming language     */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*   Copyright (c) 1992-1999 Manuel Serrano                            */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo-request@kaolin.unice.fr                                */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bigloo/recette/dsssl.scm                    */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Mar 31 09:21:59 1998                          */
;*    Last change :  Mon Sep 21 16:52:44 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    Dsssl keyword test                                               */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module dsssl
   (import  (main "main.scm"))
   (include "test.sch")
   (export  (test-dsssl)
	    (foo x y #!optional #!rest #!key)))

(define (foo x y #!optional z (zz 1) #!rest r #!key i (j 1))
   (let ((f (lambda (z y #!key (i 8)) (list z y i))))
      (labels ((g (a b #!rest l) (list a b l)))
	 (list x y z zz i: i j: j))))

(eval '(define (dsssl x y #!optional z (zz 1) #!rest r #!key i (j 1))
	  (let ((f (lambda (z y #!key (i 8)) (list z y i))))
	     (labels ((g (a b #!rest l) (list a b l)))
		(list x y z zz i: i j: j)))))
 
;*---------------------------------------------------------------------*/
;*    test-dsssl ...                                                   */
;*---------------------------------------------------------------------*/
(define (test-dsssl)
   (test-module "dsssl" "dsssl.scm")
   (test "dsssl" (foo 1 2 3 4 I: 5) '(1 2 3 4 I: 5 J: 1))
   (test "dsssl" ((lambda (x y #!optional z #!rest r #!key i (j 1))
		     (list x y z i: i j: j))
		  3 4 5 i: 6 i: 7)
	 '(3 4 5 I: 6 J: 1))
   (test "eval" (eval '(dsssl 1 2 3 4 I: 5)) '(1 2 3 4 I: 5 J: 1))
   (test "dsssl" (eval '((lambda (x y #!optional z #!rest r #!key i (j 1))
			    (list x y z i: i j: j))
		       3 4 5 i: 6 i: 7))
	 '(3 4 5 I: 6 J: 1)))
	 
