;*---------------------------------------------------------------------*/
;*   A pratical implementation for the Scheme programming language     */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*   Copyright (c) 1992-1999 Manuel Serrano                            */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo-request@kaolin.unice.fr                                */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bigloo/runtime/Eval/expd-try.scm            */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel SERRANO                                    */
;*    Creation    :  Tue Sep  1 16:21:59 1992                          */
;*    Last change :  Fri Sep 18 17:58:09 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    Try form expansion                                               */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __expander_try
   
   (import  (__error                   "Llib/error.scm")
	    (__bigloo                  "Llib/bigloo.scm")
	    (__tvector                 "Llib/tvector.scm")
	    (__structure               "Llib/struct.scm")
	    (__tvector                 "Llib/tvector.scm")
	    (__bexit                   "Llib/bexit.scm")
	    
	    (__r4_numbers_6_5          "Ieee/number.scm")
	    (__r4_numbers_6_5_fixnum   "Ieee/fixnum.scm")
	    (__r4_numbers_6_5_flonum   "Ieee/flonum.scm")
	    (__r4_characters_6_6       "Ieee/char.scm")
	    (__r4_equivalence_6_2      "Ieee/equiv.scm")
	    (__r4_booleans_6_1         "Ieee/boolean.scm")
	    (__r4_symbols_6_4          "Ieee/symbol.scm")
	    (__r4_strings_6_7          "Ieee/string.scm")
	    (__r4_pairs_and_lists_6_3  "Ieee/pair-list.scm")
	    (__r4_input_6_10_2         "Ieee/input.scm")
	    (__r4_control_features_6_9 "Ieee/control.scm")
	    (__r4_vectors_6_8          "Ieee/vector.scm")
	    (__r4_ports_6_10_1         "Ieee/port.scm")
	    (__r4_output_6_10_3        "Ieee/output.scm")
	    
	    (__progn                   "Eval/progn.scm"))
   
   (use     (__type                    "Llib/type.scm")
	    (__evenv                   "Eval/evenv.scm"))
   
   (export  (expand-try <expression> <expander>)))

;*---------------------------------------------------------------------*/
;*    expand-try ...                                                   */
;*    -------------------------------------------------------------    */
;*    This is a fixed version of expand-try. The fix has been          */
;*    proposed by:                                                     */
;*       Christopher Oliver  -- oliver@fritz.co.traverse.com           */
;*    Many thanks ...                                                  */
;*---------------------------------------------------------------------*/
(define (expand-try x e)
   (match-case x
      ((?- (and ?body (not ())) ?handler)
       (let ((nhandler (gensym 'handler))
	     (rhandler (gensym 'rhandler))
             (nbody    (gensym 'body))
	     (armed    (gensym 'armed)))
	  (e `(letrec ((,armed    #t)
		       (,nhandler ,handler)
		       (,rhandler (lambda (esc obj proc msg)
				     (set! ,armed #f)
				     (remove-error-handler!)
				     (,nhandler esc obj proc msg)))
		       (,nbody    (lambda () ,body)))
		 (bind-exit (escape)
		    (dynamic-wind
		       (lambda () (add-error-handler! ,rhandler escape))
		       ,nbody
		       (lambda () (if ,armed
				      (begin
					 (set! ,armed #f)
					 (remove-error-handler!)))))))
	     e)))
      (else
       (error "try" "Illegal form" x))))

(define (expand-try.old.old x e)
   (match-case x
      ((?- (and ?body (not ())) ?handler)
       (let ((nhandler (gensym 'handler))
             (nbody    (gensym 'body))
             (armed    (gensym 'armed)))
          (e `(let ((,nhandler ,handler)
		    (,nbody    (lambda () ,body))
		    (,armed    #t))
                 (bind-exit (escape)
                    (add-error-handler! ,nhandler
					(lambda (arg)
					   (set! ,armed #f)
					   (escape arg)))
                    (unwind-protect
		       (,nbody)
		       (if ,armed (remove-error-handler!)))))
             e)))
      (else
       (error "try" "Illegal form" x))))



