/*===========================================================================*/
/*   (Cfa/cinfo.scm)                                                         */
/*   Bigloo (2.0)                                                            */
/*   Manuel Serrano (c)       Thu Feb 11 22:46:22 CET 1999                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.0a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
  }
    *type_t;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_t;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_t;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_t;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_t;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_t;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_t;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_t;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_t;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_t;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_t;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_t;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_t;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_t;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_t;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_t;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_t;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_t;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_t;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_t;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_t;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_t;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_t;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_t;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_t;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_t;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_t;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_t;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_t;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_t;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_t;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_t;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_t;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_t;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_t;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_t;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_t;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_t;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_t;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_t;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_t;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_t;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_t;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_t;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_t;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_t;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_t;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_t;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_t;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_t;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_t;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_t;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_t;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_t;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_t;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_t;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_t;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_t;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_t;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_t;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_t;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_t;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_t;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_t;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_t;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_t;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_t;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_t;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_t;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_t;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_t;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_t;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_t;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_t;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_t;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_t;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_t;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_t;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_t;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_t;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_t;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_t;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_t;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_t;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_t;


static obj_t _reshaped_global_evaluable_4369_74_cfa_info(obj_t, obj_t);
static obj_t object__struct_pre_clo_env_226_cfa_info(obj_t, obj_t);
static obj_t _make_cvar_cinfo4405_180_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_struct_app_args3859_196_cfa_info(obj_t, obj_t);
extern obj_t conditional_cinfo_loc_197_cfa_info(conditional_t);
static obj_t _widening1005_scnst_cinfo4417_213_cfa_info(obj_t, obj_t);
static obj_t _struct_set__app_loc3822_188_cfa_info(obj_t, obj_t);
extern approx_t scnst_cinfo_approx_162_cfa_info(scnst_cinfo_0_t);
static obj_t _atom_cinfo_approx4348_99_cfa_info(obj_t, obj_t);
extern obj_t make_procedure_app_stack_info_60_cfa_info(app_t);
extern variable_t make_struct_app_owner_33_cfa_info(make_struct_app_214_t);
extern app_t allocate_pre_make_vector_app_231_cfa_info();
extern obj_t vector_set__app_stack_info_174_cfa_info(app_t);
extern obj_t reshaped_local_access_set__128_cfa_info(local_t, obj_t);
static obj_t _make_box_o_cinfo_key_set__74_cfa_info(obj_t, obj_t, obj_t);
extern obj_t extern_sfun_cinfo_side_effect__set__111_cfa_info(sfun_t, obj_t);
extern cfun_cinfo_200_t widening1002_cfun_cinfo_213_cfa_info(approx_t);
extern obj_t select_cinfo_side_effect__set__150_cfa_info(select_t, obj_t);
extern obj_t atom_cinfo_loc_162_cfa_info(atom_t);
static obj_t _extern_sfun_cinfo_the_closure_set_4464_103_cfa_info(obj_t, obj_t, obj_t);
extern sexit_cinfo_49_t widening1009_sexit_cinfo_132_cfa_info(approx_t);
extern approx_t intern_sfun_cinfo_approx_57_cfa_info(intern_sfun_cinfo_192_t);
extern obj_t reshaped_local_binding_value_248_cfa_info(reshaped_local_224_t);
extern obj_t setq_cinfo_loc_179_cfa_info(setq_t);
extern obj_t struct_set__app_type_set__172_cfa_info(app_t, type_t);
extern obj_t pre_clo_env_loc_set__78_cfa_info(svar_t, obj_t);
static obj_t _make_box_o_cinfo_key4195_188_cfa_info(obj_t, obj_t);
static obj_t object__struct_pre_make_struct_app_244_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box_value_set_4219_159_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_type4080_241_cfa_info(obj_t, obj_t);
static obj_t method_init_76_cfa_info();
static obj_t _make_make_procedure_app4077_0_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_box_202_ast_node;
static obj_t _extern_sfun_cinfo_dsssl_keywords4475_201_cfa_info(obj_t, obj_t);
extern obj_t struct_set__app_loc_83_cfa_info(app_t);
static obj_t _funcall_cinfo_type_error_noticed_4316_69_cfa_info(obj_t, obj_t);
extern obj_t pragma_cinfo_side_effect__231_cfa_info(pragma_t);
static obj_t _make_box_set__cinfo4179_235_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t reshaped_global_evaluable__213_cfa_info(global_t);
extern obj_t make_vector_app_lost_stamp_set__132_cfa_info(make_vector_app_205_t, long);
static obj_t _vector_ref_app_stack_info_set_3937_136_cfa_info(obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_dsssl_keywords_set__175_cfa_info(sfun_t, obj_t);
extern obj_t funcall_cinfo_args_set__97_cfa_info(funcall_t, obj_t);
static obj_t _reshaped_local_removable_set_4389_217_cfa_info(obj_t, obj_t, obj_t);
extern struct_set__app_162_t widening1050_struct_set__app_76_cfa_info(approx_t);
static obj_t _extern_sfun_cinfo_dsssl_keywords_set_4474_11_cfa_info(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_lost_stamp3958_168_cfa_info(obj_t, obj_t);
static obj_t _make_struct_app_stack_stamp_set_3870_221_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_import_set_4366_139_cfa_info(obj_t, obj_t, obj_t);
extern bool_t funcall_cinfo_arity_error_noticed__251_cfa_info(funcall_cinfo_75_t);
static obj_t _make_vector_app_stackable_3987_124_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_ref_app_loc_154_cfa_info(app_t);
extern pre_clo_env_191_t widening1006_pre_clo_env_44_cfa_info();
extern obj_t pre_make_vector_app_fun_set__108_cfa_info(app_t, var_t);
extern var_t pre_make_vector_app_fun_151_cfa_info(app_t);
extern obj_t box_set__cinfo_value_set__94_cfa_info(box_set__221_t, node_t);
static obj_t _make_vector_app_stack_info_set_3978_28_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_occurrence_set__92_cfa_info(global_t, long);
extern obj_t make_procedure_app_key_144_cfa_info(app_t);
extern obj_t reshaped_global_user__set__184_cfa_info(global_t, bool_t);
static obj_t _widening1026_make_box_o_cinfo4188_73_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_stack_allocator4461_171_cfa_info(obj_t, obj_t);
static obj_t _make_vector_app_side_effect_3972_17_cfa_info(obj_t, obj_t);
extern bool_t cvar_cinfo__125_cfa_info(obj_t);
extern obj_t conditional_cinfo_side_effect__set__214_cfa_info(conditional_t, obj_t);
extern fail_cinfo_75_t widening1020_fail_cinfo_114_cfa_info(approx_t);
extern obj_t funcall_ast_node;
extern obj_t funcall_cinfo_arity_error_noticed__set__137_cfa_info(funcall_cinfo_75_t, bool_t);
extern obj_t conditional_cinfo_key_148_cfa_info(conditional_t);
static obj_t struct_object__object_intern_sfun_cinfo_38_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_jump_ex_it_cinfo_111_cfa_info(obj_t, obj_t);
static obj_t _create_vector_app_type3944_91_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo__48_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_the_closure_set__203_cfa_info(sfun_t, obj_t);
static obj_t _pre_procedure_set__app_stack_info4119_155_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_name_set_4351_195_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_args_type4492_112_cfa_info(obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_loc4223_55_cfa_info(obj_t, obj_t);
extern type_t reshaped_local_type_195_cfa_info(local_t);
extern bool_t svar_cinfo_clo_env__3_cfa_info(svar_cinfo_166_t);
extern type_t app_ly_cinfo_type_137_cfa_info(app_ly_162_t);
extern bool_t box_ref_cinfo__23_cfa_info(obj_t);
static obj_t _fail_cinfo_approx4264_42_cfa_info(obj_t, obj_t);
extern obj_t svar_cinfo_loc_set__81_cfa_info(svar_t, obj_t);
static obj_t _pre_struct_set__app_fun3879_141_cfa_info(obj_t, obj_t);
static obj_t _make_vector_app_stackable__set_3986_235_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1044_vector_set__app3912_19_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_ref_app_loc4005_201_cfa_info(obj_t, obj_t);
extern obj_t jump_ex_it_cinfo_loc_13_cfa_info(jump_ex_it_184_t);
static obj_t _make_procedure_app_key4083_226_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_class4473_67_cfa_info(obj_t, obj_t);
extern obj_t cfun_cinfo_stack_allocator_set__152_cfa_info(cfun_t, obj_t);
static obj_t _reshaped_global_name4352_232_cfa_info(obj_t, obj_t);
extern obj_t struct_ref_app_side_effect__151_cfa_info(app_t);
extern bool_t reshaped_local_user__5_cfa_info(local_t);
extern obj_t make_procedure_app_stack_stamp_100_cfa_info(make_procedure_app_48_t);
extern app_t allocate_make_vector_app_226_cfa_info();
static obj_t _allocate_extern_sfun_cinfo_234_cfa_info(obj_t);
extern bool_t make_struct_app_stackable__22_cfa_info(make_struct_app_214_t);
extern obj_t make_box_o_cinfo_side_effect__220_cfa_info(make_box_202_t);
extern obj_t make_struct_app_approx_set__191_cfa_info(make_struct_app_214_t, approx_t);
extern obj_t cfun_cinfo_args_type_205_cfa_info(cfun_t);
static obj_t _pre_clo_env_loc4416_146_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_ref_app_side_effect__set_3888_128_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_struct_ref_app_side_effect__set__16_cfa_info(app_t, obj_t);
extern obj_t make_struct_app_key_set__110_cfa_info(app_t, obj_t);
static obj_t _make_struct_set__app3821_217_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t struct_set__app_key_92_cfa_info(app_t);
obj_t box_set__cinfo_94_cfa_info = BUNSPEC;
extern node_t funcall_cinfo_fun_73_cfa_info(funcall_t);
extern var_t pre_make_procedure_app_fun_199_cfa_info(app_t);
static obj_t _jump_ex_it_cinfo__23_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo_item_type4251_143_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_set__app_side_effect__17_cfa_info(app_t);
static obj_t _widening1003_extern_sfun_cinfo4453_165_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_ref_app_args4013_248_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_pre_clo_env_30_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_box_cinfo_side_effect__155_cfa_info(make_box_202_t);
static obj_t _pragma_cinfo_key_set__201_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_make_procedure_app_51_cfa_info(obj_t, obj_t, obj_t);
extern intern_sfun_cinfo_192_t make_intern_sfun_cinfo_198_cfa_info(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, approx_t, long);
extern type_t make_box_cinfo_type_207_cfa_info(make_box_202_t);
extern approx_t create_vector_app_approx_174_cfa_info(create_vector_app_150_t);
extern setq_cinfo_191_t widening1018_setq_cinfo_59_cfa_info(approx_t);
extern obj_t funcall_cinfo_strength_set__61_cfa_info(funcall_t, obj_t);
extern obj_t extern_sfun_cinfo_args_4_cfa_info(sfun_t);
static obj_t _box_ref_o_cinfo_side_effect__set_4153_214_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_vector_ref_app_key_59_cfa_info(app_t);
extern type_t make_struct_app_type_23_cfa_info(app_t);
obj_t make_box_cinfo_127_cfa_info = BUNSPEC;
static obj_t object__struct_pre_procedure_ref_app_223_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_pre_make_vector_app_45_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1037_pre_make_vector_app4032_253_cfa_info(obj_t, obj_t);
extern create_vector_app_150_t widening1042_create_vector_app_219_cfa_info(approx_t, approx_t, long, variable_t, bool_t, obj_t, bool_t);
extern type_t vector_set__app_type_116_cfa_info(app_t);
static obj_t _make_pre_vector_ref_app4004_14_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_procedure_set__app_side_effect__40_cfa_info(app_t);
static obj_t _reshaped_global_user__set_4372_177_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_name_set__33_cfa_info(global_t, obj_t);
static obj_t _allocate_pre_create_vector_app_171_cfa_info(obj_t);
static obj_t _setq_cinfo_var_set_4284_103_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pragma_cinfo__129_cfa_info(obj_t, obj_t);
static obj_t _make_approx4497_37_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t struct_ref_app_args_190_cfa_info(app_t);
extern cvar_cinfo_53_t widening1008_cvar_cinfo_33_cfa_info(approx_t);
extern obj_t pre_make_struct_app_side_effect__189_cfa_info(app_t);
extern obj_t fail_ast_node;
obj_t pre_struct_set__app_116_cfa_info = BUNSPEC;
extern bool_t scnst_cinfo__144_cfa_info(obj_t);
extern obj_t set_ex_it_cinfo_var_set__245_cfa_info(set_ex_it_116_t, var_t);
extern obj_t box_ref_o_cinfo_key_set__15_cfa_info(box_ref_242_t, obj_t);
static obj_t _intern_sfun_cinfo_args4441_113_cfa_info(obj_t, obj_t);
extern obj_t make_vector_app_stackable__set__110_cfa_info(make_vector_app_205_t, bool_t);
extern obj_t intern_sfun_cinfo_stamp_set__83_cfa_info(intern_sfun_cinfo_192_t, long);
extern obj_t struct_set__app_args_163_cfa_info(app_t);
static obj_t _allocate_pre_make_procedure_app_108_cfa_info(obj_t);
static obj_t _procedure_set__app_type4052_159_cfa_info(obj_t, obj_t);
extern obj_t make_struct_app_loc_176_cfa_info(app_t);
static obj_t struct_object__object_setq_cinfo_26_cfa_info(obj_t, obj_t, obj_t);
extern bool_t struct_set__app__191_cfa_info(obj_t);
extern pre_vector_ref_app_208_t make_pre_vector_ref_app_82_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t);
static obj_t _struct_ref_app_side_effect__set_3839_174_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_ref_app_side_effect_4125_202_cfa_info(obj_t, obj_t);
extern bool_t sexit_cinfo_detached__124_cfa_info(sexit_t);
static obj_t _make_pre_create_vector_app4017_15_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t vector_ref_app__203_cfa_info(obj_t);
extern app_t allocate_pre_vector_set__app_20_cfa_info();
static obj_t _pre_make_vector_app_args4044_120_cfa_info(obj_t, obj_t);
extern obj_t make_struct_app_stack_info_set__189_cfa_info(app_t, obj_t);
obj_t funcall_cinfo_75_cfa_info = BUNSPEC;
extern obj_t box_ref_o_cinfo_var_set__204_cfa_info(box_ref_242_t, var_t);
static obj_t _make_svar_cinfo4409_207_cfa_info(obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_make_box_o_cinfo_104_cfa_info(obj_t, obj_t);
static obj_t _kwote_node__166_cfa_info(obj_t, obj_t);
static obj_t _pre_make_struct_app_type3900_2_cfa_info(obj_t, obj_t);
static obj_t _allocate_pre_make_box_48_cfa_info(obj_t);
static obj_t struct_object__object_procedure_ref_app_161_cfa_info(obj_t, obj_t, obj_t);
static obj_t _kwote_cinfo_approx4333_226_cfa_info(obj_t, obj_t);
obj_t conditional_cinfo_212_cfa_info = BUNSPEC;
extern bool_t pre_create_vector_app__191_cfa_info(obj_t);
extern obj_t setq_cinfo_var_set__169_cfa_info(setq_t, var_t);
static obj_t _make_app_ly_cinfo4318_157_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern node_t kwote_node_node_71_cfa_info(kwote_node_102_t);
static obj_t _allocate_scnst_cinfo_162_cfa_info(obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t reshaped_global_access_set__53_cfa_info(global_t, obj_t);
static obj_t struct_object__object_jump_ex_it_cinfo_82_cfa_info(obj_t, obj_t, obj_t);
extern app_ly_162_t allocate_app_ly_cinfo_200_cfa_info();
extern var_t make_procedure_app_fun_101_cfa_info(app_t);
static obj_t _pre_procedure_set__app_stack_info_set_4118_226_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_type_set_3823_57_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_struct_app_stackable_3869_173_cfa_info(obj_t, obj_t);
static obj_t _pragma_cinfo_args4298_204_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_value4197_165_cfa_info(obj_t, obj_t);
static obj_t _box_ref_o_cinfo_var_set_4155_190_cfa_info(obj_t, obj_t, obj_t);
extern local_t allocate_reshaped_local_100_cfa_info();
extern var_t set_ex_it_cinfo_var_14_cfa_info(set_ex_it_116_t);
static obj_t _reshaped_local_binding_value4396_81_cfa_info(obj_t, obj_t);
extern obj_t create_vector_app_stack_stamp_set__220_cfa_info(create_vector_app_150_t, obj_t);
static obj_t _make_procedure_app_key_set__144_cfa_info(obj_t, obj_t, obj_t);
static obj_t _select_cinfo__186_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_ref_app_type3887_59_cfa_info(obj_t, obj_t);
static obj_t _vector_ref_app_approx3939_106_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_name_190_cfa_info(global_t);
extern obj_t pre_vector_set__app_loc_126_cfa_info(app_t);
static obj_t _make_make_struct_app3849_83_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _pre_procedure_ref_app_fun4127_167_cfa_info(obj_t, obj_t);
static obj_t _pre_make_procedure_app_stack_info4146_76_cfa_info(obj_t, obj_t);
static obj_t _kwote_node_type_set_4337_57_cfa_info(obj_t, obj_t, obj_t);
extern obj_t select_cinfo_key_set__126_cfa_info(select_t, obj_t);
static obj_t _pre_procedure_set__app_fun_set_4114_225_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_kwote_cinfo4328_235_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_property4467_53_cfa_info(obj_t, obj_t);
obj_t pre_make_struct_app_218_cfa_info = BUNSPEC;
static obj_t _pre_struct_set__app_args_set_3880_136_cfa_info(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_fun_set_4055_58_cfa_info(obj_t, obj_t, obj_t);
static obj_t _set_ex_it_cinfo_body4239_6_cfa_info(obj_t, obj_t);
extern bool_t jump_ex_it_cinfo__199_cfa_info(obj_t);
extern cfun_t allocate_cfun_cinfo_179_cfa_info();
static obj_t _kwote_node_type4338_162_cfa_info(obj_t, obj_t);
extern scnst_cinfo_0_t make_scnst_cinfo_57_cfa_info(obj_t, obj_t, obj_t, approx_t);
extern obj_t make_vector_app_fun_set__56_cfa_info(app_t, var_t);
extern obj_t pre_struct_ref_app_side_effect__198_cfa_info(app_t);
extern obj_t make_struct_app_key_199_cfa_info(app_t);
static obj_t _allocate_funcall_cinfo_40_cfa_info(obj_t);
static obj_t _app_ly_cinfo_fun4323_133_cfa_info(obj_t, obj_t);
extern obj_t box_set__o_cinfo_loc_249_cfa_info(box_set__221_t);
static obj_t _pre_struct_ref_app_stack_info3895_249_cfa_info(obj_t, obj_t);
extern procedure_ref_app_49_t make_procedure_ref_app_197_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t);
static obj_t _struct_ref_app_loc3836_68_cfa_info(obj_t, obj_t);
static obj_t _create_vector_app_key_set__7_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_vector_ref_app_116_cfa_info(obj_t, obj_t, obj_t);
extern intern_sfun_cinfo_192_t widening1004_intern_sfun_cinfo_148_cfa_info(approx_t, long);
static obj_t _reshaped_local_user__set_4393_102_cfa_info(obj_t, obj_t, obj_t);
extern bool_t cfun_cinfo__10_cfa_info(obj_t);
static obj_t _pre_vector_ref_app_args_set_4012_83_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_side_effect_4038_113_cfa_info(obj_t, obj_t);
obj_t pre_create_vector_app_162_cfa_info = BUNSPEC;
static obj_t _intern_sfun_cinfo_property_set_4438_254_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_vector_app_fun_set_3974_137_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_create_vector_app_side_effect_4022_243_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_set__app_stack_info_set__9_cfa_info(app_t, obj_t);
extern var_t struct_set__app_fun_107_cfa_info(app_t);
obj_t cfun_cinfo_200_cfa_info = BUNSPEC;
static obj_t _cfun_cinfo_top_4489_13_cfa_info(obj_t, obj_t);
extern svar_cinfo_166_t make_svar_cinfo_148_cfa_info(obj_t, approx_t, bool_t);
static obj_t _intern_sfun_cinfo_property4439_34_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_set__app_stack_info_98_cfa_info(app_t);
static obj_t _cfun_cinfo_macro_4493_246_cfa_info(obj_t, obj_t);
extern obj_t box_ref_cinfo_type_set__65_cfa_info(box_ref_242_t, type_t);
static obj_t _box_ref_o_cinfo_var4156_18_cfa_info(obj_t, obj_t);
static obj_t _make_sexit_cinfo4398_253_cfa_info(obj_t, obj_t, obj_t, obj_t);
extern obj_t procedure_set__app_type_set__29_cfa_info(app_t, type_t);
static obj_t _vector_set__app_stack_info_set_3923_27_cfa_info(obj_t, obj_t, obj_t);
extern long reshaped_global_occurrence_72_cfa_info(global_t);
extern app_t allocate_vector_set__app_126_cfa_info();
static obj_t _sexit_cinfo_handler4400_92_cfa_info(obj_t, obj_t);
static obj_t _set_ex_it_cinfo_type_set_4234_28_cfa_info(obj_t, obj_t, obj_t);
extern bool_t pre_vector_set__app__39_cfa_info(obj_t);
static obj_t _vector_set__app_fun3920_255_cfa_info(obj_t, obj_t);
static obj_t _box_set__cinfo_type4182_217_cfa_info(obj_t, obj_t);
extern var_t pre_vector_ref_app_fun_8_cfa_info(app_t);
static obj_t _make_procedure_app_approx_set_4090_181_cfa_info(obj_t, obj_t, obj_t);
extern value_t reshaped_global_value_27_cfa_info(global_t);
extern obj_t pre_make_vector_app_stack_info_set__175_cfa_info(app_t, obj_t);
static obj_t _widening1031_pre_make_procedure_app4132_79_cfa_info(obj_t, obj_t);
extern bool_t approx_top__34_cfa_info(approx_t);
extern long make_procedure_app_lost_stamp_58_cfa_info(make_procedure_app_48_t);
static obj_t object__struct_pre_procedure_set__app_130_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_set__app_side_effect__set_3996_17_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_struct_ref_app_key_126_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_set__app_key_243_cfa_info(app_t);
static obj_t _make_struct_app_stack_info_set_3860_205_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_make_procedure_app_stack_info_161_cfa_info(app_t);
static obj_t _box_set__o_cinfo_var_set_4163_39_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_jump_ex_it_cinfo4222_70_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_make_struct_app_args_set__137_cfa_info(app_t, obj_t);
static obj_t struct_object__object_pre_vector_set__app_122_cfa_info(obj_t, obj_t, obj_t);
extern sfun_t allocate_intern_sfun_cinfo_151_cfa_info();
extern pre_make_box_186_t widening1024_pre_make_box_161_cfa_info();
static obj_t _pre_procedure_ref_app_fun_set_4126_166_cfa_info(obj_t, obj_t, obj_t);
static obj_t _fail_cinfo__61_cfa_info(obj_t, obj_t);
static obj_t _widening1046_pre_struct_ref_app_77_cfa_info(obj_t);
static obj_t struct_object__object_make_box_o_cinfo_100_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_make_vector_app_type_set__223_cfa_info(app_t, type_t);
static obj_t _widening1038_pre_create_vector_app4016_34_cfa_info(obj_t, obj_t);
static obj_t _widening1036_procedure_set__app4048_121_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_set__app_stack_info_set_3882_247_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_type_set_4079_172_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_box_key4218_85_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_key_222_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_reshaped_global_132_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_args_set__42_cfa_info(app_t, obj_t);
static obj_t _create_vector_app_stack_stamp3963_42_cfa_info(obj_t, obj_t);
static obj_t _procedure_ref_app_fun_set_4069_83_cfa_info(obj_t, obj_t, obj_t);
extern obj_t atom_cinfo_value_110_cfa_info(atom_t);
static obj_t _procedure_set__app_key_set__54_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_struct_app_stackable__set_3868_160_cfa_info(obj_t, obj_t, obj_t);
extern obj_t kwote_node_loc_4_cfa_info(kwote_t);
static obj_t _box_set__o_cinfo_loc4160_0_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_ref_app_args_207_cfa_info(app_t);
static obj_t _pre_make_vector_app__65_cfa_info(obj_t, obj_t);
static obj_t _struct_set__app_side_effect_3826_199_cfa_info(obj_t, obj_t);
extern obj_t struct_ref_app_fun_set__15_cfa_info(app_t, var_t);
static obj_t _make_box_o_cinfo_approx_set_4198_214_cfa_info(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_key_set__89_cfa_info(app_t, obj_t);
static obj_t _struct_set__app_fun_set_3827_17_cfa_info(obj_t, obj_t, obj_t);
extern obj_t box_ref_o_cinfo_side_effect__set__170_cfa_info(box_ref_242_t, obj_t);
static obj_t _box_set__o_cinfo_type4162_84_cfa_info(obj_t, obj_t);
extern box_set__221_t allocate_box_set__o_cinfo_236_cfa_info();
static obj_t _create_vector_app_loc3942_173_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_stack_info_22_cfa_info(app_t);
extern obj_t make_procedure_app_x_set__126_cfa_info(make_procedure_app_48_t, bool_t);
extern obj_t procedure_ref_app_stack_info_set__100_cfa_info(app_t, obj_t);
extern bool_t kwote_node__206_cfa_info(obj_t);
static obj_t _kwote_cinfo__102_cfa_info(obj_t, obj_t);
static obj_t object__struct_scnst_cinfo_225_cfa_info(obj_t, obj_t);
obj_t reshaped_global_160_cfa_info = BUNSPEC;
extern atom_cinfo_155_t make_atom_cinfo_25_cfa_info(obj_t, type_t, obj_t, approx_t);
extern object_t struct_object__object_93___object(object_t, obj_t);
static obj_t _struct_ref_app_approx3847_222_cfa_info(obj_t, obj_t);
extern variable_t pre_create_vector_app_owner_119_cfa_info(pre_create_vector_app_162_t);
static obj_t _pre_procedure_ref_app__123_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_set__app_stack_info_set__151_cfa_info(app_t, obj_t);
static obj_t struct_object__object_box_ref_o_cinfo_19_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_side_effect__set_4037_222_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_box_type4214_63_cfa_info(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_set__app_loc_154_cfa_info(app_t);
static obj_t _pre_struct_ref_app_key_set__136_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_user_4373_223_cfa_info(obj_t, obj_t);
extern obj_t box_ref_cinfo_side_effect__63_cfa_info(box_ref_242_t);
extern obj_t intern_sfun_cinfo_stack_allocator_82_cfa_info(sfun_t);
extern approx_t procedure_set__app_approx_70_cfa_info(procedure_set__app_32_t);
extern obj_t pre_create_vector_app_args_163_cfa_info(app_t);
static obj_t _make_procedure_app__219_cfa_info(obj_t, obj_t);
static obj_t _allocate_select_cinfo_74_cfa_info(obj_t);
static obj_t _make_conditional_cinfo4266_140_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern approx_t make_vector_app_value_approx_202_cfa_info(make_vector_app_205_t);
extern obj_t reshaped_local_occurrence_set__7_cfa_info(local_t, long);
extern obj_t global_ast_var;
static obj_t _extern_sfun_cinfo_the_closure4465_235_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_removable_103_cfa_info(local_t);
extern type_t select_cinfo_type_249_cfa_info(select_t);
extern obj_t conditional_cinfo_false_set__59_cfa_info(conditional_t, node_t);
extern var_t make_struct_app_fun_76_cfa_info(app_t);
static obj_t _make_vector_app_value_approx3982_99_cfa_info(obj_t, obj_t);
static obj_t _make_box_cinfo_side_effect_4207_157_cfa_info(obj_t, obj_t);
extern node_t jump_ex_it_cinfo_value_33_cfa_info(jump_ex_it_184_t);
static obj_t _pre_make_struct_app_key3904_233_cfa_info(obj_t, obj_t);
static obj_t object__struct_setq_cinfo_111_cfa_info(obj_t, obj_t);
extern pre_make_vector_app_251_t make_pre_make_vector_app_107_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, variable_t);
extern obj_t pre_create_vector_app_stack_info_137_cfa_info(app_t);
static obj_t _make_procedure_app_args4087_72_cfa_info(obj_t, obj_t);
static obj_t _make_struct_app_fun3857_148_cfa_info(obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_type4225_115_cfa_info(obj_t, obj_t);
static obj_t _make_vector_app_stack_stamp3989_185_cfa_info(obj_t, obj_t);
extern obj_t app_ly_cinfo_loc_252_cfa_info(app_ly_162_t);
extern svar_t allocate_pre_clo_env_40_cfa_info();
extern obj_t conditional_cinfo_key_set__171_cfa_info(conditional_t, obj_t);
obj_t box_ref_o_cinfo_98_cfa_info = BUNSPEC;
static obj_t _box_set__cinfo_value4186_7_cfa_info(obj_t, obj_t);
extern obj_t pragma_ast_node;
extern jump_ex_it_cinfo_139_t widening1023_jump_ex_it_cinfo_79_cfa_info(approx_t);
static obj_t _widening1032_pre_procedure_ref_app_158_cfa_info(obj_t);
extern bool_t funcall_cinfo_type_error_noticed__56_cfa_info(funcall_cinfo_75_t);
static obj_t _vector_ref_app_type3930_49_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_occurrence4364_159_cfa_info(obj_t, obj_t);
extern obj_t make_procedure_app_side_effect__185_cfa_info(app_t);
extern obj_t pre_make_struct_app_fun_set__18_cfa_info(app_t, var_t);
static obj_t _allocate_pre_make_vector_app_80_cfa_info(obj_t);
extern variable_t pre_make_procedure_app_owner_169_cfa_info(pre_make_procedure_app_60_t);
static obj_t _funcall_cinfo_args_set_4307_122_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_set_ex_it_cinfo_254_cfa_info(obj_t, obj_t, obj_t);
extern box_ref_242_t allocate_box_ref_cinfo_31_cfa_info();
extern approx_t procedure_ref_app_approx_118_cfa_info(procedure_ref_app_49_t);
obj_t pre_procedure_set__app_208_cfa_info = BUNSPEC;
extern obj_t pre_make_box_side_effect__set__136_cfa_info(make_box_202_t, obj_t);
extern obj_t make_struct_app_stack_stamp_197_cfa_info(make_struct_app_214_t);
static obj_t _make_vector_app_stack_stamp_set_3988_78_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_set__o_cinfo_approx4167_50_cfa_info(obj_t, obj_t);
extern obj_t box_set__cinfo_type_set__127_cfa_info(box_set__221_t, type_t);
extern struct_ref_app_73_t make_struct_ref_app_97_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t);
static obj_t _reshaped_global_access_set_4357_87_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_evaluable__set_4368_13_cfa_info(obj_t, obj_t, obj_t);
extern app_t allocate_procedure_ref_app_165_cfa_info();
static obj_t _setq_cinfo_var4285_116_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_set__app_type_set__58_cfa_info(app_t, type_t);
static obj_t _widening1017_pragma_cinfo4289_191_cfa_info(obj_t, obj_t);
extern obj_t pre_make_procedure_app_type_set__46_cfa_info(app_t, type_t);
static obj_t _vector_set__app_args_set_3921_32_cfa_info(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_args3951_133_cfa_info(obj_t, obj_t);
extern obj_t cvar_ast_var;
static obj_t _create_vector_app_stack_info3953_169_cfa_info(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
static obj_t _reshaped_local_value4384_82_cfa_info(obj_t, obj_t);
obj_t set_ex_it_cinfo_168_cfa_info = BUNSPEC;
extern var_t pre_vector_set__app_fun_157_cfa_info(app_t);
static obj_t _vector_ref_app_stack_info3938_180_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_set__app_key_59_cfa_info(app_t);
static obj_t struct_object__object_extern_sfun_cinfo_23_cfa_info(obj_t, obj_t, obj_t);
extern jump_ex_it_cinfo_139_t make_jump_ex_it_cinfo_16_cfa_info(obj_t, type_t, node_t, node_t, approx_t);
extern app_t allocate_pre_make_procedure_app_4_cfa_info();
extern obj_t procedure_set__app_loc_37_cfa_info(app_t);
static obj_t _vector_ref_app_fun3934_63_cfa_info(obj_t, obj_t);
extern obj_t make_box_o_cinfo_value_set__222_cfa_info(make_box_202_t, node_t);
static obj_t _reshaped_global_removable4362_127_cfa_info(obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_t, obj_t, obj_t);
extern cvar_t allocate_cvar_cinfo_69_cfa_info();
extern obj_t create_vector_app_args_44_cfa_info(app_t);
static obj_t _widening1029_box_set__o_cinfo4158_92_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_struct_set__app_209_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_stamp4452_130_cfa_info(obj_t, obj_t);
extern select_cinfo_150_t widening1021_select_cinfo_60_cfa_info(approx_t);
static obj_t _pre_make_procedure_app__252_cfa_info(obj_t, obj_t);
static obj_t _set_ex_it_cinfo_loc4233_210_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_stack_info_set__115_cfa_info(app_t, obj_t);
static obj_t _pre_make_procedure_app_stack_info_set_4145_174_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_box_o_cinfo_type_set__41_cfa_info(make_box_202_t, type_t);
extern obj_t pre_procedure_set__app_args_set__156_cfa_info(app_t, obj_t);
static obj_t _make_procedure_app_lost_stamp4096_31_cfa_info(obj_t, obj_t);
static obj_t _pre_make_procedure_app_type_set_4135_203_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_box_o_cinfo_loc_160_cfa_info(make_box_202_t);
extern bool_t cvar_cinfo_macro__62_cfa_info(cvar_t);
extern obj_t vector_ref_app_loc_223_cfa_info(app_t);
static obj_t _pre_create_vector_app_owner4031_176_cfa_info(obj_t, obj_t);
static obj_t _widening1004_intern_sfun_cinfo4425_56_cfa_info(obj_t, obj_t, obj_t);
obj_t cvar_cinfo_53_cfa_info = BUNSPEC;
static obj_t _make_box_set__o_cinfo4159_124_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern approx_t make_procedure_app_values_approx_ref_67_cfa_info(make_procedure_app_48_t, long);
static obj_t object__struct_funcall_cinfo_250_cfa_info(obj_t, obj_t);
extern bool_t fail_cinfo__175_cfa_info(obj_t);
extern obj_t pre_procedure_ref_app_args_98_cfa_info(app_t);
extern approx_t make_box_cinfo_approx_244_cfa_info(make_box_cinfo_127_t);
static obj_t _make_vector_app_loc3968_153_cfa_info(obj_t, obj_t);
obj_t struct_set__app_162_cfa_info = BUNSPEC;
static obj_t _pre_struct_set__app_side_effect_3877_36_cfa_info(obj_t, obj_t);
obj_t vector_ref_app_195_cfa_info = BUNSPEC;
extern approx_t sexit_cinfo_approx_118_cfa_info(sexit_cinfo_49_t);
static obj_t struct_object__object_scnst_cinfo_187_cfa_info(obj_t, obj_t, obj_t);
obj_t jump_ex_it_cinfo_139_cfa_info = BUNSPEC;
extern obj_t intern_sfun_cinfo_dsssl_keywords_133_cfa_info(sfun_t);
static obj_t _intern_sfun_cinfo_body4443_134_cfa_info(obj_t, obj_t);
extern fail_t allocate_fail_cinfo_138_cfa_info();
extern obj_t atom_cinfo_value_set__32_cfa_info(atom_t, obj_t);
static obj_t _make_box_cinfo_value_set_4208_18_cfa_info(obj_t, obj_t, obj_t);
extern extern_sfun_cinfo_6_t make_extern_sfun_cinfo_180_cfa_info(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, approx_t);
static obj_t _make_pre_make_vector_app4033_155_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _box_ref_cinfo_var4176_172_cfa_info(obj_t, obj_t);
static obj_t _pre_create_vector_app_key4024_163_cfa_info(obj_t, obj_t);
extern app_t allocate_pre_struct_ref_app_69_cfa_info();
static obj_t _reshaped_local_occurrence4392_74_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_predicate_of_set__1_cfa_info(sfun_t, obj_t);
extern pre_create_vector_app_162_t make_pre_create_vector_app_207_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, variable_t);
static obj_t _make_procedure_set__app4049_250_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern procedure_ref_app_49_t widening1035_procedure_ref_app_150_cfa_info(approx_t);
extern obj_t pre_make_vector_app_args_212_cfa_info(app_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t reshaped_local_user__set__128_cfa_info(local_t, bool_t);
extern obj_t make_procedure_app_stack_stamp_set__40_cfa_info(make_procedure_app_48_t, obj_t);
static obj_t _pre_make_struct_app_owner3911_67_cfa_info(obj_t, obj_t);
static obj_t _procedure_set__app_args4058_49_cfa_info(obj_t, obj_t);
obj_t fail_cinfo_75_cfa_info = BUNSPEC;
extern node_t set_ex_it_cinfo_body_103_cfa_info(set_ex_it_116_t);
static obj_t _intern_sfun_cinfo_the_closure_set_4436_80_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_struct_ref_app_167_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_infix__set__3_cfa_info(cfun_t, bool_t);
static obj_t _allocate_make_procedure_app_241_cfa_info(obj_t);
static obj_t _widening1048_make_struct_app3848_127_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_set_ex_it_cinfo4232_34_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _set_ex_it_cinfo_body_set_4238_104_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_struct_set__app_type_set__207_cfa_info(app_t, type_t);
extern obj_t box_ref_o_cinfo_side_effect__156_cfa_info(box_ref_242_t);
static obj_t struct_object__object_svar_cinfo_24_cfa_info(obj_t, obj_t, obj_t);
extern obj_t procedure_set__app_key_241_cfa_info(app_t);
static obj_t _box_ref_o_cinfo_approx4157_217_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_make_struct_app_10_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_vector_app_lost_stamp_set_3983_140_cfa_info(obj_t, obj_t, obj_t);
static obj_t _select_cinfo_test4249_94_cfa_info(obj_t, obj_t);
extern obj_t app_ly_cinfo_arg_set__121_cfa_info(app_ly_162_t, node_t);
static obj_t _make_vector_app_seen__set_3990_22_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_ref_app_type_set_4122_5_cfa_info(obj_t, obj_t, obj_t);
static obj_t _procedure_ref_app_type_set_4065_213_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_struct_app_args3908_145_cfa_info(obj_t, obj_t);
static obj_t _widening1014_kwote_cinfo4327_186_cfa_info(obj_t, obj_t);
extern pre_procedure_ref_app_85_t widening1032_pre_procedure_ref_app_123_cfa_info();
extern bool_t make_procedure_app_stackable__92_cfa_info(make_procedure_app_48_t);
static obj_t _fail_cinfo_obj4263_218_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_type_set__241_cfa_info(local_t, type_t);
extern obj_t make_box_o_cinfo_key_140_cfa_info(make_box_202_t);
extern obj_t vector_ref_app_key_24_cfa_info(app_t);
static obj_t _widening1015_app_ly_cinfo4317_127_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_class_set__85_cfa_info(sfun_t, obj_t);
static obj_t _make_box_cinfo_type4205_248_cfa_info(obj_t, obj_t);
extern pre_vector_set__app_211_t make_pre_vector_set__app_26_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t);
extern make_box_o_cinfo_96_t make_make_box_o_cinfo_242_cfa_info(obj_t, type_t, obj_t, obj_t, node_t, approx_t, approx_t);
obj_t intern_sfun_cinfo_192_cfa_info = BUNSPEC;
static obj_t _intern_sfun_cinfo_dsssl_keywords_set_4446_68_cfa_info(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_loc_250_cfa_info(app_t);
extern approx_t box_set__cinfo_approx_234_cfa_info(box_set__cinfo_94_t);
obj_t make_struct_app_214_cfa_info = BUNSPEC;
static obj_t _set_ex_it_cinfo_approx4240_95_cfa_info(obj_t, obj_t);
extern obj_t approx_top__set__151_cfa_info(approx_t, bool_t);
extern obj_t procedure_ref_app_args_118_cfa_info(app_t);
static obj_t struct_object__object_reshaped_local_214_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_set__cinfo_var4184_170_cfa_info(obj_t, obj_t);
extern obj_t pre_struct_ref_app_type_set__101_cfa_info(app_t, type_t);
static obj_t _vector_ref_app_key_set__134_cfa_info(obj_t, obj_t, obj_t);
static obj_t _kwote_node_value4339_148_cfa_info(obj_t, obj_t);
extern obj_t vector_ref_app_stack_info_set__142_cfa_info(app_t, obj_t);
extern funcall_cinfo_75_t widening1016_funcall_cinfo_219_cfa_info(approx_t, approx_t, bool_t, bool_t);
extern box_set__cinfo_94_t widening1027_box_set__cinfo_228_cfa_info(approx_t);
extern obj_t pre_struct_set__app_loc_71_cfa_info(app_t);
extern type_t procedure_set__app_type_50_cfa_info(app_t);
static obj_t _allocate_pre_vector_set__app_63_cfa_info(obj_t);
static obj_t _kwote_cinfo_type_set_4330_243_cfa_info(obj_t, obj_t, obj_t);
extern obj_t set_ex_it_cinfo_loc_59_cfa_info(set_ex_it_116_t);
static obj_t _pre_struct_ref_app_args3893_29_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_set__app_type_set_3994_42_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_struct_app__44_cfa_info(obj_t, obj_t);
static obj_t _widening1020_fail_cinfo4253_123_cfa_info(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern var_t pre_procedure_set__app_fun_8_cfa_info(app_t);
static obj_t _procedure_set__app__159_cfa_info(obj_t, obj_t);
extern obj_t make_struct_app_fun_set__249_cfa_info(app_t, var_t);
extern reshaped_global_160_t make_reshaped_global_202_cfa_info(obj_t, obj_t, type_t, value_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, bool_t, bool_t, bool_t, obj_t, obj_t);
extern pre_make_box_186_t make_pre_make_box_82_cfa_info(obj_t, type_t, obj_t, obj_t, node_t);
extern obj_t pre_procedure_ref_app_side_effect__set__159_cfa_info(app_t, obj_t);
extern variable_t make_procedure_app_owner_38_cfa_info(make_procedure_app_48_t);
static obj_t _approx_lost_stamp_set_4504_160_cfa_info(obj_t, obj_t, obj_t);
obj_t pre_clo_env_191_cfa_info = BUNSPEC;
extern pre_procedure_set__app_208_t make_pre_procedure_set__app_49_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t);
static obj_t _svar_cinfo_loc_set_4410_107_cfa_info(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_approx4061_130_cfa_info(obj_t, obj_t);
obj_t pre_struct_ref_app_207_cfa_info = BUNSPEC;
extern pre_struct_ref_app_207_t widening1046_pre_struct_ref_app_29_cfa_info();
extern obj_t pre_procedure_ref_app_key_set__34_cfa_info(app_t, obj_t);
extern node_t fail_cinfo_proc_58_cfa_info(fail_t);
static obj_t _pre_procedure_set__app_side_effect__set_4112_183_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_pragma_cinfo_82_cfa_info(obj_t);
obj_t make_box_o_cinfo_96_cfa_info = BUNSPEC;
static obj_t _procedure_set__app_args_set_4057_128_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_make_vector_app_189_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_stack_allocator4433_1_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_the_closure_set_4490_255_cfa_info(obj_t, obj_t, obj_t);
extern bool_t create_vector_app__151_cfa_info(obj_t);
extern obj_t reshaped_local_id_99_cfa_info(local_t);
extern obj_t box_ref_cinfo_side_effect__set__36_cfa_info(box_ref_242_t, obj_t);
extern bool_t approx_type_locked__124_cfa_info(approx_t);
extern node_t app_ly_cinfo_fun_95_cfa_info(app_ly_162_t);
static obj_t _fail_cinfo_proc4259_227_cfa_info(obj_t, obj_t);
extern obj_t approx_lost_stamp_set__114_cfa_info(approx_t, long);
static obj_t _pragma_cinfo_side_effect_4295_162_cfa_info(obj_t, obj_t);
static obj_t _vector_set__app_side_effect__set_3917_73_cfa_info(obj_t, obj_t, obj_t);
static obj_t _procedure_ref_app_stack_info4074_171_cfa_info(obj_t, obj_t);
extern obj_t make_vector_app_side_effect__209_cfa_info(app_t);
static obj_t _pre_make_vector_app_fun4042_147_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_type_set_4191_204_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_evaluable__set__240_cfa_info(global_t, bool_t);
static obj_t _vector_ref_app__210_cfa_info(obj_t, obj_t);
static obj_t _pre_create_vector_app_stack_info4030_214_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_ref_app__54_cfa_info(obj_t, obj_t);
extern obj_t vector_ref_app_side_effect__111_cfa_info(app_t);
static obj_t struct_object__object_atom_cinfo_113_cfa_info(obj_t, obj_t, obj_t);
extern svar_cinfo_166_t widening1007_svar_cinfo_145_cfa_info(approx_t, bool_t);
extern obj_t reshaped_global_id_236_cfa_info(global_t);
static obj_t _pre_struct_ref_app_loc3885_215_cfa_info(obj_t, obj_t);
static obj_t _allocate_kwote_cinfo_178_cfa_info(obj_t);
static obj_t _procedure_set__app_stack_info_set_4059_238_cfa_info(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_approx_set_3954_71_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_ref_app_fun_set_3841_162_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_property_set_4466_95_cfa_info(obj_t, obj_t, obj_t);
extern box_ref_o_cinfo_98_t make_box_ref_o_cinfo_177_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, approx_t);
extern approx_t pragma_cinfo_approx_152_cfa_info(pragma_cinfo_220_t);
static obj_t _make_vector_app_side_effect__set_3971_134_cfa_info(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_key_147_cfa_info(app_t);
static obj_t _fail_cinfo_loc4255_82_cfa_info(obj_t, obj_t);
extern box_ref_o_cinfo_98_t widening1030_box_ref_o_cinfo_31_cfa_info(approx_t);
static obj_t _jump_ex_it_cinfo_value_set_4228_209_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_fun_set_4041_181_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_ref_app_stack_info_set_3845_170_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1040_pre_vector_set__app_75_cfa_info(obj_t);
extern obj_t struct_set__app_side_effect__159_cfa_info(app_t);
extern obj_t procedure_ref_app_side_effect__178_cfa_info(app_t);
extern pragma_cinfo_220_t widening1017_pragma_cinfo_177_cfa_info(approx_t);
extern obj_t pre_struct_set__app_key_246_cfa_info(app_t);
extern cfun_cinfo_200_t make_cfun_cinfo_44_cfa_info(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, bool_t, bool_t, approx_t);
static obj_t _app_ly_cinfo_arg4325_242_cfa_info(obj_t, obj_t);
extern node_t fail_cinfo_obj_134_cfa_info(fail_t);
static obj_t _struct_ref_app_type_set_3837_191_cfa_info(obj_t, obj_t, obj_t);
obj_t pre_make_box_186_cfa_info = BUNSPEC;
static obj_t object__struct_approx_119_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_loc_set__209_cfa_info(sfun_t, obj_t);
static obj_t _allocate_kwote_node_49_cfa_info(obj_t);
extern node_t fail_cinfo_msg_186_cfa_info(fail_t);
static obj_t _allocate_create_vector_app_246_cfa_info(obj_t);
static obj_t _make_procedure_app_side_effect_4082_191_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_id4350_75_cfa_info(obj_t, obj_t);
static obj_t object__struct_box_set__cinfo_66_cfa_info(obj_t, obj_t);
extern reshaped_local_224_t widening1010_reshaped_local_53_cfa_info(obj_t);
extern var_t procedure_set__app_fun_41_cfa_info(app_t);
extern atom_cinfo_155_t widening1012_atom_cinfo_57_cfa_info(approx_t);
extern kwote_cinfo_48_t make_kwote_cinfo_77_cfa_info(obj_t, type_t, obj_t, approx_t);
obj_t procedure_ref_app_49_cfa_info = BUNSPEC;
static obj_t object__struct_box_set__o_cinfo_141_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_set__app__169_cfa_info(obj_t, obj_t);
static obj_t _allocate_box_set__cinfo_187_cfa_info(obj_t);
extern set_ex_it_cinfo_168_t make_set_ex_it_cinfo_156_cfa_info(obj_t, type_t, var_t, node_t, approx_t);
extern type_t make_procedure_app_type_193_cfa_info(app_t);
static obj_t _struct_set__app_approx3833_191_cfa_info(obj_t, obj_t);
extern sfun_t allocate_extern_sfun_cinfo_223_cfa_info();
static obj_t _pre_make_procedure_app_fun4142_229_cfa_info(obj_t, obj_t);
static obj_t object__struct_make_box_cinfo_186_cfa_info(obj_t, obj_t);
extern obj_t pre_struct_ref_app_args_87_cfa_info(app_t);
extern type_t pre_make_struct_app_type_250_cfa_info(app_t);
static obj_t _box_set__cinfo_type_set_4181_102_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_make_box_o_cinfo4189_169_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_conditional_cinfo_223_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_top_4463_92_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_set__app_fun_set_3878_88_cfa_info(obj_t, obj_t, obj_t);
extern var_t vector_ref_app_fun_217_cfa_info(app_t);
static obj_t _make_vector_app_approx_set_3980_189_cfa_info(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_side_effect_4054_216_cfa_info(obj_t, obj_t);
extern type_t pre_vector_set__app_type_92_cfa_info(app_t);
static obj_t _pre_make_box__20_cfa_info(obj_t, obj_t);
static obj_t _allocate_make_box_cinfo_36_cfa_info(obj_t);
static obj_t _make_box_ref_cinfo4169_167_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_make_struct_app_loc_207_cfa_info(app_t);
static obj_t _vector_set__app_fun_set_3919_16_cfa_info(obj_t, obj_t, obj_t);
extern variable_t pre_make_struct_app_owner_50_cfa_info(pre_make_struct_app_218_t);
static obj_t _make_struct_app_args_set_3858_83_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1027_box_set__cinfo4178_94_cfa_info(obj_t, obj_t);
extern type_t pragma_cinfo_type_144_cfa_info(pragma_t);
extern obj_t make_struct_app_stack_stamp_set__112_cfa_info(make_struct_app_214_t, obj_t);
static obj_t _pre_procedure_set__app_fun4115_173_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_loc4477_88_cfa_info(obj_t, obj_t);
extern obj_t pre_struct_set__app_args_53_cfa_info(app_t);
static obj_t _make_vector_ref_app3927_130_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t kwote_node_value_143_cfa_info(kwote_t);
extern struct_set__app_162_t make_struct_set__app_96_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t);
static obj_t _procedure_set__app_stack_info4060_125_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_name4380_238_cfa_info(obj_t, obj_t);
extern obj_t fail_cinfo_loc_64_cfa_info(fail_t);
extern long reshaped_local_occurrence_171_cfa_info(local_t);
extern long make_procedure_app_values_approx_len_202_cfa_info(make_procedure_app_48_t);
static obj_t struct_object__object_pre_make_box_16_cfa_info(obj_t, obj_t, obj_t);
extern obj_t funcall_cinfo_type_error_noticed__set__27_cfa_info(funcall_cinfo_75_t, bool_t);
static obj_t _kwote_node_loc4336_209_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_loc4190_53_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_library_4371_56_cfa_info(obj_t, obj_t);
extern app_t allocate_procedure_set__app_12_cfa_info();
static obj_t _svar_cinfo_approx4412_1_cfa_info(obj_t, obj_t);
static obj_t _funcall_cinfo_arity_error_noticed_4314_220_cfa_info(obj_t, obj_t);
static obj_t _struct_set__app_type3824_132_cfa_info(obj_t, obj_t);
static obj_t _make_box_cinfo_type_set_4204_72_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1013_kwote_node4334_113_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_loc_249_cfa_info(sfun_t);
static obj_t _make_procedure_app_values_approx_len4092_35_cfa_info(obj_t, obj_t);
static obj_t _make_pragma_cinfo4290_232_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t struct_ref_app_type_set__226_cfa_info(app_t, type_t);
static obj_t object__struct_svar_cinfo_7_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_import4367_113_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_set__app_args_set_4116_96_cfa_info(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_side_effect__set_3945_171_cfa_info(obj_t, obj_t, obj_t);
extern type_t conditional_cinfo_type_74_cfa_info(conditional_t);
extern obj_t jump_ex_it_cinfo_exit_set__81_cfa_info(jump_ex_it_184_t, node_t);
static obj_t _pre_struct_ref_app_side_effect_3889_58_cfa_info(obj_t, obj_t);
static obj_t _make_struct_app_fun_set_3856_97_cfa_info(obj_t, obj_t, obj_t);
static obj_t _approx_type_set_4498_139_cfa_info(obj_t, obj_t, obj_t);
static obj_t _sexit_cinfo_detached_4402_213_cfa_info(obj_t, obj_t);
extern app_t allocate_struct_ref_app_224_cfa_info();
static obj_t _scnst_cinfo__113_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_procedure_set__app_110_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_value_set__202_cfa_info(global_t, value_t);
static obj_t _struct_ref_app_side_effect_3840_167_cfa_info(obj_t, obj_t);
extern obj_t scnst_cinfo_class_89_cfa_info(scnst_t);
static obj_t _make_vector_app_lost_stamp3984_11_cfa_info(obj_t, obj_t);
static obj_t _make_vector_app_owner3985_202_cfa_info(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t pre_vector_ref_app_side_effect__40_cfa_info(app_t);
extern scnst_t allocate_scnst_cinfo_156_cfa_info();
extern obj_t struct_ref_app_stack_info_set__87_cfa_info(app_t, obj_t);
extern bool_t sexit_cinfo__140_cfa_info(obj_t);
static obj_t _pre_make_procedure_app_type4136_42_cfa_info(obj_t, obj_t);
static obj_t _vector_ref_app_args3936_244_cfa_info(obj_t, obj_t);
static obj_t _procedure_ref_app_loc4064_180_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_stack_info4131_112_cfa_info(obj_t, obj_t);
static obj_t _struct_set__app_fun3828_168_cfa_info(obj_t, obj_t);
extern obj_t svar_ast_var;
static obj_t _pragma_cinfo_key_170_cfa_info(obj_t, obj_t);
static obj_t _struct_ref_app_key_111_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_src4376_17_cfa_info(obj_t, obj_t);
static obj_t _create_vector_app_seen_3965_143_cfa_info(obj_t, obj_t);
static obj_t _widening1047_pre_struct_set__app_81_cfa_info(obj_t);
static obj_t object__struct_pre_vector_set__app_201_cfa_info(obj_t, obj_t);
extern approx_t vector_ref_app_approx_240_cfa_info(vector_ref_app_195_t);
extern bool_t app_ly_cinfo__179_cfa_info(obj_t);
static obj_t _make_struct_app_lost_stamp_set_3865_171_cfa_info(obj_t, obj_t, obj_t);
static obj_t _app_ly_cinfo_fun_set_4322_68_cfa_info(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_type_set__61_cfa_info(app_t, type_t);
extern obj_t intern_sfun_cinfo_property_154_cfa_info(sfun_t);
extern select_cinfo_150_t make_select_cinfo_178_cfa_info(obj_t, type_t, obj_t, obj_t, node_t, obj_t, type_t, approx_t);
extern obj_t pre_make_struct_app_key_253_cfa_info(app_t);
static obj_t _conditional_cinfo__117_cfa_info(obj_t, obj_t);
extern var_t procedure_ref_app_fun_180_cfa_info(app_t);
extern type_t make_box_o_cinfo_type_235_cfa_info(make_box_202_t);
extern obj_t create_vector_app_type_set__83_cfa_info(app_t, type_t);
extern approx_t svar_cinfo_approx_144_cfa_info(svar_cinfo_166_t);
static obj_t _kwote_cinfo_type4331_130_cfa_info(obj_t, obj_t);
static obj_t _box_ref_cinfo_side_effect_4174_28_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_fast_alpha_178_cfa_info(global_t);
extern make_box_cinfo_127_t widening1025_make_box_cinfo_175_cfa_info(approx_t);
static obj_t _reshaped_global_fast_alpha4360_7_cfa_info(obj_t, obj_t);
static obj_t object__struct_kwote_cinfo_203_cfa_info(obj_t, obj_t);
static obj_t _make_box_cinfo_key_set__204_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_infix_4495_55_cfa_info(obj_t, obj_t);
static obj_t _conditional_cinfo_false4277_112_cfa_info(obj_t, obj_t);
extern type_t vector_ref_app_type_35_cfa_info(app_t);
static obj_t _reshaped_local_name_set_4379_233_cfa_info(obj_t, obj_t, obj_t);
extern make_struct_app_214_t make_make_struct_app_186_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t, approx_t, long, variable_t, bool_t, obj_t);
extern obj_t pre_vector_ref_app_type_set__203_cfa_info(app_t, type_t);
extern var_t pre_struct_set__app_fun_114_cfa_info(app_t);
extern bool_t intern_sfun_cinfo__209_cfa_info(obj_t);
static obj_t _conditional_cinfo_false_set_4276_41_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1007_svar_cinfo4408_80_cfa_info(obj_t, obj_t, obj_t);
extern obj_t scnst_ast_var;
static obj_t struct_object__object_box_set__o_cinfo_219_cfa_info(obj_t, obj_t, obj_t);
obj_t reshaped_local_224_cfa_info = BUNSPEC;
static obj_t _widening1041_make_vector_app3966_245_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_box_cinfo_value4209_19_cfa_info(obj_t, obj_t);
obj_t pre_make_vector_app_251_cfa_info = BUNSPEC;
static obj_t _make_procedure_app_loc4078_29_cfa_info(obj_t, obj_t);
static obj_t object__struct_pre_struct_ref_app_38_cfa_info(obj_t, obj_t);
static obj_t _pragma_cinfo_approx4299_32_cfa_info(obj_t, obj_t);
static obj_t _funcall_cinfo_strength_set_4309_38_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_dsssl_keywords4447_80_cfa_info(obj_t, obj_t);
extern obj_t create_vector_app_key_set__126_cfa_info(app_t, obj_t);
static obj_t _box_ref_cinfo_approx4177_0_cfa_info(obj_t, obj_t);
extern obj_t procedure_ref_app_fun_set__2_cfa_info(app_t, var_t);
static obj_t _svar_cinfo__163_cfa_info(obj_t, obj_t);
extern obj_t pre_vector_ref_app_key_set__8_cfa_info(app_t, obj_t);
extern obj_t make_struct_app_type_set__65_cfa_info(app_t, type_t);
extern approx_t make_struct_app_value_approx_246_cfa_info(make_struct_app_214_t);
static obj_t object__struct_app_ly_cinfo_39_cfa_info(obj_t, obj_t);
static obj_t _procedure_ref_app__14_cfa_info(obj_t, obj_t);
extern obj_t pre_clo_env_loc_179_cfa_info(svar_t);
extern obj_t kwote_cinfo_value_171_cfa_info(kwote_t);
obj_t procedure_set__app_32_cfa_info = BUNSPEC;
static obj_t _procedure_set__app_loc4050_91_cfa_info(obj_t, obj_t);
extern obj_t make_box_cinfo_type_set__156_cfa_info(make_box_202_t, type_t);
extern obj_t create_vector_app_approx_set__132_cfa_info(create_vector_app_150_t, approx_t);
static obj_t _make_pre_make_procedure_app4133_249_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t create_vector_app_stack_info_set__169_cfa_info(app_t, obj_t);
extern node_t setq_cinfo_value_181_cfa_info(setq_t);
extern bool_t make_struct_app__23_cfa_info(obj_t);
static obj_t _reshaped_global_type_set_4353_23_cfa_info(obj_t, obj_t, obj_t);
obj_t select_cinfo_150_cfa_info = BUNSPEC;
static obj_t _pre_procedure_ref_app_type4123_8_cfa_info(obj_t, obj_t);
extern node_t app_ly_cinfo_arg_233_cfa_info(app_ly_162_t);
extern kwote_node_102_t widening1013_kwote_node_98_cfa_info(node_t);
static obj_t object__struct_atom_cinfo_211_cfa_info(obj_t, obj_t);
extern bool_t cfun_cinfo_infix__163_cfa_info(cfun_t);
extern box_ref_cinfo_214_t make_box_ref_cinfo_128_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, approx_t);
extern type_t box_set__o_cinfo_type_128_cfa_info(box_set__221_t);
extern obj_t funcall_cinfo_fun_set__87_cfa_info(funcall_t, node_t);
static obj_t _procedure_set__app_side_effect__set_4053_86_cfa_info(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_side_effect__set__126_cfa_info(app_t, obj_t);
extern obj_t intern_sfun_cinfo_args_set__79_cfa_info(sfun_t, obj_t);
static obj_t _make_pre_vector_set__app3992_134_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _struct_set__app_key_set__192_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_vector_ref_app_fun4011_88_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_stack_info4089_35_cfa_info(obj_t, obj_t);
static obj_t _create_vector_app_fun_set_3948_68_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_funcall_cinfo_97_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_stack_info_set__230_cfa_info(app_t, obj_t);
extern cvar_cinfo_53_t make_cvar_cinfo_209_cfa_info(bool_t, approx_t);
extern obj_t kwote_node_type_set__67_cfa_info(kwote_t, type_t);
static obj_t _pre_make_struct_app_type_set_3899_16_cfa_info(obj_t, obj_t, obj_t);
extern box_ref_cinfo_214_t widening1028_box_ref_cinfo_34_cfa_info(approx_t);
extern obj_t make_box_cinfo_loc_173_cfa_info(make_box_202_t);
extern bool_t make_vector_app_seen__62_cfa_info(make_vector_app_205_t);
static obj_t _vector_set__app__140_cfa_info(obj_t, obj_t);
static obj_t _pre_create_vector_app_fun_set_4025_210_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_jump_ex_it_cinfo_34_cfa_info(obj_t);
static obj_t _make_vector_app_approx3981_121_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_stack_allocator_17_cfa_info(sfun_t);
static obj_t _make_procedure_app_x_set_4099_130_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_vector_ref_app_31_cfa_info(obj_t);
static obj_t _make_vector_app_args_set_3976_166_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_stack_info_set_4088_255_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_struct_set__app__221_cfa_info(obj_t, obj_t);
extern bool_t reshaped_local__109_cfa_info(obj_t);
static obj_t _reshaped_local_fast_alpha4388_156_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_args4469_187_cfa_info(obj_t, obj_t);
extern obj_t set_ex_it_cinfo_body_set__25_cfa_info(set_ex_it_116_t, node_t);
static obj_t _pre_make_struct_app_side_effect__set_3901_34_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_type4111_183_cfa_info(obj_t, obj_t);
static obj_t _struct_ref_app_type3838_64_cfa_info(obj_t, obj_t);
extern node_t make_box_o_cinfo_value_153_cfa_info(make_box_202_t);
extern obj_t extern_sfun_cinfo_predicate_of_set__5_cfa_info(sfun_t, obj_t);
extern bool_t reshaped_global_library__243_cfa_info(global_t);
extern obj_t struct_set__app_stack_info_137_cfa_info(app_t);
static obj_t _reshaped_global__169_cfa_info(obj_t, obj_t);
extern bool_t pre_make_vector_app__111_cfa_info(obj_t);
static obj_t _make_struct_app_lost_stamp3866_30_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_name_set__115_cfa_info(local_t, obj_t);
static obj_t imported_modules_init_94_cfa_info();
extern bool_t make_procedure_app__51_cfa_info(obj_t);
static obj_t _extern_sfun_cinfo_body_set_4470_56_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_ref_app_type_set__15_cfa_info(app_t, type_t);
static obj_t _reshaped_global_removable_set_4361_50_cfa_info(obj_t, obj_t, obj_t);
extern type_t fail_cinfo_type_26_cfa_info(fail_t);
extern obj_t pre_create_vector_app_type_set__172_cfa_info(app_t, type_t);
extern fail_cinfo_75_t make_fail_cinfo_148_cfa_info(obj_t, type_t, node_t, node_t, node_t, approx_t);
static obj_t struct_object__object_select_cinfo_79_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_stackable__set_4104_216_cfa_info(obj_t, obj_t, obj_t);
extern obj_t conditional_cinfo_test_set__167_cfa_info(conditional_t, node_t);
extern obj_t box_set__o_cinfo_value_set__181_cfa_info(box_set__221_t, node_t);
extern var_t pre_make_struct_app_fun_214_cfa_info(app_t);
static obj_t struct_object__object_cfun_cinfo_204_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_src_255_cfa_info(global_t);
static obj_t struct_object__object_kwote_cinfo_192_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_vector_ref_app_stack_info_set_4014_28_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_the_closure_set__73_cfa_info(cfun_t, obj_t);
extern obj_t vector_ref_app_stack_info_39_cfa_info(app_t);
obj_t extern_sfun_cinfo_6_cfa_info = BUNSPEC;
extern approx_t create_vector_app_value_approx_116_cfa_info(create_vector_app_150_t);
extern obj_t make_vector_app_args_set__241_cfa_info(app_t, obj_t);
static obj_t _fail_cinfo_proc_set_4258_166_cfa_info(obj_t, obj_t, obj_t);
static obj_t _vector_set__app_type3916_3_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_side_effect_4429_206_cfa_info(obj_t, obj_t);
extern obj_t make_struct_app_lost_stamp_set__51_cfa_info(make_struct_app_214_t, long);
extern obj_t pre_create_vector_app_stack_info_set__211_cfa_info(app_t, obj_t);
extern obj_t pragma_cinfo_loc_22_cfa_info(pragma_t);
static obj_t _pragma_cinfo_loc4291_208_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_predicate_of_set_4484_6_cfa_info(obj_t, obj_t, obj_t);
static obj_t _conditional_cinfo_test4273_188_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_predicate_of_245_cfa_info(sfun_t);
static obj_t _sexit_cinfo_approx4403_117_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_removable_set__25_cfa_info(local_t, obj_t);
static obj_t _pre_make_box_side_effect__set_4215_66_cfa_info(obj_t, obj_t, obj_t);
extern obj_t fail_cinfo_type_set__85_cfa_info(fail_t, type_t);
static obj_t object__struct_pre_create_vector_app_184_cfa_info(obj_t, obj_t);
extern obj_t make_box_cinfo_key_12_cfa_info(make_box_202_t);
extern obj_t make_box_o_cinfo_approx_set__53_cfa_info(make_box_o_cinfo_96_t, approx_t);
extern type_t atom_cinfo_type_135_cfa_info(atom_t);
extern type_t make_vector_app_type_150_cfa_info(app_t);
extern obj_t pragma_cinfo_key_set__146_cfa_info(pragma_t, obj_t);
extern pre_make_vector_app_251_t widening1037_pre_make_vector_app_63_cfa_info(variable_t);
obj_t scnst_cinfo_0_cfa_info = BUNSPEC;
static obj_t _pre_vector_set__app_loc3993_34_cfa_info(obj_t, obj_t);
extern obj_t procedure_set__app_stack_info_212_cfa_info(app_t);
extern variable_t make_vector_app_owner_193_cfa_info(make_vector_app_205_t);
extern obj_t pre_create_vector_app_side_effect__set__203_cfa_info(app_t, obj_t);
extern obj_t intern_sfun_cinfo_predicate_of_250_cfa_info(sfun_t);
static obj_t _pre_make_vector_app_key_set_4039_63_cfa_info(obj_t, obj_t, obj_t);
extern approx_t atom_cinfo_approx_215_cfa_info(atom_cinfo_155_t);
static obj_t _select_cinfo_side_effect__set_4246_220_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1019_conditional_cinfo4265_21_cfa_info(obj_t, obj_t);
extern obj_t struct_set__app_stack_info_set__211_cfa_info(app_t, obj_t);
obj_t pre_vector_set__app_211_cfa_info = BUNSPEC;
extern obj_t set_ex_it_cinfo_type_set__35_cfa_info(set_ex_it_116_t, type_t);
extern obj_t vector_ref_app_type_set__10_cfa_info(app_t, type_t);
extern obj_t scnst_cinfo_loc_35_cfa_info(scnst_t);
static obj_t _extern_sfun_cinfo_side_effect__set_4456_23_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pragma_cinfo_side_effect__set__54_cfa_info(pragma_t, obj_t);
extern obj_t pragma_cinfo_args_set__20_cfa_info(pragma_t, obj_t);
static obj_t object__struct_pre_make_procedure_app_202_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_occurrence_set_4363_110_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_make_box_o_cinfo_133_cfa_info(obj_t);
static obj_t _procedure_ref_app_side_effect__set_4067_83_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_set__app_args_207_cfa_info(app_t);
static obj_t _box_set__o_cinfo_value4166_97_cfa_info(obj_t, obj_t);
extern approx_t make_struct_app_approx_49_cfa_info(make_struct_app_214_t);
extern approx_t box_ref_o_cinfo_approx_223_cfa_info(box_ref_o_cinfo_98_t);
static obj_t struct_object__object_pre_procedure_ref_app_139_cfa_info(obj_t, obj_t, obj_t);
extern bool_t svar_cinfo__59_cfa_info(obj_t);
extern obj_t approx_allocs_203_cfa_info(approx_t);
static obj_t _widening1025_make_box_cinfo4201_110_cfa_info(obj_t, obj_t);
extern bool_t make_procedure_app_x_t__146_cfa_info(make_procedure_app_48_t);
static obj_t _scnst_cinfo_class4421_86_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo__255_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_ref_app_type_set_3886_192_cfa_info(obj_t, obj_t, obj_t);
extern obj_t extern_sfun_cinfo_property_set__166_cfa_info(sfun_t, obj_t);
extern obj_t box_ref_cinfo_key_set__110_cfa_info(box_ref_242_t, obj_t);
extern approx_t box_ref_cinfo_approx_49_cfa_info(box_ref_cinfo_214_t);
static obj_t struct_object__object_create_vector_app_49_cfa_info(obj_t, obj_t, obj_t);
extern obj_t svar_cinfo_loc_67_cfa_info(svar_t);
static obj_t _create_vector_app_type_set_3943_133_cfa_info(obj_t, obj_t, obj_t);
extern pragma_cinfo_220_t make_pragma_cinfo_123_cfa_info(obj_t, type_t, obj_t, obj_t, obj_t, obj_t, approx_t);
extern bool_t create_vector_app_seen__3_cfa_info(create_vector_app_150_t);
extern type_t box_ref_cinfo_type_23_cfa_info(box_ref_242_t);
static obj_t _svar_cinfo_clo_env_4414_89_cfa_info(obj_t, obj_t);
extern type_t setq_cinfo_type_65_cfa_info(setq_t);
static obj_t _vector_ref_app_type_set_3929_191_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_ref_app_fun3842_117_cfa_info(obj_t, obj_t);
static obj_t _make_box_cinfo_approx4210_116_cfa_info(obj_t, obj_t);
extern obj_t conditional_cinfo_side_effect__139_cfa_info(conditional_t);
extern obj_t pragma_cinfo_key_115_cfa_info(pragma_t);
static obj_t _struct_ref_app_key_set__180_cfa_info(obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern make_box_202_t allocate_pre_make_box_175_cfa_info();
static obj_t _cvar_cinfo_approx4407_165_cfa_info(obj_t, obj_t);
extern obj_t scnst_cinfo_loc_set__10_cfa_info(scnst_t, obj_t);
extern obj_t create_vector_app_loc_246_cfa_info(app_t);
extern obj_t pre_make_box_side_effect__126_cfa_info(make_box_202_t);
static obj_t _fail_cinfo_msg4261_30_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_ref_app4063_52_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern node_t conditional_cinfo_true_183_cfa_info(conditional_t);
extern obj_t make_box_o_cinfo_key_set__68_cfa_info(make_box_202_t, obj_t);
extern pre_procedure_set__app_208_t widening1033_pre_procedure_set__app_11_cfa_info();
static obj_t object__struct_reshaped_global_19_cfa_info(obj_t, obj_t);
extern obj_t cfun_ast_var;
extern pre_struct_ref_app_207_t make_pre_struct_ref_app_240_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t);
static obj_t _make_box_cinfo_side_effect__set_4206_43_cfa_info(obj_t, obj_t, obj_t);
extern obj_t box_ref_cinfo_var_set__56_cfa_info(box_ref_242_t, var_t);
extern obj_t struct_ref_app_stack_info_73_cfa_info(app_t);
extern obj_t extern_sfun_cinfo_dsssl_keywords_3_cfa_info(sfun_t);
extern app_t allocate_pre_procedure_ref_app_138_cfa_info();
extern obj_t funcall_cinfo_args_85_cfa_info(funcall_t);
static obj_t _jump_ex_it_cinfo_exit_set_4226_196_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_struct_set__app_key_set__234_cfa_info(app_t, obj_t);
extern node_t jump_ex_it_cinfo_exit_67_cfa_info(jump_ex_it_184_t);
static obj_t _pre_create_vector_app_type_set_4019_91_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_vector_set__app_fun_set_3998_143_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_box_loc4212_83_cfa_info(obj_t, obj_t);
static obj_t _setq_cinfo_type_set_4282_115_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_vector_ref_app_174_cfa_info(obj_t, obj_t);
static obj_t _widening1018_setq_cinfo4279_199_cfa_info(obj_t, obj_t);
extern obj_t vector_set__app_args_set__4_cfa_info(app_t, obj_t);
extern obj_t vector_set__app_side_effect__60_cfa_info(app_t);
static obj_t _pre_procedure_ref_app_key_set__188_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_make_box_cinfo4202_207_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _setq_cinfo_value4287_60_cfa_info(obj_t, obj_t);
extern box_set__o_cinfo_6_t make_box_set__o_cinfo_60_cfa_info(obj_t, type_t, var_t, node_t, approx_t);
static obj_t object__struct_procedure_set__app_86_cfa_info(obj_t, obj_t);
static obj_t _allocate_vector_ref_app_194_cfa_info(obj_t);
static obj_t _intern_sfun_cinfo_approx4450_186_cfa_info(obj_t, obj_t);
extern obj_t select_cinfo_side_effect__33_cfa_info(select_t);
static obj_t _make_extern_sfun_cinfo4454_19_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_struct_app_stackable__set__115_cfa_info(make_struct_app_214_t, bool_t);
static obj_t _make_struct_app_key3855_132_cfa_info(obj_t, obj_t);
extern approx_t allocate_approx_85_cfa_info();
static obj_t object__struct_intern_sfun_cinfo_28_cfa_info(obj_t, obj_t);
static obj_t _box_set__o_cinfo_var4164_214_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_loc_set_4476_26_cfa_info(obj_t, obj_t, obj_t);
extern create_vector_app_150_t make_create_vector_app_136_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t, approx_t, long, variable_t, bool_t, obj_t, bool_t);
static obj_t _box_ref_o_cinfo_side_effect_4154_125_cfa_info(obj_t, obj_t);
static obj_t _struct_set__app_stack_info_set_3831_102_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_box_ref_o_cinfo_174_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box_side_effect_4216_75_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_fast_alpha_set_4359_174_cfa_info(obj_t, obj_t, obj_t);
extern obj_t funcall_cinfo_type_set__85_cfa_info(funcall_t, type_t);
static obj_t _reshaped_global_access4358_220_cfa_info(obj_t, obj_t);
extern obj_t make_struct_app_side_effect__63_cfa_info(app_t);
static obj_t _reshaped_local_access4386_232_cfa_info(obj_t, obj_t);
obj_t pragma_cinfo_220_cfa_info = BUNSPEC;
static obj_t _atom_cinfo_value_set_4346_19_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_create_vector_app_key_set__58_cfa_info(app_t, obj_t);
static obj_t _app_ly_cinfo_approx4326_82_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_fun_set__152_cfa_info(app_t, var_t);
extern long cfun_cinfo_arity_247_cfa_info(cfun_t);
static obj_t _conditional_cinfo_test_set_4272_187_cfa_info(obj_t, obj_t, obj_t);
extern value_t reshaped_local_value_240_cfa_info(local_t);
static obj_t _allocate_setq_cinfo_116_cfa_info(obj_t);
extern obj_t app_ly_cinfo_type_set__211_cfa_info(app_ly_162_t, type_t);
extern var_t box_ref_cinfo_var_121_cfa_info(box_ref_242_t);
static obj_t _select_cinfo_test_set_4248_179_cfa_info(obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo_strength4310_166_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_stack_allocator_set_4460_90_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_type_set_4035_221_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_key_set__239_cfa_info(obj_t, obj_t, obj_t);
static obj_t _vector_set__app_key_set__89_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_make_procedure_app_args_217_cfa_info(app_t);
static obj_t _pre_make_struct_app_loc3898_247_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_loc_set_4448_214_cfa_info(obj_t, obj_t, obj_t);
extern pre_vector_set__app_211_t widening1040_pre_vector_set__app_254_cfa_info();
static obj_t _funcall_cinfo_loc4302_189_cfa_info(obj_t, obj_t);
obj_t box_set__o_cinfo_6_cfa_info = BUNSPEC;
extern approx_t make_vector_app_approx_58_cfa_info(make_vector_app_205_t);
extern variable_t create_vector_app_owner_226_cfa_info(create_vector_app_150_t);
extern obj_t app_ly_cinfo_fun_set__61_cfa_info(app_ly_162_t, node_t);
static obj_t _pragma_cinfo_type_set_4292_129_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_arity4427_65_cfa_info(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t create_vector_app_key_178_cfa_info(app_t);
static obj_t _box_set__cinfo_var_set_4183_81_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_o_cinfo__52_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_body_set_4442_55_cfa_info(obj_t, obj_t, obj_t);
extern kwote_cinfo_48_t widening1014_kwote_cinfo_146_cfa_info(approx_t);
obj_t pre_make_procedure_app_60_cfa_info = BUNSPEC;
extern bool_t intern_sfun_cinfo_top__47_cfa_info(sfun_t);
static obj_t _intern_sfun_cinfo_side_effect__set_4428_136_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_args3830_80_cfa_info(obj_t, obj_t);
extern box_set__o_cinfo_6_t widening1029_box_set__o_cinfo_148_cfa_info(approx_t);
static obj_t struct_object__object_struct_ref_app_176_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_struct_app_fun_set_3905_60_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_make_vector_app_26_cfa_info(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_fun_set_3933_193_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_set_ex_it_cinfo_216_cfa_info(obj_t, obj_t);
static obj_t _allocate_reshaped_global_82_cfa_info(obj_t);
static obj_t _atom_cinfo_value4347_202_cfa_info(obj_t, obj_t);
extern bool_t box_set__cinfo__218_cfa_info(obj_t);
static obj_t library_modules_init_112_cfa_info();
static obj_t _app_ly_cinfo_type_set_4320_179_cfa_info(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_fun3949_243_cfa_info(obj_t, obj_t);
static obj_t _pre_make_procedure_app_args4144_74_cfa_info(obj_t, obj_t);
extern obj_t make_procedure_app_key_set__38_cfa_info(app_t, obj_t);
static obj_t _funcall_cinfo_type_error_noticed__set_4315_29_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_set__o_cinfo_value_set_4165_22_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_reshaped_global4349_214_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t vector_set__app__15_cfa_info(obj_t);
extern bool_t procedure_set__app__65_cfa_info(obj_t);
extern bool_t pre_clo_env__121_cfa_info(obj_t);
static obj_t struct_object__object_cvar_cinfo_125_cfa_info(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_side_effect_3932_110_cfa_info(obj_t, obj_t);
obj_t make_vector_app_205_cfa_info = BUNSPEC;
static obj_t _make_pre_make_box4211_93_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t struct_set__app_args_set__3_cfa_info(app_t, obj_t);
extern obj_t create_vector_app_stack_stamp_255_cfa_info(create_vector_app_150_t);
static obj_t object__struct_cfun_cinfo_76_cfa_info(obj_t, obj_t);
static obj_t _kwote_cinfo_value4332_237_cfa_info(obj_t, obj_t);
extern type_t struct_ref_app_type_202_cfa_info(app_t);
static obj_t _fail_cinfo_msg_set_4260_104_cfa_info(obj_t, obj_t, obj_t);
extern bool_t pragma_cinfo__149_cfa_info(obj_t);
static obj_t _scnst_cinfo_approx4424_226_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_pragma_cinfo_100_cfa_info(obj_t, obj_t, obj_t);
extern type_t struct_set__app_type_138_cfa_info(app_t);
static obj_t _make_vector_app_stack_info3979_52_cfa_info(obj_t, obj_t);
extern bool_t reshaped_global__139_cfa_info(obj_t);
static obj_t _pre_make_procedure_app_side_effect__set_4137_217_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_struct_set__app_208_cfa_info(obj_t, obj_t);
static obj_t _allocate_box_ref_o_cinfo_197_cfa_info(obj_t);
extern obj_t pre_struct_set__app_stack_info_177_cfa_info(app_t);
extern obj_t extern_sfun_cinfo_side_effect__154_cfa_info(sfun_t);
static obj_t _box_ref_o_cinfo_type_set_4151_14_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_vector_ref_app_stack_info_set__151_cfa_info(app_t, obj_t);
extern bool_t pre_struct_ref_app__163_cfa_info(obj_t);
static obj_t _reshaped_local_removable4390_108_cfa_info(obj_t, obj_t);
extern node_t pre_make_box_value_157_cfa_info(make_box_202_t);
extern obj_t make_vector_app_stack_info_168_cfa_info(app_t);
static obj_t _pre_vector_ref_app_side_effect_4009_50_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_value4356_90_cfa_info(obj_t, obj_t);
static obj_t _pre_make_vector_app_stack_info4046_220_cfa_info(obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t intern_sfun_cinfo_top__set__70_cfa_info(sfun_t, bool_t);
extern pre_make_procedure_app_60_t widening1031_pre_make_procedure_app_55_cfa_info(variable_t);
static obj_t object__struct_procedure_ref_app_22_cfa_info(obj_t, obj_t);
extern long extern_sfun_cinfo_arity_43_cfa_info(sfun_t);
static obj_t _vector_set__app_stack_info3924_202_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_values_approx_set_4093_149_cfa_info(obj_t, obj_t, obj_t, obj_t);
extern obj_t create_vector_app_side_effect__33_cfa_info(app_t);
static obj_t _set_ex_it_cinfo_var4237_21_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_side_effect__206_cfa_info(sfun_t);
static obj_t _widening1049_struct_ref_app3834_218_cfa_info(obj_t, obj_t);
static obj_t _funcall_cinfo_type4304_241_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_property_set__111_cfa_info(sfun_t, obj_t);
extern obj_t extern_sfun_cinfo_args_set__187_cfa_info(sfun_t, obj_t);
extern obj_t sexit_cinfo_handler_set__65_cfa_info(sexit_t, obj_t);
extern obj_t pre_make_struct_app_stack_info_set__82_cfa_info(app_t, obj_t);
static obj_t _approx__184_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_fail_cinfo_67_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_x4100_182_cfa_info(obj_t, obj_t);
extern long reshaped_local_key_22_cfa_info(local_t);
extern type_t reshaped_global_type_121_cfa_info(global_t);
static obj_t _pre_vector_set__app_stack_info4003_26_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_stack_info_set_4130_149_cfa_info(obj_t, obj_t, obj_t);
extern obj_t funcall_cinfo_strength_95_cfa_info(funcall_t);
static obj_t _make_struct_app_side_effect__set_3853_48_cfa_info(obj_t, obj_t, obj_t);
extern kwote_t allocate_kwote_cinfo_134_cfa_info();
extern obj_t fail_cinfo_msg_set__145_cfa_info(fail_t, node_t);
extern approx_t kwote_cinfo_approx_226_cfa_info(kwote_cinfo_48_t);
static obj_t _make_reshaped_local4377_222_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _approx_type4499_248_cfa_info(obj_t, obj_t);
extern kwote_t allocate_kwote_node_139_cfa_info();
static obj_t _allocate_set_ex_it_cinfo_22_cfa_info(obj_t);
static obj_t _pre_procedure_ref_app_args4129_205_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_side_effect_4457_249_cfa_info(obj_t, obj_t);
extern select_t allocate_select_cinfo_105_cfa_info();
extern obj_t cfun_cinfo_side_effect__set__194_cfa_info(cfun_t, obj_t);
extern obj_t box_ref_o_cinfo_type_set__20_cfa_info(box_ref_242_t, type_t);
static obj_t _struct_set__app_args_set_3829_39_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_create_vector_app_key_set_4023_254_cfa_info(obj_t, obj_t, obj_t);
extern obj_t fail_cinfo_obj_set__135_cfa_info(fail_t, node_t);
extern node_t select_cinfo_test_124_cfa_info(select_t);
static obj_t _select_cinfo_key_1_cfa_info(obj_t, obj_t);
static obj_t _box_ref_cinfo_var_set_4175_2_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_select_cinfo4242_184_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_stack_allocator_172_cfa_info(cfun_t);
extern obj_t reshaped_local_value_set__28_cfa_info(local_t, value_t);
static obj_t _widening1023_jump_ex_it_cinfo4221_44_cfa_info(obj_t, obj_t);
extern bool_t make_box_o_cinfo__221_cfa_info(obj_t);
extern obj_t struct_set__app_key_set__58_cfa_info(app_t, obj_t);
static obj_t _allocate_sexit_cinfo_64_cfa_info(obj_t);
static obj_t _pre_vector_ref_app_key_37_cfa_info(obj_t, obj_t);
extern bool_t select_cinfo__151_cfa_info(obj_t);
static obj_t _struct_ref_app_stack_info3846_168_cfa_info(obj_t, obj_t);
static obj_t _pre_create_vector_app_loc4018_46_cfa_info(obj_t, obj_t);
static obj_t _fail_cinfo_obj_set_4262_243_cfa_info(obj_t, obj_t, obj_t);
obj_t kwote_node_102_cfa_info = BUNSPEC;
extern pre_struct_set__app_116_t widening1047_pre_struct_set__app_28_cfa_info();
extern obj_t conditional_cinfo_type_set__218_cfa_info(conditional_t, type_t);
static obj_t _jump_ex_it_cinfo_exit4227_62_cfa_info(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t add_class__117___object(obj_t, obj_t, obj_t, long, obj_t, obj_t);
static obj_t _box_set__o_cinfo__123_cfa_info(obj_t, obj_t);
static obj_t object__struct_make_struct_app_173_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_class_204_cfa_info(sfun_t);
extern obj_t create_vector_app_side_effect__set__150_cfa_info(app_t, obj_t);
extern obj_t box_set__o_cinfo_type_set__107_cfa_info(box_set__221_t, type_t);
extern obj_t make_vector_app_stack_stamp_set__141_cfa_info(make_vector_app_205_t, obj_t);
static obj_t _fail_cinfo_type4257_58_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_body4471_1_cfa_info(obj_t, obj_t);
static obj_t _make_funcall_cinfo4301_147_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern node_t box_set__cinfo_value_36_cfa_info(box_set__221_t);
extern obj_t pre_procedure_ref_app_side_effect__41_cfa_info(app_t);
static obj_t _widening1022_set_ex_it_cinfo4231_122_cfa_info(obj_t, obj_t);
extern make_vector_app_205_t widening1041_make_vector_app_175_cfa_info(approx_t, approx_t, long, variable_t, bool_t, obj_t, bool_t);
extern app_t allocate_create_vector_app_89_cfa_info();
extern obj_t reshaped_local_fast_alpha_133_cfa_info(local_t);
extern approx_t cfun_cinfo_approx_232_cfa_info(cfun_cinfo_200_t);
extern obj_t procedure_set__app_key_set__118_cfa_info(app_t, obj_t);
extern var_t create_vector_app_fun_92_cfa_info(app_t);
static obj_t _allocate_struct_set__app_138_cfa_info(obj_t);
static obj_t _pragma_cinfo_side_effect__set_4294_183_cfa_info(obj_t, obj_t, obj_t);
static obj_t _select_cinfo_side_effect_4247_86_cfa_info(obj_t, obj_t);
static obj_t _funcall_cinfo__59_cfa_info(obj_t, obj_t);
static obj_t toplevel_init_63_cfa_info();
static obj_t _reshaped_global_type4354_0_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_set__app_args4117_236_cfa_info(obj_t, obj_t);
static obj_t _setq_cinfo_value_set_4286_185_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_ref_app_args3844_142_cfa_info(obj_t, obj_t);
static obj_t _make_vector_app_fun3975_121_cfa_info(obj_t, obj_t);
extern approx_t setq_cinfo_approx_141_cfa_info(setq_cinfo_191_t);
extern obj_t vector_ref_app_side_effect__set__180_cfa_info(app_t, obj_t);
extern obj_t pre_vector_set__app_key_set__109_cfa_info(app_t, obj_t);
extern sexit_cinfo_49_t make_sexit_cinfo_207_cfa_info(obj_t, bool_t, approx_t);
extern obj_t pre_make_procedure_app_key_set__101_cfa_info(app_t, obj_t);
extern procedure_set__app_32_t make_procedure_set__app_42_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t);
extern obj_t reshaped_local_name_22_cfa_info(local_t);
extern obj_t pre_procedure_ref_app_loc_169_cfa_info(app_t);
static obj_t _make_pre_struct_set__app3872_222_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_cinfo_format_141_cfa_info(pragma_t);
static obj_t _box_ref_o_cinfo__170_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_set__app_stack_info_34_cfa_info(app_t);
static obj_t _cfun_cinfo_side_effect_4483_210_cfa_info(obj_t, obj_t);
extern obj_t procedure_ref_app_stack_info_176_cfa_info(app_t);
static obj_t _pre_create_vector_app__32_cfa_info(obj_t, obj_t);
static obj_t _set_ex_it_cinfo_var_set_4236_142_cfa_info(obj_t, obj_t, obj_t);
extern obj_t approx_type_set__202_cfa_info(approx_t, type_t);
extern obj_t pre_struct_ref_app_key_set__138_cfa_info(app_t, obj_t);
static obj_t struct_object__object_vector_set__app_246_cfa_info(obj_t, obj_t, obj_t);
extern obj_t vector_set__app_side_effect__set__230_cfa_info(app_t, obj_t);
extern obj_t procedure_set__app_side_effect__120_cfa_info(app_t);
static obj_t _pre_make_vector_app_key4040_147_cfa_info(obj_t, obj_t);
static obj_t _box_ref_cinfo_side_effect__set_4173_191_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_scnst_cinfo4418_0_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _select_cinfo_type4245_174_cfa_info(obj_t, obj_t);
extern pre_make_procedure_app_60_t make_pre_make_procedure_app_142_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, variable_t);
extern obj_t make_struct_app_args_183_cfa_info(app_t);
static obj_t _pre_struct_set__app_side_effect__set_3876_249_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_struct_ref_app_loc_17_cfa_info(app_t);
static obj_t _pre_make_struct_app_stack_info3910_27_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_stack_allocator_set_4432_140_cfa_info(obj_t, obj_t, obj_t);
extern obj_t vector_set__app_args_237_cfa_info(app_t);
static obj_t _pre_struct_set__app_type3875_200_cfa_info(obj_t, obj_t);
static obj_t _vector_set__app_args3922_148_cfa_info(obj_t, obj_t);
extern obj_t pre_make_box_loc_183_cfa_info(make_box_202_t);
static obj_t _pre_make_box_value4220_113_cfa_info(obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
static obj_t _make_box_cinfo_loc4203_222_cfa_info(obj_t, obj_t);
extern type_t box_ref_o_cinfo_type_224_cfa_info(box_ref_242_t);
extern obj_t create_vector_app_fun_set__58_cfa_info(app_t, var_t);
extern obj_t reshaped_global_src_set__220_cfa_info(global_t, obj_t);
extern bool_t make_box_cinfo__176_cfa_info(obj_t);
extern obj_t pre_vector_ref_app_fun_set__200_cfa_info(app_t, var_t);
extern funcall_t allocate_funcall_cinfo_11_cfa_info();
extern obj_t open_input_string(obj_t);
static obj_t _make_struct_app_stack_info3861_128_cfa_info(obj_t, obj_t);
extern obj_t create_vector_app_stack_info_51_cfa_info(app_t);
static obj_t _approx_allocs4501_142_cfa_info(obj_t, obj_t);
extern approx_t struct_ref_app_approx_125_cfa_info(struct_ref_app_73_t);
obj_t vector_set__app_21_cfa_info = BUNSPEC;
extern obj_t kwote_ast_node;
static obj_t _cfun_cinfo_stack_allocator4487_207_cfa_info(obj_t, obj_t);
static obj_t _make_pre_procedure_set__app4108_230_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _allocate_make_struct_app_151_cfa_info(obj_t);
static obj_t _setq_cinfo_approx4288_114_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_class_set__12_cfa_info(sfun_t, obj_t);
static obj_t _make_procedure_app_args_set_4086_97_cfa_info(obj_t, obj_t, obj_t);
extern obj_t setq_cinfo_type_set__243_cfa_info(setq_t, type_t);
extern obj_t pre_make_struct_app_type_set__1_cfa_info(app_t, type_t);
static obj_t _widening1035_procedure_ref_app4062_1_cfa_info(obj_t, obj_t);
extern type_t pre_vector_ref_app_type_159_cfa_info(app_t);
extern pre_make_struct_app_218_t widening1045_pre_make_struct_app_3_cfa_info(variable_t);
extern obj_t reshaped_global_library__set__109_cfa_info(global_t, bool_t);
extern box_set__cinfo_94_t make_box_set__cinfo_228_cfa_info(obj_t, type_t, var_t, node_t, approx_t);
static obj_t _app_ly_cinfo_arg_set_4324_253_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_local__93_cfa_info(obj_t, obj_t);
static obj_t _make_struct_app_stack_stamp3871_79_cfa_info(obj_t, obj_t);
extern bool_t box_set__o_cinfo__167_cfa_info(obj_t);
extern obj_t pre_procedure_ref_app_key_86_cfa_info(app_t);
static obj_t _make_cfun_cinfo4480_68_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t reshaped_global_fast_alpha_set__126_cfa_info(global_t, obj_t);
static obj_t _atom_cinfo_loc4343_195_cfa_info(obj_t, obj_t);
obj_t struct_ref_app_73_cfa_info = BUNSPEC;
static obj_t _pre_make_procedure_app_key4140_143_cfa_info(obj_t, obj_t);
extern obj_t make_procedure_app_type_set__163_cfa_info(app_t, type_t);
extern obj_t pre_struct_ref_app_stack_info_set__163_cfa_info(app_t, obj_t);
extern make_box_cinfo_127_t make_make_box_cinfo_79_cfa_info(obj_t, type_t, obj_t, obj_t, node_t, approx_t);
extern obj_t sfun_ast_var;
static obj_t object__struct_reshaped_local_22_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_lost_stamp_set_4095_153_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_loc4449_245_cfa_info(obj_t, obj_t);
static obj_t _make_atom_cinfo4342_156_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_cvar_cinfo_219_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_ref_app_fun_set_3890_179_cfa_info(obj_t, obj_t, obj_t);
static obj_t _approx_top_4503_87_cfa_info(obj_t, obj_t);
static obj_t _pre_create_vector_app_type4020_192_cfa_info(obj_t, obj_t);
static obj_t _pre_create_vector_app_stack_info_set_4029_152_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_struct_ref_app_key_6_cfa_info(app_t);
static obj_t _scnst_cinfo_class_set_4420_88_cfa_info(obj_t, obj_t, obj_t);
extern type_t pre_create_vector_app_type_138_cfa_info(app_t);
static obj_t _allocate_reshaped_local_17_cfa_info(obj_t);
extern obj_t reshaped_global_access_146_cfa_info(global_t);
static obj_t _sexit_cinfo__68_cfa_info(obj_t, obj_t);
static obj_t _vector_set__app_key_147_cfa_info(obj_t, obj_t);
static obj_t _object__struct4510_218___object(obj_t, obj_t);
extern make_vector_app_205_t make_make_vector_app_32_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t, approx_t, long, variable_t, bool_t, obj_t, bool_t);
static obj_t _pre_struct_set__app_type_set_3874_35_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_make_box_key_102_cfa_info(make_box_202_t);
static obj_t _reshaped_local_key4395_20_cfa_info(obj_t, obj_t);
static obj_t _widening1002_cfun_cinfo4479_45_cfa_info(obj_t, obj_t);
extern obj_t make_vector_app_seen__set__213_cfa_info(make_vector_app_205_t, bool_t);
static obj_t _make_vector_app_type3970_181_cfa_info(obj_t, obj_t);
static obj_t _make_pre_struct_ref_app3884_217_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_pre_make_struct_app3897_100_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_sexit_cinfo_98_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_set__app_key_set__8_cfa_info(app_t, obj_t);
extern obj_t pre_vector_set__app_side_effect__set__23_cfa_info(app_t, obj_t);
extern obj_t select_cinfo_loc_246_cfa_info(select_t);
static obj_t _conditional_cinfo_key_29_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_set__app_stack_info3883_34_cfa_info(obj_t, obj_t);
extern obj_t procedure_set__app_args_set__164_cfa_info(app_t, obj_t);
static obj_t _make_setq_cinfo4280_206_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _widening1016_funcall_cinfo4300_74_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
extern long intern_sfun_cinfo_stamp_249_cfa_info(intern_sfun_cinfo_192_t);
extern obj_t vector_set__app_stack_info_set__132_cfa_info(app_t, obj_t);
static obj_t _pre_vector_ref_app_type_set_4006_27_cfa_info(obj_t, obj_t, obj_t);
obj_t kwote_cinfo_48_cfa_info = BUNSPEC;
extern obj_t intern_sfun_cinfo_the_closure_231_cfa_info(sfun_t);
static obj_t _pre_struct_ref_app_fun3891_141_cfa_info(obj_t, obj_t);
extern obj_t setq_ast_node;
static obj_t _pre_make_box_type_set_4213_178_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_stack_info3832_186_cfa_info(obj_t, obj_t);
static obj_t object__struct_fail_cinfo_130_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_arity4455_205_cfa_info(obj_t, obj_t);
extern obj_t make_struct_app_side_effect__set__36_cfa_info(app_t, obj_t);
static obj_t _make_procedure_app_side_effect__set_4081_159_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_predicate_of_78_cfa_info(cfun_t);
extern obj_t extern_sfun_cinfo_loc_set__83_cfa_info(sfun_t, obj_t);
extern obj_t intern_sfun_cinfo_loc_54_cfa_info(sfun_t);
extern obj_t pre_make_procedure_app_side_effect__30_cfa_info(app_t);
static obj_t _box_ref_cinfo_key_241_cfa_info(obj_t, obj_t);
extern long intern_sfun_cinfo_arity_6_cfa_info(sfun_t);
extern obj_t pre_make_vector_app_stack_info_133_cfa_info(app_t);
extern obj_t atom_cinfo_type_set__31_cfa_info(atom_t, type_t);
extern approx_t app_ly_cinfo_approx_252_cfa_info(app_ly_cinfo_234_t);
extern set_ex_it_cinfo_168_t widening1022_set_ex_it_cinfo_89_cfa_info(approx_t);
extern bool_t pre_procedure_ref_app__89_cfa_info(obj_t);
extern obj_t make_vector_app_stack_info_set__239_cfa_info(app_t, obj_t);
extern obj_t box_set__221_ast_node;
obj_t box_ref_cinfo_214_cfa_info = BUNSPEC;
static obj_t object__struct_extern_sfun_cinfo_81_cfa_info(obj_t, obj_t);
extern app_t allocate_make_procedure_app_115_cfa_info();
extern obj_t pre_vector_ref_app_stack_info_34_cfa_info(app_t);
extern pragma_t allocate_pragma_cinfo_134_cfa_info();
static obj_t _pre_struct_set__app_key_set__68_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_struct_app_key_set_3903_249_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1024_pre_make_box_222_cfa_info(obj_t);
extern obj_t pre_make_vector_app_args_set__250_cfa_info(app_t, obj_t);
extern bool_t approx__114_cfa_info(obj_t);
extern obj_t pre_make_box_key_set__46_cfa_info(make_box_202_t, obj_t);
extern obj_t svar_cinfo_clo_env__set__212_cfa_info(svar_cinfo_166_t, bool_t);
static obj_t _widening1034_make_procedure_app4076_93_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t vector_set__app_key_set__63_cfa_info(app_t, obj_t);
extern obj_t make_vector_app_loc_140_cfa_info(app_t);
static obj_t _pre_vector_ref_app__133_cfa_info(obj_t, obj_t);
static obj_t _allocate_svar_cinfo_185_cfa_info(obj_t);
extern type_t create_vector_app_type_249_cfa_info(app_t);
static obj_t struct_object__object_make_procedure_app_38_cfa_info(obj_t, obj_t, obj_t);
extern bool_t reshaped_global_user__181_cfa_info(global_t);
extern bool_t pre_make_procedure_app__25_cfa_info(obj_t);
extern obj_t box_ref_cinfo_loc_176_cfa_info(box_ref_242_t);
static obj_t _pre_create_vector_app_side_effect__set_4021_43_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_vector_set__app_key_195_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_stack_stamp_set_4106_128_cfa_info(obj_t, obj_t, obj_t);
extern bool_t pre_struct_set__app__46_cfa_info(obj_t);
static obj_t _reshaped_local_access_set_4385_25_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_make_vector_app3967_73_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _cvar_cinfo_macro_4406_52_cfa_info(obj_t, obj_t);
extern obj_t select_cinfo_key_178_cfa_info(select_t);
static obj_t _widening1030_box_ref_o_cinfo4148_151_cfa_info(obj_t, obj_t);
extern approx_t vector_set__app_approx_61_cfa_info(vector_set__app_21_t);
extern approx_t jump_ex_it_cinfo_approx_160_cfa_info(jump_ex_it_cinfo_139_t);
extern long make_vector_app_lost_stamp_174_cfa_info(make_vector_app_205_t);
static obj_t _procedure_ref_app_side_effect_4068_53_cfa_info(obj_t, obj_t);
static obj_t _conditional_cinfo_true_set_4274_243_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_struct_app_approx3863_199_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_set__app_loc3873_24_cfa_info(obj_t, obj_t);
extern global_t allocate_reshaped_global_131_cfa_info();
extern node_t make_box_cinfo_value_44_cfa_info(make_box_202_t);
static obj_t _widening1050_struct_set__app3820_227_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_values_approx_ref4094_120_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_vector_set__app_type3995_199_cfa_info(obj_t, obj_t);
static obj_t _pre_make_procedure_app_args_set_4143_113_cfa_info(obj_t, obj_t, obj_t);
extern obj_t object___object;
static obj_t _allocate_pre_procedure_ref_app_105_cfa_info(obj_t);
extern type_t pre_procedure_ref_app_type_232_cfa_info(app_t);
extern obj_t intern_sfun_cinfo_class_26_cfa_info(sfun_t);
extern reshaped_global_160_t widening1011_reshaped_global_190_cfa_info();
static obj_t _allocate_box_set__o_cinfo_20_cfa_info(obj_t);
extern obj_t sexit_cinfo_detached__set__246_cfa_info(sexit_t, bool_t);
extern var_t pre_procedure_ref_app_fun_172_cfa_info(app_t);
static obj_t _pre_make_procedure_app_fun_set_4141_230_cfa_info(obj_t, obj_t, obj_t);
static obj_t _atom_cinfo_type4345_80_cfa_info(obj_t, obj_t);
extern approx_t box_set__o_cinfo_approx_180_cfa_info(box_set__o_cinfo_6_t);
obj_t create_vector_app_150_cfa_info = BUNSPEC;
static obj_t _create_vector_app_stackable_3961_41_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_fun_set_4084_224_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_set__app_type_set__203_cfa_info(app_t, type_t);
static obj_t _pre_struct_ref_app_stack_info_set_3894_151_cfa_info(obj_t, obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_approx4230_117_cfa_info(obj_t, obj_t);
static obj_t _allocate_box_ref_cinfo_238_cfa_info(obj_t);
extern obj_t extern_sfun_cinfo_top__set__250_cfa_info(sfun_t, bool_t);
static obj_t _make_box_o_cinfo_value_set_4196_101_cfa_info(obj_t, obj_t, obj_t);
extern bool_t struct_ref_app__100_cfa_info(obj_t);
static obj_t _procedure_ref_app_stack_info_set_4073_25_cfa_info(obj_t, obj_t, obj_t);
extern app_t allocate_pre_struct_set__app_186_cfa_info();
static obj_t _box_ref_o_cinfo_key_193_cfa_info(obj_t, obj_t);
static obj_t _make_create_vector_app3941_23_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_stack_info_set_4045_187_cfa_info(obj_t, obj_t, obj_t);
static obj_t _setq_cinfo_type4283_134_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_pragma_7_cfa_info(global_t);
static obj_t _allocate_approx_254_cfa_info(obj_t);
extern box_ref_242_t allocate_box_ref_o_cinfo_99_cfa_info();
extern var_t pre_struct_ref_app_fun_229_cfa_info(app_t);
static obj_t _allocate_conditional_cinfo_139_cfa_info(obj_t);
static obj_t _make_vector_app__161_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_predicate_of4431_196_cfa_info(obj_t, obj_t);
extern obj_t pre_struct_set__app_fun_set__90_cfa_info(app_t, var_t);
static obj_t _select_cinfo_approx4252_199_cfa_info(obj_t, obj_t);
extern type_t pre_make_vector_app_type_229_cfa_info(app_t);
extern obj_t pre_make_struct_app_side_effect__set__106_cfa_info(app_t, obj_t);
extern obj_t create_vector_app_seen__set__212_cfa_info(create_vector_app_150_t, bool_t);
static obj_t _allocate_app_ly_cinfo_17_cfa_info(obj_t);
static obj_t _create_vector_app_side_effect_3946_172_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_sexit_cinfo_74_cfa_info(obj_t, obj_t, obj_t);
static obj_t _approx_lost_stamp4505_172_cfa_info(obj_t, obj_t);
extern bool_t box_ref_o_cinfo__192_cfa_info(obj_t);
extern obj_t local_ast_var;
obj_t make_procedure_app_48_cfa_info = BUNSPEC;
extern obj_t make_vector_app_key_103_cfa_info(app_t);
extern obj_t box_set__cinfo_var_set__136_cfa_info(box_set__221_t, var_t);
static obj_t _conditional_cinfo_side_effect_4271_3_cfa_info(obj_t, obj_t);
static obj_t _widening1028_box_ref_cinfo4168_108_cfa_info(obj_t, obj_t);
static obj_t _sexit_cinfo_handler_set_4399_90_cfa_info(obj_t, obj_t, obj_t);
extern obj_t extern_sfun_cinfo_property_112_cfa_info(sfun_t);
extern obj_t box_ref_cinfo_key_199_cfa_info(box_ref_242_t);
extern obj_t pre_struct_ref_app_stack_info_193_cfa_info(app_t);
extern extern_sfun_cinfo_6_t widening1003_extern_sfun_cinfo_159_cfa_info(approx_t);
static obj_t _procedure_ref_app_fun4070_3_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_args_set_4128_84_cfa_info(obj_t, obj_t, obj_t);
extern obj_t select_cinfo_test_set__246_cfa_info(select_t, node_t);
static obj_t _select_cinfo_key_set__141_cfa_info(obj_t, obj_t, obj_t);
extern app_ly_cinfo_234_t widening1015_app_ly_cinfo_53_cfa_info(approx_t);
static obj_t _procedure_ref_app_args_set_4071_177_cfa_info(obj_t, obj_t, obj_t);
extern vector_set__app_21_t make_vector_set__app_24_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t);
extern pre_create_vector_app_162_t widening1038_pre_create_vector_app_165_cfa_info(variable_t);
static obj_t _funcall_cinfo_args4308_56_cfa_info(obj_t, obj_t);
static obj_t _allocate_atom_cinfo_64_cfa_info(obj_t);
extern obj_t pre_vector_set__app_args_set__202_cfa_info(app_t, obj_t);
extern obj_t extern_sfun_cinfo_stack_allocator_set__23_cfa_info(sfun_t, obj_t);
extern obj_t pre_make_procedure_app_side_effect__set__13_cfa_info(app_t, obj_t);
extern obj_t pre_make_procedure_app_args_set__119_cfa_info(app_t, obj_t);
extern set_ex_it_116_t allocate_set_ex_it_cinfo_32_cfa_info();
extern obj_t make_box_cinfo_side_effect__set__59_cfa_info(make_box_202_t, obj_t);
extern obj_t pre_create_vector_app_fun_set__208_cfa_info(app_t, var_t);
static obj_t _funcall_cinfo_arity_error_noticed__set_4313_165_cfa_info(obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo_type_set_4303_21_cfa_info(obj_t, obj_t, obj_t);
extern bool_t extern_sfun_cinfo_top__212_cfa_info(sfun_t);
static obj_t _reshaped_local_type_set_4381_49_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_vector_app_key_set__16_cfa_info(obj_t, obj_t, obj_t);
extern type_t procedure_ref_app_type_95_cfa_info(app_t);
extern obj_t vector_ref_app_key_set__80_cfa_info(app_t, obj_t);
static obj_t _pre_make_struct_app__245_cfa_info(obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_value4229_147_cfa_info(obj_t, obj_t);
static obj_t _box_set__cinfo__142_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_class_set_4444_82_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_owner4103_232_cfa_info(obj_t, obj_t);
extern app_t allocate_pre_make_struct_app_64_cfa_info();
static obj_t _make_procedure_app_t_set_4101_189_cfa_info(obj_t, obj_t, obj_t);
static obj_t _vector_set__app_type_set_3915_252_cfa_info(obj_t, obj_t, obj_t);
extern obj_t struct_set__app_side_effect__set__203_cfa_info(app_t, obj_t);
static obj_t _make_procedure_app_fun4085_52_cfa_info(obj_t, obj_t);
extern node_t conditional_cinfo_test_91_cfa_info(conditional_t);
extern node_t box_set__o_cinfo_value_185_cfa_info(box_set__221_t);
obj_t pre_procedure_ref_app_85_cfa_info = BUNSPEC;
static obj_t struct_object__object_pre_procedure_set__app_129_cfa_info(obj_t, obj_t, obj_t);
obj_t approx_cfa_info = BUNSPEC;
extern type_t select_cinfo_item_type_151_cfa_info(select_t);
static obj_t _widening1008_cvar_cinfo4404_111_cfa_info(obj_t, obj_t);
extern obj_t make_box_o_cinfo_side_effect__set__221_cfa_info(make_box_202_t, obj_t);
static obj_t _box_set__cinfo_approx4187_33_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_body_52_cfa_info(sfun_t);
extern obj_t procedure_set__app_stack_info_set__250_cfa_info(app_t, obj_t);
static obj_t _widening1012_atom_cinfo4341_187_cfa_info(obj_t, obj_t);
extern var_t box_ref_o_cinfo_var_44_cfa_info(box_ref_242_t);
static obj_t _struct_set__app_side_effect__set_3825_156_cfa_info(obj_t, obj_t, obj_t);
extern app_t allocate_struct_set__app_3_cfa_info();
extern obj_t create_vector_app_lost_stamp_set__92_cfa_info(create_vector_app_150_t, long);
static obj_t _pre_procedure_ref_app_loc4121_31_cfa_info(obj_t, obj_t);
extern long create_vector_app_lost_stamp_72_cfa_info(create_vector_app_150_t);
extern obj_t make_procedure_app_fun_set__162_cfa_info(app_t, var_t);
static obj_t _funcall_cinfo_approx4311_125_cfa_info(obj_t, obj_t);
static obj_t _pre_clo_env_loc_set_4415_110_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1039_pre_vector_ref_app_183_cfa_info(obj_t);
static obj_t _procedure_set__app_fun4056_131_cfa_info(obj_t, obj_t);
static obj_t _procedure_set__app_key_231_cfa_info(obj_t, obj_t);
static obj_t _allocate_pre_procedure_set__app_24_cfa_info(obj_t);
extern obj_t box_set__o_cinfo_var_set__7_cfa_info(box_set__221_t, var_t);
static obj_t _app_ly_cinfo_loc4319_10_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_side_effect_4194_224_cfa_info(obj_t, obj_t);
extern scnst_cinfo_0_t widening1005_scnst_cinfo_42_cfa_info(approx_t);
static obj_t _sexit_cinfo_detached__set_4401_18_cfa_info(obj_t, obj_t, obj_t);
extern kwote_node_102_t make_kwote_node_13_cfa_info(obj_t, type_t, obj_t, node_t);
static obj_t _conditional_cinfo_type_set_4268_201_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_side_effect__165_cfa_info(cfun_t);
extern setq_t allocate_setq_cinfo_202_cfa_info();
static obj_t _conditional_cinfo_approx4278_206_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_top__set_4488_176_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_infix__set_4494_96_cfa_info(obj_t, obj_t, obj_t);
static obj_t _select_cinfo_type_set_4244_74_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_struct_set__app_147_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_lost_stamp_set__66_cfa_info(make_procedure_app_48_t, long);
static obj_t _reshaped_global_pragma4374_115_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_set__app_args_set_4000_233_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_owner4047_141_cfa_info(obj_t, obj_t);
static obj_t _create_vector_app_stack_stamp_set_3962_205_cfa_info(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_stack_info_set_3952_56_cfa_info(obj_t, obj_t, obj_t);
extern make_box_o_cinfo_96_t widening1026_make_box_o_cinfo_221_cfa_info(approx_t, approx_t);
static obj_t _conditional_cinfo_loc4267_89_cfa_info(obj_t, obj_t);
static obj_t _box_ref_cinfo_type_set_4171_142_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_local_id4378_67_cfa_info(obj_t, obj_t);
static obj_t _make_struct_app_approx_set_3862_80_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_box_cinfo_value_set__204_cfa_info(make_box_202_t, node_t);
static obj_t object__struct_pre_make_box_150_cfa_info(obj_t, obj_t);
obj_t setq_cinfo_191_cfa_info = BUNSPEC;
static obj_t _app_ly_cinfo_type4321_85_cfa_info(obj_t, obj_t);
extern var_t box_set__cinfo_var_126_cfa_info(box_set__221_t);
extern obj_t pre_struct_set__app_args_set__238_cfa_info(app_t, obj_t);
static obj_t _pre_vector_ref_app_stack_info4015_64_cfa_info(obj_t, obj_t);
static obj_t _scnst_cinfo_loc4423_42_cfa_info(obj_t, obj_t);
static obj_t _vector_set__app_loc3914_162_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box_key_set_4217_70_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_top__set__172_cfa_info(cfun_t, bool_t);
static obj_t _pre_struct_set__app_args3881_189_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_import_set__167_cfa_info(global_t, obj_t);
static obj_t _pre_procedure_ref_app_side_effect__set_4124_61_cfa_info(obj_t, obj_t, obj_t);
extern obj_t extern_sfun_cinfo_dsssl_keywords_set__212_cfa_info(sfun_t, obj_t);
static obj_t _struct_ref_app_args_set_3843_166_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_module4365_231_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_fast_alpha_set__175_cfa_info(local_t, obj_t);
static obj_t _cfun_cinfo_stack_allocator_set_4486_92_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_vector_set__app_key_set__241_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_args_set_4468_204_cfa_info(obj_t, obj_t, obj_t);
extern var_t make_vector_app_fun_121_cfa_info(app_t);
extern bool_t pre_procedure_set__app__184_cfa_info(obj_t);
extern box_set__221_t allocate_box_set__cinfo_232_cfa_info();
static obj_t _create_vector_app_stackable__set_3960_139_cfa_info(obj_t, obj_t, obj_t);
extern variable_t pre_make_vector_app_owner_220_cfa_info(pre_make_vector_app_251_t);
extern app_t allocate_make_struct_app_180_cfa_info();
extern obj_t reshaped_global_import_91_cfa_info(global_t);
extern bool_t funcall_cinfo__175_cfa_info(obj_t);
static obj_t _set_ex_it_cinfo_type4235_175_cfa_info(obj_t, obj_t);
extern type_t jump_ex_it_cinfo_type_129_cfa_info(jump_ex_it_184_t);
static obj_t _set_ex_it_cinfo__175_cfa_info(obj_t, obj_t);
extern obj_t pre_struct_set__app_side_effect__set__33_cfa_info(app_t, obj_t);
extern obj_t cfun_cinfo_the_closure_238_cfa_info(cfun_t);
extern type_t pre_struct_ref_app_type_242_cfa_info(app_t);
static obj_t _vector_ref_app_key_21_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_x_t__set_4097_188_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_ref_o_cinfo_loc4150_12_cfa_info(obj_t, obj_t);
static obj_t _make_kwote_node4335_66_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_struct_ref_app_args_set__168_cfa_info(app_t, obj_t);
extern make_box_202_t allocate_make_box_cinfo_213_cfa_info();
extern approx_t make_approx_172_cfa_info(type_t, bool_t, obj_t, bool_t, long);
extern obj_t struct_set__app_fun_set__208_cfa_info(app_t, var_t);
static obj_t _fail_cinfo_type_set_4256_100_cfa_info(obj_t, obj_t, obj_t);
static obj_t object_init_111_cfa_info();
extern bool_t pre_make_box__245_cfa_info(obj_t);
static obj_t _conditional_cinfo_type4269_211_cfa_info(obj_t, obj_t);
extern obj_t scnst_cinfo_node_230_cfa_info(scnst_t);
extern obj_t make_struct_app_stack_info_206_cfa_info(app_t);
extern obj_t struct_ref_app_loc_11_cfa_info(app_t);
static obj_t struct_object__object_pre_make_struct_app_226_cfa_info(obj_t, obj_t, obj_t);
extern vector_ref_app_195_t make_vector_ref_app_105_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t);
static obj_t _atom_cinfo__122_cfa_info(obj_t, obj_t);
extern obj_t pre_procedure_set__app_side_effect__set__95_cfa_info(app_t, obj_t);
static obj_t _pre_vector_set__app_stack_info_set_4002_134_cfa_info(obj_t, obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_type_set_4224_254_cfa_info(obj_t, obj_t, obj_t);
extern obj_t kwote_cinfo_type_set__163_cfa_info(kwote_t, type_t);
extern type_t pre_struct_set__app_type_46_cfa_info(app_t);
static obj_t _atom_cinfo_type_set_4344_128_cfa_info(obj_t, obj_t, obj_t);
extern approx_t select_cinfo_approx_174_cfa_info(select_cinfo_150_t);
static obj_t _pre_make_struct_app_stack_info_set_3909_197_cfa_info(obj_t, obj_t, obj_t);
extern obj_t create_vector_app_stackable__set__21_cfa_info(create_vector_app_150_t, bool_t);
extern approx_t conditional_cinfo_approx_37_cfa_info(conditional_cinfo_212_t);
static obj_t _scnst_cinfo_loc_set_4422_122_cfa_info(obj_t, obj_t, obj_t);
extern type_t kwote_node_type_31_cfa_info(kwote_t);
extern approx_t funcall_cinfo_va_approx_93_cfa_info(funcall_cinfo_75_t);
extern bool_t make_vector_app_stackable__199_cfa_info(make_vector_app_205_t);
static obj_t _svar_cinfo_clo_env__set_4413_164_cfa_info(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_key_221_cfa_info(obj_t, obj_t);
extern obj_t procedure_set__app_fun_set__159_cfa_info(app_t, var_t);
static obj_t _pre_create_vector_app_args4028_255_cfa_info(obj_t, obj_t);
extern obj_t pre_make_vector_app_key_set__238_cfa_info(app_t, obj_t);
extern obj_t make_vector_app_approx_set__66_cfa_info(make_vector_app_205_t, approx_t);
extern obj_t procedure_set__app_args_80_cfa_info(app_t);
extern obj_t pre_create_vector_app_loc_83_cfa_info(app_t);
static obj_t _make_intern_sfun_cinfo4426_20_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_box_ref_cinfo_171_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_set__app_fun3999_141_cfa_info(obj_t, obj_t);
static obj_t _make_vector_app_args3977_212_cfa_info(obj_t, obj_t);
static obj_t _procedure_ref_app_type4066_25_cfa_info(obj_t, obj_t);
static obj_t _box_ref_o_cinfo_type4152_46_cfa_info(obj_t, obj_t);
static obj_t _pre_clo_env__150_cfa_info(obj_t, obj_t);
extern vector_ref_app_195_t widening1043_vector_ref_app_60_cfa_info(approx_t);
extern obj_t pre_vector_set__app_fun_set__57_cfa_info(app_t, var_t);
extern obj_t pre_make_procedure_app_fun_set__110_cfa_info(app_t, var_t);
static obj_t object__struct_make_procedure_app_124_cfa_info(obj_t, obj_t);
static obj_t _make_struct_app_side_effect_3854_6_cfa_info(obj_t, obj_t);
static obj_t _create_vector_app__45_cfa_info(obj_t, obj_t);
extern funcall_cinfo_75_t make_funcall_cinfo_132_cfa_info(obj_t, type_t, node_t, obj_t, obj_t, approx_t, approx_t, bool_t, bool_t);
extern obj_t make_procedure_app_stackable__set__58_cfa_info(make_procedure_app_48_t, bool_t);
static obj_t _allocate_pre_struct_ref_app_15_cfa_info(obj_t);
extern obj_t pre_vector_ref_app_side_effect__set__95_cfa_info(app_t, obj_t);
static obj_t _procedure_set__app_type_set_4051_224_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_cinfo__189_cfa_info(obj_t, obj_t);
static obj_t _kwote_cinfo_loc4329_151_cfa_info(obj_t, obj_t);
extern obj_t pre_struct_ref_app_fun_set__223_cfa_info(app_t, var_t);
extern type_t set_ex_it_cinfo_type_68_cfa_info(set_ex_it_116_t);
extern obj_t reshaped_global_removable_146_cfa_info(global_t);
extern long approx_lost_stamp_29_cfa_info(approx_t);
extern bool_t make_vector_app__222_cfa_info(obj_t);
extern type_t pre_make_box_type_57_cfa_info(make_box_202_t);
static obj_t _make_procedure_app_approx4091_52_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_side_effect__set__189_cfa_info(sfun_t, obj_t);
static obj_t _make_pre_clo_env_110_cfa_info(obj_t, obj_t);
extern obj_t pre_create_vector_app_side_effect__159_cfa_info(app_t);
static obj_t _make_struct_app_loc3850_156_cfa_info(obj_t, obj_t);
extern obj_t struct_ref_app_side_effect__set__108_cfa_info(app_t, obj_t);
extern type_t box_set__cinfo_type_226_cfa_info(box_set__221_t);
extern approx_t make_box_o_cinfo_approx_146_cfa_info(make_box_o_cinfo_96_t);
static obj_t _make_struct_app_type3852_107_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_predicate_of4459_42_cfa_info(obj_t, obj_t);
extern obj_t make_procedure_app_t_set__133_cfa_info(make_procedure_app_48_t, bool_t);
extern obj_t struct_ref_app_key_250_cfa_info(app_t);
extern obj_t make_box_cinfo_key_set__72_cfa_info(make_box_202_t, obj_t);
extern bool_t cfun_cinfo_top__138_cfa_info(cfun_t);
static obj_t _create_vector_app_key3947_51_cfa_info(obj_t, obj_t);
extern sexit_t allocate_sexit_cinfo_160_cfa_info();
extern obj_t pre_make_box_value_set__57_cfa_info(make_box_202_t, node_t);
extern obj_t select_cinfo_clauses_111_cfa_info(select_t);
extern obj_t make_procedure_app_values_approx_set__111_cfa_info(make_procedure_app_48_t, long, approx_t);
static obj_t _reshaped_local_user_4394_145_cfa_info(obj_t, obj_t);
extern bool_t conditional_cinfo__69_cfa_info(obj_t);
extern app_t allocate_pre_vector_ref_app_241_cfa_info();
static obj_t _svar_cinfo_loc4411_139_cfa_info(obj_t, obj_t);
extern obj_t pre_make_procedure_app_stack_info_set__177_cfa_info(app_t, obj_t);
extern obj_t setq_cinfo_value_set__184_cfa_info(setq_t, node_t);
extern var_t setq_cinfo_var_51_cfa_info(setq_t);
extern obj_t make_procedure_app_side_effect__set__181_cfa_info(app_t, obj_t);
extern obj_t intern_sfun_cinfo_body_set__86_cfa_info(sfun_t, obj_t);
static obj_t _extern_sfun_cinfo_approx4478_97_cfa_info(obj_t, obj_t);
extern obj_t make_vector_app_side_effect__set__75_cfa_info(app_t, obj_t);
static obj_t _box_ref_cinfo__65_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_set__app_key_140_cfa_info(obj_t, obj_t);
extern obj_t sexit_ast_var;
static obj_t _scnst_cinfo_node4419_234_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_pre_vector_ref_app_99_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_create_vector_app_key_92_cfa_info(app_t);
static obj_t object__struct_make_vector_app_114_cfa_info(obj_t, obj_t);
static obj_t _make_pre_procedure_ref_app4120_6_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_create_vector_app_213_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_procedure_app_key_set_4139_227_cfa_info(obj_t, obj_t, obj_t);
extern approx_t set_ex_it_cinfo_approx_28_cfa_info(set_ex_it_cinfo_168_t);
static obj_t _make_struct_app_owner3867_64_cfa_info(obj_t, obj_t);
static obj_t _vector_ref_app_loc3928_132_cfa_info(obj_t, obj_t);
static obj_t _make_vector_app_seen_3991_253_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_top__set_4462_110_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_args_93_cfa_info(app_t);
static obj_t object__struct_select_cinfo_146_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_args_90_cfa_info(sfun_t);
static obj_t _setq_cinfo__245_cfa_info(obj_t, obj_t);
extern obj_t jump_ex_it_cinfo_type_set__231_cfa_info(jump_ex_it_184_t, type_t);
extern obj_t vector_set__app_loc_147_cfa_info(app_t);
static obj_t _create_vector_app_value_approx3956_148_cfa_info(obj_t, obj_t);
extern obj_t fail_cinfo_proc_set__66_cfa_info(fail_t, node_t);
extern pre_procedure_ref_app_85_t make_pre_procedure_ref_app_17_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t);
extern obj_t pre_make_struct_app_args_251_cfa_info(app_t);
static obj_t _allocate_cfun_cinfo_87_cfa_info(obj_t);
static obj_t _make_box_o_cinfo_side_effect__set_4193_232_cfa_info(obj_t, obj_t, obj_t);
extern obj_t conditional_cinfo_true_set__242_cfa_info(conditional_t, node_t);
extern bool_t procedure_ref_app__140_cfa_info(obj_t);
extern obj_t select_cinfo_type_set__83_cfa_info(select_t, type_t);
extern obj_t pre_make_vector_app_side_effect__69_cfa_info(app_t);
extern obj_t pre_vector_set__app_args_27_cfa_info(app_t);
extern obj_t select_ast_node;
extern app_t allocate_pre_create_vector_app_95_cfa_info();
static obj_t _cfun_cinfo_predicate_of4485_174_cfa_info(obj_t, obj_t);
static obj_t _setq_cinfo_loc4281_14_cfa_info(obj_t, obj_t);
static obj_t _create_vector_app_owner3959_48_cfa_info(obj_t, obj_t);
static obj_t _widening1006_pre_clo_env_70_cfa_info(obj_t);
static obj_t struct_object__object_conditional_cinfo_141_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_struct_app_type_set_3851_13_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_vector_set__app__223_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_occurrence_set_4391_31_cfa_info(obj_t, obj_t, obj_t);
extern bool_t create_vector_app_stackable__57_cfa_info(create_vector_app_150_t);
static obj_t _intern_sfun_cinfo_args_set_4440_25_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_set__app_fun_set__200_cfa_info(app_t, var_t);
static obj_t _box_ref_cinfo_type4172_28_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo_clauses4250_19_cfa_info(obj_t, obj_t);
extern approx_t cvar_cinfo_approx_12_cfa_info(cvar_cinfo_53_t);
extern obj_t pragma_cinfo_args_224_cfa_info(pragma_t);
static obj_t _funcall_cinfo_fun4306_184_cfa_info(obj_t, obj_t);
static obj_t _pre_make_struct_app_fun3906_132_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_removable_set__53_cfa_info(global_t, obj_t);
static obj_t _reshaped_global_value_set_4355_229_cfa_info(obj_t, obj_t, obj_t);
extern obj_t extern_sfun_cinfo_the_closure_159_cfa_info(sfun_t);
static obj_t _make_vector_set__app3913_180_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _kwote_node_node4340_239_cfa_info(obj_t, obj_t);
extern approx_t funcall_cinfo_approx_11_cfa_info(funcall_cinfo_75_t);
extern obj_t struct_ref_app_args_set__33_cfa_info(app_t, obj_t);
extern obj_t pre_struct_set__app_side_effect__190_cfa_info(app_t);
static obj_t _reshaped_local_type4382_168_cfa_info(obj_t, obj_t);
static obj_t _allocate_intern_sfun_cinfo_249_cfa_info(obj_t);
extern bool_t atom_cinfo__127_cfa_info(obj_t);
static obj_t _pre_vector_set__app_args4001_232_cfa_info(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern pre_struct_set__app_116_t make_pre_struct_set__app_188_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t);
static obj_t _pre_vector_ref_app_fun_set_4010_91_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_struct_app_args_set_3907_42_cfa_info(obj_t, obj_t, obj_t);
obj_t pre_vector_ref_app_208_cfa_info = BUNSPEC;
static obj_t _widening1011_reshaped_global_101_cfa_info(obj_t);
extern obj_t make_procedure_app_x_t__set__53_cfa_info(make_procedure_app_48_t, bool_t);
static obj_t struct_object__object_kwote_node_133_cfa_info(obj_t, obj_t, obj_t);
static obj_t _approx_type_locked_4500_170_cfa_info(obj_t, obj_t);
static obj_t _vector_set__app_approx3925_213_cfa_info(obj_t, obj_t);
static obj_t _pre_make_struct_app_side_effect_3902_234_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_arity4481_7_cfa_info(obj_t, obj_t);
extern pre_vector_ref_app_208_t widening1039_pre_vector_ref_app_74_cfa_info();
static obj_t _widening1033_pre_procedure_set__app_239_cfa_info(obj_t);
static obj_t _pre_procedure_set__app_type_set_4110_185_cfa_info(obj_t, obj_t, obj_t);
extern jump_ex_it_184_t allocate_jump_ex_it_cinfo_167_cfa_info();
extern bool_t kwote_cinfo__51_cfa_info(obj_t);
extern obj_t procedure_ref_app_args_set__11_cfa_info(app_t, obj_t);
static obj_t _allocate_make_vector_app_18_cfa_info(obj_t);
static obj_t _allocate_pre_struct_set__app_93_cfa_info(obj_t);
static obj_t object__struct_struct_ref_app_85_cfa_info(obj_t, obj_t);
extern app_t allocate_pre_procedure_set__app_97_cfa_info();
extern obj_t create_vector_app_args_set__204_cfa_info(app_t, obj_t);
extern make_procedure_app_48_t widening1034_make_procedure_app_105_cfa_info(approx_t, long, approx_t, long, bool_t, bool_t, bool_t, variable_t, bool_t, obj_t);
static obj_t _conditional_cinfo_side_effect__set_4270_90_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1010_reshaped_local_27_cfa_info(obj_t, obj_t);
extern conditional_cinfo_212_t make_conditional_cinfo_187_cfa_info(obj_t, type_t, obj_t, obj_t, node_t, node_t, node_t, approx_t);
extern obj_t pre_make_vector_app_side_effect__set__39_cfa_info(app_t, obj_t);
static obj_t _make_struct_app_key_set__175_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_vector_app_key_set__25_cfa_info(app_t, obj_t);
extern obj_t vector_set__app_key_77_cfa_info(app_t);
static obj_t _pre_vector_ref_app_type4007_159_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_ref_app_side_effect__set_4008_64_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_struct_ref_app_88_cfa_info(obj_t);
static obj_t _make_procedure_app_stackable_4105_191_cfa_info(obj_t, obj_t);
static obj_t _procedure_ref_app_key_set__179_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_vector_ref_app_args_set__156_cfa_info(app_t, obj_t);
extern bool_t make_procedure_app_x_178_cfa_info(make_procedure_app_48_t);
static obj_t _make_vector_app_key3973_24_cfa_info(obj_t, obj_t);
static obj_t _app_ly_cinfo__202_cfa_info(obj_t, obj_t);
static obj_t _pre_make_procedure_app_owner4147_18_cfa_info(obj_t, obj_t);
extern app_ly_cinfo_234_t make_app_ly_cinfo_1_cfa_info(obj_t, type_t, node_t, node_t, approx_t);
static obj_t _make_box_o_cinfo_type4192_221_cfa_info(obj_t, obj_t);
extern bool_t make_procedure_app_t_252_cfa_info(make_procedure_app_48_t);
extern obj_t vector_set__app_fun_set__135_cfa_info(app_t, var_t);
extern procedure_set__app_32_t widening1036_procedure_set__app_234_cfa_info(approx_t);
static obj_t _widening1009_sexit_cinfo4397_17_cfa_info(obj_t, obj_t);
static obj_t _approx_top__set_4502_59_cfa_info(obj_t, obj_t, obj_t);
extern var_t struct_ref_app_fun_232_cfa_info(app_t);
extern bool_t set_ex_it_cinfo__11_cfa_info(obj_t);
static obj_t _intern_sfun_cinfo__158_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_type_set__56_cfa_info(global_t, type_t);
static obj_t _vector_ref_app_side_effect__set_3931_208_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_ref_cinfo_loc4170_99_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_class4445_4_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_fast_alpha_set_4387_79_cfa_info(obj_t, obj_t, obj_t);
static obj_t _vector_set__app_side_effect_3918_82_cfa_info(obj_t, obj_t);
static obj_t _make_box_ref_o_cinfo4149_10_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_box_o_cinfo_value_approx4200_243_cfa_info(obj_t, obj_t);
extern obj_t make_procedure_app_approx_set__127_cfa_info(make_procedure_app_48_t, approx_t);
extern obj_t intern_sfun_cinfo_the_closure_set__54_cfa_info(sfun_t, obj_t);
extern obj_t vector_ref_app_args_194_cfa_info(app_t);
static obj_t _struct_ref_app__47_cfa_info(obj_t, obj_t);
extern obj_t make_struct_app_args_set__242_cfa_info(app_t, obj_t);
static obj_t _procedure_ref_app_key_2_cfa_info(obj_t, obj_t);
extern var_t pre_create_vector_app_fun_107_cfa_info(app_t);
static obj_t _box_ref_o_cinfo_key_set__163_cfa_info(obj_t, obj_t, obj_t);
extern make_procedure_app_48_t make_make_procedure_app_99_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, approx_t, long, approx_t, long, bool_t, bool_t, bool_t, variable_t, bool_t, obj_t);
extern pre_make_struct_app_218_t make_pre_make_struct_app_250_cfa_info(obj_t, type_t, obj_t, obj_t, var_t, obj_t, obj_t, variable_t);
extern obj_t sexit_cinfo_handler_23_cfa_info(sexit_t);
extern obj_t procedure_set__app_side_effect__set__24_cfa_info(app_t, obj_t);
extern obj_t pre_make_struct_app_stack_info_182_cfa_info(app_t);
extern obj_t make_vector_app_type_set__45_cfa_info(app_t, type_t);
extern obj_t box_ref_o_cinfo_loc_36_cfa_info(box_ref_242_t);
static obj_t _pre_make_vector_app_type4036_231_cfa_info(obj_t, obj_t);
static obj_t _conditional_cinfo_key_set__114_cfa_info(obj_t, obj_t, obj_t);
extern type_t kwote_cinfo_type_193_cfa_info(kwote_t);
static obj_t _create_vector_app_seen__set_3964_25_cfa_info(obj_t, obj_t, obj_t);
static obj_t _procedure_ref_app_approx4075_236_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_approx4496_91_cfa_info(obj_t, obj_t);
static obj_t _allocate_pre_clo_env_10_cfa_info(obj_t);
static obj_t _reshaped_local_value_set_4383_162_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_make_struct_app_85_cfa_info(obj_t);
static obj_t _reshaped_global_src_set_4375_186_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_vector_set__app_75_cfa_info(obj_t, obj_t);
static obj_t _allocate_procedure_set__app_204_cfa_info(obj_t);
extern obj_t pre_struct_set__app_stack_info_set__52_cfa_info(app_t, obj_t);
obj_t sexit_cinfo_49_cfa_info = BUNSPEC;
extern obj_t pre_make_vector_app_loc_212_cfa_info(app_t);
static obj_t _make_struct_ref_app3835_139_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
obj_t app_ly_cinfo_234_cfa_info = BUNSPEC;
extern bool_t pre_vector_ref_app__184_cfa_info(obj_t);
extern svar_t allocate_svar_cinfo_217_cfa_info();
extern type_t pre_procedure_set__app_type_159_cfa_info(app_t);
extern approx_t struct_set__app_approx_154_cfa_info(struct_set__app_162_t);
static obj_t _make_procedure_app_x_t_4098_104_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_predicate_of_set_4458_176_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening1042_create_vector_app3940_225_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _box_set__cinfo_loc4180_133_cfa_info(obj_t, obj_t);
static obj_t _pre_create_vector_app_fun4026_202_cfa_info(obj_t, obj_t);
static obj_t object__struct_create_vector_app_178_cfa_info(obj_t, obj_t);
static obj_t _allocate_procedure_ref_app_56_cfa_info(obj_t);
static obj_t _pragma_cinfo_type4293_206_cfa_info(obj_t, obj_t);
static obj_t _pre_make_vector_app_loc4034_165_cfa_info(obj_t, obj_t);
extern bool_t cfun_cinfo_macro__33_cfa_info(cfun_t);
extern obj_t object__struct_50___object(object_t);
extern long make_struct_app_lost_stamp_13_cfa_info(make_struct_app_214_t);
extern bool_t setq_cinfo__121_cfa_info(obj_t);
static obj_t _conditional_cinfo_true4275_31_cfa_info(obj_t, obj_t);
static obj_t _pre_struct_ref_app_args_set_3892_26_cfa_info(obj_t, obj_t, obj_t);
extern make_box_202_t allocate_make_box_o_cinfo_222_cfa_info();
extern obj_t pragma_cinfo_type_set__38_cfa_info(pragma_t, type_t);
extern approx_t make_box_o_cinfo_value_approx_169_cfa_info(make_box_o_cinfo_96_t);
static obj_t _create_vector_app_args_set_3950_85_cfa_info(obj_t, obj_t, obj_t);
obj_t svar_cinfo_166_cfa_info = BUNSPEC;
extern node_t conditional_cinfo_false_155_cfa_info(conditional_t);
extern type_t approx_type_27_cfa_info(approx_t);
extern vector_set__app_21_t widening1044_vector_set__app_206_cfa_info(approx_t);
static obj_t _create_vector_app_approx3955_106_cfa_info(obj_t, obj_t);
extern obj_t struct_ref_app_key_set__1_cfa_info(app_t, obj_t);
extern obj_t box_set__cinfo_loc_149_cfa_info(box_set__221_t);
static obj_t _vector_ref_app_args_set_3935_221_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_key_168_cfa_info(obj_t, obj_t);
static obj_t _widening1021_select_cinfo4241_110_cfa_info(obj_t, obj_t);
extern struct_ref_app_73_t widening1049_struct_ref_app_102_cfa_info(approx_t);
extern bool_t extern_sfun_cinfo__167_cfa_info(obj_t);
extern pre_clo_env_191_t make_pre_clo_env_164_cfa_info(obj_t);
extern obj_t jump_ex_it_cinfo_value_set__150_cfa_info(jump_ex_it_184_t, node_t);
static obj_t struct_object__object_box_set__cinfo_119_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_top__set_4434_86_cfa_info(obj_t, obj_t, obj_t);
extern var_t box_set__o_cinfo_var_171_cfa_info(box_set__221_t);
static obj_t _box_set__o_cinfo_type_set_4161_232_cfa_info(obj_t, obj_t, obj_t);
extern reshaped_local_224_t make_reshaped_local_12_cfa_info(obj_t, obj_t, type_t, value_t, obj_t, obj_t, obj_t, long, bool_t, long, obj_t);
static obj_t _funcall_cinfo_fun_set_4305_215_cfa_info(obj_t, obj_t, obj_t);
extern type_t funcall_cinfo_type_26_cfa_info(funcall_t);
static obj_t require_initialization_114_cfa_info = BUNSPEC;
static obj_t _make_vector_app_type_set_3969_21_cfa_info(obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo_va_approx4312_166_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_module_134_cfa_info(global_t);
static obj_t _reshaped_global_library__set_4370_158_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_the_closure4437_96_cfa_info(obj_t, obj_t);
extern obj_t conditional_ast_node;
extern obj_t kwote_cinfo_loc_185_cfa_info(kwote_t);
extern obj_t pre_procedure_ref_app_args_set__9_cfa_info(app_t, obj_t);
extern obj_t make_vector_app_stack_stamp_1_cfa_info(make_vector_app_205_t);
extern obj_t extern_sfun_cinfo_body_232_cfa_info(sfun_t);
static obj_t _pre_create_vector_app_args_set_4027_207_cfa_info(obj_t, obj_t, obj_t);
extern obj_t box_ref_o_cinfo_key_232_cfa_info(box_ref_242_t);
extern obj_t vector_ref_app_fun_set__119_cfa_info(app_t, var_t);
extern obj_t intern_sfun_cinfo_stack_allocator_set__130_cfa_info(sfun_t, obj_t);
extern obj_t pre_create_vector_app_args_set__3_cfa_info(app_t, obj_t);
extern approx_t make_procedure_app_approx_226_cfa_info(make_procedure_app_48_t);
static obj_t _cvar_cinfo__113_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_make_box_cinfo_10_cfa_info(obj_t, obj_t, obj_t);
extern obj_t funcall_cinfo_loc_64_cfa_info(funcall_t);
extern setq_cinfo_191_t make_setq_cinfo_232_cfa_info(obj_t, type_t, var_t, node_t, approx_t);
extern app_t allocate_vector_ref_app_0_cfa_info();
extern obj_t pre_make_box_type_set__21_cfa_info(make_box_202_t, type_t);
static obj_t _cfun_cinfo_the_closure4491_101_cfa_info(obj_t, obj_t);
extern obj_t pre_make_procedure_app_loc_229_cfa_info(app_t);
static obj_t _widening1045_pre_make_struct_app3896_78_cfa_info(obj_t, obj_t);
extern var_t vector_set__app_fun_134_cfa_info(app_t);
static obj_t _intern_sfun_cinfo_stamp_set_4451_82_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_cvar_cinfo_74_cfa_info(obj_t);
static obj_t _struct_set__app__165_cfa_info(obj_t, obj_t);
static obj_t _make_struct_app_value_approx3864_211_cfa_info(obj_t, obj_t);
static obj_t object__struct_pragma_cinfo_175_cfa_info(obj_t, obj_t);
static obj_t _make_procedure_app_t4102_213_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_app_ly_cinfo_255_cfa_info(obj_t, obj_t, obj_t);
extern obj_t pre_make_vector_app_key_53_cfa_info(app_t);
static obj_t _pre_vector_ref_app_key_set__22_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_procedure_app_loc4134_49_cfa_info(obj_t, obj_t);
extern make_struct_app_214_t widening1048_make_struct_app_108_cfa_info(approx_t, approx_t, long, variable_t, bool_t, obj_t);
extern obj_t vector_set__app_type_set__199_cfa_info(app_t, type_t);
static obj_t _allocate_vector_set__app_158_cfa_info(obj_t);
static obj_t _widening1043_vector_ref_app3926_75_cfa_info(obj_t, obj_t);
static obj_t _pre_make_procedure_app_side_effect_4138_178_cfa_info(obj_t, obj_t);
static obj_t _pragma_cinfo_format4296_175_cfa_info(obj_t, obj_t);
static obj_t _pre_vector_set__app_side_effect_3997_75_cfa_info(obj_t, obj_t);
extern obj_t pre_make_struct_app_key_set__227_cfa_info(app_t, obj_t);
extern approx_t fail_cinfo_approx_11_cfa_info(fail_cinfo_75_t);
static obj_t struct_object__object_approx_184_cfa_info(obj_t, obj_t, obj_t);
static obj_t _select_cinfo_loc4243_207_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_approx4199_31_cfa_info(obj_t, obj_t);
extern atom_t allocate_atom_cinfo_55_cfa_info();
static obj_t _box_ref_cinfo_key_set__118_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_side_effect__set_4482_56_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_cinfo_key_44_cfa_info(obj_t, obj_t);
extern type_t pre_make_procedure_app_type_102_cfa_info(app_t);
static obj_t _pre_procedure_set__app_loc4109_229_cfa_info(obj_t, obj_t);
extern conditional_t allocate_conditional_cinfo_71_cfa_info();
static obj_t _extern_sfun_cinfo_class_set_4472_168_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_args_set_4043_152_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_set__cinfo_value_set_4185_132_cfa_info(obj_t, obj_t, obj_t);
static obj_t _procedure_ref_app_args4072_140_cfa_info(obj_t, obj_t);
static obj_t object__struct_pre_struct_set__app_44_cfa_info(obj_t, obj_t);
extern obj_t cfun_cinfo_predicate_of_set__153_cfa_info(cfun_t, obj_t);
extern approx_t extern_sfun_cinfo_approx_180_cfa_info(extern_sfun_cinfo_6_t);
static obj_t object__struct_pre_vector_ref_app_11_cfa_info(obj_t, obj_t);
static obj_t _pre_procedure_set__app_side_effect_4113_146_cfa_info(obj_t, obj_t);
extern obj_t vector_ref_app_args_set__176_cfa_info(app_t, obj_t);
static obj_t _pragma_cinfo_args_set_4297_45_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_top_4435_189_cfa_info(obj_t, obj_t);
static obj_t cnst_init_137_cfa_info();
extern conditional_cinfo_212_t widening1019_conditional_cinfo_187_cfa_info(approx_t);
static obj_t _allocate_fail_cinfo_247_cfa_info(obj_t);
static obj_t _struct_object__object4508_191___object(obj_t, obj_t, obj_t);
obj_t atom_cinfo_155_cfa_info = BUNSPEC;
extern obj_t scnst_cinfo_class_set__149_cfa_info(scnst_t, obj_t);
extern obj_t make_vector_app_args_195_cfa_info(app_t);
static obj_t _create_vector_app_lost_stamp_set_3957_3_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_fail_cinfo4254_145_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_kwote_node_184_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_predicate_of_set_4430_130_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_box_ref_cinfo_78_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_vector(long, obj_t);
extern obj_t pre_make_procedure_app_key_242_cfa_info(app_t);
extern obj_t reshaped_local_access_5_cfa_info(local_t);
extern obj_t extern_sfun_cinfo_body_set__15_cfa_info(sfun_t, obj_t);
static obj_t _make_procedure_app_stack_stamp4107_219_cfa_info(obj_t, obj_t);
extern obj_t make_procedure_app_loc_185_cfa_info(app_t);
extern bool_t pre_make_struct_app__0_cfa_info(obj_t);
static obj_t __cnst[51];

DEFINE_EXPORT_PROCEDURE(allocate_make_box_o_cinfo_env_97_cfa_info, _allocate_make_box_o_cinfo_133_cfa_info4617, _allocate_make_box_o_cinfo_133_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_side_effect__env_214_cfa_info, _pre_make_struct_app_side_effect_3902_234_cfa_info4618, _pre_make_struct_app_side_effect_3902_234_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1008_cvar_cinfo_env_63_cfa_info, _widening1008_cvar_cinfo4404_111_cfa_info4619, _widening1008_cvar_cinfo4404_111_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1038_pre_create_vector_app_env_35_cfa_info, _widening1038_pre_create_vector_app4016_34_cfa_info4620, _widening1038_pre_create_vector_app4016_34_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_fun_env_23_cfa_info, _pre_create_vector_app_fun4026_202_cfa_info4621, _pre_create_vector_app_fun4026_202_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_arity_env_62_cfa_info, _cfun_cinfo_arity4481_7_cfa_info4622, _cfun_cinfo_arity4481_7_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_stack_info_env_145_cfa_info, _procedure_set__app_stack_info4060_125_cfa_info4623, _procedure_set__app_stack_info4060_125_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_lost_stamp_env_13_cfa_info, _create_vector_app_lost_stamp3958_168_cfa_info4624, _create_vector_app_lost_stamp3958_168_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_loc_env_34_cfa_info, _jump_ex_it_cinfo_loc4223_55_cfa_info4625, _jump_ex_it_cinfo_loc4223_55_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo__env_243_cfa_info, _scnst_cinfo__113_cfa_info4626, _scnst_cinfo__113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_approx_env_144_cfa_info, _box_set__cinfo_approx4187_33_cfa_info4627, _box_set__cinfo_approx4187_33_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_fun_env_24_cfa_info, _pre_vector_set__app_fun3999_141_cfa_info4628, _pre_vector_set__app_fun3999_141_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_fun_set__env_139_cfa_info, _procedure_set__app_fun_set_4055_58_cfa_info4629, _procedure_set__app_fun_set_4055_58_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_side_effect__env_78_cfa_info, _make_vector_app_side_effect_3972_17_cfa_info4630, _make_vector_app_side_effect_3972_17_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1044_vector_set__app_env_227_cfa_info, _widening1044_vector_set__app3912_19_cfa_info4631, _widening1044_vector_set__app3912_19_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_true_env_122_cfa_info, _conditional_cinfo_true4275_31_cfa_info4632, _conditional_cinfo_true4275_31_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_name_set__env_172_cfa_info, _reshaped_local_name_set_4379_233_cfa_info4633, _reshaped_local_name_set_4379_233_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stamp_set__env_245_cfa_info, _intern_sfun_cinfo_stamp_set_4451_82_cfa_info4634, _intern_sfun_cinfo_stamp_set_4451_82_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_make_struct_app_env_196_cfa_info, _make_make_struct_app3849_83_cfa_info4635, _make_make_struct_app3849_83_cfa_info, 0L, 13);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_args_env_220_cfa_info, _procedure_ref_app_args4072_140_cfa_info4636, _procedure_ref_app_args4072_140_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_top__set__env_101_cfa_info, _approx_top__set_4502_59_cfa_info4637, _approx_top__set_4502_59_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_kwote_node_env_116_cfa_info, _allocate_kwote_node_49_cfa_info4638, _allocate_kwote_node_49_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_procedure_app_env_235_cfa_info, _allocate_pre_make_procedure_app_108_cfa_info4639, _allocate_pre_make_procedure_app_108_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_type_set__env_223_cfa_info, _pre_procedure_set__app_type_set_4110_185_cfa_info4640, _pre_procedure_set__app_type_set_4110_185_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_side_effect__set__env_154_cfa_info, _vector_ref_app_side_effect__set_3931_208_cfa_info4641, _vector_ref_app_side_effect__set_3931_208_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_key_env_150_cfa_info, _struct_ref_app_key_111_cfa_info4642, _struct_ref_app_key_111_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_type_set__env_125_cfa_info, _make_vector_app_type_set_3969_21_cfa_info4643, _make_vector_app_type_set_3969_21_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_fun_set__env_234_cfa_info, _funcall_cinfo_fun_set_4305_215_cfa_info4644, _funcall_cinfo_fun_set_4305_215_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo__env_187_cfa_info, _extern_sfun_cinfo__255_cfa_info4645, _extern_sfun_cinfo__255_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_args_env_171_cfa_info, _funcall_cinfo_args4308_56_cfa_info4646, _funcall_cinfo_args4308_56_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_set__cinfo_env_96_cfa_info, _allocate_box_set__cinfo_187_cfa_info4647, _allocate_box_set__cinfo_187_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_struct_app_loc_env_239_cfa_info, _make_struct_app_loc3850_156_cfa_info4648, _make_struct_app_loc3850_156_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_set_ex_it_cinfo_env_250_cfa_info, _allocate_set_ex_it_cinfo_22_cfa_info4649, _allocate_set_ex_it_cinfo_22_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_class_set__env_74_cfa_info, _extern_sfun_cinfo_class_set_4472_168_cfa_info4650, _extern_sfun_cinfo_class_set_4472_168_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_loc_env_174_cfa_info, _box_ref_o_cinfo_loc4150_12_cfa_info4651, _box_ref_o_cinfo_loc4150_12_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_side_effect__set__env_246_cfa_info, _cfun_cinfo_side_effect__set_4482_56_cfa_info4652, _cfun_cinfo_side_effect__set_4482_56_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_name_env_188_cfa_info, _reshaped_global_name4352_232_cfa_info4653, _reshaped_global_name4352_232_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_side_effect__set__env_178_cfa_info, _procedure_ref_app_side_effect__set_4067_83_cfa_info4654, _procedure_ref_app_side_effect__set_4067_83_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app__env_189_cfa_info, _struct_ref_app__47_cfa_info4655, _struct_ref_app__47_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_procedure_set__app_env_74_cfa_info, _allocate_procedure_set__app_204_cfa_info4656, _allocate_procedure_set__app_204_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(select_cinfo_loc_env_50_cfa_info, _select_cinfo_loc4243_207_cfa_info4657, _select_cinfo_loc4243_207_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1034_make_procedure_app_env_166_cfa_info, _widening1034_make_procedure_app4076_93_cfa_info4658, _widening1034_make_procedure_app4076_93_cfa_info, 0L, 10);
DEFINE_EXPORT_PROCEDURE(allocate_pre_clo_env_env_170_cfa_info, _allocate_pre_clo_env_10_cfa_info4659, _allocate_pre_clo_env_10_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_key_set__env_115_cfa_info, _conditional_cinfo_key_set__114_cfa_info4660, _conditional_cinfo_key_set__114_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_fail_cinfo_env_82_cfa_info, _make_fail_cinfo4254_145_cfa_info4661, _make_fail_cinfo4254_145_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(struct_set__app__env_2_cfa_info, _struct_set__app__165_cfa_info4662, _struct_set__app__165_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_key_set__env_28_cfa_info, _pre_make_box_key_set_4217_70_cfa_info4663, _pre_make_box_key_set_4217_70_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_create_vector_app_env_147_cfa_info, _allocate_pre_create_vector_app_171_cfa_info4664, _allocate_pre_create_vector_app_171_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_type_set__env_71_cfa_info, _vector_ref_app_type_set_3929_191_cfa_info4665, _vector_ref_app_type_set_3929_191_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_loc_env_244_cfa_info, _conditional_cinfo_loc4267_89_cfa_info4666, _conditional_cinfo_loc4267_89_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_stack_info_env_70_cfa_info, _pre_procedure_set__app_stack_info4119_155_cfa_info4667, _pre_procedure_set__app_stack_info4119_155_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_fun_env_103_cfa_info, _pre_make_struct_app_fun3906_132_cfa_info4668, _pre_make_struct_app_fun3906_132_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_key_set__env_111_cfa_info, _vector_set__app_key_set__89_cfa_info4669, _vector_set__app_key_set__89_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1021_select_cinfo_env_46_cfa_info, _widening1021_select_cinfo4241_110_cfa_info4670, _widening1021_select_cinfo4241_110_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_owner_env_222_cfa_info, _create_vector_app_owner3959_48_cfa_info4671, _create_vector_app_owner3959_48_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_key_set__env_178_cfa_info, _select_cinfo_key_set__141_cfa_info4672, _select_cinfo_key_set__141_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_args_type_env_76_cfa_info, _cfun_cinfo_args_type4492_112_cfa_info4673, _cfun_cinfo_args_type4492_112_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global__env_116_cfa_info, _reshaped_global__169_cfa_info4674, _reshaped_global__169_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_type_set__env_233_cfa_info, _pre_make_struct_app_type_set_3899_16_cfa_info4675, _pre_make_struct_app_type_set_3899_16_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_value_set__env_131_cfa_info, _reshaped_local_value_set_4383_162_cfa_info4676, _reshaped_local_value_set_4383_162_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_args_set__env_49_cfa_info, _pragma_cinfo_args_set_4297_45_cfa_info4677, _pragma_cinfo_args_set_4297_45_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_key_set__env_128_cfa_info, _make_struct_app_key_set__175_cfa_info4678, _make_struct_app_key_set__175_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_side_effect__set__env_165_cfa_info, _pre_struct_ref_app_side_effect__set_3888_128_cfa_info4679, _pre_struct_ref_app_side_effect__set_3888_128_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_error_noticed__env_88_cfa_info, _funcall_cinfo_type_error_noticed_4316_69_cfa_info4680, _funcall_cinfo_type_error_noticed_4316_69_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_loc_env_58_cfa_info, _pre_vector_ref_app_loc4005_201_cfa_info4681, _pre_vector_ref_app_loc4005_201_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_type_env_215_cfa_info, _create_vector_app_type3944_91_cfa_info4682, _create_vector_app_type3944_91_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1045_pre_make_struct_app_env_221_cfa_info, _widening1045_pre_make_struct_app3896_78_cfa_info4683, _widening1045_pre_make_struct_app3896_78_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_type_env_139_cfa_info, _pre_vector_ref_app_type4007_159_cfa_info4684, _pre_vector_ref_app_type4007_159_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_key_env_204_cfa_info, _create_vector_app_key3947_51_cfa_info4685, _create_vector_app_key3947_51_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_fun_set__env_128_cfa_info, _pre_make_procedure_app_fun_set_4141_230_cfa_info4686, _pre_make_procedure_app_fun_set_4141_230_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_fun_env_83_cfa_info, _funcall_cinfo_fun4306_184_cfa_info4687, _funcall_cinfo_fun4306_184_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_exit_set__env_226_cfa_info, _jump_ex_it_cinfo_exit_set_4226_196_cfa_info4688, _jump_ex_it_cinfo_exit_set_4226_196_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_owner_env_63_cfa_info, _make_struct_app_owner3867_64_cfa_info4689, _make_struct_app_owner3867_64_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_info_env_46_cfa_info, _make_procedure_app_stack_info4089_35_cfa_info4690, _make_procedure_app_stack_info4089_35_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_body_env_21_cfa_info, _set_ex_it_cinfo_body4239_6_cfa_info4691, _set_ex_it_cinfo_body4239_6_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_the_closure_env_75_cfa_info, _cfun_cinfo_the_closure4491_101_cfa_info4692, _cfun_cinfo_the_closure4491_101_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_value_set__env_0_cfa_info, _box_set__cinfo_value_set_4185_132_cfa_info4693, _box_set__cinfo_value_set_4185_132_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_loc_env_239_cfa_info, _box_ref_cinfo_loc4170_99_cfa_info4694, _box_ref_cinfo_loc4170_99_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_side_effect__set__env_89_cfa_info, _box_ref_o_cinfo_side_effect__set_4153_214_cfa_info4695, _box_ref_o_cinfo_side_effect__set_4153_214_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cvar_cinfo_env_78_cfa_info, _make_cvar_cinfo4405_180_cfa_info4696, _make_cvar_cinfo4405_180_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_args_set__env_108_cfa_info, _pre_vector_ref_app_args_set_4012_83_cfa_info4697, _pre_vector_ref_app_args_set_4012_83_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_key_env_243_cfa_info, _make_procedure_app_key4083_226_cfa_info4698, _make_procedure_app_key4083_226_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_top__env_61_cfa_info, _intern_sfun_cinfo_top_4435_189_cfa_info4699, _intern_sfun_cinfo_top_4435_189_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_type_set__env_109_cfa_info, _kwote_node_type_set_4337_57_cfa_info4700, _kwote_node_type_set_4337_57_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_stamp_env_233_cfa_info, _make_vector_app_stack_stamp3989_185_cfa_info4701, _make_vector_app_stack_stamp3989_185_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_args_set__env_107_cfa_info, _pre_procedure_ref_app_args_set_4128_84_cfa_info4702, _pre_procedure_ref_app_args_set_4128_84_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_key_env_180_cfa_info, _procedure_set__app_key_231_cfa_info4703, _procedure_set__app_key_231_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_seen__env_3_cfa_info, _make_vector_app_seen_3991_253_cfa_info4704, _make_vector_app_seen_3991_253_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_side_effect__env_195_cfa_info, _pre_vector_set__app_side_effect_3997_75_cfa_info4705, _pre_vector_set__app_side_effect_3997_75_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_stack_info_env_156_cfa_info, _vector_set__app_stack_info3924_202_cfa_info4706, _vector_set__app_stack_info3924_202_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_info_env_132_cfa_info, _make_vector_app_stack_info3979_52_cfa_info4707, _make_vector_app_stack_info3979_52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_loc_env_126_cfa_info, _vector_ref_app_loc3928_132_cfa_info4708, _vector_ref_app_loc3928_132_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo__env_119_cfa_info, _svar_cinfo__163_cfa_info4709, _svar_cinfo__163_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_loc_env_215_cfa_info, _box_set__o_cinfo_loc4160_0_cfa_info4710, _box_set__o_cinfo_loc4160_0_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_stack_allocator_env_195_cfa_info, _extern_sfun_cinfo_stack_allocator4461_171_cfa_info4711, _extern_sfun_cinfo_stack_allocator4461_171_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_side_effect__env_228_cfa_info, _make_box_cinfo_side_effect_4207_157_cfa_info4712, _make_box_cinfo_side_effect_4207_157_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo__env_142_cfa_info, _box_ref_o_cinfo__170_cfa_info4713, _box_ref_o_cinfo__170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_scnst_cinfo_env_108_cfa_info, _allocate_scnst_cinfo_162_cfa_info4714, _allocate_scnst_cinfo_162_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_stack_info_set__env_234_cfa_info, _struct_ref_app_stack_info_set_3845_170_cfa_info4715, _struct_ref_app_stack_info_set_3845_170_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_side_effect__set__env_190_cfa_info, _extern_sfun_cinfo_side_effect__set_4456_23_cfa_info4716, _extern_sfun_cinfo_side_effect__set_4456_23_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_side_effect__env_139_cfa_info, _struct_set__app_side_effect_3826_199_cfa_info4717, _struct_set__app_side_effect_3826_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_key_set__env_178_cfa_info, _create_vector_app_key_set__7_cfa_info4718, _create_vector_app_key_set__7_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_loc_env_145_cfa_info, _pre_make_vector_app_loc4034_165_cfa_info4719, _pre_make_vector_app_loc4034_165_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_owner_env_51_cfa_info, _pre_create_vector_app_owner4031_176_cfa_info4720, _pre_create_vector_app_owner4031_176_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_stack_info_env_53_cfa_info, _pre_make_procedure_app_stack_info4146_76_cfa_info4721, _pre_make_procedure_app_stack_info4146_76_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app__env_161_cfa_info, _pre_vector_ref_app__133_cfa_info4722, _pre_vector_ref_app__133_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_t__env_211_cfa_info, _make_procedure_app_x_t_4098_104_cfa_info4723, _make_procedure_app_x_t_4098_104_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1004_intern_sfun_cinfo_env_82_cfa_info, _widening1004_intern_sfun_cinfo4425_56_cfa_info4724, _widening1004_intern_sfun_cinfo4425_56_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_key_env_21_cfa_info, _make_vector_app_key3973_24_cfa_info4725, _make_vector_app_key3973_24_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_ref_app_env_247_cfa_info, _make_struct_ref_app3835_139_cfa_info4726, _make_struct_ref_app3835_139_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(select_cinfo_item_type_env_101_cfa_info, _select_cinfo_item_type4251_143_cfa_info4727, _select_cinfo_item_type4251_143_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_stamp_set__env_202_cfa_info, _make_struct_app_stack_stamp_set_3870_221_cfa_info4728, _make_struct_app_stack_stamp_set_3870_221_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_type_env_243_cfa_info, _pragma_cinfo_type4293_206_cfa_info4729, _pragma_cinfo_type4293_206_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_type_set__env_255_cfa_info, _make_procedure_app_type_set_4079_172_cfa_info4730, _make_procedure_app_type_set_4079_172_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_args_env_65_cfa_info, _pre_procedure_ref_app_args4129_205_cfa_info4731, _pre_procedure_ref_app_args4129_205_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo__env_71_cfa_info, _cfun_cinfo__48_cfa_info4732, _cfun_cinfo__48_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_loc_set__env_245_cfa_info, _extern_sfun_cinfo_loc_set_4476_26_cfa_info4733, _extern_sfun_cinfo_loc_set_4476_26_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_predicate_of_env_249_cfa_info, _cfun_cinfo_predicate_of4485_174_cfa_info4734, _cfun_cinfo_predicate_of4485_174_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_procedure_ref_app_env_35_cfa_info, _allocate_procedure_ref_app_56_cfa_info4735, _allocate_procedure_ref_app_56_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app__env_2_cfa_info, _pre_create_vector_app__32_cfa_info4736, _pre_create_vector_app__32_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_clo_env_loc_env_112_cfa_info, _pre_clo_env_loc4416_146_cfa_info4737, _pre_clo_env_loc4416_146_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_key_set__env_70_cfa_info, _pre_procedure_ref_app_key_set__188_cfa_info4738, _pre_procedure_ref_app_key_set__188_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_value_env_174_cfa_info, _box_set__cinfo_value4186_7_cfa_info4739, _box_set__cinfo_value4186_7_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_loc_env_109_cfa_info, _svar_cinfo_loc4411_139_cfa_info4740, _svar_cinfo_loc4411_139_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_type_set__env_224_cfa_info, _struct_set__app_type_set_3823_57_cfa_info4741, _struct_set__app_type_set_3823_57_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_loc_env_112_cfa_info, _setq_cinfo_loc4281_14_cfa_info4742, _setq_cinfo_loc4281_14_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_binding_value_env_124_cfa_info, _reshaped_local_binding_value4396_81_cfa_info4743, _reshaped_local_binding_value4396_81_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_approx_env_240_cfa_info, _intern_sfun_cinfo_approx4450_186_cfa_info4744, _intern_sfun_cinfo_approx4450_186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_loc_set__env_78_cfa_info, _intern_sfun_cinfo_loc_set_4448_214_cfa_info4745, _intern_sfun_cinfo_loc_set_4448_214_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_info_env_227_cfa_info, _make_struct_app_stack_info3861_128_cfa_info4746, _make_struct_app_stack_info3861_128_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_stack_info_set__env_150_cfa_info, _procedure_set__app_stack_info_set_4059_238_cfa_info4747, _procedure_set__app_stack_info_set_4059_238_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_struct_set__app_env_14_cfa_info, _make_pre_struct_set__app3872_222_cfa_info4748, _make_pre_struct_set__app3872_222_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_type_env_241_cfa_info, _box_ref_cinfo_type4172_28_cfa_info4749, _box_ref_cinfo_type4172_28_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_type_set__env_205_cfa_info, _procedure_ref_app_type_set_4065_213_cfa_info4750, _procedure_ref_app_type_set_4065_213_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_access_set__env_92_cfa_info, _reshaped_global_access_set_4357_87_cfa_info4751, _reshaped_global_access_set_4357_87_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_key_set__env_220_cfa_info, _procedure_set__app_key_set__54_cfa_info4752, _procedure_set__app_key_set__54_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_approx_env_96_cfa_info, _cfun_cinfo_approx4496_91_cfa_info4753, _cfun_cinfo_approx4496_91_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_value_approx_env_69_cfa_info, _make_vector_app_value_approx3982_99_cfa_info4754, _make_vector_app_value_approx3982_99_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_side_effect__set__env_214_cfa_info, _intern_sfun_cinfo_side_effect__set_4428_136_cfa_info4755, _intern_sfun_cinfo_side_effect__set_4428_136_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_value_env_216_cfa_info, _make_box_o_cinfo_value4197_165_cfa_info4756, _make_box_o_cinfo_value4197_165_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_type_env_201_cfa_info, _make_box_o_cinfo_type4192_221_cfa_info4757, _make_box_o_cinfo_type4192_221_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_type_set__env_126_cfa_info, _pre_make_vector_app_type_set_4035_221_cfa_info4758, _pre_make_vector_app_type_set_4035_221_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_type_env_28_cfa_info, _pre_struct_set__app_type3875_200_cfa_info4759, _pre_struct_set__app_type3875_200_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_approx_set__env_92_cfa_info, _make_box_o_cinfo_approx_set_4198_214_cfa_info4760, _make_box_o_cinfo_approx_set_4198_214_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_type_env_57_cfa_info, _reshaped_local_type4382_168_cfa_info4761, _reshaped_local_type4382_168_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_class_env_252_cfa_info, _intern_sfun_cinfo_class4445_4_cfa_info4762, _intern_sfun_cinfo_class4445_4_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_svar_cinfo_env_82_cfa_info, _make_svar_cinfo4409_207_cfa_info4763, _make_svar_cinfo4409_207_cfa_info, 0L, 3);
DEFINE_EXPORT_PROCEDURE(reshaped_global_name_set__env_63_cfa_info, _reshaped_global_name_set_4351_195_cfa_info4764, _reshaped_global_name_set_4351_195_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_the_closure_set__env_19_cfa_info, _intern_sfun_cinfo_the_closure_set_4436_80_cfa_info4765, _intern_sfun_cinfo_the_closure_set_4436_80_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app__env_101_cfa_info, _create_vector_app__45_cfa_info4766, _create_vector_app__45_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_side_effect__set__env_26_cfa_info, _struct_ref_app_side_effect__set_3839_174_cfa_info4767, _struct_ref_app_side_effect__set_3839_174_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1010_reshaped_local_env_92_cfa_info, _widening1010_reshaped_local_27_cfa_info4768, _widening1010_reshaped_local_27_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_info_env_181_cfa_info, _create_vector_app_stack_info3953_169_cfa_info4769, _create_vector_app_stack_info3953_169_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_args_env_237_cfa_info, _intern_sfun_cinfo_args4441_113_cfa_info4770, _intern_sfun_cinfo_args4441_113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_va_approx_env_209_cfa_info, _funcall_cinfo_va_approx4312_166_cfa_info4771, _funcall_cinfo_va_approx4312_166_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_type_env_99_cfa_info, _kwote_node_type4338_162_cfa_info4772, _kwote_node_type4338_162_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1037_pre_make_vector_app_env_111_cfa_info, _widening1037_pre_make_vector_app4032_253_cfa_info4773, _widening1037_pre_make_vector_app4032_253_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_type_env_67_cfa_info, _pre_create_vector_app_type4020_192_cfa_info4774, _pre_create_vector_app_type4020_192_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_removable_env_21_cfa_info, _reshaped_local_removable4390_108_cfa_info4775, _reshaped_local_removable4390_108_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_approx_env_211_cfa_info, _make_box_o_cinfo_approx4199_31_cfa_info4776, _make_box_o_cinfo_approx4199_31_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_key_env_172_cfa_info, _pragma_cinfo_key_170_cfa_info4777, _pragma_cinfo_key_170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_dsssl_keywords_set__env_145_cfa_info, _extern_sfun_cinfo_dsssl_keywords_set_4474_11_cfa_info4778, _extern_sfun_cinfo_dsssl_keywords_set_4474_11_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_stack_info_env_77_cfa_info, _struct_set__app_stack_info3832_186_cfa_info4779, _struct_set__app_stack_info3832_186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app__env_133_cfa_info, _pre_procedure_ref_app__123_cfa_info4780, _pre_procedure_ref_app__123_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_kwote_cinfo_env_169_cfa_info, _make_kwote_cinfo4328_235_cfa_info4781, _make_kwote_cinfo4328_235_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_fun_env_224_cfa_info, _pre_procedure_ref_app_fun4127_167_cfa_info4782, _pre_procedure_ref_app_fun4127_167_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_fun_env_147_cfa_info, _app_ly_cinfo_fun4323_133_cfa_info4783, _app_ly_cinfo_fun4323_133_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_type_locked__env_55_cfa_info, _approx_type_locked_4500_170_cfa_info4784, _approx_type_locked_4500_170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_fail_cinfo_env_67_cfa_info, _allocate_fail_cinfo_247_cfa_info4785, _allocate_fail_cinfo_247_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(struct_set__app_loc_env_245_cfa_info, _struct_set__app_loc3822_188_cfa_info4786, _struct_set__app_loc3822_188_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1048_make_struct_app_env_26_cfa_info, _widening1048_make_struct_app3848_127_cfa_info4787, _widening1048_make_struct_app3848_127_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(reshaped_local_value_env_95_cfa_info, _reshaped_local_value4384_82_cfa_info4788, _reshaped_local_value4384_82_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_side_effect__set__env_223_cfa_info, _pre_create_vector_app_side_effect__set_4021_43_cfa_info4789, _pre_create_vector_app_side_effect__set_4021_43_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_error_noticed__set__env_64_cfa_info, _funcall_cinfo_type_error_noticed__set_4315_29_cfa_info4790, _funcall_cinfo_type_error_noticed__set_4315_29_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_key_env_200_cfa_info, _pre_make_procedure_app_key4140_143_cfa_info4791, _pre_make_procedure_app_key4140_143_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_type_env_64_cfa_info, _approx_type4499_248_cfa_info4792, _approx_type4499_248_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1039_pre_vector_ref_app_env_52_cfa_info, _widening1039_pre_vector_ref_app_183_cfa_info4793, _widening1039_pre_vector_ref_app_183_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app__env_190_cfa_info, _pre_make_vector_app__65_cfa_info4794, _pre_make_vector_app__65_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_var_set__env_113_cfa_info, _set_ex_it_cinfo_var_set_4236_142_cfa_info4795, _set_ex_it_cinfo_var_set_4236_142_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_type_env_149_cfa_info, _make_procedure_app_type4080_241_cfa_info4796, _make_procedure_app_type4080_241_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_set_ex_it_cinfo_env_108_cfa_info, _make_set_ex_it_cinfo4232_34_cfa_info4797, _make_set_ex_it_cinfo4232_34_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_pre_make_struct_app_env_150_cfa_info, _make_pre_make_struct_app3897_100_cfa_info4798, _make_pre_make_struct_app3897_100_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(make_make_procedure_app_env_184_cfa_info, _make_make_procedure_app4077_0_cfa_info4799, _make_make_procedure_app4077_0_cfa_info, 0L, 17);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_key_env_119_cfa_info, _pre_procedure_set__app_key_168_cfa_info4800, _pre_procedure_set__app_key_168_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_approx_env_167_cfa_info, _atom_cinfo_approx4348_99_cfa_info4801, _atom_cinfo_approx4348_99_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_key_env_153_cfa_info, _pre_make_box_key4218_85_cfa_info4802, _pre_make_box_key4218_85_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_loc_env_191_cfa_info, _box_set__cinfo_loc4180_133_cfa_info4803, _box_set__cinfo_loc4180_133_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_stack_allocator_set__env_241_cfa_info, _extern_sfun_cinfo_stack_allocator_set_4460_90_cfa_info4804, _extern_sfun_cinfo_stack_allocator_set_4460_90_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_fun_env_16_cfa_info, _pre_struct_set__app_fun3879_141_cfa_info4805, _pre_struct_set__app_fun3879_141_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_stack_allocator_set__env_114_cfa_info, _cfun_cinfo_stack_allocator_set_4486_92_cfa_info4806, _cfun_cinfo_stack_allocator_set_4486_92_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_key_set__env_25_cfa_info, _pre_make_procedure_app_key_set_4139_227_cfa_info4807, _pre_make_procedure_app_key_set_4139_227_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_sexit_cinfo_env_8_cfa_info, _make_sexit_cinfo4398_253_cfa_info4808, _make_sexit_cinfo4398_253_cfa_info, 0L, 3);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_top__env_67_cfa_info, _cfun_cinfo_top_4489_13_cfa_info4809, _cfun_cinfo_top_4489_13_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_dsssl_keywords_env_221_cfa_info, _extern_sfun_cinfo_dsssl_keywords4475_201_cfa_info4810, _extern_sfun_cinfo_dsssl_keywords4475_201_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_side_effect__set__env_34_cfa_info, _pre_make_procedure_app_side_effect__set_4137_217_cfa_info4811, _pre_make_procedure_app_side_effect__set_4137_217_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pragma_cinfo_env_199_cfa_info, _allocate_pragma_cinfo_82_cfa_info4812, _allocate_pragma_cinfo_82_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_extern_sfun_cinfo_env_126_cfa_info, _allocate_extern_sfun_cinfo_234_cfa_info4813, _allocate_extern_sfun_cinfo_234_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app__env_143_cfa_info, _procedure_ref_app__14_cfa_info4814, _procedure_ref_app__14_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_approx_set__env_86_cfa_info, _make_vector_app_approx_set_3980_189_cfa_info4815, _make_vector_app_approx_set_3980_189_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_side_effect__env_101_cfa_info, _struct_ref_app_side_effect_3840_167_cfa_info4816, _struct_ref_app_side_effect_3840_167_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_side_effect__set__env_241_cfa_info, _pre_vector_set__app_side_effect__set_3996_17_cfa_info4817, _pre_vector_set__app_side_effect__set_3996_17_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_value_set__env_9_cfa_info, _jump_ex_it_cinfo_value_set_4228_209_cfa_info4818, _jump_ex_it_cinfo_value_set_4228_209_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_procedure_set__app_env_247_cfa_info, _allocate_pre_procedure_set__app_24_cfa_info4819, _allocate_pre_procedure_set__app_24_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_box_value_set__env_240_cfa_info, _pre_make_box_value_set_4219_159_cfa_info4820, _pre_make_box_value_set_4219_159_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_fun_set__env_54_cfa_info, _pre_create_vector_app_fun_set_4025_210_cfa_info4821, _pre_create_vector_app_fun_set_4025_210_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_approx_env_186_cfa_info, _fail_cinfo_approx4264_42_cfa_info4822, _fail_cinfo_approx4264_42_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cvar_cinfo_env_84_cfa_info, _allocate_cvar_cinfo_74_cfa_info4823, _allocate_cvar_cinfo_74_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(create_vector_app_args_env_43_cfa_info, _create_vector_app_args3951_133_cfa_info4824, _create_vector_app_args3951_133_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_side_effect__env_84_cfa_info, _pre_make_vector_app_side_effect_4038_113_cfa_info4825, _pre_make_vector_app_side_effect_4038_113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_args_env_8_cfa_info, _pre_vector_ref_app_args4013_248_cfa_info4826, _pre_vector_ref_app_args4013_248_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_type_set__env_44_cfa_info, _set_ex_it_cinfo_type_set_4234_28_cfa_info4827, _set_ex_it_cinfo_type_set_4234_28_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_var_set__env_183_cfa_info, _box_set__o_cinfo_var_set_4163_39_cfa_info4828, _box_set__o_cinfo_var_set_4163_39_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_format_env_232_cfa_info, _pragma_cinfo_format4296_175_cfa_info4829, _pragma_cinfo_format4296_175_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_vector_ref_app_env_106_cfa_info, _make_pre_vector_ref_app4004_14_cfa_info4830, _make_pre_vector_ref_app4004_14_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_side_effect__set__env_230_cfa_info, _pre_make_vector_app_side_effect__set_4037_222_cfa_info4831, _pre_make_vector_app_side_effect__set_4037_222_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_conditional_cinfo_env_151_cfa_info, _make_conditional_cinfo4266_140_cfa_info4832, _make_conditional_cinfo4266_140_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(struct_set__app_type_env_67_cfa_info, _struct_set__app_type3824_132_cfa_info4833, _struct_set__app_type3824_132_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_arity_error_noticed__env_173_cfa_info, _funcall_cinfo_arity_error_noticed_4314_220_cfa_info4834, _funcall_cinfo_arity_error_noticed_4314_220_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1027_box_set__cinfo_env_140_cfa_info, _widening1027_box_set__cinfo4178_94_cfa_info4835, _widening1027_box_set__cinfo4178_94_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1016_funcall_cinfo_env_11_cfa_info, _widening1016_funcall_cinfo4300_74_cfa_info4836, _widening1016_funcall_cinfo4300_74_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_stack_allocator_env_224_cfa_info, _cfun_cinfo_stack_allocator4487_207_cfa_info4837, _cfun_cinfo_stack_allocator4487_207_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_args_set__env_208_cfa_info, _procedure_set__app_args_set_4057_128_cfa_info4838, _procedure_set__app_args_set_4057_128_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_stamp_set__env_170_cfa_info, _make_procedure_app_stack_stamp_set_4106_128_cfa_info4839, _make_procedure_app_stack_stamp_set_4106_128_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_user__set__env_80_cfa_info, _reshaped_local_user__set_4393_102_cfa_info4840, _reshaped_local_user__set_4393_102_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1023_jump_ex_it_cinfo_env_141_cfa_info, _widening1023_jump_ex_it_cinfo4221_44_cfa_info4841, _widening1023_jump_ex_it_cinfo4221_44_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_type_env_210_cfa_info, _procedure_set__app_type4052_159_cfa_info4842, _procedure_set__app_type4052_159_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_key_env_177_cfa_info, _procedure_ref_app_key_2_cfa_info4843, _procedure_ref_app_key_2_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_stack_info_env_239_cfa_info, _procedure_ref_app_stack_info4074_171_cfa_info4844, _procedure_ref_app_stack_info4074_171_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_args_set__env_235_cfa_info, _vector_set__app_args_set_3921_32_cfa_info4845, _vector_set__app_args_set_3921_32_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_stack_info_set__env_176_cfa_info, _pre_make_vector_app_stack_info_set_4045_187_cfa_info4846, _pre_make_vector_app_stack_info_set_4045_187_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_the_closure_set__env_83_cfa_info, _cfun_cinfo_the_closure_set_4490_255_cfa_info4847, _cfun_cinfo_the_closure_set_4490_255_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_fun_set__env_26_cfa_info, _pre_make_vector_app_fun_set_4041_181_cfa_info4848, _pre_make_vector_app_fun_set_4041_181_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_type_env_29_cfa_info, _pre_vector_set__app_type3995_199_cfa_info4849, _pre_vector_set__app_type3995_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_type_env_153_cfa_info, _pre_make_procedure_app_type4136_42_cfa_info4850, _pre_make_procedure_app_type4136_42_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_set__cinfo_env_140_cfa_info, _make_box_set__cinfo4179_235_cfa_info4851, _make_box_set__cinfo4179_235_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_info_set__env_253_cfa_info, _make_procedure_app_stack_info_set_4088_255_cfa_info4852, _make_procedure_app_stack_info_set_4088_255_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_set__app_side_effect__set__env_253_cfa_info, _vector_set__app_side_effect__set_3917_73_cfa_info4853, _vector_set__app_side_effect__set_3917_73_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_stack_info_set__env_101_cfa_info, _pre_vector_ref_app_stack_info_set_4014_28_cfa_info4854, _pre_vector_ref_app_stack_info_set_4014_28_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_top__env_70_cfa_info, _approx_top_4503_87_cfa_info4855, _approx_top_4503_87_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_type_env_200_cfa_info, _pre_struct_ref_app_type3887_59_cfa_info4856, _pre_struct_ref_app_type3887_59_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_stack_info_env_230_cfa_info, _vector_ref_app_stack_info3938_180_cfa_info4857, _vector_ref_app_stack_info3938_180_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo__env_206_cfa_info, _jump_ex_it_cinfo__23_cfa_info4858, _jump_ex_it_cinfo__23_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_fun_set__env_237_cfa_info, _pre_struct_set__app_fun_set_3878_88_cfa_info4859, _pre_struct_set__app_fun_set_3878_88_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_type_set__env_8_cfa_info, _pre_struct_set__app_type_set_3874_35_cfa_info4860, _pre_struct_set__app_type_set_3874_35_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app__env_255_cfa_info, _pre_struct_ref_app__54_cfa_info4861, _pre_struct_ref_app__54_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1047_pre_struct_set__app_env_131_cfa_info, _widening1047_pre_struct_set__app_81_cfa_info4862, _widening1047_pre_struct_set__app_81_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stackable__set__env_81_cfa_info, _make_procedure_app_stackable__set_4104_216_cfa_info4863, _make_procedure_app_stackable__set_4104_216_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1028_box_ref_cinfo_env_70_cfa_info, _widening1028_box_ref_cinfo4168_108_cfa_info4864, _widening1028_box_ref_cinfo4168_108_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_vector_app_env_198_cfa_info, _allocate_pre_make_vector_app_80_cfa_info4865, _allocate_pre_make_vector_app_80_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_app_ly_cinfo_env_233_cfa_info, _make_app_ly_cinfo4318_157_cfa_info4866, _make_app_ly_cinfo4318_157_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_vector_app_side_effect__set__env_163_cfa_info, _make_vector_app_side_effect__set_3971_134_cfa_info4867, _make_vector_app_side_effect__set_3971_134_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cvar_cinfo__env_217_cfa_info, _cvar_cinfo__113_cfa_info4868, _cvar_cinfo__113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app__env_28_cfa_info, _pre_struct_set__app__221_cfa_info4869, _pre_struct_set__app__221_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_loc_env_157_cfa_info, _make_box_o_cinfo_loc4190_53_cfa_info4870, _make_box_o_cinfo_loc4190_53_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_args_env_33_cfa_info, _pragma_cinfo_args4298_204_cfa_info4871, _pragma_cinfo_args4298_204_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node__env_227_cfa_info, _kwote_node__166_cfa_info4872, _kwote_node__166_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_approx_env_126_cfa_info, _box_ref_o_cinfo_approx4157_217_cfa_info4873, _box_ref_o_cinfo_approx4157_217_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_access_set__env_80_cfa_info, _reshaped_local_access_set_4385_25_cfa_info4874, _reshaped_local_access_set_4385_25_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_args_set__env_221_cfa_info, _pre_create_vector_app_args_set_4027_207_cfa_info4875, _pre_create_vector_app_args_set_4027_207_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stack_allocator_set__env_120_cfa_info, _intern_sfun_cinfo_stack_allocator_set_4432_140_cfa_info4876, _intern_sfun_cinfo_stack_allocator_set_4432_140_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_make_procedure_app_env_160_cfa_info, _make_pre_make_procedure_app4133_249_cfa_info4877, _make_pre_make_procedure_app4133_249_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(pre_make_box_side_effect__set__env_137_cfa_info, _pre_make_box_side_effect__set_4215_66_cfa_info4878, _pre_make_box_side_effect__set_4215_66_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_key_env_29_cfa_info, _pre_create_vector_app_key4024_163_cfa_info4879, _pre_create_vector_app_key4024_163_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_arity_error_noticed__set__env_77_cfa_info, _funcall_cinfo_arity_error_noticed__set_4313_165_cfa_info4880, _funcall_cinfo_arity_error_noticed__set_4313_165_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_owner_env_210_cfa_info, _pre_make_struct_app_owner3911_67_cfa_info4881, _pre_make_struct_app_owner3911_67_cfa_info, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(allocate_vector_ref_app_env_93_cfa_info, _allocate_vector_ref_app_194_cfa_info4882, _allocate_vector_ref_app_194_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_loc_env_195_cfa_info, _pre_struct_ref_app_loc3885_215_cfa_info4883, _pre_struct_ref_app_loc3885_215_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_key_env_20_cfa_info, _pre_vector_set__app_key_195_cfa_info4884, _pre_vector_set__app_key_195_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_owner_env_162_cfa_info, _make_procedure_app_owner4103_232_cfa_info4885, _make_procedure_app_owner4103_232_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_side_effect__set__env_139_cfa_info, _pre_procedure_ref_app_side_effect__set_4124_61_cfa_info4886, _pre_procedure_ref_app_side_effect__set_4124_61_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_class_env_236_cfa_info, _extern_sfun_cinfo_class4473_67_cfa_info4887, _extern_sfun_cinfo_class4473_67_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_removable_set__env_92_cfa_info, _reshaped_global_removable_set_4361_50_cfa_info4888, _reshaped_global_removable_set_4361_50_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_side_effect__set__env_9_cfa_info, _select_cinfo_side_effect__set_4246_220_cfa_info4889, _select_cinfo_side_effect__set_4246_220_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1017_pragma_cinfo_env_7_cfa_info, _widening1017_pragma_cinfo4289_191_cfa_info4890, _widening1017_pragma_cinfo4289_191_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo__env_186_cfa_info, _set_ex_it_cinfo__175_cfa_info4891, _set_ex_it_cinfo__175_cfa_info, 0L, 1);
DEFINE_STRING(string4611_cfa_info, string4611_cfa_info4892, "DONE STRUCT-SET!-APP STRUCT-REF-APP MAKE-STRUCT-APP PRE-STRUCT-SET!-APP PRE-STRUCT-REF-APP PRE-MAKE-STRUCT-APP VECTOR-SET!-APP VECTOR-REF-APP CREATE-VECTOR-APP MAKE-VECTOR-APP PRE-VECTOR-SET!-APP PRE-VECTOR-REF-APP PRE-CREATE-VECTOR-APP PRE-MAKE-VECTOR-APP PROCEDURE-SET!-APP PROCEDURE-REF-APP MAKE-PROCEDURE-APP PRE-PROCEDURE-SET!-APP PRE-PROCEDURE-REF-APP PRE-MAKE-PROCEDURE-APP BOX-REF/O-CINFO BOX-SET!/O-CINFO BOX-REF/CINFO BOX-SET!/CINFO MAKE-BOX/O-CINFO MAKE-BOX/CINFO PRE-MAKE-BOX JUMP-EX-IT/CINFO SET-EX-IT/CINFO SELECT/CINFO FAIL/CINFO CONDITIONAL/CINFO SETQ/CINFO PRAGMA/CINFO FUNCALL/CINFO APP-LY/CINFO KWOTE/CINFO KWOTE/NODE ATOM/CINFO RESHAPED-GLOBAL RESHAPED-LOCAL SEXIT/CINFO CVAR/CINFO SVAR/CINFO PRE-CLO-ENV SCNST/CINFO INTERN-SFUN/CINFO EXTERN-SFUN/CINFO CFUN/CINFO APPROX ", 791);
DEFINE_EXPORT_PROCEDURE(pre_make_box__env_113_cfa_info, _pre_make_box__20_cfa_info4893, _pre_make_box__20_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1019_conditional_cinfo_env_151_cfa_info, _widening1019_conditional_cinfo4265_21_cfa_info4894, _widening1019_conditional_cinfo4265_21_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_svar_cinfo_env_152_cfa_info, _allocate_svar_cinfo_185_cfa_info4895, _allocate_svar_cinfo_185_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(struct_set__app_approx_env_58_cfa_info, _struct_set__app_approx3833_191_cfa_info4896, _struct_set__app_approx3833_191_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_type_env_139_cfa_info, _pre_procedure_set__app_type4111_183_cfa_info4897, _pre_procedure_set__app_type4111_183_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_stamp_set__env_232_cfa_info, _make_vector_app_stack_stamp_set_3988_78_cfa_info4898, _make_vector_app_stack_stamp_set_3988_78_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_args_set__env_63_cfa_info, _struct_ref_app_args_set_3843_166_cfa_info4899, _struct_ref_app_args_set_3843_166_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo__env_12_cfa_info, _box_set__cinfo__142_cfa_info4900, _box_set__cinfo__142_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_strength_set__env_205_cfa_info, _funcall_cinfo_strength_set_4309_38_cfa_info4901, _funcall_cinfo_strength_set_4309_38_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_approx_env_131_cfa_info, _set_ex_it_cinfo_approx4240_95_cfa_info4902, _set_ex_it_cinfo_approx4240_95_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_reshaped_global_env_91_cfa_info, _allocate_reshaped_global_82_cfa_info4903, _allocate_reshaped_global_82_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_value_env_43_cfa_info, _make_box_cinfo_value4209_19_cfa_info4904, _make_box_cinfo_value4209_19_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_args_env_92_cfa_info, _pre_struct_set__app_args3881_189_cfa_info4905, _pre_struct_set__app_args3881_189_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_side_effect__env_188_cfa_info, _pre_struct_set__app_side_effect_3877_36_cfa_info4906, _pre_struct_set__app_side_effect_3877_36_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_approx_env_110_cfa_info, _box_ref_cinfo_approx4177_0_cfa_info4907, _box_ref_cinfo_approx4177_0_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_value_set__env_236_cfa_info, _make_box_cinfo_value_set_4208_18_cfa_info4908, _make_box_cinfo_value_set_4208_18_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_approx_env_95_cfa_info, _vector_ref_app_approx3939_106_cfa_info4909, _vector_ref_app_approx3939_106_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_side_effect__env_227_cfa_info, _intern_sfun_cinfo_side_effect_4429_206_cfa_info4910, _intern_sfun_cinfo_side_effect_4429_206_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_var_set__env_182_cfa_info, _setq_cinfo_var_set_4284_103_cfa_info4911, _setq_cinfo_var_set_4284_103_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_body_env_59_cfa_info, _intern_sfun_cinfo_body4443_134_cfa_info4912, _intern_sfun_cinfo_body4443_134_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_proc_env_81_cfa_info, _fail_cinfo_proc4259_227_cfa_info4913, _fail_cinfo_proc4259_227_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_removable_env_211_cfa_info, _reshaped_global_removable4362_127_cfa_info4914, _reshaped_global_removable4362_127_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_fun_env_199_cfa_info, _vector_set__app_fun3920_255_cfa_info4915, _vector_set__app_fun3920_255_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_loc_env_186_cfa_info, _struct_ref_app_loc3836_68_cfa_info4916, _struct_ref_app_loc3836_68_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_value_env_42_cfa_info, _kwote_node_value4339_148_cfa_info4917, _kwote_node_value4339_148_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_create_vector_app_env_133_cfa_info, _allocate_create_vector_app_246_cfa_info4918, _allocate_create_vector_app_246_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(widening1041_make_vector_app_env_176_cfa_info, _widening1041_make_vector_app3966_245_cfa_info4919, _widening1041_make_vector_app3966_245_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_args_env_255_cfa_info, _pre_create_vector_app_args4028_255_cfa_info4920, _pre_create_vector_app_args4028_255_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_approx_env_79_cfa_info, _procedure_set__app_approx4061_130_cfa_info4921, _procedure_set__app_approx4061_130_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stack_allocator_env_106_cfa_info, _intern_sfun_cinfo_stack_allocator4433_1_cfa_info4922, _intern_sfun_cinfo_stack_allocator4433_1_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_type_env_240_cfa_info, _pre_make_box_type4214_63_cfa_info4923, _pre_make_box_type4214_63_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_stack_info_set__env_107_cfa_info, _pre_vector_set__app_stack_info_set_4002_134_cfa_info4924, _pre_vector_set__app_stack_info_set_4002_134_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_body_set__env_47_cfa_info, _set_ex_it_cinfo_body_set_4238_104_cfa_info4925, _set_ex_it_cinfo_body_set_4238_104_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_set__app_type_env_159_cfa_info, _vector_set__app_type3916_3_cfa_info4926, _vector_set__app_type3916_3_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_key_env_31_cfa_info, _pre_make_struct_app_key3904_233_cfa_info4927, _pre_make_struct_app_key3904_233_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_stack_info_set__env_106_cfa_info, _pre_make_struct_app_stack_info_set_3909_197_cfa_info4928, _pre_make_struct_app_stack_info_set_3909_197_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_handler_set__env_32_cfa_info, _sexit_cinfo_handler_set_4399_90_cfa_info4929, _sexit_cinfo_handler_set_4399_90_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_type_set__env_28_cfa_info, _pre_make_procedure_app_type_set_4135_203_cfa_info4930, _pre_make_procedure_app_type_set_4135_203_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_macro__env_63_cfa_info, _cfun_cinfo_macro_4493_246_cfa_info4931, _cfun_cinfo_macro_4493_246_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_type_set__env_245_cfa_info, _create_vector_app_type_set_3943_133_cfa_info4932, _create_vector_app_type_set_3943_133_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_type_set__env_180_cfa_info, _reshaped_local_type_set_4381_49_cfa_info4933, _reshaped_local_type_set_4381_49_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_var_env_43_cfa_info, _box_ref_o_cinfo_var4156_18_cfa_info4934, _box_ref_o_cinfo_var4156_18_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_clo_env__env_100_cfa_info, _pre_clo_env__150_cfa_info4935, _pre_clo_env__150_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_stack_info_env_65_cfa_info, _pre_vector_set__app_stack_info4003_26_cfa_info4936, _pre_vector_set__app_stack_info4003_26_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_stack_info_env_248_cfa_info, _pre_make_vector_app_stack_info4046_220_cfa_info4937, _pre_make_vector_app_stack_info4046_220_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_args_env_209_cfa_info, _make_procedure_app_args4087_72_cfa_info4938, _make_procedure_app_args4087_72_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_approx_env_121_cfa_info, _conditional_cinfo_approx4278_206_cfa_info4939, _conditional_cinfo_approx4278_206_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_detached__set__env_50_cfa_info, _sexit_cinfo_detached__set_4401_18_cfa_info4940, _sexit_cinfo_detached__set_4401_18_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_values_approx_len_env_69_cfa_info, _make_procedure_app_values_approx_len4092_35_cfa_info4941, _make_procedure_app_values_approx_len4092_35_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_occurrence_env_115_cfa_info, _reshaped_local_occurrence4392_74_cfa_info4942, _reshaped_local_occurrence4392_74_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_type_env_222_cfa_info, _box_set__cinfo_type4182_217_cfa_info4943, _box_set__cinfo_type4182_217_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1015_app_ly_cinfo_env_92_cfa_info, _widening1015_app_ly_cinfo4317_127_cfa_info4944, _widening1015_app_ly_cinfo4317_127_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_approx_env_217_cfa_info, _struct_ref_app_approx3847_222_cfa_info4945, _struct_ref_app_approx3847_222_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_args_set__env_200_cfa_info, _make_struct_app_args_set_3858_83_cfa_info4946, _make_struct_app_args_set_3858_83_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_type_set__env_198_cfa_info, _jump_ex_it_cinfo_type_set_4224_254_cfa_info4947, _jump_ex_it_cinfo_type_set_4224_254_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_key_set__env_81_cfa_info, _pre_create_vector_app_key_set_4023_254_cfa_info4948, _pre_create_vector_app_key_set_4023_254_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_arg_env_40_cfa_info, _app_ly_cinfo_arg4325_242_cfa_info4949, _app_ly_cinfo_arg4325_242_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_fun_env_22_cfa_info, _make_struct_app_fun3857_148_cfa_info4950, _make_struct_app_fun3857_148_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_false_set__env_119_cfa_info, _conditional_cinfo_false_set_4276_41_cfa_info4951, _conditional_cinfo_false_set_4276_41_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_box_env_176_cfa_info, _allocate_pre_make_box_48_cfa_info4952, _allocate_pre_make_box_48_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(widening1025_make_box_cinfo_env_176_cfa_info, _widening1025_make_box_cinfo4201_110_cfa_info4953, _widening1025_make_box_cinfo4201_110_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_info_set__env_251_cfa_info, _make_vector_app_stack_info_set_3978_28_cfa_info4954, _make_vector_app_stack_info_set_3978_28_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_lost_stamp_set__env_16_cfa_info, _approx_lost_stamp_set_4504_160_cfa_info4955, _approx_lost_stamp_set_4504_160_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_loc_env_50_cfa_info, _create_vector_app_loc3942_173_cfa_info4956, _create_vector_app_loc3942_173_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_approx_env_222_cfa_info, _kwote_cinfo_approx4333_226_cfa_info4957, _kwote_cinfo_approx4333_226_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_proc_set__env_86_cfa_info, _fail_cinfo_proc_set_4258_166_cfa_info4958, _fail_cinfo_proc_set_4258_166_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_approx_env_154_cfa_info, _box_set__o_cinfo_approx4167_50_cfa_info4959, _box_set__o_cinfo_approx4167_50_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_body_set__env_27_cfa_info, _extern_sfun_cinfo_body_set_4470_56_cfa_info4960, _extern_sfun_cinfo_body_set_4470_56_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_stack_info_env_77_cfa_info, _pre_create_vector_app_stack_info4030_214_cfa_info4961, _pre_create_vector_app_stack_info4030_214_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stackable__set__env_128_cfa_info, _make_vector_app_stackable__set_3986_235_cfa_info4962, _make_vector_app_stackable__set_3986_235_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_args_set__env_69_cfa_info, _pre_vector_set__app_args_set_4000_233_cfa_info4963, _pre_vector_set__app_args_set_4000_233_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_type_env_44_cfa_info, _vector_ref_app_type3930_49_cfa_info4964, _vector_ref_app_type3930_49_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_side_effect__env_198_cfa_info, _pragma_cinfo_side_effect_4295_162_cfa_info4965, _pragma_cinfo_side_effect_4295_162_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_jump_ex_it_cinfo_env_165_cfa_info, _make_jump_ex_it_cinfo4222_70_cfa_info4966, _make_jump_ex_it_cinfo4222_70_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_pre_procedure_ref_app_env_195_cfa_info, _make_pre_procedure_ref_app4120_6_cfa_info4967, _make_pre_procedure_ref_app4120_6_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_var_env_100_cfa_info, _box_ref_cinfo_var4176_172_cfa_info4968, _box_ref_cinfo_var4176_172_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_loc_env_203_cfa_info, _make_procedure_app_loc4078_29_cfa_info4969, _make_procedure_app_loc4078_29_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo__env_181_cfa_info, _kwote_cinfo__102_cfa_info4970, _kwote_cinfo__102_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_args_env_255_cfa_info, _struct_set__app_args3830_80_cfa_info4971, _struct_set__app_args3830_80_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_dsssl_keywords_set__env_176_cfa_info, _intern_sfun_cinfo_dsssl_keywords_set_4446_68_cfa_info4972, _intern_sfun_cinfo_dsssl_keywords_set_4446_68_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_stack_info_env_70_cfa_info, _pre_vector_ref_app_stack_info4015_64_cfa_info4973, _pre_vector_ref_app_stack_info4015_64_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_stack_info_env_127_cfa_info, _pre_make_struct_app_stack_info3910_27_cfa_info4974, _pre_make_struct_app_stack_info3910_27_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_side_effect__set__env_6_cfa_info, _procedure_set__app_side_effect__set_4053_86_cfa_info4975, _procedure_set__app_side_effect__set_4053_86_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_handler_env_241_cfa_info, _sexit_cinfo_handler4400_92_cfa_info4976, _sexit_cinfo_handler4400_92_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_loc_env_121_cfa_info, _procedure_set__app_loc4050_91_cfa_info4977, _procedure_set__app_loc4050_91_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_key_set__env_75_cfa_info, _pre_make_vector_app_key_set_4039_63_cfa_info4978, _pre_make_vector_app_key_set_4039_63_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_type_env_80_cfa_info, _box_set__o_cinfo_type4162_84_cfa_info4979, _box_set__o_cinfo_type4162_84_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_side_effect__env_190_cfa_info, _vector_ref_app_side_effect_3932_110_cfa_info4980, _vector_ref_app_side_effect_3932_110_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1049_struct_ref_app_env_153_cfa_info, _widening1049_struct_ref_app3834_218_cfa_info4981, _widening1049_struct_ref_app3834_218_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_set__app_env_73_cfa_info, _make_procedure_set__app4049_250_cfa_info4982, _make_procedure_set__app4049_250_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(allocate_pre_struct_ref_app_env_84_cfa_info, _allocate_pre_struct_ref_app_15_cfa_info4983, _allocate_pre_struct_ref_app_15_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_fun_env_130_cfa_info, _pre_vector_ref_app_fun4011_88_cfa_info4984, _pre_vector_ref_app_fun4011_88_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app__env_161_cfa_info, _pre_procedure_set__app__169_cfa_info4985, _pre_procedure_set__app__169_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_args_set__env_247_cfa_info, _funcall_cinfo_args_set_4307_122_cfa_info4986, _funcall_cinfo_args_set_4307_122_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_type_set__env_25_cfa_info, _pre_struct_ref_app_type_set_3886_192_cfa_info4987, _pre_struct_ref_app_type_set_3886_192_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_select_cinfo_env_166_cfa_info, _allocate_select_cinfo_74_cfa_info4988, _allocate_select_cinfo_74_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_args_env_134_cfa_info, _procedure_set__app_args4058_49_cfa_info4989, _procedure_set__app_args4058_49_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_make_vector_app_env_222_cfa_info, _allocate_make_vector_app_18_cfa_info4990, _allocate_make_vector_app_18_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_key_set__env_144_cfa_info, _pre_struct_set__app_key_set__68_cfa_info4991, _pre_struct_set__app_key_set__68_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_top__env_145_cfa_info, _extern_sfun_cinfo_top_4463_92_cfa_info4992, _extern_sfun_cinfo_top_4463_92_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx__env_16_cfa_info, _approx__184_cfa_info4993, _approx__184_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_test_env_55_cfa_info, _select_cinfo_test4249_94_cfa_info4994, _select_cinfo_test4249_94_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_args_env_64_cfa_info, _pre_vector_set__app_args4001_232_cfa_info4995, _pre_vector_set__app_args4001_232_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_args_env_152_cfa_info, _pre_make_procedure_app_args4144_74_cfa_info4996, _pre_make_procedure_app_args4144_74_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_side_effect__env_155_cfa_info, _make_box_o_cinfo_side_effect_4194_224_cfa_info4997, _make_box_o_cinfo_side_effect_4194_224_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_var_env_115_cfa_info, _box_set__o_cinfo_var4164_214_cfa_info4998, _box_set__o_cinfo_var4164_214_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo__env_176_cfa_info, _funcall_cinfo__59_cfa_info4999, _funcall_cinfo__59_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_import_env_87_cfa_info, _reshaped_global_import4367_113_cfa_info5000, _reshaped_global_import4367_113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_value_set__env_60_cfa_info, _box_set__o_cinfo_value_set_4165_22_cfa_info5001, _box_set__o_cinfo_value_set_4165_22_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_test_set__env_187_cfa_info, _conditional_cinfo_test_set_4272_187_cfa_info5002, _conditional_cinfo_test_set_4272_187_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_clo_env__set__env_145_cfa_info, _svar_cinfo_clo_env__set_4413_164_cfa_info5003, _svar_cinfo_clo_env__set_4413_164_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_args_env_234_cfa_info, _pre_struct_ref_app_args3893_29_cfa_info5004, _pre_struct_ref_app_args3893_29_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_type_env_149_cfa_info, _kwote_cinfo_type4331_130_cfa_info5005, _kwote_cinfo_type4331_130_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_approx_env_81_cfa_info, _make_vector_app_approx3981_121_cfa_info5006, _make_vector_app_approx3981_121_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1035_procedure_ref_app_env_9_cfa_info, _widening1035_procedure_ref_app4062_1_cfa_info5007, _widening1035_procedure_ref_app4062_1_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_type_env_10_cfa_info, _jump_ex_it_cinfo_type4225_115_cfa_info5008, _jump_ex_it_cinfo_type4225_115_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_loc_env_143_cfa_info, _make_vector_app_loc3968_153_cfa_info5009, _make_vector_app_loc3968_153_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_type_set__env_20_cfa_info, _setq_cinfo_type_set_4282_115_cfa_info5010, _setq_cinfo_type_set_4282_115_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_fun_set__env_27_cfa_info, _struct_ref_app_fun_set_3841_162_cfa_info5011, _struct_ref_app_fun_set_3841_162_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_side_effect__set__env_19_cfa_info, _pragma_cinfo_side_effect__set_4294_183_cfa_info5012, _pragma_cinfo_side_effect__set_4294_183_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_stack_info_env_7_cfa_info, _pre_struct_set__app_stack_info3883_34_cfa_info5013, _pre_struct_set__app_stack_info3883_34_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_fun_env_152_cfa_info, _vector_ref_app_fun3934_63_cfa_info5014, _vector_ref_app_fun3934_63_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_fun_set__env_240_cfa_info, _pre_vector_set__app_fun_set_3998_143_cfa_info5015, _pre_vector_set__app_fun_set_3998_143_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_type_set__env_69_cfa_info, _approx_type_set_4498_139_cfa_info5016, _approx_type_set_4498_139_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_side_effect__env_58_cfa_info, _extern_sfun_cinfo_side_effect_4457_249_cfa_info5017, _extern_sfun_cinfo_side_effect_4457_249_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_vector_set__app_env_49_cfa_info, _allocate_pre_vector_set__app_63_cfa_info5018, _allocate_pre_vector_set__app_63_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_fun_env_101_cfa_info, _pre_make_vector_app_fun4042_147_cfa_info5019, _pre_make_vector_app_fun4042_147_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app__env_47_cfa_info, _pre_make_procedure_app__252_cfa_info5020, _pre_make_procedure_app__252_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_user__env_60_cfa_info, _reshaped_global_user_4373_223_cfa_info5021, _reshaped_global_user_4373_223_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_loc_env_119_cfa_info, _set_ex_it_cinfo_loc4233_210_cfa_info5022, _set_ex_it_cinfo_loc4233_210_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_fun_set__env_68_cfa_info, _pre_procedure_set__app_fun_set_4114_225_cfa_info5023, _pre_procedure_set__app_fun_set_4114_225_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_set__app_stack_info_set__env_104_cfa_info, _vector_set__app_stack_info_set_3923_27_cfa_info5024, _vector_set__app_stack_info_set_3923_27_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stamp_env_215_cfa_info, _intern_sfun_cinfo_stamp4452_130_cfa_info5025, _intern_sfun_cinfo_stamp4452_130_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_fun_set__env_90_cfa_info, _pre_make_struct_app_fun_set_3905_60_cfa_info5026, _pre_make_struct_app_fun_set_3905_60_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_var_env_181_cfa_info, _setq_cinfo_var4285_116_cfa_info5027, _setq_cinfo_var4285_116_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_set__o_cinfo_env_46_cfa_info, _make_box_set__o_cinfo4159_124_cfa_info5028, _make_box_set__o_cinfo4159_124_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_info_set__env_214_cfa_info, _make_struct_app_stack_info_set_3860_205_cfa_info5029, _make_struct_app_stack_info_set_3860_205_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_args_set__env_108_cfa_info, _pre_procedure_set__app_args_set_4116_96_cfa_info5030, _pre_procedure_set__app_args_set_4116_96_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_side_effect__set__env_17_cfa_info, _pre_make_struct_app_side_effect__set_3901_34_cfa_info5031, _pre_make_struct_app_side_effect__set_3901_34_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_type_env_218_cfa_info, _pre_make_vector_app_type4036_231_cfa_info5032, _pre_make_vector_app_type4036_231_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_value_set__env_69_cfa_info, _reshaped_global_value_set_4355_229_cfa_info5033, _reshaped_global_value_set_4355_229_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_side_effect__env_108_cfa_info, _box_ref_o_cinfo_side_effect_4154_125_cfa_info5034, _box_ref_o_cinfo_side_effect_4154_125_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_env_204_cfa_info, _make_procedure_app_x4100_182_cfa_info5035, _make_procedure_app_x4100_182_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_body_set__env_138_cfa_info, _intern_sfun_cinfo_body_set_4442_55_cfa_info5036, _intern_sfun_cinfo_body_set_4442_55_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_args_set__env_180_cfa_info, _make_vector_app_args_set_3976_166_cfa_info5037, _make_vector_app_args_set_3976_166_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_set__env_178_cfa_info, _make_procedure_app_x_set_4099_130_cfa_info5038, _make_procedure_app_x_set_4099_130_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_stack_info_env_98_cfa_info, _pre_procedure_ref_app_stack_info4131_112_cfa_info5039, _pre_procedure_ref_app_stack_info4131_112_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_args_env_8_cfa_info, _pre_procedure_set__app_args4117_236_cfa_info5040, _pre_procedure_set__app_args4117_236_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_lost_stamp_set__env_86_cfa_info, _make_procedure_app_lost_stamp_set_4095_153_cfa_info5041, _make_procedure_app_lost_stamp_set_4095_153_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_approx_env_220_cfa_info, _procedure_ref_app_approx4075_236_cfa_info5042, _procedure_ref_app_approx4075_236_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stackable__set__env_172_cfa_info, _make_struct_app_stackable__set_3868_160_cfa_info5043, _make_struct_app_stackable__set_3868_160_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_make_box_cinfo_env_36_cfa_info, _allocate_make_box_cinfo_36_cfa_info5044, _allocate_make_box_cinfo_36_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(widening1020_fail_cinfo_env_16_cfa_info, _widening1020_fail_cinfo4253_123_cfa_info5045, _widening1020_fail_cinfo4253_123_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_side_effect__set__env_103_cfa_info, _conditional_cinfo_side_effect__set_4270_90_cfa_info5046, _conditional_cinfo_side_effect__set_4270_90_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_approx_env_154_cfa_info, _extern_sfun_cinfo_approx4478_97_cfa_info5047, _extern_sfun_cinfo_approx4478_97_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_predicate_of_set__env_216_cfa_info, _cfun_cinfo_predicate_of_set_4484_6_cfa_info5048, _cfun_cinfo_predicate_of_set_4484_6_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_key_env_138_cfa_info, _pre_procedure_ref_app_key_222_cfa_info5049, _pre_procedure_ref_app_key_222_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1036_procedure_set__app_env_144_cfa_info, _widening1036_procedure_set__app4048_121_cfa_info5050, _widening1036_procedure_set__app4048_121_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_stamp_env_244_cfa_info, _make_struct_app_stack_stamp3871_79_cfa_info5051, _make_struct_app_stack_stamp3871_79_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_args_set__env_239_cfa_info, _vector_ref_app_args_set_3935_221_cfa_info5052, _vector_ref_app_args_set_3935_221_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_reshaped_global_env_69_cfa_info, _make_reshaped_global4349_214_cfa_info5053, _make_reshaped_global4349_214_cfa_info, 0L, 15);
DEFINE_EXPORT_PROCEDURE(approx_allocs_env_223_cfa_info, _approx_allocs4501_142_cfa_info5054, _approx_allocs4501_142_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_ref_app_env_244_cfa_info, _make_procedure_ref_app4063_52_cfa_info5055, _make_procedure_ref_app4063_52_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(create_vector_app_approx_env_156_cfa_info, _create_vector_app_approx3955_106_cfa_info5056, _create_vector_app_approx3955_106_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_type_env_8_cfa_info, _make_box_cinfo_type4205_248_cfa_info5057, _make_box_cinfo_type4205_248_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_side_effect__env_204_cfa_info, _procedure_ref_app_side_effect_4068_53_cfa_info5058, _procedure_ref_app_side_effect_4068_53_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_approx_env_171_cfa_info, _allocate_approx_254_cfa_info5059, _allocate_approx_254_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_loc_env_98_cfa_info, _pragma_cinfo_loc4291_208_cfa_info5060, _pragma_cinfo_loc4291_208_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_value_env_203_cfa_info, _box_set__o_cinfo_value4166_97_cfa_info5061, _box_set__o_cinfo_value4166_97_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_test_env_87_cfa_info, _conditional_cinfo_test4273_188_cfa_info5062, _conditional_cinfo_test4273_188_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_procedure_set__app_env_110_cfa_info, _make_pre_procedure_set__app4108_230_cfa_info5063, _make_pre_procedure_set__app4108_230_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_type_set__env_23_cfa_info, _box_set__o_cinfo_type_set_4161_232_cfa_info5064, _box_set__o_cinfo_type_set_4161_232_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_fun_set__env_126_cfa_info, _pre_struct_ref_app_fun_set_3890_179_cfa_info5065, _pre_struct_ref_app_fun_set_3890_179_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_key_env_50_cfa_info, _pre_struct_set__app_key_140_cfa_info5066, _pre_struct_set__app_key_140_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_args_env_30_cfa_info, _vector_set__app_args3922_148_cfa_info5067, _vector_set__app_args3922_148_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_type_set__env_88_cfa_info, _reshaped_global_type_set_4353_23_cfa_info5068, _reshaped_global_type_set_4353_23_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_args_set__env_77_cfa_info, _pre_make_struct_app_args_set_3907_42_cfa_info5069, _pre_make_struct_app_args_set_3907_42_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_args_env_235_cfa_info, _extern_sfun_cinfo_args4469_187_cfa_info5070, _extern_sfun_cinfo_args4469_187_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_side_effect__set__env_174_cfa_info, _make_struct_app_side_effect__set_3853_48_cfa_info5071, _make_struct_app_side_effect__set_3853_48_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_obj_env_199_cfa_info, _fail_cinfo_obj4263_218_cfa_info5072, _fail_cinfo_obj4263_218_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_loc_env_218_cfa_info, _pre_make_procedure_app_loc4134_49_cfa_info5073, _pre_make_procedure_app_loc4134_49_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_side_effect__env_63_cfa_info, _create_vector_app_side_effect_3946_172_cfa_info5074, _create_vector_app_side_effect_3946_172_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_intern_sfun_cinfo_env_101_cfa_info, _allocate_intern_sfun_cinfo_249_cfa_info5075, _allocate_intern_sfun_cinfo_249_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(widening1024_pre_make_box_env_53_cfa_info, _widening1024_pre_make_box_222_cfa_info5076, _widening1024_pre_make_box_222_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_stack_info_set__env_255_cfa_info, _pre_struct_ref_app_stack_info_set_3894_151_cfa_info5077, _pre_struct_ref_app_stack_info_set_3894_151_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1046_pre_struct_ref_app_env_117_cfa_info, _widening1046_pre_struct_ref_app_77_cfa_info5078, _widening1046_pre_struct_ref_app_77_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_loc_env_58_cfa_info, _pre_procedure_set__app_loc4109_229_cfa_info5079, _pre_procedure_set__app_loc4109_229_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local__env_45_cfa_info, _reshaped_local__93_cfa_info5080, _reshaped_local__93_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo__env_112_cfa_info, _app_ly_cinfo__202_cfa_info5081, _app_ly_cinfo__202_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1009_sexit_cinfo_env_104_cfa_info, _widening1009_sexit_cinfo4397_17_cfa_info5082, _widening1009_sexit_cinfo4397_17_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_loc_env_122_cfa_info, _pre_make_box_loc4212_83_cfa_info5083, _pre_make_box_loc4212_83_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_seen__env_221_cfa_info, _create_vector_app_seen_3965_143_cfa_info5084, _create_vector_app_seen_3965_143_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pragma_cinfo_env_229_cfa_info, _make_pragma_cinfo4290_232_cfa_info5085, _make_pragma_cinfo4290_232_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_var_env_178_cfa_info, _box_set__cinfo_var4184_170_cfa_info5086, _box_set__cinfo_var4184_170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_side_effect__env_193_cfa_info, _pre_make_procedure_app_side_effect_4138_178_cfa_info5087, _pre_make_procedure_app_side_effect_4138_178_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1032_pre_procedure_ref_app_env_229_cfa_info, _widening1032_pre_procedure_ref_app_158_cfa_info5088, _widening1032_pre_procedure_ref_app_158_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_property_set__env_190_cfa_info, _intern_sfun_cinfo_property_set_4438_254_cfa_info5089, _intern_sfun_cinfo_property_set_4438_254_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_ref_app_env_166_cfa_info, _make_vector_ref_app3927_130_cfa_info5090, _make_vector_ref_app3927_130_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(reshaped_local_fast_alpha_env_248_cfa_info, _reshaped_local_fast_alpha4388_156_cfa_info5091, _reshaped_local_fast_alpha4388_156_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_fun_env_23_cfa_info, _struct_set__app_fun3828_168_cfa_info5092, _struct_set__app_fun3828_168_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_side_effect__env_170_cfa_info, _pre_procedure_set__app_side_effect_4113_146_cfa_info5093, _pre_procedure_set__app_side_effect_4113_146_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo__env_239_cfa_info, _make_box_cinfo__189_cfa_info5094, _make_box_cinfo__189_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_src_set__env_155_cfa_info, _reshaped_global_src_set_4375_186_cfa_info5095, _reshaped_global_src_set_4375_186_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stackable__env_29_cfa_info, _make_procedure_app_stackable_4105_191_cfa_info5096, _make_procedure_app_stackable_4105_191_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_type_set__env_255_cfa_info, _kwote_cinfo_type_set_4330_243_cfa_info5097, _kwote_cinfo_type_set_4330_243_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_key_env_74_cfa_info, _make_box_cinfo_key_44_cfa_info5098, _make_box_cinfo_key_44_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app__env_241_cfa_info, _make_struct_app__44_cfa_info5099, _make_struct_app__44_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_value_env_60_cfa_info, _setq_cinfo_value4287_60_cfa_info5100, _setq_cinfo_value4287_60_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app__env_27_cfa_info, _vector_set__app__140_cfa_info5101, _vector_set__app__140_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_approx_env_243_cfa_info, _svar_cinfo_approx4412_1_cfa_info5102, _svar_cinfo_approx4412_1_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_type_env_100_cfa_info, _reshaped_global_type4354_0_cfa_info5103, _reshaped_global_type4354_0_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_type_env_9_cfa_info, _make_vector_app_type3970_181_cfa_info5104, _make_vector_app_type3970_181_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_loc_set__env_226_cfa_info, _svar_cinfo_loc_set_4410_107_cfa_info5105, _svar_cinfo_loc_set_4410_107_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_loc_env_41_cfa_info, _fail_cinfo_loc4255_82_cfa_info5106, _fail_cinfo_loc4255_82_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_predicate_of_set__env_185_cfa_info, _extern_sfun_cinfo_predicate_of_set_4458_176_cfa_info5107, _extern_sfun_cinfo_predicate_of_set_4458_176_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_test_set__env_50_cfa_info, _select_cinfo_test_set_4248_179_cfa_info5108, _select_cinfo_test_set_4248_179_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_args_env_246_cfa_info, _vector_ref_app_args3936_244_cfa_info5109, _vector_ref_app_args3936_244_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_key_set__env_211_cfa_info, _pragma_cinfo_key_set__201_cfa_info5110, _pragma_cinfo_key_set__201_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_dsssl_keywords_env_248_cfa_info, _intern_sfun_cinfo_dsssl_keywords4447_80_cfa_info5111, _intern_sfun_cinfo_dsssl_keywords4447_80_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_side_effect__env_116_cfa_info, _conditional_cinfo_side_effect_4271_3_cfa_info5112, _conditional_cinfo_side_effect_4271_3_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1022_set_ex_it_cinfo_env_133_cfa_info, _widening1022_set_ex_it_cinfo4231_122_cfa_info5113, _widening1022_set_ex_it_cinfo4231_122_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_make_box_o_cinfo_env_200_cfa_info, _make_make_box_o_cinfo4189_169_cfa_info5114, _make_make_box_o_cinfo4189_169_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_strength_env_147_cfa_info, _funcall_cinfo_strength4310_166_cfa_info5115, _funcall_cinfo_strength4310_166_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stackable__env_206_cfa_info, _make_vector_app_stackable_3987_124_cfa_info5116, _make_vector_app_stackable_3987_124_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1013_kwote_node_env_65_cfa_info, _widening1013_kwote_node4334_113_cfa_info5117, _widening1013_kwote_node4334_113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_access_env_211_cfa_info, _reshaped_global_access4358_220_cfa_info5118, _reshaped_global_access4358_220_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_value_approx_env_182_cfa_info, _make_box_o_cinfo_value_approx4200_243_cfa_info5119, _make_box_o_cinfo_value_approx4200_243_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_type_set__env_162_cfa_info, _pragma_cinfo_type_set_4292_129_cfa_info5120, _pragma_cinfo_type_set_4292_129_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_loc_env_150_cfa_info, _procedure_ref_app_loc4064_180_cfa_info5121, _procedure_ref_app_loc4064_180_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_kwote_cinfo_env_199_cfa_info, _allocate_kwote_cinfo_178_cfa_info5122, _allocate_kwote_cinfo_178_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_args_set__env_73_cfa_info, _make_procedure_app_args_set_4086_97_cfa_info5123, _make_procedure_app_args_set_4086_97_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_owner_env_149_cfa_info, _make_vector_app_owner3985_202_cfa_info5124, _make_vector_app_owner3985_202_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_fun_set__env_197_cfa_info, _make_procedure_app_fun_set_4084_224_cfa_info5125, _make_procedure_app_fun_set_4084_224_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_false_env_228_cfa_info, _conditional_cinfo_false4277_112_cfa_info5126, _conditional_cinfo_false4277_112_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_extern_sfun_cinfo_env_154_cfa_info, _make_extern_sfun_cinfo4454_19_cfa_info5127, _make_extern_sfun_cinfo4454_19_cfa_info, 0L, 13);
DEFINE_EXPORT_PROCEDURE(pre_make_box_side_effect__env_178_cfa_info, _pre_make_box_side_effect_4216_75_cfa_info5128, _pre_make_box_side_effect_4216_75_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_type_set__env_219_cfa_info, _app_ly_cinfo_type_set_4320_179_cfa_info5129, _app_ly_cinfo_type_set_4320_179_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_value_env_128_cfa_info, _atom_cinfo_value4347_202_cfa_info5130, _atom_cinfo_value4347_202_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_predicate_of_env_150_cfa_info, _intern_sfun_cinfo_predicate_of4431_196_cfa_info5131, _intern_sfun_cinfo_predicate_of4431_196_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_reshaped_local_env_189_cfa_info, _allocate_reshaped_local_17_cfa_info5132, _allocate_reshaped_local_17_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_ref_cinfo_env_80_cfa_info, _make_box_ref_cinfo4169_167_cfa_info5133, _make_box_ref_cinfo4169_167_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_infix__env_255_cfa_info, _cfun_cinfo_infix_4495_55_cfa_info5134, _cfun_cinfo_infix_4495_55_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_make_vector_app_env_250_cfa_info, _make_make_vector_app3967_73_cfa_info5135, _make_make_vector_app3967_73_cfa_info, 0L, 14);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_key_set__env_233_cfa_info, _struct_ref_app_key_set__180_cfa_info5136, _struct_ref_app_key_set__180_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_args_set__env_221_cfa_info, _struct_set__app_args_set_3829_39_cfa_info5137, _struct_set__app_args_set_3829_39_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1033_pre_procedure_set__app_env_186_cfa_info, _widening1033_pre_procedure_set__app_239_cfa_info5138, _widening1033_pre_procedure_set__app_239_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_key_set__env_179_cfa_info, _make_box_o_cinfo_key_set__74_cfa_info5139, _make_box_o_cinfo_key_set__74_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_vector_set__app_env_178_cfa_info, _allocate_vector_set__app_158_cfa_info5140, _allocate_vector_set__app_158_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_type_set__env_223_cfa_info, _pre_vector_ref_app_type_set_4006_27_cfa_info5141, _pre_vector_ref_app_type_set_4006_27_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_lost_stamp_set__env_104_cfa_info, _make_vector_app_lost_stamp_set_3983_140_cfa_info5142, _make_vector_app_lost_stamp_set_3983_140_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_evaluable__env_36_cfa_info, _reshaped_global_evaluable_4369_74_cfa_info5143, _reshaped_global_evaluable_4369_74_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_stamp_set__env_155_cfa_info, _create_vector_app_stack_stamp_set_3962_205_cfa_info5144, _create_vector_app_stack_stamp_set_3962_205_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_evaluable__set__env_95_cfa_info, _reshaped_global_evaluable__set_4368_13_cfa_info5145, _reshaped_global_evaluable__set_4368_13_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_key_set__env_45_cfa_info, _pre_vector_set__app_key_set__241_cfa_info5146, _pre_vector_set__app_key_set__241_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_args_set__env_186_cfa_info, _procedure_ref_app_args_set_4071_177_cfa_info5147, _procedure_ref_app_args_set_4071_177_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_type_env_69_cfa_info, _struct_ref_app_type3838_64_cfa_info5148, _struct_ref_app_type3838_64_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_key_set__env_13_cfa_info, _make_box_cinfo_key_set__204_cfa_info5149, _make_box_cinfo_key_set__204_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_stack_info_env_83_cfa_info, _struct_ref_app_stack_info3846_168_cfa_info5150, _struct_ref_app_stack_info3846_168_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_var_set__env_88_cfa_info, _box_ref_cinfo_var_set_4175_2_cfa_info5151, _box_ref_cinfo_var_set_4175_2_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_type_set__env_27_cfa_info, _pre_procedure_ref_app_type_set_4122_5_cfa_info5152, _pre_procedure_ref_app_type_set_4122_5_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_value_set__env_97_cfa_info, _make_box_o_cinfo_value_set_4196_101_cfa_info5153, _make_box_o_cinfo_value_set_4196_101_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_true_set__env_200_cfa_info, _conditional_cinfo_true_set_4274_243_cfa_info5154, _conditional_cinfo_true_set_4274_243_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_key_set__env_130_cfa_info, _pre_procedure_set__app_key_set__239_cfa_info5155, _pre_procedure_set__app_key_set__239_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_id_env_94_cfa_info, _reshaped_global_id4350_75_cfa_info5156, _reshaped_global_id4350_75_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1007_svar_cinfo_env_1_cfa_info, _widening1007_svar_cinfo4408_80_cfa_info5157, _widening1007_svar_cinfo4408_80_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_clo_env_env_208_cfa_info, _make_pre_clo_env_110_cfa_info5158, _make_pre_clo_env_110_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_name_env_98_cfa_info, _reshaped_local_name4380_238_cfa_info5159, _reshaped_local_name4380_238_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_create_vector_app_env_8_cfa_info, _make_pre_create_vector_app4017_15_cfa_info5160, _make_pre_create_vector_app4017_15_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_predicate_of_set__env_233_cfa_info, _intern_sfun_cinfo_predicate_of_set_4430_130_cfa_info5161, _intern_sfun_cinfo_predicate_of_set_4430_130_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_sexit_cinfo_env_157_cfa_info, _allocate_sexit_cinfo_64_cfa_info5162, _allocate_sexit_cinfo_64_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_type_env_252_cfa_info, _fail_cinfo_type4257_58_cfa_info5163, _fail_cinfo_type4257_58_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_side_effect__set__env_119_cfa_info, _make_box_cinfo_side_effect__set_4206_43_cfa_info5164, _make_box_cinfo_side_effect__set_4206_43_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1050_struct_set__app_env_22_cfa_info, _widening1050_struct_set__app3820_227_cfa_info5165, _widening1050_struct_set__app3820_227_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_args_set__env_150_cfa_info, _pre_make_vector_app_args_set_4043_152_cfa_info5166, _pre_make_vector_app_args_set_4043_152_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_key_set__env_129_cfa_info, _pre_make_struct_app_key_set_3903_249_cfa_info5167, _pre_make_struct_app_key_set_3903_249_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_type_set__env_49_cfa_info, _box_ref_o_cinfo_type_set_4151_14_cfa_info5168, _box_ref_o_cinfo_type_set_4151_14_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(kwote_node_loc_env_235_cfa_info, _kwote_node_loc4336_209_cfa_info5169, _kwote_node_loc4336_209_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_loc_env_245_cfa_info, _pre_create_vector_app_loc4018_46_cfa_info5170, _pre_create_vector_app_loc4018_46_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stackable__env_98_cfa_info, _make_struct_app_stackable_3869_173_cfa_info5171, _make_struct_app_stackable_3869_173_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_struct_set__app_env_196_cfa_info, _allocate_pre_struct_set__app_93_cfa_info5172, _allocate_pre_struct_set__app_93_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_values_approx_set__env_190_cfa_info, _make_procedure_app_values_approx_set_4093_149_cfa_info5173, _make_procedure_app_values_approx_set_4093_149_cfa_info, 0L, 3);
DEFINE_EXPORT_PROCEDURE(widening1040_pre_vector_set__app_env_85_cfa_info, _widening1040_pre_vector_set__app_75_cfa_info5174, _widening1040_pre_vector_set__app_75_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_loc_env_178_cfa_info, _pre_vector_set__app_loc3993_34_cfa_info5175, _pre_vector_set__app_loc3993_34_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1005_scnst_cinfo_env_73_cfa_info, _widening1005_scnst_cinfo4417_213_cfa_info5176, _widening1005_scnst_cinfo4417_213_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_approx_set__env_2_cfa_info, _make_struct_app_approx_set_3862_80_cfa_info5177, _make_struct_app_approx_set_3862_80_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_src_env_194_cfa_info, _reshaped_global_src4376_17_cfa_info5178, _reshaped_global_src4376_17_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_type_env_150_cfa_info, _pre_make_struct_app_type3900_2_cfa_info5179, _pre_make_struct_app_type3900_2_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_stack_info_set__env_172_cfa_info, _pre_procedure_ref_app_stack_info_set_4130_149_cfa_info5180, _pre_procedure_ref_app_stack_info_set_4130_149_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_fun_set__env_205_cfa_info, _app_ly_cinfo_fun_set_4322_68_cfa_info5181, _app_ly_cinfo_fun_set_4322_68_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_loc_env_215_cfa_info, _extern_sfun_cinfo_loc4477_88_cfa_info5182, _extern_sfun_cinfo_loc4477_88_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_approx_env_114_cfa_info, _pragma_cinfo_approx4299_32_cfa_info5183, _pragma_cinfo_approx4299_32_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_args_env_145_cfa_info, _pre_make_vector_app_args4044_120_cfa_info5184, _pre_make_vector_app_args4044_120_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_key_env_169_cfa_info, _vector_set__app_key_147_cfa_info5185, _vector_set__app_key_147_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_detached__env_55_cfa_info, _sexit_cinfo_detached_4402_213_cfa_info5186, _sexit_cinfo_detached_4402_213_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_side_effect__set__env_63_cfa_info, _pre_struct_set__app_side_effect__set_3876_249_cfa_info5187, _pre_struct_set__app_side_effect__set_3876_249_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1006_pre_clo_env_env_43_cfa_info, _widening1006_pre_clo_env_70_cfa_info5188, _widening1006_pre_clo_env_70_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(reshaped_global_library__set__env_45_cfa_info, _reshaped_global_library__set_4370_158_cfa_info5189, _reshaped_global_library__set_4370_158_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stackable__env_240_cfa_info, _create_vector_app_stackable_3961_41_cfa_info5190, _create_vector_app_stackable_3961_41_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_ref_o_cinfo_env_184_cfa_info, _allocate_box_ref_o_cinfo_197_cfa_info5191, _allocate_box_ref_o_cinfo_197_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_fun_env_218_cfa_info, _pre_struct_ref_app_fun3891_141_cfa_info5192, _pre_struct_ref_app_fun3891_141_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1030_box_ref_o_cinfo_env_99_cfa_info, _widening1030_box_ref_o_cinfo4148_151_cfa_info5193, _widening1030_box_ref_o_cinfo4148_151_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_key_set__env_67_cfa_info, _pre_struct_ref_app_key_set__136_cfa_info5194, _pre_struct_ref_app_key_set__136_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_side_effect__env_203_cfa_info, _make_procedure_app_side_effect_4082_191_cfa_info5195, _make_procedure_app_side_effect_4082_191_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo__env_101_cfa_info, _select_cinfo__186_cfa_info5196, _select_cinfo__186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_the_closure_env_198_cfa_info, _intern_sfun_cinfo_the_closure4437_96_cfa_info5197, _intern_sfun_cinfo_the_closure4437_96_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_side_effect__env_192_cfa_info, _procedure_set__app_side_effect_4054_216_cfa_info5198, _procedure_set__app_side_effect_4054_216_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_side_effect__set__env_60_cfa_info, _make_procedure_app_side_effect__set_4081_159_cfa_info5199, _make_procedure_app_side_effect__set_4081_159_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_value_approx_env_159_cfa_info, _create_vector_app_value_approx3956_148_cfa_info5200, _create_vector_app_value_approx3956_148_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_user__set__env_161_cfa_info, _reshaped_global_user__set_4372_177_cfa_info5201, _reshaped_global_user__set_4372_177_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_loc_env_8_cfa_info, _pre_make_struct_app_loc3898_247_cfa_info5202, _pre_make_struct_app_loc3898_247_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_class_env_133_cfa_info, _scnst_cinfo_class4421_86_cfa_info5203, _scnst_cinfo_class4421_86_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_body_env_96_cfa_info, _extern_sfun_cinfo_body4471_1_cfa_info5204, _extern_sfun_cinfo_body4471_1_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_ref_cinfo_env_99_cfa_info, _allocate_box_ref_cinfo_238_cfa_info5205, _allocate_box_ref_cinfo_238_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(select_cinfo_side_effect__env_63_cfa_info, _select_cinfo_side_effect_4247_86_cfa_info5206, _select_cinfo_side_effect_4247_86_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_var_set__env_236_cfa_info, _box_ref_o_cinfo_var_set_4155_190_cfa_info5207, _box_ref_o_cinfo_var_set_4155_190_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_struct_app_env_41_cfa_info, _allocate_pre_make_struct_app_85_cfa_info5208, _allocate_pre_make_struct_app_85_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_type_set__env_12_cfa_info, _conditional_cinfo_type_set_4268_201_cfa_info5209, _conditional_cinfo_type_set_4268_201_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cvar_cinfo_approx_env_74_cfa_info, _cvar_cinfo_approx4407_165_cfa_info5210, _cvar_cinfo_approx4407_165_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_stack_info_set__env_189_cfa_info, _procedure_ref_app_stack_info_set_4073_25_cfa_info5211, _procedure_ref_app_stack_info_set_4073_25_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_approx_env_110_cfa_info, _make_struct_app_approx3863_199_cfa_info5212, _make_struct_app_approx3863_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_key_env_206_cfa_info, _make_struct_app_key3855_132_cfa_info5213, _make_struct_app_key3855_132_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_side_effect__env_207_cfa_info, _pre_struct_ref_app_side_effect_3889_58_cfa_info5214, _pre_struct_ref_app_side_effect_3889_58_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_fun_set__env_88_cfa_info, _make_vector_app_fun_set_3974_137_cfa_info5215, _make_vector_app_fun_set_3974_137_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_scnst_cinfo_env_240_cfa_info, _make_scnst_cinfo4418_0_cfa_info5216, _make_scnst_cinfo4418_0_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_fun_set__env_51_cfa_info, _vector_ref_app_fun_set_3933_193_cfa_info5217, _vector_ref_app_fun_set_3933_193_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_key_env_96_cfa_info, _box_ref_o_cinfo_key_193_cfa_info5218, _box_ref_o_cinfo_key_193_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_lost_stamp_set__env_181_cfa_info, _make_struct_app_lost_stamp_set_3865_171_cfa_info5219, _make_struct_app_lost_stamp_set_3865_171_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_key_env_204_cfa_info, _select_cinfo_key_1_cfa_info5220, _select_cinfo_key_1_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_stack_info_set__env_59_cfa_info, _pre_struct_set__app_stack_info_set_3882_247_cfa_info5221, _pre_struct_set__app_stack_info_set_3882_247_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_atom_cinfo_env_47_cfa_info, _make_atom_cinfo4342_156_cfa_info5222, _make_atom_cinfo4342_156_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo__env_143_cfa_info, _sexit_cinfo__68_cfa_info5223, _sexit_cinfo__68_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_setq_cinfo_env_96_cfa_info, _make_setq_cinfo4280_206_cfa_info5224, _make_setq_cinfo4280_206_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_loc_env_41_cfa_info, _funcall_cinfo_loc4302_189_cfa_info5225, _funcall_cinfo_loc4302_189_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_fun_env_96_cfa_info, _struct_ref_app_fun3842_117_cfa_info5226, _struct_ref_app_fun3842_117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_fun_set__env_54_cfa_info, _struct_set__app_fun_set_3827_17_cfa_info5227, _struct_set__app_fun_set_3827_17_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_approx_env_224_cfa_info, _make_approx4497_37_cfa_info5228, _make_approx4497_37_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_stack_info_set__env_219_cfa_info, _pre_create_vector_app_stack_info_set_4029_152_cfa_info5229, _pre_create_vector_app_stack_info_set_4029_152_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_side_effect__set__env_223_cfa_info, _struct_set__app_side_effect__set_3825_156_cfa_info5230, _struct_set__app_side_effect__set_3825_156_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_fun_set__env_146_cfa_info, _procedure_ref_app_fun_set_4069_83_cfa_info5231, _procedure_ref_app_fun_set_4069_83_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_key_env_82_cfa_info, _conditional_cinfo_key_29_cfa_info5232, _conditional_cinfo_key_29_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_make_box_env_106_cfa_info, _make_pre_make_box4211_93_cfa_info5233, _make_pre_make_box4211_93_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_values_approx_ref_env_109_cfa_info, _make_procedure_app_values_approx_ref4094_120_cfa_info5234, _make_procedure_app_values_approx_ref4094_120_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1026_make_box_o_cinfo_env_4_cfa_info, _widening1026_make_box_o_cinfo4188_73_cfa_info5235, _widening1026_make_box_o_cinfo4188_73_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1018_setq_cinfo_env_119_cfa_info, _widening1018_setq_cinfo4279_199_cfa_info5236, _widening1018_setq_cinfo4279_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_type_set__env_123_cfa_info, _pre_make_box_type_set_4213_178_cfa_info5237, _pre_make_box_type_set_4213_178_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1031_pre_make_procedure_app_env_231_cfa_info, _widening1031_pre_make_procedure_app4132_79_cfa_info5238, _widening1031_pre_make_procedure_app4132_79_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_approx_env_186_cfa_info, _funcall_cinfo_approx4311_125_cfa_info5239, _funcall_cinfo_approx4311_125_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_var_set__env_137_cfa_info, _box_set__cinfo_var_set_4183_81_cfa_info5240, _box_set__cinfo_var_set_4183_81_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cfun_cinfo_env_43_cfa_info, _make_cfun_cinfo4480_68_cfa_info5241, _make_cfun_cinfo4480_68_cfa_info, 0L, 10);
DEFINE_EXPORT_PROCEDURE(make_create_vector_app_env_137_cfa_info, _make_create_vector_app3941_23_cfa_info5242, _make_create_vector_app3941_23_cfa_info, 0L, 14);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_stack_info_set__env_101_cfa_info, _pre_procedure_set__app_stack_info_set_4118_226_cfa_info5243, _pre_procedure_set__app_stack_info_set_4118_226_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_key_set__env_128_cfa_info, _box_ref_cinfo_key_set__118_cfa_info5244, _box_ref_cinfo_key_set__118_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_property_set__env_242_cfa_info, _extern_sfun_cinfo_property_set_4466_95_cfa_info5245, _extern_sfun_cinfo_property_set_4466_95_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_type_env_241_cfa_info, _make_struct_app_type3852_107_cfa_info5246, _make_struct_app_type3852_107_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_key_env_119_cfa_info, _pre_vector_ref_app_key_37_cfa_info5247, _pre_vector_ref_app_key_37_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_predicate_of_env_113_cfa_info, _extern_sfun_cinfo_predicate_of4459_42_cfa_info5248, _extern_sfun_cinfo_predicate_of4459_42_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_side_effect__set__env_4_cfa_info, _make_box_o_cinfo_side_effect__set_4193_232_cfa_info5249, _make_box_o_cinfo_side_effect__set_4193_232_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_value_env_115_cfa_info, _kwote_cinfo_value4332_237_cfa_info5250, _kwote_cinfo_value4332_237_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_args_env_57_cfa_info, _make_vector_app_args3977_212_cfa_info5251, _make_vector_app_args3977_212_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_class_set__env_191_cfa_info, _scnst_cinfo_class_set_4420_88_cfa_info5252, _scnst_cinfo_class_set_4420_88_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_make_box_cinfo_env_141_cfa_info, _make_make_box_cinfo4202_207_cfa_info5253, _make_make_box_cinfo4202_207_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_approx_env_212_cfa_info, _make_box_cinfo_approx4210_116_cfa_info5254, _make_box_cinfo_approx4210_116_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_type_env_179_cfa_info, _set_ex_it_cinfo_type4235_175_cfa_info5255, _set_ex_it_cinfo_type4235_175_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_key_env_206_cfa_info, _box_ref_cinfo_key_241_cfa_info5256, _box_ref_cinfo_key_241_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_property_env_202_cfa_info, _extern_sfun_cinfo_property4467_53_cfa_info5257, _extern_sfun_cinfo_property4467_53_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_clo_env_loc_set__env_249_cfa_info, _pre_clo_env_loc_set_4415_110_cfa_info5258, _pre_clo_env_loc_set_4415_110_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_removable_set__env_47_cfa_info, _reshaped_local_removable_set_4389_217_cfa_info5259, _reshaped_local_removable_set_4389_217_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_key_set__env_162_cfa_info, _make_procedure_app_key_set__144_cfa_info5260, _make_procedure_app_key_set__144_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_args_set__env_75_cfa_info, _pre_struct_set__app_args_set_3880_136_cfa_info5261, _pre_struct_set__app_args_set_3880_136_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1042_create_vector_app_env_11_cfa_info, _widening1042_create_vector_app3940_225_cfa_info5262, _widening1042_create_vector_app3940_225_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(make_select_cinfo_env_204_cfa_info, _make_select_cinfo4242_184_cfa_info5263, _make_select_cinfo4242_184_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_property_env_58_cfa_info, _intern_sfun_cinfo_property4439_34_cfa_info5264, _intern_sfun_cinfo_property4439_34_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_msg_env_196_cfa_info, _fail_cinfo_msg4261_30_cfa_info5265, _fail_cinfo_msg4261_30_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_type_env_33_cfa_info, _box_ref_o_cinfo_type4152_46_cfa_info5266, _box_ref_o_cinfo_type4152_46_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_args_set__env_151_cfa_info, _extern_sfun_cinfo_args_set_4468_204_cfa_info5267, _extern_sfun_cinfo_args_set_4468_204_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_type_set__env_171_cfa_info, _fail_cinfo_type_set_4256_100_cfa_info5268, _fail_cinfo_type_set_4256_100_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_info_set__env_182_cfa_info, _create_vector_app_stack_info_set_3952_56_cfa_info5269, _create_vector_app_stack_info_set_3952_56_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_fun_env_29_cfa_info, _create_vector_app_fun3949_243_cfa_info5270, _create_vector_app_fun3949_243_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_occurrence_set__env_183_cfa_info, _reshaped_local_occurrence_set_4391_31_cfa_info5271, _reshaped_local_occurrence_set_4391_31_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_type_env_32_cfa_info, _setq_cinfo_type4283_134_cfa_info5272, _setq_cinfo_type4283_134_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_stack_info_env_149_cfa_info, _pre_struct_ref_app_stack_info3895_249_cfa_info5273, _pre_struct_ref_app_stack_info3895_249_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_fun_set__env_68_cfa_info, _pre_vector_ref_app_fun_set_4010_91_cfa_info5274, _pre_vector_ref_app_fun_set_4010_91_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_side_effect__env_111_cfa_info, _make_struct_app_side_effect_3854_6_cfa_info5275, _make_struct_app_side_effect_3854_6_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_type_env_18_cfa_info, _atom_cinfo_type4345_80_cfa_info5276, _atom_cinfo_type4345_80_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_clo_env__env_221_cfa_info, _svar_cinfo_clo_env_4414_89_cfa_info5277, _svar_cinfo_clo_env_4414_89_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_approx_env_220_cfa_info, _sexit_cinfo_approx4403_117_cfa_info5278, _sexit_cinfo_approx4403_117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_t__set__env_92_cfa_info, _make_procedure_app_x_t__set_4097_188_cfa_info5279, _make_procedure_app_x_t__set_4097_188_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app__env_32_cfa_info, _procedure_set__app__159_cfa_info5280, _procedure_set__app__159_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_top__set__env_224_cfa_info, _cfun_cinfo_top__set_4488_176_cfa_info5281, _cfun_cinfo_top__set_4488_176_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_arity_env_15_cfa_info, _intern_sfun_cinfo_arity4427_65_cfa_info5282, _intern_sfun_cinfo_arity4427_65_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_key_env_6_cfa_info, _vector_ref_app_key_21_cfa_info5283, _vector_ref_app_key_21_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stackable__set__env_123_cfa_info, _create_vector_app_stackable__set_3960_139_cfa_info5284, _create_vector_app_stackable__set_3960_139_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_fun_env_25_cfa_info, _make_procedure_app_fun4085_52_cfa_info5285, _make_procedure_app_fun4085_52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_struct_set__app_env_221_cfa_info, _allocate_struct_set__app_138_cfa_info5286, _allocate_struct_set__app_138_cfa_info, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc4599_cfa_info, object__struct_pre_clo_env_226_cfa_info5287, object__struct_pre_clo_env_226_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4609_cfa_info, object__struct_approx_119_cfa_info5288, object__struct_approx_119_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4610_cfa_info, struct_object__object_approx_184_cfa_info5289, struct_object__object_approx_184_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4598_cfa_info, struct_object__object_svar_cinfo_24_cfa_info5290, struct_object__object_svar_cinfo_24_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4608_cfa_info, struct_object__object_cfun_cinfo_204_cfa_info5291, struct_object__object_cfun_cinfo_204_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4597_cfa_info, object__struct_svar_cinfo_7_cfa_info5292, object__struct_svar_cinfo_7_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4607_cfa_info, object__struct_cfun_cinfo_76_cfa_info5293, object__struct_cfun_cinfo_76_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4596_cfa_info, struct_object__object_cvar_cinfo_125_cfa_info5294, struct_object__object_cvar_cinfo_125_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4606_cfa_info, struct_object__object_extern_sfun_cinfo_23_cfa_info5295, struct_object__object_extern_sfun_cinfo_23_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4595_cfa_info, object__struct_cvar_cinfo_219_cfa_info5296, object__struct_cvar_cinfo_219_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4605_cfa_info, object__struct_extern_sfun_cinfo_81_cfa_info5297, object__struct_extern_sfun_cinfo_81_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4594_cfa_info, struct_object__object_sexit_cinfo_74_cfa_info5298, struct_object__object_sexit_cinfo_74_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4604_cfa_info, struct_object__object_intern_sfun_cinfo_38_cfa_info5299, struct_object__object_intern_sfun_cinfo_38_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4593_cfa_info, object__struct_sexit_cinfo_98_cfa_info5300, object__struct_sexit_cinfo_98_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4603_cfa_info, object__struct_intern_sfun_cinfo_28_cfa_info5301, object__struct_intern_sfun_cinfo_28_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4592_cfa_info, struct_object__object_reshaped_local_214_cfa_info5302, struct_object__object_reshaped_local_214_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4602_cfa_info, struct_object__object_scnst_cinfo_187_cfa_info5303, struct_object__object_scnst_cinfo_187_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4591_cfa_info, object__struct_reshaped_local_22_cfa_info5304, object__struct_reshaped_local_22_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4601_cfa_info, object__struct_scnst_cinfo_225_cfa_info5305, object__struct_scnst_cinfo_225_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_approx_env_175_cfa_info, _app_ly_cinfo_approx4326_82_cfa_info5306, _app_ly_cinfo_approx4326_82_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_type_set__env_99_cfa_info, _atom_cinfo_type_set_4344_128_cfa_info5307, _atom_cinfo_type_set_4344_128_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4589_cfa_info, object__struct_reshaped_global_19_cfa_info5308, object__struct_reshaped_global_19_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4590_cfa_info, struct_object__object_reshaped_global_132_cfa_info5309, struct_object__object_reshaped_global_132_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4600_cfa_info, struct_object__object_pre_clo_env_30_cfa_info5310, struct_object__object_pre_clo_env_30_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_fun_env_66_cfa_info, _procedure_set__app_fun4056_131_cfa_info5311, _procedure_set__app_fun4056_131_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4588_cfa_info, struct_object__object_atom_cinfo_113_cfa_info5312, struct_object__object_atom_cinfo_113_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_key_env_92_cfa_info, _pre_make_vector_app_key4040_147_cfa_info5313, _pre_make_vector_app_key4040_147_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4587_cfa_info, object__struct_atom_cinfo_211_cfa_info5314, object__struct_atom_cinfo_211_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4586_cfa_info, struct_object__object_kwote_node_133_cfa_info5315, struct_object__object_kwote_node_133_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_class_set__env_171_cfa_info, _intern_sfun_cinfo_class_set_4444_82_cfa_info5316, _intern_sfun_cinfo_class_set_4444_82_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4585_cfa_info, object__struct_kwote_node_184_cfa_info5317, object__struct_kwote_node_184_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4584_cfa_info, struct_object__object_kwote_cinfo_192_cfa_info5318, struct_object__object_kwote_cinfo_192_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4583_cfa_info, object__struct_kwote_cinfo_203_cfa_info5319, object__struct_kwote_cinfo_203_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4582_cfa_info, struct_object__object_app_ly_cinfo_255_cfa_info5320, struct_object__object_app_ly_cinfo_255_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4581_cfa_info, object__struct_app_ly_cinfo_39_cfa_info5321, object__struct_app_ly_cinfo_39_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4579_cfa_info, object__struct_funcall_cinfo_250_cfa_info5322, object__struct_funcall_cinfo_250_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4580_cfa_info, struct_object__object_funcall_cinfo_97_cfa_info5323, struct_object__object_funcall_cinfo_97_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4578_cfa_info, struct_object__object_pragma_cinfo_100_cfa_info5324, struct_object__object_pragma_cinfo_100_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4577_cfa_info, object__struct_pragma_cinfo_175_cfa_info5325, object__struct_pragma_cinfo_175_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4576_cfa_info, struct_object__object_setq_cinfo_26_cfa_info5326, struct_object__object_setq_cinfo_26_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4575_cfa_info, object__struct_setq_cinfo_111_cfa_info5327, object__struct_setq_cinfo_111_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4574_cfa_info, struct_object__object_conditional_cinfo_141_cfa_info5328, struct_object__object_conditional_cinfo_141_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4573_cfa_info, object__struct_conditional_cinfo_223_cfa_info5329, object__struct_conditional_cinfo_223_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4572_cfa_info, struct_object__object_fail_cinfo_67_cfa_info5330, struct_object__object_fail_cinfo_67_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4571_cfa_info, object__struct_fail_cinfo_130_cfa_info5331, object__struct_fail_cinfo_130_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4569_cfa_info, object__struct_select_cinfo_146_cfa_info5332, object__struct_select_cinfo_146_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4570_cfa_info, struct_object__object_select_cinfo_79_cfa_info5333, struct_object__object_select_cinfo_79_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4568_cfa_info, struct_object__object_set_ex_it_cinfo_254_cfa_info5334, struct_object__object_set_ex_it_cinfo_254_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4567_cfa_info, object__struct_set_ex_it_cinfo_216_cfa_info5335, object__struct_set_ex_it_cinfo_216_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4566_cfa_info, struct_object__object_jump_ex_it_cinfo_82_cfa_info5336, struct_object__object_jump_ex_it_cinfo_82_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4565_cfa_info, object__struct_jump_ex_it_cinfo_111_cfa_info5337, object__struct_jump_ex_it_cinfo_111_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4564_cfa_info, struct_object__object_pre_make_box_16_cfa_info5338, struct_object__object_pre_make_box_16_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4563_cfa_info, object__struct_pre_make_box_150_cfa_info5339, object__struct_pre_make_box_150_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4562_cfa_info, struct_object__object_make_box_cinfo_10_cfa_info5340, struct_object__object_make_box_cinfo_10_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4561_cfa_info, object__struct_make_box_cinfo_186_cfa_info5341, object__struct_make_box_cinfo_186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_type_env_215_cfa_info, _select_cinfo_type4245_174_cfa_info5342, _select_cinfo_type4245_174_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4559_cfa_info, object__struct_make_box_o_cinfo_104_cfa_info5343, object__struct_make_box_o_cinfo_104_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4560_cfa_info, struct_object__object_make_box_o_cinfo_100_cfa_info5344, struct_object__object_make_box_o_cinfo_100_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4558_cfa_info, struct_object__object_box_set__cinfo_119_cfa_info5345, struct_object__object_box_set__cinfo_119_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4557_cfa_info, object__struct_box_set__cinfo_66_cfa_info5346, object__struct_box_set__cinfo_66_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_type_set__env_117_cfa_info, _procedure_set__app_type_set_4051_224_cfa_info5347, _procedure_set__app_type_set_4051_224_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4556_cfa_info, struct_object__object_box_ref_cinfo_78_cfa_info5348, struct_object__object_box_ref_cinfo_78_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4555_cfa_info, object__struct_box_ref_cinfo_171_cfa_info5349, object__struct_box_ref_cinfo_171_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4554_cfa_info, struct_object__object_box_set__o_cinfo_219_cfa_info5350, struct_object__object_box_set__o_cinfo_219_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_args_env_188_cfa_info, _struct_ref_app_args3844_142_cfa_info5351, _struct_ref_app_args3844_142_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4553_cfa_info, object__struct_box_set__o_cinfo_141_cfa_info5352, object__struct_box_set__o_cinfo_141_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_set__app_env_6_cfa_info, _make_vector_set__app3913_180_cfa_info5353, _make_vector_set__app3913_180_cfa_info, 0L, 8);
DEFINE_STATIC_PROCEDURE(proc4552_cfa_info, struct_object__object_box_ref_o_cinfo_19_cfa_info5354, struct_object__object_box_ref_o_cinfo_19_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4551_cfa_info, object__struct_box_ref_o_cinfo_174_cfa_info5355, object__struct_box_ref_o_cinfo_174_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4549_cfa_info, object__struct_pre_make_procedure_app_202_cfa_info5356, object__struct_pre_make_procedure_app_202_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4550_cfa_info, struct_object__object_pre_make_procedure_app_51_cfa_info5357, struct_object__object_pre_make_procedure_app_51_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4548_cfa_info, struct_object__object_pre_procedure_ref_app_139_cfa_info5358, struct_object__object_pre_procedure_ref_app_139_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4547_cfa_info, object__struct_pre_procedure_ref_app_223_cfa_info5359, object__struct_pre_procedure_ref_app_223_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4546_cfa_info, struct_object__object_pre_procedure_set__app_129_cfa_info5360, struct_object__object_pre_procedure_set__app_129_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4545_cfa_info, object__struct_pre_procedure_set__app_130_cfa_info5361, object__struct_pre_procedure_set__app_130_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4544_cfa_info, struct_object__object_make_procedure_app_38_cfa_info5362, struct_object__object_make_procedure_app_38_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4543_cfa_info, object__struct_make_procedure_app_124_cfa_info5363, object__struct_make_procedure_app_124_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4542_cfa_info, struct_object__object_procedure_ref_app_161_cfa_info5364, struct_object__object_procedure_ref_app_161_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4541_cfa_info, object__struct_procedure_ref_app_22_cfa_info5365, object__struct_procedure_ref_app_22_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4539_cfa_info, object__struct_procedure_set__app_86_cfa_info5366, object__struct_procedure_set__app_86_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4540_cfa_info, struct_object__object_procedure_set__app_110_cfa_info5367, struct_object__object_procedure_set__app_110_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4538_cfa_info, struct_object__object_pre_make_vector_app_45_cfa_info5368, struct_object__object_pre_make_vector_app_45_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4537_cfa_info, object__struct_pre_make_vector_app_189_cfa_info5369, object__struct_pre_make_vector_app_189_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4536_cfa_info, struct_object__object_pre_create_vector_app_213_cfa_info5370, struct_object__object_pre_create_vector_app_213_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4535_cfa_info, object__struct_pre_create_vector_app_184_cfa_info5371, object__struct_pre_create_vector_app_184_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4534_cfa_info, struct_object__object_pre_vector_ref_app_99_cfa_info5372, struct_object__object_pre_vector_ref_app_99_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4533_cfa_info, object__struct_pre_vector_ref_app_11_cfa_info5373, object__struct_pre_vector_ref_app_11_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4532_cfa_info, struct_object__object_pre_vector_set__app_122_cfa_info5374, struct_object__object_pre_vector_set__app_122_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4531_cfa_info, object__struct_pre_vector_set__app_201_cfa_info5375, object__struct_pre_vector_set__app_201_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4529_cfa_info, object__struct_make_vector_app_114_cfa_info5376, object__struct_make_vector_app_114_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4530_cfa_info, struct_object__object_make_vector_app_26_cfa_info5377, struct_object__object_make_vector_app_26_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4528_cfa_info, struct_object__object_create_vector_app_49_cfa_info5378, struct_object__object_create_vector_app_49_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4527_cfa_info, object__struct_create_vector_app_178_cfa_info5379, object__struct_create_vector_app_178_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4526_cfa_info, struct_object__object_vector_ref_app_116_cfa_info5380, struct_object__object_vector_ref_app_116_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4525_cfa_info, object__struct_vector_ref_app_174_cfa_info5381, object__struct_vector_ref_app_174_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4524_cfa_info, struct_object__object_vector_set__app_246_cfa_info5382, struct_object__object_vector_set__app_246_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4523_cfa_info, object__struct_vector_set__app_75_cfa_info5383, object__struct_vector_set__app_75_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_value_set__env_250_cfa_info, _atom_cinfo_value_set_4346_19_cfa_info5384, _atom_cinfo_value_set_4346_19_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4522_cfa_info, struct_object__object_pre_make_struct_app_226_cfa_info5385, struct_object__object_pre_make_struct_app_226_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4521_cfa_info, object__struct_pre_make_struct_app_244_cfa_info5386, object__struct_pre_make_struct_app_244_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4519_cfa_info, object__struct_pre_struct_ref_app_38_cfa_info5387, object__struct_pre_struct_ref_app_38_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4520_cfa_info, struct_object__object_pre_struct_ref_app_167_cfa_info5388, struct_object__object_pre_struct_ref_app_167_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_value_env_63_cfa_info, _jump_ex_it_cinfo_value4229_147_cfa_info5389, _jump_ex_it_cinfo_value4229_147_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4518_cfa_info, struct_object__object_pre_struct_set__app_147_cfa_info5390, struct_object__object_pre_struct_set__app_147_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4517_cfa_info, object__struct_pre_struct_set__app_44_cfa_info5391, object__struct_pre_struct_set__app_44_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_loc_set__env_71_cfa_info, _scnst_cinfo_loc_set_4422_122_cfa_info5392, _scnst_cinfo_loc_set_4422_122_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4516_cfa_info, struct_object__object_make_struct_app_10_cfa_info5393, struct_object__object_make_struct_app_10_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4515_cfa_info, object__struct_make_struct_app_173_cfa_info5394, object__struct_make_struct_app_173_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_fast_alpha_set__env_176_cfa_info, _reshaped_local_fast_alpha_set_4387_79_cfa_info5395, _reshaped_local_fast_alpha_set_4387_79_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4514_cfa_info, struct_object__object_struct_ref_app_176_cfa_info5396, struct_object__object_struct_ref_app_176_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4513_cfa_info, object__struct_struct_ref_app_85_cfa_info5397, object__struct_struct_ref_app_85_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc4512_cfa_info, struct_object__object_struct_set__app_209_cfa_info5398, struct_object__object_struct_set__app_209_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc4511_cfa_info, object__struct_struct_set__app_208_cfa_info5399, object__struct_struct_set__app_208_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_type_set__env_206_cfa_info, _vector_set__app_type_set_3915_252_cfa_info5400, _vector_set__app_type_set_3915_252_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_msg_set__env_1_cfa_info, _fail_cinfo_msg_set_4260_104_cfa_info5401, _fail_cinfo_msg_set_4260_104_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_access_env_185_cfa_info, _reshaped_local_access4386_232_cfa_info5402, _reshaped_local_access4386_232_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_make_vector_app_env_23_cfa_info, _make_pre_make_vector_app4033_155_cfa_info5403, _make_pre_make_vector_app4033_155_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(reshaped_global_occurrence_env_13_cfa_info, _reshaped_global_occurrence4364_159_cfa_info5404, _reshaped_global_occurrence4364_159_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_key_set__env_27_cfa_info, _box_ref_o_cinfo_key_set__163_cfa_info5405, _box_ref_o_cinfo_key_set__163_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_var_env_225_cfa_info, _set_ex_it_cinfo_var4237_21_cfa_info5406, _set_ex_it_cinfo_var4237_21_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_seen__set__env_36_cfa_info, _make_vector_app_seen__set_3990_22_cfa_info5407, _make_vector_app_seen__set_3990_22_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_approx_env_232_cfa_info, _setq_cinfo_approx4288_114_cfa_info5408, _setq_cinfo_approx4288_114_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_jump_ex_it_cinfo_env_187_cfa_info, _allocate_jump_ex_it_cinfo_34_cfa_info5409, _allocate_jump_ex_it_cinfo_34_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_stamp_env_194_cfa_info, _create_vector_app_stack_stamp3963_42_cfa_info5410, _create_vector_app_stack_stamp3963_42_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_t_set__env_248_cfa_info, _make_procedure_app_t_set_4101_189_cfa_info5411, _make_procedure_app_t_set_4101_189_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_struct_ref_app_env_95_cfa_info, _make_pre_struct_ref_app3884_217_cfa_info5412, _make_pre_struct_ref_app3884_217_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(make_vector_app_fun_env_100_cfa_info, _make_vector_app_fun3975_121_cfa_info5413, _make_vector_app_fun3975_121_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app__env_181_cfa_info, _make_procedure_app__219_cfa_info5414, _make_procedure_app__219_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo__env_78_cfa_info, _intern_sfun_cinfo__158_cfa_info5415, _intern_sfun_cinfo__158_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_make_procedure_app_env_172_cfa_info, _allocate_make_procedure_app_241_cfa_info5416, _allocate_make_procedure_app_241_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_args_env_173_cfa_info, _pre_make_struct_app_args3908_145_cfa_info5417, _pre_make_struct_app_args3908_145_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app__env_93_cfa_info, _pre_make_struct_app__245_cfa_info5418, _pre_make_struct_app__245_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_procedure_ref_app_env_67_cfa_info, _allocate_pre_procedure_ref_app_105_cfa_info5419, _allocate_pre_procedure_ref_app_105_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app__env_230_cfa_info, _pre_vector_set__app__223_cfa_info5420, _pre_vector_set__app__223_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_args_set__env_51_cfa_info, _pre_make_procedure_app_args_set_4143_113_cfa_info5421, _pre_make_procedure_app_args_set_4143_113_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_type_set__env_245_cfa_info, _select_cinfo_type_set_4244_74_cfa_info5422, _select_cinfo_type_set_4244_74_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_stack_info_set__env_219_cfa_info, _struct_set__app_stack_info_set_3831_102_cfa_info5423, _struct_set__app_stack_info_set_3831_102_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_stamp_env_189_cfa_info, _make_procedure_app_stack_stamp4107_219_cfa_info5424, _make_procedure_app_stack_stamp4107_219_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_user__env_185_cfa_info, _reshaped_local_user_4394_145_cfa_info5425, _reshaped_local_user_4394_145_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_top__set__env_150_cfa_info, _extern_sfun_cinfo_top__set_4462_110_cfa_info5426, _extern_sfun_cinfo_top__set_4462_110_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_loc_env_182_cfa_info, _pre_procedure_ref_app_loc4121_31_cfa_info5427, _pre_procedure_ref_app_loc4121_31_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_args_set__env_236_cfa_info, _create_vector_app_args_set_3950_85_cfa_info5428, _create_vector_app_args_set_3950_85_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo__env_191_cfa_info, _pragma_cinfo__129_cfa_info5429, _pragma_cinfo__129_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_loc_env_175_cfa_info, _app_ly_cinfo_loc4319_10_cfa_info5430, _app_ly_cinfo_loc4319_10_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_clauses_env_190_cfa_info, _select_cinfo_clauses4250_19_cfa_info5431, _select_cinfo_clauses4250_19_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_make_struct_app_env_154_cfa_info, _allocate_make_struct_app_151_cfa_info5432, _allocate_make_struct_app_151_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_owner_env_155_cfa_info, _pre_make_vector_app_owner4047_141_cfa_info5433, _pre_make_vector_app_owner4047_141_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_type_set__env_224_cfa_info, _pre_create_vector_app_type_set_4019_91_cfa_info5434, _pre_create_vector_app_type_set_4019_91_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_obj_set__env_18_cfa_info, _fail_cinfo_obj_set_4262_243_cfa_info5435, _fail_cinfo_obj_set_4262_243_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_args_set__env_141_cfa_info, _intern_sfun_cinfo_args_set_4440_25_cfa_info5436, _intern_sfun_cinfo_args_set_4440_25_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_exit_env_109_cfa_info, _jump_ex_it_cinfo_exit4227_62_cfa_info5437, _jump_ex_it_cinfo_exit4227_62_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_value_env_64_cfa_info, _reshaped_global_value4356_90_cfa_info5438, _reshaped_global_value4356_90_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_type_env_147_cfa_info, _procedure_ref_app_type4066_25_cfa_info5439, _procedure_ref_app_type4066_25_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_stack_info_set__env_160_cfa_info, _vector_ref_app_stack_info_set_3937_136_cfa_info5440, _vector_ref_app_stack_info_set_3937_136_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_ref_o_cinfo_env_7_cfa_info, _make_box_ref_o_cinfo4149_10_cfa_info5441, _make_box_ref_o_cinfo4149_10_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(make_reshaped_local_env_74_cfa_info, _make_reshaped_local4377_222_cfa_info5442, _make_reshaped_local4377_222_cfa_info, 0L, 11);
DEFINE_EXPORT_PROCEDURE(make_vector_app_key_set__env_47_cfa_info, _make_vector_app_key_set__16_cfa_info5443, _make_vector_app_key_set__16_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_vector_ref_app_env_180_cfa_info, _allocate_pre_vector_ref_app_31_cfa_info5444, _allocate_pre_vector_ref_app_31_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo__env_84_cfa_info, _conditional_cinfo__117_cfa_info5445, _conditional_cinfo__117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_key_set__env_134_cfa_info, _vector_ref_app_key_set__134_cfa_info5446, _vector_ref_app_key_set__134_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_loc_env_136_cfa_info, _pre_struct_set__app_loc3873_24_cfa_info5447, _pre_struct_set__app_loc3873_24_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1043_vector_ref_app_env_46_cfa_info, _widening1043_vector_ref_app3926_75_cfa_info5448, _widening1043_vector_ref_app3926_75_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_loc_env_44_cfa_info, _scnst_cinfo_loc4423_42_cfa_info5449, _scnst_cinfo_loc4423_42_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_kwote_node_env_34_cfa_info, _make_kwote_node4335_66_cfa_info5450, _make_kwote_node4335_66_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(reshaped_global_pragma_env_183_cfa_info, _reshaped_global_pragma4374_115_cfa_info5451, _reshaped_global_pragma4374_115_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_type_set__env_222_cfa_info, _struct_ref_app_type_set_3837_191_cfa_info5452, _struct_ref_app_type_set_3837_191_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_env_252_cfa_info, _funcall_cinfo_type4304_241_cfa_info5453, _funcall_cinfo_type4304_241_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_stack_info_set__env_7_cfa_info, _pre_make_procedure_app_stack_info_set_4145_174_cfa_info5454, _pre_make_procedure_app_stack_info_set_4145_174_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_atom_cinfo_env_231_cfa_info, _allocate_atom_cinfo_64_cfa_info5455, _allocate_atom_cinfo_64_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(struct_set__app_key_set__env_81_cfa_info, _struct_set__app_key_set__192_cfa_info5456, _struct_set__app_key_set__192_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo__env_4_cfa_info, _make_box_o_cinfo__52_cfa_info5457, _make_box_o_cinfo__52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_key_set__env_133_cfa_info, _procedure_ref_app_key_set__179_cfa_info5458, _procedure_ref_app_key_set__179_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_setq_cinfo_env_69_cfa_info, _allocate_setq_cinfo_116_cfa_info5459, _allocate_setq_cinfo_116_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_side_effect__env_35_cfa_info, _cfun_cinfo_side_effect_4483_210_cfa_info5460, _cfun_cinfo_side_effect_4483_210_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_key_env_29_cfa_info, _struct_set__app_key_221_cfa_info5461, _struct_set__app_key_221_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_type_env_52_cfa_info, _conditional_cinfo_type4269_211_cfa_info5462, _conditional_cinfo_type4269_211_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_approx_env_197_cfa_info, _scnst_cinfo_approx4424_226_cfa_info5463, _scnst_cinfo_approx4424_226_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_module_env_199_cfa_info, _reshaped_global_module4365_231_cfa_info5464, _reshaped_global_module4365_231_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_value_set__env_161_cfa_info, _setq_cinfo_value_set_4286_185_cfa_info5465, _setq_cinfo_value_set_4286_185_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_set__app_side_effect__env_46_cfa_info, _vector_set__app_side_effect_3918_82_cfa_info5466, _vector_set__app_side_effect_3918_82_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app__env_223_cfa_info, _vector_ref_app__210_cfa_info5467, _vector_ref_app__210_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_conditional_cinfo_env_136_cfa_info, _allocate_conditional_cinfo_139_cfa_info5468, _allocate_conditional_cinfo_139_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_type_set__env_66_cfa_info, _make_box_o_cinfo_type_set_4191_204_cfa_info5469, _make_box_o_cinfo_type_set_4191_204_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_infix__set__env_221_cfa_info, _cfun_cinfo_infix__set_4494_96_cfa_info5470, _cfun_cinfo_infix__set_4494_96_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_occurrence_set__env_29_cfa_info, _reshaped_global_occurrence_set_4363_110_cfa_info5471, _reshaped_global_occurrence_set_4363_110_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening1014_kwote_cinfo_env_211_cfa_info, _widening1014_kwote_cinfo4327_186_cfa_info5472, _widening1014_kwote_cinfo4327_186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_set__o_cinfo_env_94_cfa_info, _allocate_box_set__o_cinfo_20_cfa_info5473, _allocate_box_set__o_cinfo_20_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_funcall_cinfo_env_104_cfa_info, _make_funcall_cinfo4301_147_cfa_info5474, _make_funcall_cinfo4301_147_cfa_info, 0L, 9);
DEFINE_EXPORT_PROCEDURE(allocate_cfun_cinfo_env_112_cfa_info, _allocate_cfun_cinfo_87_cfa_info5475, _allocate_cfun_cinfo_87_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_struct_ref_app_env_33_cfa_info, _allocate_struct_ref_app_88_cfa_info5476, _allocate_struct_ref_app_88_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_loc_env_203_cfa_info, _kwote_cinfo_loc4329_151_cfa_info5477, _kwote_cinfo_loc4329_151_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_owner_env_182_cfa_info, _pre_make_procedure_app_owner4147_18_cfa_info5478, _pre_make_procedure_app_owner4147_18_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_lost_stamp_env_81_cfa_info, _make_procedure_app_lost_stamp4096_31_cfa_info5479, _make_procedure_app_lost_stamp4096_31_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1029_box_set__o_cinfo_env_82_cfa_info, _widening1029_box_set__o_cinfo4158_92_cfa_info5480, _widening1029_box_set__o_cinfo4158_92_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_loc_env_56_cfa_info, _make_box_cinfo_loc4203_222_cfa_info5481, _make_box_cinfo_loc4203_222_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_fun_env_206_cfa_info, _pre_make_procedure_app_fun4142_229_cfa_info5482, _pre_make_procedure_app_fun4142_229_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_seen__set__env_145_cfa_info, _create_vector_app_seen__set_3964_25_cfa_info5483, _create_vector_app_seen__set_3964_25_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_side_effect__env_170_cfa_info, _pre_vector_ref_app_side_effect_4009_50_cfa_info5484, _pre_vector_ref_app_side_effect_4009_50_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_fun_set__env_18_cfa_info, _vector_set__app_fun_set_3919_16_cfa_info5485, _vector_set__app_fun_set_3919_16_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_t_env_175_cfa_info, _make_procedure_app_t4102_213_cfa_info5486, _make_procedure_app_t4102_213_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_value_env_24_cfa_info, _pre_make_box_value4220_113_cfa_info5487, _pre_make_box_value4220_113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_args_set__env_132_cfa_info, _pre_struct_ref_app_args_set_3892_26_cfa_info5488, _pre_struct_ref_app_args_set_3892_26_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo__env_187_cfa_info, _box_set__o_cinfo__123_cfa_info5489, _box_set__o_cinfo__123_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_fun_env_130_cfa_info, _pre_procedure_set__app_fun4115_173_cfa_info5490, _pre_procedure_set__app_fun4115_173_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cvar_cinfo_macro__env_3_cfa_info, _cvar_cinfo_macro_4406_52_cfa_info5491, _cvar_cinfo_macro_4406_52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_side_effect__set__env_147_cfa_info, _pre_vector_ref_app_side_effect__set_4008_64_cfa_info5492, _pre_vector_ref_app_side_effect__set_4008_64_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_approx_env_222_cfa_info, _make_procedure_app_approx4091_52_cfa_info5493, _make_procedure_app_approx4091_52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_args_env_122_cfa_info, _make_struct_app_args3859_196_cfa_info5494, _make_struct_app_args3859_196_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_approx_env_205_cfa_info, _vector_set__app_approx3925_213_cfa_info5495, _vector_set__app_approx3925_213_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_fun_set__env_215_cfa_info, _make_struct_app_fun_set_3856_97_cfa_info5496, _make_struct_app_fun_set_3856_97_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_intern_sfun_cinfo_env_207_cfa_info, _make_intern_sfun_cinfo4426_20_cfa_info5497, _make_intern_sfun_cinfo4426_20_cfa_info, 0L, 14);
DEFINE_EXPORT_PROCEDURE(widening1002_cfun_cinfo_env_36_cfa_info, _widening1002_cfun_cinfo4479_45_cfa_info5498, _widening1002_cfun_cinfo4479_45_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_arg_set__env_100_cfa_info, _app_ly_cinfo_arg_set_4324_253_cfa_info5499, _app_ly_cinfo_arg_set_4324_253_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_top__set__env_79_cfa_info, _intern_sfun_cinfo_top__set_4434_86_cfa_info5500, _intern_sfun_cinfo_top__set_4434_86_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_type_set__env_32_cfa_info, _make_struct_app_type_set_3851_13_cfa_info5501, _make_struct_app_type_set_3851_13_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_value_approx_env_50_cfa_info, _make_struct_app_value_approx3864_211_cfa_info5502, _make_struct_app_value_approx3864_211_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_key_set__env_130_cfa_info, _pre_vector_ref_app_key_set__22_cfa_info5503, _pre_vector_ref_app_key_set__22_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_lost_stamp_env_156_cfa_info, _make_vector_app_lost_stamp3984_11_cfa_info5504, _make_vector_app_lost_stamp3984_11_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_approx_env_157_cfa_info, _jump_ex_it_cinfo_approx4230_117_cfa_info5505, _jump_ex_it_cinfo_approx4230_117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_fast_alpha_set__env_178_cfa_info, _reshaped_global_fast_alpha_set_4359_174_cfa_info5506, _reshaped_global_fast_alpha_set_4359_174_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_side_effect__set__env_9_cfa_info, _create_vector_app_side_effect__set_3945_171_cfa_info5507, _create_vector_app_side_effect__set_3945_171_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_the_closure_env_139_cfa_info, _extern_sfun_cinfo_the_closure4465_235_cfa_info5508, _extern_sfun_cinfo_the_closure4465_235_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_loc_env_197_cfa_info, _atom_cinfo_loc4343_195_cfa_info5509, _atom_cinfo_loc4343_195_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_arity_env_37_cfa_info, _extern_sfun_cinfo_arity4455_205_cfa_info5510, _extern_sfun_cinfo_arity4455_205_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_type_set__env_254_cfa_info, _box_set__cinfo_type_set_4181_102_cfa_info5511, _box_set__cinfo_type_set_4181_102_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo__env_176_cfa_info, _fail_cinfo__61_cfa_info5512, _fail_cinfo__61_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_type_set__env_81_cfa_info, _pre_vector_set__app_type_set_3994_42_cfa_info5513, _pre_vector_set__app_type_set_3994_42_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_node_env_253_cfa_info, _scnst_cinfo_node4419_234_cfa_info5514, _scnst_cinfo_node4419_234_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_node_env_136_cfa_info, _kwote_node_node4340_239_cfa_info5515, _kwote_node_node4340_239_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_the_closure_set__env_223_cfa_info, _extern_sfun_cinfo_the_closure_set_4464_103_cfa_info5516, _extern_sfun_cinfo_the_closure_set_4464_103_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_side_effect__env_66_cfa_info, _pre_procedure_ref_app_side_effect_4125_202_cfa_info5517, _pre_procedure_ref_app_side_effect_4125_202_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo__env_254_cfa_info, _atom_cinfo__122_cfa_info5518, _atom_cinfo__122_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_side_effect__env_111_cfa_info, _box_ref_cinfo_side_effect_4174_28_cfa_info5519, _box_ref_cinfo_side_effect_4174_28_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app__env_97_cfa_info, _make_vector_app__161_cfa_info5520, _make_vector_app__161_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_lost_stamp_env_117_cfa_info, _approx_lost_stamp4505_172_cfa_info5521, _approx_lost_stamp4505_172_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_loc_env_19_cfa_info, _intern_sfun_cinfo_loc4449_245_cfa_info5522, _intern_sfun_cinfo_loc4449_245_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_approx_set__env_104_cfa_info, _create_vector_app_approx_set_3954_71_cfa_info5523, _create_vector_app_approx_set_3954_71_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_type_set__env_108_cfa_info, _make_box_cinfo_type_set_4204_72_cfa_info5524, _make_box_cinfo_type_set_4204_72_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_set__app_env_158_cfa_info, _make_struct_set__app3821_217_cfa_info5525, _make_struct_set__app3821_217_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_fun_env_154_cfa_info, _procedure_ref_app_fun4070_3_cfa_info5526, _procedure_ref_app_fun4070_3_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_fun_set__env_81_cfa_info, _create_vector_app_fun_set_3948_68_cfa_info5527, _create_vector_app_fun_set_3948_68_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_set__env_171_cfa_info, _funcall_cinfo_type_set_4303_21_cfa_info5528, _funcall_cinfo_type_set_4303_21_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_side_effect__set__env_147_cfa_info, _pre_procedure_set__app_side_effect__set_4112_183_cfa_info5529, _pre_procedure_set__app_side_effect__set_4112_183_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_type_env_96_cfa_info, _pre_procedure_ref_app_type4123_8_cfa_info5530, _pre_procedure_ref_app_type4123_8_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_lost_stamp_env_34_cfa_info, _make_struct_app_lost_stamp3866_30_cfa_info5531, _make_struct_app_lost_stamp3866_30_cfa_info, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_side_effect__env_139_cfa_info, _pre_create_vector_app_side_effect_4022_243_cfa_info5532, _pre_create_vector_app_side_effect_4022_243_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1003_extern_sfun_cinfo_env_139_cfa_info, _widening1003_extern_sfun_cinfo4453_165_cfa_info5533, _widening1003_extern_sfun_cinfo4453_165_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_funcall_cinfo_env_186_cfa_info, _allocate_funcall_cinfo_40_cfa_info5534, _allocate_funcall_cinfo_40_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_key_env_143_cfa_info, _make_box_o_cinfo_key4195_188_cfa_info5535, _make_box_o_cinfo_key4195_188_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_approx_set__env_254_cfa_info, _make_procedure_app_approx_set_4090_181_cfa_info5536, _make_procedure_app_approx_set_4090_181_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_key_env_98_cfa_info, _reshaped_local_key4395_20_cfa_info5537, _reshaped_local_key4395_20_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_approx_env_156_cfa_info, _select_cinfo_approx4252_199_cfa_info5538, _select_cinfo_approx4252_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_app_ly_cinfo_env_68_cfa_info, _allocate_app_ly_cinfo_17_cfa_info5539, _allocate_app_ly_cinfo_17_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo__env_241_cfa_info, _box_ref_cinfo__65_cfa_info5540, _box_ref_cinfo__65_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_type_env_77_cfa_info, _app_ly_cinfo_type4321_85_cfa_info5541, _app_ly_cinfo_type4321_85_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1011_reshaped_global_env_188_cfa_info, _widening1011_reshaped_global_101_cfa_info5542, _widening1011_reshaped_global_101_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(setq_cinfo__env_100_cfa_info, _setq_cinfo__245_cfa_info5543, _setq_cinfo__245_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_type_set__env_32_cfa_info, _box_ref_cinfo_type_set_4171_142_cfa_info5544, _box_ref_cinfo_type_set_4171_142_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_lost_stamp_set__env_29_cfa_info, _create_vector_app_lost_stamp_set_3957_3_cfa_info5545, _create_vector_app_lost_stamp_set_3957_3_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_key_env_15_cfa_info, _pre_struct_ref_app_key_126_cfa_info5546, _pre_struct_ref_app_key_126_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_side_effect__set__env_174_cfa_info, _box_ref_cinfo_side_effect__set_4173_191_cfa_info5547, _box_ref_cinfo_side_effect__set_4173_191_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_id_env_184_cfa_info, _reshaped_local_id4378_67_cfa_info5548, _reshaped_local_id4378_67_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_import_set__env_187_cfa_info, _reshaped_global_import_set_4366_139_cfa_info5549, _reshaped_global_import_set_4366_139_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_library__env_20_cfa_info, _reshaped_global_library_4371_56_cfa_info5550, _reshaped_global_library_4371_56_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_fast_alpha_env_204_cfa_info, _reshaped_global_fast_alpha4360_7_cfa_info5551, _reshaped_global_fast_alpha4360_7_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening1012_atom_cinfo_env_240_cfa_info, _widening1012_atom_cinfo4341_187_cfa_info5552, _widening1012_atom_cinfo4341_187_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_vector_set__app_env_252_cfa_info, _make_pre_vector_set__app3992_134_cfa_info5553, _make_pre_vector_set__app3992_134_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(vector_set__app_loc_env_177_cfa_info, _vector_set__app_loc3914_162_cfa_info5554, _vector_set__app_loc3914_162_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_fun_set__env_114_cfa_info, _pre_procedure_ref_app_fun_set_4126_166_cfa_info5555, _pre_procedure_ref_app_fun_set_4126_166_cfa_info, 0L, 2);


/* module-initialization */ obj_t 
module_initialization_70_cfa_info(long checksum_10626, char *from_10627)
{
   if (CBOOL(require_initialization_114_cfa_info))
     {
	require_initialization_114_cfa_info = BBOOL(((bool_t) 0));
	library_modules_init_112_cfa_info();
	cnst_init_137_cfa_info();
	imported_modules_init_94_cfa_info();
	object_init_111_cfa_info();
	method_init_76_cfa_info();
	toplevel_init_63_cfa_info();
	return BUNSPEC;
     }
   else
     {
	return BUNSPEC;
     }
}


/* library-modules-init */ obj_t 
library_modules_init_112_cfa_info()
{
   module_initialization_70___object(((long) 0), "CFA_INFO");
   module_initialization_70___reader(((long) 0), "CFA_INFO");
   return BUNSPEC;
}


/* cnst-init */ obj_t 
cnst_init_137_cfa_info()
{
   {
      obj_t cnst_port_138_10618;
      cnst_port_138_10618 = open_input_string(string4611_cfa_info);
      {
	 long i_10619;
	 i_10619 = ((long) 50);
       loop_10620:
	 {
	    bool_t test4612_10621;
	    test4612_10621 = (i_10619 == ((long) -1));
	    if (test4612_10621)
	      {
		 return BUNSPEC;
	      }
	    else
	      {
		 {
		    obj_t arg4613_10622;
		    {
		       obj_t list4614_10623;
		       {
			  obj_t arg4615_10624;
			  arg4615_10624 = BNIL;
			  list4614_10623 = MAKE_PAIR(cnst_port_138_10618, arg4615_10624);
		       }
		       arg4613_10622 = read___reader(list4614_10623);
		    }
		    CNST_TABLE_SET(i_10619, arg4613_10622);
		 }
		 {
		    int aux_10625;
		    {
		       long aux_10645;
		       aux_10645 = (i_10619 - ((long) 1));
		       aux_10625 = (int) (aux_10645);
		    }
		    {
		       long i_10648;
		       i_10648 = (long) (aux_10625);
		       i_10619 = i_10648;
		       goto loop_10620;
		    }
		 }
	      }
	 }
      }
   }
}


/* toplevel-init */ obj_t 
toplevel_init_63_cfa_info()
{
   return BUNSPEC;
}


/* object-init */ obj_t 
object_init_111_cfa_info()
{
   {
      obj_t arg2596_2245;
      arg2596_2245 = object___object;
      approx_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 0)), arg2596_2245, allocate_approx_env_171_cfa_info, ((long) 41446), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2600_2249;
      arg2600_2249 = cfun_ast_var;
      cfun_cinfo_200_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 1)), arg2600_2249, allocate_cfun_cinfo_env_112_cfa_info, ((long) 36674), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2605_2253;
      arg2605_2253 = sfun_ast_var;
      extern_sfun_cinfo_6_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 2)), arg2605_2253, allocate_extern_sfun_cinfo_env_126_cfa_info, ((long) 31309), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2609_2257;
      arg2609_2257 = sfun_ast_var;
      intern_sfun_cinfo_192_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 3)), arg2609_2257, allocate_intern_sfun_cinfo_env_101_cfa_info, ((long) 40550), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2613_2261;
      arg2613_2261 = scnst_ast_var;
      scnst_cinfo_0_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 4)), arg2613_2261, allocate_scnst_cinfo_env_108_cfa_info, ((long) 27137), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2617_2265;
      arg2617_2265 = svar_ast_var;
      pre_clo_env_191_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 5)), arg2617_2265, allocate_pre_clo_env_env_170_cfa_info, ((long) 43896), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2621_2269;
      arg2621_2269 = svar_ast_var;
      svar_cinfo_166_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 6)), arg2621_2269, allocate_svar_cinfo_env_152_cfa_info, ((long) 42337), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2625_2273;
      arg2625_2273 = cvar_ast_var;
      cvar_cinfo_53_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 7)), arg2625_2273, allocate_cvar_cinfo_env_84_cfa_info, ((long) 20194), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2629_2277;
      arg2629_2277 = sexit_ast_var;
      sexit_cinfo_49_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 8)), arg2629_2277, allocate_sexit_cinfo_env_157_cfa_info, ((long) 41891), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2633_2281;
      arg2633_2281 = local_ast_var;
      reshaped_local_224_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 9)), arg2633_2281, allocate_reshaped_local_env_189_cfa_info, ((long) 23233), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2638_2285;
      arg2638_2285 = global_ast_var;
      reshaped_global_160_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 10)), arg2638_2285, allocate_reshaped_global_env_91_cfa_info, ((long) 40250), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2643_2289;
      arg2643_2289 = atom_ast_node;
      atom_cinfo_155_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 11)), arg2643_2289, allocate_atom_cinfo_env_231_cfa_info, ((long) 53911), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2647_2293;
      arg2647_2293 = kwote_ast_node;
      kwote_node_102_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 12)), arg2647_2293, allocate_kwote_node_env_116_cfa_info, ((long) 22839), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2651_2297;
      arg2651_2297 = kwote_ast_node;
      kwote_cinfo_48_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 13)), arg2651_2297, allocate_kwote_cinfo_env_199_cfa_info, ((long) 46904), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2655_2301;
      arg2655_2301 = app_ly_162_ast_node;
      app_ly_cinfo_234_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 14)), arg2655_2301, allocate_app_ly_cinfo_env_68_cfa_info, ((long) 25505), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2659_2305;
      arg2659_2305 = funcall_ast_node;
      funcall_cinfo_75_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 15)), arg2659_2305, allocate_funcall_cinfo_env_186_cfa_info, ((long) 58558), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2663_2309;
      arg2663_2309 = pragma_ast_node;
      pragma_cinfo_220_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 16)), arg2663_2309, allocate_pragma_cinfo_env_199_cfa_info, ((long) 62814), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2667_2313;
      arg2667_2313 = setq_ast_node;
      setq_cinfo_191_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 17)), arg2667_2313, allocate_setq_cinfo_env_69_cfa_info, ((long) 8475), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2671_2317;
      arg2671_2317 = conditional_ast_node;
      conditional_cinfo_212_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 18)), arg2671_2317, allocate_conditional_cinfo_env_136_cfa_info, ((long) 36034), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2676_2321;
      arg2676_2321 = fail_ast_node;
      fail_cinfo_75_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 19)), arg2676_2321, allocate_fail_cinfo_env_67_cfa_info, ((long) 3770), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2680_2325;
      arg2680_2325 = select_ast_node;
      select_cinfo_150_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 20)), arg2680_2325, allocate_select_cinfo_env_166_cfa_info, ((long) 43814), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2685_2329;
      arg2685_2329 = set_ex_it_116_ast_node;
      set_ex_it_cinfo_168_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 21)), arg2685_2329, allocate_set_ex_it_cinfo_env_250_cfa_info, ((long) 24110), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2690_2333;
      arg2690_2333 = jump_ex_it_184_ast_node;
      jump_ex_it_cinfo_139_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 22)), arg2690_2333, allocate_jump_ex_it_cinfo_env_187_cfa_info, ((long) 24206), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2694_2337;
      arg2694_2337 = make_box_202_ast_node;
      pre_make_box_186_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 23)), arg2694_2337, allocate_pre_make_box_env_176_cfa_info, ((long) 11008), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2698_2341;
      arg2698_2341 = make_box_202_ast_node;
      make_box_cinfo_127_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 24)), arg2698_2341, allocate_make_box_cinfo_env_36_cfa_info, ((long) 60506), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2702_2345;
      arg2702_2345 = make_box_202_ast_node;
      make_box_o_cinfo_96_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 25)), arg2702_2345, allocate_make_box_o_cinfo_env_97_cfa_info, ((long) 43380), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2706_2349;
      arg2706_2349 = box_set__221_ast_node;
      box_set__cinfo_94_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 26)), arg2706_2349, allocate_box_set__cinfo_env_96_cfa_info, ((long) 3505), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2710_2353;
      arg2710_2353 = box_ref_242_ast_node;
      box_ref_cinfo_214_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 27)), arg2710_2353, allocate_box_ref_cinfo_env_99_cfa_info, ((long) 51073), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2714_2357;
      arg2714_2357 = box_set__221_ast_node;
      box_set__o_cinfo_6_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 28)), arg2714_2357, allocate_box_set__o_cinfo_env_94_cfa_info, ((long) 17669), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2718_2361;
      arg2718_2361 = box_ref_242_ast_node;
      box_ref_o_cinfo_98_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 29)), arg2718_2361, allocate_box_ref_o_cinfo_env_184_cfa_info, ((long) 28245), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2724_2365;
      arg2724_2365 = app_ast_node;
      pre_make_procedure_app_60_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 30)), arg2724_2365, allocate_pre_make_procedure_app_env_235_cfa_info, ((long) 58299), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2728_2369;
      arg2728_2369 = app_ast_node;
      pre_procedure_ref_app_85_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 31)), arg2728_2369, allocate_pre_procedure_ref_app_env_67_cfa_info, ((long) 29725), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2732_2373;
      arg2732_2373 = app_ast_node;
      pre_procedure_set__app_208_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 32)), arg2732_2373, allocate_pre_procedure_set__app_env_247_cfa_info, ((long) 15565), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2736_2377;
      arg2736_2377 = app_ast_node;
      make_procedure_app_48_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 33)), arg2736_2377, allocate_make_procedure_app_env_172_cfa_info, ((long) 5541), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2740_2381;
      arg2740_2381 = app_ast_node;
      procedure_ref_app_49_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 34)), arg2740_2381, allocate_procedure_ref_app_env_35_cfa_info, ((long) 6233), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2744_2385;
      arg2744_2385 = app_ast_node;
      procedure_set__app_32_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 35)), arg2744_2385, allocate_procedure_set__app_env_74_cfa_info, ((long) 39689), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2748_2389;
      arg2748_2389 = app_ast_node;
      pre_make_vector_app_251_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 36)), arg2748_2389, allocate_pre_make_vector_app_env_198_cfa_info, ((long) 52733), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2752_2393;
      arg2752_2393 = app_ast_node;
      pre_create_vector_app_162_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 37)), arg2752_2393, allocate_pre_create_vector_app_env_147_cfa_info, ((long) 6683), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2756_2397;
      arg2756_2397 = app_ast_node;
      pre_vector_ref_app_208_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 38)), arg2756_2397, allocate_pre_vector_ref_app_env_180_cfa_info, ((long) 12767), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2760_2401;
      arg2760_2401 = app_ast_node;
      pre_vector_set__app_211_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 39)), arg2760_2401, allocate_pre_vector_set__app_env_49_cfa_info, ((long) 59551), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2764_2405;
      arg2764_2405 = app_ast_node;
      make_vector_app_205_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 40)), arg2764_2405, allocate_make_vector_app_env_222_cfa_info, ((long) 9488), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2768_2409;
      arg2768_2409 = app_ast_node;
      create_vector_app_150_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 41)), arg2768_2409, allocate_create_vector_app_env_133_cfa_info, ((long) 46782), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2772_2413;
      arg2772_2413 = app_ast_node;
      vector_ref_app_195_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 42)), arg2772_2413, allocate_vector_ref_app_env_93_cfa_info, ((long) 12027), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2776_2417;
      arg2776_2417 = app_ast_node;
      vector_set__app_21_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 43)), arg2776_2417, allocate_vector_set__app_env_178_cfa_info, ((long) 54427), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2780_2421;
      arg2780_2421 = app_ast_node;
      pre_make_struct_app_218_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 44)), arg2780_2421, allocate_pre_make_struct_app_env_41_cfa_info, ((long) 59951), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2784_2425;
      arg2784_2425 = app_ast_node;
      pre_struct_ref_app_207_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 45)), arg2784_2425, allocate_pre_struct_ref_app_env_84_cfa_info, ((long) 2929), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2788_2429;
      arg2788_2429 = app_ast_node;
      pre_struct_set__app_116_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 46)), arg2788_2429, allocate_pre_struct_set__app_env_196_cfa_info, ((long) 36545), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2792_2433;
      arg2792_2433 = app_ast_node;
      make_struct_app_214_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 47)), arg2792_2433, allocate_make_struct_app_env_154_cfa_info, ((long) 19688), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2796_2437;
      arg2796_2437 = app_ast_node;
      struct_ref_app_73_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 48)), arg2796_2437, allocate_struct_ref_app_env_33_cfa_info, ((long) 1901), BUNSPEC, BFALSE);
   }
   {
      obj_t arg2800_2441;
      arg2800_2441 = app_ast_node;
      struct_set__app_162_cfa_info = add_class__117___object(CNST_TABLE_REF(((long) 49)), arg2800_2441, allocate_struct_set__app_env_221_cfa_info, ((long) 32509), BUNSPEC, BFALSE);
   }
   return BUNSPEC;
}


/* allocate-struct-set!-app */ app_t 
allocate_struct_set__app_3_cfa_info()
{
   {
      app_t new2393_2444;
      new2393_2444 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2803_2445;
	 arg2803_2445 = class_num_218___object(struct_set__app_162_cfa_info);
	 {
	    obj_t obj_4527;
	    obj_4527 = (obj_t) (new2393_2444);
	    (((obj_t) CREF(obj_4527))->header = MAKE_HEADER(arg2803_2445, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10754;
	 aux_10754 = (object_t) (new2393_2444);
	 OBJECT_WIDENING_SET(aux_10754, BFALSE);
      }
      return new2393_2444;
   }
}


/* _allocate-struct-set!-app */ obj_t 
_allocate_struct_set__app_138_cfa_info(obj_t env_8070)
{
   {
      app_t aux_10757;
      aux_10757 = allocate_struct_set__app_3_cfa_info();
      return (obj_t) (aux_10757);
   }
}


/* struct-set!-app? */ bool_t 
struct_set__app__191_cfa_info(obj_t obj_4)
{
   return is_a__118___object(obj_4, struct_set__app_162_cfa_info);
}


/* _struct-set!-app? */ obj_t 
_struct_set__app__165_cfa_info(obj_t env_8071, obj_t obj_8072)
{
   {
      bool_t aux_10761;
      aux_10761 = struct_set__app__191_cfa_info(obj_8072);
      return BBOOL(aux_10761);
   }
}


/* widening1050-struct-set!-app */ struct_set__app_162_t 
widening1050_struct_set__app_76_cfa_info(approx_t approx_5)
{
   {
      struct_set__app_162_t new2382_4529;
      new2382_4529 = ((struct_set__app_162_t) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
      ((((struct_set__app_162_t) CREF(new2382_4529))->approx) = ((approx_t) approx_5), BUNSPEC);
      return new2382_4529;
   }
}


/* _widening1050-struct-set!-app3820 */ obj_t 
_widening1050_struct_set__app3820_227_cfa_info(obj_t env_8073, obj_t approx_8074)
{
   {
      struct_set__app_162_t aux_10766;
      aux_10766 = widening1050_struct_set__app_76_cfa_info((approx_t) (approx_8074));
      return (obj_t) (aux_10766);
   }
}


/* make-struct-set!-app */ struct_set__app_162_t 
make_struct_set__app_96_cfa_info(obj_t loc_6, type_t type_7, obj_t side_effect__165_8, obj_t key_9, var_t fun_10, obj_t args_11, obj_t stack_info_255_12, approx_t approx_13)
{
   {
      app_t aux2385_4531;
      {
	 app_t res3672_4553;
	 {
	    app_t new1289_4542;
	    new1289_4542 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4543;
	       arg2999_4543 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4551;
		  obj_4551 = (obj_t) (new1289_4542);
		  (((obj_t) CREF(obj_4551))->header = MAKE_HEADER(arg2999_4543, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_10774;
	       aux_10774 = (object_t) (new1289_4542);
	       OBJECT_WIDENING_SET(aux_10774, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4542))->loc) = ((obj_t) loc_6), BUNSPEC);
	    ((((app_t) CREF(new1289_4542))->type) = ((type_t) type_7), BUNSPEC);
	    ((((app_t) CREF(new1289_4542))->side_effect__165) = ((obj_t) side_effect__165_8), BUNSPEC);
	    ((((app_t) CREF(new1289_4542))->key) = ((obj_t) key_9), BUNSPEC);
	    ((((app_t) CREF(new1289_4542))->fun) = ((var_t) fun_10), BUNSPEC);
	    ((((app_t) CREF(new1289_4542))->args) = ((obj_t) args_11), BUNSPEC);
	    ((((app_t) CREF(new1289_4542))->stack_info_255) = ((obj_t) stack_info_255_12), BUNSPEC);
	    res3672_4553 = new1289_4542;
	 }
	 aux2385_4531 = res3672_4553;
      }
      {
	 struct_set__app_162_t new2386_4532;
	 new2386_4532 = ((struct_set__app_162_t) (aux2385_4531));
	 {
	    long arg2804_4533;
	    arg2804_4533 = class_num_218___object(struct_set__app_162_cfa_info);
	    {
	       obj_t obj_4554;
	       obj_4554 = (obj_t) (new2386_4532);
	       (((obj_t) CREF(obj_4554))->header = MAKE_HEADER(arg2804_4533, 0), BUNSPEC);
	    }
	 }
	 {
	    struct_set__app_162_t arg2805_4534;
	    {
	       struct_set__app_162_t res3673_4559;
	       {
		  struct_set__app_162_t new2382_4557;
		  new2382_4557 = ((struct_set__app_162_t) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
		  ((((struct_set__app_162_t) CREF(new2382_4557))->approx) = ((approx_t) approx_13), BUNSPEC);
		  res3673_4559 = new2382_4557;
	       }
	       arg2805_4534 = res3673_4559;
	    }
	    {
	       obj_t aux_10792;
	       object_t aux_10790;
	       aux_10792 = (obj_t) (arg2805_4534);
	       aux_10790 = (object_t) (new2386_4532);
	       OBJECT_WIDENING_SET(aux_10790, aux_10792);
	    }
	 }
	 return new2386_4532;
      }
   }
}


/* _make-struct-set!-app3821 */ obj_t 
_make_struct_set__app3821_217_cfa_info(obj_t env_8075, obj_t loc_8076, obj_t type_8077, obj_t side_effect__165_8078, obj_t key_8079, obj_t fun_8080, obj_t args_8081, obj_t stack_info_255_8082, obj_t approx_8083)
{
   {
      struct_set__app_162_t aux_10795;
      aux_10795 = make_struct_set__app_96_cfa_info(loc_8076, (type_t) (type_8077), side_effect__165_8078, key_8079, (var_t) (fun_8080), args_8081, stack_info_255_8082, (approx_t) (approx_8083));
      return (obj_t) (aux_10795);
   }
}


/* struct-set!-app-loc */ obj_t 
struct_set__app_loc_83_cfa_info(app_t obj_14)
{
   return (((app_t) CREF(obj_14))->loc);
}


/* _struct-set!-app-loc3822 */ obj_t 
_struct_set__app_loc3822_188_cfa_info(obj_t env_8084, obj_t obj_8085)
{
   return struct_set__app_loc_83_cfa_info((app_t) (obj_8085));
}


/* struct-set!-app-type-set! */ obj_t 
struct_set__app_type_set__172_cfa_info(app_t obj_15, type_t val2387_16)
{
   return ((((app_t) CREF(obj_15))->type) = ((type_t) val2387_16), BUNSPEC);
}


/* _struct-set!-app-type-set!3823 */ obj_t 
_struct_set__app_type_set_3823_57_cfa_info(obj_t env_8086, obj_t obj_8087, obj_t val2387_8088)
{
   return struct_set__app_type_set__172_cfa_info((app_t) (obj_8087), (type_t) (val2387_8088));
}


/* struct-set!-app-type */ type_t 
struct_set__app_type_138_cfa_info(app_t obj_17)
{
   return (((app_t) CREF(obj_17))->type);
}


/* _struct-set!-app-type3824 */ obj_t 
_struct_set__app_type3824_132_cfa_info(obj_t env_8089, obj_t obj_8090)
{
   {
      type_t aux_10809;
      aux_10809 = struct_set__app_type_138_cfa_info((app_t) (obj_8090));
      return (obj_t) (aux_10809);
   }
}


/* struct-set!-app-side-effect?-set! */ obj_t 
struct_set__app_side_effect__set__203_cfa_info(app_t obj_18, obj_t val2388_19)
{
   return ((((app_t) CREF(obj_18))->side_effect__165) = ((obj_t) val2388_19), BUNSPEC);
}


/* _struct-set!-app-side-effect?-set!3825 */ obj_t 
_struct_set__app_side_effect__set_3825_156_cfa_info(obj_t env_8091, obj_t obj_8092, obj_t val2388_8093)
{
   return struct_set__app_side_effect__set__203_cfa_info((app_t) (obj_8092), val2388_8093);
}


/* struct-set!-app-side-effect? */ obj_t 
struct_set__app_side_effect__159_cfa_info(app_t obj_20)
{
   return (((app_t) CREF(obj_20))->side_effect__165);
}


/* _struct-set!-app-side-effect?3826 */ obj_t 
_struct_set__app_side_effect_3826_199_cfa_info(obj_t env_8094, obj_t obj_8095)
{
   return struct_set__app_side_effect__159_cfa_info((app_t) (obj_8095));
}


/* struct-set!-app-key-set! */ obj_t 
struct_set__app_key_set__58_cfa_info(app_t obj_21, obj_t val2389_22)
{
   return ((((app_t) CREF(obj_21))->key) = ((obj_t) val2389_22), BUNSPEC);
}


/* _struct-set!-app-key-set! */ obj_t 
_struct_set__app_key_set__192_cfa_info(obj_t env_8096, obj_t obj_8097, obj_t val2389_8098)
{
   return struct_set__app_key_set__58_cfa_info((app_t) (obj_8097), val2389_8098);
}


/* struct-set!-app-key */ obj_t 
struct_set__app_key_92_cfa_info(app_t obj_23)
{
   return (((app_t) CREF(obj_23))->key);
}


/* _struct-set!-app-key */ obj_t 
_struct_set__app_key_221_cfa_info(obj_t env_8099, obj_t obj_8100)
{
   return struct_set__app_key_92_cfa_info((app_t) (obj_8100));
}


/* struct-set!-app-fun-set! */ obj_t 
struct_set__app_fun_set__208_cfa_info(app_t obj_24, var_t val2390_25)
{
   return ((((app_t) CREF(obj_24))->fun) = ((var_t) val2390_25), BUNSPEC);
}


/* _struct-set!-app-fun-set!3827 */ obj_t 
_struct_set__app_fun_set_3827_17_cfa_info(obj_t env_8101, obj_t obj_8102, obj_t val2390_8103)
{
   return struct_set__app_fun_set__208_cfa_info((app_t) (obj_8102), (var_t) (val2390_8103));
}


/* struct-set!-app-fun */ var_t 
struct_set__app_fun_107_cfa_info(app_t obj_26)
{
   return (((app_t) CREF(obj_26))->fun);
}


/* _struct-set!-app-fun3828 */ obj_t 
_struct_set__app_fun3828_168_cfa_info(obj_t env_8104, obj_t obj_8105)
{
   {
      var_t aux_10830;
      aux_10830 = struct_set__app_fun_107_cfa_info((app_t) (obj_8105));
      return (obj_t) (aux_10830);
   }
}


/* struct-set!-app-args-set! */ obj_t 
struct_set__app_args_set__3_cfa_info(app_t obj_27, obj_t val2391_28)
{
   return ((((app_t) CREF(obj_27))->args) = ((obj_t) val2391_28), BUNSPEC);
}


/* _struct-set!-app-args-set!3829 */ obj_t 
_struct_set__app_args_set_3829_39_cfa_info(obj_t env_8106, obj_t obj_8107, obj_t val2391_8108)
{
   return struct_set__app_args_set__3_cfa_info((app_t) (obj_8107), val2391_8108);
}


/* struct-set!-app-args */ obj_t 
struct_set__app_args_163_cfa_info(app_t obj_29)
{
   return (((app_t) CREF(obj_29))->args);
}


/* _struct-set!-app-args3830 */ obj_t 
_struct_set__app_args3830_80_cfa_info(obj_t env_8109, obj_t obj_8110)
{
   return struct_set__app_args_163_cfa_info((app_t) (obj_8110));
}


/* struct-set!-app-stack-info-set! */ obj_t 
struct_set__app_stack_info_set__211_cfa_info(app_t obj_30, obj_t val2392_31)
{
   return ((((app_t) CREF(obj_30))->stack_info_255) = ((obj_t) val2392_31), BUNSPEC);
}


/* _struct-set!-app-stack-info-set!3831 */ obj_t 
_struct_set__app_stack_info_set_3831_102_cfa_info(obj_t env_8111, obj_t obj_8112, obj_t val2392_8113)
{
   return struct_set__app_stack_info_set__211_cfa_info((app_t) (obj_8112), val2392_8113);
}


/* struct-set!-app-stack-info */ obj_t 
struct_set__app_stack_info_137_cfa_info(app_t obj_32)
{
   return (((app_t) CREF(obj_32))->stack_info_255);
}


/* _struct-set!-app-stack-info3832 */ obj_t 
_struct_set__app_stack_info3832_186_cfa_info(obj_t env_8114, obj_t obj_8115)
{
   return struct_set__app_stack_info_137_cfa_info((app_t) (obj_8115));
}


/* struct-set!-app-approx */ approx_t 
struct_set__app_approx_154_cfa_info(struct_set__app_162_t obj_33)
{
   {
      obj_t aux_10846;
      {
	 object_t aux_10847;
	 aux_10847 = (object_t) (obj_33);
	 aux_10846 = OBJECT_WIDENING(aux_10847);
      }
      return (((struct_set__app_162_t) CREF(aux_10846))->approx);
   }
}


/* _struct-set!-app-approx3833 */ obj_t 
_struct_set__app_approx3833_191_cfa_info(obj_t env_8116, obj_t obj_8117)
{
   {
      approx_t aux_10851;
      aux_10851 = struct_set__app_approx_154_cfa_info((struct_set__app_162_t) (obj_8117));
      return (obj_t) (aux_10851);
   }
}


/* allocate-struct-ref-app */ app_t 
allocate_struct_ref_app_224_cfa_info()
{
   {
      app_t new2375_2452;
      new2375_2452 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2806_2453;
	 arg2806_2453 = class_num_218___object(struct_ref_app_73_cfa_info);
	 {
	    obj_t obj_4560;
	    obj_4560 = (obj_t) (new2375_2452);
	    (((obj_t) CREF(obj_4560))->header = MAKE_HEADER(arg2806_2453, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10859;
	 aux_10859 = (object_t) (new2375_2452);
	 OBJECT_WIDENING_SET(aux_10859, BFALSE);
      }
      return new2375_2452;
   }
}


/* _allocate-struct-ref-app */ obj_t 
_allocate_struct_ref_app_88_cfa_info(obj_t env_8069)
{
   {
      app_t aux_10862;
      aux_10862 = allocate_struct_ref_app_224_cfa_info();
      return (obj_t) (aux_10862);
   }
}


/* struct-ref-app? */ bool_t 
struct_ref_app__100_cfa_info(obj_t obj_37)
{
   return is_a__118___object(obj_37, struct_ref_app_73_cfa_info);
}


/* _struct-ref-app? */ obj_t 
_struct_ref_app__47_cfa_info(obj_t env_8118, obj_t obj_8119)
{
   {
      bool_t aux_10866;
      aux_10866 = struct_ref_app__100_cfa_info(obj_8119);
      return BBOOL(aux_10866);
   }
}


/* widening1049-struct-ref-app */ struct_ref_app_73_t 
widening1049_struct_ref_app_102_cfa_info(approx_t approx_38)
{
   {
      struct_ref_app_73_t new2364_4562;
      new2364_4562 = ((struct_ref_app_73_t) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
      ((((struct_ref_app_73_t) CREF(new2364_4562))->approx) = ((approx_t) approx_38), BUNSPEC);
      return new2364_4562;
   }
}


/* _widening1049-struct-ref-app3834 */ obj_t 
_widening1049_struct_ref_app3834_218_cfa_info(obj_t env_8120, obj_t approx_8121)
{
   {
      struct_ref_app_73_t aux_10871;
      aux_10871 = widening1049_struct_ref_app_102_cfa_info((approx_t) (approx_8121));
      return (obj_t) (aux_10871);
   }
}


/* make-struct-ref-app */ struct_ref_app_73_t 
make_struct_ref_app_97_cfa_info(obj_t loc_39, type_t type_40, obj_t side_effect__165_41, obj_t key_42, var_t fun_43, obj_t args_44, obj_t stack_info_255_45, approx_t approx_46)
{
   {
      app_t aux2367_4564;
      {
	 app_t res3674_4586;
	 {
	    app_t new1289_4575;
	    new1289_4575 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4576;
	       arg2999_4576 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4584;
		  obj_4584 = (obj_t) (new1289_4575);
		  (((obj_t) CREF(obj_4584))->header = MAKE_HEADER(arg2999_4576, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_10879;
	       aux_10879 = (object_t) (new1289_4575);
	       OBJECT_WIDENING_SET(aux_10879, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4575))->loc) = ((obj_t) loc_39), BUNSPEC);
	    ((((app_t) CREF(new1289_4575))->type) = ((type_t) type_40), BUNSPEC);
	    ((((app_t) CREF(new1289_4575))->side_effect__165) = ((obj_t) side_effect__165_41), BUNSPEC);
	    ((((app_t) CREF(new1289_4575))->key) = ((obj_t) key_42), BUNSPEC);
	    ((((app_t) CREF(new1289_4575))->fun) = ((var_t) fun_43), BUNSPEC);
	    ((((app_t) CREF(new1289_4575))->args) = ((obj_t) args_44), BUNSPEC);
	    ((((app_t) CREF(new1289_4575))->stack_info_255) = ((obj_t) stack_info_255_45), BUNSPEC);
	    res3674_4586 = new1289_4575;
	 }
	 aux2367_4564 = res3674_4586;
      }
      {
	 struct_ref_app_73_t new2368_4565;
	 new2368_4565 = ((struct_ref_app_73_t) (aux2367_4564));
	 {
	    long arg2807_4566;
	    arg2807_4566 = class_num_218___object(struct_ref_app_73_cfa_info);
	    {
	       obj_t obj_4587;
	       obj_4587 = (obj_t) (new2368_4565);
	       (((obj_t) CREF(obj_4587))->header = MAKE_HEADER(arg2807_4566, 0), BUNSPEC);
	    }
	 }
	 {
	    struct_ref_app_73_t arg2808_4567;
	    {
	       struct_ref_app_73_t res3675_4592;
	       {
		  struct_ref_app_73_t new2364_4590;
		  new2364_4590 = ((struct_ref_app_73_t) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
		  ((((struct_ref_app_73_t) CREF(new2364_4590))->approx) = ((approx_t) approx_46), BUNSPEC);
		  res3675_4592 = new2364_4590;
	       }
	       arg2808_4567 = res3675_4592;
	    }
	    {
	       obj_t aux_10897;
	       object_t aux_10895;
	       aux_10897 = (obj_t) (arg2808_4567);
	       aux_10895 = (object_t) (new2368_4565);
	       OBJECT_WIDENING_SET(aux_10895, aux_10897);
	    }
	 }
	 return new2368_4565;
      }
   }
}


/* _make-struct-ref-app3835 */ obj_t 
_make_struct_ref_app3835_139_cfa_info(obj_t env_8122, obj_t loc_8123, obj_t type_8124, obj_t side_effect__165_8125, obj_t key_8126, obj_t fun_8127, obj_t args_8128, obj_t stack_info_255_8129, obj_t approx_8130)
{
   {
      struct_ref_app_73_t aux_10900;
      aux_10900 = make_struct_ref_app_97_cfa_info(loc_8123, (type_t) (type_8124), side_effect__165_8125, key_8126, (var_t) (fun_8127), args_8128, stack_info_255_8129, (approx_t) (approx_8130));
      return (obj_t) (aux_10900);
   }
}


/* struct-ref-app-loc */ obj_t 
struct_ref_app_loc_11_cfa_info(app_t obj_47)
{
   return (((app_t) CREF(obj_47))->loc);
}


/* _struct-ref-app-loc3836 */ obj_t 
_struct_ref_app_loc3836_68_cfa_info(obj_t env_8131, obj_t obj_8132)
{
   return struct_ref_app_loc_11_cfa_info((app_t) (obj_8132));
}


/* struct-ref-app-type-set! */ obj_t 
struct_ref_app_type_set__226_cfa_info(app_t obj_48, type_t val2369_49)
{
   return ((((app_t) CREF(obj_48))->type) = ((type_t) val2369_49), BUNSPEC);
}


/* _struct-ref-app-type-set!3837 */ obj_t 
_struct_ref_app_type_set_3837_191_cfa_info(obj_t env_8133, obj_t obj_8134, obj_t val2369_8135)
{
   return struct_ref_app_type_set__226_cfa_info((app_t) (obj_8134), (type_t) (val2369_8135));
}


/* struct-ref-app-type */ type_t 
struct_ref_app_type_202_cfa_info(app_t obj_50)
{
   return (((app_t) CREF(obj_50))->type);
}


/* _struct-ref-app-type3838 */ obj_t 
_struct_ref_app_type3838_64_cfa_info(obj_t env_8136, obj_t obj_8137)
{
   {
      type_t aux_10914;
      aux_10914 = struct_ref_app_type_202_cfa_info((app_t) (obj_8137));
      return (obj_t) (aux_10914);
   }
}


/* struct-ref-app-side-effect?-set! */ obj_t 
struct_ref_app_side_effect__set__108_cfa_info(app_t obj_51, obj_t val2370_52)
{
   return ((((app_t) CREF(obj_51))->side_effect__165) = ((obj_t) val2370_52), BUNSPEC);
}


/* _struct-ref-app-side-effect?-set!3839 */ obj_t 
_struct_ref_app_side_effect__set_3839_174_cfa_info(obj_t env_8138, obj_t obj_8139, obj_t val2370_8140)
{
   return struct_ref_app_side_effect__set__108_cfa_info((app_t) (obj_8139), val2370_8140);
}


/* struct-ref-app-side-effect? */ obj_t 
struct_ref_app_side_effect__151_cfa_info(app_t obj_53)
{
   return (((app_t) CREF(obj_53))->side_effect__165);
}


/* _struct-ref-app-side-effect?3840 */ obj_t 
_struct_ref_app_side_effect_3840_167_cfa_info(obj_t env_8141, obj_t obj_8142)
{
   return struct_ref_app_side_effect__151_cfa_info((app_t) (obj_8142));
}


/* struct-ref-app-key-set! */ obj_t 
struct_ref_app_key_set__1_cfa_info(app_t obj_54, obj_t val2371_55)
{
   return ((((app_t) CREF(obj_54))->key) = ((obj_t) val2371_55), BUNSPEC);
}


/* _struct-ref-app-key-set! */ obj_t 
_struct_ref_app_key_set__180_cfa_info(obj_t env_8143, obj_t obj_8144, obj_t val2371_8145)
{
   return struct_ref_app_key_set__1_cfa_info((app_t) (obj_8144), val2371_8145);
}


/* struct-ref-app-key */ obj_t 
struct_ref_app_key_250_cfa_info(app_t obj_56)
{
   return (((app_t) CREF(obj_56))->key);
}


/* _struct-ref-app-key */ obj_t 
_struct_ref_app_key_111_cfa_info(obj_t env_8146, obj_t obj_8147)
{
   return struct_ref_app_key_250_cfa_info((app_t) (obj_8147));
}


/* struct-ref-app-fun-set! */ obj_t 
struct_ref_app_fun_set__15_cfa_info(app_t obj_57, var_t val2372_58)
{
   return ((((app_t) CREF(obj_57))->fun) = ((var_t) val2372_58), BUNSPEC);
}


/* _struct-ref-app-fun-set!3841 */ obj_t 
_struct_ref_app_fun_set_3841_162_cfa_info(obj_t env_8148, obj_t obj_8149, obj_t val2372_8150)
{
   return struct_ref_app_fun_set__15_cfa_info((app_t) (obj_8149), (var_t) (val2372_8150));
}


/* struct-ref-app-fun */ var_t 
struct_ref_app_fun_232_cfa_info(app_t obj_59)
{
   return (((app_t) CREF(obj_59))->fun);
}


/* _struct-ref-app-fun3842 */ obj_t 
_struct_ref_app_fun3842_117_cfa_info(obj_t env_8151, obj_t obj_8152)
{
   {
      var_t aux_10935;
      aux_10935 = struct_ref_app_fun_232_cfa_info((app_t) (obj_8152));
      return (obj_t) (aux_10935);
   }
}


/* struct-ref-app-args-set! */ obj_t 
struct_ref_app_args_set__33_cfa_info(app_t obj_60, obj_t val2373_61)
{
   return ((((app_t) CREF(obj_60))->args) = ((obj_t) val2373_61), BUNSPEC);
}


/* _struct-ref-app-args-set!3843 */ obj_t 
_struct_ref_app_args_set_3843_166_cfa_info(obj_t env_8153, obj_t obj_8154, obj_t val2373_8155)
{
   return struct_ref_app_args_set__33_cfa_info((app_t) (obj_8154), val2373_8155);
}


/* struct-ref-app-args */ obj_t 
struct_ref_app_args_190_cfa_info(app_t obj_62)
{
   return (((app_t) CREF(obj_62))->args);
}


/* _struct-ref-app-args3844 */ obj_t 
_struct_ref_app_args3844_142_cfa_info(obj_t env_8156, obj_t obj_8157)
{
   return struct_ref_app_args_190_cfa_info((app_t) (obj_8157));
}


/* struct-ref-app-stack-info-set! */ obj_t 
struct_ref_app_stack_info_set__87_cfa_info(app_t obj_63, obj_t val2374_64)
{
   return ((((app_t) CREF(obj_63))->stack_info_255) = ((obj_t) val2374_64), BUNSPEC);
}


/* _struct-ref-app-stack-info-set!3845 */ obj_t 
_struct_ref_app_stack_info_set_3845_170_cfa_info(obj_t env_8158, obj_t obj_8159, obj_t val2374_8160)
{
   return struct_ref_app_stack_info_set__87_cfa_info((app_t) (obj_8159), val2374_8160);
}


/* struct-ref-app-stack-info */ obj_t 
struct_ref_app_stack_info_73_cfa_info(app_t obj_65)
{
   return (((app_t) CREF(obj_65))->stack_info_255);
}


/* _struct-ref-app-stack-info3846 */ obj_t 
_struct_ref_app_stack_info3846_168_cfa_info(obj_t env_8161, obj_t obj_8162)
{
   return struct_ref_app_stack_info_73_cfa_info((app_t) (obj_8162));
}


/* struct-ref-app-approx */ approx_t 
struct_ref_app_approx_125_cfa_info(struct_ref_app_73_t obj_66)
{
   {
      obj_t aux_10951;
      {
	 object_t aux_10952;
	 aux_10952 = (object_t) (obj_66);
	 aux_10951 = OBJECT_WIDENING(aux_10952);
      }
      return (((struct_ref_app_73_t) CREF(aux_10951))->approx);
   }
}


/* _struct-ref-app-approx3847 */ obj_t 
_struct_ref_app_approx3847_222_cfa_info(obj_t env_8163, obj_t obj_8164)
{
   {
      approx_t aux_10956;
      aux_10956 = struct_ref_app_approx_125_cfa_info((struct_ref_app_73_t) (obj_8164));
      return (obj_t) (aux_10956);
   }
}


/* allocate-make-struct-app */ app_t 
allocate_make_struct_app_180_cfa_info()
{
   {
      app_t new2357_2460;
      new2357_2460 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2809_2461;
	 arg2809_2461 = class_num_218___object(make_struct_app_214_cfa_info);
	 {
	    obj_t obj_4593;
	    obj_4593 = (obj_t) (new2357_2460);
	    (((obj_t) CREF(obj_4593))->header = MAKE_HEADER(arg2809_2461, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_10964;
	 aux_10964 = (object_t) (new2357_2460);
	 OBJECT_WIDENING_SET(aux_10964, BFALSE);
      }
      return new2357_2460;
   }
}


/* _allocate-make-struct-app */ obj_t 
_allocate_make_struct_app_151_cfa_info(obj_t env_8068)
{
   {
      app_t aux_10967;
      aux_10967 = allocate_make_struct_app_180_cfa_info();
      return (obj_t) (aux_10967);
   }
}


/* make-struct-app? */ bool_t 
make_struct_app__23_cfa_info(obj_t obj_70)
{
   return is_a__118___object(obj_70, make_struct_app_214_cfa_info);
}


/* _make-struct-app? */ obj_t 
_make_struct_app__44_cfa_info(obj_t env_8165, obj_t obj_8166)
{
   {
      bool_t aux_10971;
      aux_10971 = make_struct_app__23_cfa_info(obj_8166);
      return BBOOL(aux_10971);
   }
}


/* widening1048-make-struct-app */ make_struct_app_214_t 
widening1048_make_struct_app_108_cfa_info(approx_t approx_71, approx_t value_approx_19_72, long lost_stamp_114_73, variable_t owner_74, bool_t stackable__42_75, obj_t stack_stamp_31_76)
{
   {
      make_struct_app_214_t new2337_4595;
      new2337_4595 = ((make_struct_app_214_t) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
      ((((make_struct_app_214_t) CREF(new2337_4595))->approx) = ((approx_t) approx_71), BUNSPEC);
      ((((make_struct_app_214_t) CREF(new2337_4595))->value_approx_19) = ((approx_t) value_approx_19_72), BUNSPEC);
      ((((make_struct_app_214_t) CREF(new2337_4595))->lost_stamp_114) = ((long) lost_stamp_114_73), BUNSPEC);
      ((((make_struct_app_214_t) CREF(new2337_4595))->owner) = ((variable_t) owner_74), BUNSPEC);
      ((((make_struct_app_214_t) CREF(new2337_4595))->stackable__42) = ((bool_t) stackable__42_75), BUNSPEC);
      ((((make_struct_app_214_t) CREF(new2337_4595))->stack_stamp_31) = ((obj_t) stack_stamp_31_76), BUNSPEC);
      return new2337_4595;
   }
}


/* _widening1048-make-struct-app3848 */ obj_t 
_widening1048_make_struct_app3848_127_cfa_info(obj_t env_8167, obj_t approx_8168, obj_t value_approx_19_8169, obj_t lost_stamp_114_8170, obj_t owner_8171, obj_t stackable__42_8172, obj_t stack_stamp_31_8173)
{
   {
      make_struct_app_214_t aux_10981;
      aux_10981 = widening1048_make_struct_app_108_cfa_info((approx_t) (approx_8168), (approx_t) (value_approx_19_8169), (long) CINT(lost_stamp_114_8170), (variable_t) (owner_8171), CBOOL(stackable__42_8172), stack_stamp_31_8173);
      return (obj_t) (aux_10981);
   }
}


/* make-make-struct-app */ make_struct_app_214_t 
make_make_struct_app_186_cfa_info(obj_t loc_77, type_t type_78, obj_t side_effect__165_79, obj_t key_80, var_t fun_81, obj_t args_82, obj_t stack_info_255_83, approx_t approx_84, approx_t value_approx_19_85, long lost_stamp_114_86, variable_t owner_87, bool_t stackable__42_88, obj_t stack_stamp_31_89)
{
   {
      app_t aux2345_4602;
      {
	 app_t res3676_4624;
	 {
	    app_t new1289_4613;
	    new1289_4613 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4614;
	       arg2999_4614 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4622;
		  obj_4622 = (obj_t) (new1289_4613);
		  (((obj_t) CREF(obj_4622))->header = MAKE_HEADER(arg2999_4614, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_10993;
	       aux_10993 = (object_t) (new1289_4613);
	       OBJECT_WIDENING_SET(aux_10993, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4613))->loc) = ((obj_t) loc_77), BUNSPEC);
	    ((((app_t) CREF(new1289_4613))->type) = ((type_t) type_78), BUNSPEC);
	    ((((app_t) CREF(new1289_4613))->side_effect__165) = ((obj_t) side_effect__165_79), BUNSPEC);
	    ((((app_t) CREF(new1289_4613))->key) = ((obj_t) key_80), BUNSPEC);
	    ((((app_t) CREF(new1289_4613))->fun) = ((var_t) fun_81), BUNSPEC);
	    ((((app_t) CREF(new1289_4613))->args) = ((obj_t) args_82), BUNSPEC);
	    ((((app_t) CREF(new1289_4613))->stack_info_255) = ((obj_t) stack_info_255_83), BUNSPEC);
	    res3676_4624 = new1289_4613;
	 }
	 aux2345_4602 = res3676_4624;
      }
      {
	 make_struct_app_214_t new2346_4603;
	 new2346_4603 = ((make_struct_app_214_t) (aux2345_4602));
	 {
	    long arg2810_4604;
	    arg2810_4604 = class_num_218___object(make_struct_app_214_cfa_info);
	    {
	       obj_t obj_4625;
	       obj_4625 = (obj_t) (new2346_4603);
	       (((obj_t) CREF(obj_4625))->header = MAKE_HEADER(arg2810_4604, 0), BUNSPEC);
	    }
	 }
	 {
	    make_struct_app_214_t arg2811_4605;
	    {
	       make_struct_app_214_t res3677_4640;
	       {
		  make_struct_app_214_t new2337_4633;
		  new2337_4633 = ((make_struct_app_214_t) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
		  ((((make_struct_app_214_t) CREF(new2337_4633))->approx) = ((approx_t) approx_84), BUNSPEC);
		  ((((make_struct_app_214_t) CREF(new2337_4633))->value_approx_19) = ((approx_t) value_approx_19_85), BUNSPEC);
		  ((((make_struct_app_214_t) CREF(new2337_4633))->lost_stamp_114) = ((long) lost_stamp_114_86), BUNSPEC);
		  ((((make_struct_app_214_t) CREF(new2337_4633))->owner) = ((variable_t) owner_87), BUNSPEC);
		  ((((make_struct_app_214_t) CREF(new2337_4633))->stackable__42) = ((bool_t) stackable__42_88), BUNSPEC);
		  ((((make_struct_app_214_t) CREF(new2337_4633))->stack_stamp_31) = ((obj_t) stack_stamp_31_89), BUNSPEC);
		  res3677_4640 = new2337_4633;
	       }
	       arg2811_4605 = res3677_4640;
	    }
	    {
	       obj_t aux_11016;
	       object_t aux_11014;
	       aux_11016 = (obj_t) (arg2811_4605);
	       aux_11014 = (object_t) (new2346_4603);
	       OBJECT_WIDENING_SET(aux_11014, aux_11016);
	    }
	 }
	 return new2346_4603;
      }
   }
}


/* _make-make-struct-app3849 */ obj_t 
_make_make_struct_app3849_83_cfa_info(obj_t env_8174, obj_t loc_8175, obj_t type_8176, obj_t side_effect__165_8177, obj_t key_8178, obj_t fun_8179, obj_t args_8180, obj_t stack_info_255_8181, obj_t approx_8182, obj_t value_approx_19_8183, obj_t lost_stamp_114_8184, obj_t owner_8185, obj_t stackable__42_8186, obj_t stack_stamp_31_8187)
{
   {
      make_struct_app_214_t aux_11019;
      aux_11019 = make_make_struct_app_186_cfa_info(loc_8175, (type_t) (type_8176), side_effect__165_8177, key_8178, (var_t) (fun_8179), args_8180, stack_info_255_8181, (approx_t) (approx_8182), (approx_t) (value_approx_19_8183), (long) CINT(lost_stamp_114_8184), (variable_t) (owner_8185), CBOOL(stackable__42_8186), stack_stamp_31_8187);
      return (obj_t) (aux_11019);
   }
}


/* make-struct-app-loc */ obj_t 
make_struct_app_loc_176_cfa_info(app_t obj_90)
{
   return (((app_t) CREF(obj_90))->loc);
}


/* _make-struct-app-loc3850 */ obj_t 
_make_struct_app_loc3850_156_cfa_info(obj_t env_8188, obj_t obj_8189)
{
   return make_struct_app_loc_176_cfa_info((app_t) (obj_8189));
}


/* make-struct-app-type-set! */ obj_t 
make_struct_app_type_set__65_cfa_info(app_t obj_91, type_t val2347_92)
{
   return ((((app_t) CREF(obj_91))->type) = ((type_t) val2347_92), BUNSPEC);
}


/* _make-struct-app-type-set!3851 */ obj_t 
_make_struct_app_type_set_3851_13_cfa_info(obj_t env_8190, obj_t obj_8191, obj_t val2347_8192)
{
   return make_struct_app_type_set__65_cfa_info((app_t) (obj_8191), (type_t) (val2347_8192));
}


/* make-struct-app-type */ type_t 
make_struct_app_type_23_cfa_info(app_t obj_93)
{
   return (((app_t) CREF(obj_93))->type);
}


/* _make-struct-app-type3852 */ obj_t 
_make_struct_app_type3852_107_cfa_info(obj_t env_8193, obj_t obj_8194)
{
   {
      type_t aux_11037;
      aux_11037 = make_struct_app_type_23_cfa_info((app_t) (obj_8194));
      return (obj_t) (aux_11037);
   }
}


/* make-struct-app-side-effect?-set! */ obj_t 
make_struct_app_side_effect__set__36_cfa_info(app_t obj_94, obj_t val2348_95)
{
   return ((((app_t) CREF(obj_94))->side_effect__165) = ((obj_t) val2348_95), BUNSPEC);
}


/* _make-struct-app-side-effect?-set!3853 */ obj_t 
_make_struct_app_side_effect__set_3853_48_cfa_info(obj_t env_8195, obj_t obj_8196, obj_t val2348_8197)
{
   return make_struct_app_side_effect__set__36_cfa_info((app_t) (obj_8196), val2348_8197);
}


/* make-struct-app-side-effect? */ obj_t 
make_struct_app_side_effect__63_cfa_info(app_t obj_96)
{
   return (((app_t) CREF(obj_96))->side_effect__165);
}


/* _make-struct-app-side-effect?3854 */ obj_t 
_make_struct_app_side_effect_3854_6_cfa_info(obj_t env_8198, obj_t obj_8199)
{
   return make_struct_app_side_effect__63_cfa_info((app_t) (obj_8199));
}


/* make-struct-app-key-set! */ obj_t 
make_struct_app_key_set__110_cfa_info(app_t obj_97, obj_t val2349_98)
{
   return ((((app_t) CREF(obj_97))->key) = ((obj_t) val2349_98), BUNSPEC);
}


/* _make-struct-app-key-set! */ obj_t 
_make_struct_app_key_set__175_cfa_info(obj_t env_8200, obj_t obj_8201, obj_t val2349_8202)
{
   return make_struct_app_key_set__110_cfa_info((app_t) (obj_8201), val2349_8202);
}


/* make-struct-app-key */ obj_t 
make_struct_app_key_199_cfa_info(app_t obj_99)
{
   return (((app_t) CREF(obj_99))->key);
}


/* _make-struct-app-key3855 */ obj_t 
_make_struct_app_key3855_132_cfa_info(obj_t env_8203, obj_t obj_8204)
{
   return make_struct_app_key_199_cfa_info((app_t) (obj_8204));
}


/* make-struct-app-fun-set! */ obj_t 
make_struct_app_fun_set__249_cfa_info(app_t obj_100, var_t val2350_101)
{
   return ((((app_t) CREF(obj_100))->fun) = ((var_t) val2350_101), BUNSPEC);
}


/* _make-struct-app-fun-set!3856 */ obj_t 
_make_struct_app_fun_set_3856_97_cfa_info(obj_t env_8205, obj_t obj_8206, obj_t val2350_8207)
{
   return make_struct_app_fun_set__249_cfa_info((app_t) (obj_8206), (var_t) (val2350_8207));
}


/* make-struct-app-fun */ var_t 
make_struct_app_fun_76_cfa_info(app_t obj_102)
{
   return (((app_t) CREF(obj_102))->fun);
}


/* _make-struct-app-fun3857 */ obj_t 
_make_struct_app_fun3857_148_cfa_info(obj_t env_8208, obj_t obj_8209)
{
   {
      var_t aux_11058;
      aux_11058 = make_struct_app_fun_76_cfa_info((app_t) (obj_8209));
      return (obj_t) (aux_11058);
   }
}


/* make-struct-app-args-set! */ obj_t 
make_struct_app_args_set__242_cfa_info(app_t obj_103, obj_t val2351_104)
{
   return ((((app_t) CREF(obj_103))->args) = ((obj_t) val2351_104), BUNSPEC);
}


/* _make-struct-app-args-set!3858 */ obj_t 
_make_struct_app_args_set_3858_83_cfa_info(obj_t env_8210, obj_t obj_8211, obj_t val2351_8212)
{
   return make_struct_app_args_set__242_cfa_info((app_t) (obj_8211), val2351_8212);
}


/* make-struct-app-args */ obj_t 
make_struct_app_args_183_cfa_info(app_t obj_105)
{
   return (((app_t) CREF(obj_105))->args);
}


/* _make-struct-app-args3859 */ obj_t 
_make_struct_app_args3859_196_cfa_info(obj_t env_8213, obj_t obj_8214)
{
   return make_struct_app_args_183_cfa_info((app_t) (obj_8214));
}


/* make-struct-app-stack-info-set! */ obj_t 
make_struct_app_stack_info_set__189_cfa_info(app_t obj_106, obj_t val2352_107)
{
   return ((((app_t) CREF(obj_106))->stack_info_255) = ((obj_t) val2352_107), BUNSPEC);
}


/* _make-struct-app-stack-info-set!3860 */ obj_t 
_make_struct_app_stack_info_set_3860_205_cfa_info(obj_t env_8215, obj_t obj_8216, obj_t val2352_8217)
{
   return make_struct_app_stack_info_set__189_cfa_info((app_t) (obj_8216), val2352_8217);
}


/* make-struct-app-stack-info */ obj_t 
make_struct_app_stack_info_206_cfa_info(app_t obj_108)
{
   return (((app_t) CREF(obj_108))->stack_info_255);
}


/* _make-struct-app-stack-info3861 */ obj_t 
_make_struct_app_stack_info3861_128_cfa_info(obj_t env_8218, obj_t obj_8219)
{
   return make_struct_app_stack_info_206_cfa_info((app_t) (obj_8219));
}


/* make-struct-app-approx-set! */ obj_t 
make_struct_app_approx_set__191_cfa_info(make_struct_app_214_t obj_109, approx_t val2353_110)
{
   {
      obj_t aux_11074;
      {
	 object_t aux_11075;
	 aux_11075 = (object_t) (obj_109);
	 aux_11074 = OBJECT_WIDENING(aux_11075);
      }
      return ((((make_struct_app_214_t) CREF(aux_11074))->approx) = ((approx_t) val2353_110), BUNSPEC);
   }
}


/* _make-struct-app-approx-set!3862 */ obj_t 
_make_struct_app_approx_set_3862_80_cfa_info(obj_t env_8220, obj_t obj_8221, obj_t val2353_8222)
{
   return make_struct_app_approx_set__191_cfa_info((make_struct_app_214_t) (obj_8221), (approx_t) (val2353_8222));
}


/* make-struct-app-approx */ approx_t 
make_struct_app_approx_49_cfa_info(make_struct_app_214_t obj_111)
{
   {
      obj_t aux_11082;
      {
	 object_t aux_11083;
	 aux_11083 = (object_t) (obj_111);
	 aux_11082 = OBJECT_WIDENING(aux_11083);
      }
      return (((make_struct_app_214_t) CREF(aux_11082))->approx);
   }
}


/* _make-struct-app-approx3863 */ obj_t 
_make_struct_app_approx3863_199_cfa_info(obj_t env_8223, obj_t obj_8224)
{
   {
      approx_t aux_11087;
      aux_11087 = make_struct_app_approx_49_cfa_info((make_struct_app_214_t) (obj_8224));
      return (obj_t) (aux_11087);
   }
}


/* make-struct-app-value-approx */ approx_t 
make_struct_app_value_approx_246_cfa_info(make_struct_app_214_t obj_112)
{
   {
      obj_t aux_11091;
      {
	 object_t aux_11092;
	 aux_11092 = (object_t) (obj_112);
	 aux_11091 = OBJECT_WIDENING(aux_11092);
      }
      return (((make_struct_app_214_t) CREF(aux_11091))->value_approx_19);
   }
}


/* _make-struct-app-value-approx3864 */ obj_t 
_make_struct_app_value_approx3864_211_cfa_info(obj_t env_8225, obj_t obj_8226)
{
   {
      approx_t aux_11096;
      aux_11096 = make_struct_app_value_approx_246_cfa_info((make_struct_app_214_t) (obj_8226));
      return (obj_t) (aux_11096);
   }
}


/* make-struct-app-lost-stamp-set! */ obj_t 
make_struct_app_lost_stamp_set__51_cfa_info(make_struct_app_214_t obj_113, long val2354_114)
{
   {
      obj_t aux_11100;
      {
	 object_t aux_11101;
	 aux_11101 = (object_t) (obj_113);
	 aux_11100 = OBJECT_WIDENING(aux_11101);
      }
      return ((((make_struct_app_214_t) CREF(aux_11100))->lost_stamp_114) = ((long) val2354_114), BUNSPEC);
   }
}


/* _make-struct-app-lost-stamp-set!3865 */ obj_t 
_make_struct_app_lost_stamp_set_3865_171_cfa_info(obj_t env_8227, obj_t obj_8228, obj_t val2354_8229)
{
   return make_struct_app_lost_stamp_set__51_cfa_info((make_struct_app_214_t) (obj_8228), (long) CINT(val2354_8229));
}


/* make-struct-app-lost-stamp */ long 
make_struct_app_lost_stamp_13_cfa_info(make_struct_app_214_t obj_115)
{
   {
      obj_t aux_11108;
      {
	 object_t aux_11109;
	 aux_11109 = (object_t) (obj_115);
	 aux_11108 = OBJECT_WIDENING(aux_11109);
      }
      return (((make_struct_app_214_t) CREF(aux_11108))->lost_stamp_114);
   }
}


/* _make-struct-app-lost-stamp3866 */ obj_t 
_make_struct_app_lost_stamp3866_30_cfa_info(obj_t env_8230, obj_t obj_8231)
{
   {
      long aux_11113;
      aux_11113 = make_struct_app_lost_stamp_13_cfa_info((make_struct_app_214_t) (obj_8231));
      return BINT(aux_11113);
   }
}


/* make-struct-app-owner */ variable_t 
make_struct_app_owner_33_cfa_info(make_struct_app_214_t obj_116)
{
   {
      obj_t aux_11117;
      {
	 object_t aux_11118;
	 aux_11118 = (object_t) (obj_116);
	 aux_11117 = OBJECT_WIDENING(aux_11118);
      }
      return (((make_struct_app_214_t) CREF(aux_11117))->owner);
   }
}


/* _make-struct-app-owner3867 */ obj_t 
_make_struct_app_owner3867_64_cfa_info(obj_t env_8232, obj_t obj_8233)
{
   {
      variable_t aux_11122;
      aux_11122 = make_struct_app_owner_33_cfa_info((make_struct_app_214_t) (obj_8233));
      return (obj_t) (aux_11122);
   }
}


/* make-struct-app-stackable?-set! */ obj_t 
make_struct_app_stackable__set__115_cfa_info(make_struct_app_214_t obj_117, bool_t val2355_118)
{
   {
      obj_t aux_11126;
      {
	 object_t aux_11127;
	 aux_11127 = (object_t) (obj_117);
	 aux_11126 = OBJECT_WIDENING(aux_11127);
      }
      return ((((make_struct_app_214_t) CREF(aux_11126))->stackable__42) = ((bool_t) val2355_118), BUNSPEC);
   }
}


/* _make-struct-app-stackable?-set!3868 */ obj_t 
_make_struct_app_stackable__set_3868_160_cfa_info(obj_t env_8234, obj_t obj_8235, obj_t val2355_8236)
{
   return make_struct_app_stackable__set__115_cfa_info((make_struct_app_214_t) (obj_8235), CBOOL(val2355_8236));
}


/* make-struct-app-stackable? */ bool_t 
make_struct_app_stackable__22_cfa_info(make_struct_app_214_t obj_119)
{
   {
      obj_t aux_11134;
      {
	 object_t aux_11135;
	 aux_11135 = (object_t) (obj_119);
	 aux_11134 = OBJECT_WIDENING(aux_11135);
      }
      return (((make_struct_app_214_t) CREF(aux_11134))->stackable__42);
   }
}


/* _make-struct-app-stackable?3869 */ obj_t 
_make_struct_app_stackable_3869_173_cfa_info(obj_t env_8237, obj_t obj_8238)
{
   {
      bool_t aux_11139;
      aux_11139 = make_struct_app_stackable__22_cfa_info((make_struct_app_214_t) (obj_8238));
      return BBOOL(aux_11139);
   }
}


/* make-struct-app-stack-stamp-set! */ obj_t 
make_struct_app_stack_stamp_set__112_cfa_info(make_struct_app_214_t obj_120, obj_t val2356_121)
{
   {
      obj_t aux_11143;
      {
	 object_t aux_11144;
	 aux_11144 = (object_t) (obj_120);
	 aux_11143 = OBJECT_WIDENING(aux_11144);
      }
      return ((((make_struct_app_214_t) CREF(aux_11143))->stack_stamp_31) = ((obj_t) val2356_121), BUNSPEC);
   }
}


/* _make-struct-app-stack-stamp-set!3870 */ obj_t 
_make_struct_app_stack_stamp_set_3870_221_cfa_info(obj_t env_8239, obj_t obj_8240, obj_t val2356_8241)
{
   return make_struct_app_stack_stamp_set__112_cfa_info((make_struct_app_214_t) (obj_8240), val2356_8241);
}


/* make-struct-app-stack-stamp */ obj_t 
make_struct_app_stack_stamp_197_cfa_info(make_struct_app_214_t obj_122)
{
   {
      obj_t aux_11150;
      {
	 object_t aux_11151;
	 aux_11151 = (object_t) (obj_122);
	 aux_11150 = OBJECT_WIDENING(aux_11151);
      }
      return (((make_struct_app_214_t) CREF(aux_11150))->stack_stamp_31);
   }
}


/* _make-struct-app-stack-stamp3871 */ obj_t 
_make_struct_app_stack_stamp3871_79_cfa_info(obj_t env_8242, obj_t obj_8243)
{
   return make_struct_app_stack_stamp_197_cfa_info((make_struct_app_214_t) (obj_8243));
}


/* allocate-pre-struct-set!-app */ app_t 
allocate_pre_struct_set__app_186_cfa_info()
{
   {
      app_t new2330_2473;
      new2330_2473 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2812_2474;
	 arg2812_2474 = class_num_218___object(pre_struct_set__app_116_cfa_info);
	 {
	    obj_t obj_4641;
	    obj_4641 = (obj_t) (new2330_2473);
	    (((obj_t) CREF(obj_4641))->header = MAKE_HEADER(arg2812_2474, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11161;
	 aux_11161 = (object_t) (new2330_2473);
	 OBJECT_WIDENING_SET(aux_11161, BFALSE);
      }
      return new2330_2473;
   }
}


/* _allocate-pre-struct-set!-app */ obj_t 
_allocate_pre_struct_set__app_93_cfa_info(obj_t env_8067)
{
   {
      app_t aux_11164;
      aux_11164 = allocate_pre_struct_set__app_186_cfa_info();
      return (obj_t) (aux_11164);
   }
}


/* pre-struct-set!-app? */ bool_t 
pre_struct_set__app__46_cfa_info(obj_t obj_126)
{
   return is_a__118___object(obj_126, pre_struct_set__app_116_cfa_info);
}


/* _pre-struct-set!-app? */ obj_t 
_pre_struct_set__app__221_cfa_info(obj_t env_8244, obj_t obj_8245)
{
   {
      bool_t aux_11168;
      aux_11168 = pre_struct_set__app__46_cfa_info(obj_8245);
      return BBOOL(aux_11168);
   }
}


/* widening1047-pre-struct-set!-app */ pre_struct_set__app_116_t 
widening1047_pre_struct_set__app_28_cfa_info()
{
   {
      return ((pre_struct_set__app_116_t) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
   }
}


/* _widening1047-pre-struct-set!-app */ obj_t 
_widening1047_pre_struct_set__app_81_cfa_info(obj_t env_8246)
{
   {
      pre_struct_set__app_116_t aux_11172;
      aux_11172 = widening1047_pre_struct_set__app_28_cfa_info();
      return (obj_t) (aux_11172);
   }
}


/* make-pre-struct-set!-app */ pre_struct_set__app_116_t 
make_pre_struct_set__app_188_cfa_info(obj_t loc_127, type_t type_128, obj_t side_effect__165_129, obj_t key_130, var_t fun_131, obj_t args_132, obj_t stack_info_255_133)
{
   {
      app_t aux2322_4644;
      {
	 app_t res3678_4666;
	 {
	    app_t new1289_4655;
	    new1289_4655 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4656;
	       arg2999_4656 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4664;
		  obj_4664 = (obj_t) (new1289_4655);
		  (((obj_t) CREF(obj_4664))->header = MAKE_HEADER(arg2999_4656, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_11179;
	       aux_11179 = (object_t) (new1289_4655);
	       OBJECT_WIDENING_SET(aux_11179, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4655))->loc) = ((obj_t) loc_127), BUNSPEC);
	    ((((app_t) CREF(new1289_4655))->type) = ((type_t) type_128), BUNSPEC);
	    ((((app_t) CREF(new1289_4655))->side_effect__165) = ((obj_t) side_effect__165_129), BUNSPEC);
	    ((((app_t) CREF(new1289_4655))->key) = ((obj_t) key_130), BUNSPEC);
	    ((((app_t) CREF(new1289_4655))->fun) = ((var_t) fun_131), BUNSPEC);
	    ((((app_t) CREF(new1289_4655))->args) = ((obj_t) args_132), BUNSPEC);
	    ((((app_t) CREF(new1289_4655))->stack_info_255) = ((obj_t) stack_info_255_133), BUNSPEC);
	    res3678_4666 = new1289_4655;
	 }
	 aux2322_4644 = res3678_4666;
      }
      {
	 pre_struct_set__app_116_t new2323_4645;
	 new2323_4645 = ((pre_struct_set__app_116_t) (aux2322_4644));
	 {
	    long arg2813_4646;
	    arg2813_4646 = class_num_218___object(pre_struct_set__app_116_cfa_info);
	    {
	       obj_t obj_4667;
	       obj_4667 = (obj_t) (new2323_4645);
	       (((obj_t) CREF(obj_4667))->header = MAKE_HEADER(arg2813_4646, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_11195;
	    object_t aux_11193;
	    {
	       pre_struct_set__app_116_t aux_11196;
	       {
		  aux_11196 = ((pre_struct_set__app_116_t) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
	       }
	       aux_11195 = (obj_t) (aux_11196);
	    }
	    aux_11193 = (object_t) (new2323_4645);
	    OBJECT_WIDENING_SET(aux_11193, aux_11195);
	 }
	 return new2323_4645;
      }
   }
}


/* _make-pre-struct-set!-app3872 */ obj_t 
_make_pre_struct_set__app3872_222_cfa_info(obj_t env_8247, obj_t loc_8248, obj_t type_8249, obj_t side_effect__165_8250, obj_t key_8251, obj_t fun_8252, obj_t args_8253, obj_t stack_info_255_8254)
{
   {
      pre_struct_set__app_116_t aux_11200;
      aux_11200 = make_pre_struct_set__app_188_cfa_info(loc_8248, (type_t) (type_8249), side_effect__165_8250, key_8251, (var_t) (fun_8252), args_8253, stack_info_255_8254);
      return (obj_t) (aux_11200);
   }
}


/* pre-struct-set!-app-loc */ obj_t 
pre_struct_set__app_loc_71_cfa_info(app_t obj_134)
{
   return (((app_t) CREF(obj_134))->loc);
}


/* _pre-struct-set!-app-loc3873 */ obj_t 
_pre_struct_set__app_loc3873_24_cfa_info(obj_t env_8255, obj_t obj_8256)
{
   return pre_struct_set__app_loc_71_cfa_info((app_t) (obj_8256));
}


/* pre-struct-set!-app-type-set! */ obj_t 
pre_struct_set__app_type_set__207_cfa_info(app_t obj_135, type_t val2324_136)
{
   return ((((app_t) CREF(obj_135))->type) = ((type_t) val2324_136), BUNSPEC);
}


/* _pre-struct-set!-app-type-set!3874 */ obj_t 
_pre_struct_set__app_type_set_3874_35_cfa_info(obj_t env_8257, obj_t obj_8258, obj_t val2324_8259)
{
   return pre_struct_set__app_type_set__207_cfa_info((app_t) (obj_8258), (type_t) (val2324_8259));
}


/* pre-struct-set!-app-type */ type_t 
pre_struct_set__app_type_46_cfa_info(app_t obj_137)
{
   return (((app_t) CREF(obj_137))->type);
}


/* _pre-struct-set!-app-type3875 */ obj_t 
_pre_struct_set__app_type3875_200_cfa_info(obj_t env_8260, obj_t obj_8261)
{
   {
      type_t aux_11213;
      aux_11213 = pre_struct_set__app_type_46_cfa_info((app_t) (obj_8261));
      return (obj_t) (aux_11213);
   }
}


/* pre-struct-set!-app-side-effect?-set! */ obj_t 
pre_struct_set__app_side_effect__set__33_cfa_info(app_t obj_138, obj_t val2325_139)
{
   return ((((app_t) CREF(obj_138))->side_effect__165) = ((obj_t) val2325_139), BUNSPEC);
}


/* _pre-struct-set!-app-side-effect?-set!3876 */ obj_t 
_pre_struct_set__app_side_effect__set_3876_249_cfa_info(obj_t env_8262, obj_t obj_8263, obj_t val2325_8264)
{
   return pre_struct_set__app_side_effect__set__33_cfa_info((app_t) (obj_8263), val2325_8264);
}


/* pre-struct-set!-app-side-effect? */ obj_t 
pre_struct_set__app_side_effect__190_cfa_info(app_t obj_140)
{
   return (((app_t) CREF(obj_140))->side_effect__165);
}


/* _pre-struct-set!-app-side-effect?3877 */ obj_t 
_pre_struct_set__app_side_effect_3877_36_cfa_info(obj_t env_8265, obj_t obj_8266)
{
   return pre_struct_set__app_side_effect__190_cfa_info((app_t) (obj_8266));
}


/* pre-struct-set!-app-key-set! */ obj_t 
pre_struct_set__app_key_set__234_cfa_info(app_t obj_141, obj_t val2326_142)
{
   return ((((app_t) CREF(obj_141))->key) = ((obj_t) val2326_142), BUNSPEC);
}


/* _pre-struct-set!-app-key-set! */ obj_t 
_pre_struct_set__app_key_set__68_cfa_info(obj_t env_8267, obj_t obj_8268, obj_t val2326_8269)
{
   return pre_struct_set__app_key_set__234_cfa_info((app_t) (obj_8268), val2326_8269);
}


/* pre-struct-set!-app-key */ obj_t 
pre_struct_set__app_key_246_cfa_info(app_t obj_143)
{
   return (((app_t) CREF(obj_143))->key);
}


/* _pre-struct-set!-app-key */ obj_t 
_pre_struct_set__app_key_140_cfa_info(obj_t env_8270, obj_t obj_8271)
{
   return pre_struct_set__app_key_246_cfa_info((app_t) (obj_8271));
}


/* pre-struct-set!-app-fun-set! */ obj_t 
pre_struct_set__app_fun_set__90_cfa_info(app_t obj_144, var_t val2327_145)
{
   return ((((app_t) CREF(obj_144))->fun) = ((var_t) val2327_145), BUNSPEC);
}


/* _pre-struct-set!-app-fun-set!3878 */ obj_t 
_pre_struct_set__app_fun_set_3878_88_cfa_info(obj_t env_8272, obj_t obj_8273, obj_t val2327_8274)
{
   return pre_struct_set__app_fun_set__90_cfa_info((app_t) (obj_8273), (var_t) (val2327_8274));
}


/* pre-struct-set!-app-fun */ var_t 
pre_struct_set__app_fun_114_cfa_info(app_t obj_146)
{
   return (((app_t) CREF(obj_146))->fun);
}


/* _pre-struct-set!-app-fun3879 */ obj_t 
_pre_struct_set__app_fun3879_141_cfa_info(obj_t env_8275, obj_t obj_8276)
{
   {
      var_t aux_11234;
      aux_11234 = pre_struct_set__app_fun_114_cfa_info((app_t) (obj_8276));
      return (obj_t) (aux_11234);
   }
}


/* pre-struct-set!-app-args-set! */ obj_t 
pre_struct_set__app_args_set__238_cfa_info(app_t obj_147, obj_t val2328_148)
{
   return ((((app_t) CREF(obj_147))->args) = ((obj_t) val2328_148), BUNSPEC);
}


/* _pre-struct-set!-app-args-set!3880 */ obj_t 
_pre_struct_set__app_args_set_3880_136_cfa_info(obj_t env_8277, obj_t obj_8278, obj_t val2328_8279)
{
   return pre_struct_set__app_args_set__238_cfa_info((app_t) (obj_8278), val2328_8279);
}


/* pre-struct-set!-app-args */ obj_t 
pre_struct_set__app_args_53_cfa_info(app_t obj_149)
{
   return (((app_t) CREF(obj_149))->args);
}


/* _pre-struct-set!-app-args3881 */ obj_t 
_pre_struct_set__app_args3881_189_cfa_info(obj_t env_8280, obj_t obj_8281)
{
   return pre_struct_set__app_args_53_cfa_info((app_t) (obj_8281));
}


/* pre-struct-set!-app-stack-info-set! */ obj_t 
pre_struct_set__app_stack_info_set__52_cfa_info(app_t obj_150, obj_t val2329_151)
{
   return ((((app_t) CREF(obj_150))->stack_info_255) = ((obj_t) val2329_151), BUNSPEC);
}


/* _pre-struct-set!-app-stack-info-set!3882 */ obj_t 
_pre_struct_set__app_stack_info_set_3882_247_cfa_info(obj_t env_8282, obj_t obj_8283, obj_t val2329_8284)
{
   return pre_struct_set__app_stack_info_set__52_cfa_info((app_t) (obj_8283), val2329_8284);
}


/* pre-struct-set!-app-stack-info */ obj_t 
pre_struct_set__app_stack_info_177_cfa_info(app_t obj_152)
{
   return (((app_t) CREF(obj_152))->stack_info_255);
}


/* _pre-struct-set!-app-stack-info3883 */ obj_t 
_pre_struct_set__app_stack_info3883_34_cfa_info(obj_t env_8285, obj_t obj_8286)
{
   return pre_struct_set__app_stack_info_177_cfa_info((app_t) (obj_8286));
}


/* allocate-pre-struct-ref-app */ app_t 
allocate_pre_struct_ref_app_69_cfa_info()
{
   {
      app_t new2313_2480;
      new2313_2480 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2815_2481;
	 arg2815_2481 = class_num_218___object(pre_struct_ref_app_207_cfa_info);
	 {
	    obj_t obj_4671;
	    obj_4671 = (obj_t) (new2313_2480);
	    (((obj_t) CREF(obj_4671))->header = MAKE_HEADER(arg2815_2481, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11254;
	 aux_11254 = (object_t) (new2313_2480);
	 OBJECT_WIDENING_SET(aux_11254, BFALSE);
      }
      return new2313_2480;
   }
}


/* _allocate-pre-struct-ref-app */ obj_t 
_allocate_pre_struct_ref_app_15_cfa_info(obj_t env_8066)
{
   {
      app_t aux_11257;
      aux_11257 = allocate_pre_struct_ref_app_69_cfa_info();
      return (obj_t) (aux_11257);
   }
}


/* pre-struct-ref-app? */ bool_t 
pre_struct_ref_app__163_cfa_info(obj_t obj_156)
{
   return is_a__118___object(obj_156, pre_struct_ref_app_207_cfa_info);
}


/* _pre-struct-ref-app? */ obj_t 
_pre_struct_ref_app__54_cfa_info(obj_t env_8287, obj_t obj_8288)
{
   {
      bool_t aux_11261;
      aux_11261 = pre_struct_ref_app__163_cfa_info(obj_8288);
      return BBOOL(aux_11261);
   }
}


/* widening1046-pre-struct-ref-app */ pre_struct_ref_app_207_t 
widening1046_pre_struct_ref_app_29_cfa_info()
{
   {
      return ((pre_struct_ref_app_207_t) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
   }
}


/* _widening1046-pre-struct-ref-app */ obj_t 
_widening1046_pre_struct_ref_app_77_cfa_info(obj_t env_8289)
{
   {
      pre_struct_ref_app_207_t aux_11265;
      aux_11265 = widening1046_pre_struct_ref_app_29_cfa_info();
      return (obj_t) (aux_11265);
   }
}


/* make-pre-struct-ref-app */ pre_struct_ref_app_207_t 
make_pre_struct_ref_app_240_cfa_info(obj_t loc_157, type_t type_158, obj_t side_effect__165_159, obj_t key_160, var_t fun_161, obj_t args_162, obj_t stack_info_255_163)
{
   {
      app_t aux2305_4674;
      {
	 app_t res3680_4696;
	 {
	    app_t new1289_4685;
	    new1289_4685 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4686;
	       arg2999_4686 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4694;
		  obj_4694 = (obj_t) (new1289_4685);
		  (((obj_t) CREF(obj_4694))->header = MAKE_HEADER(arg2999_4686, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_11272;
	       aux_11272 = (object_t) (new1289_4685);
	       OBJECT_WIDENING_SET(aux_11272, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4685))->loc) = ((obj_t) loc_157), BUNSPEC);
	    ((((app_t) CREF(new1289_4685))->type) = ((type_t) type_158), BUNSPEC);
	    ((((app_t) CREF(new1289_4685))->side_effect__165) = ((obj_t) side_effect__165_159), BUNSPEC);
	    ((((app_t) CREF(new1289_4685))->key) = ((obj_t) key_160), BUNSPEC);
	    ((((app_t) CREF(new1289_4685))->fun) = ((var_t) fun_161), BUNSPEC);
	    ((((app_t) CREF(new1289_4685))->args) = ((obj_t) args_162), BUNSPEC);
	    ((((app_t) CREF(new1289_4685))->stack_info_255) = ((obj_t) stack_info_255_163), BUNSPEC);
	    res3680_4696 = new1289_4685;
	 }
	 aux2305_4674 = res3680_4696;
      }
      {
	 pre_struct_ref_app_207_t new2306_4675;
	 new2306_4675 = ((pre_struct_ref_app_207_t) (aux2305_4674));
	 {
	    long arg2816_4676;
	    arg2816_4676 = class_num_218___object(pre_struct_ref_app_207_cfa_info);
	    {
	       obj_t obj_4697;
	       obj_4697 = (obj_t) (new2306_4675);
	       (((obj_t) CREF(obj_4697))->header = MAKE_HEADER(arg2816_4676, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_11288;
	    object_t aux_11286;
	    {
	       pre_struct_ref_app_207_t aux_11289;
	       {
		  aux_11289 = ((pre_struct_ref_app_207_t) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
	       }
	       aux_11288 = (obj_t) (aux_11289);
	    }
	    aux_11286 = (object_t) (new2306_4675);
	    OBJECT_WIDENING_SET(aux_11286, aux_11288);
	 }
	 return new2306_4675;
      }
   }
}


/* _make-pre-struct-ref-app3884 */ obj_t 
_make_pre_struct_ref_app3884_217_cfa_info(obj_t env_8290, obj_t loc_8291, obj_t type_8292, obj_t side_effect__165_8293, obj_t key_8294, obj_t fun_8295, obj_t args_8296, obj_t stack_info_255_8297)
{
   {
      pre_struct_ref_app_207_t aux_11293;
      aux_11293 = make_pre_struct_ref_app_240_cfa_info(loc_8291, (type_t) (type_8292), side_effect__165_8293, key_8294, (var_t) (fun_8295), args_8296, stack_info_255_8297);
      return (obj_t) (aux_11293);
   }
}


/* pre-struct-ref-app-loc */ obj_t 
pre_struct_ref_app_loc_17_cfa_info(app_t obj_164)
{
   return (((app_t) CREF(obj_164))->loc);
}


/* _pre-struct-ref-app-loc3885 */ obj_t 
_pre_struct_ref_app_loc3885_215_cfa_info(obj_t env_8298, obj_t obj_8299)
{
   return pre_struct_ref_app_loc_17_cfa_info((app_t) (obj_8299));
}


/* pre-struct-ref-app-type-set! */ obj_t 
pre_struct_ref_app_type_set__101_cfa_info(app_t obj_165, type_t val2307_166)
{
   return ((((app_t) CREF(obj_165))->type) = ((type_t) val2307_166), BUNSPEC);
}


/* _pre-struct-ref-app-type-set!3886 */ obj_t 
_pre_struct_ref_app_type_set_3886_192_cfa_info(obj_t env_8300, obj_t obj_8301, obj_t val2307_8302)
{
   return pre_struct_ref_app_type_set__101_cfa_info((app_t) (obj_8301), (type_t) (val2307_8302));
}


/* pre-struct-ref-app-type */ type_t 
pre_struct_ref_app_type_242_cfa_info(app_t obj_167)
{
   return (((app_t) CREF(obj_167))->type);
}


/* _pre-struct-ref-app-type3887 */ obj_t 
_pre_struct_ref_app_type3887_59_cfa_info(obj_t env_8303, obj_t obj_8304)
{
   {
      type_t aux_11306;
      aux_11306 = pre_struct_ref_app_type_242_cfa_info((app_t) (obj_8304));
      return (obj_t) (aux_11306);
   }
}


/* pre-struct-ref-app-side-effect?-set! */ obj_t 
pre_struct_ref_app_side_effect__set__16_cfa_info(app_t obj_168, obj_t val2308_169)
{
   return ((((app_t) CREF(obj_168))->side_effect__165) = ((obj_t) val2308_169), BUNSPEC);
}


/* _pre-struct-ref-app-side-effect?-set!3888 */ obj_t 
_pre_struct_ref_app_side_effect__set_3888_128_cfa_info(obj_t env_8305, obj_t obj_8306, obj_t val2308_8307)
{
   return pre_struct_ref_app_side_effect__set__16_cfa_info((app_t) (obj_8306), val2308_8307);
}


/* pre-struct-ref-app-side-effect? */ obj_t 
pre_struct_ref_app_side_effect__198_cfa_info(app_t obj_170)
{
   return (((app_t) CREF(obj_170))->side_effect__165);
}


/* _pre-struct-ref-app-side-effect?3889 */ obj_t 
_pre_struct_ref_app_side_effect_3889_58_cfa_info(obj_t env_8308, obj_t obj_8309)
{
   return pre_struct_ref_app_side_effect__198_cfa_info((app_t) (obj_8309));
}


/* pre-struct-ref-app-key-set! */ obj_t 
pre_struct_ref_app_key_set__138_cfa_info(app_t obj_171, obj_t val2309_172)
{
   return ((((app_t) CREF(obj_171))->key) = ((obj_t) val2309_172), BUNSPEC);
}


/* _pre-struct-ref-app-key-set! */ obj_t 
_pre_struct_ref_app_key_set__136_cfa_info(obj_t env_8310, obj_t obj_8311, obj_t val2309_8312)
{
   return pre_struct_ref_app_key_set__138_cfa_info((app_t) (obj_8311), val2309_8312);
}


/* pre-struct-ref-app-key */ obj_t 
pre_struct_ref_app_key_6_cfa_info(app_t obj_173)
{
   return (((app_t) CREF(obj_173))->key);
}


/* _pre-struct-ref-app-key */ obj_t 
_pre_struct_ref_app_key_126_cfa_info(obj_t env_8313, obj_t obj_8314)
{
   return pre_struct_ref_app_key_6_cfa_info((app_t) (obj_8314));
}


/* pre-struct-ref-app-fun-set! */ obj_t 
pre_struct_ref_app_fun_set__223_cfa_info(app_t obj_174, var_t val2310_175)
{
   return ((((app_t) CREF(obj_174))->fun) = ((var_t) val2310_175), BUNSPEC);
}


/* _pre-struct-ref-app-fun-set!3890 */ obj_t 
_pre_struct_ref_app_fun_set_3890_179_cfa_info(obj_t env_8315, obj_t obj_8316, obj_t val2310_8317)
{
   return pre_struct_ref_app_fun_set__223_cfa_info((app_t) (obj_8316), (var_t) (val2310_8317));
}


/* pre-struct-ref-app-fun */ var_t 
pre_struct_ref_app_fun_229_cfa_info(app_t obj_176)
{
   return (((app_t) CREF(obj_176))->fun);
}


/* _pre-struct-ref-app-fun3891 */ obj_t 
_pre_struct_ref_app_fun3891_141_cfa_info(obj_t env_8318, obj_t obj_8319)
{
   {
      var_t aux_11327;
      aux_11327 = pre_struct_ref_app_fun_229_cfa_info((app_t) (obj_8319));
      return (obj_t) (aux_11327);
   }
}


/* pre-struct-ref-app-args-set! */ obj_t 
pre_struct_ref_app_args_set__168_cfa_info(app_t obj_177, obj_t val2311_178)
{
   return ((((app_t) CREF(obj_177))->args) = ((obj_t) val2311_178), BUNSPEC);
}


/* _pre-struct-ref-app-args-set!3892 */ obj_t 
_pre_struct_ref_app_args_set_3892_26_cfa_info(obj_t env_8320, obj_t obj_8321, obj_t val2311_8322)
{
   return pre_struct_ref_app_args_set__168_cfa_info((app_t) (obj_8321), val2311_8322);
}


/* pre-struct-ref-app-args */ obj_t 
pre_struct_ref_app_args_87_cfa_info(app_t obj_179)
{
   return (((app_t) CREF(obj_179))->args);
}


/* _pre-struct-ref-app-args3893 */ obj_t 
_pre_struct_ref_app_args3893_29_cfa_info(obj_t env_8323, obj_t obj_8324)
{
   return pre_struct_ref_app_args_87_cfa_info((app_t) (obj_8324));
}


/* pre-struct-ref-app-stack-info-set! */ obj_t 
pre_struct_ref_app_stack_info_set__163_cfa_info(app_t obj_180, obj_t val2312_181)
{
   return ((((app_t) CREF(obj_180))->stack_info_255) = ((obj_t) val2312_181), BUNSPEC);
}


/* _pre-struct-ref-app-stack-info-set!3894 */ obj_t 
_pre_struct_ref_app_stack_info_set_3894_151_cfa_info(obj_t env_8325, obj_t obj_8326, obj_t val2312_8327)
{
   return pre_struct_ref_app_stack_info_set__163_cfa_info((app_t) (obj_8326), val2312_8327);
}


/* pre-struct-ref-app-stack-info */ obj_t 
pre_struct_ref_app_stack_info_193_cfa_info(app_t obj_182)
{
   return (((app_t) CREF(obj_182))->stack_info_255);
}


/* _pre-struct-ref-app-stack-info3895 */ obj_t 
_pre_struct_ref_app_stack_info3895_249_cfa_info(obj_t env_8328, obj_t obj_8329)
{
   return pre_struct_ref_app_stack_info_193_cfa_info((app_t) (obj_8329));
}


/* allocate-pre-make-struct-app */ app_t 
allocate_pre_make_struct_app_64_cfa_info()
{
   {
      app_t new2296_2487;
      new2296_2487 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2818_2488;
	 arg2818_2488 = class_num_218___object(pre_make_struct_app_218_cfa_info);
	 {
	    obj_t obj_4701;
	    obj_4701 = (obj_t) (new2296_2487);
	    (((obj_t) CREF(obj_4701))->header = MAKE_HEADER(arg2818_2488, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11347;
	 aux_11347 = (object_t) (new2296_2487);
	 OBJECT_WIDENING_SET(aux_11347, BFALSE);
      }
      return new2296_2487;
   }
}


/* _allocate-pre-make-struct-app */ obj_t 
_allocate_pre_make_struct_app_85_cfa_info(obj_t env_8065)
{
   {
      app_t aux_11350;
      aux_11350 = allocate_pre_make_struct_app_64_cfa_info();
      return (obj_t) (aux_11350);
   }
}


/* pre-make-struct-app? */ bool_t 
pre_make_struct_app__0_cfa_info(obj_t obj_186)
{
   return is_a__118___object(obj_186, pre_make_struct_app_218_cfa_info);
}


/* _pre-make-struct-app? */ obj_t 
_pre_make_struct_app__245_cfa_info(obj_t env_8330, obj_t obj_8331)
{
   {
      bool_t aux_11354;
      aux_11354 = pre_make_struct_app__0_cfa_info(obj_8331);
      return BBOOL(aux_11354);
   }
}


/* widening1045-pre-make-struct-app */ pre_make_struct_app_218_t 
widening1045_pre_make_struct_app_3_cfa_info(variable_t owner_187)
{
   {
      pre_make_struct_app_218_t new2285_4703;
      new2285_4703 = ((pre_make_struct_app_218_t) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
      ((((pre_make_struct_app_218_t) CREF(new2285_4703))->owner) = ((variable_t) owner_187), BUNSPEC);
      return new2285_4703;
   }
}


/* _widening1045-pre-make-struct-app3896 */ obj_t 
_widening1045_pre_make_struct_app3896_78_cfa_info(obj_t env_8332, obj_t owner_8333)
{
   {
      pre_make_struct_app_218_t aux_11359;
      aux_11359 = widening1045_pre_make_struct_app_3_cfa_info((variable_t) (owner_8333));
      return (obj_t) (aux_11359);
   }
}


/* make-pre-make-struct-app */ pre_make_struct_app_218_t 
make_pre_make_struct_app_250_cfa_info(obj_t loc_188, type_t type_189, obj_t side_effect__165_190, obj_t key_191, var_t fun_192, obj_t args_193, obj_t stack_info_255_194, variable_t owner_195)
{
   {
      app_t aux2288_4705;
      {
	 app_t res3682_4727;
	 {
	    app_t new1289_4716;
	    new1289_4716 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4717;
	       arg2999_4717 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4725;
		  obj_4725 = (obj_t) (new1289_4716);
		  (((obj_t) CREF(obj_4725))->header = MAKE_HEADER(arg2999_4717, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_11367;
	       aux_11367 = (object_t) (new1289_4716);
	       OBJECT_WIDENING_SET(aux_11367, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4716))->loc) = ((obj_t) loc_188), BUNSPEC);
	    ((((app_t) CREF(new1289_4716))->type) = ((type_t) type_189), BUNSPEC);
	    ((((app_t) CREF(new1289_4716))->side_effect__165) = ((obj_t) side_effect__165_190), BUNSPEC);
	    ((((app_t) CREF(new1289_4716))->key) = ((obj_t) key_191), BUNSPEC);
	    ((((app_t) CREF(new1289_4716))->fun) = ((var_t) fun_192), BUNSPEC);
	    ((((app_t) CREF(new1289_4716))->args) = ((obj_t) args_193), BUNSPEC);
	    ((((app_t) CREF(new1289_4716))->stack_info_255) = ((obj_t) stack_info_255_194), BUNSPEC);
	    res3682_4727 = new1289_4716;
	 }
	 aux2288_4705 = res3682_4727;
      }
      {
	 pre_make_struct_app_218_t new2289_4706;
	 new2289_4706 = ((pre_make_struct_app_218_t) (aux2288_4705));
	 {
	    long arg2819_4707;
	    arg2819_4707 = class_num_218___object(pre_make_struct_app_218_cfa_info);
	    {
	       obj_t obj_4728;
	       obj_4728 = (obj_t) (new2289_4706);
	       (((obj_t) CREF(obj_4728))->header = MAKE_HEADER(arg2819_4707, 0), BUNSPEC);
	    }
	 }
	 {
	    pre_make_struct_app_218_t arg2820_4708;
	    {
	       pre_make_struct_app_218_t res3683_4733;
	       {
		  pre_make_struct_app_218_t new2285_4731;
		  new2285_4731 = ((pre_make_struct_app_218_t) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
		  ((((pre_make_struct_app_218_t) CREF(new2285_4731))->owner) = ((variable_t) owner_195), BUNSPEC);
		  res3683_4733 = new2285_4731;
	       }
	       arg2820_4708 = res3683_4733;
	    }
	    {
	       obj_t aux_11385;
	       object_t aux_11383;
	       aux_11385 = (obj_t) (arg2820_4708);
	       aux_11383 = (object_t) (new2289_4706);
	       OBJECT_WIDENING_SET(aux_11383, aux_11385);
	    }
	 }
	 return new2289_4706;
      }
   }
}


/* _make-pre-make-struct-app3897 */ obj_t 
_make_pre_make_struct_app3897_100_cfa_info(obj_t env_8334, obj_t loc_8335, obj_t type_8336, obj_t side_effect__165_8337, obj_t key_8338, obj_t fun_8339, obj_t args_8340, obj_t stack_info_255_8341, obj_t owner_8342)
{
   {
      pre_make_struct_app_218_t aux_11388;
      aux_11388 = make_pre_make_struct_app_250_cfa_info(loc_8335, (type_t) (type_8336), side_effect__165_8337, key_8338, (var_t) (fun_8339), args_8340, stack_info_255_8341, (variable_t) (owner_8342));
      return (obj_t) (aux_11388);
   }
}


/* pre-make-struct-app-loc */ obj_t 
pre_make_struct_app_loc_207_cfa_info(app_t obj_196)
{
   return (((app_t) CREF(obj_196))->loc);
}


/* _pre-make-struct-app-loc3898 */ obj_t 
_pre_make_struct_app_loc3898_247_cfa_info(obj_t env_8343, obj_t obj_8344)
{
   return pre_make_struct_app_loc_207_cfa_info((app_t) (obj_8344));
}


/* pre-make-struct-app-type-set! */ obj_t 
pre_make_struct_app_type_set__1_cfa_info(app_t obj_197, type_t val2290_198)
{
   return ((((app_t) CREF(obj_197))->type) = ((type_t) val2290_198), BUNSPEC);
}


/* _pre-make-struct-app-type-set!3899 */ obj_t 
_pre_make_struct_app_type_set_3899_16_cfa_info(obj_t env_8345, obj_t obj_8346, obj_t val2290_8347)
{
   return pre_make_struct_app_type_set__1_cfa_info((app_t) (obj_8346), (type_t) (val2290_8347));
}


/* pre-make-struct-app-type */ type_t 
pre_make_struct_app_type_250_cfa_info(app_t obj_199)
{
   return (((app_t) CREF(obj_199))->type);
}


/* _pre-make-struct-app-type3900 */ obj_t 
_pre_make_struct_app_type3900_2_cfa_info(obj_t env_8348, obj_t obj_8349)
{
   {
      type_t aux_11402;
      aux_11402 = pre_make_struct_app_type_250_cfa_info((app_t) (obj_8349));
      return (obj_t) (aux_11402);
   }
}


/* pre-make-struct-app-side-effect?-set! */ obj_t 
pre_make_struct_app_side_effect__set__106_cfa_info(app_t obj_200, obj_t val2291_201)
{
   return ((((app_t) CREF(obj_200))->side_effect__165) = ((obj_t) val2291_201), BUNSPEC);
}


/* _pre-make-struct-app-side-effect?-set!3901 */ obj_t 
_pre_make_struct_app_side_effect__set_3901_34_cfa_info(obj_t env_8350, obj_t obj_8351, obj_t val2291_8352)
{
   return pre_make_struct_app_side_effect__set__106_cfa_info((app_t) (obj_8351), val2291_8352);
}


/* pre-make-struct-app-side-effect? */ obj_t 
pre_make_struct_app_side_effect__189_cfa_info(app_t obj_202)
{
   return (((app_t) CREF(obj_202))->side_effect__165);
}


/* _pre-make-struct-app-side-effect?3902 */ obj_t 
_pre_make_struct_app_side_effect_3902_234_cfa_info(obj_t env_8353, obj_t obj_8354)
{
   return pre_make_struct_app_side_effect__189_cfa_info((app_t) (obj_8354));
}


/* pre-make-struct-app-key-set! */ obj_t 
pre_make_struct_app_key_set__227_cfa_info(app_t obj_203, obj_t val2292_204)
{
   return ((((app_t) CREF(obj_203))->key) = ((obj_t) val2292_204), BUNSPEC);
}


/* _pre-make-struct-app-key-set!3903 */ obj_t 
_pre_make_struct_app_key_set_3903_249_cfa_info(obj_t env_8355, obj_t obj_8356, obj_t val2292_8357)
{
   return pre_make_struct_app_key_set__227_cfa_info((app_t) (obj_8356), val2292_8357);
}


/* pre-make-struct-app-key */ obj_t 
pre_make_struct_app_key_253_cfa_info(app_t obj_205)
{
   return (((app_t) CREF(obj_205))->key);
}


/* _pre-make-struct-app-key3904 */ obj_t 
_pre_make_struct_app_key3904_233_cfa_info(obj_t env_8358, obj_t obj_8359)
{
   return pre_make_struct_app_key_253_cfa_info((app_t) (obj_8359));
}


/* pre-make-struct-app-fun-set! */ obj_t 
pre_make_struct_app_fun_set__18_cfa_info(app_t obj_206, var_t val2293_207)
{
   return ((((app_t) CREF(obj_206))->fun) = ((var_t) val2293_207), BUNSPEC);
}


/* _pre-make-struct-app-fun-set!3905 */ obj_t 
_pre_make_struct_app_fun_set_3905_60_cfa_info(obj_t env_8360, obj_t obj_8361, obj_t val2293_8362)
{
   return pre_make_struct_app_fun_set__18_cfa_info((app_t) (obj_8361), (var_t) (val2293_8362));
}


/* pre-make-struct-app-fun */ var_t 
pre_make_struct_app_fun_214_cfa_info(app_t obj_208)
{
   return (((app_t) CREF(obj_208))->fun);
}


/* _pre-make-struct-app-fun3906 */ obj_t 
_pre_make_struct_app_fun3906_132_cfa_info(obj_t env_8363, obj_t obj_8364)
{
   {
      var_t aux_11423;
      aux_11423 = pre_make_struct_app_fun_214_cfa_info((app_t) (obj_8364));
      return (obj_t) (aux_11423);
   }
}


/* pre-make-struct-app-args-set! */ obj_t 
pre_make_struct_app_args_set__137_cfa_info(app_t obj_209, obj_t val2294_210)
{
   return ((((app_t) CREF(obj_209))->args) = ((obj_t) val2294_210), BUNSPEC);
}


/* _pre-make-struct-app-args-set!3907 */ obj_t 
_pre_make_struct_app_args_set_3907_42_cfa_info(obj_t env_8365, obj_t obj_8366, obj_t val2294_8367)
{
   return pre_make_struct_app_args_set__137_cfa_info((app_t) (obj_8366), val2294_8367);
}


/* pre-make-struct-app-args */ obj_t 
pre_make_struct_app_args_251_cfa_info(app_t obj_211)
{
   return (((app_t) CREF(obj_211))->args);
}


/* _pre-make-struct-app-args3908 */ obj_t 
_pre_make_struct_app_args3908_145_cfa_info(obj_t env_8368, obj_t obj_8369)
{
   return pre_make_struct_app_args_251_cfa_info((app_t) (obj_8369));
}


/* pre-make-struct-app-stack-info-set! */ obj_t 
pre_make_struct_app_stack_info_set__82_cfa_info(app_t obj_212, obj_t val2295_213)
{
   return ((((app_t) CREF(obj_212))->stack_info_255) = ((obj_t) val2295_213), BUNSPEC);
}


/* _pre-make-struct-app-stack-info-set!3909 */ obj_t 
_pre_make_struct_app_stack_info_set_3909_197_cfa_info(obj_t env_8370, obj_t obj_8371, obj_t val2295_8372)
{
   return pre_make_struct_app_stack_info_set__82_cfa_info((app_t) (obj_8371), val2295_8372);
}


/* pre-make-struct-app-stack-info */ obj_t 
pre_make_struct_app_stack_info_182_cfa_info(app_t obj_214)
{
   return (((app_t) CREF(obj_214))->stack_info_255);
}


/* _pre-make-struct-app-stack-info3910 */ obj_t 
_pre_make_struct_app_stack_info3910_27_cfa_info(obj_t env_8373, obj_t obj_8374)
{
   return pre_make_struct_app_stack_info_182_cfa_info((app_t) (obj_8374));
}


/* pre-make-struct-app-owner */ variable_t 
pre_make_struct_app_owner_50_cfa_info(pre_make_struct_app_218_t obj_215)
{
   {
      obj_t aux_11439;
      {
	 object_t aux_11440;
	 aux_11440 = (object_t) (obj_215);
	 aux_11439 = OBJECT_WIDENING(aux_11440);
      }
      return (((pre_make_struct_app_218_t) CREF(aux_11439))->owner);
   }
}


/* _pre-make-struct-app-owner3911 */ obj_t 
_pre_make_struct_app_owner3911_67_cfa_info(obj_t env_8375, obj_t obj_8376)
{
   {
      variable_t aux_11444;
      aux_11444 = pre_make_struct_app_owner_50_cfa_info((pre_make_struct_app_218_t) (obj_8376));
      return (obj_t) (aux_11444);
   }
}


/* allocate-vector-set!-app */ app_t 
allocate_vector_set__app_126_cfa_info()
{
   {
      app_t new2278_2495;
      new2278_2495 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2821_2496;
	 arg2821_2496 = class_num_218___object(vector_set__app_21_cfa_info);
	 {
	    obj_t obj_4734;
	    obj_4734 = (obj_t) (new2278_2495);
	    (((obj_t) CREF(obj_4734))->header = MAKE_HEADER(arg2821_2496, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11452;
	 aux_11452 = (object_t) (new2278_2495);
	 OBJECT_WIDENING_SET(aux_11452, BFALSE);
      }
      return new2278_2495;
   }
}


/* _allocate-vector-set!-app */ obj_t 
_allocate_vector_set__app_158_cfa_info(obj_t env_8064)
{
   {
      app_t aux_11455;
      aux_11455 = allocate_vector_set__app_126_cfa_info();
      return (obj_t) (aux_11455);
   }
}


/* vector-set!-app? */ bool_t 
vector_set__app__15_cfa_info(obj_t obj_219)
{
   return is_a__118___object(obj_219, vector_set__app_21_cfa_info);
}


/* _vector-set!-app? */ obj_t 
_vector_set__app__140_cfa_info(obj_t env_8377, obj_t obj_8378)
{
   {
      bool_t aux_11459;
      aux_11459 = vector_set__app__15_cfa_info(obj_8378);
      return BBOOL(aux_11459);
   }
}


/* widening1044-vector-set!-app */ vector_set__app_21_t 
widening1044_vector_set__app_206_cfa_info(approx_t approx_220)
{
   {
      vector_set__app_21_t new2267_4736;
      new2267_4736 = ((vector_set__app_21_t) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
      ((((vector_set__app_21_t) CREF(new2267_4736))->approx) = ((approx_t) approx_220), BUNSPEC);
      return new2267_4736;
   }
}


/* _widening1044-vector-set!-app3912 */ obj_t 
_widening1044_vector_set__app3912_19_cfa_info(obj_t env_8379, obj_t approx_8380)
{
   {
      vector_set__app_21_t aux_11464;
      aux_11464 = widening1044_vector_set__app_206_cfa_info((approx_t) (approx_8380));
      return (obj_t) (aux_11464);
   }
}


/* make-vector-set!-app */ vector_set__app_21_t 
make_vector_set__app_24_cfa_info(obj_t loc_221, type_t type_222, obj_t side_effect__165_223, obj_t key_224, var_t fun_225, obj_t args_226, obj_t stack_info_255_227, approx_t approx_228)
{
   {
      app_t aux2270_4738;
      {
	 app_t res3684_4760;
	 {
	    app_t new1289_4749;
	    new1289_4749 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4750;
	       arg2999_4750 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4758;
		  obj_4758 = (obj_t) (new1289_4749);
		  (((obj_t) CREF(obj_4758))->header = MAKE_HEADER(arg2999_4750, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_11472;
	       aux_11472 = (object_t) (new1289_4749);
	       OBJECT_WIDENING_SET(aux_11472, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4749))->loc) = ((obj_t) loc_221), BUNSPEC);
	    ((((app_t) CREF(new1289_4749))->type) = ((type_t) type_222), BUNSPEC);
	    ((((app_t) CREF(new1289_4749))->side_effect__165) = ((obj_t) side_effect__165_223), BUNSPEC);
	    ((((app_t) CREF(new1289_4749))->key) = ((obj_t) key_224), BUNSPEC);
	    ((((app_t) CREF(new1289_4749))->fun) = ((var_t) fun_225), BUNSPEC);
	    ((((app_t) CREF(new1289_4749))->args) = ((obj_t) args_226), BUNSPEC);
	    ((((app_t) CREF(new1289_4749))->stack_info_255) = ((obj_t) stack_info_255_227), BUNSPEC);
	    res3684_4760 = new1289_4749;
	 }
	 aux2270_4738 = res3684_4760;
      }
      {
	 vector_set__app_21_t new2271_4739;
	 new2271_4739 = ((vector_set__app_21_t) (aux2270_4738));
	 {
	    long arg2822_4740;
	    arg2822_4740 = class_num_218___object(vector_set__app_21_cfa_info);
	    {
	       obj_t obj_4761;
	       obj_4761 = (obj_t) (new2271_4739);
	       (((obj_t) CREF(obj_4761))->header = MAKE_HEADER(arg2822_4740, 0), BUNSPEC);
	    }
	 }
	 {
	    vector_set__app_21_t arg2823_4741;
	    {
	       vector_set__app_21_t res3685_4766;
	       {
		  vector_set__app_21_t new2267_4764;
		  new2267_4764 = ((vector_set__app_21_t) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
		  ((((vector_set__app_21_t) CREF(new2267_4764))->approx) = ((approx_t) approx_228), BUNSPEC);
		  res3685_4766 = new2267_4764;
	       }
	       arg2823_4741 = res3685_4766;
	    }
	    {
	       obj_t aux_11490;
	       object_t aux_11488;
	       aux_11490 = (obj_t) (arg2823_4741);
	       aux_11488 = (object_t) (new2271_4739);
	       OBJECT_WIDENING_SET(aux_11488, aux_11490);
	    }
	 }
	 return new2271_4739;
      }
   }
}


/* _make-vector-set!-app3913 */ obj_t 
_make_vector_set__app3913_180_cfa_info(obj_t env_8381, obj_t loc_8382, obj_t type_8383, obj_t side_effect__165_8384, obj_t key_8385, obj_t fun_8386, obj_t args_8387, obj_t stack_info_255_8388, obj_t approx_8389)
{
   {
      vector_set__app_21_t aux_11493;
      aux_11493 = make_vector_set__app_24_cfa_info(loc_8382, (type_t) (type_8383), side_effect__165_8384, key_8385, (var_t) (fun_8386), args_8387, stack_info_255_8388, (approx_t) (approx_8389));
      return (obj_t) (aux_11493);
   }
}


/* vector-set!-app-loc */ obj_t 
vector_set__app_loc_147_cfa_info(app_t obj_229)
{
   return (((app_t) CREF(obj_229))->loc);
}


/* _vector-set!-app-loc3914 */ obj_t 
_vector_set__app_loc3914_162_cfa_info(obj_t env_8390, obj_t obj_8391)
{
   return vector_set__app_loc_147_cfa_info((app_t) (obj_8391));
}


/* vector-set!-app-type-set! */ obj_t 
vector_set__app_type_set__199_cfa_info(app_t obj_230, type_t val2272_231)
{
   return ((((app_t) CREF(obj_230))->type) = ((type_t) val2272_231), BUNSPEC);
}


/* _vector-set!-app-type-set!3915 */ obj_t 
_vector_set__app_type_set_3915_252_cfa_info(obj_t env_8392, obj_t obj_8393, obj_t val2272_8394)
{
   return vector_set__app_type_set__199_cfa_info((app_t) (obj_8393), (type_t) (val2272_8394));
}


/* vector-set!-app-type */ type_t 
vector_set__app_type_116_cfa_info(app_t obj_232)
{
   return (((app_t) CREF(obj_232))->type);
}


/* _vector-set!-app-type3916 */ obj_t 
_vector_set__app_type3916_3_cfa_info(obj_t env_8395, obj_t obj_8396)
{
   {
      type_t aux_11507;
      aux_11507 = vector_set__app_type_116_cfa_info((app_t) (obj_8396));
      return (obj_t) (aux_11507);
   }
}


/* vector-set!-app-side-effect?-set! */ obj_t 
vector_set__app_side_effect__set__230_cfa_info(app_t obj_233, obj_t val2273_234)
{
   return ((((app_t) CREF(obj_233))->side_effect__165) = ((obj_t) val2273_234), BUNSPEC);
}


/* _vector-set!-app-side-effect?-set!3917 */ obj_t 
_vector_set__app_side_effect__set_3917_73_cfa_info(obj_t env_8397, obj_t obj_8398, obj_t val2273_8399)
{
   return vector_set__app_side_effect__set__230_cfa_info((app_t) (obj_8398), val2273_8399);
}


/* vector-set!-app-side-effect? */ obj_t 
vector_set__app_side_effect__60_cfa_info(app_t obj_235)
{
   return (((app_t) CREF(obj_235))->side_effect__165);
}


/* _vector-set!-app-side-effect?3918 */ obj_t 
_vector_set__app_side_effect_3918_82_cfa_info(obj_t env_8400, obj_t obj_8401)
{
   return vector_set__app_side_effect__60_cfa_info((app_t) (obj_8401));
}


/* vector-set!-app-key-set! */ obj_t 
vector_set__app_key_set__63_cfa_info(app_t obj_236, obj_t val2274_237)
{
   return ((((app_t) CREF(obj_236))->key) = ((obj_t) val2274_237), BUNSPEC);
}


/* _vector-set!-app-key-set! */ obj_t 
_vector_set__app_key_set__89_cfa_info(obj_t env_8402, obj_t obj_8403, obj_t val2274_8404)
{
   return vector_set__app_key_set__63_cfa_info((app_t) (obj_8403), val2274_8404);
}


/* vector-set!-app-key */ obj_t 
vector_set__app_key_77_cfa_info(app_t obj_238)
{
   return (((app_t) CREF(obj_238))->key);
}


/* _vector-set!-app-key */ obj_t 
_vector_set__app_key_147_cfa_info(obj_t env_8405, obj_t obj_8406)
{
   return vector_set__app_key_77_cfa_info((app_t) (obj_8406));
}


/* vector-set!-app-fun-set! */ obj_t 
vector_set__app_fun_set__135_cfa_info(app_t obj_239, var_t val2275_240)
{
   return ((((app_t) CREF(obj_239))->fun) = ((var_t) val2275_240), BUNSPEC);
}


/* _vector-set!-app-fun-set!3919 */ obj_t 
_vector_set__app_fun_set_3919_16_cfa_info(obj_t env_8407, obj_t obj_8408, obj_t val2275_8409)
{
   return vector_set__app_fun_set__135_cfa_info((app_t) (obj_8408), (var_t) (val2275_8409));
}


/* vector-set!-app-fun */ var_t 
vector_set__app_fun_134_cfa_info(app_t obj_241)
{
   return (((app_t) CREF(obj_241))->fun);
}


/* _vector-set!-app-fun3920 */ obj_t 
_vector_set__app_fun3920_255_cfa_info(obj_t env_8410, obj_t obj_8411)
{
   {
      var_t aux_11528;
      aux_11528 = vector_set__app_fun_134_cfa_info((app_t) (obj_8411));
      return (obj_t) (aux_11528);
   }
}


/* vector-set!-app-args-set! */ obj_t 
vector_set__app_args_set__4_cfa_info(app_t obj_242, obj_t val2276_243)
{
   return ((((app_t) CREF(obj_242))->args) = ((obj_t) val2276_243), BUNSPEC);
}


/* _vector-set!-app-args-set!3921 */ obj_t 
_vector_set__app_args_set_3921_32_cfa_info(obj_t env_8412, obj_t obj_8413, obj_t val2276_8414)
{
   return vector_set__app_args_set__4_cfa_info((app_t) (obj_8413), val2276_8414);
}


/* vector-set!-app-args */ obj_t 
vector_set__app_args_237_cfa_info(app_t obj_244)
{
   return (((app_t) CREF(obj_244))->args);
}


/* _vector-set!-app-args3922 */ obj_t 
_vector_set__app_args3922_148_cfa_info(obj_t env_8415, obj_t obj_8416)
{
   return vector_set__app_args_237_cfa_info((app_t) (obj_8416));
}


/* vector-set!-app-stack-info-set! */ obj_t 
vector_set__app_stack_info_set__132_cfa_info(app_t obj_245, obj_t val2277_246)
{
   return ((((app_t) CREF(obj_245))->stack_info_255) = ((obj_t) val2277_246), BUNSPEC);
}


/* _vector-set!-app-stack-info-set!3923 */ obj_t 
_vector_set__app_stack_info_set_3923_27_cfa_info(obj_t env_8417, obj_t obj_8418, obj_t val2277_8419)
{
   return vector_set__app_stack_info_set__132_cfa_info((app_t) (obj_8418), val2277_8419);
}


/* vector-set!-app-stack-info */ obj_t 
vector_set__app_stack_info_174_cfa_info(app_t obj_247)
{
   return (((app_t) CREF(obj_247))->stack_info_255);
}


/* _vector-set!-app-stack-info3924 */ obj_t 
_vector_set__app_stack_info3924_202_cfa_info(obj_t env_8420, obj_t obj_8421)
{
   return vector_set__app_stack_info_174_cfa_info((app_t) (obj_8421));
}


/* vector-set!-app-approx */ approx_t 
vector_set__app_approx_61_cfa_info(vector_set__app_21_t obj_248)
{
   {
      obj_t aux_11544;
      {
	 object_t aux_11545;
	 aux_11545 = (object_t) (obj_248);
	 aux_11544 = OBJECT_WIDENING(aux_11545);
      }
      return (((vector_set__app_21_t) CREF(aux_11544))->approx);
   }
}


/* _vector-set!-app-approx3925 */ obj_t 
_vector_set__app_approx3925_213_cfa_info(obj_t env_8422, obj_t obj_8423)
{
   {
      approx_t aux_11549;
      aux_11549 = vector_set__app_approx_61_cfa_info((vector_set__app_21_t) (obj_8423));
      return (obj_t) (aux_11549);
   }
}


/* allocate-vector-ref-app */ app_t 
allocate_vector_ref_app_0_cfa_info()
{
   {
      app_t new2260_2503;
      new2260_2503 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2824_2504;
	 arg2824_2504 = class_num_218___object(vector_ref_app_195_cfa_info);
	 {
	    obj_t obj_4767;
	    obj_4767 = (obj_t) (new2260_2503);
	    (((obj_t) CREF(obj_4767))->header = MAKE_HEADER(arg2824_2504, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11557;
	 aux_11557 = (object_t) (new2260_2503);
	 OBJECT_WIDENING_SET(aux_11557, BFALSE);
      }
      return new2260_2503;
   }
}


/* _allocate-vector-ref-app */ obj_t 
_allocate_vector_ref_app_194_cfa_info(obj_t env_8063)
{
   {
      app_t aux_11560;
      aux_11560 = allocate_vector_ref_app_0_cfa_info();
      return (obj_t) (aux_11560);
   }
}


/* vector-ref-app? */ bool_t 
vector_ref_app__203_cfa_info(obj_t obj_252)
{
   return is_a__118___object(obj_252, vector_ref_app_195_cfa_info);
}


/* _vector-ref-app? */ obj_t 
_vector_ref_app__210_cfa_info(obj_t env_8424, obj_t obj_8425)
{
   {
      bool_t aux_11564;
      aux_11564 = vector_ref_app__203_cfa_info(obj_8425);
      return BBOOL(aux_11564);
   }
}


/* widening1043-vector-ref-app */ vector_ref_app_195_t 
widening1043_vector_ref_app_60_cfa_info(approx_t approx_253)
{
   {
      vector_ref_app_195_t new2249_4769;
      new2249_4769 = ((vector_ref_app_195_t) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
      ((((vector_ref_app_195_t) CREF(new2249_4769))->approx) = ((approx_t) approx_253), BUNSPEC);
      return new2249_4769;
   }
}


/* _widening1043-vector-ref-app3926 */ obj_t 
_widening1043_vector_ref_app3926_75_cfa_info(obj_t env_8426, obj_t approx_8427)
{
   {
      vector_ref_app_195_t aux_11569;
      aux_11569 = widening1043_vector_ref_app_60_cfa_info((approx_t) (approx_8427));
      return (obj_t) (aux_11569);
   }
}


/* make-vector-ref-app */ vector_ref_app_195_t 
make_vector_ref_app_105_cfa_info(obj_t loc_254, type_t type_255, obj_t side_effect__165_256, obj_t key_257, var_t fun_258, obj_t args_259, obj_t stack_info_255_260, approx_t approx_261)
{
   {
      app_t aux2252_4771;
      {
	 app_t res3686_4793;
	 {
	    app_t new1289_4782;
	    new1289_4782 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4783;
	       arg2999_4783 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4791;
		  obj_4791 = (obj_t) (new1289_4782);
		  (((obj_t) CREF(obj_4791))->header = MAKE_HEADER(arg2999_4783, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_11577;
	       aux_11577 = (object_t) (new1289_4782);
	       OBJECT_WIDENING_SET(aux_11577, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4782))->loc) = ((obj_t) loc_254), BUNSPEC);
	    ((((app_t) CREF(new1289_4782))->type) = ((type_t) type_255), BUNSPEC);
	    ((((app_t) CREF(new1289_4782))->side_effect__165) = ((obj_t) side_effect__165_256), BUNSPEC);
	    ((((app_t) CREF(new1289_4782))->key) = ((obj_t) key_257), BUNSPEC);
	    ((((app_t) CREF(new1289_4782))->fun) = ((var_t) fun_258), BUNSPEC);
	    ((((app_t) CREF(new1289_4782))->args) = ((obj_t) args_259), BUNSPEC);
	    ((((app_t) CREF(new1289_4782))->stack_info_255) = ((obj_t) stack_info_255_260), BUNSPEC);
	    res3686_4793 = new1289_4782;
	 }
	 aux2252_4771 = res3686_4793;
      }
      {
	 vector_ref_app_195_t new2253_4772;
	 new2253_4772 = ((vector_ref_app_195_t) (aux2252_4771));
	 {
	    long arg2825_4773;
	    arg2825_4773 = class_num_218___object(vector_ref_app_195_cfa_info);
	    {
	       obj_t obj_4794;
	       obj_4794 = (obj_t) (new2253_4772);
	       (((obj_t) CREF(obj_4794))->header = MAKE_HEADER(arg2825_4773, 0), BUNSPEC);
	    }
	 }
	 {
	    vector_ref_app_195_t arg2826_4774;
	    {
	       vector_ref_app_195_t res3687_4799;
	       {
		  vector_ref_app_195_t new2249_4797;
		  new2249_4797 = ((vector_ref_app_195_t) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
		  ((((vector_ref_app_195_t) CREF(new2249_4797))->approx) = ((approx_t) approx_261), BUNSPEC);
		  res3687_4799 = new2249_4797;
	       }
	       arg2826_4774 = res3687_4799;
	    }
	    {
	       obj_t aux_11595;
	       object_t aux_11593;
	       aux_11595 = (obj_t) (arg2826_4774);
	       aux_11593 = (object_t) (new2253_4772);
	       OBJECT_WIDENING_SET(aux_11593, aux_11595);
	    }
	 }
	 return new2253_4772;
      }
   }
}


/* _make-vector-ref-app3927 */ obj_t 
_make_vector_ref_app3927_130_cfa_info(obj_t env_8428, obj_t loc_8429, obj_t type_8430, obj_t side_effect__165_8431, obj_t key_8432, obj_t fun_8433, obj_t args_8434, obj_t stack_info_255_8435, obj_t approx_8436)
{
   {
      vector_ref_app_195_t aux_11598;
      aux_11598 = make_vector_ref_app_105_cfa_info(loc_8429, (type_t) (type_8430), side_effect__165_8431, key_8432, (var_t) (fun_8433), args_8434, stack_info_255_8435, (approx_t) (approx_8436));
      return (obj_t) (aux_11598);
   }
}


/* vector-ref-app-loc */ obj_t 
vector_ref_app_loc_223_cfa_info(app_t obj_262)
{
   return (((app_t) CREF(obj_262))->loc);
}


/* _vector-ref-app-loc3928 */ obj_t 
_vector_ref_app_loc3928_132_cfa_info(obj_t env_8437, obj_t obj_8438)
{
   return vector_ref_app_loc_223_cfa_info((app_t) (obj_8438));
}


/* vector-ref-app-type-set! */ obj_t 
vector_ref_app_type_set__10_cfa_info(app_t obj_263, type_t val2254_264)
{
   return ((((app_t) CREF(obj_263))->type) = ((type_t) val2254_264), BUNSPEC);
}


/* _vector-ref-app-type-set!3929 */ obj_t 
_vector_ref_app_type_set_3929_191_cfa_info(obj_t env_8439, obj_t obj_8440, obj_t val2254_8441)
{
   return vector_ref_app_type_set__10_cfa_info((app_t) (obj_8440), (type_t) (val2254_8441));
}


/* vector-ref-app-type */ type_t 
vector_ref_app_type_35_cfa_info(app_t obj_265)
{
   return (((app_t) CREF(obj_265))->type);
}


/* _vector-ref-app-type3930 */ obj_t 
_vector_ref_app_type3930_49_cfa_info(obj_t env_8442, obj_t obj_8443)
{
   {
      type_t aux_11612;
      aux_11612 = vector_ref_app_type_35_cfa_info((app_t) (obj_8443));
      return (obj_t) (aux_11612);
   }
}


/* vector-ref-app-side-effect?-set! */ obj_t 
vector_ref_app_side_effect__set__180_cfa_info(app_t obj_266, obj_t val2255_267)
{
   return ((((app_t) CREF(obj_266))->side_effect__165) = ((obj_t) val2255_267), BUNSPEC);
}


/* _vector-ref-app-side-effect?-set!3931 */ obj_t 
_vector_ref_app_side_effect__set_3931_208_cfa_info(obj_t env_8444, obj_t obj_8445, obj_t val2255_8446)
{
   return vector_ref_app_side_effect__set__180_cfa_info((app_t) (obj_8445), val2255_8446);
}


/* vector-ref-app-side-effect? */ obj_t 
vector_ref_app_side_effect__111_cfa_info(app_t obj_268)
{
   return (((app_t) CREF(obj_268))->side_effect__165);
}


/* _vector-ref-app-side-effect?3932 */ obj_t 
_vector_ref_app_side_effect_3932_110_cfa_info(obj_t env_8447, obj_t obj_8448)
{
   return vector_ref_app_side_effect__111_cfa_info((app_t) (obj_8448));
}


/* vector-ref-app-key-set! */ obj_t 
vector_ref_app_key_set__80_cfa_info(app_t obj_269, obj_t val2256_270)
{
   return ((((app_t) CREF(obj_269))->key) = ((obj_t) val2256_270), BUNSPEC);
}


/* _vector-ref-app-key-set! */ obj_t 
_vector_ref_app_key_set__134_cfa_info(obj_t env_8449, obj_t obj_8450, obj_t val2256_8451)
{
   return vector_ref_app_key_set__80_cfa_info((app_t) (obj_8450), val2256_8451);
}


/* vector-ref-app-key */ obj_t 
vector_ref_app_key_24_cfa_info(app_t obj_271)
{
   return (((app_t) CREF(obj_271))->key);
}


/* _vector-ref-app-key */ obj_t 
_vector_ref_app_key_21_cfa_info(obj_t env_8452, obj_t obj_8453)
{
   return vector_ref_app_key_24_cfa_info((app_t) (obj_8453));
}


/* vector-ref-app-fun-set! */ obj_t 
vector_ref_app_fun_set__119_cfa_info(app_t obj_272, var_t val2257_273)
{
   return ((((app_t) CREF(obj_272))->fun) = ((var_t) val2257_273), BUNSPEC);
}


/* _vector-ref-app-fun-set!3933 */ obj_t 
_vector_ref_app_fun_set_3933_193_cfa_info(obj_t env_8454, obj_t obj_8455, obj_t val2257_8456)
{
   return vector_ref_app_fun_set__119_cfa_info((app_t) (obj_8455), (var_t) (val2257_8456));
}


/* vector-ref-app-fun */ var_t 
vector_ref_app_fun_217_cfa_info(app_t obj_274)
{
   return (((app_t) CREF(obj_274))->fun);
}


/* _vector-ref-app-fun3934 */ obj_t 
_vector_ref_app_fun3934_63_cfa_info(obj_t env_8457, obj_t obj_8458)
{
   {
      var_t aux_11633;
      aux_11633 = vector_ref_app_fun_217_cfa_info((app_t) (obj_8458));
      return (obj_t) (aux_11633);
   }
}


/* vector-ref-app-args-set! */ obj_t 
vector_ref_app_args_set__176_cfa_info(app_t obj_275, obj_t val2258_276)
{
   return ((((app_t) CREF(obj_275))->args) = ((obj_t) val2258_276), BUNSPEC);
}


/* _vector-ref-app-args-set!3935 */ obj_t 
_vector_ref_app_args_set_3935_221_cfa_info(obj_t env_8459, obj_t obj_8460, obj_t val2258_8461)
{
   return vector_ref_app_args_set__176_cfa_info((app_t) (obj_8460), val2258_8461);
}


/* vector-ref-app-args */ obj_t 
vector_ref_app_args_194_cfa_info(app_t obj_277)
{
   return (((app_t) CREF(obj_277))->args);
}


/* _vector-ref-app-args3936 */ obj_t 
_vector_ref_app_args3936_244_cfa_info(obj_t env_8462, obj_t obj_8463)
{
   return vector_ref_app_args_194_cfa_info((app_t) (obj_8463));
}


/* vector-ref-app-stack-info-set! */ obj_t 
vector_ref_app_stack_info_set__142_cfa_info(app_t obj_278, obj_t val2259_279)
{
   return ((((app_t) CREF(obj_278))->stack_info_255) = ((obj_t) val2259_279), BUNSPEC);
}


/* _vector-ref-app-stack-info-set!3937 */ obj_t 
_vector_ref_app_stack_info_set_3937_136_cfa_info(obj_t env_8464, obj_t obj_8465, obj_t val2259_8466)
{
   return vector_ref_app_stack_info_set__142_cfa_info((app_t) (obj_8465), val2259_8466);
}


/* vector-ref-app-stack-info */ obj_t 
vector_ref_app_stack_info_39_cfa_info(app_t obj_280)
{
   return (((app_t) CREF(obj_280))->stack_info_255);
}


/* _vector-ref-app-stack-info3938 */ obj_t 
_vector_ref_app_stack_info3938_180_cfa_info(obj_t env_8467, obj_t obj_8468)
{
   return vector_ref_app_stack_info_39_cfa_info((app_t) (obj_8468));
}


/* vector-ref-app-approx */ approx_t 
vector_ref_app_approx_240_cfa_info(vector_ref_app_195_t obj_281)
{
   {
      obj_t aux_11649;
      {
	 object_t aux_11650;
	 aux_11650 = (object_t) (obj_281);
	 aux_11649 = OBJECT_WIDENING(aux_11650);
      }
      return (((vector_ref_app_195_t) CREF(aux_11649))->approx);
   }
}


/* _vector-ref-app-approx3939 */ obj_t 
_vector_ref_app_approx3939_106_cfa_info(obj_t env_8469, obj_t obj_8470)
{
   {
      approx_t aux_11654;
      aux_11654 = vector_ref_app_approx_240_cfa_info((vector_ref_app_195_t) (obj_8470));
      return (obj_t) (aux_11654);
   }
}


/* allocate-create-vector-app */ app_t 
allocate_create_vector_app_89_cfa_info()
{
   {
      app_t new2242_2511;
      new2242_2511 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2827_2512;
	 arg2827_2512 = class_num_218___object(create_vector_app_150_cfa_info);
	 {
	    obj_t obj_4800;
	    obj_4800 = (obj_t) (new2242_2511);
	    (((obj_t) CREF(obj_4800))->header = MAKE_HEADER(arg2827_2512, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11662;
	 aux_11662 = (object_t) (new2242_2511);
	 OBJECT_WIDENING_SET(aux_11662, BFALSE);
      }
      return new2242_2511;
   }
}


/* _allocate-create-vector-app */ obj_t 
_allocate_create_vector_app_246_cfa_info(obj_t env_8062)
{
   {
      app_t aux_11665;
      aux_11665 = allocate_create_vector_app_89_cfa_info();
      return (obj_t) (aux_11665);
   }
}


/* create-vector-app? */ bool_t 
create_vector_app__151_cfa_info(obj_t obj_285)
{
   return is_a__118___object(obj_285, create_vector_app_150_cfa_info);
}


/* _create-vector-app? */ obj_t 
_create_vector_app__45_cfa_info(obj_t env_8471, obj_t obj_8472)
{
   {
      bool_t aux_11669;
      aux_11669 = create_vector_app__151_cfa_info(obj_8472);
      return BBOOL(aux_11669);
   }
}


/* widening1042-create-vector-app */ create_vector_app_150_t 
widening1042_create_vector_app_219_cfa_info(approx_t approx_286, approx_t value_approx_19_287, long lost_stamp_114_288, variable_t owner_289, bool_t stackable__42_290, obj_t stack_stamp_31_291, bool_t seen__39_292)
{
   {
      create_vector_app_150_t new2220_4802;
      new2220_4802 = ((create_vector_app_150_t) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
      ((((create_vector_app_150_t) CREF(new2220_4802))->approx) = ((approx_t) approx_286), BUNSPEC);
      ((((create_vector_app_150_t) CREF(new2220_4802))->value_approx_19) = ((approx_t) value_approx_19_287), BUNSPEC);
      ((((create_vector_app_150_t) CREF(new2220_4802))->lost_stamp_114) = ((long) lost_stamp_114_288), BUNSPEC);
      ((((create_vector_app_150_t) CREF(new2220_4802))->owner) = ((variable_t) owner_289), BUNSPEC);
      ((((create_vector_app_150_t) CREF(new2220_4802))->stackable__42) = ((bool_t) stackable__42_290), BUNSPEC);
      ((((create_vector_app_150_t) CREF(new2220_4802))->stack_stamp_31) = ((obj_t) stack_stamp_31_291), BUNSPEC);
      ((((create_vector_app_150_t) CREF(new2220_4802))->seen__39) = ((bool_t) seen__39_292), BUNSPEC);
      return new2220_4802;
   }
}


/* _widening1042-create-vector-app3940 */ obj_t 
_widening1042_create_vector_app3940_225_cfa_info(obj_t env_8473, obj_t approx_8474, obj_t value_approx_19_8475, obj_t lost_stamp_114_8476, obj_t owner_8477, obj_t stackable__42_8478, obj_t stack_stamp_31_8479, obj_t seen__39_8480)
{
   {
      create_vector_app_150_t aux_11680;
      aux_11680 = widening1042_create_vector_app_219_cfa_info((approx_t) (approx_8474), (approx_t) (value_approx_19_8475), (long) CINT(lost_stamp_114_8476), (variable_t) (owner_8477), CBOOL(stackable__42_8478), stack_stamp_31_8479, CBOOL(seen__39_8480));
      return (obj_t) (aux_11680);
   }
}


/* make-create-vector-app */ create_vector_app_150_t 
make_create_vector_app_136_cfa_info(obj_t loc_293, type_t type_294, obj_t side_effect__165_295, obj_t key_296, var_t fun_297, obj_t args_298, obj_t stack_info_255_299, approx_t approx_300, approx_t value_approx_19_301, long lost_stamp_114_302, variable_t owner_303, bool_t stackable__42_304, obj_t stack_stamp_31_305, bool_t seen__39_306)
{
   {
      app_t aux2229_4810;
      {
	 app_t res3688_4832;
	 {
	    app_t new1289_4821;
	    new1289_4821 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4822;
	       arg2999_4822 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4830;
		  obj_4830 = (obj_t) (new1289_4821);
		  (((obj_t) CREF(obj_4830))->header = MAKE_HEADER(arg2999_4822, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_11693;
	       aux_11693 = (object_t) (new1289_4821);
	       OBJECT_WIDENING_SET(aux_11693, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4821))->loc) = ((obj_t) loc_293), BUNSPEC);
	    ((((app_t) CREF(new1289_4821))->type) = ((type_t) type_294), BUNSPEC);
	    ((((app_t) CREF(new1289_4821))->side_effect__165) = ((obj_t) side_effect__165_295), BUNSPEC);
	    ((((app_t) CREF(new1289_4821))->key) = ((obj_t) key_296), BUNSPEC);
	    ((((app_t) CREF(new1289_4821))->fun) = ((var_t) fun_297), BUNSPEC);
	    ((((app_t) CREF(new1289_4821))->args) = ((obj_t) args_298), BUNSPEC);
	    ((((app_t) CREF(new1289_4821))->stack_info_255) = ((obj_t) stack_info_255_299), BUNSPEC);
	    res3688_4832 = new1289_4821;
	 }
	 aux2229_4810 = res3688_4832;
      }
      {
	 create_vector_app_150_t new2230_4811;
	 new2230_4811 = ((create_vector_app_150_t) (aux2229_4810));
	 {
	    long arg2828_4812;
	    arg2828_4812 = class_num_218___object(create_vector_app_150_cfa_info);
	    {
	       obj_t obj_4833;
	       obj_4833 = (obj_t) (new2230_4811);
	       (((obj_t) CREF(obj_4833))->header = MAKE_HEADER(arg2828_4812, 0), BUNSPEC);
	    }
	 }
	 {
	    create_vector_app_150_t arg2829_4813;
	    {
	       create_vector_app_150_t res3689_4850;
	       {
		  create_vector_app_150_t new2220_4842;
		  new2220_4842 = ((create_vector_app_150_t) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
		  ((((create_vector_app_150_t) CREF(new2220_4842))->approx) = ((approx_t) approx_300), BUNSPEC);
		  ((((create_vector_app_150_t) CREF(new2220_4842))->value_approx_19) = ((approx_t) value_approx_19_301), BUNSPEC);
		  ((((create_vector_app_150_t) CREF(new2220_4842))->lost_stamp_114) = ((long) lost_stamp_114_302), BUNSPEC);
		  ((((create_vector_app_150_t) CREF(new2220_4842))->owner) = ((variable_t) owner_303), BUNSPEC);
		  ((((create_vector_app_150_t) CREF(new2220_4842))->stackable__42) = ((bool_t) stackable__42_304), BUNSPEC);
		  ((((create_vector_app_150_t) CREF(new2220_4842))->stack_stamp_31) = ((obj_t) stack_stamp_31_305), BUNSPEC);
		  ((((create_vector_app_150_t) CREF(new2220_4842))->seen__39) = ((bool_t) seen__39_306), BUNSPEC);
		  res3689_4850 = new2220_4842;
	       }
	       arg2829_4813 = res3689_4850;
	    }
	    {
	       obj_t aux_11717;
	       object_t aux_11715;
	       aux_11717 = (obj_t) (arg2829_4813);
	       aux_11715 = (object_t) (new2230_4811);
	       OBJECT_WIDENING_SET(aux_11715, aux_11717);
	    }
	 }
	 return new2230_4811;
      }
   }
}


/* _make-create-vector-app3941 */ obj_t 
_make_create_vector_app3941_23_cfa_info(obj_t env_8481, obj_t loc_8482, obj_t type_8483, obj_t side_effect__165_8484, obj_t key_8485, obj_t fun_8486, obj_t args_8487, obj_t stack_info_255_8488, obj_t approx_8489, obj_t value_approx_19_8490, obj_t lost_stamp_114_8491, obj_t owner_8492, obj_t stackable__42_8493, obj_t stack_stamp_31_8494, obj_t seen__39_8495)
{
   {
      create_vector_app_150_t aux_11720;
      aux_11720 = make_create_vector_app_136_cfa_info(loc_8482, (type_t) (type_8483), side_effect__165_8484, key_8485, (var_t) (fun_8486), args_8487, stack_info_255_8488, (approx_t) (approx_8489), (approx_t) (value_approx_19_8490), (long) CINT(lost_stamp_114_8491), (variable_t) (owner_8492), CBOOL(stackable__42_8493), stack_stamp_31_8494, CBOOL(seen__39_8495));
      return (obj_t) (aux_11720);
   }
}


/* create-vector-app-loc */ obj_t 
create_vector_app_loc_246_cfa_info(app_t obj_307)
{
   return (((app_t) CREF(obj_307))->loc);
}


/* _create-vector-app-loc3942 */ obj_t 
_create_vector_app_loc3942_173_cfa_info(obj_t env_8496, obj_t obj_8497)
{
   return create_vector_app_loc_246_cfa_info((app_t) (obj_8497));
}


/* create-vector-app-type-set! */ obj_t 
create_vector_app_type_set__83_cfa_info(app_t obj_308, type_t val2231_309)
{
   return ((((app_t) CREF(obj_308))->type) = ((type_t) val2231_309), BUNSPEC);
}


/* _create-vector-app-type-set!3943 */ obj_t 
_create_vector_app_type_set_3943_133_cfa_info(obj_t env_8498, obj_t obj_8499, obj_t val2231_8500)
{
   return create_vector_app_type_set__83_cfa_info((app_t) (obj_8499), (type_t) (val2231_8500));
}


/* create-vector-app-type */ type_t 
create_vector_app_type_249_cfa_info(app_t obj_310)
{
   return (((app_t) CREF(obj_310))->type);
}


/* _create-vector-app-type3944 */ obj_t 
_create_vector_app_type3944_91_cfa_info(obj_t env_8501, obj_t obj_8502)
{
   {
      type_t aux_11739;
      aux_11739 = create_vector_app_type_249_cfa_info((app_t) (obj_8502));
      return (obj_t) (aux_11739);
   }
}


/* create-vector-app-side-effect?-set! */ obj_t 
create_vector_app_side_effect__set__150_cfa_info(app_t obj_311, obj_t val2232_312)
{
   return ((((app_t) CREF(obj_311))->side_effect__165) = ((obj_t) val2232_312), BUNSPEC);
}


/* _create-vector-app-side-effect?-set!3945 */ obj_t 
_create_vector_app_side_effect__set_3945_171_cfa_info(obj_t env_8503, obj_t obj_8504, obj_t val2232_8505)
{
   return create_vector_app_side_effect__set__150_cfa_info((app_t) (obj_8504), val2232_8505);
}


/* create-vector-app-side-effect? */ obj_t 
create_vector_app_side_effect__33_cfa_info(app_t obj_313)
{
   return (((app_t) CREF(obj_313))->side_effect__165);
}


/* _create-vector-app-side-effect?3946 */ obj_t 
_create_vector_app_side_effect_3946_172_cfa_info(obj_t env_8506, obj_t obj_8507)
{
   return create_vector_app_side_effect__33_cfa_info((app_t) (obj_8507));
}


/* create-vector-app-key-set! */ obj_t 
create_vector_app_key_set__126_cfa_info(app_t obj_314, obj_t val2233_315)
{
   return ((((app_t) CREF(obj_314))->key) = ((obj_t) val2233_315), BUNSPEC);
}


/* _create-vector-app-key-set! */ obj_t 
_create_vector_app_key_set__7_cfa_info(obj_t env_8508, obj_t obj_8509, obj_t val2233_8510)
{
   return create_vector_app_key_set__126_cfa_info((app_t) (obj_8509), val2233_8510);
}


/* create-vector-app-key */ obj_t 
create_vector_app_key_178_cfa_info(app_t obj_316)
{
   return (((app_t) CREF(obj_316))->key);
}


/* _create-vector-app-key3947 */ obj_t 
_create_vector_app_key3947_51_cfa_info(obj_t env_8511, obj_t obj_8512)
{
   return create_vector_app_key_178_cfa_info((app_t) (obj_8512));
}


/* create-vector-app-fun-set! */ obj_t 
create_vector_app_fun_set__58_cfa_info(app_t obj_317, var_t val2234_318)
{
   return ((((app_t) CREF(obj_317))->fun) = ((var_t) val2234_318), BUNSPEC);
}


/* _create-vector-app-fun-set!3948 */ obj_t 
_create_vector_app_fun_set_3948_68_cfa_info(obj_t env_8513, obj_t obj_8514, obj_t val2234_8515)
{
   return create_vector_app_fun_set__58_cfa_info((app_t) (obj_8514), (var_t) (val2234_8515));
}


/* create-vector-app-fun */ var_t 
create_vector_app_fun_92_cfa_info(app_t obj_319)
{
   return (((app_t) CREF(obj_319))->fun);
}


/* _create-vector-app-fun3949 */ obj_t 
_create_vector_app_fun3949_243_cfa_info(obj_t env_8516, obj_t obj_8517)
{
   {
      var_t aux_11760;
      aux_11760 = create_vector_app_fun_92_cfa_info((app_t) (obj_8517));
      return (obj_t) (aux_11760);
   }
}


/* create-vector-app-args-set! */ obj_t 
create_vector_app_args_set__204_cfa_info(app_t obj_320, obj_t val2235_321)
{
   return ((((app_t) CREF(obj_320))->args) = ((obj_t) val2235_321), BUNSPEC);
}


/* _create-vector-app-args-set!3950 */ obj_t 
_create_vector_app_args_set_3950_85_cfa_info(obj_t env_8518, obj_t obj_8519, obj_t val2235_8520)
{
   return create_vector_app_args_set__204_cfa_info((app_t) (obj_8519), val2235_8520);
}


/* create-vector-app-args */ obj_t 
create_vector_app_args_44_cfa_info(app_t obj_322)
{
   return (((app_t) CREF(obj_322))->args);
}


/* _create-vector-app-args3951 */ obj_t 
_create_vector_app_args3951_133_cfa_info(obj_t env_8521, obj_t obj_8522)
{
   return create_vector_app_args_44_cfa_info((app_t) (obj_8522));
}


/* create-vector-app-stack-info-set! */ obj_t 
create_vector_app_stack_info_set__169_cfa_info(app_t obj_323, obj_t val2236_324)
{
   return ((((app_t) CREF(obj_323))->stack_info_255) = ((obj_t) val2236_324), BUNSPEC);
}


/* _create-vector-app-stack-info-set!3952 */ obj_t 
_create_vector_app_stack_info_set_3952_56_cfa_info(obj_t env_8523, obj_t obj_8524, obj_t val2236_8525)
{
   return create_vector_app_stack_info_set__169_cfa_info((app_t) (obj_8524), val2236_8525);
}


/* create-vector-app-stack-info */ obj_t 
create_vector_app_stack_info_51_cfa_info(app_t obj_325)
{
   return (((app_t) CREF(obj_325))->stack_info_255);
}


/* _create-vector-app-stack-info3953 */ obj_t 
_create_vector_app_stack_info3953_169_cfa_info(obj_t env_8526, obj_t obj_8527)
{
   return create_vector_app_stack_info_51_cfa_info((app_t) (obj_8527));
}


/* create-vector-app-approx-set! */ obj_t 
create_vector_app_approx_set__132_cfa_info(create_vector_app_150_t obj_326, approx_t val2237_327)
{
   {
      obj_t aux_11776;
      {
	 object_t aux_11777;
	 aux_11777 = (object_t) (obj_326);
	 aux_11776 = OBJECT_WIDENING(aux_11777);
      }
      return ((((create_vector_app_150_t) CREF(aux_11776))->approx) = ((approx_t) val2237_327), BUNSPEC);
   }
}


/* _create-vector-app-approx-set!3954 */ obj_t 
_create_vector_app_approx_set_3954_71_cfa_info(obj_t env_8528, obj_t obj_8529, obj_t val2237_8530)
{
   return create_vector_app_approx_set__132_cfa_info((create_vector_app_150_t) (obj_8529), (approx_t) (val2237_8530));
}


/* create-vector-app-approx */ approx_t 
create_vector_app_approx_174_cfa_info(create_vector_app_150_t obj_328)
{
   {
      obj_t aux_11784;
      {
	 object_t aux_11785;
	 aux_11785 = (object_t) (obj_328);
	 aux_11784 = OBJECT_WIDENING(aux_11785);
      }
      return (((create_vector_app_150_t) CREF(aux_11784))->approx);
   }
}


/* _create-vector-app-approx3955 */ obj_t 
_create_vector_app_approx3955_106_cfa_info(obj_t env_8531, obj_t obj_8532)
{
   {
      approx_t aux_11789;
      aux_11789 = create_vector_app_approx_174_cfa_info((create_vector_app_150_t) (obj_8532));
      return (obj_t) (aux_11789);
   }
}


/* create-vector-app-value-approx */ approx_t 
create_vector_app_value_approx_116_cfa_info(create_vector_app_150_t obj_329)
{
   {
      obj_t aux_11793;
      {
	 object_t aux_11794;
	 aux_11794 = (object_t) (obj_329);
	 aux_11793 = OBJECT_WIDENING(aux_11794);
      }
      return (((create_vector_app_150_t) CREF(aux_11793))->value_approx_19);
   }
}


/* _create-vector-app-value-approx3956 */ obj_t 
_create_vector_app_value_approx3956_148_cfa_info(obj_t env_8533, obj_t obj_8534)
{
   {
      approx_t aux_11798;
      aux_11798 = create_vector_app_value_approx_116_cfa_info((create_vector_app_150_t) (obj_8534));
      return (obj_t) (aux_11798);
   }
}


/* create-vector-app-lost-stamp-set! */ obj_t 
create_vector_app_lost_stamp_set__92_cfa_info(create_vector_app_150_t obj_330, long val2238_331)
{
   {
      obj_t aux_11802;
      {
	 object_t aux_11803;
	 aux_11803 = (object_t) (obj_330);
	 aux_11802 = OBJECT_WIDENING(aux_11803);
      }
      return ((((create_vector_app_150_t) CREF(aux_11802))->lost_stamp_114) = ((long) val2238_331), BUNSPEC);
   }
}


/* _create-vector-app-lost-stamp-set!3957 */ obj_t 
_create_vector_app_lost_stamp_set_3957_3_cfa_info(obj_t env_8535, obj_t obj_8536, obj_t val2238_8537)
{
   return create_vector_app_lost_stamp_set__92_cfa_info((create_vector_app_150_t) (obj_8536), (long) CINT(val2238_8537));
}


/* create-vector-app-lost-stamp */ long 
create_vector_app_lost_stamp_72_cfa_info(create_vector_app_150_t obj_332)
{
   {
      obj_t aux_11810;
      {
	 object_t aux_11811;
	 aux_11811 = (object_t) (obj_332);
	 aux_11810 = OBJECT_WIDENING(aux_11811);
      }
      return (((create_vector_app_150_t) CREF(aux_11810))->lost_stamp_114);
   }
}


/* _create-vector-app-lost-stamp3958 */ obj_t 
_create_vector_app_lost_stamp3958_168_cfa_info(obj_t env_8538, obj_t obj_8539)
{
   {
      long aux_11815;
      aux_11815 = create_vector_app_lost_stamp_72_cfa_info((create_vector_app_150_t) (obj_8539));
      return BINT(aux_11815);
   }
}


/* create-vector-app-owner */ variable_t 
create_vector_app_owner_226_cfa_info(create_vector_app_150_t obj_333)
{
   {
      obj_t aux_11819;
      {
	 object_t aux_11820;
	 aux_11820 = (object_t) (obj_333);
	 aux_11819 = OBJECT_WIDENING(aux_11820);
      }
      return (((create_vector_app_150_t) CREF(aux_11819))->owner);
   }
}


/* _create-vector-app-owner3959 */ obj_t 
_create_vector_app_owner3959_48_cfa_info(obj_t env_8540, obj_t obj_8541)
{
   {
      variable_t aux_11824;
      aux_11824 = create_vector_app_owner_226_cfa_info((create_vector_app_150_t) (obj_8541));
      return (obj_t) (aux_11824);
   }
}


/* create-vector-app-stackable?-set! */ obj_t 
create_vector_app_stackable__set__21_cfa_info(create_vector_app_150_t obj_334, bool_t val2239_335)
{
   {
      obj_t aux_11828;
      {
	 object_t aux_11829;
	 aux_11829 = (object_t) (obj_334);
	 aux_11828 = OBJECT_WIDENING(aux_11829);
      }
      return ((((create_vector_app_150_t) CREF(aux_11828))->stackable__42) = ((bool_t) val2239_335), BUNSPEC);
   }
}


/* _create-vector-app-stackable?-set!3960 */ obj_t 
_create_vector_app_stackable__set_3960_139_cfa_info(obj_t env_8542, obj_t obj_8543, obj_t val2239_8544)
{
   return create_vector_app_stackable__set__21_cfa_info((create_vector_app_150_t) (obj_8543), CBOOL(val2239_8544));
}


/* create-vector-app-stackable? */ bool_t 
create_vector_app_stackable__57_cfa_info(create_vector_app_150_t obj_336)
{
   {
      obj_t aux_11836;
      {
	 object_t aux_11837;
	 aux_11837 = (object_t) (obj_336);
	 aux_11836 = OBJECT_WIDENING(aux_11837);
      }
      return (((create_vector_app_150_t) CREF(aux_11836))->stackable__42);
   }
}


/* _create-vector-app-stackable?3961 */ obj_t 
_create_vector_app_stackable_3961_41_cfa_info(obj_t env_8545, obj_t obj_8546)
{
   {
      bool_t aux_11841;
      aux_11841 = create_vector_app_stackable__57_cfa_info((create_vector_app_150_t) (obj_8546));
      return BBOOL(aux_11841);
   }
}


/* create-vector-app-stack-stamp-set! */ obj_t 
create_vector_app_stack_stamp_set__220_cfa_info(create_vector_app_150_t obj_337, obj_t val2240_338)
{
   {
      obj_t aux_11845;
      {
	 object_t aux_11846;
	 aux_11846 = (object_t) (obj_337);
	 aux_11845 = OBJECT_WIDENING(aux_11846);
      }
      return ((((create_vector_app_150_t) CREF(aux_11845))->stack_stamp_31) = ((obj_t) val2240_338), BUNSPEC);
   }
}


/* _create-vector-app-stack-stamp-set!3962 */ obj_t 
_create_vector_app_stack_stamp_set_3962_205_cfa_info(obj_t env_8547, obj_t obj_8548, obj_t val2240_8549)
{
   return create_vector_app_stack_stamp_set__220_cfa_info((create_vector_app_150_t) (obj_8548), val2240_8549);
}


/* create-vector-app-stack-stamp */ obj_t 
create_vector_app_stack_stamp_255_cfa_info(create_vector_app_150_t obj_339)
{
   {
      obj_t aux_11852;
      {
	 object_t aux_11853;
	 aux_11853 = (object_t) (obj_339);
	 aux_11852 = OBJECT_WIDENING(aux_11853);
      }
      return (((create_vector_app_150_t) CREF(aux_11852))->stack_stamp_31);
   }
}


/* _create-vector-app-stack-stamp3963 */ obj_t 
_create_vector_app_stack_stamp3963_42_cfa_info(obj_t env_8550, obj_t obj_8551)
{
   return create_vector_app_stack_stamp_255_cfa_info((create_vector_app_150_t) (obj_8551));
}


/* create-vector-app-seen?-set! */ obj_t 
create_vector_app_seen__set__212_cfa_info(create_vector_app_150_t obj_340, bool_t val2241_341)
{
   {
      obj_t aux_11859;
      {
	 object_t aux_11860;
	 aux_11860 = (object_t) (obj_340);
	 aux_11859 = OBJECT_WIDENING(aux_11860);
      }
      return ((((create_vector_app_150_t) CREF(aux_11859))->seen__39) = ((bool_t) val2241_341), BUNSPEC);
   }
}


/* _create-vector-app-seen?-set!3964 */ obj_t 
_create_vector_app_seen__set_3964_25_cfa_info(obj_t env_8552, obj_t obj_8553, obj_t val2241_8554)
{
   return create_vector_app_seen__set__212_cfa_info((create_vector_app_150_t) (obj_8553), CBOOL(val2241_8554));
}


/* create-vector-app-seen? */ bool_t 
create_vector_app_seen__3_cfa_info(create_vector_app_150_t obj_342)
{
   {
      obj_t aux_11867;
      {
	 object_t aux_11868;
	 aux_11868 = (object_t) (obj_342);
	 aux_11867 = OBJECT_WIDENING(aux_11868);
      }
      return (((create_vector_app_150_t) CREF(aux_11867))->seen__39);
   }
}


/* _create-vector-app-seen?3965 */ obj_t 
_create_vector_app_seen_3965_143_cfa_info(obj_t env_8555, obj_t obj_8556)
{
   {
      bool_t aux_11872;
      aux_11872 = create_vector_app_seen__3_cfa_info((create_vector_app_150_t) (obj_8556));
      return BBOOL(aux_11872);
   }
}


/* allocate-make-vector-app */ app_t 
allocate_make_vector_app_226_cfa_info()
{
   {
      app_t new2213_2525;
      new2213_2525 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2830_2526;
	 arg2830_2526 = class_num_218___object(make_vector_app_205_cfa_info);
	 {
	    obj_t obj_4851;
	    obj_4851 = (obj_t) (new2213_2525);
	    (((obj_t) CREF(obj_4851))->header = MAKE_HEADER(arg2830_2526, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_11880;
	 aux_11880 = (object_t) (new2213_2525);
	 OBJECT_WIDENING_SET(aux_11880, BFALSE);
      }
      return new2213_2525;
   }
}


/* _allocate-make-vector-app */ obj_t 
_allocate_make_vector_app_18_cfa_info(obj_t env_8061)
{
   {
      app_t aux_11883;
      aux_11883 = allocate_make_vector_app_226_cfa_info();
      return (obj_t) (aux_11883);
   }
}


/* make-vector-app? */ bool_t 
make_vector_app__222_cfa_info(obj_t obj_346)
{
   return is_a__118___object(obj_346, make_vector_app_205_cfa_info);
}


/* _make-vector-app? */ obj_t 
_make_vector_app__161_cfa_info(obj_t env_8557, obj_t obj_8558)
{
   {
      bool_t aux_11887;
      aux_11887 = make_vector_app__222_cfa_info(obj_8558);
      return BBOOL(aux_11887);
   }
}


/* widening1041-make-vector-app */ make_vector_app_205_t 
widening1041_make_vector_app_175_cfa_info(approx_t approx_347, approx_t value_approx_19_348, long lost_stamp_114_349, variable_t owner_350, bool_t stackable__42_351, obj_t stack_stamp_31_352, bool_t seen__39_353)
{
   {
      make_vector_app_205_t new2191_4853;
      new2191_4853 = ((make_vector_app_205_t) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
      ((((make_vector_app_205_t) CREF(new2191_4853))->approx) = ((approx_t) approx_347), BUNSPEC);
      ((((make_vector_app_205_t) CREF(new2191_4853))->value_approx_19) = ((approx_t) value_approx_19_348), BUNSPEC);
      ((((make_vector_app_205_t) CREF(new2191_4853))->lost_stamp_114) = ((long) lost_stamp_114_349), BUNSPEC);
      ((((make_vector_app_205_t) CREF(new2191_4853))->owner) = ((variable_t) owner_350), BUNSPEC);
      ((((make_vector_app_205_t) CREF(new2191_4853))->stackable__42) = ((bool_t) stackable__42_351), BUNSPEC);
      ((((make_vector_app_205_t) CREF(new2191_4853))->stack_stamp_31) = ((obj_t) stack_stamp_31_352), BUNSPEC);
      ((((make_vector_app_205_t) CREF(new2191_4853))->seen__39) = ((bool_t) seen__39_353), BUNSPEC);
      return new2191_4853;
   }
}


/* _widening1041-make-vector-app3966 */ obj_t 
_widening1041_make_vector_app3966_245_cfa_info(obj_t env_8559, obj_t approx_8560, obj_t value_approx_19_8561, obj_t lost_stamp_114_8562, obj_t owner_8563, obj_t stackable__42_8564, obj_t stack_stamp_31_8565, obj_t seen__39_8566)
{
   {
      make_vector_app_205_t aux_11898;
      aux_11898 = widening1041_make_vector_app_175_cfa_info((approx_t) (approx_8560), (approx_t) (value_approx_19_8561), (long) CINT(lost_stamp_114_8562), (variable_t) (owner_8563), CBOOL(stackable__42_8564), stack_stamp_31_8565, CBOOL(seen__39_8566));
      return (obj_t) (aux_11898);
   }
}


/* make-make-vector-app */ make_vector_app_205_t 
make_make_vector_app_32_cfa_info(obj_t loc_354, type_t type_355, obj_t side_effect__165_356, obj_t key_357, var_t fun_358, obj_t args_359, obj_t stack_info_255_360, approx_t approx_361, approx_t value_approx_19_362, long lost_stamp_114_363, variable_t owner_364, bool_t stackable__42_365, obj_t stack_stamp_31_366, bool_t seen__39_367)
{
   {
      app_t aux2200_4861;
      {
	 app_t res3690_4883;
	 {
	    app_t new1289_4872;
	    new1289_4872 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4873;
	       arg2999_4873 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4881;
		  obj_4881 = (obj_t) (new1289_4872);
		  (((obj_t) CREF(obj_4881))->header = MAKE_HEADER(arg2999_4873, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_11911;
	       aux_11911 = (object_t) (new1289_4872);
	       OBJECT_WIDENING_SET(aux_11911, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4872))->loc) = ((obj_t) loc_354), BUNSPEC);
	    ((((app_t) CREF(new1289_4872))->type) = ((type_t) type_355), BUNSPEC);
	    ((((app_t) CREF(new1289_4872))->side_effect__165) = ((obj_t) side_effect__165_356), BUNSPEC);
	    ((((app_t) CREF(new1289_4872))->key) = ((obj_t) key_357), BUNSPEC);
	    ((((app_t) CREF(new1289_4872))->fun) = ((var_t) fun_358), BUNSPEC);
	    ((((app_t) CREF(new1289_4872))->args) = ((obj_t) args_359), BUNSPEC);
	    ((((app_t) CREF(new1289_4872))->stack_info_255) = ((obj_t) stack_info_255_360), BUNSPEC);
	    res3690_4883 = new1289_4872;
	 }
	 aux2200_4861 = res3690_4883;
      }
      {
	 make_vector_app_205_t new2201_4862;
	 new2201_4862 = ((make_vector_app_205_t) (aux2200_4861));
	 {
	    long arg2831_4863;
	    arg2831_4863 = class_num_218___object(make_vector_app_205_cfa_info);
	    {
	       obj_t obj_4884;
	       obj_4884 = (obj_t) (new2201_4862);
	       (((obj_t) CREF(obj_4884))->header = MAKE_HEADER(arg2831_4863, 0), BUNSPEC);
	    }
	 }
	 {
	    make_vector_app_205_t arg2832_4864;
	    {
	       make_vector_app_205_t res3691_4901;
	       {
		  make_vector_app_205_t new2191_4893;
		  new2191_4893 = ((make_vector_app_205_t) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
		  ((((make_vector_app_205_t) CREF(new2191_4893))->approx) = ((approx_t) approx_361), BUNSPEC);
		  ((((make_vector_app_205_t) CREF(new2191_4893))->value_approx_19) = ((approx_t) value_approx_19_362), BUNSPEC);
		  ((((make_vector_app_205_t) CREF(new2191_4893))->lost_stamp_114) = ((long) lost_stamp_114_363), BUNSPEC);
		  ((((make_vector_app_205_t) CREF(new2191_4893))->owner) = ((variable_t) owner_364), BUNSPEC);
		  ((((make_vector_app_205_t) CREF(new2191_4893))->stackable__42) = ((bool_t) stackable__42_365), BUNSPEC);
		  ((((make_vector_app_205_t) CREF(new2191_4893))->stack_stamp_31) = ((obj_t) stack_stamp_31_366), BUNSPEC);
		  ((((make_vector_app_205_t) CREF(new2191_4893))->seen__39) = ((bool_t) seen__39_367), BUNSPEC);
		  res3691_4901 = new2191_4893;
	       }
	       arg2832_4864 = res3691_4901;
	    }
	    {
	       obj_t aux_11935;
	       object_t aux_11933;
	       aux_11935 = (obj_t) (arg2832_4864);
	       aux_11933 = (object_t) (new2201_4862);
	       OBJECT_WIDENING_SET(aux_11933, aux_11935);
	    }
	 }
	 return new2201_4862;
      }
   }
}


/* _make-make-vector-app3967 */ obj_t 
_make_make_vector_app3967_73_cfa_info(obj_t env_8567, obj_t loc_8568, obj_t type_8569, obj_t side_effect__165_8570, obj_t key_8571, obj_t fun_8572, obj_t args_8573, obj_t stack_info_255_8574, obj_t approx_8575, obj_t value_approx_19_8576, obj_t lost_stamp_114_8577, obj_t owner_8578, obj_t stackable__42_8579, obj_t stack_stamp_31_8580, obj_t seen__39_8581)
{
   {
      make_vector_app_205_t aux_11938;
      aux_11938 = make_make_vector_app_32_cfa_info(loc_8568, (type_t) (type_8569), side_effect__165_8570, key_8571, (var_t) (fun_8572), args_8573, stack_info_255_8574, (approx_t) (approx_8575), (approx_t) (value_approx_19_8576), (long) CINT(lost_stamp_114_8577), (variable_t) (owner_8578), CBOOL(stackable__42_8579), stack_stamp_31_8580, CBOOL(seen__39_8581));
      return (obj_t) (aux_11938);
   }
}


/* make-vector-app-loc */ obj_t 
make_vector_app_loc_140_cfa_info(app_t obj_368)
{
   return (((app_t) CREF(obj_368))->loc);
}


/* _make-vector-app-loc3968 */ obj_t 
_make_vector_app_loc3968_153_cfa_info(obj_t env_8582, obj_t obj_8583)
{
   return make_vector_app_loc_140_cfa_info((app_t) (obj_8583));
}


/* make-vector-app-type-set! */ obj_t 
make_vector_app_type_set__45_cfa_info(app_t obj_369, type_t val2202_370)
{
   return ((((app_t) CREF(obj_369))->type) = ((type_t) val2202_370), BUNSPEC);
}


/* _make-vector-app-type-set!3969 */ obj_t 
_make_vector_app_type_set_3969_21_cfa_info(obj_t env_8584, obj_t obj_8585, obj_t val2202_8586)
{
   return make_vector_app_type_set__45_cfa_info((app_t) (obj_8585), (type_t) (val2202_8586));
}


/* make-vector-app-type */ type_t 
make_vector_app_type_150_cfa_info(app_t obj_371)
{
   return (((app_t) CREF(obj_371))->type);
}


/* _make-vector-app-type3970 */ obj_t 
_make_vector_app_type3970_181_cfa_info(obj_t env_8587, obj_t obj_8588)
{
   {
      type_t aux_11957;
      aux_11957 = make_vector_app_type_150_cfa_info((app_t) (obj_8588));
      return (obj_t) (aux_11957);
   }
}


/* make-vector-app-side-effect?-set! */ obj_t 
make_vector_app_side_effect__set__75_cfa_info(app_t obj_372, obj_t val2203_373)
{
   return ((((app_t) CREF(obj_372))->side_effect__165) = ((obj_t) val2203_373), BUNSPEC);
}


/* _make-vector-app-side-effect?-set!3971 */ obj_t 
_make_vector_app_side_effect__set_3971_134_cfa_info(obj_t env_8589, obj_t obj_8590, obj_t val2203_8591)
{
   return make_vector_app_side_effect__set__75_cfa_info((app_t) (obj_8590), val2203_8591);
}


/* make-vector-app-side-effect? */ obj_t 
make_vector_app_side_effect__209_cfa_info(app_t obj_374)
{
   return (((app_t) CREF(obj_374))->side_effect__165);
}


/* _make-vector-app-side-effect?3972 */ obj_t 
_make_vector_app_side_effect_3972_17_cfa_info(obj_t env_8592, obj_t obj_8593)
{
   return make_vector_app_side_effect__209_cfa_info((app_t) (obj_8593));
}


/* make-vector-app-key-set! */ obj_t 
make_vector_app_key_set__25_cfa_info(app_t obj_375, obj_t val2204_376)
{
   return ((((app_t) CREF(obj_375))->key) = ((obj_t) val2204_376), BUNSPEC);
}


/* _make-vector-app-key-set! */ obj_t 
_make_vector_app_key_set__16_cfa_info(obj_t env_8594, obj_t obj_8595, obj_t val2204_8596)
{
   return make_vector_app_key_set__25_cfa_info((app_t) (obj_8595), val2204_8596);
}


/* make-vector-app-key */ obj_t 
make_vector_app_key_103_cfa_info(app_t obj_377)
{
   return (((app_t) CREF(obj_377))->key);
}


/* _make-vector-app-key3973 */ obj_t 
_make_vector_app_key3973_24_cfa_info(obj_t env_8597, obj_t obj_8598)
{
   return make_vector_app_key_103_cfa_info((app_t) (obj_8598));
}


/* make-vector-app-fun-set! */ obj_t 
make_vector_app_fun_set__56_cfa_info(app_t obj_378, var_t val2205_379)
{
   return ((((app_t) CREF(obj_378))->fun) = ((var_t) val2205_379), BUNSPEC);
}


/* _make-vector-app-fun-set!3974 */ obj_t 
_make_vector_app_fun_set_3974_137_cfa_info(obj_t env_8599, obj_t obj_8600, obj_t val2205_8601)
{
   return make_vector_app_fun_set__56_cfa_info((app_t) (obj_8600), (var_t) (val2205_8601));
}


/* make-vector-app-fun */ var_t 
make_vector_app_fun_121_cfa_info(app_t obj_380)
{
   return (((app_t) CREF(obj_380))->fun);
}


/* _make-vector-app-fun3975 */ obj_t 
_make_vector_app_fun3975_121_cfa_info(obj_t env_8602, obj_t obj_8603)
{
   {
      var_t aux_11978;
      aux_11978 = make_vector_app_fun_121_cfa_info((app_t) (obj_8603));
      return (obj_t) (aux_11978);
   }
}


/* make-vector-app-args-set! */ obj_t 
make_vector_app_args_set__241_cfa_info(app_t obj_381, obj_t val2206_382)
{
   return ((((app_t) CREF(obj_381))->args) = ((obj_t) val2206_382), BUNSPEC);
}


/* _make-vector-app-args-set!3976 */ obj_t 
_make_vector_app_args_set_3976_166_cfa_info(obj_t env_8604, obj_t obj_8605, obj_t val2206_8606)
{
   return make_vector_app_args_set__241_cfa_info((app_t) (obj_8605), val2206_8606);
}


/* make-vector-app-args */ obj_t 
make_vector_app_args_195_cfa_info(app_t obj_383)
{
   return (((app_t) CREF(obj_383))->args);
}


/* _make-vector-app-args3977 */ obj_t 
_make_vector_app_args3977_212_cfa_info(obj_t env_8607, obj_t obj_8608)
{
   return make_vector_app_args_195_cfa_info((app_t) (obj_8608));
}


/* make-vector-app-stack-info-set! */ obj_t 
make_vector_app_stack_info_set__239_cfa_info(app_t obj_384, obj_t val2207_385)
{
   return ((((app_t) CREF(obj_384))->stack_info_255) = ((obj_t) val2207_385), BUNSPEC);
}


/* _make-vector-app-stack-info-set!3978 */ obj_t 
_make_vector_app_stack_info_set_3978_28_cfa_info(obj_t env_8609, obj_t obj_8610, obj_t val2207_8611)
{
   return make_vector_app_stack_info_set__239_cfa_info((app_t) (obj_8610), val2207_8611);
}


/* make-vector-app-stack-info */ obj_t 
make_vector_app_stack_info_168_cfa_info(app_t obj_386)
{
   return (((app_t) CREF(obj_386))->stack_info_255);
}


/* _make-vector-app-stack-info3979 */ obj_t 
_make_vector_app_stack_info3979_52_cfa_info(obj_t env_8612, obj_t obj_8613)
{
   return make_vector_app_stack_info_168_cfa_info((app_t) (obj_8613));
}


/* make-vector-app-approx-set! */ obj_t 
make_vector_app_approx_set__66_cfa_info(make_vector_app_205_t obj_387, approx_t val2208_388)
{
   {
      obj_t aux_11994;
      {
	 object_t aux_11995;
	 aux_11995 = (object_t) (obj_387);
	 aux_11994 = OBJECT_WIDENING(aux_11995);
      }
      return ((((make_vector_app_205_t) CREF(aux_11994))->approx) = ((approx_t) val2208_388), BUNSPEC);
   }
}


/* _make-vector-app-approx-set!3980 */ obj_t 
_make_vector_app_approx_set_3980_189_cfa_info(obj_t env_8614, obj_t obj_8615, obj_t val2208_8616)
{
   return make_vector_app_approx_set__66_cfa_info((make_vector_app_205_t) (obj_8615), (approx_t) (val2208_8616));
}


/* make-vector-app-approx */ approx_t 
make_vector_app_approx_58_cfa_info(make_vector_app_205_t obj_389)
{
   {
      obj_t aux_12002;
      {
	 object_t aux_12003;
	 aux_12003 = (object_t) (obj_389);
	 aux_12002 = OBJECT_WIDENING(aux_12003);
      }
      return (((make_vector_app_205_t) CREF(aux_12002))->approx);
   }
}


/* _make-vector-app-approx3981 */ obj_t 
_make_vector_app_approx3981_121_cfa_info(obj_t env_8617, obj_t obj_8618)
{
   {
      approx_t aux_12007;
      aux_12007 = make_vector_app_approx_58_cfa_info((make_vector_app_205_t) (obj_8618));
      return (obj_t) (aux_12007);
   }
}


/* make-vector-app-value-approx */ approx_t 
make_vector_app_value_approx_202_cfa_info(make_vector_app_205_t obj_390)
{
   {
      obj_t aux_12011;
      {
	 object_t aux_12012;
	 aux_12012 = (object_t) (obj_390);
	 aux_12011 = OBJECT_WIDENING(aux_12012);
      }
      return (((make_vector_app_205_t) CREF(aux_12011))->value_approx_19);
   }
}


/* _make-vector-app-value-approx3982 */ obj_t 
_make_vector_app_value_approx3982_99_cfa_info(obj_t env_8619, obj_t obj_8620)
{
   {
      approx_t aux_12016;
      aux_12016 = make_vector_app_value_approx_202_cfa_info((make_vector_app_205_t) (obj_8620));
      return (obj_t) (aux_12016);
   }
}


/* make-vector-app-lost-stamp-set! */ obj_t 
make_vector_app_lost_stamp_set__132_cfa_info(make_vector_app_205_t obj_391, long val2209_392)
{
   {
      obj_t aux_12020;
      {
	 object_t aux_12021;
	 aux_12021 = (object_t) (obj_391);
	 aux_12020 = OBJECT_WIDENING(aux_12021);
      }
      return ((((make_vector_app_205_t) CREF(aux_12020))->lost_stamp_114) = ((long) val2209_392), BUNSPEC);
   }
}


/* _make-vector-app-lost-stamp-set!3983 */ obj_t 
_make_vector_app_lost_stamp_set_3983_140_cfa_info(obj_t env_8621, obj_t obj_8622, obj_t val2209_8623)
{
   return make_vector_app_lost_stamp_set__132_cfa_info((make_vector_app_205_t) (obj_8622), (long) CINT(val2209_8623));
}


/* make-vector-app-lost-stamp */ long 
make_vector_app_lost_stamp_174_cfa_info(make_vector_app_205_t obj_393)
{
   {
      obj_t aux_12028;
      {
	 object_t aux_12029;
	 aux_12029 = (object_t) (obj_393);
	 aux_12028 = OBJECT_WIDENING(aux_12029);
      }
      return (((make_vector_app_205_t) CREF(aux_12028))->lost_stamp_114);
   }
}


/* _make-vector-app-lost-stamp3984 */ obj_t 
_make_vector_app_lost_stamp3984_11_cfa_info(obj_t env_8624, obj_t obj_8625)
{
   {
      long aux_12033;
      aux_12033 = make_vector_app_lost_stamp_174_cfa_info((make_vector_app_205_t) (obj_8625));
      return BINT(aux_12033);
   }
}


/* make-vector-app-owner */ variable_t 
make_vector_app_owner_193_cfa_info(make_vector_app_205_t obj_394)
{
   {
      obj_t aux_12037;
      {
	 object_t aux_12038;
	 aux_12038 = (object_t) (obj_394);
	 aux_12037 = OBJECT_WIDENING(aux_12038);
      }
      return (((make_vector_app_205_t) CREF(aux_12037))->owner);
   }
}


/* _make-vector-app-owner3985 */ obj_t 
_make_vector_app_owner3985_202_cfa_info(obj_t env_8626, obj_t obj_8627)
{
   {
      variable_t aux_12042;
      aux_12042 = make_vector_app_owner_193_cfa_info((make_vector_app_205_t) (obj_8627));
      return (obj_t) (aux_12042);
   }
}


/* make-vector-app-stackable?-set! */ obj_t 
make_vector_app_stackable__set__110_cfa_info(make_vector_app_205_t obj_395, bool_t val2210_396)
{
   {
      obj_t aux_12046;
      {
	 object_t aux_12047;
	 aux_12047 = (object_t) (obj_395);
	 aux_12046 = OBJECT_WIDENING(aux_12047);
      }
      return ((((make_vector_app_205_t) CREF(aux_12046))->stackable__42) = ((bool_t) val2210_396), BUNSPEC);
   }
}


/* _make-vector-app-stackable?-set!3986 */ obj_t 
_make_vector_app_stackable__set_3986_235_cfa_info(obj_t env_8628, obj_t obj_8629, obj_t val2210_8630)
{
   return make_vector_app_stackable__set__110_cfa_info((make_vector_app_205_t) (obj_8629), CBOOL(val2210_8630));
}


/* make-vector-app-stackable? */ bool_t 
make_vector_app_stackable__199_cfa_info(make_vector_app_205_t obj_397)
{
   {
      obj_t aux_12054;
      {
	 object_t aux_12055;
	 aux_12055 = (object_t) (obj_397);
	 aux_12054 = OBJECT_WIDENING(aux_12055);
      }
      return (((make_vector_app_205_t) CREF(aux_12054))->stackable__42);
   }
}


/* _make-vector-app-stackable?3987 */ obj_t 
_make_vector_app_stackable_3987_124_cfa_info(obj_t env_8631, obj_t obj_8632)
{
   {
      bool_t aux_12059;
      aux_12059 = make_vector_app_stackable__199_cfa_info((make_vector_app_205_t) (obj_8632));
      return BBOOL(aux_12059);
   }
}


/* make-vector-app-stack-stamp-set! */ obj_t 
make_vector_app_stack_stamp_set__141_cfa_info(make_vector_app_205_t obj_398, obj_t val2211_399)
{
   {
      obj_t aux_12063;
      {
	 object_t aux_12064;
	 aux_12064 = (object_t) (obj_398);
	 aux_12063 = OBJECT_WIDENING(aux_12064);
      }
      return ((((make_vector_app_205_t) CREF(aux_12063))->stack_stamp_31) = ((obj_t) val2211_399), BUNSPEC);
   }
}


/* _make-vector-app-stack-stamp-set!3988 */ obj_t 
_make_vector_app_stack_stamp_set_3988_78_cfa_info(obj_t env_8633, obj_t obj_8634, obj_t val2211_8635)
{
   return make_vector_app_stack_stamp_set__141_cfa_info((make_vector_app_205_t) (obj_8634), val2211_8635);
}


/* make-vector-app-stack-stamp */ obj_t 
make_vector_app_stack_stamp_1_cfa_info(make_vector_app_205_t obj_400)
{
   {
      obj_t aux_12070;
      {
	 object_t aux_12071;
	 aux_12071 = (object_t) (obj_400);
	 aux_12070 = OBJECT_WIDENING(aux_12071);
      }
      return (((make_vector_app_205_t) CREF(aux_12070))->stack_stamp_31);
   }
}


/* _make-vector-app-stack-stamp3989 */ obj_t 
_make_vector_app_stack_stamp3989_185_cfa_info(obj_t env_8636, obj_t obj_8637)
{
   return make_vector_app_stack_stamp_1_cfa_info((make_vector_app_205_t) (obj_8637));
}


/* make-vector-app-seen?-set! */ obj_t 
make_vector_app_seen__set__213_cfa_info(make_vector_app_205_t obj_401, bool_t val2212_402)
{
   {
      obj_t aux_12077;
      {
	 object_t aux_12078;
	 aux_12078 = (object_t) (obj_401);
	 aux_12077 = OBJECT_WIDENING(aux_12078);
      }
      return ((((make_vector_app_205_t) CREF(aux_12077))->seen__39) = ((bool_t) val2212_402), BUNSPEC);
   }
}


/* _make-vector-app-seen?-set!3990 */ obj_t 
_make_vector_app_seen__set_3990_22_cfa_info(obj_t env_8638, obj_t obj_8639, obj_t val2212_8640)
{
   return make_vector_app_seen__set__213_cfa_info((make_vector_app_205_t) (obj_8639), CBOOL(val2212_8640));
}


/* make-vector-app-seen? */ bool_t 
make_vector_app_seen__62_cfa_info(make_vector_app_205_t obj_403)
{
   {
      obj_t aux_12085;
      {
	 object_t aux_12086;
	 aux_12086 = (object_t) (obj_403);
	 aux_12085 = OBJECT_WIDENING(aux_12086);
      }
      return (((make_vector_app_205_t) CREF(aux_12085))->seen__39);
   }
}


/* _make-vector-app-seen?3991 */ obj_t 
_make_vector_app_seen_3991_253_cfa_info(obj_t env_8641, obj_t obj_8642)
{
   {
      bool_t aux_12090;
      aux_12090 = make_vector_app_seen__62_cfa_info((make_vector_app_205_t) (obj_8642));
      return BBOOL(aux_12090);
   }
}


/* allocate-pre-vector-set!-app */ app_t 
allocate_pre_vector_set__app_20_cfa_info()
{
   {
      app_t new2184_2539;
      new2184_2539 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2833_2540;
	 arg2833_2540 = class_num_218___object(pre_vector_set__app_211_cfa_info);
	 {
	    obj_t obj_4902;
	    obj_4902 = (obj_t) (new2184_2539);
	    (((obj_t) CREF(obj_4902))->header = MAKE_HEADER(arg2833_2540, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_12098;
	 aux_12098 = (object_t) (new2184_2539);
	 OBJECT_WIDENING_SET(aux_12098, BFALSE);
      }
      return new2184_2539;
   }
}


/* _allocate-pre-vector-set!-app */ obj_t 
_allocate_pre_vector_set__app_63_cfa_info(obj_t env_8060)
{
   {
      app_t aux_12101;
      aux_12101 = allocate_pre_vector_set__app_20_cfa_info();
      return (obj_t) (aux_12101);
   }
}


/* pre-vector-set!-app? */ bool_t 
pre_vector_set__app__39_cfa_info(obj_t obj_407)
{
   return is_a__118___object(obj_407, pre_vector_set__app_211_cfa_info);
}


/* _pre-vector-set!-app? */ obj_t 
_pre_vector_set__app__223_cfa_info(obj_t env_8643, obj_t obj_8644)
{
   {
      bool_t aux_12105;
      aux_12105 = pre_vector_set__app__39_cfa_info(obj_8644);
      return BBOOL(aux_12105);
   }
}


/* widening1040-pre-vector-set!-app */ pre_vector_set__app_211_t 
widening1040_pre_vector_set__app_254_cfa_info()
{
   {
      return ((pre_vector_set__app_211_t) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
   }
}


/* _widening1040-pre-vector-set!-app */ obj_t 
_widening1040_pre_vector_set__app_75_cfa_info(obj_t env_8645)
{
   {
      pre_vector_set__app_211_t aux_12109;
      aux_12109 = widening1040_pre_vector_set__app_254_cfa_info();
      return (obj_t) (aux_12109);
   }
}


/* make-pre-vector-set!-app */ pre_vector_set__app_211_t 
make_pre_vector_set__app_26_cfa_info(obj_t loc_408, type_t type_409, obj_t side_effect__165_410, obj_t key_411, var_t fun_412, obj_t args_413, obj_t stack_info_255_414)
{
   {
      app_t aux2176_4905;
      {
	 app_t res3692_4927;
	 {
	    app_t new1289_4916;
	    new1289_4916 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4917;
	       arg2999_4917 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4925;
		  obj_4925 = (obj_t) (new1289_4916);
		  (((obj_t) CREF(obj_4925))->header = MAKE_HEADER(arg2999_4917, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_12116;
	       aux_12116 = (object_t) (new1289_4916);
	       OBJECT_WIDENING_SET(aux_12116, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4916))->loc) = ((obj_t) loc_408), BUNSPEC);
	    ((((app_t) CREF(new1289_4916))->type) = ((type_t) type_409), BUNSPEC);
	    ((((app_t) CREF(new1289_4916))->side_effect__165) = ((obj_t) side_effect__165_410), BUNSPEC);
	    ((((app_t) CREF(new1289_4916))->key) = ((obj_t) key_411), BUNSPEC);
	    ((((app_t) CREF(new1289_4916))->fun) = ((var_t) fun_412), BUNSPEC);
	    ((((app_t) CREF(new1289_4916))->args) = ((obj_t) args_413), BUNSPEC);
	    ((((app_t) CREF(new1289_4916))->stack_info_255) = ((obj_t) stack_info_255_414), BUNSPEC);
	    res3692_4927 = new1289_4916;
	 }
	 aux2176_4905 = res3692_4927;
      }
      {
	 pre_vector_set__app_211_t new2177_4906;
	 new2177_4906 = ((pre_vector_set__app_211_t) (aux2176_4905));
	 {
	    long arg2834_4907;
	    arg2834_4907 = class_num_218___object(pre_vector_set__app_211_cfa_info);
	    {
	       obj_t obj_4928;
	       obj_4928 = (obj_t) (new2177_4906);
	       (((obj_t) CREF(obj_4928))->header = MAKE_HEADER(arg2834_4907, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_12132;
	    object_t aux_12130;
	    {
	       pre_vector_set__app_211_t aux_12133;
	       {
		  aux_12133 = ((pre_vector_set__app_211_t) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
	       }
	       aux_12132 = (obj_t) (aux_12133);
	    }
	    aux_12130 = (object_t) (new2177_4906);
	    OBJECT_WIDENING_SET(aux_12130, aux_12132);
	 }
	 return new2177_4906;
      }
   }
}


/* _make-pre-vector-set!-app3992 */ obj_t 
_make_pre_vector_set__app3992_134_cfa_info(obj_t env_8646, obj_t loc_8647, obj_t type_8648, obj_t side_effect__165_8649, obj_t key_8650, obj_t fun_8651, obj_t args_8652, obj_t stack_info_255_8653)
{
   {
      pre_vector_set__app_211_t aux_12137;
      aux_12137 = make_pre_vector_set__app_26_cfa_info(loc_8647, (type_t) (type_8648), side_effect__165_8649, key_8650, (var_t) (fun_8651), args_8652, stack_info_255_8653);
      return (obj_t) (aux_12137);
   }
}


/* pre-vector-set!-app-loc */ obj_t 
pre_vector_set__app_loc_126_cfa_info(app_t obj_415)
{
   return (((app_t) CREF(obj_415))->loc);
}


/* _pre-vector-set!-app-loc3993 */ obj_t 
_pre_vector_set__app_loc3993_34_cfa_info(obj_t env_8654, obj_t obj_8655)
{
   return pre_vector_set__app_loc_126_cfa_info((app_t) (obj_8655));
}


/* pre-vector-set!-app-type-set! */ obj_t 
pre_vector_set__app_type_set__58_cfa_info(app_t obj_416, type_t val2178_417)
{
   return ((((app_t) CREF(obj_416))->type) = ((type_t) val2178_417), BUNSPEC);
}


/* _pre-vector-set!-app-type-set!3994 */ obj_t 
_pre_vector_set__app_type_set_3994_42_cfa_info(obj_t env_8656, obj_t obj_8657, obj_t val2178_8658)
{
   return pre_vector_set__app_type_set__58_cfa_info((app_t) (obj_8657), (type_t) (val2178_8658));
}


/* pre-vector-set!-app-type */ type_t 
pre_vector_set__app_type_92_cfa_info(app_t obj_418)
{
   return (((app_t) CREF(obj_418))->type);
}


/* _pre-vector-set!-app-type3995 */ obj_t 
_pre_vector_set__app_type3995_199_cfa_info(obj_t env_8659, obj_t obj_8660)
{
   {
      type_t aux_12150;
      aux_12150 = pre_vector_set__app_type_92_cfa_info((app_t) (obj_8660));
      return (obj_t) (aux_12150);
   }
}


/* pre-vector-set!-app-side-effect?-set! */ obj_t 
pre_vector_set__app_side_effect__set__23_cfa_info(app_t obj_419, obj_t val2179_420)
{
   return ((((app_t) CREF(obj_419))->side_effect__165) = ((obj_t) val2179_420), BUNSPEC);
}


/* _pre-vector-set!-app-side-effect?-set!3996 */ obj_t 
_pre_vector_set__app_side_effect__set_3996_17_cfa_info(obj_t env_8661, obj_t obj_8662, obj_t val2179_8663)
{
   return pre_vector_set__app_side_effect__set__23_cfa_info((app_t) (obj_8662), val2179_8663);
}


/* pre-vector-set!-app-side-effect? */ obj_t 
pre_vector_set__app_side_effect__17_cfa_info(app_t obj_421)
{
   return (((app_t) CREF(obj_421))->side_effect__165);
}


/* _pre-vector-set!-app-side-effect?3997 */ obj_t 
_pre_vector_set__app_side_effect_3997_75_cfa_info(obj_t env_8664, obj_t obj_8665)
{
   return pre_vector_set__app_side_effect__17_cfa_info((app_t) (obj_8665));
}


/* pre-vector-set!-app-key-set! */ obj_t 
pre_vector_set__app_key_set__109_cfa_info(app_t obj_422, obj_t val2180_423)
{
   return ((((app_t) CREF(obj_422))->key) = ((obj_t) val2180_423), BUNSPEC);
}


/* _pre-vector-set!-app-key-set! */ obj_t 
_pre_vector_set__app_key_set__241_cfa_info(obj_t env_8666, obj_t obj_8667, obj_t val2180_8668)
{
   return pre_vector_set__app_key_set__109_cfa_info((app_t) (obj_8667), val2180_8668);
}


/* pre-vector-set!-app-key */ obj_t 
pre_vector_set__app_key_243_cfa_info(app_t obj_424)
{
   return (((app_t) CREF(obj_424))->key);
}


/* _pre-vector-set!-app-key */ obj_t 
_pre_vector_set__app_key_195_cfa_info(obj_t env_8669, obj_t obj_8670)
{
   return pre_vector_set__app_key_243_cfa_info((app_t) (obj_8670));
}


/* pre-vector-set!-app-fun-set! */ obj_t 
pre_vector_set__app_fun_set__57_cfa_info(app_t obj_425, var_t val2181_426)
{
   return ((((app_t) CREF(obj_425))->fun) = ((var_t) val2181_426), BUNSPEC);
}


/* _pre-vector-set!-app-fun-set!3998 */ obj_t 
_pre_vector_set__app_fun_set_3998_143_cfa_info(obj_t env_8671, obj_t obj_8672, obj_t val2181_8673)
{
   return pre_vector_set__app_fun_set__57_cfa_info((app_t) (obj_8672), (var_t) (val2181_8673));
}


/* pre-vector-set!-app-fun */ var_t 
pre_vector_set__app_fun_157_cfa_info(app_t obj_427)
{
   return (((app_t) CREF(obj_427))->fun);
}


/* _pre-vector-set!-app-fun3999 */ obj_t 
_pre_vector_set__app_fun3999_141_cfa_info(obj_t env_8674, obj_t obj_8675)
{
   {
      var_t aux_12171;
      aux_12171 = pre_vector_set__app_fun_157_cfa_info((app_t) (obj_8675));
      return (obj_t) (aux_12171);
   }
}


/* pre-vector-set!-app-args-set! */ obj_t 
pre_vector_set__app_args_set__202_cfa_info(app_t obj_428, obj_t val2182_429)
{
   return ((((app_t) CREF(obj_428))->args) = ((obj_t) val2182_429), BUNSPEC);
}


/* _pre-vector-set!-app-args-set!4000 */ obj_t 
_pre_vector_set__app_args_set_4000_233_cfa_info(obj_t env_8676, obj_t obj_8677, obj_t val2182_8678)
{
   return pre_vector_set__app_args_set__202_cfa_info((app_t) (obj_8677), val2182_8678);
}


/* pre-vector-set!-app-args */ obj_t 
pre_vector_set__app_args_27_cfa_info(app_t obj_430)
{
   return (((app_t) CREF(obj_430))->args);
}


/* _pre-vector-set!-app-args4001 */ obj_t 
_pre_vector_set__app_args4001_232_cfa_info(obj_t env_8679, obj_t obj_8680)
{
   return pre_vector_set__app_args_27_cfa_info((app_t) (obj_8680));
}


/* pre-vector-set!-app-stack-info-set! */ obj_t 
pre_vector_set__app_stack_info_set__9_cfa_info(app_t obj_431, obj_t val2183_432)
{
   return ((((app_t) CREF(obj_431))->stack_info_255) = ((obj_t) val2183_432), BUNSPEC);
}


/* _pre-vector-set!-app-stack-info-set!4002 */ obj_t 
_pre_vector_set__app_stack_info_set_4002_134_cfa_info(obj_t env_8681, obj_t obj_8682, obj_t val2183_8683)
{
   return pre_vector_set__app_stack_info_set__9_cfa_info((app_t) (obj_8682), val2183_8683);
}


/* pre-vector-set!-app-stack-info */ obj_t 
pre_vector_set__app_stack_info_98_cfa_info(app_t obj_433)
{
   return (((app_t) CREF(obj_433))->stack_info_255);
}


/* _pre-vector-set!-app-stack-info4003 */ obj_t 
_pre_vector_set__app_stack_info4003_26_cfa_info(obj_t env_8684, obj_t obj_8685)
{
   return pre_vector_set__app_stack_info_98_cfa_info((app_t) (obj_8685));
}


/* allocate-pre-vector-ref-app */ app_t 
allocate_pre_vector_ref_app_241_cfa_info()
{
   {
      app_t new2167_2546;
      new2167_2546 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2836_2547;
	 arg2836_2547 = class_num_218___object(pre_vector_ref_app_208_cfa_info);
	 {
	    obj_t obj_4932;
	    obj_4932 = (obj_t) (new2167_2546);
	    (((obj_t) CREF(obj_4932))->header = MAKE_HEADER(arg2836_2547, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_12191;
	 aux_12191 = (object_t) (new2167_2546);
	 OBJECT_WIDENING_SET(aux_12191, BFALSE);
      }
      return new2167_2546;
   }
}


/* _allocate-pre-vector-ref-app */ obj_t 
_allocate_pre_vector_ref_app_31_cfa_info(obj_t env_8059)
{
   {
      app_t aux_12194;
      aux_12194 = allocate_pre_vector_ref_app_241_cfa_info();
      return (obj_t) (aux_12194);
   }
}


/* pre-vector-ref-app? */ bool_t 
pre_vector_ref_app__184_cfa_info(obj_t obj_437)
{
   return is_a__118___object(obj_437, pre_vector_ref_app_208_cfa_info);
}


/* _pre-vector-ref-app? */ obj_t 
_pre_vector_ref_app__133_cfa_info(obj_t env_8686, obj_t obj_8687)
{
   {
      bool_t aux_12198;
      aux_12198 = pre_vector_ref_app__184_cfa_info(obj_8687);
      return BBOOL(aux_12198);
   }
}


/* widening1039-pre-vector-ref-app */ pre_vector_ref_app_208_t 
widening1039_pre_vector_ref_app_74_cfa_info()
{
   {
      return ((pre_vector_ref_app_208_t) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
   }
}


/* _widening1039-pre-vector-ref-app */ obj_t 
_widening1039_pre_vector_ref_app_183_cfa_info(obj_t env_8688)
{
   {
      pre_vector_ref_app_208_t aux_12202;
      aux_12202 = widening1039_pre_vector_ref_app_74_cfa_info();
      return (obj_t) (aux_12202);
   }
}


/* make-pre-vector-ref-app */ pre_vector_ref_app_208_t 
make_pre_vector_ref_app_82_cfa_info(obj_t loc_438, type_t type_439, obj_t side_effect__165_440, obj_t key_441, var_t fun_442, obj_t args_443, obj_t stack_info_255_444)
{
   {
      app_t aux2159_4935;
      {
	 app_t res3694_4957;
	 {
	    app_t new1289_4946;
	    new1289_4946 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4947;
	       arg2999_4947 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4955;
		  obj_4955 = (obj_t) (new1289_4946);
		  (((obj_t) CREF(obj_4955))->header = MAKE_HEADER(arg2999_4947, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_12209;
	       aux_12209 = (object_t) (new1289_4946);
	       OBJECT_WIDENING_SET(aux_12209, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4946))->loc) = ((obj_t) loc_438), BUNSPEC);
	    ((((app_t) CREF(new1289_4946))->type) = ((type_t) type_439), BUNSPEC);
	    ((((app_t) CREF(new1289_4946))->side_effect__165) = ((obj_t) side_effect__165_440), BUNSPEC);
	    ((((app_t) CREF(new1289_4946))->key) = ((obj_t) key_441), BUNSPEC);
	    ((((app_t) CREF(new1289_4946))->fun) = ((var_t) fun_442), BUNSPEC);
	    ((((app_t) CREF(new1289_4946))->args) = ((obj_t) args_443), BUNSPEC);
	    ((((app_t) CREF(new1289_4946))->stack_info_255) = ((obj_t) stack_info_255_444), BUNSPEC);
	    res3694_4957 = new1289_4946;
	 }
	 aux2159_4935 = res3694_4957;
      }
      {
	 pre_vector_ref_app_208_t new2160_4936;
	 new2160_4936 = ((pre_vector_ref_app_208_t) (aux2159_4935));
	 {
	    long arg2837_4937;
	    arg2837_4937 = class_num_218___object(pre_vector_ref_app_208_cfa_info);
	    {
	       obj_t obj_4958;
	       obj_4958 = (obj_t) (new2160_4936);
	       (((obj_t) CREF(obj_4958))->header = MAKE_HEADER(arg2837_4937, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_12225;
	    object_t aux_12223;
	    {
	       pre_vector_ref_app_208_t aux_12226;
	       {
		  aux_12226 = ((pre_vector_ref_app_208_t) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
	       }
	       aux_12225 = (obj_t) (aux_12226);
	    }
	    aux_12223 = (object_t) (new2160_4936);
	    OBJECT_WIDENING_SET(aux_12223, aux_12225);
	 }
	 return new2160_4936;
      }
   }
}


/* _make-pre-vector-ref-app4004 */ obj_t 
_make_pre_vector_ref_app4004_14_cfa_info(obj_t env_8689, obj_t loc_8690, obj_t type_8691, obj_t side_effect__165_8692, obj_t key_8693, obj_t fun_8694, obj_t args_8695, obj_t stack_info_255_8696)
{
   {
      pre_vector_ref_app_208_t aux_12230;
      aux_12230 = make_pre_vector_ref_app_82_cfa_info(loc_8690, (type_t) (type_8691), side_effect__165_8692, key_8693, (var_t) (fun_8694), args_8695, stack_info_255_8696);
      return (obj_t) (aux_12230);
   }
}


/* pre-vector-ref-app-loc */ obj_t 
pre_vector_ref_app_loc_154_cfa_info(app_t obj_445)
{
   return (((app_t) CREF(obj_445))->loc);
}


/* _pre-vector-ref-app-loc4005 */ obj_t 
_pre_vector_ref_app_loc4005_201_cfa_info(obj_t env_8697, obj_t obj_8698)
{
   return pre_vector_ref_app_loc_154_cfa_info((app_t) (obj_8698));
}


/* pre-vector-ref-app-type-set! */ obj_t 
pre_vector_ref_app_type_set__203_cfa_info(app_t obj_446, type_t val2161_447)
{
   return ((((app_t) CREF(obj_446))->type) = ((type_t) val2161_447), BUNSPEC);
}


/* _pre-vector-ref-app-type-set!4006 */ obj_t 
_pre_vector_ref_app_type_set_4006_27_cfa_info(obj_t env_8699, obj_t obj_8700, obj_t val2161_8701)
{
   return pre_vector_ref_app_type_set__203_cfa_info((app_t) (obj_8700), (type_t) (val2161_8701));
}


/* pre-vector-ref-app-type */ type_t 
pre_vector_ref_app_type_159_cfa_info(app_t obj_448)
{
   return (((app_t) CREF(obj_448))->type);
}


/* _pre-vector-ref-app-type4007 */ obj_t 
_pre_vector_ref_app_type4007_159_cfa_info(obj_t env_8702, obj_t obj_8703)
{
   {
      type_t aux_12243;
      aux_12243 = pre_vector_ref_app_type_159_cfa_info((app_t) (obj_8703));
      return (obj_t) (aux_12243);
   }
}


/* pre-vector-ref-app-side-effect?-set! */ obj_t 
pre_vector_ref_app_side_effect__set__95_cfa_info(app_t obj_449, obj_t val2162_450)
{
   return ((((app_t) CREF(obj_449))->side_effect__165) = ((obj_t) val2162_450), BUNSPEC);
}


/* _pre-vector-ref-app-side-effect?-set!4008 */ obj_t 
_pre_vector_ref_app_side_effect__set_4008_64_cfa_info(obj_t env_8704, obj_t obj_8705, obj_t val2162_8706)
{
   return pre_vector_ref_app_side_effect__set__95_cfa_info((app_t) (obj_8705), val2162_8706);
}


/* pre-vector-ref-app-side-effect? */ obj_t 
pre_vector_ref_app_side_effect__40_cfa_info(app_t obj_451)
{
   return (((app_t) CREF(obj_451))->side_effect__165);
}


/* _pre-vector-ref-app-side-effect?4009 */ obj_t 
_pre_vector_ref_app_side_effect_4009_50_cfa_info(obj_t env_8707, obj_t obj_8708)
{
   return pre_vector_ref_app_side_effect__40_cfa_info((app_t) (obj_8708));
}


/* pre-vector-ref-app-key-set! */ obj_t 
pre_vector_ref_app_key_set__8_cfa_info(app_t obj_452, obj_t val2163_453)
{
   return ((((app_t) CREF(obj_452))->key) = ((obj_t) val2163_453), BUNSPEC);
}


/* _pre-vector-ref-app-key-set! */ obj_t 
_pre_vector_ref_app_key_set__22_cfa_info(obj_t env_8709, obj_t obj_8710, obj_t val2163_8711)
{
   return pre_vector_ref_app_key_set__8_cfa_info((app_t) (obj_8710), val2163_8711);
}


/* pre-vector-ref-app-key */ obj_t 
pre_vector_ref_app_key_59_cfa_info(app_t obj_454)
{
   return (((app_t) CREF(obj_454))->key);
}


/* _pre-vector-ref-app-key */ obj_t 
_pre_vector_ref_app_key_37_cfa_info(obj_t env_8712, obj_t obj_8713)
{
   return pre_vector_ref_app_key_59_cfa_info((app_t) (obj_8713));
}


/* pre-vector-ref-app-fun-set! */ obj_t 
pre_vector_ref_app_fun_set__200_cfa_info(app_t obj_455, var_t val2164_456)
{
   return ((((app_t) CREF(obj_455))->fun) = ((var_t) val2164_456), BUNSPEC);
}


/* _pre-vector-ref-app-fun-set!4010 */ obj_t 
_pre_vector_ref_app_fun_set_4010_91_cfa_info(obj_t env_8714, obj_t obj_8715, obj_t val2164_8716)
{
   return pre_vector_ref_app_fun_set__200_cfa_info((app_t) (obj_8715), (var_t) (val2164_8716));
}


/* pre-vector-ref-app-fun */ var_t 
pre_vector_ref_app_fun_8_cfa_info(app_t obj_457)
{
   return (((app_t) CREF(obj_457))->fun);
}


/* _pre-vector-ref-app-fun4011 */ obj_t 
_pre_vector_ref_app_fun4011_88_cfa_info(obj_t env_8717, obj_t obj_8718)
{
   {
      var_t aux_12264;
      aux_12264 = pre_vector_ref_app_fun_8_cfa_info((app_t) (obj_8718));
      return (obj_t) (aux_12264);
   }
}


/* pre-vector-ref-app-args-set! */ obj_t 
pre_vector_ref_app_args_set__156_cfa_info(app_t obj_458, obj_t val2165_459)
{
   return ((((app_t) CREF(obj_458))->args) = ((obj_t) val2165_459), BUNSPEC);
}


/* _pre-vector-ref-app-args-set!4012 */ obj_t 
_pre_vector_ref_app_args_set_4012_83_cfa_info(obj_t env_8719, obj_t obj_8720, obj_t val2165_8721)
{
   return pre_vector_ref_app_args_set__156_cfa_info((app_t) (obj_8720), val2165_8721);
}


/* pre-vector-ref-app-args */ obj_t 
pre_vector_ref_app_args_207_cfa_info(app_t obj_460)
{
   return (((app_t) CREF(obj_460))->args);
}


/* _pre-vector-ref-app-args4013 */ obj_t 
_pre_vector_ref_app_args4013_248_cfa_info(obj_t env_8722, obj_t obj_8723)
{
   return pre_vector_ref_app_args_207_cfa_info((app_t) (obj_8723));
}


/* pre-vector-ref-app-stack-info-set! */ obj_t 
pre_vector_ref_app_stack_info_set__151_cfa_info(app_t obj_461, obj_t val2166_462)
{
   return ((((app_t) CREF(obj_461))->stack_info_255) = ((obj_t) val2166_462), BUNSPEC);
}


/* _pre-vector-ref-app-stack-info-set!4014 */ obj_t 
_pre_vector_ref_app_stack_info_set_4014_28_cfa_info(obj_t env_8724, obj_t obj_8725, obj_t val2166_8726)
{
   return pre_vector_ref_app_stack_info_set__151_cfa_info((app_t) (obj_8725), val2166_8726);
}


/* pre-vector-ref-app-stack-info */ obj_t 
pre_vector_ref_app_stack_info_34_cfa_info(app_t obj_463)
{
   return (((app_t) CREF(obj_463))->stack_info_255);
}


/* _pre-vector-ref-app-stack-info4015 */ obj_t 
_pre_vector_ref_app_stack_info4015_64_cfa_info(obj_t env_8727, obj_t obj_8728)
{
   return pre_vector_ref_app_stack_info_34_cfa_info((app_t) (obj_8728));
}


/* allocate-pre-create-vector-app */ app_t 
allocate_pre_create_vector_app_95_cfa_info()
{
   {
      app_t new2150_2553;
      new2150_2553 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2839_2554;
	 arg2839_2554 = class_num_218___object(pre_create_vector_app_162_cfa_info);
	 {
	    obj_t obj_4962;
	    obj_4962 = (obj_t) (new2150_2553);
	    (((obj_t) CREF(obj_4962))->header = MAKE_HEADER(arg2839_2554, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_12284;
	 aux_12284 = (object_t) (new2150_2553);
	 OBJECT_WIDENING_SET(aux_12284, BFALSE);
      }
      return new2150_2553;
   }
}


/* _allocate-pre-create-vector-app */ obj_t 
_allocate_pre_create_vector_app_171_cfa_info(obj_t env_8058)
{
   {
      app_t aux_12287;
      aux_12287 = allocate_pre_create_vector_app_95_cfa_info();
      return (obj_t) (aux_12287);
   }
}


/* pre-create-vector-app? */ bool_t 
pre_create_vector_app__191_cfa_info(obj_t obj_467)
{
   return is_a__118___object(obj_467, pre_create_vector_app_162_cfa_info);
}


/* _pre-create-vector-app? */ obj_t 
_pre_create_vector_app__32_cfa_info(obj_t env_8729, obj_t obj_8730)
{
   {
      bool_t aux_12291;
      aux_12291 = pre_create_vector_app__191_cfa_info(obj_8730);
      return BBOOL(aux_12291);
   }
}


/* widening1038-pre-create-vector-app */ pre_create_vector_app_162_t 
widening1038_pre_create_vector_app_165_cfa_info(variable_t owner_468)
{
   {
      pre_create_vector_app_162_t new2139_4964;
      new2139_4964 = ((pre_create_vector_app_162_t) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
      ((((pre_create_vector_app_162_t) CREF(new2139_4964))->owner) = ((variable_t) owner_468), BUNSPEC);
      return new2139_4964;
   }
}


/* _widening1038-pre-create-vector-app4016 */ obj_t 
_widening1038_pre_create_vector_app4016_34_cfa_info(obj_t env_8731, obj_t owner_8732)
{
   {
      pre_create_vector_app_162_t aux_12296;
      aux_12296 = widening1038_pre_create_vector_app_165_cfa_info((variable_t) (owner_8732));
      return (obj_t) (aux_12296);
   }
}


/* make-pre-create-vector-app */ pre_create_vector_app_162_t 
make_pre_create_vector_app_207_cfa_info(obj_t loc_469, type_t type_470, obj_t side_effect__165_471, obj_t key_472, var_t fun_473, obj_t args_474, obj_t stack_info_255_475, variable_t owner_476)
{
   {
      app_t aux2142_4966;
      {
	 app_t res3696_4988;
	 {
	    app_t new1289_4977;
	    new1289_4977 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_4978;
	       arg2999_4978 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_4986;
		  obj_4986 = (obj_t) (new1289_4977);
		  (((obj_t) CREF(obj_4986))->header = MAKE_HEADER(arg2999_4978, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_12304;
	       aux_12304 = (object_t) (new1289_4977);
	       OBJECT_WIDENING_SET(aux_12304, BFALSE);
	    }
	    ((((app_t) CREF(new1289_4977))->loc) = ((obj_t) loc_469), BUNSPEC);
	    ((((app_t) CREF(new1289_4977))->type) = ((type_t) type_470), BUNSPEC);
	    ((((app_t) CREF(new1289_4977))->side_effect__165) = ((obj_t) side_effect__165_471), BUNSPEC);
	    ((((app_t) CREF(new1289_4977))->key) = ((obj_t) key_472), BUNSPEC);
	    ((((app_t) CREF(new1289_4977))->fun) = ((var_t) fun_473), BUNSPEC);
	    ((((app_t) CREF(new1289_4977))->args) = ((obj_t) args_474), BUNSPEC);
	    ((((app_t) CREF(new1289_4977))->stack_info_255) = ((obj_t) stack_info_255_475), BUNSPEC);
	    res3696_4988 = new1289_4977;
	 }
	 aux2142_4966 = res3696_4988;
      }
      {
	 pre_create_vector_app_162_t new2143_4967;
	 new2143_4967 = ((pre_create_vector_app_162_t) (aux2142_4966));
	 {
	    long arg2840_4968;
	    arg2840_4968 = class_num_218___object(pre_create_vector_app_162_cfa_info);
	    {
	       obj_t obj_4989;
	       obj_4989 = (obj_t) (new2143_4967);
	       (((obj_t) CREF(obj_4989))->header = MAKE_HEADER(arg2840_4968, 0), BUNSPEC);
	    }
	 }
	 {
	    pre_create_vector_app_162_t arg2841_4969;
	    {
	       pre_create_vector_app_162_t res3697_4994;
	       {
		  pre_create_vector_app_162_t new2139_4992;
		  new2139_4992 = ((pre_create_vector_app_162_t) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
		  ((((pre_create_vector_app_162_t) CREF(new2139_4992))->owner) = ((variable_t) owner_476), BUNSPEC);
		  res3697_4994 = new2139_4992;
	       }
	       arg2841_4969 = res3697_4994;
	    }
	    {
	       obj_t aux_12322;
	       object_t aux_12320;
	       aux_12322 = (obj_t) (arg2841_4969);
	       aux_12320 = (object_t) (new2143_4967);
	       OBJECT_WIDENING_SET(aux_12320, aux_12322);
	    }
	 }
	 return new2143_4967;
      }
   }
}


/* _make-pre-create-vector-app4017 */ obj_t 
_make_pre_create_vector_app4017_15_cfa_info(obj_t env_8733, obj_t loc_8734, obj_t type_8735, obj_t side_effect__165_8736, obj_t key_8737, obj_t fun_8738, obj_t args_8739, obj_t stack_info_255_8740, obj_t owner_8741)
{
   {
      pre_create_vector_app_162_t aux_12325;
      aux_12325 = make_pre_create_vector_app_207_cfa_info(loc_8734, (type_t) (type_8735), side_effect__165_8736, key_8737, (var_t) (fun_8738), args_8739, stack_info_255_8740, (variable_t) (owner_8741));
      return (obj_t) (aux_12325);
   }
}


/* pre-create-vector-app-loc */ obj_t 
pre_create_vector_app_loc_83_cfa_info(app_t obj_477)
{
   return (((app_t) CREF(obj_477))->loc);
}


/* _pre-create-vector-app-loc4018 */ obj_t 
_pre_create_vector_app_loc4018_46_cfa_info(obj_t env_8742, obj_t obj_8743)
{
   return pre_create_vector_app_loc_83_cfa_info((app_t) (obj_8743));
}


/* pre-create-vector-app-type-set! */ obj_t 
pre_create_vector_app_type_set__172_cfa_info(app_t obj_478, type_t val2144_479)
{
   return ((((app_t) CREF(obj_478))->type) = ((type_t) val2144_479), BUNSPEC);
}


/* _pre-create-vector-app-type-set!4019 */ obj_t 
_pre_create_vector_app_type_set_4019_91_cfa_info(obj_t env_8744, obj_t obj_8745, obj_t val2144_8746)
{
   return pre_create_vector_app_type_set__172_cfa_info((app_t) (obj_8745), (type_t) (val2144_8746));
}


/* pre-create-vector-app-type */ type_t 
pre_create_vector_app_type_138_cfa_info(app_t obj_480)
{
   return (((app_t) CREF(obj_480))->type);
}


/* _pre-create-vector-app-type4020 */ obj_t 
_pre_create_vector_app_type4020_192_cfa_info(obj_t env_8747, obj_t obj_8748)
{
   {
      type_t aux_12339;
      aux_12339 = pre_create_vector_app_type_138_cfa_info((app_t) (obj_8748));
      return (obj_t) (aux_12339);
   }
}


/* pre-create-vector-app-side-effect?-set! */ obj_t 
pre_create_vector_app_side_effect__set__203_cfa_info(app_t obj_481, obj_t val2145_482)
{
   return ((((app_t) CREF(obj_481))->side_effect__165) = ((obj_t) val2145_482), BUNSPEC);
}


/* _pre-create-vector-app-side-effect?-set!4021 */ obj_t 
_pre_create_vector_app_side_effect__set_4021_43_cfa_info(obj_t env_8749, obj_t obj_8750, obj_t val2145_8751)
{
   return pre_create_vector_app_side_effect__set__203_cfa_info((app_t) (obj_8750), val2145_8751);
}


/* pre-create-vector-app-side-effect? */ obj_t 
pre_create_vector_app_side_effect__159_cfa_info(app_t obj_483)
{
   return (((app_t) CREF(obj_483))->side_effect__165);
}


/* _pre-create-vector-app-side-effect?4022 */ obj_t 
_pre_create_vector_app_side_effect_4022_243_cfa_info(obj_t env_8752, obj_t obj_8753)
{
   return pre_create_vector_app_side_effect__159_cfa_info((app_t) (obj_8753));
}


/* pre-create-vector-app-key-set! */ obj_t 
pre_create_vector_app_key_set__58_cfa_info(app_t obj_484, obj_t val2146_485)
{
   return ((((app_t) CREF(obj_484))->key) = ((obj_t) val2146_485), BUNSPEC);
}


/* _pre-create-vector-app-key-set!4023 */ obj_t 
_pre_create_vector_app_key_set_4023_254_cfa_info(obj_t env_8754, obj_t obj_8755, obj_t val2146_8756)
{
   return pre_create_vector_app_key_set__58_cfa_info((app_t) (obj_8755), val2146_8756);
}


/* pre-create-vector-app-key */ obj_t 
pre_create_vector_app_key_92_cfa_info(app_t obj_486)
{
   return (((app_t) CREF(obj_486))->key);
}


/* _pre-create-vector-app-key4024 */ obj_t 
_pre_create_vector_app_key4024_163_cfa_info(obj_t env_8757, obj_t obj_8758)
{
   return pre_create_vector_app_key_92_cfa_info((app_t) (obj_8758));
}


/* pre-create-vector-app-fun-set! */ obj_t 
pre_create_vector_app_fun_set__208_cfa_info(app_t obj_487, var_t val2147_488)
{
   return ((((app_t) CREF(obj_487))->fun) = ((var_t) val2147_488), BUNSPEC);
}


/* _pre-create-vector-app-fun-set!4025 */ obj_t 
_pre_create_vector_app_fun_set_4025_210_cfa_info(obj_t env_8759, obj_t obj_8760, obj_t val2147_8761)
{
   return pre_create_vector_app_fun_set__208_cfa_info((app_t) (obj_8760), (var_t) (val2147_8761));
}


/* pre-create-vector-app-fun */ var_t 
pre_create_vector_app_fun_107_cfa_info(app_t obj_489)
{
   return (((app_t) CREF(obj_489))->fun);
}


/* _pre-create-vector-app-fun4026 */ obj_t 
_pre_create_vector_app_fun4026_202_cfa_info(obj_t env_8762, obj_t obj_8763)
{
   {
      var_t aux_12360;
      aux_12360 = pre_create_vector_app_fun_107_cfa_info((app_t) (obj_8763));
      return (obj_t) (aux_12360);
   }
}


/* pre-create-vector-app-args-set! */ obj_t 
pre_create_vector_app_args_set__3_cfa_info(app_t obj_490, obj_t val2148_491)
{
   return ((((app_t) CREF(obj_490))->args) = ((obj_t) val2148_491), BUNSPEC);
}


/* _pre-create-vector-app-args-set!4027 */ obj_t 
_pre_create_vector_app_args_set_4027_207_cfa_info(obj_t env_8764, obj_t obj_8765, obj_t val2148_8766)
{
   return pre_create_vector_app_args_set__3_cfa_info((app_t) (obj_8765), val2148_8766);
}


/* pre-create-vector-app-args */ obj_t 
pre_create_vector_app_args_163_cfa_info(app_t obj_492)
{
   return (((app_t) CREF(obj_492))->args);
}


/* _pre-create-vector-app-args4028 */ obj_t 
_pre_create_vector_app_args4028_255_cfa_info(obj_t env_8767, obj_t obj_8768)
{
   return pre_create_vector_app_args_163_cfa_info((app_t) (obj_8768));
}


/* pre-create-vector-app-stack-info-set! */ obj_t 
pre_create_vector_app_stack_info_set__211_cfa_info(app_t obj_493, obj_t val2149_494)
{
   return ((((app_t) CREF(obj_493))->stack_info_255) = ((obj_t) val2149_494), BUNSPEC);
}


/* _pre-create-vector-app-stack-info-set!4029 */ obj_t 
_pre_create_vector_app_stack_info_set_4029_152_cfa_info(obj_t env_8769, obj_t obj_8770, obj_t val2149_8771)
{
   return pre_create_vector_app_stack_info_set__211_cfa_info((app_t) (obj_8770), val2149_8771);
}


/* pre-create-vector-app-stack-info */ obj_t 
pre_create_vector_app_stack_info_137_cfa_info(app_t obj_495)
{
   return (((app_t) CREF(obj_495))->stack_info_255);
}


/* _pre-create-vector-app-stack-info4030 */ obj_t 
_pre_create_vector_app_stack_info4030_214_cfa_info(obj_t env_8772, obj_t obj_8773)
{
   return pre_create_vector_app_stack_info_137_cfa_info((app_t) (obj_8773));
}


/* pre-create-vector-app-owner */ variable_t 
pre_create_vector_app_owner_119_cfa_info(pre_create_vector_app_162_t obj_496)
{
   {
      obj_t aux_12376;
      {
	 object_t aux_12377;
	 aux_12377 = (object_t) (obj_496);
	 aux_12376 = OBJECT_WIDENING(aux_12377);
      }
      return (((pre_create_vector_app_162_t) CREF(aux_12376))->owner);
   }
}


/* _pre-create-vector-app-owner4031 */ obj_t 
_pre_create_vector_app_owner4031_176_cfa_info(obj_t env_8774, obj_t obj_8775)
{
   {
      variable_t aux_12381;
      aux_12381 = pre_create_vector_app_owner_119_cfa_info((pre_create_vector_app_162_t) (obj_8775));
      return (obj_t) (aux_12381);
   }
}


/* allocate-pre-make-vector-app */ app_t 
allocate_pre_make_vector_app_231_cfa_info()
{
   {
      app_t new2132_2561;
      new2132_2561 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2842_2562;
	 arg2842_2562 = class_num_218___object(pre_make_vector_app_251_cfa_info);
	 {
	    obj_t obj_4995;
	    obj_4995 = (obj_t) (new2132_2561);
	    (((obj_t) CREF(obj_4995))->header = MAKE_HEADER(arg2842_2562, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_12389;
	 aux_12389 = (object_t) (new2132_2561);
	 OBJECT_WIDENING_SET(aux_12389, BFALSE);
      }
      return new2132_2561;
   }
}


/* _allocate-pre-make-vector-app */ obj_t 
_allocate_pre_make_vector_app_80_cfa_info(obj_t env_8057)
{
   {
      app_t aux_12392;
      aux_12392 = allocate_pre_make_vector_app_231_cfa_info();
      return (obj_t) (aux_12392);
   }
}


/* pre-make-vector-app? */ bool_t 
pre_make_vector_app__111_cfa_info(obj_t obj_500)
{
   return is_a__118___object(obj_500, pre_make_vector_app_251_cfa_info);
}


/* _pre-make-vector-app? */ obj_t 
_pre_make_vector_app__65_cfa_info(obj_t env_8776, obj_t obj_8777)
{
   {
      bool_t aux_12396;
      aux_12396 = pre_make_vector_app__111_cfa_info(obj_8777);
      return BBOOL(aux_12396);
   }
}


/* widening1037-pre-make-vector-app */ pre_make_vector_app_251_t 
widening1037_pre_make_vector_app_63_cfa_info(variable_t owner_501)
{
   {
      pre_make_vector_app_251_t new2121_4997;
      new2121_4997 = ((pre_make_vector_app_251_t) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
      ((((pre_make_vector_app_251_t) CREF(new2121_4997))->owner) = ((variable_t) owner_501), BUNSPEC);
      return new2121_4997;
   }
}


/* _widening1037-pre-make-vector-app4032 */ obj_t 
_widening1037_pre_make_vector_app4032_253_cfa_info(obj_t env_8778, obj_t owner_8779)
{
   {
      pre_make_vector_app_251_t aux_12401;
      aux_12401 = widening1037_pre_make_vector_app_63_cfa_info((variable_t) (owner_8779));
      return (obj_t) (aux_12401);
   }
}


/* make-pre-make-vector-app */ pre_make_vector_app_251_t 
make_pre_make_vector_app_107_cfa_info(obj_t loc_502, type_t type_503, obj_t side_effect__165_504, obj_t key_505, var_t fun_506, obj_t args_507, obj_t stack_info_255_508, variable_t owner_509)
{
   {
      app_t aux2124_4999;
      {
	 app_t res3698_5021;
	 {
	    app_t new1289_5010;
	    new1289_5010 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_5011;
	       arg2999_5011 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_5019;
		  obj_5019 = (obj_t) (new1289_5010);
		  (((obj_t) CREF(obj_5019))->header = MAKE_HEADER(arg2999_5011, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_12409;
	       aux_12409 = (object_t) (new1289_5010);
	       OBJECT_WIDENING_SET(aux_12409, BFALSE);
	    }
	    ((((app_t) CREF(new1289_5010))->loc) = ((obj_t) loc_502), BUNSPEC);
	    ((((app_t) CREF(new1289_5010))->type) = ((type_t) type_503), BUNSPEC);
	    ((((app_t) CREF(new1289_5010))->side_effect__165) = ((obj_t) side_effect__165_504), BUNSPEC);
	    ((((app_t) CREF(new1289_5010))->key) = ((obj_t) key_505), BUNSPEC);
	    ((((app_t) CREF(new1289_5010))->fun) = ((var_t) fun_506), BUNSPEC);
	    ((((app_t) CREF(new1289_5010))->args) = ((obj_t) args_507), BUNSPEC);
	    ((((app_t) CREF(new1289_5010))->stack_info_255) = ((obj_t) stack_info_255_508), BUNSPEC);
	    res3698_5021 = new1289_5010;
	 }
	 aux2124_4999 = res3698_5021;
      }
      {
	 pre_make_vector_app_251_t new2125_5000;
	 new2125_5000 = ((pre_make_vector_app_251_t) (aux2124_4999));
	 {
	    long arg2843_5001;
	    arg2843_5001 = class_num_218___object(pre_make_vector_app_251_cfa_info);
	    {
	       obj_t obj_5022;
	       obj_5022 = (obj_t) (new2125_5000);
	       (((obj_t) CREF(obj_5022))->header = MAKE_HEADER(arg2843_5001, 0), BUNSPEC);
	    }
	 }
	 {
	    pre_make_vector_app_251_t arg2844_5002;
	    {
	       pre_make_vector_app_251_t res3699_5027;
	       {
		  pre_make_vector_app_251_t new2121_5025;
		  new2121_5025 = ((pre_make_vector_app_251_t) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
		  ((((pre_make_vector_app_251_t) CREF(new2121_5025))->owner) = ((variable_t) owner_509), BUNSPEC);
		  res3699_5027 = new2121_5025;
	       }
	       arg2844_5002 = res3699_5027;
	    }
	    {
	       obj_t aux_12427;
	       object_t aux_12425;
	       aux_12427 = (obj_t) (arg2844_5002);
	       aux_12425 = (object_t) (new2125_5000);
	       OBJECT_WIDENING_SET(aux_12425, aux_12427);
	    }
	 }
	 return new2125_5000;
      }
   }
}


/* _make-pre-make-vector-app4033 */ obj_t 
_make_pre_make_vector_app4033_155_cfa_info(obj_t env_8780, obj_t loc_8781, obj_t type_8782, obj_t side_effect__165_8783, obj_t key_8784, obj_t fun_8785, obj_t args_8786, obj_t stack_info_255_8787, obj_t owner_8788)
{
   {
      pre_make_vector_app_251_t aux_12430;
      aux_12430 = make_pre_make_vector_app_107_cfa_info(loc_8781, (type_t) (type_8782), side_effect__165_8783, key_8784, (var_t) (fun_8785), args_8786, stack_info_255_8787, (variable_t) (owner_8788));
      return (obj_t) (aux_12430);
   }
}


/* pre-make-vector-app-loc */ obj_t 
pre_make_vector_app_loc_212_cfa_info(app_t obj_510)
{
   return (((app_t) CREF(obj_510))->loc);
}


/* _pre-make-vector-app-loc4034 */ obj_t 
_pre_make_vector_app_loc4034_165_cfa_info(obj_t env_8789, obj_t obj_8790)
{
   return pre_make_vector_app_loc_212_cfa_info((app_t) (obj_8790));
}


/* pre-make-vector-app-type-set! */ obj_t 
pre_make_vector_app_type_set__223_cfa_info(app_t obj_511, type_t val2126_512)
{
   return ((((app_t) CREF(obj_511))->type) = ((type_t) val2126_512), BUNSPEC);
}


/* _pre-make-vector-app-type-set!4035 */ obj_t 
_pre_make_vector_app_type_set_4035_221_cfa_info(obj_t env_8791, obj_t obj_8792, obj_t val2126_8793)
{
   return pre_make_vector_app_type_set__223_cfa_info((app_t) (obj_8792), (type_t) (val2126_8793));
}


/* pre-make-vector-app-type */ type_t 
pre_make_vector_app_type_229_cfa_info(app_t obj_513)
{
   return (((app_t) CREF(obj_513))->type);
}


/* _pre-make-vector-app-type4036 */ obj_t 
_pre_make_vector_app_type4036_231_cfa_info(obj_t env_8794, obj_t obj_8795)
{
   {
      type_t aux_12444;
      aux_12444 = pre_make_vector_app_type_229_cfa_info((app_t) (obj_8795));
      return (obj_t) (aux_12444);
   }
}


/* pre-make-vector-app-side-effect?-set! */ obj_t 
pre_make_vector_app_side_effect__set__39_cfa_info(app_t obj_514, obj_t val2127_515)
{
   return ((((app_t) CREF(obj_514))->side_effect__165) = ((obj_t) val2127_515), BUNSPEC);
}


/* _pre-make-vector-app-side-effect?-set!4037 */ obj_t 
_pre_make_vector_app_side_effect__set_4037_222_cfa_info(obj_t env_8796, obj_t obj_8797, obj_t val2127_8798)
{
   return pre_make_vector_app_side_effect__set__39_cfa_info((app_t) (obj_8797), val2127_8798);
}


/* pre-make-vector-app-side-effect? */ obj_t 
pre_make_vector_app_side_effect__69_cfa_info(app_t obj_516)
{
   return (((app_t) CREF(obj_516))->side_effect__165);
}


/* _pre-make-vector-app-side-effect?4038 */ obj_t 
_pre_make_vector_app_side_effect_4038_113_cfa_info(obj_t env_8799, obj_t obj_8800)
{
   return pre_make_vector_app_side_effect__69_cfa_info((app_t) (obj_8800));
}


/* pre-make-vector-app-key-set! */ obj_t 
pre_make_vector_app_key_set__238_cfa_info(app_t obj_517, obj_t val2128_518)
{
   return ((((app_t) CREF(obj_517))->key) = ((obj_t) val2128_518), BUNSPEC);
}


/* _pre-make-vector-app-key-set!4039 */ obj_t 
_pre_make_vector_app_key_set_4039_63_cfa_info(obj_t env_8801, obj_t obj_8802, obj_t val2128_8803)
{
   return pre_make_vector_app_key_set__238_cfa_info((app_t) (obj_8802), val2128_8803);
}


/* pre-make-vector-app-key */ obj_t 
pre_make_vector_app_key_53_cfa_info(app_t obj_519)
{
   return (((app_t) CREF(obj_519))->key);
}


/* _pre-make-vector-app-key4040 */ obj_t 
_pre_make_vector_app_key4040_147_cfa_info(obj_t env_8804, obj_t obj_8805)
{
   return pre_make_vector_app_key_53_cfa_info((app_t) (obj_8805));
}


/* pre-make-vector-app-fun-set! */ obj_t 
pre_make_vector_app_fun_set__108_cfa_info(app_t obj_520, var_t val2129_521)
{
   return ((((app_t) CREF(obj_520))->fun) = ((var_t) val2129_521), BUNSPEC);
}


/* _pre-make-vector-app-fun-set!4041 */ obj_t 
_pre_make_vector_app_fun_set_4041_181_cfa_info(obj_t env_8806, obj_t obj_8807, obj_t val2129_8808)
{
   return pre_make_vector_app_fun_set__108_cfa_info((app_t) (obj_8807), (var_t) (val2129_8808));
}


/* pre-make-vector-app-fun */ var_t 
pre_make_vector_app_fun_151_cfa_info(app_t obj_522)
{
   return (((app_t) CREF(obj_522))->fun);
}


/* _pre-make-vector-app-fun4042 */ obj_t 
_pre_make_vector_app_fun4042_147_cfa_info(obj_t env_8809, obj_t obj_8810)
{
   {
      var_t aux_12465;
      aux_12465 = pre_make_vector_app_fun_151_cfa_info((app_t) (obj_8810));
      return (obj_t) (aux_12465);
   }
}


/* pre-make-vector-app-args-set! */ obj_t 
pre_make_vector_app_args_set__250_cfa_info(app_t obj_523, obj_t val2130_524)
{
   return ((((app_t) CREF(obj_523))->args) = ((obj_t) val2130_524), BUNSPEC);
}


/* _pre-make-vector-app-args-set!4043 */ obj_t 
_pre_make_vector_app_args_set_4043_152_cfa_info(obj_t env_8811, obj_t obj_8812, obj_t val2130_8813)
{
   return pre_make_vector_app_args_set__250_cfa_info((app_t) (obj_8812), val2130_8813);
}


/* pre-make-vector-app-args */ obj_t 
pre_make_vector_app_args_212_cfa_info(app_t obj_525)
{
   return (((app_t) CREF(obj_525))->args);
}


/* _pre-make-vector-app-args4044 */ obj_t 
_pre_make_vector_app_args4044_120_cfa_info(obj_t env_8814, obj_t obj_8815)
{
   return pre_make_vector_app_args_212_cfa_info((app_t) (obj_8815));
}


/* pre-make-vector-app-stack-info-set! */ obj_t 
pre_make_vector_app_stack_info_set__175_cfa_info(app_t obj_526, obj_t val2131_527)
{
   return ((((app_t) CREF(obj_526))->stack_info_255) = ((obj_t) val2131_527), BUNSPEC);
}


/* _pre-make-vector-app-stack-info-set!4045 */ obj_t 
_pre_make_vector_app_stack_info_set_4045_187_cfa_info(obj_t env_8816, obj_t obj_8817, obj_t val2131_8818)
{
   return pre_make_vector_app_stack_info_set__175_cfa_info((app_t) (obj_8817), val2131_8818);
}


/* pre-make-vector-app-stack-info */ obj_t 
pre_make_vector_app_stack_info_133_cfa_info(app_t obj_528)
{
   return (((app_t) CREF(obj_528))->stack_info_255);
}


/* _pre-make-vector-app-stack-info4046 */ obj_t 
_pre_make_vector_app_stack_info4046_220_cfa_info(obj_t env_8819, obj_t obj_8820)
{
   return pre_make_vector_app_stack_info_133_cfa_info((app_t) (obj_8820));
}


/* pre-make-vector-app-owner */ variable_t 
pre_make_vector_app_owner_220_cfa_info(pre_make_vector_app_251_t obj_529)
{
   {
      obj_t aux_12481;
      {
	 object_t aux_12482;
	 aux_12482 = (object_t) (obj_529);
	 aux_12481 = OBJECT_WIDENING(aux_12482);
      }
      return (((pre_make_vector_app_251_t) CREF(aux_12481))->owner);
   }
}


/* _pre-make-vector-app-owner4047 */ obj_t 
_pre_make_vector_app_owner4047_141_cfa_info(obj_t env_8821, obj_t obj_8822)
{
   {
      variable_t aux_12486;
      aux_12486 = pre_make_vector_app_owner_220_cfa_info((pre_make_vector_app_251_t) (obj_8822));
      return (obj_t) (aux_12486);
   }
}


/* allocate-procedure-set!-app */ app_t 
allocate_procedure_set__app_12_cfa_info()
{
   {
      app_t new2114_2569;
      new2114_2569 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2845_2570;
	 arg2845_2570 = class_num_218___object(procedure_set__app_32_cfa_info);
	 {
	    obj_t obj_5028;
	    obj_5028 = (obj_t) (new2114_2569);
	    (((obj_t) CREF(obj_5028))->header = MAKE_HEADER(arg2845_2570, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_12494;
	 aux_12494 = (object_t) (new2114_2569);
	 OBJECT_WIDENING_SET(aux_12494, BFALSE);
      }
      return new2114_2569;
   }
}


/* _allocate-procedure-set!-app */ obj_t 
_allocate_procedure_set__app_204_cfa_info(obj_t env_8056)
{
   {
      app_t aux_12497;
      aux_12497 = allocate_procedure_set__app_12_cfa_info();
      return (obj_t) (aux_12497);
   }
}


/* procedure-set!-app? */ bool_t 
procedure_set__app__65_cfa_info(obj_t obj_533)
{
   return is_a__118___object(obj_533, procedure_set__app_32_cfa_info);
}


/* _procedure-set!-app? */ obj_t 
_procedure_set__app__159_cfa_info(obj_t env_8823, obj_t obj_8824)
{
   {
      bool_t aux_12501;
      aux_12501 = procedure_set__app__65_cfa_info(obj_8824);
      return BBOOL(aux_12501);
   }
}


/* widening1036-procedure-set!-app */ procedure_set__app_32_t 
widening1036_procedure_set__app_234_cfa_info(approx_t approx_534)
{
   {
      procedure_set__app_32_t new2103_5030;
      new2103_5030 = ((procedure_set__app_32_t) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
      ((((procedure_set__app_32_t) CREF(new2103_5030))->approx) = ((approx_t) approx_534), BUNSPEC);
      return new2103_5030;
   }
}


/* _widening1036-procedure-set!-app4048 */ obj_t 
_widening1036_procedure_set__app4048_121_cfa_info(obj_t env_8825, obj_t approx_8826)
{
   {
      procedure_set__app_32_t aux_12506;
      aux_12506 = widening1036_procedure_set__app_234_cfa_info((approx_t) (approx_8826));
      return (obj_t) (aux_12506);
   }
}


/* make-procedure-set!-app */ procedure_set__app_32_t 
make_procedure_set__app_42_cfa_info(obj_t loc_535, type_t type_536, obj_t side_effect__165_537, obj_t key_538, var_t fun_539, obj_t args_540, obj_t stack_info_255_541, approx_t approx_542)
{
   {
      app_t aux2106_5032;
      {
	 app_t res3700_5054;
	 {
	    app_t new1289_5043;
	    new1289_5043 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_5044;
	       arg2999_5044 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_5052;
		  obj_5052 = (obj_t) (new1289_5043);
		  (((obj_t) CREF(obj_5052))->header = MAKE_HEADER(arg2999_5044, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_12514;
	       aux_12514 = (object_t) (new1289_5043);
	       OBJECT_WIDENING_SET(aux_12514, BFALSE);
	    }
	    ((((app_t) CREF(new1289_5043))->loc) = ((obj_t) loc_535), BUNSPEC);
	    ((((app_t) CREF(new1289_5043))->type) = ((type_t) type_536), BUNSPEC);
	    ((((app_t) CREF(new1289_5043))->side_effect__165) = ((obj_t) side_effect__165_537), BUNSPEC);
	    ((((app_t) CREF(new1289_5043))->key) = ((obj_t) key_538), BUNSPEC);
	    ((((app_t) CREF(new1289_5043))->fun) = ((var_t) fun_539), BUNSPEC);
	    ((((app_t) CREF(new1289_5043))->args) = ((obj_t) args_540), BUNSPEC);
	    ((((app_t) CREF(new1289_5043))->stack_info_255) = ((obj_t) stack_info_255_541), BUNSPEC);
	    res3700_5054 = new1289_5043;
	 }
	 aux2106_5032 = res3700_5054;
      }
      {
	 procedure_set__app_32_t new2107_5033;
	 new2107_5033 = ((procedure_set__app_32_t) (aux2106_5032));
	 {
	    long arg2846_5034;
	    arg2846_5034 = class_num_218___object(procedure_set__app_32_cfa_info);
	    {
	       obj_t obj_5055;
	       obj_5055 = (obj_t) (new2107_5033);
	       (((obj_t) CREF(obj_5055))->header = MAKE_HEADER(arg2846_5034, 0), BUNSPEC);
	    }
	 }
	 {
	    procedure_set__app_32_t arg2847_5035;
	    {
	       procedure_set__app_32_t res3701_5060;
	       {
		  procedure_set__app_32_t new2103_5058;
		  new2103_5058 = ((procedure_set__app_32_t) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
		  ((((procedure_set__app_32_t) CREF(new2103_5058))->approx) = ((approx_t) approx_542), BUNSPEC);
		  res3701_5060 = new2103_5058;
	       }
	       arg2847_5035 = res3701_5060;
	    }
	    {
	       obj_t aux_12532;
	       object_t aux_12530;
	       aux_12532 = (obj_t) (arg2847_5035);
	       aux_12530 = (object_t) (new2107_5033);
	       OBJECT_WIDENING_SET(aux_12530, aux_12532);
	    }
	 }
	 return new2107_5033;
      }
   }
}


/* _make-procedure-set!-app4049 */ obj_t 
_make_procedure_set__app4049_250_cfa_info(obj_t env_8827, obj_t loc_8828, obj_t type_8829, obj_t side_effect__165_8830, obj_t key_8831, obj_t fun_8832, obj_t args_8833, obj_t stack_info_255_8834, obj_t approx_8835)
{
   {
      procedure_set__app_32_t aux_12535;
      aux_12535 = make_procedure_set__app_42_cfa_info(loc_8828, (type_t) (type_8829), side_effect__165_8830, key_8831, (var_t) (fun_8832), args_8833, stack_info_255_8834, (approx_t) (approx_8835));
      return (obj_t) (aux_12535);
   }
}


/* procedure-set!-app-loc */ obj_t 
procedure_set__app_loc_37_cfa_info(app_t obj_543)
{
   return (((app_t) CREF(obj_543))->loc);
}


/* _procedure-set!-app-loc4050 */ obj_t 
_procedure_set__app_loc4050_91_cfa_info(obj_t env_8836, obj_t obj_8837)
{
   return procedure_set__app_loc_37_cfa_info((app_t) (obj_8837));
}


/* procedure-set!-app-type-set! */ obj_t 
procedure_set__app_type_set__29_cfa_info(app_t obj_544, type_t val2108_545)
{
   return ((((app_t) CREF(obj_544))->type) = ((type_t) val2108_545), BUNSPEC);
}


/* _procedure-set!-app-type-set!4051 */ obj_t 
_procedure_set__app_type_set_4051_224_cfa_info(obj_t env_8838, obj_t obj_8839, obj_t val2108_8840)
{
   return procedure_set__app_type_set__29_cfa_info((app_t) (obj_8839), (type_t) (val2108_8840));
}


/* procedure-set!-app-type */ type_t 
procedure_set__app_type_50_cfa_info(app_t obj_546)
{
   return (((app_t) CREF(obj_546))->type);
}


/* _procedure-set!-app-type4052 */ obj_t 
_procedure_set__app_type4052_159_cfa_info(obj_t env_8841, obj_t obj_8842)
{
   {
      type_t aux_12549;
      aux_12549 = procedure_set__app_type_50_cfa_info((app_t) (obj_8842));
      return (obj_t) (aux_12549);
   }
}


/* procedure-set!-app-side-effect?-set! */ obj_t 
procedure_set__app_side_effect__set__24_cfa_info(app_t obj_547, obj_t val2109_548)
{
   return ((((app_t) CREF(obj_547))->side_effect__165) = ((obj_t) val2109_548), BUNSPEC);
}


/* _procedure-set!-app-side-effect?-set!4053 */ obj_t 
_procedure_set__app_side_effect__set_4053_86_cfa_info(obj_t env_8843, obj_t obj_8844, obj_t val2109_8845)
{
   return procedure_set__app_side_effect__set__24_cfa_info((app_t) (obj_8844), val2109_8845);
}


/* procedure-set!-app-side-effect? */ obj_t 
procedure_set__app_side_effect__120_cfa_info(app_t obj_549)
{
   return (((app_t) CREF(obj_549))->side_effect__165);
}


/* _procedure-set!-app-side-effect?4054 */ obj_t 
_procedure_set__app_side_effect_4054_216_cfa_info(obj_t env_8846, obj_t obj_8847)
{
   return procedure_set__app_side_effect__120_cfa_info((app_t) (obj_8847));
}


/* procedure-set!-app-key-set! */ obj_t 
procedure_set__app_key_set__118_cfa_info(app_t obj_550, obj_t val2110_551)
{
   return ((((app_t) CREF(obj_550))->key) = ((obj_t) val2110_551), BUNSPEC);
}


/* _procedure-set!-app-key-set! */ obj_t 
_procedure_set__app_key_set__54_cfa_info(obj_t env_8848, obj_t obj_8849, obj_t val2110_8850)
{
   return procedure_set__app_key_set__118_cfa_info((app_t) (obj_8849), val2110_8850);
}


/* procedure-set!-app-key */ obj_t 
procedure_set__app_key_241_cfa_info(app_t obj_552)
{
   return (((app_t) CREF(obj_552))->key);
}


/* _procedure-set!-app-key */ obj_t 
_procedure_set__app_key_231_cfa_info(obj_t env_8851, obj_t obj_8852)
{
   return procedure_set__app_key_241_cfa_info((app_t) (obj_8852));
}


/* procedure-set!-app-fun-set! */ obj_t 
procedure_set__app_fun_set__159_cfa_info(app_t obj_553, var_t val2111_554)
{
   return ((((app_t) CREF(obj_553))->fun) = ((var_t) val2111_554), BUNSPEC);
}


/* _procedure-set!-app-fun-set!4055 */ obj_t 
_procedure_set__app_fun_set_4055_58_cfa_info(obj_t env_8853, obj_t obj_8854, obj_t val2111_8855)
{
   return procedure_set__app_fun_set__159_cfa_info((app_t) (obj_8854), (var_t) (val2111_8855));
}


/* procedure-set!-app-fun */ var_t 
procedure_set__app_fun_41_cfa_info(app_t obj_555)
{
   return (((app_t) CREF(obj_555))->fun);
}


/* _procedure-set!-app-fun4056 */ obj_t 
_procedure_set__app_fun4056_131_cfa_info(obj_t env_8856, obj_t obj_8857)
{
   {
      var_t aux_12570;
      aux_12570 = procedure_set__app_fun_41_cfa_info((app_t) (obj_8857));
      return (obj_t) (aux_12570);
   }
}


/* procedure-set!-app-args-set! */ obj_t 
procedure_set__app_args_set__164_cfa_info(app_t obj_556, obj_t val2112_557)
{
   return ((((app_t) CREF(obj_556))->args) = ((obj_t) val2112_557), BUNSPEC);
}


/* _procedure-set!-app-args-set!4057 */ obj_t 
_procedure_set__app_args_set_4057_128_cfa_info(obj_t env_8858, obj_t obj_8859, obj_t val2112_8860)
{
   return procedure_set__app_args_set__164_cfa_info((app_t) (obj_8859), val2112_8860);
}


/* procedure-set!-app-args */ obj_t 
procedure_set__app_args_80_cfa_info(app_t obj_558)
{
   return (((app_t) CREF(obj_558))->args);
}


/* _procedure-set!-app-args4058 */ obj_t 
_procedure_set__app_args4058_49_cfa_info(obj_t env_8861, obj_t obj_8862)
{
   return procedure_set__app_args_80_cfa_info((app_t) (obj_8862));
}


/* procedure-set!-app-stack-info-set! */ obj_t 
procedure_set__app_stack_info_set__250_cfa_info(app_t obj_559, obj_t val2113_560)
{
   return ((((app_t) CREF(obj_559))->stack_info_255) = ((obj_t) val2113_560), BUNSPEC);
}


/* _procedure-set!-app-stack-info-set!4059 */ obj_t 
_procedure_set__app_stack_info_set_4059_238_cfa_info(obj_t env_8863, obj_t obj_8864, obj_t val2113_8865)
{
   return procedure_set__app_stack_info_set__250_cfa_info((app_t) (obj_8864), val2113_8865);
}


/* procedure-set!-app-stack-info */ obj_t 
procedure_set__app_stack_info_212_cfa_info(app_t obj_561)
{
   return (((app_t) CREF(obj_561))->stack_info_255);
}


/* _procedure-set!-app-stack-info4060 */ obj_t 
_procedure_set__app_stack_info4060_125_cfa_info(obj_t env_8866, obj_t obj_8867)
{
   return procedure_set__app_stack_info_212_cfa_info((app_t) (obj_8867));
}


/* procedure-set!-app-approx */ approx_t 
procedure_set__app_approx_70_cfa_info(procedure_set__app_32_t obj_562)
{
   {
      obj_t aux_12586;
      {
	 object_t aux_12587;
	 aux_12587 = (object_t) (obj_562);
	 aux_12586 = OBJECT_WIDENING(aux_12587);
      }
      return (((procedure_set__app_32_t) CREF(aux_12586))->approx);
   }
}


/* _procedure-set!-app-approx4061 */ obj_t 
_procedure_set__app_approx4061_130_cfa_info(obj_t env_8868, obj_t obj_8869)
{
   {
      approx_t aux_12591;
      aux_12591 = procedure_set__app_approx_70_cfa_info((procedure_set__app_32_t) (obj_8869));
      return (obj_t) (aux_12591);
   }
}


/* allocate-procedure-ref-app */ app_t 
allocate_procedure_ref_app_165_cfa_info()
{
   {
      app_t new2096_2577;
      new2096_2577 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2848_2578;
	 arg2848_2578 = class_num_218___object(procedure_ref_app_49_cfa_info);
	 {
	    obj_t obj_5061;
	    obj_5061 = (obj_t) (new2096_2577);
	    (((obj_t) CREF(obj_5061))->header = MAKE_HEADER(arg2848_2578, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_12599;
	 aux_12599 = (object_t) (new2096_2577);
	 OBJECT_WIDENING_SET(aux_12599, BFALSE);
      }
      return new2096_2577;
   }
}


/* _allocate-procedure-ref-app */ obj_t 
_allocate_procedure_ref_app_56_cfa_info(obj_t env_8055)
{
   {
      app_t aux_12602;
      aux_12602 = allocate_procedure_ref_app_165_cfa_info();
      return (obj_t) (aux_12602);
   }
}


/* procedure-ref-app? */ bool_t 
procedure_ref_app__140_cfa_info(obj_t obj_566)
{
   return is_a__118___object(obj_566, procedure_ref_app_49_cfa_info);
}


/* _procedure-ref-app? */ obj_t 
_procedure_ref_app__14_cfa_info(obj_t env_8870, obj_t obj_8871)
{
   {
      bool_t aux_12606;
      aux_12606 = procedure_ref_app__140_cfa_info(obj_8871);
      return BBOOL(aux_12606);
   }
}


/* widening1035-procedure-ref-app */ procedure_ref_app_49_t 
widening1035_procedure_ref_app_150_cfa_info(approx_t approx_567)
{
   {
      procedure_ref_app_49_t new2085_5063;
      new2085_5063 = ((procedure_ref_app_49_t) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
      ((((procedure_ref_app_49_t) CREF(new2085_5063))->approx) = ((approx_t) approx_567), BUNSPEC);
      return new2085_5063;
   }
}


/* _widening1035-procedure-ref-app4062 */ obj_t 
_widening1035_procedure_ref_app4062_1_cfa_info(obj_t env_8872, obj_t approx_8873)
{
   {
      procedure_ref_app_49_t aux_12611;
      aux_12611 = widening1035_procedure_ref_app_150_cfa_info((approx_t) (approx_8873));
      return (obj_t) (aux_12611);
   }
}


/* make-procedure-ref-app */ procedure_ref_app_49_t 
make_procedure_ref_app_197_cfa_info(obj_t loc_568, type_t type_569, obj_t side_effect__165_570, obj_t key_571, var_t fun_572, obj_t args_573, obj_t stack_info_255_574, approx_t approx_575)
{
   {
      app_t aux2088_5065;
      {
	 app_t res3702_5087;
	 {
	    app_t new1289_5076;
	    new1289_5076 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_5077;
	       arg2999_5077 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_5085;
		  obj_5085 = (obj_t) (new1289_5076);
		  (((obj_t) CREF(obj_5085))->header = MAKE_HEADER(arg2999_5077, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_12619;
	       aux_12619 = (object_t) (new1289_5076);
	       OBJECT_WIDENING_SET(aux_12619, BFALSE);
	    }
	    ((((app_t) CREF(new1289_5076))->loc) = ((obj_t) loc_568), BUNSPEC);
	    ((((app_t) CREF(new1289_5076))->type) = ((type_t) type_569), BUNSPEC);
	    ((((app_t) CREF(new1289_5076))->side_effect__165) = ((obj_t) side_effect__165_570), BUNSPEC);
	    ((((app_t) CREF(new1289_5076))->key) = ((obj_t) key_571), BUNSPEC);
	    ((((app_t) CREF(new1289_5076))->fun) = ((var_t) fun_572), BUNSPEC);
	    ((((app_t) CREF(new1289_5076))->args) = ((obj_t) args_573), BUNSPEC);
	    ((((app_t) CREF(new1289_5076))->stack_info_255) = ((obj_t) stack_info_255_574), BUNSPEC);
	    res3702_5087 = new1289_5076;
	 }
	 aux2088_5065 = res3702_5087;
      }
      {
	 procedure_ref_app_49_t new2089_5066;
	 new2089_5066 = ((procedure_ref_app_49_t) (aux2088_5065));
	 {
	    long arg2849_5067;
	    arg2849_5067 = class_num_218___object(procedure_ref_app_49_cfa_info);
	    {
	       obj_t obj_5088;
	       obj_5088 = (obj_t) (new2089_5066);
	       (((obj_t) CREF(obj_5088))->header = MAKE_HEADER(arg2849_5067, 0), BUNSPEC);
	    }
	 }
	 {
	    procedure_ref_app_49_t arg2850_5068;
	    {
	       procedure_ref_app_49_t res3703_5093;
	       {
		  procedure_ref_app_49_t new2085_5091;
		  new2085_5091 = ((procedure_ref_app_49_t) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
		  ((((procedure_ref_app_49_t) CREF(new2085_5091))->approx) = ((approx_t) approx_575), BUNSPEC);
		  res3703_5093 = new2085_5091;
	       }
	       arg2850_5068 = res3703_5093;
	    }
	    {
	       obj_t aux_12637;
	       object_t aux_12635;
	       aux_12637 = (obj_t) (arg2850_5068);
	       aux_12635 = (object_t) (new2089_5066);
	       OBJECT_WIDENING_SET(aux_12635, aux_12637);
	    }
	 }
	 return new2089_5066;
      }
   }
}


/* _make-procedure-ref-app4063 */ obj_t 
_make_procedure_ref_app4063_52_cfa_info(obj_t env_8874, obj_t loc_8875, obj_t type_8876, obj_t side_effect__165_8877, obj_t key_8878, obj_t fun_8879, obj_t args_8880, obj_t stack_info_255_8881, obj_t approx_8882)
{
   {
      procedure_ref_app_49_t aux_12640;
      aux_12640 = make_procedure_ref_app_197_cfa_info(loc_8875, (type_t) (type_8876), side_effect__165_8877, key_8878, (var_t) (fun_8879), args_8880, stack_info_255_8881, (approx_t) (approx_8882));
      return (obj_t) (aux_12640);
   }
}


/* procedure-ref-app-loc */ obj_t 
procedure_ref_app_loc_250_cfa_info(app_t obj_576)
{
   return (((app_t) CREF(obj_576))->loc);
}


/* _procedure-ref-app-loc4064 */ obj_t 
_procedure_ref_app_loc4064_180_cfa_info(obj_t env_8883, obj_t obj_8884)
{
   return procedure_ref_app_loc_250_cfa_info((app_t) (obj_8884));
}


/* procedure-ref-app-type-set! */ obj_t 
procedure_ref_app_type_set__61_cfa_info(app_t obj_577, type_t val2090_578)
{
   return ((((app_t) CREF(obj_577))->type) = ((type_t) val2090_578), BUNSPEC);
}


/* _procedure-ref-app-type-set!4065 */ obj_t 
_procedure_ref_app_type_set_4065_213_cfa_info(obj_t env_8885, obj_t obj_8886, obj_t val2090_8887)
{
   return procedure_ref_app_type_set__61_cfa_info((app_t) (obj_8886), (type_t) (val2090_8887));
}


/* procedure-ref-app-type */ type_t 
procedure_ref_app_type_95_cfa_info(app_t obj_579)
{
   return (((app_t) CREF(obj_579))->type);
}


/* _procedure-ref-app-type4066 */ obj_t 
_procedure_ref_app_type4066_25_cfa_info(obj_t env_8888, obj_t obj_8889)
{
   {
      type_t aux_12654;
      aux_12654 = procedure_ref_app_type_95_cfa_info((app_t) (obj_8889));
      return (obj_t) (aux_12654);
   }
}


/* procedure-ref-app-side-effect?-set! */ obj_t 
procedure_ref_app_side_effect__set__126_cfa_info(app_t obj_580, obj_t val2091_581)
{
   return ((((app_t) CREF(obj_580))->side_effect__165) = ((obj_t) val2091_581), BUNSPEC);
}


/* _procedure-ref-app-side-effect?-set!4067 */ obj_t 
_procedure_ref_app_side_effect__set_4067_83_cfa_info(obj_t env_8890, obj_t obj_8891, obj_t val2091_8892)
{
   return procedure_ref_app_side_effect__set__126_cfa_info((app_t) (obj_8891), val2091_8892);
}


/* procedure-ref-app-side-effect? */ obj_t 
procedure_ref_app_side_effect__178_cfa_info(app_t obj_582)
{
   return (((app_t) CREF(obj_582))->side_effect__165);
}


/* _procedure-ref-app-side-effect?4068 */ obj_t 
_procedure_ref_app_side_effect_4068_53_cfa_info(obj_t env_8893, obj_t obj_8894)
{
   return procedure_ref_app_side_effect__178_cfa_info((app_t) (obj_8894));
}


/* procedure-ref-app-key-set! */ obj_t 
procedure_ref_app_key_set__89_cfa_info(app_t obj_583, obj_t val2092_584)
{
   return ((((app_t) CREF(obj_583))->key) = ((obj_t) val2092_584), BUNSPEC);
}


/* _procedure-ref-app-key-set! */ obj_t 
_procedure_ref_app_key_set__179_cfa_info(obj_t env_8895, obj_t obj_8896, obj_t val2092_8897)
{
   return procedure_ref_app_key_set__89_cfa_info((app_t) (obj_8896), val2092_8897);
}


/* procedure-ref-app-key */ obj_t 
procedure_ref_app_key_147_cfa_info(app_t obj_585)
{
   return (((app_t) CREF(obj_585))->key);
}


/* _procedure-ref-app-key */ obj_t 
_procedure_ref_app_key_2_cfa_info(obj_t env_8898, obj_t obj_8899)
{
   return procedure_ref_app_key_147_cfa_info((app_t) (obj_8899));
}


/* procedure-ref-app-fun-set! */ obj_t 
procedure_ref_app_fun_set__2_cfa_info(app_t obj_586, var_t val2093_587)
{
   return ((((app_t) CREF(obj_586))->fun) = ((var_t) val2093_587), BUNSPEC);
}


/* _procedure-ref-app-fun-set!4069 */ obj_t 
_procedure_ref_app_fun_set_4069_83_cfa_info(obj_t env_8900, obj_t obj_8901, obj_t val2093_8902)
{
   return procedure_ref_app_fun_set__2_cfa_info((app_t) (obj_8901), (var_t) (val2093_8902));
}


/* procedure-ref-app-fun */ var_t 
procedure_ref_app_fun_180_cfa_info(app_t obj_588)
{
   return (((app_t) CREF(obj_588))->fun);
}


/* _procedure-ref-app-fun4070 */ obj_t 
_procedure_ref_app_fun4070_3_cfa_info(obj_t env_8903, obj_t obj_8904)
{
   {
      var_t aux_12675;
      aux_12675 = procedure_ref_app_fun_180_cfa_info((app_t) (obj_8904));
      return (obj_t) (aux_12675);
   }
}


/* procedure-ref-app-args-set! */ obj_t 
procedure_ref_app_args_set__11_cfa_info(app_t obj_589, obj_t val2094_590)
{
   return ((((app_t) CREF(obj_589))->args) = ((obj_t) val2094_590), BUNSPEC);
}


/* _procedure-ref-app-args-set!4071 */ obj_t 
_procedure_ref_app_args_set_4071_177_cfa_info(obj_t env_8905, obj_t obj_8906, obj_t val2094_8907)
{
   return procedure_ref_app_args_set__11_cfa_info((app_t) (obj_8906), val2094_8907);
}


/* procedure-ref-app-args */ obj_t 
procedure_ref_app_args_118_cfa_info(app_t obj_591)
{
   return (((app_t) CREF(obj_591))->args);
}


/* _procedure-ref-app-args4072 */ obj_t 
_procedure_ref_app_args4072_140_cfa_info(obj_t env_8908, obj_t obj_8909)
{
   return procedure_ref_app_args_118_cfa_info((app_t) (obj_8909));
}


/* procedure-ref-app-stack-info-set! */ obj_t 
procedure_ref_app_stack_info_set__100_cfa_info(app_t obj_592, obj_t val2095_593)
{
   return ((((app_t) CREF(obj_592))->stack_info_255) = ((obj_t) val2095_593), BUNSPEC);
}


/* _procedure-ref-app-stack-info-set!4073 */ obj_t 
_procedure_ref_app_stack_info_set_4073_25_cfa_info(obj_t env_8910, obj_t obj_8911, obj_t val2095_8912)
{
   return procedure_ref_app_stack_info_set__100_cfa_info((app_t) (obj_8911), val2095_8912);
}


/* procedure-ref-app-stack-info */ obj_t 
procedure_ref_app_stack_info_176_cfa_info(app_t obj_594)
{
   return (((app_t) CREF(obj_594))->stack_info_255);
}


/* _procedure-ref-app-stack-info4074 */ obj_t 
_procedure_ref_app_stack_info4074_171_cfa_info(obj_t env_8913, obj_t obj_8914)
{
   return procedure_ref_app_stack_info_176_cfa_info((app_t) (obj_8914));
}


/* procedure-ref-app-approx */ approx_t 
procedure_ref_app_approx_118_cfa_info(procedure_ref_app_49_t obj_595)
{
   {
      obj_t aux_12691;
      {
	 object_t aux_12692;
	 aux_12692 = (object_t) (obj_595);
	 aux_12691 = OBJECT_WIDENING(aux_12692);
      }
      return (((procedure_ref_app_49_t) CREF(aux_12691))->approx);
   }
}


/* _procedure-ref-app-approx4075 */ obj_t 
_procedure_ref_app_approx4075_236_cfa_info(obj_t env_8915, obj_t obj_8916)
{
   {
      approx_t aux_12696;
      aux_12696 = procedure_ref_app_approx_118_cfa_info((procedure_ref_app_49_t) (obj_8916));
      return (obj_t) (aux_12696);
   }
}


/* allocate-make-procedure-app */ app_t 
allocate_make_procedure_app_115_cfa_info()
{
   {
      app_t new2074_2585;
      new2074_2585 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2851_2586;
	 arg2851_2586 = class_num_218___object(make_procedure_app_48_cfa_info);
	 {
	    obj_t obj_5094;
	    obj_5094 = (obj_t) (new2074_2585);
	    (((obj_t) CREF(obj_5094))->header = MAKE_HEADER(arg2851_2586, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_12704;
	 aux_12704 = (object_t) (new2074_2585);
	 OBJECT_WIDENING_SET(aux_12704, BFALSE);
      }
      return new2074_2585;
   }
}


/* _allocate-make-procedure-app */ obj_t 
_allocate_make_procedure_app_241_cfa_info(obj_t env_8054)
{
   {
      app_t aux_12707;
      aux_12707 = allocate_make_procedure_app_115_cfa_info();
      return (obj_t) (aux_12707);
   }
}


/* make-procedure-app? */ bool_t 
make_procedure_app__51_cfa_info(obj_t obj_599)
{
   return is_a__118___object(obj_599, make_procedure_app_48_cfa_info);
}


/* _make-procedure-app? */ obj_t 
_make_procedure_app__219_cfa_info(obj_t env_8917, obj_t obj_8918)
{
   {
      bool_t aux_12711;
      aux_12711 = make_procedure_app__51_cfa_info(obj_8918);
      return BBOOL(aux_12711);
   }
}


/* widening1034-make-procedure-app */ make_procedure_app_48_t 
widening1034_make_procedure_app_105_cfa_info(approx_t approx_600, long values_approx_len_106_601, approx_t values_approx_79_602, long lost_stamp_114_603, bool_t x_t__142_604, bool_t x_605, bool_t t_606, variable_t owner_607, bool_t stackable__42_608, obj_t stack_stamp_31_609)
{
   {
      make_procedure_app_48_t new2046_5096;
      new2046_5096 = ((make_procedure_app_48_t) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
      ((((make_procedure_app_48_t) CREF(new2046_5096))->approx) = ((approx_t) approx_600), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->values_approx_len_106) = ((long) values_approx_len_106_601), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->values_approx_79) = ((approx_t *) GC_MALLOC(sizeof(struct approx) * values_approx_len_106_601)), BUNSPEC);
      {
	 long i2047_5108;
	 i2047_5108 = ((long) 0);
       loop2050_5107:
	 if ((i2047_5108 == values_approx_len_106_601))
	   {
	      CNST_TABLE_REF(((long) 50));
	   }
	 else
	   {
	      ((((make_procedure_app_48_t) CREF(new2046_5096))->values_approx_79)[i2047_5108] = ((approx_t) values_approx_79_602), BUNSPEC);
	      {
		 long i2047_12723;
		 i2047_12723 = (i2047_5108 + ((long) 1));
		 i2047_5108 = i2047_12723;
		 goto loop2050_5107;
	      }
	   }
      }
      ((((make_procedure_app_48_t) CREF(new2046_5096))->lost_stamp_114) = ((long) lost_stamp_114_603), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->x_t__142) = ((bool_t) x_t__142_604), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->x) = ((bool_t) x_605), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->t) = ((bool_t) t_606), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->owner) = ((variable_t) owner_607), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->stackable__42) = ((bool_t) stackable__42_608), BUNSPEC);
      ((((make_procedure_app_48_t) CREF(new2046_5096))->stack_stamp_31) = ((obj_t) stack_stamp_31_609), BUNSPEC);
      return new2046_5096;
   }
}


/* _widening1034-make-procedure-app4076 */ obj_t 
_widening1034_make_procedure_app4076_93_cfa_info(obj_t env_8919, obj_t approx_8920, obj_t values_approx_len_106_8921, obj_t values_approx_79_8922, obj_t lost_stamp_114_8923, obj_t x_t__142_8924, obj_t x_8925, obj_t t_8926, obj_t owner_8927, obj_t stackable__42_8928, obj_t stack_stamp_31_8929)
{
   {
      make_procedure_app_48_t aux_12732;
      aux_12732 = widening1034_make_procedure_app_105_cfa_info((approx_t) (approx_8920), (long) CINT(values_approx_len_106_8921), (approx_t) (values_approx_79_8922), (long) CINT(lost_stamp_114_8923), CBOOL(x_t__142_8924), CBOOL(x_8925), CBOOL(t_8926), (variable_t) (owner_8927), CBOOL(stackable__42_8928), stack_stamp_31_8929);
      return (obj_t) (aux_12732);
   }
}


/* make-make-procedure-app */ make_procedure_app_48_t 
make_make_procedure_app_99_cfa_info(obj_t loc_610, type_t type_611, obj_t side_effect__165_612, obj_t key_613, var_t fun_614, obj_t args_615, obj_t stack_info_255_616, approx_t approx_617, long values_approx_len_106_618, approx_t values_approx_79_619, long lost_stamp_114_620, bool_t x_t__142_621, bool_t x_622, bool_t t_623, variable_t owner_624, bool_t stackable__42_625, obj_t stack_stamp_31_626)
{
   {
      app_t aux2058_5115;
      {
	 app_t res3704_5137;
	 {
	    app_t new1289_5126;
	    new1289_5126 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_5127;
	       arg2999_5127 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_5135;
		  obj_5135 = (obj_t) (new1289_5126);
		  (((obj_t) CREF(obj_5135))->header = MAKE_HEADER(arg2999_5127, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_12748;
	       aux_12748 = (object_t) (new1289_5126);
	       OBJECT_WIDENING_SET(aux_12748, BFALSE);
	    }
	    ((((app_t) CREF(new1289_5126))->loc) = ((obj_t) loc_610), BUNSPEC);
	    ((((app_t) CREF(new1289_5126))->type) = ((type_t) type_611), BUNSPEC);
	    ((((app_t) CREF(new1289_5126))->side_effect__165) = ((obj_t) side_effect__165_612), BUNSPEC);
	    ((((app_t) CREF(new1289_5126))->key) = ((obj_t) key_613), BUNSPEC);
	    ((((app_t) CREF(new1289_5126))->fun) = ((var_t) fun_614), BUNSPEC);
	    ((((app_t) CREF(new1289_5126))->args) = ((obj_t) args_615), BUNSPEC);
	    ((((app_t) CREF(new1289_5126))->stack_info_255) = ((obj_t) stack_info_255_616), BUNSPEC);
	    res3704_5137 = new1289_5126;
	 }
	 aux2058_5115 = res3704_5137;
      }
      {
	 make_procedure_app_48_t new2059_5116;
	 new2059_5116 = ((make_procedure_app_48_t) (aux2058_5115));
	 {
	    long arg2854_5117;
	    arg2854_5117 = class_num_218___object(make_procedure_app_48_cfa_info);
	    {
	       obj_t obj_5138;
	       obj_5138 = (obj_t) (new2059_5116);
	       (((obj_t) CREF(obj_5138))->header = MAKE_HEADER(arg2854_5117, 0), BUNSPEC);
	    }
	 }
	 {
	    make_procedure_app_48_t arg2855_5118;
	    {
	       make_procedure_app_48_t res3705_5169;
	       {
		  make_procedure_app_48_t new2046_5150;
		  new2046_5150 = ((make_procedure_app_48_t) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->approx) = ((approx_t) approx_617), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->values_approx_len_106) = ((long) values_approx_len_106_618), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->values_approx_79) = ((approx_t *) GC_MALLOC(sizeof(struct approx) * values_approx_len_106_618)), BUNSPEC);
		  {
		     long i2047_5162;
		     i2047_5162 = ((long) 0);
		   loop2050_5161:
		     if ((i2047_5162 == values_approx_len_106_618))
		       {
			  CNST_TABLE_REF(((long) 50));
		       }
		     else
		       {
			  ((((make_procedure_app_48_t) CREF(new2046_5150))->values_approx_79)[i2047_5162] = ((approx_t) values_approx_79_619), BUNSPEC);
			  {
			     long i2047_12771;
			     i2047_12771 = (i2047_5162 + ((long) 1));
			     i2047_5162 = i2047_12771;
			     goto loop2050_5161;
			  }
		       }
		  }
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->lost_stamp_114) = ((long) lost_stamp_114_620), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->x_t__142) = ((bool_t) x_t__142_621), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->x) = ((bool_t) x_622), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->t) = ((bool_t) t_623), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->owner) = ((variable_t) owner_624), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->stackable__42) = ((bool_t) stackable__42_625), BUNSPEC);
		  ((((make_procedure_app_48_t) CREF(new2046_5150))->stack_stamp_31) = ((obj_t) stack_stamp_31_626), BUNSPEC);
		  res3705_5169 = new2046_5150;
	       }
	       arg2855_5118 = res3705_5169;
	    }
	    {
	       obj_t aux_12782;
	       object_t aux_12780;
	       aux_12782 = (obj_t) (arg2855_5118);
	       aux_12780 = (object_t) (new2059_5116);
	       OBJECT_WIDENING_SET(aux_12780, aux_12782);
	    }
	 }
	 return new2059_5116;
      }
   }
}


/* _make-make-procedure-app4077 */ obj_t 
_make_make_procedure_app4077_0_cfa_info(obj_t env_8930, obj_t loc_8931, obj_t type_8932, obj_t side_effect__165_8933, obj_t key_8934, obj_t fun_8935, obj_t args_8936, obj_t stack_info_255_8937, obj_t approx_8938, obj_t values_approx_len_106_8939, obj_t values_approx_79_8940, obj_t lost_stamp_114_8941, obj_t x_t__142_8942, obj_t x_8943, obj_t t_8944, obj_t owner_8945, obj_t stackable__42_8946, obj_t stack_stamp_31_8947)
{
   {
      make_procedure_app_48_t aux_12785;
      aux_12785 = make_make_procedure_app_99_cfa_info(loc_8931, (type_t) (type_8932), side_effect__165_8933, key_8934, (var_t) (fun_8935), args_8936, stack_info_255_8937, (approx_t) (approx_8938), (long) CINT(values_approx_len_106_8939), (approx_t) (values_approx_79_8940), (long) CINT(lost_stamp_114_8941), CBOOL(x_t__142_8942), CBOOL(x_8943), CBOOL(t_8944), (variable_t) (owner_8945), CBOOL(stackable__42_8946), stack_stamp_31_8947);
      return (obj_t) (aux_12785);
   }
}


/* make-procedure-app-loc */ obj_t 
make_procedure_app_loc_185_cfa_info(app_t obj_627)
{
   return (((app_t) CREF(obj_627))->loc);
}


/* _make-procedure-app-loc4078 */ obj_t 
_make_procedure_app_loc4078_29_cfa_info(obj_t env_8948, obj_t obj_8949)
{
   return make_procedure_app_loc_185_cfa_info((app_t) (obj_8949));
}


/* make-procedure-app-type-set! */ obj_t 
make_procedure_app_type_set__163_cfa_info(app_t obj_628, type_t val2060_629)
{
   return ((((app_t) CREF(obj_628))->type) = ((type_t) val2060_629), BUNSPEC);
}


/* _make-procedure-app-type-set!4079 */ obj_t 
_make_procedure_app_type_set_4079_172_cfa_info(obj_t env_8950, obj_t obj_8951, obj_t val2060_8952)
{
   return make_procedure_app_type_set__163_cfa_info((app_t) (obj_8951), (type_t) (val2060_8952));
}


/* make-procedure-app-type */ type_t 
make_procedure_app_type_193_cfa_info(app_t obj_630)
{
   return (((app_t) CREF(obj_630))->type);
}


/* _make-procedure-app-type4080 */ obj_t 
_make_procedure_app_type4080_241_cfa_info(obj_t env_8953, obj_t obj_8954)
{
   {
      type_t aux_12807;
      aux_12807 = make_procedure_app_type_193_cfa_info((app_t) (obj_8954));
      return (obj_t) (aux_12807);
   }
}


/* make-procedure-app-side-effect?-set! */ obj_t 
make_procedure_app_side_effect__set__181_cfa_info(app_t obj_631, obj_t val2061_632)
{
   return ((((app_t) CREF(obj_631))->side_effect__165) = ((obj_t) val2061_632), BUNSPEC);
}


/* _make-procedure-app-side-effect?-set!4081 */ obj_t 
_make_procedure_app_side_effect__set_4081_159_cfa_info(obj_t env_8955, obj_t obj_8956, obj_t val2061_8957)
{
   return make_procedure_app_side_effect__set__181_cfa_info((app_t) (obj_8956), val2061_8957);
}


/* make-procedure-app-side-effect? */ obj_t 
make_procedure_app_side_effect__185_cfa_info(app_t obj_633)
{
   return (((app_t) CREF(obj_633))->side_effect__165);
}


/* _make-procedure-app-side-effect?4082 */ obj_t 
_make_procedure_app_side_effect_4082_191_cfa_info(obj_t env_8958, obj_t obj_8959)
{
   return make_procedure_app_side_effect__185_cfa_info((app_t) (obj_8959));
}


/* make-procedure-app-key-set! */ obj_t 
make_procedure_app_key_set__38_cfa_info(app_t obj_634, obj_t val2062_635)
{
   return ((((app_t) CREF(obj_634))->key) = ((obj_t) val2062_635), BUNSPEC);
}


/* _make-procedure-app-key-set! */ obj_t 
_make_procedure_app_key_set__144_cfa_info(obj_t env_8960, obj_t obj_8961, obj_t val2062_8962)
{
   return make_procedure_app_key_set__38_cfa_info((app_t) (obj_8961), val2062_8962);
}


/* make-procedure-app-key */ obj_t 
make_procedure_app_key_144_cfa_info(app_t obj_636)
{
   return (((app_t) CREF(obj_636))->key);
}


/* _make-procedure-app-key4083 */ obj_t 
_make_procedure_app_key4083_226_cfa_info(obj_t env_8963, obj_t obj_8964)
{
   return make_procedure_app_key_144_cfa_info((app_t) (obj_8964));
}


/* make-procedure-app-fun-set! */ obj_t 
make_procedure_app_fun_set__162_cfa_info(app_t obj_637, var_t val2063_638)
{
   return ((((app_t) CREF(obj_637))->fun) = ((var_t) val2063_638), BUNSPEC);
}


/* _make-procedure-app-fun-set!4084 */ obj_t 
_make_procedure_app_fun_set_4084_224_cfa_info(obj_t env_8965, obj_t obj_8966, obj_t val2063_8967)
{
   return make_procedure_app_fun_set__162_cfa_info((app_t) (obj_8966), (var_t) (val2063_8967));
}


/* make-procedure-app-fun */ var_t 
make_procedure_app_fun_101_cfa_info(app_t obj_639)
{
   return (((app_t) CREF(obj_639))->fun);
}


/* _make-procedure-app-fun4085 */ obj_t 
_make_procedure_app_fun4085_52_cfa_info(obj_t env_8968, obj_t obj_8969)
{
   {
      var_t aux_12828;
      aux_12828 = make_procedure_app_fun_101_cfa_info((app_t) (obj_8969));
      return (obj_t) (aux_12828);
   }
}


/* make-procedure-app-args-set! */ obj_t 
make_procedure_app_args_set__42_cfa_info(app_t obj_640, obj_t val2064_641)
{
   return ((((app_t) CREF(obj_640))->args) = ((obj_t) val2064_641), BUNSPEC);
}


/* _make-procedure-app-args-set!4086 */ obj_t 
_make_procedure_app_args_set_4086_97_cfa_info(obj_t env_8970, obj_t obj_8971, obj_t val2064_8972)
{
   return make_procedure_app_args_set__42_cfa_info((app_t) (obj_8971), val2064_8972);
}


/* make-procedure-app-args */ obj_t 
make_procedure_app_args_93_cfa_info(app_t obj_642)
{
   return (((app_t) CREF(obj_642))->args);
}


/* _make-procedure-app-args4087 */ obj_t 
_make_procedure_app_args4087_72_cfa_info(obj_t env_8973, obj_t obj_8974)
{
   return make_procedure_app_args_93_cfa_info((app_t) (obj_8974));
}


/* make-procedure-app-stack-info-set! */ obj_t 
make_procedure_app_stack_info_set__230_cfa_info(app_t obj_643, obj_t val2065_644)
{
   return ((((app_t) CREF(obj_643))->stack_info_255) = ((obj_t) val2065_644), BUNSPEC);
}


/* _make-procedure-app-stack-info-set!4088 */ obj_t 
_make_procedure_app_stack_info_set_4088_255_cfa_info(obj_t env_8975, obj_t obj_8976, obj_t val2065_8977)
{
   return make_procedure_app_stack_info_set__230_cfa_info((app_t) (obj_8976), val2065_8977);
}


/* make-procedure-app-stack-info */ obj_t 
make_procedure_app_stack_info_60_cfa_info(app_t obj_645)
{
   return (((app_t) CREF(obj_645))->stack_info_255);
}


/* _make-procedure-app-stack-info4089 */ obj_t 
_make_procedure_app_stack_info4089_35_cfa_info(obj_t env_8978, obj_t obj_8979)
{
   return make_procedure_app_stack_info_60_cfa_info((app_t) (obj_8979));
}


/* make-procedure-app-approx-set! */ obj_t 
make_procedure_app_approx_set__127_cfa_info(make_procedure_app_48_t obj_646, approx_t val2066_647)
{
   {
      obj_t aux_12844;
      {
	 object_t aux_12845;
	 aux_12845 = (object_t) (obj_646);
	 aux_12844 = OBJECT_WIDENING(aux_12845);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12844))->approx) = ((approx_t) val2066_647), BUNSPEC);
   }
}


/* _make-procedure-app-approx-set!4090 */ obj_t 
_make_procedure_app_approx_set_4090_181_cfa_info(obj_t env_8980, obj_t obj_8981, obj_t val2066_8982)
{
   return make_procedure_app_approx_set__127_cfa_info((make_procedure_app_48_t) (obj_8981), (approx_t) (val2066_8982));
}


/* make-procedure-app-approx */ approx_t 
make_procedure_app_approx_226_cfa_info(make_procedure_app_48_t obj_648)
{
   {
      obj_t aux_12852;
      {
	 object_t aux_12853;
	 aux_12853 = (object_t) (obj_648);
	 aux_12852 = OBJECT_WIDENING(aux_12853);
      }
      return (((make_procedure_app_48_t) CREF(aux_12852))->approx);
   }
}


/* _make-procedure-app-approx4091 */ obj_t 
_make_procedure_app_approx4091_52_cfa_info(obj_t env_8983, obj_t obj_8984)
{
   {
      approx_t aux_12857;
      aux_12857 = make_procedure_app_approx_226_cfa_info((make_procedure_app_48_t) (obj_8984));
      return (obj_t) (aux_12857);
   }
}


/* make-procedure-app-values-approx-len */ long 
make_procedure_app_values_approx_len_202_cfa_info(make_procedure_app_48_t obj_649)
{
   {
      obj_t aux_12861;
      {
	 object_t aux_12862;
	 aux_12862 = (object_t) (obj_649);
	 aux_12861 = OBJECT_WIDENING(aux_12862);
      }
      return (((make_procedure_app_48_t) CREF(aux_12861))->values_approx_len_106);
   }
}


/* _make-procedure-app-values-approx-len4092 */ obj_t 
_make_procedure_app_values_approx_len4092_35_cfa_info(obj_t env_8985, obj_t obj_8986)
{
   {
      long aux_12866;
      aux_12866 = make_procedure_app_values_approx_len_202_cfa_info((make_procedure_app_48_t) (obj_8986));
      return BINT(aux_12866);
   }
}


/* make-procedure-app-values-approx-set! */ obj_t 
make_procedure_app_values_approx_set__111_cfa_info(make_procedure_app_48_t obj_650, long index_651, approx_t val2067_652)
{
   {
      obj_t aux_12870;
      {
	 object_t aux_12871;
	 aux_12871 = (object_t) (obj_650);
	 aux_12870 = OBJECT_WIDENING(aux_12871);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12870))->values_approx_79)[index_651] = ((approx_t) val2067_652), BUNSPEC);
   }
}


/* _make-procedure-app-values-approx-set!4093 */ obj_t 
_make_procedure_app_values_approx_set_4093_149_cfa_info(obj_t env_8987, obj_t obj_8988, obj_t index_8989, obj_t val2067_8990)
{
   return make_procedure_app_values_approx_set__111_cfa_info((make_procedure_app_48_t) (obj_8988), (long) CINT(index_8989), (approx_t) (val2067_8990));
}


/* make-procedure-app-values-approx-ref */ approx_t 
make_procedure_app_values_approx_ref_67_cfa_info(make_procedure_app_48_t obj_653, long index_654)
{
   {
      obj_t aux_12879;
      {
	 object_t aux_12880;
	 aux_12880 = (object_t) (obj_653);
	 aux_12879 = OBJECT_WIDENING(aux_12880);
      }
      return (((make_procedure_app_48_t) CREF(aux_12879))->values_approx_79)[index_654];
   }
}


/* _make-procedure-app-values-approx-ref4094 */ obj_t 
_make_procedure_app_values_approx_ref4094_120_cfa_info(obj_t env_8991, obj_t obj_8992, obj_t index_8993)
{
   {
      approx_t aux_12884;
      aux_12884 = make_procedure_app_values_approx_ref_67_cfa_info((make_procedure_app_48_t) (obj_8992), (long) CINT(index_8993));
      return (obj_t) (aux_12884);
   }
}


/* make-procedure-app-lost-stamp-set! */ obj_t 
make_procedure_app_lost_stamp_set__66_cfa_info(make_procedure_app_48_t obj_655, long val2068_656)
{
   {
      obj_t aux_12889;
      {
	 object_t aux_12890;
	 aux_12890 = (object_t) (obj_655);
	 aux_12889 = OBJECT_WIDENING(aux_12890);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12889))->lost_stamp_114) = ((long) val2068_656), BUNSPEC);
   }
}


/* _make-procedure-app-lost-stamp-set!4095 */ obj_t 
_make_procedure_app_lost_stamp_set_4095_153_cfa_info(obj_t env_8994, obj_t obj_8995, obj_t val2068_8996)
{
   return make_procedure_app_lost_stamp_set__66_cfa_info((make_procedure_app_48_t) (obj_8995), (long) CINT(val2068_8996));
}


/* make-procedure-app-lost-stamp */ long 
make_procedure_app_lost_stamp_58_cfa_info(make_procedure_app_48_t obj_657)
{
   {
      obj_t aux_12897;
      {
	 object_t aux_12898;
	 aux_12898 = (object_t) (obj_657);
	 aux_12897 = OBJECT_WIDENING(aux_12898);
      }
      return (((make_procedure_app_48_t) CREF(aux_12897))->lost_stamp_114);
   }
}


/* _make-procedure-app-lost-stamp4096 */ obj_t 
_make_procedure_app_lost_stamp4096_31_cfa_info(obj_t env_8997, obj_t obj_8998)
{
   {
      long aux_12902;
      aux_12902 = make_procedure_app_lost_stamp_58_cfa_info((make_procedure_app_48_t) (obj_8998));
      return BINT(aux_12902);
   }
}


/* make-procedure-app-x-t?-set! */ obj_t 
make_procedure_app_x_t__set__53_cfa_info(make_procedure_app_48_t obj_658, bool_t val2069_659)
{
   {
      obj_t aux_12906;
      {
	 object_t aux_12907;
	 aux_12907 = (object_t) (obj_658);
	 aux_12906 = OBJECT_WIDENING(aux_12907);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12906))->x_t__142) = ((bool_t) val2069_659), BUNSPEC);
   }
}


/* _make-procedure-app-x-t?-set!4097 */ obj_t 
_make_procedure_app_x_t__set_4097_188_cfa_info(obj_t env_8999, obj_t obj_9000, obj_t val2069_9001)
{
   return make_procedure_app_x_t__set__53_cfa_info((make_procedure_app_48_t) (obj_9000), CBOOL(val2069_9001));
}


/* make-procedure-app-x-t? */ bool_t 
make_procedure_app_x_t__146_cfa_info(make_procedure_app_48_t obj_660)
{
   {
      obj_t aux_12914;
      {
	 object_t aux_12915;
	 aux_12915 = (object_t) (obj_660);
	 aux_12914 = OBJECT_WIDENING(aux_12915);
      }
      return (((make_procedure_app_48_t) CREF(aux_12914))->x_t__142);
   }
}


/* _make-procedure-app-x-t?4098 */ obj_t 
_make_procedure_app_x_t_4098_104_cfa_info(obj_t env_9002, obj_t obj_9003)
{
   {
      bool_t aux_12919;
      aux_12919 = make_procedure_app_x_t__146_cfa_info((make_procedure_app_48_t) (obj_9003));
      return BBOOL(aux_12919);
   }
}


/* make-procedure-app-x-set! */ obj_t 
make_procedure_app_x_set__126_cfa_info(make_procedure_app_48_t obj_661, bool_t val2070_662)
{
   {
      obj_t aux_12923;
      {
	 object_t aux_12924;
	 aux_12924 = (object_t) (obj_661);
	 aux_12923 = OBJECT_WIDENING(aux_12924);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12923))->x) = ((bool_t) val2070_662), BUNSPEC);
   }
}


/* _make-procedure-app-x-set!4099 */ obj_t 
_make_procedure_app_x_set_4099_130_cfa_info(obj_t env_9004, obj_t obj_9005, obj_t val2070_9006)
{
   return make_procedure_app_x_set__126_cfa_info((make_procedure_app_48_t) (obj_9005), CBOOL(val2070_9006));
}


/* make-procedure-app-x */ bool_t 
make_procedure_app_x_178_cfa_info(make_procedure_app_48_t obj_663)
{
   {
      obj_t aux_12931;
      {
	 object_t aux_12932;
	 aux_12932 = (object_t) (obj_663);
	 aux_12931 = OBJECT_WIDENING(aux_12932);
      }
      return (((make_procedure_app_48_t) CREF(aux_12931))->x);
   }
}


/* _make-procedure-app-x4100 */ obj_t 
_make_procedure_app_x4100_182_cfa_info(obj_t env_9007, obj_t obj_9008)
{
   {
      bool_t aux_12936;
      aux_12936 = make_procedure_app_x_178_cfa_info((make_procedure_app_48_t) (obj_9008));
      return BBOOL(aux_12936);
   }
}


/* make-procedure-app-t-set! */ obj_t 
make_procedure_app_t_set__133_cfa_info(make_procedure_app_48_t obj_664, bool_t val2071_665)
{
   {
      obj_t aux_12940;
      {
	 object_t aux_12941;
	 aux_12941 = (object_t) (obj_664);
	 aux_12940 = OBJECT_WIDENING(aux_12941);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12940))->t) = ((bool_t) val2071_665), BUNSPEC);
   }
}


/* _make-procedure-app-t-set!4101 */ obj_t 
_make_procedure_app_t_set_4101_189_cfa_info(obj_t env_9009, obj_t obj_9010, obj_t val2071_9011)
{
   return make_procedure_app_t_set__133_cfa_info((make_procedure_app_48_t) (obj_9010), CBOOL(val2071_9011));
}


/* make-procedure-app-t */ bool_t 
make_procedure_app_t_252_cfa_info(make_procedure_app_48_t obj_666)
{
   {
      obj_t aux_12948;
      {
	 object_t aux_12949;
	 aux_12949 = (object_t) (obj_666);
	 aux_12948 = OBJECT_WIDENING(aux_12949);
      }
      return (((make_procedure_app_48_t) CREF(aux_12948))->t);
   }
}


/* _make-procedure-app-t4102 */ obj_t 
_make_procedure_app_t4102_213_cfa_info(obj_t env_9012, obj_t obj_9013)
{
   {
      bool_t aux_12953;
      aux_12953 = make_procedure_app_t_252_cfa_info((make_procedure_app_48_t) (obj_9013));
      return BBOOL(aux_12953);
   }
}


/* make-procedure-app-owner */ variable_t 
make_procedure_app_owner_38_cfa_info(make_procedure_app_48_t obj_667)
{
   {
      obj_t aux_12957;
      {
	 object_t aux_12958;
	 aux_12958 = (object_t) (obj_667);
	 aux_12957 = OBJECT_WIDENING(aux_12958);
      }
      return (((make_procedure_app_48_t) CREF(aux_12957))->owner);
   }
}


/* _make-procedure-app-owner4103 */ obj_t 
_make_procedure_app_owner4103_232_cfa_info(obj_t env_9014, obj_t obj_9015)
{
   {
      variable_t aux_12962;
      aux_12962 = make_procedure_app_owner_38_cfa_info((make_procedure_app_48_t) (obj_9015));
      return (obj_t) (aux_12962);
   }
}


/* make-procedure-app-stackable?-set! */ obj_t 
make_procedure_app_stackable__set__58_cfa_info(make_procedure_app_48_t obj_668, bool_t val2072_669)
{
   {
      obj_t aux_12966;
      {
	 object_t aux_12967;
	 aux_12967 = (object_t) (obj_668);
	 aux_12966 = OBJECT_WIDENING(aux_12967);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12966))->stackable__42) = ((bool_t) val2072_669), BUNSPEC);
   }
}


/* _make-procedure-app-stackable?-set!4104 */ obj_t 
_make_procedure_app_stackable__set_4104_216_cfa_info(obj_t env_9016, obj_t obj_9017, obj_t val2072_9018)
{
   return make_procedure_app_stackable__set__58_cfa_info((make_procedure_app_48_t) (obj_9017), CBOOL(val2072_9018));
}


/* make-procedure-app-stackable? */ bool_t 
make_procedure_app_stackable__92_cfa_info(make_procedure_app_48_t obj_670)
{
   {
      obj_t aux_12974;
      {
	 object_t aux_12975;
	 aux_12975 = (object_t) (obj_670);
	 aux_12974 = OBJECT_WIDENING(aux_12975);
      }
      return (((make_procedure_app_48_t) CREF(aux_12974))->stackable__42);
   }
}


/* _make-procedure-app-stackable?4105 */ obj_t 
_make_procedure_app_stackable_4105_191_cfa_info(obj_t env_9019, obj_t obj_9020)
{
   {
      bool_t aux_12979;
      aux_12979 = make_procedure_app_stackable__92_cfa_info((make_procedure_app_48_t) (obj_9020));
      return BBOOL(aux_12979);
   }
}


/* make-procedure-app-stack-stamp-set! */ obj_t 
make_procedure_app_stack_stamp_set__40_cfa_info(make_procedure_app_48_t obj_671, obj_t val2073_672)
{
   {
      obj_t aux_12983;
      {
	 object_t aux_12984;
	 aux_12984 = (object_t) (obj_671);
	 aux_12983 = OBJECT_WIDENING(aux_12984);
      }
      return ((((make_procedure_app_48_t) CREF(aux_12983))->stack_stamp_31) = ((obj_t) val2073_672), BUNSPEC);
   }
}


/* _make-procedure-app-stack-stamp-set!4106 */ obj_t 
_make_procedure_app_stack_stamp_set_4106_128_cfa_info(obj_t env_9021, obj_t obj_9022, obj_t val2073_9023)
{
   return make_procedure_app_stack_stamp_set__40_cfa_info((make_procedure_app_48_t) (obj_9022), val2073_9023);
}


/* make-procedure-app-stack-stamp */ obj_t 
make_procedure_app_stack_stamp_100_cfa_info(make_procedure_app_48_t obj_673)
{
   {
      obj_t aux_12990;
      {
	 object_t aux_12991;
	 aux_12991 = (object_t) (obj_673);
	 aux_12990 = OBJECT_WIDENING(aux_12991);
      }
      return (((make_procedure_app_48_t) CREF(aux_12990))->stack_stamp_31);
   }
}


/* _make-procedure-app-stack-stamp4107 */ obj_t 
_make_procedure_app_stack_stamp4107_219_cfa_info(obj_t env_9024, obj_t obj_9025)
{
   return make_procedure_app_stack_stamp_100_cfa_info((make_procedure_app_48_t) (obj_9025));
}


/* allocate-pre-procedure-set!-app */ app_t 
allocate_pre_procedure_set__app_97_cfa_info()
{
   {
      app_t new2039_2606;
      new2039_2606 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2856_2607;
	 arg2856_2607 = class_num_218___object(pre_procedure_set__app_208_cfa_info);
	 {
	    obj_t obj_5170;
	    obj_5170 = (obj_t) (new2039_2606);
	    (((obj_t) CREF(obj_5170))->header = MAKE_HEADER(arg2856_2607, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13001;
	 aux_13001 = (object_t) (new2039_2606);
	 OBJECT_WIDENING_SET(aux_13001, BFALSE);
      }
      return new2039_2606;
   }
}


/* _allocate-pre-procedure-set!-app */ obj_t 
_allocate_pre_procedure_set__app_24_cfa_info(obj_t env_8053)
{
   {
      app_t aux_13004;
      aux_13004 = allocate_pre_procedure_set__app_97_cfa_info();
      return (obj_t) (aux_13004);
   }
}


/* pre-procedure-set!-app? */ bool_t 
pre_procedure_set__app__184_cfa_info(obj_t obj_677)
{
   return is_a__118___object(obj_677, pre_procedure_set__app_208_cfa_info);
}


/* _pre-procedure-set!-app? */ obj_t 
_pre_procedure_set__app__169_cfa_info(obj_t env_9026, obj_t obj_9027)
{
   {
      bool_t aux_13008;
      aux_13008 = pre_procedure_set__app__184_cfa_info(obj_9027);
      return BBOOL(aux_13008);
   }
}


/* widening1033-pre-procedure-set!-app */ pre_procedure_set__app_208_t 
widening1033_pre_procedure_set__app_11_cfa_info()
{
   {
      return ((pre_procedure_set__app_208_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
   }
}


/* _widening1033-pre-procedure-set!-app */ obj_t 
_widening1033_pre_procedure_set__app_239_cfa_info(obj_t env_9028)
{
   {
      pre_procedure_set__app_208_t aux_13012;
      aux_13012 = widening1033_pre_procedure_set__app_11_cfa_info();
      return (obj_t) (aux_13012);
   }
}


/* make-pre-procedure-set!-app */ pre_procedure_set__app_208_t 
make_pre_procedure_set__app_49_cfa_info(obj_t loc_678, type_t type_679, obj_t side_effect__165_680, obj_t key_681, var_t fun_682, obj_t args_683, obj_t stack_info_255_684)
{
   {
      app_t aux2031_5173;
      {
	 app_t res3706_5195;
	 {
	    app_t new1289_5184;
	    new1289_5184 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_5185;
	       arg2999_5185 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_5193;
		  obj_5193 = (obj_t) (new1289_5184);
		  (((obj_t) CREF(obj_5193))->header = MAKE_HEADER(arg2999_5185, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13019;
	       aux_13019 = (object_t) (new1289_5184);
	       OBJECT_WIDENING_SET(aux_13019, BFALSE);
	    }
	    ((((app_t) CREF(new1289_5184))->loc) = ((obj_t) loc_678), BUNSPEC);
	    ((((app_t) CREF(new1289_5184))->type) = ((type_t) type_679), BUNSPEC);
	    ((((app_t) CREF(new1289_5184))->side_effect__165) = ((obj_t) side_effect__165_680), BUNSPEC);
	    ((((app_t) CREF(new1289_5184))->key) = ((obj_t) key_681), BUNSPEC);
	    ((((app_t) CREF(new1289_5184))->fun) = ((var_t) fun_682), BUNSPEC);
	    ((((app_t) CREF(new1289_5184))->args) = ((obj_t) args_683), BUNSPEC);
	    ((((app_t) CREF(new1289_5184))->stack_info_255) = ((obj_t) stack_info_255_684), BUNSPEC);
	    res3706_5195 = new1289_5184;
	 }
	 aux2031_5173 = res3706_5195;
      }
      {
	 pre_procedure_set__app_208_t new2032_5174;
	 new2032_5174 = ((pre_procedure_set__app_208_t) (aux2031_5173));
	 {
	    long arg2857_5175;
	    arg2857_5175 = class_num_218___object(pre_procedure_set__app_208_cfa_info);
	    {
	       obj_t obj_5196;
	       obj_5196 = (obj_t) (new2032_5174);
	       (((obj_t) CREF(obj_5196))->header = MAKE_HEADER(arg2857_5175, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_13035;
	    object_t aux_13033;
	    {
	       pre_procedure_set__app_208_t aux_13036;
	       {
		  aux_13036 = ((pre_procedure_set__app_208_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
	       }
	       aux_13035 = (obj_t) (aux_13036);
	    }
	    aux_13033 = (object_t) (new2032_5174);
	    OBJECT_WIDENING_SET(aux_13033, aux_13035);
	 }
	 return new2032_5174;
      }
   }
}


/* _make-pre-procedure-set!-app4108 */ obj_t 
_make_pre_procedure_set__app4108_230_cfa_info(obj_t env_9029, obj_t loc_9030, obj_t type_9031, obj_t side_effect__165_9032, obj_t key_9033, obj_t fun_9034, obj_t args_9035, obj_t stack_info_255_9036)
{
   {
      pre_procedure_set__app_208_t aux_13040;
      aux_13040 = make_pre_procedure_set__app_49_cfa_info(loc_9030, (type_t) (type_9031), side_effect__165_9032, key_9033, (var_t) (fun_9034), args_9035, stack_info_255_9036);
      return (obj_t) (aux_13040);
   }
}


/* pre-procedure-set!-app-loc */ obj_t 
pre_procedure_set__app_loc_154_cfa_info(app_t obj_685)
{
   return (((app_t) CREF(obj_685))->loc);
}


/* _pre-procedure-set!-app-loc4109 */ obj_t 
_pre_procedure_set__app_loc4109_229_cfa_info(obj_t env_9037, obj_t obj_9038)
{
   return pre_procedure_set__app_loc_154_cfa_info((app_t) (obj_9038));
}


/* pre-procedure-set!-app-type-set! */ obj_t 
pre_procedure_set__app_type_set__203_cfa_info(app_t obj_686, type_t val2033_687)
{
   return ((((app_t) CREF(obj_686))->type) = ((type_t) val2033_687), BUNSPEC);
}


/* _pre-procedure-set!-app-type-set!4110 */ obj_t 
_pre_procedure_set__app_type_set_4110_185_cfa_info(obj_t env_9039, obj_t obj_9040, obj_t val2033_9041)
{
   return pre_procedure_set__app_type_set__203_cfa_info((app_t) (obj_9040), (type_t) (val2033_9041));
}


/* pre-procedure-set!-app-type */ type_t 
pre_procedure_set__app_type_159_cfa_info(app_t obj_688)
{
   return (((app_t) CREF(obj_688))->type);
}


/* _pre-procedure-set!-app-type4111 */ obj_t 
_pre_procedure_set__app_type4111_183_cfa_info(obj_t env_9042, obj_t obj_9043)
{
   {
      type_t aux_13053;
      aux_13053 = pre_procedure_set__app_type_159_cfa_info((app_t) (obj_9043));
      return (obj_t) (aux_13053);
   }
}


/* pre-procedure-set!-app-side-effect?-set! */ obj_t 
pre_procedure_set__app_side_effect__set__95_cfa_info(app_t obj_689, obj_t val2034_690)
{
   return ((((app_t) CREF(obj_689))->side_effect__165) = ((obj_t) val2034_690), BUNSPEC);
}


/* _pre-procedure-set!-app-side-effect?-set!4112 */ obj_t 
_pre_procedure_set__app_side_effect__set_4112_183_cfa_info(obj_t env_9044, obj_t obj_9045, obj_t val2034_9046)
{
   return pre_procedure_set__app_side_effect__set__95_cfa_info((app_t) (obj_9045), val2034_9046);
}


/* pre-procedure-set!-app-side-effect? */ obj_t 
pre_procedure_set__app_side_effect__40_cfa_info(app_t obj_691)
{
   return (((app_t) CREF(obj_691))->side_effect__165);
}


/* _pre-procedure-set!-app-side-effect?4113 */ obj_t 
_pre_procedure_set__app_side_effect_4113_146_cfa_info(obj_t env_9047, obj_t obj_9048)
{
   return pre_procedure_set__app_side_effect__40_cfa_info((app_t) (obj_9048));
}


/* pre-procedure-set!-app-key-set! */ obj_t 
pre_procedure_set__app_key_set__8_cfa_info(app_t obj_692, obj_t val2035_693)
{
   return ((((app_t) CREF(obj_692))->key) = ((obj_t) val2035_693), BUNSPEC);
}


/* _pre-procedure-set!-app-key-set! */ obj_t 
_pre_procedure_set__app_key_set__239_cfa_info(obj_t env_9049, obj_t obj_9050, obj_t val2035_9051)
{
   return pre_procedure_set__app_key_set__8_cfa_info((app_t) (obj_9050), val2035_9051);
}


/* pre-procedure-set!-app-key */ obj_t 
pre_procedure_set__app_key_59_cfa_info(app_t obj_694)
{
   return (((app_t) CREF(obj_694))->key);
}


/* _pre-procedure-set!-app-key */ obj_t 
_pre_procedure_set__app_key_168_cfa_info(obj_t env_9052, obj_t obj_9053)
{
   return pre_procedure_set__app_key_59_cfa_info((app_t) (obj_9053));
}


/* pre-procedure-set!-app-fun-set! */ obj_t 
pre_procedure_set__app_fun_set__200_cfa_info(app_t obj_695, var_t val2036_696)
{
   return ((((app_t) CREF(obj_695))->fun) = ((var_t) val2036_696), BUNSPEC);
}


/* _pre-procedure-set!-app-fun-set!4114 */ obj_t 
_pre_procedure_set__app_fun_set_4114_225_cfa_info(obj_t env_9054, obj_t obj_9055, obj_t val2036_9056)
{
   return pre_procedure_set__app_fun_set__200_cfa_info((app_t) (obj_9055), (var_t) (val2036_9056));
}


/* pre-procedure-set!-app-fun */ var_t 
pre_procedure_set__app_fun_8_cfa_info(app_t obj_697)
{
   return (((app_t) CREF(obj_697))->fun);
}


/* _pre-procedure-set!-app-fun4115 */ obj_t 
_pre_procedure_set__app_fun4115_173_cfa_info(obj_t env_9057, obj_t obj_9058)
{
   {
      var_t aux_13074;
      aux_13074 = pre_procedure_set__app_fun_8_cfa_info((app_t) (obj_9058));
      return (obj_t) (aux_13074);
   }
}


/* pre-procedure-set!-app-args-set! */ obj_t 
pre_procedure_set__app_args_set__156_cfa_info(app_t obj_698, obj_t val2037_699)
{
   return ((((app_t) CREF(obj_698))->args) = ((obj_t) val2037_699), BUNSPEC);
}


/* _pre-procedure-set!-app-args-set!4116 */ obj_t 
_pre_procedure_set__app_args_set_4116_96_cfa_info(obj_t env_9059, obj_t obj_9060, obj_t val2037_9061)
{
   return pre_procedure_set__app_args_set__156_cfa_info((app_t) (obj_9060), val2037_9061);
}


/* pre-procedure-set!-app-args */ obj_t 
pre_procedure_set__app_args_207_cfa_info(app_t obj_700)
{
   return (((app_t) CREF(obj_700))->args);
}


/* _pre-procedure-set!-app-args4117 */ obj_t 
_pre_procedure_set__app_args4117_236_cfa_info(obj_t env_9062, obj_t obj_9063)
{
   return pre_procedure_set__app_args_207_cfa_info((app_t) (obj_9063));
}


/* pre-procedure-set!-app-stack-info-set! */ obj_t 
pre_procedure_set__app_stack_info_set__151_cfa_info(app_t obj_701, obj_t val2038_702)
{
   return ((((app_t) CREF(obj_701))->stack_info_255) = ((obj_t) val2038_702), BUNSPEC);
}


/* _pre-procedure-set!-app-stack-info-set!4118 */ obj_t 
_pre_procedure_set__app_stack_info_set_4118_226_cfa_info(obj_t env_9064, obj_t obj_9065, obj_t val2038_9066)
{
   return pre_procedure_set__app_stack_info_set__151_cfa_info((app_t) (obj_9065), val2038_9066);
}


/* pre-procedure-set!-app-stack-info */ obj_t 
pre_procedure_set__app_stack_info_34_cfa_info(app_t obj_703)
{
   return (((app_t) CREF(obj_703))->stack_info_255);
}


/* _pre-procedure-set!-app-stack-info4119 */ obj_t 
_pre_procedure_set__app_stack_info4119_155_cfa_info(obj_t env_9067, obj_t obj_9068)
{
   return pre_procedure_set__app_stack_info_34_cfa_info((app_t) (obj_9068));
}


/* allocate-pre-procedure-ref-app */ app_t 
allocate_pre_procedure_ref_app_138_cfa_info()
{
   {
      app_t new2022_2613;
      new2022_2613 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2859_2614;
	 arg2859_2614 = class_num_218___object(pre_procedure_ref_app_85_cfa_info);
	 {
	    obj_t obj_5200;
	    obj_5200 = (obj_t) (new2022_2613);
	    (((obj_t) CREF(obj_5200))->header = MAKE_HEADER(arg2859_2614, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13094;
	 aux_13094 = (object_t) (new2022_2613);
	 OBJECT_WIDENING_SET(aux_13094, BFALSE);
      }
      return new2022_2613;
   }
}


/* _allocate-pre-procedure-ref-app */ obj_t 
_allocate_pre_procedure_ref_app_105_cfa_info(obj_t env_8052)
{
   {
      app_t aux_13097;
      aux_13097 = allocate_pre_procedure_ref_app_138_cfa_info();
      return (obj_t) (aux_13097);
   }
}


/* pre-procedure-ref-app? */ bool_t 
pre_procedure_ref_app__89_cfa_info(obj_t obj_707)
{
   return is_a__118___object(obj_707, pre_procedure_ref_app_85_cfa_info);
}


/* _pre-procedure-ref-app? */ obj_t 
_pre_procedure_ref_app__123_cfa_info(obj_t env_9069, obj_t obj_9070)
{
   {
      bool_t aux_13101;
      aux_13101 = pre_procedure_ref_app__89_cfa_info(obj_9070);
      return BBOOL(aux_13101);
   }
}


/* widening1032-pre-procedure-ref-app */ pre_procedure_ref_app_85_t 
widening1032_pre_procedure_ref_app_123_cfa_info()
{
   {
      return ((pre_procedure_ref_app_85_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
   }
}


/* _widening1032-pre-procedure-ref-app */ obj_t 
_widening1032_pre_procedure_ref_app_158_cfa_info(obj_t env_9071)
{
   {
      pre_procedure_ref_app_85_t aux_13105;
      aux_13105 = widening1032_pre_procedure_ref_app_123_cfa_info();
      return (obj_t) (aux_13105);
   }
}


/* make-pre-procedure-ref-app */ pre_procedure_ref_app_85_t 
make_pre_procedure_ref_app_17_cfa_info(obj_t loc_708, type_t type_709, obj_t side_effect__165_710, obj_t key_711, var_t fun_712, obj_t args_713, obj_t stack_info_255_714)
{
   {
      app_t aux2014_5203;
      {
	 app_t res3708_5225;
	 {
	    app_t new1289_5214;
	    new1289_5214 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_5215;
	       arg2999_5215 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_5223;
		  obj_5223 = (obj_t) (new1289_5214);
		  (((obj_t) CREF(obj_5223))->header = MAKE_HEADER(arg2999_5215, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13112;
	       aux_13112 = (object_t) (new1289_5214);
	       OBJECT_WIDENING_SET(aux_13112, BFALSE);
	    }
	    ((((app_t) CREF(new1289_5214))->loc) = ((obj_t) loc_708), BUNSPEC);
	    ((((app_t) CREF(new1289_5214))->type) = ((type_t) type_709), BUNSPEC);
	    ((((app_t) CREF(new1289_5214))->side_effect__165) = ((obj_t) side_effect__165_710), BUNSPEC);
	    ((((app_t) CREF(new1289_5214))->key) = ((obj_t) key_711), BUNSPEC);
	    ((((app_t) CREF(new1289_5214))->fun) = ((var_t) fun_712), BUNSPEC);
	    ((((app_t) CREF(new1289_5214))->args) = ((obj_t) args_713), BUNSPEC);
	    ((((app_t) CREF(new1289_5214))->stack_info_255) = ((obj_t) stack_info_255_714), BUNSPEC);
	    res3708_5225 = new1289_5214;
	 }
	 aux2014_5203 = res3708_5225;
      }
      {
	 pre_procedure_ref_app_85_t new2015_5204;
	 new2015_5204 = ((pre_procedure_ref_app_85_t) (aux2014_5203));
	 {
	    long arg2860_5205;
	    arg2860_5205 = class_num_218___object(pre_procedure_ref_app_85_cfa_info);
	    {
	       obj_t obj_5226;
	       obj_5226 = (obj_t) (new2015_5204);
	       (((obj_t) CREF(obj_5226))->header = MAKE_HEADER(arg2860_5205, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_13128;
	    object_t aux_13126;
	    {
	       pre_procedure_ref_app_85_t aux_13129;
	       {
		  aux_13129 = ((pre_procedure_ref_app_85_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
	       }
	       aux_13128 = (obj_t) (aux_13129);
	    }
	    aux_13126 = (object_t) (new2015_5204);
	    OBJECT_WIDENING_SET(aux_13126, aux_13128);
	 }
	 return new2015_5204;
      }
   }
}


/* _make-pre-procedure-ref-app4120 */ obj_t 
_make_pre_procedure_ref_app4120_6_cfa_info(obj_t env_9072, obj_t loc_9073, obj_t type_9074, obj_t side_effect__165_9075, obj_t key_9076, obj_t fun_9077, obj_t args_9078, obj_t stack_info_255_9079)
{
   {
      pre_procedure_ref_app_85_t aux_13133;
      aux_13133 = make_pre_procedure_ref_app_17_cfa_info(loc_9073, (type_t) (type_9074), side_effect__165_9075, key_9076, (var_t) (fun_9077), args_9078, stack_info_255_9079);
      return (obj_t) (aux_13133);
   }
}


/* pre-procedure-ref-app-loc */ obj_t 
pre_procedure_ref_app_loc_169_cfa_info(app_t obj_715)
{
   return (((app_t) CREF(obj_715))->loc);
}


/* _pre-procedure-ref-app-loc4121 */ obj_t 
_pre_procedure_ref_app_loc4121_31_cfa_info(obj_t env_9080, obj_t obj_9081)
{
   return pre_procedure_ref_app_loc_169_cfa_info((app_t) (obj_9081));
}


/* pre-procedure-ref-app-type-set! */ obj_t 
pre_procedure_ref_app_type_set__15_cfa_info(app_t obj_716, type_t val2016_717)
{
   return ((((app_t) CREF(obj_716))->type) = ((type_t) val2016_717), BUNSPEC);
}


/* _pre-procedure-ref-app-type-set!4122 */ obj_t 
_pre_procedure_ref_app_type_set_4122_5_cfa_info(obj_t env_9082, obj_t obj_9083, obj_t val2016_9084)
{
   return pre_procedure_ref_app_type_set__15_cfa_info((app_t) (obj_9083), (type_t) (val2016_9084));
}


/* pre-procedure-ref-app-type */ type_t 
pre_procedure_ref_app_type_232_cfa_info(app_t obj_718)
{
   return (((app_t) CREF(obj_718))->type);
}


/* _pre-procedure-ref-app-type4123 */ obj_t 
_pre_procedure_ref_app_type4123_8_cfa_info(obj_t env_9085, obj_t obj_9086)
{
   {
      type_t aux_13146;
      aux_13146 = pre_procedure_ref_app_type_232_cfa_info((app_t) (obj_9086));
      return (obj_t) (aux_13146);
   }
}


/* pre-procedure-ref-app-side-effect?-set! */ obj_t 
pre_procedure_ref_app_side_effect__set__159_cfa_info(app_t obj_719, obj_t val2017_720)
{
   return ((((app_t) CREF(obj_719))->side_effect__165) = ((obj_t) val2017_720), BUNSPEC);
}


/* _pre-procedure-ref-app-side-effect?-set!4124 */ obj_t 
_pre_procedure_ref_app_side_effect__set_4124_61_cfa_info(obj_t env_9087, obj_t obj_9088, obj_t val2017_9089)
{
   return pre_procedure_ref_app_side_effect__set__159_cfa_info((app_t) (obj_9088), val2017_9089);
}


/* pre-procedure-ref-app-side-effect? */ obj_t 
pre_procedure_ref_app_side_effect__41_cfa_info(app_t obj_721)
{
   return (((app_t) CREF(obj_721))->side_effect__165);
}


/* _pre-procedure-ref-app-side-effect?4125 */ obj_t 
_pre_procedure_ref_app_side_effect_4125_202_cfa_info(obj_t env_9090, obj_t obj_9091)
{
   return pre_procedure_ref_app_side_effect__41_cfa_info((app_t) (obj_9091));
}


/* pre-procedure-ref-app-key-set! */ obj_t 
pre_procedure_ref_app_key_set__34_cfa_info(app_t obj_722, obj_t val2018_723)
{
   return ((((app_t) CREF(obj_722))->key) = ((obj_t) val2018_723), BUNSPEC);
}


/* _pre-procedure-ref-app-key-set! */ obj_t 
_pre_procedure_ref_app_key_set__188_cfa_info(obj_t env_9092, obj_t obj_9093, obj_t val2018_9094)
{
   return pre_procedure_ref_app_key_set__34_cfa_info((app_t) (obj_9093), val2018_9094);
}


/* pre-procedure-ref-app-key */ obj_t 
pre_procedure_ref_app_key_86_cfa_info(app_t obj_724)
{
   return (((app_t) CREF(obj_724))->key);
}


/* _pre-procedure-ref-app-key */ obj_t 
_pre_procedure_ref_app_key_222_cfa_info(obj_t env_9095, obj_t obj_9096)
{
   return pre_procedure_ref_app_key_86_cfa_info((app_t) (obj_9096));
}


/* pre-procedure-ref-app-fun-set! */ obj_t 
pre_procedure_ref_app_fun_set__152_cfa_info(app_t obj_725, var_t val2019_726)
{
   return ((((app_t) CREF(obj_725))->fun) = ((var_t) val2019_726), BUNSPEC);
}


/* _pre-procedure-ref-app-fun-set!4126 */ obj_t 
_pre_procedure_ref_app_fun_set_4126_166_cfa_info(obj_t env_9097, obj_t obj_9098, obj_t val2019_9099)
{
   return pre_procedure_ref_app_fun_set__152_cfa_info((app_t) (obj_9098), (var_t) (val2019_9099));
}


/* pre-procedure-ref-app-fun */ var_t 
pre_procedure_ref_app_fun_172_cfa_info(app_t obj_727)
{
   return (((app_t) CREF(obj_727))->fun);
}


/* _pre-procedure-ref-app-fun4127 */ obj_t 
_pre_procedure_ref_app_fun4127_167_cfa_info(obj_t env_9100, obj_t obj_9101)
{
   {
      var_t aux_13167;
      aux_13167 = pre_procedure_ref_app_fun_172_cfa_info((app_t) (obj_9101));
      return (obj_t) (aux_13167);
   }
}


/* pre-procedure-ref-app-args-set! */ obj_t 
pre_procedure_ref_app_args_set__9_cfa_info(app_t obj_728, obj_t val2020_729)
{
   return ((((app_t) CREF(obj_728))->args) = ((obj_t) val2020_729), BUNSPEC);
}


/* _pre-procedure-ref-app-args-set!4128 */ obj_t 
_pre_procedure_ref_app_args_set_4128_84_cfa_info(obj_t env_9102, obj_t obj_9103, obj_t val2020_9104)
{
   return pre_procedure_ref_app_args_set__9_cfa_info((app_t) (obj_9103), val2020_9104);
}


/* pre-procedure-ref-app-args */ obj_t 
pre_procedure_ref_app_args_98_cfa_info(app_t obj_730)
{
   return (((app_t) CREF(obj_730))->args);
}


/* _pre-procedure-ref-app-args4129 */ obj_t 
_pre_procedure_ref_app_args4129_205_cfa_info(obj_t env_9105, obj_t obj_9106)
{
   return pre_procedure_ref_app_args_98_cfa_info((app_t) (obj_9106));
}


/* pre-procedure-ref-app-stack-info-set! */ obj_t 
pre_procedure_ref_app_stack_info_set__115_cfa_info(app_t obj_731, obj_t val2021_732)
{
   return ((((app_t) CREF(obj_731))->stack_info_255) = ((obj_t) val2021_732), BUNSPEC);
}


/* _pre-procedure-ref-app-stack-info-set!4130 */ obj_t 
_pre_procedure_ref_app_stack_info_set_4130_149_cfa_info(obj_t env_9107, obj_t obj_9108, obj_t val2021_9109)
{
   return pre_procedure_ref_app_stack_info_set__115_cfa_info((app_t) (obj_9108), val2021_9109);
}


/* pre-procedure-ref-app-stack-info */ obj_t 
pre_procedure_ref_app_stack_info_22_cfa_info(app_t obj_733)
{
   return (((app_t) CREF(obj_733))->stack_info_255);
}


/* _pre-procedure-ref-app-stack-info4131 */ obj_t 
_pre_procedure_ref_app_stack_info4131_112_cfa_info(obj_t env_9110, obj_t obj_9111)
{
   return pre_procedure_ref_app_stack_info_22_cfa_info((app_t) (obj_9111));
}


/* allocate-pre-make-procedure-app */ app_t 
allocate_pre_make_procedure_app_4_cfa_info()
{
   {
      app_t new2005_2620;
      new2005_2620 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
      {
	 long arg2862_2621;
	 arg2862_2621 = class_num_218___object(pre_make_procedure_app_60_cfa_info);
	 {
	    obj_t obj_5230;
	    obj_5230 = (obj_t) (new2005_2620);
	    (((obj_t) CREF(obj_5230))->header = MAKE_HEADER(arg2862_2621, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13187;
	 aux_13187 = (object_t) (new2005_2620);
	 OBJECT_WIDENING_SET(aux_13187, BFALSE);
      }
      return new2005_2620;
   }
}


/* _allocate-pre-make-procedure-app */ obj_t 
_allocate_pre_make_procedure_app_108_cfa_info(obj_t env_8051)
{
   {
      app_t aux_13190;
      aux_13190 = allocate_pre_make_procedure_app_4_cfa_info();
      return (obj_t) (aux_13190);
   }
}


/* pre-make-procedure-app? */ bool_t 
pre_make_procedure_app__25_cfa_info(obj_t obj_737)
{
   return is_a__118___object(obj_737, pre_make_procedure_app_60_cfa_info);
}


/* _pre-make-procedure-app? */ obj_t 
_pre_make_procedure_app__252_cfa_info(obj_t env_9112, obj_t obj_9113)
{
   {
      bool_t aux_13194;
      aux_13194 = pre_make_procedure_app__25_cfa_info(obj_9113);
      return BBOOL(aux_13194);
   }
}


/* widening1031-pre-make-procedure-app */ pre_make_procedure_app_60_t 
widening1031_pre_make_procedure_app_55_cfa_info(variable_t owner_738)
{
   {
      pre_make_procedure_app_60_t new1994_5232;
      new1994_5232 = ((pre_make_procedure_app_60_t) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
      ((((pre_make_procedure_app_60_t) CREF(new1994_5232))->owner) = ((variable_t) owner_738), BUNSPEC);
      return new1994_5232;
   }
}


/* _widening1031-pre-make-procedure-app4132 */ obj_t 
_widening1031_pre_make_procedure_app4132_79_cfa_info(obj_t env_9114, obj_t owner_9115)
{
   {
      pre_make_procedure_app_60_t aux_13199;
      aux_13199 = widening1031_pre_make_procedure_app_55_cfa_info((variable_t) (owner_9115));
      return (obj_t) (aux_13199);
   }
}


/* make-pre-make-procedure-app */ pre_make_procedure_app_60_t 
make_pre_make_procedure_app_142_cfa_info(obj_t loc_739, type_t type_740, obj_t side_effect__165_741, obj_t key_742, var_t fun_743, obj_t args_744, obj_t stack_info_255_745, variable_t owner_746)
{
   {
      app_t aux1997_5234;
      {
	 app_t res3710_5256;
	 {
	    app_t new1289_5245;
	    new1289_5245 = ((app_t) BREF(GC_MALLOC(sizeof(struct app))));
	    {
	       long arg2999_5246;
	       arg2999_5246 = class_num_218___object(app_ast_node);
	       {
		  obj_t obj_5254;
		  obj_5254 = (obj_t) (new1289_5245);
		  (((obj_t) CREF(obj_5254))->header = MAKE_HEADER(arg2999_5246, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13207;
	       aux_13207 = (object_t) (new1289_5245);
	       OBJECT_WIDENING_SET(aux_13207, BFALSE);
	    }
	    ((((app_t) CREF(new1289_5245))->loc) = ((obj_t) loc_739), BUNSPEC);
	    ((((app_t) CREF(new1289_5245))->type) = ((type_t) type_740), BUNSPEC);
	    ((((app_t) CREF(new1289_5245))->side_effect__165) = ((obj_t) side_effect__165_741), BUNSPEC);
	    ((((app_t) CREF(new1289_5245))->key) = ((obj_t) key_742), BUNSPEC);
	    ((((app_t) CREF(new1289_5245))->fun) = ((var_t) fun_743), BUNSPEC);
	    ((((app_t) CREF(new1289_5245))->args) = ((obj_t) args_744), BUNSPEC);
	    ((((app_t) CREF(new1289_5245))->stack_info_255) = ((obj_t) stack_info_255_745), BUNSPEC);
	    res3710_5256 = new1289_5245;
	 }
	 aux1997_5234 = res3710_5256;
      }
      {
	 pre_make_procedure_app_60_t new1998_5235;
	 new1998_5235 = ((pre_make_procedure_app_60_t) (aux1997_5234));
	 {
	    long arg2863_5236;
	    arg2863_5236 = class_num_218___object(pre_make_procedure_app_60_cfa_info);
	    {
	       obj_t obj_5257;
	       obj_5257 = (obj_t) (new1998_5235);
	       (((obj_t) CREF(obj_5257))->header = MAKE_HEADER(arg2863_5236, 0), BUNSPEC);
	    }
	 }
	 {
	    pre_make_procedure_app_60_t arg2864_5237;
	    {
	       pre_make_procedure_app_60_t res3711_5262;
	       {
		  pre_make_procedure_app_60_t new1994_5260;
		  new1994_5260 = ((pre_make_procedure_app_60_t) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
		  ((((pre_make_procedure_app_60_t) CREF(new1994_5260))->owner) = ((variable_t) owner_746), BUNSPEC);
		  res3711_5262 = new1994_5260;
	       }
	       arg2864_5237 = res3711_5262;
	    }
	    {
	       obj_t aux_13225;
	       object_t aux_13223;
	       aux_13225 = (obj_t) (arg2864_5237);
	       aux_13223 = (object_t) (new1998_5235);
	       OBJECT_WIDENING_SET(aux_13223, aux_13225);
	    }
	 }
	 return new1998_5235;
      }
   }
}


/* _make-pre-make-procedure-app4133 */ obj_t 
_make_pre_make_procedure_app4133_249_cfa_info(obj_t env_9116, obj_t loc_9117, obj_t type_9118, obj_t side_effect__165_9119, obj_t key_9120, obj_t fun_9121, obj_t args_9122, obj_t stack_info_255_9123, obj_t owner_9124)
{
   {
      pre_make_procedure_app_60_t aux_13228;
      aux_13228 = make_pre_make_procedure_app_142_cfa_info(loc_9117, (type_t) (type_9118), side_effect__165_9119, key_9120, (var_t) (fun_9121), args_9122, stack_info_255_9123, (variable_t) (owner_9124));
      return (obj_t) (aux_13228);
   }
}


/* pre-make-procedure-app-loc */ obj_t 
pre_make_procedure_app_loc_229_cfa_info(app_t obj_747)
{
   return (((app_t) CREF(obj_747))->loc);
}


/* _pre-make-procedure-app-loc4134 */ obj_t 
_pre_make_procedure_app_loc4134_49_cfa_info(obj_t env_9125, obj_t obj_9126)
{
   return pre_make_procedure_app_loc_229_cfa_info((app_t) (obj_9126));
}


/* pre-make-procedure-app-type-set! */ obj_t 
pre_make_procedure_app_type_set__46_cfa_info(app_t obj_748, type_t val1999_749)
{
   return ((((app_t) CREF(obj_748))->type) = ((type_t) val1999_749), BUNSPEC);
}


/* _pre-make-procedure-app-type-set!4135 */ obj_t 
_pre_make_procedure_app_type_set_4135_203_cfa_info(obj_t env_9127, obj_t obj_9128, obj_t val1999_9129)
{
   return pre_make_procedure_app_type_set__46_cfa_info((app_t) (obj_9128), (type_t) (val1999_9129));
}


/* pre-make-procedure-app-type */ type_t 
pre_make_procedure_app_type_102_cfa_info(app_t obj_750)
{
   return (((app_t) CREF(obj_750))->type);
}


/* _pre-make-procedure-app-type4136 */ obj_t 
_pre_make_procedure_app_type4136_42_cfa_info(obj_t env_9130, obj_t obj_9131)
{
   {
      type_t aux_13242;
      aux_13242 = pre_make_procedure_app_type_102_cfa_info((app_t) (obj_9131));
      return (obj_t) (aux_13242);
   }
}


/* pre-make-procedure-app-side-effect?-set! */ obj_t 
pre_make_procedure_app_side_effect__set__13_cfa_info(app_t obj_751, obj_t val2000_752)
{
   return ((((app_t) CREF(obj_751))->side_effect__165) = ((obj_t) val2000_752), BUNSPEC);
}


/* _pre-make-procedure-app-side-effect?-set!4137 */ obj_t 
_pre_make_procedure_app_side_effect__set_4137_217_cfa_info(obj_t env_9132, obj_t obj_9133, obj_t val2000_9134)
{
   return pre_make_procedure_app_side_effect__set__13_cfa_info((app_t) (obj_9133), val2000_9134);
}


/* pre-make-procedure-app-side-effect? */ obj_t 
pre_make_procedure_app_side_effect__30_cfa_info(app_t obj_753)
{
   return (((app_t) CREF(obj_753))->side_effect__165);
}


/* _pre-make-procedure-app-side-effect?4138 */ obj_t 
_pre_make_procedure_app_side_effect_4138_178_cfa_info(obj_t env_9135, obj_t obj_9136)
{
   return pre_make_procedure_app_side_effect__30_cfa_info((app_t) (obj_9136));
}


/* pre-make-procedure-app-key-set! */ obj_t 
pre_make_procedure_app_key_set__101_cfa_info(app_t obj_754, obj_t val2001_755)
{
   return ((((app_t) CREF(obj_754))->key) = ((obj_t) val2001_755), BUNSPEC);
}


/* _pre-make-procedure-app-key-set!4139 */ obj_t 
_pre_make_procedure_app_key_set_4139_227_cfa_info(obj_t env_9137, obj_t obj_9138, obj_t val2001_9139)
{
   return pre_make_procedure_app_key_set__101_cfa_info((app_t) (obj_9138), val2001_9139);
}


/* pre-make-procedure-app-key */ obj_t 
pre_make_procedure_app_key_242_cfa_info(app_t obj_756)
{
   return (((app_t) CREF(obj_756))->key);
}


/* _pre-make-procedure-app-key4140 */ obj_t 
_pre_make_procedure_app_key4140_143_cfa_info(obj_t env_9140, obj_t obj_9141)
{
   return pre_make_procedure_app_key_242_cfa_info((app_t) (obj_9141));
}


/* pre-make-procedure-app-fun-set! */ obj_t 
pre_make_procedure_app_fun_set__110_cfa_info(app_t obj_757, var_t val2002_758)
{
   return ((((app_t) CREF(obj_757))->fun) = ((var_t) val2002_758), BUNSPEC);
}


/* _pre-make-procedure-app-fun-set!4141 */ obj_t 
_pre_make_procedure_app_fun_set_4141_230_cfa_info(obj_t env_9142, obj_t obj_9143, obj_t val2002_9144)
{
   return pre_make_procedure_app_fun_set__110_cfa_info((app_t) (obj_9143), (var_t) (val2002_9144));
}


/* pre-make-procedure-app-fun */ var_t 
pre_make_procedure_app_fun_199_cfa_info(app_t obj_759)
{
   return (((app_t) CREF(obj_759))->fun);
}


/* _pre-make-procedure-app-fun4142 */ obj_t 
_pre_make_procedure_app_fun4142_229_cfa_info(obj_t env_9145, obj_t obj_9146)
{
   {
      var_t aux_13263;
      aux_13263 = pre_make_procedure_app_fun_199_cfa_info((app_t) (obj_9146));
      return (obj_t) (aux_13263);
   }
}


/* pre-make-procedure-app-args-set! */ obj_t 
pre_make_procedure_app_args_set__119_cfa_info(app_t obj_760, obj_t val2003_761)
{
   return ((((app_t) CREF(obj_760))->args) = ((obj_t) val2003_761), BUNSPEC);
}


/* _pre-make-procedure-app-args-set!4143 */ obj_t 
_pre_make_procedure_app_args_set_4143_113_cfa_info(obj_t env_9147, obj_t obj_9148, obj_t val2003_9149)
{
   return pre_make_procedure_app_args_set__119_cfa_info((app_t) (obj_9148), val2003_9149);
}


/* pre-make-procedure-app-args */ obj_t 
pre_make_procedure_app_args_217_cfa_info(app_t obj_762)
{
   return (((app_t) CREF(obj_762))->args);
}


/* _pre-make-procedure-app-args4144 */ obj_t 
_pre_make_procedure_app_args4144_74_cfa_info(obj_t env_9150, obj_t obj_9151)
{
   return pre_make_procedure_app_args_217_cfa_info((app_t) (obj_9151));
}


/* pre-make-procedure-app-stack-info-set! */ obj_t 
pre_make_procedure_app_stack_info_set__177_cfa_info(app_t obj_763, obj_t val2004_764)
{
   return ((((app_t) CREF(obj_763))->stack_info_255) = ((obj_t) val2004_764), BUNSPEC);
}


/* _pre-make-procedure-app-stack-info-set!4145 */ obj_t 
_pre_make_procedure_app_stack_info_set_4145_174_cfa_info(obj_t env_9152, obj_t obj_9153, obj_t val2004_9154)
{
   return pre_make_procedure_app_stack_info_set__177_cfa_info((app_t) (obj_9153), val2004_9154);
}


/* pre-make-procedure-app-stack-info */ obj_t 
pre_make_procedure_app_stack_info_161_cfa_info(app_t obj_765)
{
   return (((app_t) CREF(obj_765))->stack_info_255);
}


/* _pre-make-procedure-app-stack-info4146 */ obj_t 
_pre_make_procedure_app_stack_info4146_76_cfa_info(obj_t env_9155, obj_t obj_9156)
{
   return pre_make_procedure_app_stack_info_161_cfa_info((app_t) (obj_9156));
}


/* pre-make-procedure-app-owner */ variable_t 
pre_make_procedure_app_owner_169_cfa_info(pre_make_procedure_app_60_t obj_766)
{
   {
      obj_t aux_13279;
      {
	 object_t aux_13280;
	 aux_13280 = (object_t) (obj_766);
	 aux_13279 = OBJECT_WIDENING(aux_13280);
      }
      return (((pre_make_procedure_app_60_t) CREF(aux_13279))->owner);
   }
}


/* _pre-make-procedure-app-owner4147 */ obj_t 
_pre_make_procedure_app_owner4147_18_cfa_info(obj_t env_9157, obj_t obj_9158)
{
   {
      variable_t aux_13284;
      aux_13284 = pre_make_procedure_app_owner_169_cfa_info((pre_make_procedure_app_60_t) (obj_9158));
      return (obj_t) (aux_13284);
   }
}


/* allocate-box-ref/o-cinfo */ box_ref_242_t 
allocate_box_ref_o_cinfo_99_cfa_info()
{
   {
      box_ref_242_t new1987_2628;
      new1987_2628 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
      {
	 long arg2865_2629;
	 arg2865_2629 = class_num_218___object(box_ref_o_cinfo_98_cfa_info);
	 {
	    obj_t obj_5263;
	    obj_5263 = (obj_t) (new1987_2628);
	    (((obj_t) CREF(obj_5263))->header = MAKE_HEADER(arg2865_2629, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13292;
	 aux_13292 = (object_t) (new1987_2628);
	 OBJECT_WIDENING_SET(aux_13292, BFALSE);
      }
      return new1987_2628;
   }
}


/* _allocate-box-ref/o-cinfo */ obj_t 
_allocate_box_ref_o_cinfo_197_cfa_info(obj_t env_8050)
{
   {
      box_ref_242_t aux_13295;
      aux_13295 = allocate_box_ref_o_cinfo_99_cfa_info();
      return (obj_t) (aux_13295);
   }
}


/* box-ref/o-cinfo? */ bool_t 
box_ref_o_cinfo__192_cfa_info(obj_t obj_770)
{
   return is_a__118___object(obj_770, box_ref_o_cinfo_98_cfa_info);
}


/* _box-ref/o-cinfo? */ obj_t 
_box_ref_o_cinfo__170_cfa_info(obj_t env_9159, obj_t obj_9160)
{
   {
      bool_t aux_13299;
      aux_13299 = box_ref_o_cinfo__192_cfa_info(obj_9160);
      return BBOOL(aux_13299);
   }
}


/* widening1030-box-ref/o-cinfo */ box_ref_o_cinfo_98_t 
widening1030_box_ref_o_cinfo_31_cfa_info(approx_t approx_771)
{
   {
      box_ref_o_cinfo_98_t new1978_5265;
      new1978_5265 = ((box_ref_o_cinfo_98_t) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
      ((((box_ref_o_cinfo_98_t) CREF(new1978_5265))->approx) = ((approx_t) approx_771), BUNSPEC);
      return new1978_5265;
   }
}


/* _widening1030-box-ref/o-cinfo4148 */ obj_t 
_widening1030_box_ref_o_cinfo4148_151_cfa_info(obj_t env_9161, obj_t approx_9162)
{
   {
      box_ref_o_cinfo_98_t aux_13304;
      aux_13304 = widening1030_box_ref_o_cinfo_31_cfa_info((approx_t) (approx_9162));
      return (obj_t) (aux_13304);
   }
}


/* make-box-ref/o-cinfo */ box_ref_o_cinfo_98_t 
make_box_ref_o_cinfo_177_cfa_info(obj_t loc_772, type_t type_773, obj_t side_effect__165_774, obj_t key_775, var_t var_776, approx_t approx_777)
{
   {
      box_ref_242_t aux1981_5267;
      {
	 box_ref_242_t res3712_5285;
	 {
	    box_ref_242_t new1462_5276;
	    new1462_5276 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	    {
	       long arg2965_5277;
	       arg2965_5277 = class_num_218___object(box_ref_242_ast_node);
	       {
		  obj_t obj_5283;
		  obj_5283 = (obj_t) (new1462_5276);
		  (((obj_t) CREF(obj_5283))->header = MAKE_HEADER(arg2965_5277, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13312;
	       aux_13312 = (object_t) (new1462_5276);
	       OBJECT_WIDENING_SET(aux_13312, BFALSE);
	    }
	    ((((box_ref_242_t) CREF(new1462_5276))->loc) = ((obj_t) loc_772), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5276))->type) = ((type_t) type_773), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5276))->side_effect__165) = ((obj_t) side_effect__165_774), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5276))->key) = ((obj_t) key_775), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5276))->var) = ((var_t) var_776), BUNSPEC);
	    res3712_5285 = new1462_5276;
	 }
	 aux1981_5267 = res3712_5285;
      }
      {
	 box_ref_o_cinfo_98_t new1982_5268;
	 new1982_5268 = ((box_ref_o_cinfo_98_t) (aux1981_5267));
	 {
	    long arg2866_5269;
	    arg2866_5269 = class_num_218___object(box_ref_o_cinfo_98_cfa_info);
	    {
	       obj_t obj_5286;
	       obj_5286 = (obj_t) (new1982_5268);
	       (((obj_t) CREF(obj_5286))->header = MAKE_HEADER(arg2866_5269, 0), BUNSPEC);
	    }
	 }
	 {
	    box_ref_o_cinfo_98_t arg2867_5270;
	    {
	       box_ref_o_cinfo_98_t res3713_5291;
	       {
		  box_ref_o_cinfo_98_t new1978_5289;
		  new1978_5289 = ((box_ref_o_cinfo_98_t) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
		  ((((box_ref_o_cinfo_98_t) CREF(new1978_5289))->approx) = ((approx_t) approx_777), BUNSPEC);
		  res3713_5291 = new1978_5289;
	       }
	       arg2867_5270 = res3713_5291;
	    }
	    {
	       obj_t aux_13328;
	       object_t aux_13326;
	       aux_13328 = (obj_t) (arg2867_5270);
	       aux_13326 = (object_t) (new1982_5268);
	       OBJECT_WIDENING_SET(aux_13326, aux_13328);
	    }
	 }
	 return new1982_5268;
      }
   }
}


/* _make-box-ref/o-cinfo4149 */ obj_t 
_make_box_ref_o_cinfo4149_10_cfa_info(obj_t env_9163, obj_t loc_9164, obj_t type_9165, obj_t side_effect__165_9166, obj_t key_9167, obj_t var_9168, obj_t approx_9169)
{
   {
      box_ref_o_cinfo_98_t aux_13331;
      aux_13331 = make_box_ref_o_cinfo_177_cfa_info(loc_9164, (type_t) (type_9165), side_effect__165_9166, key_9167, (var_t) (var_9168), (approx_t) (approx_9169));
      return (obj_t) (aux_13331);
   }
}


/* box-ref/o-cinfo-loc */ obj_t 
box_ref_o_cinfo_loc_36_cfa_info(box_ref_242_t obj_778)
{
   return (((box_ref_242_t) CREF(obj_778))->loc);
}


/* _box-ref/o-cinfo-loc4150 */ obj_t 
_box_ref_o_cinfo_loc4150_12_cfa_info(obj_t env_9170, obj_t obj_9171)
{
   return box_ref_o_cinfo_loc_36_cfa_info((box_ref_242_t) (obj_9171));
}


/* box-ref/o-cinfo-type-set! */ obj_t 
box_ref_o_cinfo_type_set__20_cfa_info(box_ref_242_t obj_779, type_t val1983_780)
{
   return ((((box_ref_242_t) CREF(obj_779))->type) = ((type_t) val1983_780), BUNSPEC);
}


/* _box-ref/o-cinfo-type-set!4151 */ obj_t 
_box_ref_o_cinfo_type_set_4151_14_cfa_info(obj_t env_9172, obj_t obj_9173, obj_t val1983_9174)
{
   return box_ref_o_cinfo_type_set__20_cfa_info((box_ref_242_t) (obj_9173), (type_t) (val1983_9174));
}


/* box-ref/o-cinfo-type */ type_t 
box_ref_o_cinfo_type_224_cfa_info(box_ref_242_t obj_781)
{
   return (((box_ref_242_t) CREF(obj_781))->type);
}


/* _box-ref/o-cinfo-type4152 */ obj_t 
_box_ref_o_cinfo_type4152_46_cfa_info(obj_t env_9175, obj_t obj_9176)
{
   {
      type_t aux_13345;
      aux_13345 = box_ref_o_cinfo_type_224_cfa_info((box_ref_242_t) (obj_9176));
      return (obj_t) (aux_13345);
   }
}


/* box-ref/o-cinfo-side-effect?-set! */ obj_t 
box_ref_o_cinfo_side_effect__set__170_cfa_info(box_ref_242_t obj_782, obj_t val1984_783)
{
   return ((((box_ref_242_t) CREF(obj_782))->side_effect__165) = ((obj_t) val1984_783), BUNSPEC);
}


/* _box-ref/o-cinfo-side-effect?-set!4153 */ obj_t 
_box_ref_o_cinfo_side_effect__set_4153_214_cfa_info(obj_t env_9177, obj_t obj_9178, obj_t val1984_9179)
{
   return box_ref_o_cinfo_side_effect__set__170_cfa_info((box_ref_242_t) (obj_9178), val1984_9179);
}


/* box-ref/o-cinfo-side-effect? */ obj_t 
box_ref_o_cinfo_side_effect__156_cfa_info(box_ref_242_t obj_784)
{
   return (((box_ref_242_t) CREF(obj_784))->side_effect__165);
}


/* _box-ref/o-cinfo-side-effect?4154 */ obj_t 
_box_ref_o_cinfo_side_effect_4154_125_cfa_info(obj_t env_9180, obj_t obj_9181)
{
   return box_ref_o_cinfo_side_effect__156_cfa_info((box_ref_242_t) (obj_9181));
}


/* box-ref/o-cinfo-key-set! */ obj_t 
box_ref_o_cinfo_key_set__15_cfa_info(box_ref_242_t obj_785, obj_t val1985_786)
{
   return ((((box_ref_242_t) CREF(obj_785))->key) = ((obj_t) val1985_786), BUNSPEC);
}


/* _box-ref/o-cinfo-key-set! */ obj_t 
_box_ref_o_cinfo_key_set__163_cfa_info(obj_t env_9182, obj_t obj_9183, obj_t val1985_9184)
{
   return box_ref_o_cinfo_key_set__15_cfa_info((box_ref_242_t) (obj_9183), val1985_9184);
}


/* box-ref/o-cinfo-key */ obj_t 
box_ref_o_cinfo_key_232_cfa_info(box_ref_242_t obj_787)
{
   return (((box_ref_242_t) CREF(obj_787))->key);
}


/* _box-ref/o-cinfo-key */ obj_t 
_box_ref_o_cinfo_key_193_cfa_info(obj_t env_9185, obj_t obj_9186)
{
   return box_ref_o_cinfo_key_232_cfa_info((box_ref_242_t) (obj_9186));
}


/* box-ref/o-cinfo-var-set! */ obj_t 
box_ref_o_cinfo_var_set__204_cfa_info(box_ref_242_t obj_788, var_t val1986_789)
{
   return ((((box_ref_242_t) CREF(obj_788))->var) = ((var_t) val1986_789), BUNSPEC);
}


/* _box-ref/o-cinfo-var-set!4155 */ obj_t 
_box_ref_o_cinfo_var_set_4155_190_cfa_info(obj_t env_9187, obj_t obj_9188, obj_t val1986_9189)
{
   return box_ref_o_cinfo_var_set__204_cfa_info((box_ref_242_t) (obj_9188), (var_t) (val1986_9189));
}


/* box-ref/o-cinfo-var */ var_t 
box_ref_o_cinfo_var_44_cfa_info(box_ref_242_t obj_790)
{
   return (((box_ref_242_t) CREF(obj_790))->var);
}


/* _box-ref/o-cinfo-var4156 */ obj_t 
_box_ref_o_cinfo_var4156_18_cfa_info(obj_t env_9190, obj_t obj_9191)
{
   {
      var_t aux_13366;
      aux_13366 = box_ref_o_cinfo_var_44_cfa_info((box_ref_242_t) (obj_9191));
      return (obj_t) (aux_13366);
   }
}


/* box-ref/o-cinfo-approx */ approx_t 
box_ref_o_cinfo_approx_223_cfa_info(box_ref_o_cinfo_98_t obj_791)
{
   {
      obj_t aux_13370;
      {
	 object_t aux_13371;
	 aux_13371 = (object_t) (obj_791);
	 aux_13370 = OBJECT_WIDENING(aux_13371);
      }
      return (((box_ref_o_cinfo_98_t) CREF(aux_13370))->approx);
   }
}


/* _box-ref/o-cinfo-approx4157 */ obj_t 
_box_ref_o_cinfo_approx4157_217_cfa_info(obj_t env_9192, obj_t obj_9193)
{
   {
      approx_t aux_13375;
      aux_13375 = box_ref_o_cinfo_approx_223_cfa_info((box_ref_o_cinfo_98_t) (obj_9193));
      return (obj_t) (aux_13375);
   }
}


/* allocate-box-set!/o-cinfo */ box_set__221_t 
allocate_box_set__o_cinfo_236_cfa_info()
{
   {
      box_set__221_t new1971_2636;
      new1971_2636 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
      {
	 long arg2868_2637;
	 arg2868_2637 = class_num_218___object(box_set__o_cinfo_6_cfa_info);
	 {
	    obj_t obj_5292;
	    obj_5292 = (obj_t) (new1971_2636);
	    (((obj_t) CREF(obj_5292))->header = MAKE_HEADER(arg2868_2637, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13383;
	 aux_13383 = (object_t) (new1971_2636);
	 OBJECT_WIDENING_SET(aux_13383, BFALSE);
      }
      return new1971_2636;
   }
}


/* _allocate-box-set!/o-cinfo */ obj_t 
_allocate_box_set__o_cinfo_20_cfa_info(obj_t env_8049)
{
   {
      box_set__221_t aux_13386;
      aux_13386 = allocate_box_set__o_cinfo_236_cfa_info();
      return (obj_t) (aux_13386);
   }
}


/* box-set!/o-cinfo? */ bool_t 
box_set__o_cinfo__167_cfa_info(obj_t obj_795)
{
   return is_a__118___object(obj_795, box_set__o_cinfo_6_cfa_info);
}


/* _box-set!/o-cinfo? */ obj_t 
_box_set__o_cinfo__123_cfa_info(obj_t env_9194, obj_t obj_9195)
{
   {
      bool_t aux_13390;
      aux_13390 = box_set__o_cinfo__167_cfa_info(obj_9195);
      return BBOOL(aux_13390);
   }
}


/* widening1029-box-set!/o-cinfo */ box_set__o_cinfo_6_t 
widening1029_box_set__o_cinfo_148_cfa_info(approx_t approx_796)
{
   {
      box_set__o_cinfo_6_t new1963_5294;
      new1963_5294 = ((box_set__o_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
      ((((box_set__o_cinfo_6_t) CREF(new1963_5294))->approx) = ((approx_t) approx_796), BUNSPEC);
      return new1963_5294;
   }
}


/* _widening1029-box-set!/o-cinfo4158 */ obj_t 
_widening1029_box_set__o_cinfo4158_92_cfa_info(obj_t env_9196, obj_t approx_9197)
{
   {
      box_set__o_cinfo_6_t aux_13395;
      aux_13395 = widening1029_box_set__o_cinfo_148_cfa_info((approx_t) (approx_9197));
      return (obj_t) (aux_13395);
   }
}


/* make-box-set!/o-cinfo */ box_set__o_cinfo_6_t 
make_box_set__o_cinfo_60_cfa_info(obj_t loc_797, type_t type_798, var_t var_799, node_t value_800, approx_t approx_801)
{
   {
      box_set__221_t aux1966_5296;
      {
	 box_set__221_t res3714_5312;
	 {
	    box_set__221_t new1474_5304;
	    new1474_5304 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	    {
	       long arg2963_5305;
	       arg2963_5305 = class_num_218___object(box_set__221_ast_node);
	       {
		  obj_t obj_5310;
		  obj_5310 = (obj_t) (new1474_5304);
		  (((obj_t) CREF(obj_5310))->header = MAKE_HEADER(arg2963_5305, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13403;
	       aux_13403 = (object_t) (new1474_5304);
	       OBJECT_WIDENING_SET(aux_13403, BFALSE);
	    }
	    ((((box_set__221_t) CREF(new1474_5304))->loc) = ((obj_t) loc_797), BUNSPEC);
	    ((((box_set__221_t) CREF(new1474_5304))->type) = ((type_t) type_798), BUNSPEC);
	    ((((box_set__221_t) CREF(new1474_5304))->var) = ((var_t) var_799), BUNSPEC);
	    ((((box_set__221_t) CREF(new1474_5304))->value) = ((node_t) value_800), BUNSPEC);
	    res3714_5312 = new1474_5304;
	 }
	 aux1966_5296 = res3714_5312;
      }
      {
	 box_set__o_cinfo_6_t new1967_5297;
	 new1967_5297 = ((box_set__o_cinfo_6_t) (aux1966_5296));
	 {
	    long arg2869_5298;
	    arg2869_5298 = class_num_218___object(box_set__o_cinfo_6_cfa_info);
	    {
	       obj_t obj_5313;
	       obj_5313 = (obj_t) (new1967_5297);
	       (((obj_t) CREF(obj_5313))->header = MAKE_HEADER(arg2869_5298, 0), BUNSPEC);
	    }
	 }
	 {
	    box_set__o_cinfo_6_t arg2870_5299;
	    {
	       box_set__o_cinfo_6_t res3715_5318;
	       {
		  box_set__o_cinfo_6_t new1963_5316;
		  new1963_5316 = ((box_set__o_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
		  ((((box_set__o_cinfo_6_t) CREF(new1963_5316))->approx) = ((approx_t) approx_801), BUNSPEC);
		  res3715_5318 = new1963_5316;
	       }
	       arg2870_5299 = res3715_5318;
	    }
	    {
	       obj_t aux_13418;
	       object_t aux_13416;
	       aux_13418 = (obj_t) (arg2870_5299);
	       aux_13416 = (object_t) (new1967_5297);
	       OBJECT_WIDENING_SET(aux_13416, aux_13418);
	    }
	 }
	 return new1967_5297;
      }
   }
}


/* _make-box-set!/o-cinfo4159 */ obj_t 
_make_box_set__o_cinfo4159_124_cfa_info(obj_t env_9198, obj_t loc_9199, obj_t type_9200, obj_t var_9201, obj_t value_9202, obj_t approx_9203)
{
   {
      box_set__o_cinfo_6_t aux_13421;
      aux_13421 = make_box_set__o_cinfo_60_cfa_info(loc_9199, (type_t) (type_9200), (var_t) (var_9201), (node_t) (value_9202), (approx_t) (approx_9203));
      return (obj_t) (aux_13421);
   }
}


/* box-set!/o-cinfo-loc */ obj_t 
box_set__o_cinfo_loc_249_cfa_info(box_set__221_t obj_802)
{
   return (((box_set__221_t) CREF(obj_802))->loc);
}


/* _box-set!/o-cinfo-loc4160 */ obj_t 
_box_set__o_cinfo_loc4160_0_cfa_info(obj_t env_9204, obj_t obj_9205)
{
   return box_set__o_cinfo_loc_249_cfa_info((box_set__221_t) (obj_9205));
}


/* box-set!/o-cinfo-type-set! */ obj_t 
box_set__o_cinfo_type_set__107_cfa_info(box_set__221_t obj_803, type_t val1968_804)
{
   return ((((box_set__221_t) CREF(obj_803))->type) = ((type_t) val1968_804), BUNSPEC);
}


/* _box-set!/o-cinfo-type-set!4161 */ obj_t 
_box_set__o_cinfo_type_set_4161_232_cfa_info(obj_t env_9206, obj_t obj_9207, obj_t val1968_9208)
{
   return box_set__o_cinfo_type_set__107_cfa_info((box_set__221_t) (obj_9207), (type_t) (val1968_9208));
}


/* box-set!/o-cinfo-type */ type_t 
box_set__o_cinfo_type_128_cfa_info(box_set__221_t obj_805)
{
   return (((box_set__221_t) CREF(obj_805))->type);
}


/* _box-set!/o-cinfo-type4162 */ obj_t 
_box_set__o_cinfo_type4162_84_cfa_info(obj_t env_9209, obj_t obj_9210)
{
   {
      type_t aux_13436;
      aux_13436 = box_set__o_cinfo_type_128_cfa_info((box_set__221_t) (obj_9210));
      return (obj_t) (aux_13436);
   }
}


/* box-set!/o-cinfo-var-set! */ obj_t 
box_set__o_cinfo_var_set__7_cfa_info(box_set__221_t obj_806, var_t val1969_807)
{
   return ((((box_set__221_t) CREF(obj_806))->var) = ((var_t) val1969_807), BUNSPEC);
}


/* _box-set!/o-cinfo-var-set!4163 */ obj_t 
_box_set__o_cinfo_var_set_4163_39_cfa_info(obj_t env_9211, obj_t obj_9212, obj_t val1969_9213)
{
   return box_set__o_cinfo_var_set__7_cfa_info((box_set__221_t) (obj_9212), (var_t) (val1969_9213));
}


/* box-set!/o-cinfo-var */ var_t 
box_set__o_cinfo_var_171_cfa_info(box_set__221_t obj_808)
{
   return (((box_set__221_t) CREF(obj_808))->var);
}


/* _box-set!/o-cinfo-var4164 */ obj_t 
_box_set__o_cinfo_var4164_214_cfa_info(obj_t env_9214, obj_t obj_9215)
{
   {
      var_t aux_13445;
      aux_13445 = box_set__o_cinfo_var_171_cfa_info((box_set__221_t) (obj_9215));
      return (obj_t) (aux_13445);
   }
}


/* box-set!/o-cinfo-value-set! */ obj_t 
box_set__o_cinfo_value_set__181_cfa_info(box_set__221_t obj_809, node_t val1970_810)
{
   return ((((box_set__221_t) CREF(obj_809))->value) = ((node_t) val1970_810), BUNSPEC);
}


/* _box-set!/o-cinfo-value-set!4165 */ obj_t 
_box_set__o_cinfo_value_set_4165_22_cfa_info(obj_t env_9216, obj_t obj_9217, obj_t val1970_9218)
{
   return box_set__o_cinfo_value_set__181_cfa_info((box_set__221_t) (obj_9217), (node_t) (val1970_9218));
}


/* box-set!/o-cinfo-value */ node_t 
box_set__o_cinfo_value_185_cfa_info(box_set__221_t obj_811)
{
   return (((box_set__221_t) CREF(obj_811))->value);
}


/* _box-set!/o-cinfo-value4166 */ obj_t 
_box_set__o_cinfo_value4166_97_cfa_info(obj_t env_9219, obj_t obj_9220)
{
   {
      node_t aux_13454;
      aux_13454 = box_set__o_cinfo_value_185_cfa_info((box_set__221_t) (obj_9220));
      return (obj_t) (aux_13454);
   }
}


/* box-set!/o-cinfo-approx */ approx_t 
box_set__o_cinfo_approx_180_cfa_info(box_set__o_cinfo_6_t obj_812)
{
   {
      obj_t aux_13458;
      {
	 object_t aux_13459;
	 aux_13459 = (object_t) (obj_812);
	 aux_13458 = OBJECT_WIDENING(aux_13459);
      }
      return (((box_set__o_cinfo_6_t) CREF(aux_13458))->approx);
   }
}


/* _box-set!/o-cinfo-approx4167 */ obj_t 
_box_set__o_cinfo_approx4167_50_cfa_info(obj_t env_9221, obj_t obj_9222)
{
   {
      approx_t aux_13463;
      aux_13463 = box_set__o_cinfo_approx_180_cfa_info((box_set__o_cinfo_6_t) (obj_9222));
      return (obj_t) (aux_13463);
   }
}


/* allocate-box-ref/cinfo */ box_ref_242_t 
allocate_box_ref_cinfo_31_cfa_info()
{
   {
      box_ref_242_t new1956_2644;
      new1956_2644 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
      {
	 long arg2871_2645;
	 arg2871_2645 = class_num_218___object(box_ref_cinfo_214_cfa_info);
	 {
	    obj_t obj_5319;
	    obj_5319 = (obj_t) (new1956_2644);
	    (((obj_t) CREF(obj_5319))->header = MAKE_HEADER(arg2871_2645, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13471;
	 aux_13471 = (object_t) (new1956_2644);
	 OBJECT_WIDENING_SET(aux_13471, BFALSE);
      }
      return new1956_2644;
   }
}


/* _allocate-box-ref/cinfo */ obj_t 
_allocate_box_ref_cinfo_238_cfa_info(obj_t env_8048)
{
   {
      box_ref_242_t aux_13474;
      aux_13474 = allocate_box_ref_cinfo_31_cfa_info();
      return (obj_t) (aux_13474);
   }
}


/* box-ref/cinfo? */ bool_t 
box_ref_cinfo__23_cfa_info(obj_t obj_816)
{
   return is_a__118___object(obj_816, box_ref_cinfo_214_cfa_info);
}


/* _box-ref/cinfo? */ obj_t 
_box_ref_cinfo__65_cfa_info(obj_t env_9223, obj_t obj_9224)
{
   {
      bool_t aux_13478;
      aux_13478 = box_ref_cinfo__23_cfa_info(obj_9224);
      return BBOOL(aux_13478);
   }
}


/* widening1028-box-ref/cinfo */ box_ref_cinfo_214_t 
widening1028_box_ref_cinfo_34_cfa_info(approx_t approx_817)
{
   {
      box_ref_cinfo_214_t new1947_5321;
      new1947_5321 = ((box_ref_cinfo_214_t) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
      ((((box_ref_cinfo_214_t) CREF(new1947_5321))->approx) = ((approx_t) approx_817), BUNSPEC);
      return new1947_5321;
   }
}


/* _widening1028-box-ref/cinfo4168 */ obj_t 
_widening1028_box_ref_cinfo4168_108_cfa_info(obj_t env_9225, obj_t approx_9226)
{
   {
      box_ref_cinfo_214_t aux_13483;
      aux_13483 = widening1028_box_ref_cinfo_34_cfa_info((approx_t) (approx_9226));
      return (obj_t) (aux_13483);
   }
}


/* make-box-ref/cinfo */ box_ref_cinfo_214_t 
make_box_ref_cinfo_128_cfa_info(obj_t loc_818, type_t type_819, obj_t side_effect__165_820, obj_t key_821, var_t var_822, approx_t approx_823)
{
   {
      box_ref_242_t aux1950_5323;
      {
	 box_ref_242_t res3716_5341;
	 {
	    box_ref_242_t new1462_5332;
	    new1462_5332 = ((box_ref_242_t) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	    {
	       long arg2965_5333;
	       arg2965_5333 = class_num_218___object(box_ref_242_ast_node);
	       {
		  obj_t obj_5339;
		  obj_5339 = (obj_t) (new1462_5332);
		  (((obj_t) CREF(obj_5339))->header = MAKE_HEADER(arg2965_5333, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13491;
	       aux_13491 = (object_t) (new1462_5332);
	       OBJECT_WIDENING_SET(aux_13491, BFALSE);
	    }
	    ((((box_ref_242_t) CREF(new1462_5332))->loc) = ((obj_t) loc_818), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5332))->type) = ((type_t) type_819), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5332))->side_effect__165) = ((obj_t) side_effect__165_820), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5332))->key) = ((obj_t) key_821), BUNSPEC);
	    ((((box_ref_242_t) CREF(new1462_5332))->var) = ((var_t) var_822), BUNSPEC);
	    res3716_5341 = new1462_5332;
	 }
	 aux1950_5323 = res3716_5341;
      }
      {
	 box_ref_cinfo_214_t new1951_5324;
	 new1951_5324 = ((box_ref_cinfo_214_t) (aux1950_5323));
	 {
	    long arg2872_5325;
	    arg2872_5325 = class_num_218___object(box_ref_cinfo_214_cfa_info);
	    {
	       obj_t obj_5342;
	       obj_5342 = (obj_t) (new1951_5324);
	       (((obj_t) CREF(obj_5342))->header = MAKE_HEADER(arg2872_5325, 0), BUNSPEC);
	    }
	 }
	 {
	    box_ref_cinfo_214_t arg2873_5326;
	    {
	       box_ref_cinfo_214_t res3717_5347;
	       {
		  box_ref_cinfo_214_t new1947_5345;
		  new1947_5345 = ((box_ref_cinfo_214_t) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
		  ((((box_ref_cinfo_214_t) CREF(new1947_5345))->approx) = ((approx_t) approx_823), BUNSPEC);
		  res3717_5347 = new1947_5345;
	       }
	       arg2873_5326 = res3717_5347;
	    }
	    {
	       obj_t aux_13507;
	       object_t aux_13505;
	       aux_13507 = (obj_t) (arg2873_5326);
	       aux_13505 = (object_t) (new1951_5324);
	       OBJECT_WIDENING_SET(aux_13505, aux_13507);
	    }
	 }
	 return new1951_5324;
      }
   }
}


/* _make-box-ref/cinfo4169 */ obj_t 
_make_box_ref_cinfo4169_167_cfa_info(obj_t env_9227, obj_t loc_9228, obj_t type_9229, obj_t side_effect__165_9230, obj_t key_9231, obj_t var_9232, obj_t approx_9233)
{
   {
      box_ref_cinfo_214_t aux_13510;
      aux_13510 = make_box_ref_cinfo_128_cfa_info(loc_9228, (type_t) (type_9229), side_effect__165_9230, key_9231, (var_t) (var_9232), (approx_t) (approx_9233));
      return (obj_t) (aux_13510);
   }
}


/* box-ref/cinfo-loc */ obj_t 
box_ref_cinfo_loc_176_cfa_info(box_ref_242_t obj_824)
{
   return (((box_ref_242_t) CREF(obj_824))->loc);
}


/* _box-ref/cinfo-loc4170 */ obj_t 
_box_ref_cinfo_loc4170_99_cfa_info(obj_t env_9234, obj_t obj_9235)
{
   return box_ref_cinfo_loc_176_cfa_info((box_ref_242_t) (obj_9235));
}


/* box-ref/cinfo-type-set! */ obj_t 
box_ref_cinfo_type_set__65_cfa_info(box_ref_242_t obj_825, type_t val1952_826)
{
   return ((((box_ref_242_t) CREF(obj_825))->type) = ((type_t) val1952_826), BUNSPEC);
}


/* _box-ref/cinfo-type-set!4171 */ obj_t 
_box_ref_cinfo_type_set_4171_142_cfa_info(obj_t env_9236, obj_t obj_9237, obj_t val1952_9238)
{
   return box_ref_cinfo_type_set__65_cfa_info((box_ref_242_t) (obj_9237), (type_t) (val1952_9238));
}


/* box-ref/cinfo-type */ type_t 
box_ref_cinfo_type_23_cfa_info(box_ref_242_t obj_827)
{
   return (((box_ref_242_t) CREF(obj_827))->type);
}


/* _box-ref/cinfo-type4172 */ obj_t 
_box_ref_cinfo_type4172_28_cfa_info(obj_t env_9239, obj_t obj_9240)
{
   {
      type_t aux_13524;
      aux_13524 = box_ref_cinfo_type_23_cfa_info((box_ref_242_t) (obj_9240));
      return (obj_t) (aux_13524);
   }
}


/* box-ref/cinfo-side-effect?-set! */ obj_t 
box_ref_cinfo_side_effect__set__36_cfa_info(box_ref_242_t obj_828, obj_t val1953_829)
{
   return ((((box_ref_242_t) CREF(obj_828))->side_effect__165) = ((obj_t) val1953_829), BUNSPEC);
}


/* _box-ref/cinfo-side-effect?-set!4173 */ obj_t 
_box_ref_cinfo_side_effect__set_4173_191_cfa_info(obj_t env_9241, obj_t obj_9242, obj_t val1953_9243)
{
   return box_ref_cinfo_side_effect__set__36_cfa_info((box_ref_242_t) (obj_9242), val1953_9243);
}


/* box-ref/cinfo-side-effect? */ obj_t 
box_ref_cinfo_side_effect__63_cfa_info(box_ref_242_t obj_830)
{
   return (((box_ref_242_t) CREF(obj_830))->side_effect__165);
}


/* _box-ref/cinfo-side-effect?4174 */ obj_t 
_box_ref_cinfo_side_effect_4174_28_cfa_info(obj_t env_9244, obj_t obj_9245)
{
   return box_ref_cinfo_side_effect__63_cfa_info((box_ref_242_t) (obj_9245));
}


/* box-ref/cinfo-key-set! */ obj_t 
box_ref_cinfo_key_set__110_cfa_info(box_ref_242_t obj_831, obj_t val1954_832)
{
   return ((((box_ref_242_t) CREF(obj_831))->key) = ((obj_t) val1954_832), BUNSPEC);
}


/* _box-ref/cinfo-key-set! */ obj_t 
_box_ref_cinfo_key_set__118_cfa_info(obj_t env_9246, obj_t obj_9247, obj_t val1954_9248)
{
   return box_ref_cinfo_key_set__110_cfa_info((box_ref_242_t) (obj_9247), val1954_9248);
}


/* box-ref/cinfo-key */ obj_t 
box_ref_cinfo_key_199_cfa_info(box_ref_242_t obj_833)
{
   return (((box_ref_242_t) CREF(obj_833))->key);
}


/* _box-ref/cinfo-key */ obj_t 
_box_ref_cinfo_key_241_cfa_info(obj_t env_9249, obj_t obj_9250)
{
   return box_ref_cinfo_key_199_cfa_info((box_ref_242_t) (obj_9250));
}


/* box-ref/cinfo-var-set! */ obj_t 
box_ref_cinfo_var_set__56_cfa_info(box_ref_242_t obj_834, var_t val1955_835)
{
   return ((((box_ref_242_t) CREF(obj_834))->var) = ((var_t) val1955_835), BUNSPEC);
}


/* _box-ref/cinfo-var-set!4175 */ obj_t 
_box_ref_cinfo_var_set_4175_2_cfa_info(obj_t env_9251, obj_t obj_9252, obj_t val1955_9253)
{
   return box_ref_cinfo_var_set__56_cfa_info((box_ref_242_t) (obj_9252), (var_t) (val1955_9253));
}


/* box-ref/cinfo-var */ var_t 
box_ref_cinfo_var_121_cfa_info(box_ref_242_t obj_836)
{
   return (((box_ref_242_t) CREF(obj_836))->var);
}


/* _box-ref/cinfo-var4176 */ obj_t 
_box_ref_cinfo_var4176_172_cfa_info(obj_t env_9254, obj_t obj_9255)
{
   {
      var_t aux_13545;
      aux_13545 = box_ref_cinfo_var_121_cfa_info((box_ref_242_t) (obj_9255));
      return (obj_t) (aux_13545);
   }
}


/* box-ref/cinfo-approx */ approx_t 
box_ref_cinfo_approx_49_cfa_info(box_ref_cinfo_214_t obj_837)
{
   {
      obj_t aux_13549;
      {
	 object_t aux_13550;
	 aux_13550 = (object_t) (obj_837);
	 aux_13549 = OBJECT_WIDENING(aux_13550);
      }
      return (((box_ref_cinfo_214_t) CREF(aux_13549))->approx);
   }
}


/* _box-ref/cinfo-approx4177 */ obj_t 
_box_ref_cinfo_approx4177_0_cfa_info(obj_t env_9256, obj_t obj_9257)
{
   {
      approx_t aux_13554;
      aux_13554 = box_ref_cinfo_approx_49_cfa_info((box_ref_cinfo_214_t) (obj_9257));
      return (obj_t) (aux_13554);
   }
}


/* allocate-box-set!/cinfo */ box_set__221_t 
allocate_box_set__cinfo_232_cfa_info()
{
   {
      box_set__221_t new1940_2652;
      new1940_2652 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
      {
	 long arg2874_2653;
	 arg2874_2653 = class_num_218___object(box_set__cinfo_94_cfa_info);
	 {
	    obj_t obj_5348;
	    obj_5348 = (obj_t) (new1940_2652);
	    (((obj_t) CREF(obj_5348))->header = MAKE_HEADER(arg2874_2653, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13562;
	 aux_13562 = (object_t) (new1940_2652);
	 OBJECT_WIDENING_SET(aux_13562, BFALSE);
      }
      return new1940_2652;
   }
}


/* _allocate-box-set!/cinfo */ obj_t 
_allocate_box_set__cinfo_187_cfa_info(obj_t env_8047)
{
   {
      box_set__221_t aux_13565;
      aux_13565 = allocate_box_set__cinfo_232_cfa_info();
      return (obj_t) (aux_13565);
   }
}


/* box-set!/cinfo? */ bool_t 
box_set__cinfo__218_cfa_info(obj_t obj_841)
{
   return is_a__118___object(obj_841, box_set__cinfo_94_cfa_info);
}


/* _box-set!/cinfo? */ obj_t 
_box_set__cinfo__142_cfa_info(obj_t env_9258, obj_t obj_9259)
{
   {
      bool_t aux_13569;
      aux_13569 = box_set__cinfo__218_cfa_info(obj_9259);
      return BBOOL(aux_13569);
   }
}


/* widening1027-box-set!/cinfo */ box_set__cinfo_94_t 
widening1027_box_set__cinfo_228_cfa_info(approx_t approx_842)
{
   {
      box_set__cinfo_94_t new1932_5350;
      new1932_5350 = ((box_set__cinfo_94_t) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
      ((((box_set__cinfo_94_t) CREF(new1932_5350))->approx) = ((approx_t) approx_842), BUNSPEC);
      return new1932_5350;
   }
}


/* _widening1027-box-set!/cinfo4178 */ obj_t 
_widening1027_box_set__cinfo4178_94_cfa_info(obj_t env_9260, obj_t approx_9261)
{
   {
      box_set__cinfo_94_t aux_13574;
      aux_13574 = widening1027_box_set__cinfo_228_cfa_info((approx_t) (approx_9261));
      return (obj_t) (aux_13574);
   }
}


/* make-box-set!/cinfo */ box_set__cinfo_94_t 
make_box_set__cinfo_228_cfa_info(obj_t loc_843, type_t type_844, var_t var_845, node_t value_846, approx_t approx_847)
{
   {
      box_set__221_t aux1935_5352;
      {
	 box_set__221_t res3718_5368;
	 {
	    box_set__221_t new1474_5360;
	    new1474_5360 = ((box_set__221_t) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	    {
	       long arg2963_5361;
	       arg2963_5361 = class_num_218___object(box_set__221_ast_node);
	       {
		  obj_t obj_5366;
		  obj_5366 = (obj_t) (new1474_5360);
		  (((obj_t) CREF(obj_5366))->header = MAKE_HEADER(arg2963_5361, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13582;
	       aux_13582 = (object_t) (new1474_5360);
	       OBJECT_WIDENING_SET(aux_13582, BFALSE);
	    }
	    ((((box_set__221_t) CREF(new1474_5360))->loc) = ((obj_t) loc_843), BUNSPEC);
	    ((((box_set__221_t) CREF(new1474_5360))->type) = ((type_t) type_844), BUNSPEC);
	    ((((box_set__221_t) CREF(new1474_5360))->var) = ((var_t) var_845), BUNSPEC);
	    ((((box_set__221_t) CREF(new1474_5360))->value) = ((node_t) value_846), BUNSPEC);
	    res3718_5368 = new1474_5360;
	 }
	 aux1935_5352 = res3718_5368;
      }
      {
	 box_set__cinfo_94_t new1936_5353;
	 new1936_5353 = ((box_set__cinfo_94_t) (aux1935_5352));
	 {
	    long arg2875_5354;
	    arg2875_5354 = class_num_218___object(box_set__cinfo_94_cfa_info);
	    {
	       obj_t obj_5369;
	       obj_5369 = (obj_t) (new1936_5353);
	       (((obj_t) CREF(obj_5369))->header = MAKE_HEADER(arg2875_5354, 0), BUNSPEC);
	    }
	 }
	 {
	    box_set__cinfo_94_t arg2876_5355;
	    {
	       box_set__cinfo_94_t res3719_5374;
	       {
		  box_set__cinfo_94_t new1932_5372;
		  new1932_5372 = ((box_set__cinfo_94_t) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
		  ((((box_set__cinfo_94_t) CREF(new1932_5372))->approx) = ((approx_t) approx_847), BUNSPEC);
		  res3719_5374 = new1932_5372;
	       }
	       arg2876_5355 = res3719_5374;
	    }
	    {
	       obj_t aux_13597;
	       object_t aux_13595;
	       aux_13597 = (obj_t) (arg2876_5355);
	       aux_13595 = (object_t) (new1936_5353);
	       OBJECT_WIDENING_SET(aux_13595, aux_13597);
	    }
	 }
	 return new1936_5353;
      }
   }
}


/* _make-box-set!/cinfo4179 */ obj_t 
_make_box_set__cinfo4179_235_cfa_info(obj_t env_9262, obj_t loc_9263, obj_t type_9264, obj_t var_9265, obj_t value_9266, obj_t approx_9267)
{
   {
      box_set__cinfo_94_t aux_13600;
      aux_13600 = make_box_set__cinfo_228_cfa_info(loc_9263, (type_t) (type_9264), (var_t) (var_9265), (node_t) (value_9266), (approx_t) (approx_9267));
      return (obj_t) (aux_13600);
   }
}


/* box-set!/cinfo-loc */ obj_t 
box_set__cinfo_loc_149_cfa_info(box_set__221_t obj_848)
{
   return (((box_set__221_t) CREF(obj_848))->loc);
}


/* _box-set!/cinfo-loc4180 */ obj_t 
_box_set__cinfo_loc4180_133_cfa_info(obj_t env_9268, obj_t obj_9269)
{
   return box_set__cinfo_loc_149_cfa_info((box_set__221_t) (obj_9269));
}


/* box-set!/cinfo-type-set! */ obj_t 
box_set__cinfo_type_set__127_cfa_info(box_set__221_t obj_849, type_t val1937_850)
{
   return ((((box_set__221_t) CREF(obj_849))->type) = ((type_t) val1937_850), BUNSPEC);
}


/* _box-set!/cinfo-type-set!4181 */ obj_t 
_box_set__cinfo_type_set_4181_102_cfa_info(obj_t env_9270, obj_t obj_9271, obj_t val1937_9272)
{
   return box_set__cinfo_type_set__127_cfa_info((box_set__221_t) (obj_9271), (type_t) (val1937_9272));
}


/* box-set!/cinfo-type */ type_t 
box_set__cinfo_type_226_cfa_info(box_set__221_t obj_851)
{
   return (((box_set__221_t) CREF(obj_851))->type);
}


/* _box-set!/cinfo-type4182 */ obj_t 
_box_set__cinfo_type4182_217_cfa_info(obj_t env_9273, obj_t obj_9274)
{
   {
      type_t aux_13615;
      aux_13615 = box_set__cinfo_type_226_cfa_info((box_set__221_t) (obj_9274));
      return (obj_t) (aux_13615);
   }
}


/* box-set!/cinfo-var-set! */ obj_t 
box_set__cinfo_var_set__136_cfa_info(box_set__221_t obj_852, var_t val1938_853)
{
   return ((((box_set__221_t) CREF(obj_852))->var) = ((var_t) val1938_853), BUNSPEC);
}


/* _box-set!/cinfo-var-set!4183 */ obj_t 
_box_set__cinfo_var_set_4183_81_cfa_info(obj_t env_9275, obj_t obj_9276, obj_t val1938_9277)
{
   return box_set__cinfo_var_set__136_cfa_info((box_set__221_t) (obj_9276), (var_t) (val1938_9277));
}


/* box-set!/cinfo-var */ var_t 
box_set__cinfo_var_126_cfa_info(box_set__221_t obj_854)
{
   return (((box_set__221_t) CREF(obj_854))->var);
}


/* _box-set!/cinfo-var4184 */ obj_t 
_box_set__cinfo_var4184_170_cfa_info(obj_t env_9278, obj_t obj_9279)
{
   {
      var_t aux_13624;
      aux_13624 = box_set__cinfo_var_126_cfa_info((box_set__221_t) (obj_9279));
      return (obj_t) (aux_13624);
   }
}


/* box-set!/cinfo-value-set! */ obj_t 
box_set__cinfo_value_set__94_cfa_info(box_set__221_t obj_855, node_t val1939_856)
{
   return ((((box_set__221_t) CREF(obj_855))->value) = ((node_t) val1939_856), BUNSPEC);
}


/* _box-set!/cinfo-value-set!4185 */ obj_t 
_box_set__cinfo_value_set_4185_132_cfa_info(obj_t env_9280, obj_t obj_9281, obj_t val1939_9282)
{
   return box_set__cinfo_value_set__94_cfa_info((box_set__221_t) (obj_9281), (node_t) (val1939_9282));
}


/* box-set!/cinfo-value */ node_t 
box_set__cinfo_value_36_cfa_info(box_set__221_t obj_857)
{
   return (((box_set__221_t) CREF(obj_857))->value);
}


/* _box-set!/cinfo-value4186 */ obj_t 
_box_set__cinfo_value4186_7_cfa_info(obj_t env_9283, obj_t obj_9284)
{
   {
      node_t aux_13633;
      aux_13633 = box_set__cinfo_value_36_cfa_info((box_set__221_t) (obj_9284));
      return (obj_t) (aux_13633);
   }
}


/* box-set!/cinfo-approx */ approx_t 
box_set__cinfo_approx_234_cfa_info(box_set__cinfo_94_t obj_858)
{
   {
      obj_t aux_13637;
      {
	 object_t aux_13638;
	 aux_13638 = (object_t) (obj_858);
	 aux_13637 = OBJECT_WIDENING(aux_13638);
      }
      return (((box_set__cinfo_94_t) CREF(aux_13637))->approx);
   }
}


/* _box-set!/cinfo-approx4187 */ obj_t 
_box_set__cinfo_approx4187_33_cfa_info(obj_t env_9285, obj_t obj_9286)
{
   {
      approx_t aux_13642;
      aux_13642 = box_set__cinfo_approx_234_cfa_info((box_set__cinfo_94_t) (obj_9286));
      return (obj_t) (aux_13642);
   }
}


/* allocate-make-box/o-cinfo */ make_box_202_t 
allocate_make_box_o_cinfo_222_cfa_info()
{
   {
      make_box_202_t new1925_2660;
      new1925_2660 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
      {
	 long arg2877_2661;
	 arg2877_2661 = class_num_218___object(make_box_o_cinfo_96_cfa_info);
	 {
	    obj_t obj_5375;
	    obj_5375 = (obj_t) (new1925_2660);
	    (((obj_t) CREF(obj_5375))->header = MAKE_HEADER(arg2877_2661, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13650;
	 aux_13650 = (object_t) (new1925_2660);
	 OBJECT_WIDENING_SET(aux_13650, BFALSE);
      }
      return new1925_2660;
   }
}


/* _allocate-make-box/o-cinfo */ obj_t 
_allocate_make_box_o_cinfo_133_cfa_info(obj_t env_8046)
{
   {
      make_box_202_t aux_13653;
      aux_13653 = allocate_make_box_o_cinfo_222_cfa_info();
      return (obj_t) (aux_13653);
   }
}


/* make-box/o-cinfo? */ bool_t 
make_box_o_cinfo__221_cfa_info(obj_t obj_862)
{
   return is_a__118___object(obj_862, make_box_o_cinfo_96_cfa_info);
}


/* _make-box/o-cinfo? */ obj_t 
_make_box_o_cinfo__52_cfa_info(obj_t env_9287, obj_t obj_9288)
{
   {
      bool_t aux_13657;
      aux_13657 = make_box_o_cinfo__221_cfa_info(obj_9288);
      return BBOOL(aux_13657);
   }
}


/* widening1026-make-box/o-cinfo */ make_box_o_cinfo_96_t 
widening1026_make_box_o_cinfo_221_cfa_info(approx_t approx_863, approx_t value_approx_19_864)
{
   {
      make_box_o_cinfo_96_t new1914_5377;
      new1914_5377 = ((make_box_o_cinfo_96_t) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
      ((((make_box_o_cinfo_96_t) CREF(new1914_5377))->approx) = ((approx_t) approx_863), BUNSPEC);
      ((((make_box_o_cinfo_96_t) CREF(new1914_5377))->value_approx_19) = ((approx_t) value_approx_19_864), BUNSPEC);
      return new1914_5377;
   }
}


/* _widening1026-make-box/o-cinfo4188 */ obj_t 
_widening1026_make_box_o_cinfo4188_73_cfa_info(obj_t env_9289, obj_t approx_9290, obj_t value_approx_19_9291)
{
   {
      make_box_o_cinfo_96_t aux_13663;
      aux_13663 = widening1026_make_box_o_cinfo_221_cfa_info((approx_t) (approx_9290), (approx_t) (value_approx_19_9291));
      return (obj_t) (aux_13663);
   }
}


/* make-make-box/o-cinfo */ make_box_o_cinfo_96_t 
make_make_box_o_cinfo_242_cfa_info(obj_t loc_865, type_t type_866, obj_t side_effect__165_867, obj_t key_868, node_t value_869, approx_t approx_870, approx_t value_approx_19_871)
{
   {
      make_box_202_t aux1918_5380;
      {
	 make_box_202_t res3720_5398;
	 {
	    make_box_202_t new1450_5389;
	    new1450_5389 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	    {
	       long arg2967_5390;
	       arg2967_5390 = class_num_218___object(make_box_202_ast_node);
	       {
		  obj_t obj_5396;
		  obj_5396 = (obj_t) (new1450_5389);
		  (((obj_t) CREF(obj_5396))->header = MAKE_HEADER(arg2967_5390, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13672;
	       aux_13672 = (object_t) (new1450_5389);
	       OBJECT_WIDENING_SET(aux_13672, BFALSE);
	    }
	    ((((make_box_202_t) CREF(new1450_5389))->loc) = ((obj_t) loc_865), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5389))->type) = ((type_t) type_866), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5389))->side_effect__165) = ((obj_t) side_effect__165_867), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5389))->key) = ((obj_t) key_868), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5389))->value) = ((node_t) value_869), BUNSPEC);
	    res3720_5398 = new1450_5389;
	 }
	 aux1918_5380 = res3720_5398;
      }
      {
	 make_box_o_cinfo_96_t new1919_5381;
	 new1919_5381 = ((make_box_o_cinfo_96_t) (aux1918_5380));
	 {
	    long arg2878_5382;
	    arg2878_5382 = class_num_218___object(make_box_o_cinfo_96_cfa_info);
	    {
	       obj_t obj_5399;
	       obj_5399 = (obj_t) (new1919_5381);
	       (((obj_t) CREF(obj_5399))->header = MAKE_HEADER(arg2878_5382, 0), BUNSPEC);
	    }
	 }
	 {
	    make_box_o_cinfo_96_t arg2879_5383;
	    {
	       make_box_o_cinfo_96_t res3721_5406;
	       {
		  make_box_o_cinfo_96_t new1914_5403;
		  new1914_5403 = ((make_box_o_cinfo_96_t) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
		  ((((make_box_o_cinfo_96_t) CREF(new1914_5403))->approx) = ((approx_t) approx_870), BUNSPEC);
		  ((((make_box_o_cinfo_96_t) CREF(new1914_5403))->value_approx_19) = ((approx_t) value_approx_19_871), BUNSPEC);
		  res3721_5406 = new1914_5403;
	       }
	       arg2879_5383 = res3721_5406;
	    }
	    {
	       obj_t aux_13689;
	       object_t aux_13687;
	       aux_13689 = (obj_t) (arg2879_5383);
	       aux_13687 = (object_t) (new1919_5381);
	       OBJECT_WIDENING_SET(aux_13687, aux_13689);
	    }
	 }
	 return new1919_5381;
      }
   }
}


/* _make-make-box/o-cinfo4189 */ obj_t 
_make_make_box_o_cinfo4189_169_cfa_info(obj_t env_9292, obj_t loc_9293, obj_t type_9294, obj_t side_effect__165_9295, obj_t key_9296, obj_t value_9297, obj_t approx_9298, obj_t value_approx_19_9299)
{
   {
      make_box_o_cinfo_96_t aux_13692;
      aux_13692 = make_make_box_o_cinfo_242_cfa_info(loc_9293, (type_t) (type_9294), side_effect__165_9295, key_9296, (node_t) (value_9297), (approx_t) (approx_9298), (approx_t) (value_approx_19_9299));
      return (obj_t) (aux_13692);
   }
}


/* make-box/o-cinfo-loc */ obj_t 
make_box_o_cinfo_loc_160_cfa_info(make_box_202_t obj_872)
{
   return (((make_box_202_t) CREF(obj_872))->loc);
}


/* _make-box/o-cinfo-loc4190 */ obj_t 
_make_box_o_cinfo_loc4190_53_cfa_info(obj_t env_9300, obj_t obj_9301)
{
   return make_box_o_cinfo_loc_160_cfa_info((make_box_202_t) (obj_9301));
}


/* make-box/o-cinfo-type-set! */ obj_t 
make_box_o_cinfo_type_set__41_cfa_info(make_box_202_t obj_873, type_t val1920_874)
{
   return ((((make_box_202_t) CREF(obj_873))->type) = ((type_t) val1920_874), BUNSPEC);
}


/* _make-box/o-cinfo-type-set!4191 */ obj_t 
_make_box_o_cinfo_type_set_4191_204_cfa_info(obj_t env_9302, obj_t obj_9303, obj_t val1920_9304)
{
   return make_box_o_cinfo_type_set__41_cfa_info((make_box_202_t) (obj_9303), (type_t) (val1920_9304));
}


/* make-box/o-cinfo-type */ type_t 
make_box_o_cinfo_type_235_cfa_info(make_box_202_t obj_875)
{
   return (((make_box_202_t) CREF(obj_875))->type);
}


/* _make-box/o-cinfo-type4192 */ obj_t 
_make_box_o_cinfo_type4192_221_cfa_info(obj_t env_9305, obj_t obj_9306)
{
   {
      type_t aux_13707;
      aux_13707 = make_box_o_cinfo_type_235_cfa_info((make_box_202_t) (obj_9306));
      return (obj_t) (aux_13707);
   }
}


/* make-box/o-cinfo-side-effect?-set! */ obj_t 
make_box_o_cinfo_side_effect__set__221_cfa_info(make_box_202_t obj_876, obj_t val1921_877)
{
   return ((((make_box_202_t) CREF(obj_876))->side_effect__165) = ((obj_t) val1921_877), BUNSPEC);
}


/* _make-box/o-cinfo-side-effect?-set!4193 */ obj_t 
_make_box_o_cinfo_side_effect__set_4193_232_cfa_info(obj_t env_9307, obj_t obj_9308, obj_t val1921_9309)
{
   return make_box_o_cinfo_side_effect__set__221_cfa_info((make_box_202_t) (obj_9308), val1921_9309);
}


/* make-box/o-cinfo-side-effect? */ obj_t 
make_box_o_cinfo_side_effect__220_cfa_info(make_box_202_t obj_878)
{
   return (((make_box_202_t) CREF(obj_878))->side_effect__165);
}


/* _make-box/o-cinfo-side-effect?4194 */ obj_t 
_make_box_o_cinfo_side_effect_4194_224_cfa_info(obj_t env_9310, obj_t obj_9311)
{
   return make_box_o_cinfo_side_effect__220_cfa_info((make_box_202_t) (obj_9311));
}


/* make-box/o-cinfo-key-set! */ obj_t 
make_box_o_cinfo_key_set__68_cfa_info(make_box_202_t obj_879, obj_t val1922_880)
{
   return ((((make_box_202_t) CREF(obj_879))->key) = ((obj_t) val1922_880), BUNSPEC);
}


/* _make-box/o-cinfo-key-set! */ obj_t 
_make_box_o_cinfo_key_set__74_cfa_info(obj_t env_9312, obj_t obj_9313, obj_t val1922_9314)
{
   return make_box_o_cinfo_key_set__68_cfa_info((make_box_202_t) (obj_9313), val1922_9314);
}


/* make-box/o-cinfo-key */ obj_t 
make_box_o_cinfo_key_140_cfa_info(make_box_202_t obj_881)
{
   return (((make_box_202_t) CREF(obj_881))->key);
}


/* _make-box/o-cinfo-key4195 */ obj_t 
_make_box_o_cinfo_key4195_188_cfa_info(obj_t env_9315, obj_t obj_9316)
{
   return make_box_o_cinfo_key_140_cfa_info((make_box_202_t) (obj_9316));
}


/* make-box/o-cinfo-value-set! */ obj_t 
make_box_o_cinfo_value_set__222_cfa_info(make_box_202_t obj_882, node_t val1923_883)
{
   return ((((make_box_202_t) CREF(obj_882))->value) = ((node_t) val1923_883), BUNSPEC);
}


/* _make-box/o-cinfo-value-set!4196 */ obj_t 
_make_box_o_cinfo_value_set_4196_101_cfa_info(obj_t env_9317, obj_t obj_9318, obj_t val1923_9319)
{
   return make_box_o_cinfo_value_set__222_cfa_info((make_box_202_t) (obj_9318), (node_t) (val1923_9319));
}


/* make-box/o-cinfo-value */ node_t 
make_box_o_cinfo_value_153_cfa_info(make_box_202_t obj_884)
{
   return (((make_box_202_t) CREF(obj_884))->value);
}


/* _make-box/o-cinfo-value4197 */ obj_t 
_make_box_o_cinfo_value4197_165_cfa_info(obj_t env_9320, obj_t obj_9321)
{
   {
      node_t aux_13728;
      aux_13728 = make_box_o_cinfo_value_153_cfa_info((make_box_202_t) (obj_9321));
      return (obj_t) (aux_13728);
   }
}


/* make-box/o-cinfo-approx-set! */ obj_t 
make_box_o_cinfo_approx_set__53_cfa_info(make_box_o_cinfo_96_t obj_885, approx_t val1924_886)
{
   {
      obj_t aux_13732;
      {
	 object_t aux_13733;
	 aux_13733 = (object_t) (obj_885);
	 aux_13732 = OBJECT_WIDENING(aux_13733);
      }
      return ((((make_box_o_cinfo_96_t) CREF(aux_13732))->approx) = ((approx_t) val1924_886), BUNSPEC);
   }
}


/* _make-box/o-cinfo-approx-set!4198 */ obj_t 
_make_box_o_cinfo_approx_set_4198_214_cfa_info(obj_t env_9322, obj_t obj_9323, obj_t val1924_9324)
{
   return make_box_o_cinfo_approx_set__53_cfa_info((make_box_o_cinfo_96_t) (obj_9323), (approx_t) (val1924_9324));
}


/* make-box/o-cinfo-approx */ approx_t 
make_box_o_cinfo_approx_146_cfa_info(make_box_o_cinfo_96_t obj_887)
{
   {
      obj_t aux_13740;
      {
	 object_t aux_13741;
	 aux_13741 = (object_t) (obj_887);
	 aux_13740 = OBJECT_WIDENING(aux_13741);
      }
      return (((make_box_o_cinfo_96_t) CREF(aux_13740))->approx);
   }
}


/* _make-box/o-cinfo-approx4199 */ obj_t 
_make_box_o_cinfo_approx4199_31_cfa_info(obj_t env_9325, obj_t obj_9326)
{
   {
      approx_t aux_13745;
      aux_13745 = make_box_o_cinfo_approx_146_cfa_info((make_box_o_cinfo_96_t) (obj_9326));
      return (obj_t) (aux_13745);
   }
}


/* make-box/o-cinfo-value-approx */ approx_t 
make_box_o_cinfo_value_approx_169_cfa_info(make_box_o_cinfo_96_t obj_888)
{
   {
      obj_t aux_13749;
      {
	 object_t aux_13750;
	 aux_13750 = (object_t) (obj_888);
	 aux_13749 = OBJECT_WIDENING(aux_13750);
      }
      return (((make_box_o_cinfo_96_t) CREF(aux_13749))->value_approx_19);
   }
}


/* _make-box/o-cinfo-value-approx4200 */ obj_t 
_make_box_o_cinfo_value_approx4200_243_cfa_info(obj_t env_9327, obj_t obj_9328)
{
   {
      approx_t aux_13754;
      aux_13754 = make_box_o_cinfo_value_approx_169_cfa_info((make_box_o_cinfo_96_t) (obj_9328));
      return (obj_t) (aux_13754);
   }
}


/* allocate-make-box/cinfo */ make_box_202_t 
allocate_make_box_cinfo_213_cfa_info()
{
   {
      make_box_202_t new1907_2669;
      new1907_2669 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
      {
	 long arg2880_2670;
	 arg2880_2670 = class_num_218___object(make_box_cinfo_127_cfa_info);
	 {
	    obj_t obj_5407;
	    obj_5407 = (obj_t) (new1907_2669);
	    (((obj_t) CREF(obj_5407))->header = MAKE_HEADER(arg2880_2670, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13762;
	 aux_13762 = (object_t) (new1907_2669);
	 OBJECT_WIDENING_SET(aux_13762, BFALSE);
      }
      return new1907_2669;
   }
}


/* _allocate-make-box/cinfo */ obj_t 
_allocate_make_box_cinfo_36_cfa_info(obj_t env_8045)
{
   {
      make_box_202_t aux_13765;
      aux_13765 = allocate_make_box_cinfo_213_cfa_info();
      return (obj_t) (aux_13765);
   }
}


/* make-box/cinfo? */ bool_t 
make_box_cinfo__176_cfa_info(obj_t obj_892)
{
   return is_a__118___object(obj_892, make_box_cinfo_127_cfa_info);
}


/* _make-box/cinfo? */ obj_t 
_make_box_cinfo__189_cfa_info(obj_t env_9329, obj_t obj_9330)
{
   {
      bool_t aux_13769;
      aux_13769 = make_box_cinfo__176_cfa_info(obj_9330);
      return BBOOL(aux_13769);
   }
}


/* widening1025-make-box/cinfo */ make_box_cinfo_127_t 
widening1025_make_box_cinfo_175_cfa_info(approx_t approx_893)
{
   {
      make_box_cinfo_127_t new1898_5409;
      new1898_5409 = ((make_box_cinfo_127_t) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
      ((((make_box_cinfo_127_t) CREF(new1898_5409))->approx) = ((approx_t) approx_893), BUNSPEC);
      return new1898_5409;
   }
}


/* _widening1025-make-box/cinfo4201 */ obj_t 
_widening1025_make_box_cinfo4201_110_cfa_info(obj_t env_9331, obj_t approx_9332)
{
   {
      make_box_cinfo_127_t aux_13774;
      aux_13774 = widening1025_make_box_cinfo_175_cfa_info((approx_t) (approx_9332));
      return (obj_t) (aux_13774);
   }
}


/* make-make-box/cinfo */ make_box_cinfo_127_t 
make_make_box_cinfo_79_cfa_info(obj_t loc_894, type_t type_895, obj_t side_effect__165_896, obj_t key_897, node_t value_898, approx_t approx_899)
{
   {
      make_box_202_t aux1901_5411;
      {
	 make_box_202_t res3722_5429;
	 {
	    make_box_202_t new1450_5420;
	    new1450_5420 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	    {
	       long arg2967_5421;
	       arg2967_5421 = class_num_218___object(make_box_202_ast_node);
	       {
		  obj_t obj_5427;
		  obj_5427 = (obj_t) (new1450_5420);
		  (((obj_t) CREF(obj_5427))->header = MAKE_HEADER(arg2967_5421, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13782;
	       aux_13782 = (object_t) (new1450_5420);
	       OBJECT_WIDENING_SET(aux_13782, BFALSE);
	    }
	    ((((make_box_202_t) CREF(new1450_5420))->loc) = ((obj_t) loc_894), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5420))->type) = ((type_t) type_895), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5420))->side_effect__165) = ((obj_t) side_effect__165_896), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5420))->key) = ((obj_t) key_897), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5420))->value) = ((node_t) value_898), BUNSPEC);
	    res3722_5429 = new1450_5420;
	 }
	 aux1901_5411 = res3722_5429;
      }
      {
	 make_box_cinfo_127_t new1902_5412;
	 new1902_5412 = ((make_box_cinfo_127_t) (aux1901_5411));
	 {
	    long arg2882_5413;
	    arg2882_5413 = class_num_218___object(make_box_cinfo_127_cfa_info);
	    {
	       obj_t obj_5430;
	       obj_5430 = (obj_t) (new1902_5412);
	       (((obj_t) CREF(obj_5430))->header = MAKE_HEADER(arg2882_5413, 0), BUNSPEC);
	    }
	 }
	 {
	    make_box_cinfo_127_t arg2883_5414;
	    {
	       make_box_cinfo_127_t res3723_5435;
	       {
		  make_box_cinfo_127_t new1898_5433;
		  new1898_5433 = ((make_box_cinfo_127_t) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
		  ((((make_box_cinfo_127_t) CREF(new1898_5433))->approx) = ((approx_t) approx_899), BUNSPEC);
		  res3723_5435 = new1898_5433;
	       }
	       arg2883_5414 = res3723_5435;
	    }
	    {
	       obj_t aux_13798;
	       object_t aux_13796;
	       aux_13798 = (obj_t) (arg2883_5414);
	       aux_13796 = (object_t) (new1902_5412);
	       OBJECT_WIDENING_SET(aux_13796, aux_13798);
	    }
	 }
	 return new1902_5412;
      }
   }
}


/* _make-make-box/cinfo4202 */ obj_t 
_make_make_box_cinfo4202_207_cfa_info(obj_t env_9333, obj_t loc_9334, obj_t type_9335, obj_t side_effect__165_9336, obj_t key_9337, obj_t value_9338, obj_t approx_9339)
{
   {
      make_box_cinfo_127_t aux_13801;
      aux_13801 = make_make_box_cinfo_79_cfa_info(loc_9334, (type_t) (type_9335), side_effect__165_9336, key_9337, (node_t) (value_9338), (approx_t) (approx_9339));
      return (obj_t) (aux_13801);
   }
}


/* make-box/cinfo-loc */ obj_t 
make_box_cinfo_loc_173_cfa_info(make_box_202_t obj_900)
{
   return (((make_box_202_t) CREF(obj_900))->loc);
}


/* _make-box/cinfo-loc4203 */ obj_t 
_make_box_cinfo_loc4203_222_cfa_info(obj_t env_9340, obj_t obj_9341)
{
   return make_box_cinfo_loc_173_cfa_info((make_box_202_t) (obj_9341));
}


/* make-box/cinfo-type-set! */ obj_t 
make_box_cinfo_type_set__156_cfa_info(make_box_202_t obj_901, type_t val1903_902)
{
   return ((((make_box_202_t) CREF(obj_901))->type) = ((type_t) val1903_902), BUNSPEC);
}


/* _make-box/cinfo-type-set!4204 */ obj_t 
_make_box_cinfo_type_set_4204_72_cfa_info(obj_t env_9342, obj_t obj_9343, obj_t val1903_9344)
{
   return make_box_cinfo_type_set__156_cfa_info((make_box_202_t) (obj_9343), (type_t) (val1903_9344));
}


/* make-box/cinfo-type */ type_t 
make_box_cinfo_type_207_cfa_info(make_box_202_t obj_903)
{
   return (((make_box_202_t) CREF(obj_903))->type);
}


/* _make-box/cinfo-type4205 */ obj_t 
_make_box_cinfo_type4205_248_cfa_info(obj_t env_9345, obj_t obj_9346)
{
   {
      type_t aux_13815;
      aux_13815 = make_box_cinfo_type_207_cfa_info((make_box_202_t) (obj_9346));
      return (obj_t) (aux_13815);
   }
}


/* make-box/cinfo-side-effect?-set! */ obj_t 
make_box_cinfo_side_effect__set__59_cfa_info(make_box_202_t obj_904, obj_t val1904_905)
{
   return ((((make_box_202_t) CREF(obj_904))->side_effect__165) = ((obj_t) val1904_905), BUNSPEC);
}


/* _make-box/cinfo-side-effect?-set!4206 */ obj_t 
_make_box_cinfo_side_effect__set_4206_43_cfa_info(obj_t env_9347, obj_t obj_9348, obj_t val1904_9349)
{
   return make_box_cinfo_side_effect__set__59_cfa_info((make_box_202_t) (obj_9348), val1904_9349);
}


/* make-box/cinfo-side-effect? */ obj_t 
make_box_cinfo_side_effect__155_cfa_info(make_box_202_t obj_906)
{
   return (((make_box_202_t) CREF(obj_906))->side_effect__165);
}


/* _make-box/cinfo-side-effect?4207 */ obj_t 
_make_box_cinfo_side_effect_4207_157_cfa_info(obj_t env_9350, obj_t obj_9351)
{
   return make_box_cinfo_side_effect__155_cfa_info((make_box_202_t) (obj_9351));
}


/* make-box/cinfo-key-set! */ obj_t 
make_box_cinfo_key_set__72_cfa_info(make_box_202_t obj_907, obj_t val1905_908)
{
   return ((((make_box_202_t) CREF(obj_907))->key) = ((obj_t) val1905_908), BUNSPEC);
}


/* _make-box/cinfo-key-set! */ obj_t 
_make_box_cinfo_key_set__204_cfa_info(obj_t env_9352, obj_t obj_9353, obj_t val1905_9354)
{
   return make_box_cinfo_key_set__72_cfa_info((make_box_202_t) (obj_9353), val1905_9354);
}


/* make-box/cinfo-key */ obj_t 
make_box_cinfo_key_12_cfa_info(make_box_202_t obj_909)
{
   return (((make_box_202_t) CREF(obj_909))->key);
}


/* _make-box/cinfo-key */ obj_t 
_make_box_cinfo_key_44_cfa_info(obj_t env_9355, obj_t obj_9356)
{
   return make_box_cinfo_key_12_cfa_info((make_box_202_t) (obj_9356));
}


/* make-box/cinfo-value-set! */ obj_t 
make_box_cinfo_value_set__204_cfa_info(make_box_202_t obj_910, node_t val1906_911)
{
   return ((((make_box_202_t) CREF(obj_910))->value) = ((node_t) val1906_911), BUNSPEC);
}


/* _make-box/cinfo-value-set!4208 */ obj_t 
_make_box_cinfo_value_set_4208_18_cfa_info(obj_t env_9357, obj_t obj_9358, obj_t val1906_9359)
{
   return make_box_cinfo_value_set__204_cfa_info((make_box_202_t) (obj_9358), (node_t) (val1906_9359));
}


/* make-box/cinfo-value */ node_t 
make_box_cinfo_value_44_cfa_info(make_box_202_t obj_912)
{
   return (((make_box_202_t) CREF(obj_912))->value);
}


/* _make-box/cinfo-value4209 */ obj_t 
_make_box_cinfo_value4209_19_cfa_info(obj_t env_9360, obj_t obj_9361)
{
   {
      node_t aux_13836;
      aux_13836 = make_box_cinfo_value_44_cfa_info((make_box_202_t) (obj_9361));
      return (obj_t) (aux_13836);
   }
}


/* make-box/cinfo-approx */ approx_t 
make_box_cinfo_approx_244_cfa_info(make_box_cinfo_127_t obj_913)
{
   {
      obj_t aux_13840;
      {
	 object_t aux_13841;
	 aux_13841 = (object_t) (obj_913);
	 aux_13840 = OBJECT_WIDENING(aux_13841);
      }
      return (((make_box_cinfo_127_t) CREF(aux_13840))->approx);
   }
}


/* _make-box/cinfo-approx4210 */ obj_t 
_make_box_cinfo_approx4210_116_cfa_info(obj_t env_9362, obj_t obj_9363)
{
   {
      approx_t aux_13845;
      aux_13845 = make_box_cinfo_approx_244_cfa_info((make_box_cinfo_127_t) (obj_9363));
      return (obj_t) (aux_13845);
   }
}


/* allocate-pre-make-box */ make_box_202_t 
allocate_pre_make_box_175_cfa_info()
{
   {
      make_box_202_t new1891_2677;
      new1891_2677 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
      {
	 long arg2884_2678;
	 arg2884_2678 = class_num_218___object(pre_make_box_186_cfa_info);
	 {
	    obj_t obj_5436;
	    obj_5436 = (obj_t) (new1891_2677);
	    (((obj_t) CREF(obj_5436))->header = MAKE_HEADER(arg2884_2678, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13853;
	 aux_13853 = (object_t) (new1891_2677);
	 OBJECT_WIDENING_SET(aux_13853, BFALSE);
      }
      return new1891_2677;
   }
}


/* _allocate-pre-make-box */ obj_t 
_allocate_pre_make_box_48_cfa_info(obj_t env_8044)
{
   {
      make_box_202_t aux_13856;
      aux_13856 = allocate_pre_make_box_175_cfa_info();
      return (obj_t) (aux_13856);
   }
}


/* pre-make-box? */ bool_t 
pre_make_box__245_cfa_info(obj_t obj_917)
{
   return is_a__118___object(obj_917, pre_make_box_186_cfa_info);
}


/* _pre-make-box? */ obj_t 
_pre_make_box__20_cfa_info(obj_t env_9364, obj_t obj_9365)
{
   {
      bool_t aux_13860;
      aux_13860 = pre_make_box__245_cfa_info(obj_9365);
      return BBOOL(aux_13860);
   }
}


/* widening1024-pre-make-box */ pre_make_box_186_t 
widening1024_pre_make_box_161_cfa_info()
{
   {
      return ((pre_make_box_186_t) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
   }
}


/* _widening1024-pre-make-box */ obj_t 
_widening1024_pre_make_box_222_cfa_info(obj_t env_9366)
{
   {
      pre_make_box_186_t aux_13864;
      aux_13864 = widening1024_pre_make_box_161_cfa_info();
      return (obj_t) (aux_13864);
   }
}


/* make-pre-make-box */ pre_make_box_186_t 
make_pre_make_box_82_cfa_info(obj_t loc_918, type_t type_919, obj_t side_effect__165_920, obj_t key_921, node_t value_922)
{
   {
      make_box_202_t aux1885_5439;
      {
	 make_box_202_t res3724_5457;
	 {
	    make_box_202_t new1450_5448;
	    new1450_5448 = ((make_box_202_t) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	    {
	       long arg2967_5449;
	       arg2967_5449 = class_num_218___object(make_box_202_ast_node);
	       {
		  obj_t obj_5455;
		  obj_5455 = (obj_t) (new1450_5448);
		  (((obj_t) CREF(obj_5455))->header = MAKE_HEADER(arg2967_5449, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13871;
	       aux_13871 = (object_t) (new1450_5448);
	       OBJECT_WIDENING_SET(aux_13871, BFALSE);
	    }
	    ((((make_box_202_t) CREF(new1450_5448))->loc) = ((obj_t) loc_918), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5448))->type) = ((type_t) type_919), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5448))->side_effect__165) = ((obj_t) side_effect__165_920), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5448))->key) = ((obj_t) key_921), BUNSPEC);
	    ((((make_box_202_t) CREF(new1450_5448))->value) = ((node_t) value_922), BUNSPEC);
	    res3724_5457 = new1450_5448;
	 }
	 aux1885_5439 = res3724_5457;
      }
      {
	 pre_make_box_186_t new1886_5440;
	 new1886_5440 = ((pre_make_box_186_t) (aux1885_5439));
	 {
	    long arg2886_5441;
	    arg2886_5441 = class_num_218___object(pre_make_box_186_cfa_info);
	    {
	       obj_t obj_5458;
	       obj_5458 = (obj_t) (new1886_5440);
	       (((obj_t) CREF(obj_5458))->header = MAKE_HEADER(arg2886_5441, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_13885;
	    object_t aux_13883;
	    {
	       pre_make_box_186_t aux_13886;
	       {
		  aux_13886 = ((pre_make_box_186_t) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
	       }
	       aux_13885 = (obj_t) (aux_13886);
	    }
	    aux_13883 = (object_t) (new1886_5440);
	    OBJECT_WIDENING_SET(aux_13883, aux_13885);
	 }
	 return new1886_5440;
      }
   }
}


/* _make-pre-make-box4211 */ obj_t 
_make_pre_make_box4211_93_cfa_info(obj_t env_9367, obj_t loc_9368, obj_t type_9369, obj_t side_effect__165_9370, obj_t key_9371, obj_t value_9372)
{
   {
      pre_make_box_186_t aux_13890;
      aux_13890 = make_pre_make_box_82_cfa_info(loc_9368, (type_t) (type_9369), side_effect__165_9370, key_9371, (node_t) (value_9372));
      return (obj_t) (aux_13890);
   }
}


/* pre-make-box-loc */ obj_t 
pre_make_box_loc_183_cfa_info(make_box_202_t obj_923)
{
   return (((make_box_202_t) CREF(obj_923))->loc);
}


/* _pre-make-box-loc4212 */ obj_t 
_pre_make_box_loc4212_83_cfa_info(obj_t env_9373, obj_t obj_9374)
{
   return pre_make_box_loc_183_cfa_info((make_box_202_t) (obj_9374));
}


/* pre-make-box-type-set! */ obj_t 
pre_make_box_type_set__21_cfa_info(make_box_202_t obj_924, type_t val1887_925)
{
   return ((((make_box_202_t) CREF(obj_924))->type) = ((type_t) val1887_925), BUNSPEC);
}


/* _pre-make-box-type-set!4213 */ obj_t 
_pre_make_box_type_set_4213_178_cfa_info(obj_t env_9375, obj_t obj_9376, obj_t val1887_9377)
{
   return pre_make_box_type_set__21_cfa_info((make_box_202_t) (obj_9376), (type_t) (val1887_9377));
}


/* pre-make-box-type */ type_t 
pre_make_box_type_57_cfa_info(make_box_202_t obj_926)
{
   return (((make_box_202_t) CREF(obj_926))->type);
}


/* _pre-make-box-type4214 */ obj_t 
_pre_make_box_type4214_63_cfa_info(obj_t env_9378, obj_t obj_9379)
{
   {
      type_t aux_13903;
      aux_13903 = pre_make_box_type_57_cfa_info((make_box_202_t) (obj_9379));
      return (obj_t) (aux_13903);
   }
}


/* pre-make-box-side-effect?-set! */ obj_t 
pre_make_box_side_effect__set__136_cfa_info(make_box_202_t obj_927, obj_t val1888_928)
{
   return ((((make_box_202_t) CREF(obj_927))->side_effect__165) = ((obj_t) val1888_928), BUNSPEC);
}


/* _pre-make-box-side-effect?-set!4215 */ obj_t 
_pre_make_box_side_effect__set_4215_66_cfa_info(obj_t env_9380, obj_t obj_9381, obj_t val1888_9382)
{
   return pre_make_box_side_effect__set__136_cfa_info((make_box_202_t) (obj_9381), val1888_9382);
}


/* pre-make-box-side-effect? */ obj_t 
pre_make_box_side_effect__126_cfa_info(make_box_202_t obj_929)
{
   return (((make_box_202_t) CREF(obj_929))->side_effect__165);
}


/* _pre-make-box-side-effect?4216 */ obj_t 
_pre_make_box_side_effect_4216_75_cfa_info(obj_t env_9383, obj_t obj_9384)
{
   return pre_make_box_side_effect__126_cfa_info((make_box_202_t) (obj_9384));
}


/* pre-make-box-key-set! */ obj_t 
pre_make_box_key_set__46_cfa_info(make_box_202_t obj_930, obj_t val1889_931)
{
   return ((((make_box_202_t) CREF(obj_930))->key) = ((obj_t) val1889_931), BUNSPEC);
}


/* _pre-make-box-key-set!4217 */ obj_t 
_pre_make_box_key_set_4217_70_cfa_info(obj_t env_9385, obj_t obj_9386, obj_t val1889_9387)
{
   return pre_make_box_key_set__46_cfa_info((make_box_202_t) (obj_9386), val1889_9387);
}


/* pre-make-box-key */ obj_t 
pre_make_box_key_102_cfa_info(make_box_202_t obj_932)
{
   return (((make_box_202_t) CREF(obj_932))->key);
}


/* _pre-make-box-key4218 */ obj_t 
_pre_make_box_key4218_85_cfa_info(obj_t env_9388, obj_t obj_9389)
{
   return pre_make_box_key_102_cfa_info((make_box_202_t) (obj_9389));
}


/* pre-make-box-value-set! */ obj_t 
pre_make_box_value_set__57_cfa_info(make_box_202_t obj_933, node_t val1890_934)
{
   return ((((make_box_202_t) CREF(obj_933))->value) = ((node_t) val1890_934), BUNSPEC);
}


/* _pre-make-box-value-set!4219 */ obj_t 
_pre_make_box_value_set_4219_159_cfa_info(obj_t env_9390, obj_t obj_9391, obj_t val1890_9392)
{
   return pre_make_box_value_set__57_cfa_info((make_box_202_t) (obj_9391), (node_t) (val1890_9392));
}


/* pre-make-box-value */ node_t 
pre_make_box_value_157_cfa_info(make_box_202_t obj_935)
{
   return (((make_box_202_t) CREF(obj_935))->value);
}


/* _pre-make-box-value4220 */ obj_t 
_pre_make_box_value4220_113_cfa_info(obj_t env_9393, obj_t obj_9394)
{
   {
      node_t aux_13924;
      aux_13924 = pre_make_box_value_157_cfa_info((make_box_202_t) (obj_9394));
      return (obj_t) (aux_13924);
   }
}


/* allocate-jump-ex-it/cinfo */ jump_ex_it_184_t 
allocate_jump_ex_it_cinfo_167_cfa_info()
{
   {
      jump_ex_it_184_t new1876_2684;
      new1876_2684 = ((jump_ex_it_184_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
      {
	 long arg2889_2685;
	 arg2889_2685 = class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
	 {
	    obj_t obj_5462;
	    obj_5462 = (obj_t) (new1876_2684);
	    (((obj_t) CREF(obj_5462))->header = MAKE_HEADER(arg2889_2685, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_13932;
	 aux_13932 = (object_t) (new1876_2684);
	 OBJECT_WIDENING_SET(aux_13932, BFALSE);
      }
      return new1876_2684;
   }
}


/* _allocate-jump-ex-it/cinfo */ obj_t 
_allocate_jump_ex_it_cinfo_34_cfa_info(obj_t env_8043)
{
   {
      jump_ex_it_184_t aux_13935;
      aux_13935 = allocate_jump_ex_it_cinfo_167_cfa_info();
      return (obj_t) (aux_13935);
   }
}


/* jump-ex-it/cinfo? */ bool_t 
jump_ex_it_cinfo__199_cfa_info(obj_t obj_939)
{
   return is_a__118___object(obj_939, jump_ex_it_cinfo_139_cfa_info);
}


/* _jump-ex-it/cinfo? */ obj_t 
_jump_ex_it_cinfo__23_cfa_info(obj_t env_9395, obj_t obj_9396)
{
   {
      bool_t aux_13939;
      aux_13939 = jump_ex_it_cinfo__199_cfa_info(obj_9396);
      return BBOOL(aux_13939);
   }
}


/* widening1023-jump-ex-it/cinfo */ jump_ex_it_cinfo_139_t 
widening1023_jump_ex_it_cinfo_79_cfa_info(approx_t approx_940)
{
   {
      jump_ex_it_cinfo_139_t new1868_5464;
      new1868_5464 = ((jump_ex_it_cinfo_139_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
      ((((jump_ex_it_cinfo_139_t) CREF(new1868_5464))->approx) = ((approx_t) approx_940), BUNSPEC);
      return new1868_5464;
   }
}


/* _widening1023-jump-ex-it/cinfo4221 */ obj_t 
_widening1023_jump_ex_it_cinfo4221_44_cfa_info(obj_t env_9397, obj_t approx_9398)
{
   {
      jump_ex_it_cinfo_139_t aux_13944;
      aux_13944 = widening1023_jump_ex_it_cinfo_79_cfa_info((approx_t) (approx_9398));
      return (obj_t) (aux_13944);
   }
}


/* make-jump-ex-it/cinfo */ jump_ex_it_cinfo_139_t 
make_jump_ex_it_cinfo_16_cfa_info(obj_t loc_941, type_t type_942, node_t exit_943, node_t value_944, approx_t approx_945)
{
   {
      jump_ex_it_184_t aux1871_5466;
      {
	 jump_ex_it_184_t res3726_5482;
	 {
	    jump_ex_it_184_t new1440_5474;
	    new1440_5474 = ((jump_ex_it_184_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
	    {
	       long arg2969_5475;
	       arg2969_5475 = class_num_218___object(jump_ex_it_184_ast_node);
	       {
		  obj_t obj_5480;
		  obj_5480 = (obj_t) (new1440_5474);
		  (((obj_t) CREF(obj_5480))->header = MAKE_HEADER(arg2969_5475, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_13952;
	       aux_13952 = (object_t) (new1440_5474);
	       OBJECT_WIDENING_SET(aux_13952, BFALSE);
	    }
	    ((((jump_ex_it_184_t) CREF(new1440_5474))->loc) = ((obj_t) loc_941), BUNSPEC);
	    ((((jump_ex_it_184_t) CREF(new1440_5474))->type) = ((type_t) type_942), BUNSPEC);
	    ((((jump_ex_it_184_t) CREF(new1440_5474))->exit) = ((node_t) exit_943), BUNSPEC);
	    ((((jump_ex_it_184_t) CREF(new1440_5474))->value) = ((node_t) value_944), BUNSPEC);
	    res3726_5482 = new1440_5474;
	 }
	 aux1871_5466 = res3726_5482;
      }
      {
	 jump_ex_it_cinfo_139_t new1872_5467;
	 new1872_5467 = ((jump_ex_it_cinfo_139_t) (aux1871_5466));
	 {
	    long arg2890_5468;
	    arg2890_5468 = class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
	    {
	       obj_t obj_5483;
	       obj_5483 = (obj_t) (new1872_5467);
	       (((obj_t) CREF(obj_5483))->header = MAKE_HEADER(arg2890_5468, 0), BUNSPEC);
	    }
	 }
	 {
	    jump_ex_it_cinfo_139_t arg2891_5469;
	    {
	       jump_ex_it_cinfo_139_t res3727_5488;
	       {
		  jump_ex_it_cinfo_139_t new1868_5486;
		  new1868_5486 = ((jump_ex_it_cinfo_139_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
		  ((((jump_ex_it_cinfo_139_t) CREF(new1868_5486))->approx) = ((approx_t) approx_945), BUNSPEC);
		  res3727_5488 = new1868_5486;
	       }
	       arg2891_5469 = res3727_5488;
	    }
	    {
	       obj_t aux_13967;
	       object_t aux_13965;
	       aux_13967 = (obj_t) (arg2891_5469);
	       aux_13965 = (object_t) (new1872_5467);
	       OBJECT_WIDENING_SET(aux_13965, aux_13967);
	    }
	 }
	 return new1872_5467;
      }
   }
}


/* _make-jump-ex-it/cinfo4222 */ obj_t 
_make_jump_ex_it_cinfo4222_70_cfa_info(obj_t env_9399, obj_t loc_9400, obj_t type_9401, obj_t exit_9402, obj_t value_9403, obj_t approx_9404)
{
   {
      jump_ex_it_cinfo_139_t aux_13970;
      aux_13970 = make_jump_ex_it_cinfo_16_cfa_info(loc_9400, (type_t) (type_9401), (node_t) (exit_9402), (node_t) (value_9403), (approx_t) (approx_9404));
      return (obj_t) (aux_13970);
   }
}


/* jump-ex-it/cinfo-loc */ obj_t 
jump_ex_it_cinfo_loc_13_cfa_info(jump_ex_it_184_t obj_946)
{
   return (((jump_ex_it_184_t) CREF(obj_946))->loc);
}


/* _jump-ex-it/cinfo-loc4223 */ obj_t 
_jump_ex_it_cinfo_loc4223_55_cfa_info(obj_t env_9405, obj_t obj_9406)
{
   return jump_ex_it_cinfo_loc_13_cfa_info((jump_ex_it_184_t) (obj_9406));
}


/* jump-ex-it/cinfo-type-set! */ obj_t 
jump_ex_it_cinfo_type_set__231_cfa_info(jump_ex_it_184_t obj_947, type_t val1873_948)
{
   return ((((jump_ex_it_184_t) CREF(obj_947))->type) = ((type_t) val1873_948), BUNSPEC);
}


/* _jump-ex-it/cinfo-type-set!4224 */ obj_t 
_jump_ex_it_cinfo_type_set_4224_254_cfa_info(obj_t env_9407, obj_t obj_9408, obj_t val1873_9409)
{
   return jump_ex_it_cinfo_type_set__231_cfa_info((jump_ex_it_184_t) (obj_9408), (type_t) (val1873_9409));
}


/* jump-ex-it/cinfo-type */ type_t 
jump_ex_it_cinfo_type_129_cfa_info(jump_ex_it_184_t obj_949)
{
   return (((jump_ex_it_184_t) CREF(obj_949))->type);
}


/* _jump-ex-it/cinfo-type4225 */ obj_t 
_jump_ex_it_cinfo_type4225_115_cfa_info(obj_t env_9410, obj_t obj_9411)
{
   {
      type_t aux_13985;
      aux_13985 = jump_ex_it_cinfo_type_129_cfa_info((jump_ex_it_184_t) (obj_9411));
      return (obj_t) (aux_13985);
   }
}


/* jump-ex-it/cinfo-exit-set! */ obj_t 
jump_ex_it_cinfo_exit_set__81_cfa_info(jump_ex_it_184_t obj_950, node_t val1874_951)
{
   return ((((jump_ex_it_184_t) CREF(obj_950))->exit) = ((node_t) val1874_951), BUNSPEC);
}


/* _jump-ex-it/cinfo-exit-set!4226 */ obj_t 
_jump_ex_it_cinfo_exit_set_4226_196_cfa_info(obj_t env_9412, obj_t obj_9413, obj_t val1874_9414)
{
   return jump_ex_it_cinfo_exit_set__81_cfa_info((jump_ex_it_184_t) (obj_9413), (node_t) (val1874_9414));
}


/* jump-ex-it/cinfo-exit */ node_t 
jump_ex_it_cinfo_exit_67_cfa_info(jump_ex_it_184_t obj_952)
{
   return (((jump_ex_it_184_t) CREF(obj_952))->exit);
}


/* _jump-ex-it/cinfo-exit4227 */ obj_t 
_jump_ex_it_cinfo_exit4227_62_cfa_info(obj_t env_9415, obj_t obj_9416)
{
   {
      node_t aux_13994;
      aux_13994 = jump_ex_it_cinfo_exit_67_cfa_info((jump_ex_it_184_t) (obj_9416));
      return (obj_t) (aux_13994);
   }
}


/* jump-ex-it/cinfo-value-set! */ obj_t 
jump_ex_it_cinfo_value_set__150_cfa_info(jump_ex_it_184_t obj_953, node_t val1875_954)
{
   return ((((jump_ex_it_184_t) CREF(obj_953))->value) = ((node_t) val1875_954), BUNSPEC);
}


/* _jump-ex-it/cinfo-value-set!4228 */ obj_t 
_jump_ex_it_cinfo_value_set_4228_209_cfa_info(obj_t env_9417, obj_t obj_9418, obj_t val1875_9419)
{
   return jump_ex_it_cinfo_value_set__150_cfa_info((jump_ex_it_184_t) (obj_9418), (node_t) (val1875_9419));
}


/* jump-ex-it/cinfo-value */ node_t 
jump_ex_it_cinfo_value_33_cfa_info(jump_ex_it_184_t obj_955)
{
   return (((jump_ex_it_184_t) CREF(obj_955))->value);
}


/* _jump-ex-it/cinfo-value4229 */ obj_t 
_jump_ex_it_cinfo_value4229_147_cfa_info(obj_t env_9420, obj_t obj_9421)
{
   {
      node_t aux_14003;
      aux_14003 = jump_ex_it_cinfo_value_33_cfa_info((jump_ex_it_184_t) (obj_9421));
      return (obj_t) (aux_14003);
   }
}


/* jump-ex-it/cinfo-approx */ approx_t 
jump_ex_it_cinfo_approx_160_cfa_info(jump_ex_it_cinfo_139_t obj_956)
{
   {
      obj_t aux_14007;
      {
	 object_t aux_14008;
	 aux_14008 = (object_t) (obj_956);
	 aux_14007 = OBJECT_WIDENING(aux_14008);
      }
      return (((jump_ex_it_cinfo_139_t) CREF(aux_14007))->approx);
   }
}


/* _jump-ex-it/cinfo-approx4230 */ obj_t 
_jump_ex_it_cinfo_approx4230_117_cfa_info(obj_t env_9422, obj_t obj_9423)
{
   {
      approx_t aux_14012;
      aux_14012 = jump_ex_it_cinfo_approx_160_cfa_info((jump_ex_it_cinfo_139_t) (obj_9423));
      return (obj_t) (aux_14012);
   }
}


/* allocate-set-ex-it/cinfo */ set_ex_it_116_t 
allocate_set_ex_it_cinfo_32_cfa_info()
{
   {
      set_ex_it_116_t new1861_2692;
      new1861_2692 = ((set_ex_it_116_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
      {
	 long arg2892_2693;
	 arg2892_2693 = class_num_218___object(set_ex_it_cinfo_168_cfa_info);
	 {
	    obj_t obj_5489;
	    obj_5489 = (obj_t) (new1861_2692);
	    (((obj_t) CREF(obj_5489))->header = MAKE_HEADER(arg2892_2693, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14020;
	 aux_14020 = (object_t) (new1861_2692);
	 OBJECT_WIDENING_SET(aux_14020, BFALSE);
      }
      return new1861_2692;
   }
}


/* _allocate-set-ex-it/cinfo */ obj_t 
_allocate_set_ex_it_cinfo_22_cfa_info(obj_t env_8042)
{
   {
      set_ex_it_116_t aux_14023;
      aux_14023 = allocate_set_ex_it_cinfo_32_cfa_info();
      return (obj_t) (aux_14023);
   }
}


/* set-ex-it/cinfo? */ bool_t 
set_ex_it_cinfo__11_cfa_info(obj_t obj_960)
{
   return is_a__118___object(obj_960, set_ex_it_cinfo_168_cfa_info);
}


/* _set-ex-it/cinfo? */ obj_t 
_set_ex_it_cinfo__175_cfa_info(obj_t env_9424, obj_t obj_9425)
{
   {
      bool_t aux_14027;
      aux_14027 = set_ex_it_cinfo__11_cfa_info(obj_9425);
      return BBOOL(aux_14027);
   }
}


/* widening1022-set-ex-it/cinfo */ set_ex_it_cinfo_168_t 
widening1022_set_ex_it_cinfo_89_cfa_info(approx_t approx_961)
{
   {
      set_ex_it_cinfo_168_t new1853_5491;
      new1853_5491 = ((set_ex_it_cinfo_168_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
      ((((set_ex_it_cinfo_168_t) CREF(new1853_5491))->approx) = ((approx_t) approx_961), BUNSPEC);
      return new1853_5491;
   }
}


/* _widening1022-set-ex-it/cinfo4231 */ obj_t 
_widening1022_set_ex_it_cinfo4231_122_cfa_info(obj_t env_9426, obj_t approx_9427)
{
   {
      set_ex_it_cinfo_168_t aux_14032;
      aux_14032 = widening1022_set_ex_it_cinfo_89_cfa_info((approx_t) (approx_9427));
      return (obj_t) (aux_14032);
   }
}


/* make-set-ex-it/cinfo */ set_ex_it_cinfo_168_t 
make_set_ex_it_cinfo_156_cfa_info(obj_t loc_962, type_t type_963, var_t var_964, node_t body_965, approx_t approx_966)
{
   {
      set_ex_it_116_t aux1856_5493;
      {
	 set_ex_it_116_t res3728_5509;
	 {
	    set_ex_it_116_t new1430_5501;
	    new1430_5501 = ((set_ex_it_116_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
	    {
	       long arg2971_5502;
	       arg2971_5502 = class_num_218___object(set_ex_it_116_ast_node);
	       {
		  obj_t obj_5507;
		  obj_5507 = (obj_t) (new1430_5501);
		  (((obj_t) CREF(obj_5507))->header = MAKE_HEADER(arg2971_5502, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14040;
	       aux_14040 = (object_t) (new1430_5501);
	       OBJECT_WIDENING_SET(aux_14040, BFALSE);
	    }
	    ((((set_ex_it_116_t) CREF(new1430_5501))->loc) = ((obj_t) loc_962), BUNSPEC);
	    ((((set_ex_it_116_t) CREF(new1430_5501))->type) = ((type_t) type_963), BUNSPEC);
	    ((((set_ex_it_116_t) CREF(new1430_5501))->var) = ((var_t) var_964), BUNSPEC);
	    ((((set_ex_it_116_t) CREF(new1430_5501))->body) = ((node_t) body_965), BUNSPEC);
	    res3728_5509 = new1430_5501;
	 }
	 aux1856_5493 = res3728_5509;
      }
      {
	 set_ex_it_cinfo_168_t new1857_5494;
	 new1857_5494 = ((set_ex_it_cinfo_168_t) (aux1856_5493));
	 {
	    long arg2893_5495;
	    arg2893_5495 = class_num_218___object(set_ex_it_cinfo_168_cfa_info);
	    {
	       obj_t obj_5510;
	       obj_5510 = (obj_t) (new1857_5494);
	       (((obj_t) CREF(obj_5510))->header = MAKE_HEADER(arg2893_5495, 0), BUNSPEC);
	    }
	 }
	 {
	    set_ex_it_cinfo_168_t arg2894_5496;
	    {
	       set_ex_it_cinfo_168_t res3729_5515;
	       {
		  set_ex_it_cinfo_168_t new1853_5513;
		  new1853_5513 = ((set_ex_it_cinfo_168_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
		  ((((set_ex_it_cinfo_168_t) CREF(new1853_5513))->approx) = ((approx_t) approx_966), BUNSPEC);
		  res3729_5515 = new1853_5513;
	       }
	       arg2894_5496 = res3729_5515;
	    }
	    {
	       obj_t aux_14055;
	       object_t aux_14053;
	       aux_14055 = (obj_t) (arg2894_5496);
	       aux_14053 = (object_t) (new1857_5494);
	       OBJECT_WIDENING_SET(aux_14053, aux_14055);
	    }
	 }
	 return new1857_5494;
      }
   }
}


/* _make-set-ex-it/cinfo4232 */ obj_t 
_make_set_ex_it_cinfo4232_34_cfa_info(obj_t env_9428, obj_t loc_9429, obj_t type_9430, obj_t var_9431, obj_t body_9432, obj_t approx_9433)
{
   {
      set_ex_it_cinfo_168_t aux_14058;
      aux_14058 = make_set_ex_it_cinfo_156_cfa_info(loc_9429, (type_t) (type_9430), (var_t) (var_9431), (node_t) (body_9432), (approx_t) (approx_9433));
      return (obj_t) (aux_14058);
   }
}


/* set-ex-it/cinfo-loc */ obj_t 
set_ex_it_cinfo_loc_59_cfa_info(set_ex_it_116_t obj_967)
{
   return (((set_ex_it_116_t) CREF(obj_967))->loc);
}


/* _set-ex-it/cinfo-loc4233 */ obj_t 
_set_ex_it_cinfo_loc4233_210_cfa_info(obj_t env_9434, obj_t obj_9435)
{
   return set_ex_it_cinfo_loc_59_cfa_info((set_ex_it_116_t) (obj_9435));
}


/* set-ex-it/cinfo-type-set! */ obj_t 
set_ex_it_cinfo_type_set__35_cfa_info(set_ex_it_116_t obj_968, type_t val1858_969)
{
   return ((((set_ex_it_116_t) CREF(obj_968))->type) = ((type_t) val1858_969), BUNSPEC);
}


/* _set-ex-it/cinfo-type-set!4234 */ obj_t 
_set_ex_it_cinfo_type_set_4234_28_cfa_info(obj_t env_9436, obj_t obj_9437, obj_t val1858_9438)
{
   return set_ex_it_cinfo_type_set__35_cfa_info((set_ex_it_116_t) (obj_9437), (type_t) (val1858_9438));
}


/* set-ex-it/cinfo-type */ type_t 
set_ex_it_cinfo_type_68_cfa_info(set_ex_it_116_t obj_970)
{
   return (((set_ex_it_116_t) CREF(obj_970))->type);
}


/* _set-ex-it/cinfo-type4235 */ obj_t 
_set_ex_it_cinfo_type4235_175_cfa_info(obj_t env_9439, obj_t obj_9440)
{
   {
      type_t aux_14073;
      aux_14073 = set_ex_it_cinfo_type_68_cfa_info((set_ex_it_116_t) (obj_9440));
      return (obj_t) (aux_14073);
   }
}


/* set-ex-it/cinfo-var-set! */ obj_t 
set_ex_it_cinfo_var_set__245_cfa_info(set_ex_it_116_t obj_971, var_t val1859_972)
{
   return ((((set_ex_it_116_t) CREF(obj_971))->var) = ((var_t) val1859_972), BUNSPEC);
}


/* _set-ex-it/cinfo-var-set!4236 */ obj_t 
_set_ex_it_cinfo_var_set_4236_142_cfa_info(obj_t env_9441, obj_t obj_9442, obj_t val1859_9443)
{
   return set_ex_it_cinfo_var_set__245_cfa_info((set_ex_it_116_t) (obj_9442), (var_t) (val1859_9443));
}


/* set-ex-it/cinfo-var */ var_t 
set_ex_it_cinfo_var_14_cfa_info(set_ex_it_116_t obj_973)
{
   return (((set_ex_it_116_t) CREF(obj_973))->var);
}


/* _set-ex-it/cinfo-var4237 */ obj_t 
_set_ex_it_cinfo_var4237_21_cfa_info(obj_t env_9444, obj_t obj_9445)
{
   {
      var_t aux_14082;
      aux_14082 = set_ex_it_cinfo_var_14_cfa_info((set_ex_it_116_t) (obj_9445));
      return (obj_t) (aux_14082);
   }
}


/* set-ex-it/cinfo-body-set! */ obj_t 
set_ex_it_cinfo_body_set__25_cfa_info(set_ex_it_116_t obj_974, node_t val1860_975)
{
   return ((((set_ex_it_116_t) CREF(obj_974))->body) = ((node_t) val1860_975), BUNSPEC);
}


/* _set-ex-it/cinfo-body-set!4238 */ obj_t 
_set_ex_it_cinfo_body_set_4238_104_cfa_info(obj_t env_9446, obj_t obj_9447, obj_t val1860_9448)
{
   return set_ex_it_cinfo_body_set__25_cfa_info((set_ex_it_116_t) (obj_9447), (node_t) (val1860_9448));
}


/* set-ex-it/cinfo-body */ node_t 
set_ex_it_cinfo_body_103_cfa_info(set_ex_it_116_t obj_976)
{
   return (((set_ex_it_116_t) CREF(obj_976))->body);
}


/* _set-ex-it/cinfo-body4239 */ obj_t 
_set_ex_it_cinfo_body4239_6_cfa_info(obj_t env_9449, obj_t obj_9450)
{
   {
      node_t aux_14091;
      aux_14091 = set_ex_it_cinfo_body_103_cfa_info((set_ex_it_116_t) (obj_9450));
      return (obj_t) (aux_14091);
   }
}


/* set-ex-it/cinfo-approx */ approx_t 
set_ex_it_cinfo_approx_28_cfa_info(set_ex_it_cinfo_168_t obj_977)
{
   {
      obj_t aux_14095;
      {
	 object_t aux_14096;
	 aux_14096 = (object_t) (obj_977);
	 aux_14095 = OBJECT_WIDENING(aux_14096);
      }
      return (((set_ex_it_cinfo_168_t) CREF(aux_14095))->approx);
   }
}


/* _set-ex-it/cinfo-approx4240 */ obj_t 
_set_ex_it_cinfo_approx4240_95_cfa_info(obj_t env_9451, obj_t obj_9452)
{
   {
      approx_t aux_14100;
      aux_14100 = set_ex_it_cinfo_approx_28_cfa_info((set_ex_it_cinfo_168_t) (obj_9452));
      return (obj_t) (aux_14100);
   }
}


/* allocate-select/cinfo */ select_t 
allocate_select_cinfo_105_cfa_info()
{
   {
      select_t new1846_2700;
      new1846_2700 = ((select_t) BREF(GC_MALLOC(sizeof(struct select))));
      {
	 long arg2895_2701;
	 arg2895_2701 = class_num_218___object(select_cinfo_150_cfa_info);
	 {
	    obj_t obj_5516;
	    obj_5516 = (obj_t) (new1846_2700);
	    (((obj_t) CREF(obj_5516))->header = MAKE_HEADER(arg2895_2701, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14108;
	 aux_14108 = (object_t) (new1846_2700);
	 OBJECT_WIDENING_SET(aux_14108, BFALSE);
      }
      return new1846_2700;
   }
}


/* _allocate-select/cinfo */ obj_t 
_allocate_select_cinfo_74_cfa_info(obj_t env_8041)
{
   {
      select_t aux_14111;
      aux_14111 = allocate_select_cinfo_105_cfa_info();
      return (obj_t) (aux_14111);
   }
}


/* select/cinfo? */ bool_t 
select_cinfo__151_cfa_info(obj_t obj_981)
{
   return is_a__118___object(obj_981, select_cinfo_150_cfa_info);
}


/* _select/cinfo? */ obj_t 
_select_cinfo__186_cfa_info(obj_t env_9453, obj_t obj_9454)
{
   {
      bool_t aux_14115;
      aux_14115 = select_cinfo__151_cfa_info(obj_9454);
      return BBOOL(aux_14115);
   }
}


/* widening1021-select/cinfo */ select_cinfo_150_t 
widening1021_select_cinfo_60_cfa_info(approx_t approx_982)
{
   {
      select_cinfo_150_t new1837_5518;
      new1837_5518 = ((select_cinfo_150_t) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
      ((((select_cinfo_150_t) CREF(new1837_5518))->approx) = ((approx_t) approx_982), BUNSPEC);
      return new1837_5518;
   }
}


/* _widening1021-select/cinfo4241 */ obj_t 
_widening1021_select_cinfo4241_110_cfa_info(obj_t env_9455, obj_t approx_9456)
{
   {
      select_cinfo_150_t aux_14120;
      aux_14120 = widening1021_select_cinfo_60_cfa_info((approx_t) (approx_9456));
      return (obj_t) (aux_14120);
   }
}


/* make-select/cinfo */ select_cinfo_150_t 
make_select_cinfo_178_cfa_info(obj_t loc_983, type_t type_984, obj_t side_effect__165_985, obj_t key_986, node_t test_987, obj_t clauses_988, type_t item_type_130_989, approx_t approx_990)
{
   {
      select_t aux1840_5520;
      {
	 select_t res3730_5542;
	 {
	    select_t new1386_5531;
	    new1386_5531 = ((select_t) BREF(GC_MALLOC(sizeof(struct select))));
	    {
	       long arg2977_5532;
	       arg2977_5532 = class_num_218___object(select_ast_node);
	       {
		  obj_t obj_5540;
		  obj_5540 = (obj_t) (new1386_5531);
		  (((obj_t) CREF(obj_5540))->header = MAKE_HEADER(arg2977_5532, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14128;
	       aux_14128 = (object_t) (new1386_5531);
	       OBJECT_WIDENING_SET(aux_14128, BFALSE);
	    }
	    ((((select_t) CREF(new1386_5531))->loc) = ((obj_t) loc_983), BUNSPEC);
	    ((((select_t) CREF(new1386_5531))->type) = ((type_t) type_984), BUNSPEC);
	    ((((select_t) CREF(new1386_5531))->side_effect__165) = ((obj_t) side_effect__165_985), BUNSPEC);
	    ((((select_t) CREF(new1386_5531))->key) = ((obj_t) key_986), BUNSPEC);
	    ((((select_t) CREF(new1386_5531))->test) = ((node_t) test_987), BUNSPEC);
	    ((((select_t) CREF(new1386_5531))->clauses) = ((obj_t) clauses_988), BUNSPEC);
	    ((((select_t) CREF(new1386_5531))->item_type_130) = ((type_t) item_type_130_989), BUNSPEC);
	    res3730_5542 = new1386_5531;
	 }
	 aux1840_5520 = res3730_5542;
      }
      {
	 select_cinfo_150_t new1841_5521;
	 new1841_5521 = ((select_cinfo_150_t) (aux1840_5520));
	 {
	    long arg2896_5522;
	    arg2896_5522 = class_num_218___object(select_cinfo_150_cfa_info);
	    {
	       obj_t obj_5543;
	       obj_5543 = (obj_t) (new1841_5521);
	       (((obj_t) CREF(obj_5543))->header = MAKE_HEADER(arg2896_5522, 0), BUNSPEC);
	    }
	 }
	 {
	    select_cinfo_150_t arg2897_5523;
	    {
	       select_cinfo_150_t res3731_5548;
	       {
		  select_cinfo_150_t new1837_5546;
		  new1837_5546 = ((select_cinfo_150_t) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
		  ((((select_cinfo_150_t) CREF(new1837_5546))->approx) = ((approx_t) approx_990), BUNSPEC);
		  res3731_5548 = new1837_5546;
	       }
	       arg2897_5523 = res3731_5548;
	    }
	    {
	       obj_t aux_14146;
	       object_t aux_14144;
	       aux_14146 = (obj_t) (arg2897_5523);
	       aux_14144 = (object_t) (new1841_5521);
	       OBJECT_WIDENING_SET(aux_14144, aux_14146);
	    }
	 }
	 return new1841_5521;
      }
   }
}


/* _make-select/cinfo4242 */ obj_t 
_make_select_cinfo4242_184_cfa_info(obj_t env_9457, obj_t loc_9458, obj_t type_9459, obj_t side_effect__165_9460, obj_t key_9461, obj_t test_9462, obj_t clauses_9463, obj_t item_type_130_9464, obj_t approx_9465)
{
   {
      select_cinfo_150_t aux_14149;
      aux_14149 = make_select_cinfo_178_cfa_info(loc_9458, (type_t) (type_9459), side_effect__165_9460, key_9461, (node_t) (test_9462), clauses_9463, (type_t) (item_type_130_9464), (approx_t) (approx_9465));
      return (obj_t) (aux_14149);
   }
}


/* select/cinfo-loc */ obj_t 
select_cinfo_loc_246_cfa_info(select_t obj_991)
{
   return (((select_t) CREF(obj_991))->loc);
}


/* _select/cinfo-loc4243 */ obj_t 
_select_cinfo_loc4243_207_cfa_info(obj_t env_9466, obj_t obj_9467)
{
   return select_cinfo_loc_246_cfa_info((select_t) (obj_9467));
}


/* select/cinfo-type-set! */ obj_t 
select_cinfo_type_set__83_cfa_info(select_t obj_992, type_t val1842_993)
{
   return ((((select_t) CREF(obj_992))->type) = ((type_t) val1842_993), BUNSPEC);
}


/* _select/cinfo-type-set!4244 */ obj_t 
_select_cinfo_type_set_4244_74_cfa_info(obj_t env_9468, obj_t obj_9469, obj_t val1842_9470)
{
   return select_cinfo_type_set__83_cfa_info((select_t) (obj_9469), (type_t) (val1842_9470));
}


/* select/cinfo-type */ type_t 
select_cinfo_type_249_cfa_info(select_t obj_994)
{
   return (((select_t) CREF(obj_994))->type);
}


/* _select/cinfo-type4245 */ obj_t 
_select_cinfo_type4245_174_cfa_info(obj_t env_9471, obj_t obj_9472)
{
   {
      type_t aux_14164;
      aux_14164 = select_cinfo_type_249_cfa_info((select_t) (obj_9472));
      return (obj_t) (aux_14164);
   }
}


/* select/cinfo-side-effect?-set! */ obj_t 
select_cinfo_side_effect__set__150_cfa_info(select_t obj_995, obj_t val1843_996)
{
   return ((((select_t) CREF(obj_995))->side_effect__165) = ((obj_t) val1843_996), BUNSPEC);
}


/* _select/cinfo-side-effect?-set!4246 */ obj_t 
_select_cinfo_side_effect__set_4246_220_cfa_info(obj_t env_9473, obj_t obj_9474, obj_t val1843_9475)
{
   return select_cinfo_side_effect__set__150_cfa_info((select_t) (obj_9474), val1843_9475);
}


/* select/cinfo-side-effect? */ obj_t 
select_cinfo_side_effect__33_cfa_info(select_t obj_997)
{
   return (((select_t) CREF(obj_997))->side_effect__165);
}


/* _select/cinfo-side-effect?4247 */ obj_t 
_select_cinfo_side_effect_4247_86_cfa_info(obj_t env_9476, obj_t obj_9477)
{
   return select_cinfo_side_effect__33_cfa_info((select_t) (obj_9477));
}


/* select/cinfo-key-set! */ obj_t 
select_cinfo_key_set__126_cfa_info(select_t obj_998, obj_t val1844_999)
{
   return ((((select_t) CREF(obj_998))->key) = ((obj_t) val1844_999), BUNSPEC);
}


/* _select/cinfo-key-set! */ obj_t 
_select_cinfo_key_set__141_cfa_info(obj_t env_9478, obj_t obj_9479, obj_t val1844_9480)
{
   return select_cinfo_key_set__126_cfa_info((select_t) (obj_9479), val1844_9480);
}


/* select/cinfo-key */ obj_t 
select_cinfo_key_178_cfa_info(select_t obj_1000)
{
   return (((select_t) CREF(obj_1000))->key);
}


/* _select/cinfo-key */ obj_t 
_select_cinfo_key_1_cfa_info(obj_t env_9481, obj_t obj_9482)
{
   return select_cinfo_key_178_cfa_info((select_t) (obj_9482));
}


/* select/cinfo-test-set! */ obj_t 
select_cinfo_test_set__246_cfa_info(select_t obj_1001, node_t val1845_1002)
{
   return ((((select_t) CREF(obj_1001))->test) = ((node_t) val1845_1002), BUNSPEC);
}


/* _select/cinfo-test-set!4248 */ obj_t 
_select_cinfo_test_set_4248_179_cfa_info(obj_t env_9483, obj_t obj_9484, obj_t val1845_9485)
{
   return select_cinfo_test_set__246_cfa_info((select_t) (obj_9484), (node_t) (val1845_9485));
}


/* select/cinfo-test */ node_t 
select_cinfo_test_124_cfa_info(select_t obj_1003)
{
   return (((select_t) CREF(obj_1003))->test);
}


/* _select/cinfo-test4249 */ obj_t 
_select_cinfo_test4249_94_cfa_info(obj_t env_9486, obj_t obj_9487)
{
   {
      node_t aux_14185;
      aux_14185 = select_cinfo_test_124_cfa_info((select_t) (obj_9487));
      return (obj_t) (aux_14185);
   }
}


/* select/cinfo-clauses */ obj_t 
select_cinfo_clauses_111_cfa_info(select_t obj_1004)
{
   return (((select_t) CREF(obj_1004))->clauses);
}


/* _select/cinfo-clauses4250 */ obj_t 
_select_cinfo_clauses4250_19_cfa_info(obj_t env_9488, obj_t obj_9489)
{
   return select_cinfo_clauses_111_cfa_info((select_t) (obj_9489));
}


/* select/cinfo-item-type */ type_t 
select_cinfo_item_type_151_cfa_info(select_t obj_1005)
{
   return (((select_t) CREF(obj_1005))->item_type_130);
}


/* _select/cinfo-item-type4251 */ obj_t 
_select_cinfo_item_type4251_143_cfa_info(obj_t env_9490, obj_t obj_9491)
{
   {
      type_t aux_14193;
      aux_14193 = select_cinfo_item_type_151_cfa_info((select_t) (obj_9491));
      return (obj_t) (aux_14193);
   }
}


/* select/cinfo-approx */ approx_t 
select_cinfo_approx_174_cfa_info(select_cinfo_150_t obj_1006)
{
   {
      obj_t aux_14197;
      {
	 object_t aux_14198;
	 aux_14198 = (object_t) (obj_1006);
	 aux_14197 = OBJECT_WIDENING(aux_14198);
      }
      return (((select_cinfo_150_t) CREF(aux_14197))->approx);
   }
}


/* _select/cinfo-approx4252 */ obj_t 
_select_cinfo_approx4252_199_cfa_info(obj_t env_9492, obj_t obj_9493)
{
   {
      approx_t aux_14202;
      aux_14202 = select_cinfo_approx_174_cfa_info((select_cinfo_150_t) (obj_9493));
      return (obj_t) (aux_14202);
   }
}


/* allocate-fail/cinfo */ fail_t 
allocate_fail_cinfo_138_cfa_info()
{
   {
      fail_t new1830_2708;
      new1830_2708 = ((fail_t) BREF(GC_MALLOC(sizeof(struct fail))));
      {
	 long arg2898_2709;
	 arg2898_2709 = class_num_218___object(fail_cinfo_75_cfa_info);
	 {
	    obj_t obj_5549;
	    obj_5549 = (obj_t) (new1830_2708);
	    (((obj_t) CREF(obj_5549))->header = MAKE_HEADER(arg2898_2709, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14210;
	 aux_14210 = (object_t) (new1830_2708);
	 OBJECT_WIDENING_SET(aux_14210, BFALSE);
      }
      return new1830_2708;
   }
}


/* _allocate-fail/cinfo */ obj_t 
_allocate_fail_cinfo_247_cfa_info(obj_t env_8040)
{
   {
      fail_t aux_14213;
      aux_14213 = allocate_fail_cinfo_138_cfa_info();
      return (obj_t) (aux_14213);
   }
}


/* fail/cinfo? */ bool_t 
fail_cinfo__175_cfa_info(obj_t obj_1010)
{
   return is_a__118___object(obj_1010, fail_cinfo_75_cfa_info);
}


/* _fail/cinfo? */ obj_t 
_fail_cinfo__61_cfa_info(obj_t env_9494, obj_t obj_9495)
{
   {
      bool_t aux_14217;
      aux_14217 = fail_cinfo__175_cfa_info(obj_9495);
      return BBOOL(aux_14217);
   }
}


/* widening1020-fail/cinfo */ fail_cinfo_75_t 
widening1020_fail_cinfo_114_cfa_info(approx_t approx_1011)
{
   {
      fail_cinfo_75_t new1821_5551;
      new1821_5551 = ((fail_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
      ((((fail_cinfo_75_t) CREF(new1821_5551))->approx) = ((approx_t) approx_1011), BUNSPEC);
      return new1821_5551;
   }
}


/* _widening1020-fail/cinfo4253 */ obj_t 
_widening1020_fail_cinfo4253_123_cfa_info(obj_t env_9496, obj_t approx_9497)
{
   {
      fail_cinfo_75_t aux_14222;
      aux_14222 = widening1020_fail_cinfo_114_cfa_info((approx_t) (approx_9497));
      return (obj_t) (aux_14222);
   }
}


/* make-fail/cinfo */ fail_cinfo_75_t 
make_fail_cinfo_148_cfa_info(obj_t loc_1012, type_t type_1013, node_t proc_1014, node_t msg_1015, node_t obj_1016, approx_t approx_1017)
{
   {
      fail_t aux1824_5553;
      {
	 fail_t res3732_5571;
	 {
	    fail_t new1374_5562;
	    new1374_5562 = ((fail_t) BREF(GC_MALLOC(sizeof(struct fail))));
	    {
	       long arg2979_5563;
	       arg2979_5563 = class_num_218___object(fail_ast_node);
	       {
		  obj_t obj_5569;
		  obj_5569 = (obj_t) (new1374_5562);
		  (((obj_t) CREF(obj_5569))->header = MAKE_HEADER(arg2979_5563, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14230;
	       aux_14230 = (object_t) (new1374_5562);
	       OBJECT_WIDENING_SET(aux_14230, BFALSE);
	    }
	    ((((fail_t) CREF(new1374_5562))->loc) = ((obj_t) loc_1012), BUNSPEC);
	    ((((fail_t) CREF(new1374_5562))->type) = ((type_t) type_1013), BUNSPEC);
	    ((((fail_t) CREF(new1374_5562))->proc) = ((node_t) proc_1014), BUNSPEC);
	    ((((fail_t) CREF(new1374_5562))->msg) = ((node_t) msg_1015), BUNSPEC);
	    ((((fail_t) CREF(new1374_5562))->obj) = ((node_t) obj_1016), BUNSPEC);
	    res3732_5571 = new1374_5562;
	 }
	 aux1824_5553 = res3732_5571;
      }
      {
	 fail_cinfo_75_t new1825_5554;
	 new1825_5554 = ((fail_cinfo_75_t) (aux1824_5553));
	 {
	    long arg2899_5555;
	    arg2899_5555 = class_num_218___object(fail_cinfo_75_cfa_info);
	    {
	       obj_t obj_5572;
	       obj_5572 = (obj_t) (new1825_5554);
	       (((obj_t) CREF(obj_5572))->header = MAKE_HEADER(arg2899_5555, 0), BUNSPEC);
	    }
	 }
	 {
	    fail_cinfo_75_t arg2900_5556;
	    {
	       fail_cinfo_75_t res3733_5577;
	       {
		  fail_cinfo_75_t new1821_5575;
		  new1821_5575 = ((fail_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
		  ((((fail_cinfo_75_t) CREF(new1821_5575))->approx) = ((approx_t) approx_1017), BUNSPEC);
		  res3733_5577 = new1821_5575;
	       }
	       arg2900_5556 = res3733_5577;
	    }
	    {
	       obj_t aux_14246;
	       object_t aux_14244;
	       aux_14246 = (obj_t) (arg2900_5556);
	       aux_14244 = (object_t) (new1825_5554);
	       OBJECT_WIDENING_SET(aux_14244, aux_14246);
	    }
	 }
	 return new1825_5554;
      }
   }
}


/* _make-fail/cinfo4254 */ obj_t 
_make_fail_cinfo4254_145_cfa_info(obj_t env_9498, obj_t loc_9499, obj_t type_9500, obj_t proc_9501, obj_t msg_9502, obj_t obj_9503, obj_t approx_9504)
{
   {
      fail_cinfo_75_t aux_14249;
      aux_14249 = make_fail_cinfo_148_cfa_info(loc_9499, (type_t) (type_9500), (node_t) (proc_9501), (node_t) (msg_9502), (node_t) (obj_9503), (approx_t) (approx_9504));
      return (obj_t) (aux_14249);
   }
}


/* fail/cinfo-loc */ obj_t 
fail_cinfo_loc_64_cfa_info(fail_t obj_1018)
{
   return (((fail_t) CREF(obj_1018))->loc);
}


/* _fail/cinfo-loc4255 */ obj_t 
_fail_cinfo_loc4255_82_cfa_info(obj_t env_9505, obj_t obj_9506)
{
   return fail_cinfo_loc_64_cfa_info((fail_t) (obj_9506));
}


/* fail/cinfo-type-set! */ obj_t 
fail_cinfo_type_set__85_cfa_info(fail_t obj_1019, type_t val1826_1020)
{
   return ((((fail_t) CREF(obj_1019))->type) = ((type_t) val1826_1020), BUNSPEC);
}


/* _fail/cinfo-type-set!4256 */ obj_t 
_fail_cinfo_type_set_4256_100_cfa_info(obj_t env_9507, obj_t obj_9508, obj_t val1826_9509)
{
   return fail_cinfo_type_set__85_cfa_info((fail_t) (obj_9508), (type_t) (val1826_9509));
}


/* fail/cinfo-type */ type_t 
fail_cinfo_type_26_cfa_info(fail_t obj_1021)
{
   return (((fail_t) CREF(obj_1021))->type);
}


/* _fail/cinfo-type4257 */ obj_t 
_fail_cinfo_type4257_58_cfa_info(obj_t env_9510, obj_t obj_9511)
{
   {
      type_t aux_14265;
      aux_14265 = fail_cinfo_type_26_cfa_info((fail_t) (obj_9511));
      return (obj_t) (aux_14265);
   }
}


/* fail/cinfo-proc-set! */ obj_t 
fail_cinfo_proc_set__66_cfa_info(fail_t obj_1022, node_t val1827_1023)
{
   return ((((fail_t) CREF(obj_1022))->proc) = ((node_t) val1827_1023), BUNSPEC);
}


/* _fail/cinfo-proc-set!4258 */ obj_t 
_fail_cinfo_proc_set_4258_166_cfa_info(obj_t env_9512, obj_t obj_9513, obj_t val1827_9514)
{
   return fail_cinfo_proc_set__66_cfa_info((fail_t) (obj_9513), (node_t) (val1827_9514));
}


/* fail/cinfo-proc */ node_t 
fail_cinfo_proc_58_cfa_info(fail_t obj_1024)
{
   return (((fail_t) CREF(obj_1024))->proc);
}


/* _fail/cinfo-proc4259 */ obj_t 
_fail_cinfo_proc4259_227_cfa_info(obj_t env_9515, obj_t obj_9516)
{
   {
      node_t aux_14274;
      aux_14274 = fail_cinfo_proc_58_cfa_info((fail_t) (obj_9516));
      return (obj_t) (aux_14274);
   }
}


/* fail/cinfo-msg-set! */ obj_t 
fail_cinfo_msg_set__145_cfa_info(fail_t obj_1025, node_t val1828_1026)
{
   return ((((fail_t) CREF(obj_1025))->msg) = ((node_t) val1828_1026), BUNSPEC);
}


/* _fail/cinfo-msg-set!4260 */ obj_t 
_fail_cinfo_msg_set_4260_104_cfa_info(obj_t env_9517, obj_t obj_9518, obj_t val1828_9519)
{
   return fail_cinfo_msg_set__145_cfa_info((fail_t) (obj_9518), (node_t) (val1828_9519));
}


/* fail/cinfo-msg */ node_t 
fail_cinfo_msg_186_cfa_info(fail_t obj_1027)
{
   return (((fail_t) CREF(obj_1027))->msg);
}


/* _fail/cinfo-msg4261 */ obj_t 
_fail_cinfo_msg4261_30_cfa_info(obj_t env_9520, obj_t obj_9521)
{
   {
      node_t aux_14283;
      aux_14283 = fail_cinfo_msg_186_cfa_info((fail_t) (obj_9521));
      return (obj_t) (aux_14283);
   }
}


/* fail/cinfo-obj-set! */ obj_t 
fail_cinfo_obj_set__135_cfa_info(fail_t obj_1028, node_t val1829_1029)
{
   return ((((fail_t) CREF(obj_1028))->obj) = ((node_t) val1829_1029), BUNSPEC);
}


/* _fail/cinfo-obj-set!4262 */ obj_t 
_fail_cinfo_obj_set_4262_243_cfa_info(obj_t env_9522, obj_t obj_9523, obj_t val1829_9524)
{
   return fail_cinfo_obj_set__135_cfa_info((fail_t) (obj_9523), (node_t) (val1829_9524));
}


/* fail/cinfo-obj */ node_t 
fail_cinfo_obj_134_cfa_info(fail_t obj_1030)
{
   return (((fail_t) CREF(obj_1030))->obj);
}


/* _fail/cinfo-obj4263 */ obj_t 
_fail_cinfo_obj4263_218_cfa_info(obj_t env_9525, obj_t obj_9526)
{
   {
      node_t aux_14292;
      aux_14292 = fail_cinfo_obj_134_cfa_info((fail_t) (obj_9526));
      return (obj_t) (aux_14292);
   }
}


/* fail/cinfo-approx */ approx_t 
fail_cinfo_approx_11_cfa_info(fail_cinfo_75_t obj_1031)
{
   {
      obj_t aux_14296;
      {
	 object_t aux_14297;
	 aux_14297 = (object_t) (obj_1031);
	 aux_14296 = OBJECT_WIDENING(aux_14297);
      }
      return (((fail_cinfo_75_t) CREF(aux_14296))->approx);
   }
}


/* _fail/cinfo-approx4264 */ obj_t 
_fail_cinfo_approx4264_42_cfa_info(obj_t env_9527, obj_t obj_9528)
{
   {
      approx_t aux_14301;
      aux_14301 = fail_cinfo_approx_11_cfa_info((fail_cinfo_75_t) (obj_9528));
      return (obj_t) (aux_14301);
   }
}


/* allocate-conditional/cinfo */ conditional_t 
allocate_conditional_cinfo_71_cfa_info()
{
   {
      conditional_t new1814_2716;
      new1814_2716 = ((conditional_t) BREF(GC_MALLOC(sizeof(struct conditional))));
      {
	 long arg2901_2717;
	 arg2901_2717 = class_num_218___object(conditional_cinfo_212_cfa_info);
	 {
	    obj_t obj_5578;
	    obj_5578 = (obj_t) (new1814_2716);
	    (((obj_t) CREF(obj_5578))->header = MAKE_HEADER(arg2901_2717, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14309;
	 aux_14309 = (object_t) (new1814_2716);
	 OBJECT_WIDENING_SET(aux_14309, BFALSE);
      }
      return new1814_2716;
   }
}


/* _allocate-conditional/cinfo */ obj_t 
_allocate_conditional_cinfo_139_cfa_info(obj_t env_8039)
{
   {
      conditional_t aux_14312;
      aux_14312 = allocate_conditional_cinfo_71_cfa_info();
      return (obj_t) (aux_14312);
   }
}


/* conditional/cinfo? */ bool_t 
conditional_cinfo__69_cfa_info(obj_t obj_1035)
{
   return is_a__118___object(obj_1035, conditional_cinfo_212_cfa_info);
}


/* _conditional/cinfo? */ obj_t 
_conditional_cinfo__117_cfa_info(obj_t env_9529, obj_t obj_9530)
{
   {
      bool_t aux_14316;
      aux_14316 = conditional_cinfo__69_cfa_info(obj_9530);
      return BBOOL(aux_14316);
   }
}


/* widening1019-conditional/cinfo */ conditional_cinfo_212_t 
widening1019_conditional_cinfo_187_cfa_info(approx_t approx_1036)
{
   {
      conditional_cinfo_212_t new1803_5580;
      new1803_5580 = ((conditional_cinfo_212_t) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
      ((((conditional_cinfo_212_t) CREF(new1803_5580))->approx) = ((approx_t) approx_1036), BUNSPEC);
      return new1803_5580;
   }
}


/* _widening1019-conditional/cinfo4265 */ obj_t 
_widening1019_conditional_cinfo4265_21_cfa_info(obj_t env_9531, obj_t approx_9532)
{
   {
      conditional_cinfo_212_t aux_14321;
      aux_14321 = widening1019_conditional_cinfo_187_cfa_info((approx_t) (approx_9532));
      return (obj_t) (aux_14321);
   }
}


/* make-conditional/cinfo */ conditional_cinfo_212_t 
make_conditional_cinfo_187_cfa_info(obj_t loc_1037, type_t type_1038, obj_t side_effect__165_1039, obj_t key_1040, node_t test_1041, node_t true_1042, node_t false_1043, approx_t approx_1044)
{
   {
      conditional_t aux1806_5582;
      {
	 conditional_t res3734_5604;
	 {
	    conditional_t new1358_5593;
	    new1358_5593 = ((conditional_t) BREF(GC_MALLOC(sizeof(struct conditional))));
	    {
	       long arg2981_5594;
	       arg2981_5594 = class_num_218___object(conditional_ast_node);
	       {
		  obj_t obj_5602;
		  obj_5602 = (obj_t) (new1358_5593);
		  (((obj_t) CREF(obj_5602))->header = MAKE_HEADER(arg2981_5594, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14329;
	       aux_14329 = (object_t) (new1358_5593);
	       OBJECT_WIDENING_SET(aux_14329, BFALSE);
	    }
	    ((((conditional_t) CREF(new1358_5593))->loc) = ((obj_t) loc_1037), BUNSPEC);
	    ((((conditional_t) CREF(new1358_5593))->type) = ((type_t) type_1038), BUNSPEC);
	    ((((conditional_t) CREF(new1358_5593))->side_effect__165) = ((obj_t) side_effect__165_1039), BUNSPEC);
	    ((((conditional_t) CREF(new1358_5593))->key) = ((obj_t) key_1040), BUNSPEC);
	    ((((conditional_t) CREF(new1358_5593))->test) = ((node_t) test_1041), BUNSPEC);
	    ((((conditional_t) CREF(new1358_5593))->true) = ((node_t) true_1042), BUNSPEC);
	    ((((conditional_t) CREF(new1358_5593))->false) = ((node_t) false_1043), BUNSPEC);
	    res3734_5604 = new1358_5593;
	 }
	 aux1806_5582 = res3734_5604;
      }
      {
	 conditional_cinfo_212_t new1807_5583;
	 new1807_5583 = ((conditional_cinfo_212_t) (aux1806_5582));
	 {
	    long arg2902_5584;
	    arg2902_5584 = class_num_218___object(conditional_cinfo_212_cfa_info);
	    {
	       obj_t obj_5605;
	       obj_5605 = (obj_t) (new1807_5583);
	       (((obj_t) CREF(obj_5605))->header = MAKE_HEADER(arg2902_5584, 0), BUNSPEC);
	    }
	 }
	 {
	    conditional_cinfo_212_t arg2903_5585;
	    {
	       conditional_cinfo_212_t res3735_5610;
	       {
		  conditional_cinfo_212_t new1803_5608;
		  new1803_5608 = ((conditional_cinfo_212_t) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
		  ((((conditional_cinfo_212_t) CREF(new1803_5608))->approx) = ((approx_t) approx_1044), BUNSPEC);
		  res3735_5610 = new1803_5608;
	       }
	       arg2903_5585 = res3735_5610;
	    }
	    {
	       obj_t aux_14347;
	       object_t aux_14345;
	       aux_14347 = (obj_t) (arg2903_5585);
	       aux_14345 = (object_t) (new1807_5583);
	       OBJECT_WIDENING_SET(aux_14345, aux_14347);
	    }
	 }
	 return new1807_5583;
      }
   }
}


/* _make-conditional/cinfo4266 */ obj_t 
_make_conditional_cinfo4266_140_cfa_info(obj_t env_9533, obj_t loc_9534, obj_t type_9535, obj_t side_effect__165_9536, obj_t key_9537, obj_t test_9538, obj_t true_9539, obj_t false_9540, obj_t approx_9541)
{
   {
      conditional_cinfo_212_t aux_14350;
      aux_14350 = make_conditional_cinfo_187_cfa_info(loc_9534, (type_t) (type_9535), side_effect__165_9536, key_9537, (node_t) (test_9538), (node_t) (true_9539), (node_t) (false_9540), (approx_t) (approx_9541));
      return (obj_t) (aux_14350);
   }
}


/* conditional/cinfo-loc */ obj_t 
conditional_cinfo_loc_197_cfa_info(conditional_t obj_1045)
{
   return (((conditional_t) CREF(obj_1045))->loc);
}


/* _conditional/cinfo-loc4267 */ obj_t 
_conditional_cinfo_loc4267_89_cfa_info(obj_t env_9542, obj_t obj_9543)
{
   return conditional_cinfo_loc_197_cfa_info((conditional_t) (obj_9543));
}


/* conditional/cinfo-type-set! */ obj_t 
conditional_cinfo_type_set__218_cfa_info(conditional_t obj_1046, type_t val1808_1047)
{
   return ((((conditional_t) CREF(obj_1046))->type) = ((type_t) val1808_1047), BUNSPEC);
}


/* _conditional/cinfo-type-set!4268 */ obj_t 
_conditional_cinfo_type_set_4268_201_cfa_info(obj_t env_9544, obj_t obj_9545, obj_t val1808_9546)
{
   return conditional_cinfo_type_set__218_cfa_info((conditional_t) (obj_9545), (type_t) (val1808_9546));
}


/* conditional/cinfo-type */ type_t 
conditional_cinfo_type_74_cfa_info(conditional_t obj_1048)
{
   return (((conditional_t) CREF(obj_1048))->type);
}


/* _conditional/cinfo-type4269 */ obj_t 
_conditional_cinfo_type4269_211_cfa_info(obj_t env_9547, obj_t obj_9548)
{
   {
      type_t aux_14366;
      aux_14366 = conditional_cinfo_type_74_cfa_info((conditional_t) (obj_9548));
      return (obj_t) (aux_14366);
   }
}


/* conditional/cinfo-side-effect?-set! */ obj_t 
conditional_cinfo_side_effect__set__214_cfa_info(conditional_t obj_1049, obj_t val1809_1050)
{
   return ((((conditional_t) CREF(obj_1049))->side_effect__165) = ((obj_t) val1809_1050), BUNSPEC);
}


/* _conditional/cinfo-side-effect?-set!4270 */ obj_t 
_conditional_cinfo_side_effect__set_4270_90_cfa_info(obj_t env_9549, obj_t obj_9550, obj_t val1809_9551)
{
   return conditional_cinfo_side_effect__set__214_cfa_info((conditional_t) (obj_9550), val1809_9551);
}


/* conditional/cinfo-side-effect? */ obj_t 
conditional_cinfo_side_effect__139_cfa_info(conditional_t obj_1051)
{
   return (((conditional_t) CREF(obj_1051))->side_effect__165);
}


/* _conditional/cinfo-side-effect?4271 */ obj_t 
_conditional_cinfo_side_effect_4271_3_cfa_info(obj_t env_9552, obj_t obj_9553)
{
   return conditional_cinfo_side_effect__139_cfa_info((conditional_t) (obj_9553));
}


/* conditional/cinfo-key-set! */ obj_t 
conditional_cinfo_key_set__171_cfa_info(conditional_t obj_1052, obj_t val1810_1053)
{
   return ((((conditional_t) CREF(obj_1052))->key) = ((obj_t) val1810_1053), BUNSPEC);
}


/* _conditional/cinfo-key-set! */ obj_t 
_conditional_cinfo_key_set__114_cfa_info(obj_t env_9554, obj_t obj_9555, obj_t val1810_9556)
{
   return conditional_cinfo_key_set__171_cfa_info((conditional_t) (obj_9555), val1810_9556);
}


/* conditional/cinfo-key */ obj_t 
conditional_cinfo_key_148_cfa_info(conditional_t obj_1054)
{
   return (((conditional_t) CREF(obj_1054))->key);
}


/* _conditional/cinfo-key */ obj_t 
_conditional_cinfo_key_29_cfa_info(obj_t env_9557, obj_t obj_9558)
{
   return conditional_cinfo_key_148_cfa_info((conditional_t) (obj_9558));
}


/* conditional/cinfo-test-set! */ obj_t 
conditional_cinfo_test_set__167_cfa_info(conditional_t obj_1055, node_t val1811_1056)
{
   return ((((conditional_t) CREF(obj_1055))->test) = ((node_t) val1811_1056), BUNSPEC);
}


/* _conditional/cinfo-test-set!4272 */ obj_t 
_conditional_cinfo_test_set_4272_187_cfa_info(obj_t env_9559, obj_t obj_9560, obj_t val1811_9561)
{
   return conditional_cinfo_test_set__167_cfa_info((conditional_t) (obj_9560), (node_t) (val1811_9561));
}


/* conditional/cinfo-test */ node_t 
conditional_cinfo_test_91_cfa_info(conditional_t obj_1057)
{
   return (((conditional_t) CREF(obj_1057))->test);
}


/* _conditional/cinfo-test4273 */ obj_t 
_conditional_cinfo_test4273_188_cfa_info(obj_t env_9562, obj_t obj_9563)
{
   {
      node_t aux_14387;
      aux_14387 = conditional_cinfo_test_91_cfa_info((conditional_t) (obj_9563));
      return (obj_t) (aux_14387);
   }
}


/* conditional/cinfo-true-set! */ obj_t 
conditional_cinfo_true_set__242_cfa_info(conditional_t obj_1058, node_t val1812_1059)
{
   return ((((conditional_t) CREF(obj_1058))->true) = ((node_t) val1812_1059), BUNSPEC);
}


/* _conditional/cinfo-true-set!4274 */ obj_t 
_conditional_cinfo_true_set_4274_243_cfa_info(obj_t env_9564, obj_t obj_9565, obj_t val1812_9566)
{
   return conditional_cinfo_true_set__242_cfa_info((conditional_t) (obj_9565), (node_t) (val1812_9566));
}


/* conditional/cinfo-true */ node_t 
conditional_cinfo_true_183_cfa_info(conditional_t obj_1060)
{
   return (((conditional_t) CREF(obj_1060))->true);
}


/* _conditional/cinfo-true4275 */ obj_t 
_conditional_cinfo_true4275_31_cfa_info(obj_t env_9567, obj_t obj_9568)
{
   {
      node_t aux_14396;
      aux_14396 = conditional_cinfo_true_183_cfa_info((conditional_t) (obj_9568));
      return (obj_t) (aux_14396);
   }
}


/* conditional/cinfo-false-set! */ obj_t 
conditional_cinfo_false_set__59_cfa_info(conditional_t obj_1061, node_t val1813_1062)
{
   return ((((conditional_t) CREF(obj_1061))->false) = ((node_t) val1813_1062), BUNSPEC);
}


/* _conditional/cinfo-false-set!4276 */ obj_t 
_conditional_cinfo_false_set_4276_41_cfa_info(obj_t env_9569, obj_t obj_9570, obj_t val1813_9571)
{
   return conditional_cinfo_false_set__59_cfa_info((conditional_t) (obj_9570), (node_t) (val1813_9571));
}


/* conditional/cinfo-false */ node_t 
conditional_cinfo_false_155_cfa_info(conditional_t obj_1063)
{
   return (((conditional_t) CREF(obj_1063))->false);
}


/* _conditional/cinfo-false4277 */ obj_t 
_conditional_cinfo_false4277_112_cfa_info(obj_t env_9572, obj_t obj_9573)
{
   {
      node_t aux_14405;
      aux_14405 = conditional_cinfo_false_155_cfa_info((conditional_t) (obj_9573));
      return (obj_t) (aux_14405);
   }
}


/* conditional/cinfo-approx */ approx_t 
conditional_cinfo_approx_37_cfa_info(conditional_cinfo_212_t obj_1064)
{
   {
      obj_t aux_14409;
      {
	 object_t aux_14410;
	 aux_14410 = (object_t) (obj_1064);
	 aux_14409 = OBJECT_WIDENING(aux_14410);
      }
      return (((conditional_cinfo_212_t) CREF(aux_14409))->approx);
   }
}


/* _conditional/cinfo-approx4278 */ obj_t 
_conditional_cinfo_approx4278_206_cfa_info(obj_t env_9574, obj_t obj_9575)
{
   {
      approx_t aux_14414;
      aux_14414 = conditional_cinfo_approx_37_cfa_info((conditional_cinfo_212_t) (obj_9575));
      return (obj_t) (aux_14414);
   }
}


/* allocate-setq/cinfo */ setq_t 
allocate_setq_cinfo_202_cfa_info()
{
   {
      setq_t new1796_2724;
      new1796_2724 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
      {
	 long arg2905_2725;
	 arg2905_2725 = class_num_218___object(setq_cinfo_191_cfa_info);
	 {
	    obj_t obj_5611;
	    obj_5611 = (obj_t) (new1796_2724);
	    (((obj_t) CREF(obj_5611))->header = MAKE_HEADER(arg2905_2725, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14422;
	 aux_14422 = (object_t) (new1796_2724);
	 OBJECT_WIDENING_SET(aux_14422, BFALSE);
      }
      return new1796_2724;
   }
}


/* _allocate-setq/cinfo */ obj_t 
_allocate_setq_cinfo_116_cfa_info(obj_t env_8038)
{
   {
      setq_t aux_14425;
      aux_14425 = allocate_setq_cinfo_202_cfa_info();
      return (obj_t) (aux_14425);
   }
}


/* setq/cinfo? */ bool_t 
setq_cinfo__121_cfa_info(obj_t obj_1068)
{
   return is_a__118___object(obj_1068, setq_cinfo_191_cfa_info);
}


/* _setq/cinfo? */ obj_t 
_setq_cinfo__245_cfa_info(obj_t env_9576, obj_t obj_9577)
{
   {
      bool_t aux_14429;
      aux_14429 = setq_cinfo__121_cfa_info(obj_9577);
      return BBOOL(aux_14429);
   }
}


/* widening1018-setq/cinfo */ setq_cinfo_191_t 
widening1018_setq_cinfo_59_cfa_info(approx_t approx_1069)
{
   {
      setq_cinfo_191_t new1788_5613;
      new1788_5613 = ((setq_cinfo_191_t) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
      ((((setq_cinfo_191_t) CREF(new1788_5613))->approx) = ((approx_t) approx_1069), BUNSPEC);
      return new1788_5613;
   }
}


/* _widening1018-setq/cinfo4279 */ obj_t 
_widening1018_setq_cinfo4279_199_cfa_info(obj_t env_9578, obj_t approx_9579)
{
   {
      setq_cinfo_191_t aux_14434;
      aux_14434 = widening1018_setq_cinfo_59_cfa_info((approx_t) (approx_9579));
      return (obj_t) (aux_14434);
   }
}


/* make-setq/cinfo */ setq_cinfo_191_t 
make_setq_cinfo_232_cfa_info(obj_t loc_1070, type_t type_1071, var_t var_1072, node_t value_1073, approx_t approx_1074)
{
   {
      setq_t aux1791_5615;
      {
	 setq_t res3736_5631;
	 {
	    setq_t new1348_5623;
	    new1348_5623 = ((setq_t) BREF(GC_MALLOC(sizeof(struct setq))));
	    {
	       long arg2983_5624;
	       arg2983_5624 = class_num_218___object(setq_ast_node);
	       {
		  obj_t obj_5629;
		  obj_5629 = (obj_t) (new1348_5623);
		  (((obj_t) CREF(obj_5629))->header = MAKE_HEADER(arg2983_5624, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14442;
	       aux_14442 = (object_t) (new1348_5623);
	       OBJECT_WIDENING_SET(aux_14442, BFALSE);
	    }
	    ((((setq_t) CREF(new1348_5623))->loc) = ((obj_t) loc_1070), BUNSPEC);
	    ((((setq_t) CREF(new1348_5623))->type) = ((type_t) type_1071), BUNSPEC);
	    ((((setq_t) CREF(new1348_5623))->var) = ((var_t) var_1072), BUNSPEC);
	    ((((setq_t) CREF(new1348_5623))->value) = ((node_t) value_1073), BUNSPEC);
	    res3736_5631 = new1348_5623;
	 }
	 aux1791_5615 = res3736_5631;
      }
      {
	 setq_cinfo_191_t new1792_5616;
	 new1792_5616 = ((setq_cinfo_191_t) (aux1791_5615));
	 {
	    long arg2906_5617;
	    arg2906_5617 = class_num_218___object(setq_cinfo_191_cfa_info);
	    {
	       obj_t obj_5632;
	       obj_5632 = (obj_t) (new1792_5616);
	       (((obj_t) CREF(obj_5632))->header = MAKE_HEADER(arg2906_5617, 0), BUNSPEC);
	    }
	 }
	 {
	    setq_cinfo_191_t arg2907_5618;
	    {
	       setq_cinfo_191_t res3737_5637;
	       {
		  setq_cinfo_191_t new1788_5635;
		  new1788_5635 = ((setq_cinfo_191_t) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
		  ((((setq_cinfo_191_t) CREF(new1788_5635))->approx) = ((approx_t) approx_1074), BUNSPEC);
		  res3737_5637 = new1788_5635;
	       }
	       arg2907_5618 = res3737_5637;
	    }
	    {
	       obj_t aux_14457;
	       object_t aux_14455;
	       aux_14457 = (obj_t) (arg2907_5618);
	       aux_14455 = (object_t) (new1792_5616);
	       OBJECT_WIDENING_SET(aux_14455, aux_14457);
	    }
	 }
	 return new1792_5616;
      }
   }
}


/* _make-setq/cinfo4280 */ obj_t 
_make_setq_cinfo4280_206_cfa_info(obj_t env_9580, obj_t loc_9581, obj_t type_9582, obj_t var_9583, obj_t value_9584, obj_t approx_9585)
{
   {
      setq_cinfo_191_t aux_14460;
      aux_14460 = make_setq_cinfo_232_cfa_info(loc_9581, (type_t) (type_9582), (var_t) (var_9583), (node_t) (value_9584), (approx_t) (approx_9585));
      return (obj_t) (aux_14460);
   }
}


/* setq/cinfo-loc */ obj_t 
setq_cinfo_loc_179_cfa_info(setq_t obj_1075)
{
   return (((setq_t) CREF(obj_1075))->loc);
}


/* _setq/cinfo-loc4281 */ obj_t 
_setq_cinfo_loc4281_14_cfa_info(obj_t env_9586, obj_t obj_9587)
{
   return setq_cinfo_loc_179_cfa_info((setq_t) (obj_9587));
}


/* setq/cinfo-type-set! */ obj_t 
setq_cinfo_type_set__243_cfa_info(setq_t obj_1076, type_t val1793_1077)
{
   return ((((setq_t) CREF(obj_1076))->type) = ((type_t) val1793_1077), BUNSPEC);
}


/* _setq/cinfo-type-set!4282 */ obj_t 
_setq_cinfo_type_set_4282_115_cfa_info(obj_t env_9588, obj_t obj_9589, obj_t val1793_9590)
{
   return setq_cinfo_type_set__243_cfa_info((setq_t) (obj_9589), (type_t) (val1793_9590));
}


/* setq/cinfo-type */ type_t 
setq_cinfo_type_65_cfa_info(setq_t obj_1078)
{
   return (((setq_t) CREF(obj_1078))->type);
}


/* _setq/cinfo-type4283 */ obj_t 
_setq_cinfo_type4283_134_cfa_info(obj_t env_9591, obj_t obj_9592)
{
   {
      type_t aux_14475;
      aux_14475 = setq_cinfo_type_65_cfa_info((setq_t) (obj_9592));
      return (obj_t) (aux_14475);
   }
}


/* setq/cinfo-var-set! */ obj_t 
setq_cinfo_var_set__169_cfa_info(setq_t obj_1079, var_t val1794_1080)
{
   return ((((setq_t) CREF(obj_1079))->var) = ((var_t) val1794_1080), BUNSPEC);
}


/* _setq/cinfo-var-set!4284 */ obj_t 
_setq_cinfo_var_set_4284_103_cfa_info(obj_t env_9593, obj_t obj_9594, obj_t val1794_9595)
{
   return setq_cinfo_var_set__169_cfa_info((setq_t) (obj_9594), (var_t) (val1794_9595));
}


/* setq/cinfo-var */ var_t 
setq_cinfo_var_51_cfa_info(setq_t obj_1081)
{
   return (((setq_t) CREF(obj_1081))->var);
}


/* _setq/cinfo-var4285 */ obj_t 
_setq_cinfo_var4285_116_cfa_info(obj_t env_9596, obj_t obj_9597)
{
   {
      var_t aux_14484;
      aux_14484 = setq_cinfo_var_51_cfa_info((setq_t) (obj_9597));
      return (obj_t) (aux_14484);
   }
}


/* setq/cinfo-value-set! */ obj_t 
setq_cinfo_value_set__184_cfa_info(setq_t obj_1082, node_t val1795_1083)
{
   return ((((setq_t) CREF(obj_1082))->value) = ((node_t) val1795_1083), BUNSPEC);
}


/* _setq/cinfo-value-set!4286 */ obj_t 
_setq_cinfo_value_set_4286_185_cfa_info(obj_t env_9598, obj_t obj_9599, obj_t val1795_9600)
{
   return setq_cinfo_value_set__184_cfa_info((setq_t) (obj_9599), (node_t) (val1795_9600));
}


/* setq/cinfo-value */ node_t 
setq_cinfo_value_181_cfa_info(setq_t obj_1084)
{
   return (((setq_t) CREF(obj_1084))->value);
}


/* _setq/cinfo-value4287 */ obj_t 
_setq_cinfo_value4287_60_cfa_info(obj_t env_9601, obj_t obj_9602)
{
   {
      node_t aux_14493;
      aux_14493 = setq_cinfo_value_181_cfa_info((setq_t) (obj_9602));
      return (obj_t) (aux_14493);
   }
}


/* setq/cinfo-approx */ approx_t 
setq_cinfo_approx_141_cfa_info(setq_cinfo_191_t obj_1085)
{
   {
      obj_t aux_14497;
      {
	 object_t aux_14498;
	 aux_14498 = (object_t) (obj_1085);
	 aux_14497 = OBJECT_WIDENING(aux_14498);
      }
      return (((setq_cinfo_191_t) CREF(aux_14497))->approx);
   }
}


/* _setq/cinfo-approx4288 */ obj_t 
_setq_cinfo_approx4288_114_cfa_info(obj_t env_9603, obj_t obj_9604)
{
   {
      approx_t aux_14502;
      aux_14502 = setq_cinfo_approx_141_cfa_info((setq_cinfo_191_t) (obj_9604));
      return (obj_t) (aux_14502);
   }
}


/* allocate-pragma/cinfo */ pragma_t 
allocate_pragma_cinfo_134_cfa_info()
{
   {
      pragma_t new1781_2732;
      new1781_2732 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
      {
	 long arg2908_2733;
	 arg2908_2733 = class_num_218___object(pragma_cinfo_220_cfa_info);
	 {
	    obj_t obj_5638;
	    obj_5638 = (obj_t) (new1781_2732);
	    (((obj_t) CREF(obj_5638))->header = MAKE_HEADER(arg2908_2733, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14510;
	 aux_14510 = (object_t) (new1781_2732);
	 OBJECT_WIDENING_SET(aux_14510, BFALSE);
      }
      return new1781_2732;
   }
}


/* _allocate-pragma/cinfo */ obj_t 
_allocate_pragma_cinfo_82_cfa_info(obj_t env_8037)
{
   {
      pragma_t aux_14513;
      aux_14513 = allocate_pragma_cinfo_134_cfa_info();
      return (obj_t) (aux_14513);
   }
}


/* pragma/cinfo? */ bool_t 
pragma_cinfo__149_cfa_info(obj_t obj_1089)
{
   return is_a__118___object(obj_1089, pragma_cinfo_220_cfa_info);
}


/* _pragma/cinfo? */ obj_t 
_pragma_cinfo__129_cfa_info(obj_t env_9605, obj_t obj_9606)
{
   {
      bool_t aux_14517;
      aux_14517 = pragma_cinfo__149_cfa_info(obj_9606);
      return BBOOL(aux_14517);
   }
}


/* widening1017-pragma/cinfo */ pragma_cinfo_220_t 
widening1017_pragma_cinfo_177_cfa_info(approx_t approx_1090)
{
   {
      pragma_cinfo_220_t new1772_5640;
      new1772_5640 = ((pragma_cinfo_220_t) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
      ((((pragma_cinfo_220_t) CREF(new1772_5640))->approx) = ((approx_t) approx_1090), BUNSPEC);
      return new1772_5640;
   }
}


/* _widening1017-pragma/cinfo4289 */ obj_t 
_widening1017_pragma_cinfo4289_191_cfa_info(obj_t env_9607, obj_t approx_9608)
{
   {
      pragma_cinfo_220_t aux_14522;
      aux_14522 = widening1017_pragma_cinfo_177_cfa_info((approx_t) (approx_9608));
      return (obj_t) (aux_14522);
   }
}


/* make-pragma/cinfo */ pragma_cinfo_220_t 
make_pragma_cinfo_123_cfa_info(obj_t loc_1091, type_t type_1092, obj_t side_effect__165_1093, obj_t key_1094, obj_t format_1095, obj_t args_1096, approx_t approx_1097)
{
   {
      pragma_t aux1775_5642;
      {
	 pragma_t res3738_5662;
	 {
	    pragma_t new1327_5652;
	    new1327_5652 = ((pragma_t) BREF(GC_MALLOC(sizeof(struct pragma))));
	    {
	       long arg2987_5653;
	       arg2987_5653 = class_num_218___object(pragma_ast_node);
	       {
		  obj_t obj_5660;
		  obj_5660 = (obj_t) (new1327_5652);
		  (((obj_t) CREF(obj_5660))->header = MAKE_HEADER(arg2987_5653, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14530;
	       aux_14530 = (object_t) (new1327_5652);
	       OBJECT_WIDENING_SET(aux_14530, BFALSE);
	    }
	    ((((pragma_t) CREF(new1327_5652))->loc) = ((obj_t) loc_1091), BUNSPEC);
	    ((((pragma_t) CREF(new1327_5652))->type) = ((type_t) type_1092), BUNSPEC);
	    ((((pragma_t) CREF(new1327_5652))->side_effect__165) = ((obj_t) side_effect__165_1093), BUNSPEC);
	    ((((pragma_t) CREF(new1327_5652))->key) = ((obj_t) key_1094), BUNSPEC);
	    ((((pragma_t) CREF(new1327_5652))->format) = ((obj_t) format_1095), BUNSPEC);
	    ((((pragma_t) CREF(new1327_5652))->args) = ((obj_t) args_1096), BUNSPEC);
	    res3738_5662 = new1327_5652;
	 }
	 aux1775_5642 = res3738_5662;
      }
      {
	 pragma_cinfo_220_t new1776_5643;
	 new1776_5643 = ((pragma_cinfo_220_t) (aux1775_5642));
	 {
	    long arg2909_5644;
	    arg2909_5644 = class_num_218___object(pragma_cinfo_220_cfa_info);
	    {
	       obj_t obj_5663;
	       obj_5663 = (obj_t) (new1776_5643);
	       (((obj_t) CREF(obj_5663))->header = MAKE_HEADER(arg2909_5644, 0), BUNSPEC);
	    }
	 }
	 {
	    pragma_cinfo_220_t arg2910_5645;
	    {
	       pragma_cinfo_220_t res3739_5668;
	       {
		  pragma_cinfo_220_t new1772_5666;
		  new1772_5666 = ((pragma_cinfo_220_t) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
		  ((((pragma_cinfo_220_t) CREF(new1772_5666))->approx) = ((approx_t) approx_1097), BUNSPEC);
		  res3739_5668 = new1772_5666;
	       }
	       arg2910_5645 = res3739_5668;
	    }
	    {
	       obj_t aux_14547;
	       object_t aux_14545;
	       aux_14547 = (obj_t) (arg2910_5645);
	       aux_14545 = (object_t) (new1776_5643);
	       OBJECT_WIDENING_SET(aux_14545, aux_14547);
	    }
	 }
	 return new1776_5643;
      }
   }
}


/* _make-pragma/cinfo4290 */ obj_t 
_make_pragma_cinfo4290_232_cfa_info(obj_t env_9609, obj_t loc_9610, obj_t type_9611, obj_t side_effect__165_9612, obj_t key_9613, obj_t format_9614, obj_t args_9615, obj_t approx_9616)
{
   {
      pragma_cinfo_220_t aux_14550;
      aux_14550 = make_pragma_cinfo_123_cfa_info(loc_9610, (type_t) (type_9611), side_effect__165_9612, key_9613, format_9614, args_9615, (approx_t) (approx_9616));
      return (obj_t) (aux_14550);
   }
}


/* pragma/cinfo-loc */ obj_t 
pragma_cinfo_loc_22_cfa_info(pragma_t obj_1098)
{
   return (((pragma_t) CREF(obj_1098))->loc);
}


/* _pragma/cinfo-loc4291 */ obj_t 
_pragma_cinfo_loc4291_208_cfa_info(obj_t env_9617, obj_t obj_9618)
{
   return pragma_cinfo_loc_22_cfa_info((pragma_t) (obj_9618));
}


/* pragma/cinfo-type-set! */ obj_t 
pragma_cinfo_type_set__38_cfa_info(pragma_t obj_1099, type_t val1777_1100)
{
   return ((((pragma_t) CREF(obj_1099))->type) = ((type_t) val1777_1100), BUNSPEC);
}


/* _pragma/cinfo-type-set!4292 */ obj_t 
_pragma_cinfo_type_set_4292_129_cfa_info(obj_t env_9619, obj_t obj_9620, obj_t val1777_9621)
{
   return pragma_cinfo_type_set__38_cfa_info((pragma_t) (obj_9620), (type_t) (val1777_9621));
}


/* pragma/cinfo-type */ type_t 
pragma_cinfo_type_144_cfa_info(pragma_t obj_1101)
{
   return (((pragma_t) CREF(obj_1101))->type);
}


/* _pragma/cinfo-type4293 */ obj_t 
_pragma_cinfo_type4293_206_cfa_info(obj_t env_9622, obj_t obj_9623)
{
   {
      type_t aux_14563;
      aux_14563 = pragma_cinfo_type_144_cfa_info((pragma_t) (obj_9623));
      return (obj_t) (aux_14563);
   }
}


/* pragma/cinfo-side-effect?-set! */ obj_t 
pragma_cinfo_side_effect__set__54_cfa_info(pragma_t obj_1102, obj_t val1778_1103)
{
   return ((((pragma_t) CREF(obj_1102))->side_effect__165) = ((obj_t) val1778_1103), BUNSPEC);
}


/* _pragma/cinfo-side-effect?-set!4294 */ obj_t 
_pragma_cinfo_side_effect__set_4294_183_cfa_info(obj_t env_9624, obj_t obj_9625, obj_t val1778_9626)
{
   return pragma_cinfo_side_effect__set__54_cfa_info((pragma_t) (obj_9625), val1778_9626);
}


/* pragma/cinfo-side-effect? */ obj_t 
pragma_cinfo_side_effect__231_cfa_info(pragma_t obj_1104)
{
   return (((pragma_t) CREF(obj_1104))->side_effect__165);
}


/* _pragma/cinfo-side-effect?4295 */ obj_t 
_pragma_cinfo_side_effect_4295_162_cfa_info(obj_t env_9627, obj_t obj_9628)
{
   return pragma_cinfo_side_effect__231_cfa_info((pragma_t) (obj_9628));
}


/* pragma/cinfo-key-set! */ obj_t 
pragma_cinfo_key_set__146_cfa_info(pragma_t obj_1105, obj_t val1779_1106)
{
   return ((((pragma_t) CREF(obj_1105))->key) = ((obj_t) val1779_1106), BUNSPEC);
}


/* _pragma/cinfo-key-set! */ obj_t 
_pragma_cinfo_key_set__201_cfa_info(obj_t env_9629, obj_t obj_9630, obj_t val1779_9631)
{
   return pragma_cinfo_key_set__146_cfa_info((pragma_t) (obj_9630), val1779_9631);
}


/* pragma/cinfo-key */ obj_t 
pragma_cinfo_key_115_cfa_info(pragma_t obj_1107)
{
   return (((pragma_t) CREF(obj_1107))->key);
}


/* _pragma/cinfo-key */ obj_t 
_pragma_cinfo_key_170_cfa_info(obj_t env_9632, obj_t obj_9633)
{
   return pragma_cinfo_key_115_cfa_info((pragma_t) (obj_9633));
}


/* pragma/cinfo-format */ obj_t 
pragma_cinfo_format_141_cfa_info(pragma_t obj_1108)
{
   return (((pragma_t) CREF(obj_1108))->format);
}


/* _pragma/cinfo-format4296 */ obj_t 
_pragma_cinfo_format4296_175_cfa_info(obj_t env_9634, obj_t obj_9635)
{
   return pragma_cinfo_format_141_cfa_info((pragma_t) (obj_9635));
}


/* pragma/cinfo-args-set! */ obj_t 
pragma_cinfo_args_set__20_cfa_info(pragma_t obj_1109, obj_t val1780_1110)
{
   return ((((pragma_t) CREF(obj_1109))->args) = ((obj_t) val1780_1110), BUNSPEC);
}


/* _pragma/cinfo-args-set!4297 */ obj_t 
_pragma_cinfo_args_set_4297_45_cfa_info(obj_t env_9636, obj_t obj_9637, obj_t val1780_9638)
{
   return pragma_cinfo_args_set__20_cfa_info((pragma_t) (obj_9637), val1780_9638);
}


/* pragma/cinfo-args */ obj_t 
pragma_cinfo_args_224_cfa_info(pragma_t obj_1111)
{
   return (((pragma_t) CREF(obj_1111))->args);
}


/* _pragma/cinfo-args4298 */ obj_t 
_pragma_cinfo_args4298_204_cfa_info(obj_t env_9639, obj_t obj_9640)
{
   return pragma_cinfo_args_224_cfa_info((pragma_t) (obj_9640));
}


/* pragma/cinfo-approx */ approx_t 
pragma_cinfo_approx_152_cfa_info(pragma_cinfo_220_t obj_1112)
{
   {
      obj_t aux_14588;
      {
	 object_t aux_14589;
	 aux_14589 = (object_t) (obj_1112);
	 aux_14588 = OBJECT_WIDENING(aux_14589);
      }
      return (((pragma_cinfo_220_t) CREF(aux_14588))->approx);
   }
}


/* _pragma/cinfo-approx4299 */ obj_t 
_pragma_cinfo_approx4299_32_cfa_info(obj_t env_9641, obj_t obj_9642)
{
   {
      approx_t aux_14593;
      aux_14593 = pragma_cinfo_approx_152_cfa_info((pragma_cinfo_220_t) (obj_9642));
      return (obj_t) (aux_14593);
   }
}


/* allocate-funcall/cinfo */ funcall_t 
allocate_funcall_cinfo_11_cfa_info()
{
   {
      funcall_t new1765_2740;
      new1765_2740 = ((funcall_t) BREF(GC_MALLOC(sizeof(struct funcall))));
      {
	 long arg2911_2741;
	 arg2911_2741 = class_num_218___object(funcall_cinfo_75_cfa_info);
	 {
	    obj_t obj_5669;
	    obj_5669 = (obj_t) (new1765_2740);
	    (((obj_t) CREF(obj_5669))->header = MAKE_HEADER(arg2911_2741, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14601;
	 aux_14601 = (object_t) (new1765_2740);
	 OBJECT_WIDENING_SET(aux_14601, BFALSE);
      }
      return new1765_2740;
   }
}


/* _allocate-funcall/cinfo */ obj_t 
_allocate_funcall_cinfo_40_cfa_info(obj_t env_8036)
{
   {
      funcall_t aux_14604;
      aux_14604 = allocate_funcall_cinfo_11_cfa_info();
      return (obj_t) (aux_14604);
   }
}


/* funcall/cinfo? */ bool_t 
funcall_cinfo__175_cfa_info(obj_t obj_1116)
{
   return is_a__118___object(obj_1116, funcall_cinfo_75_cfa_info);
}


/* _funcall/cinfo? */ obj_t 
_funcall_cinfo__59_cfa_info(obj_t env_9643, obj_t obj_9644)
{
   {
      bool_t aux_14608;
      aux_14608 = funcall_cinfo__175_cfa_info(obj_9644);
      return BBOOL(aux_14608);
   }
}


/* widening1016-funcall/cinfo */ funcall_cinfo_75_t 
widening1016_funcall_cinfo_219_cfa_info(approx_t approx_1117, approx_t va_approx_63_1118, bool_t arity_error_noticed__118_1119, bool_t type_error_noticed__36_1120)
{
   {
      funcall_cinfo_75_t new1751_5671;
      new1751_5671 = ((funcall_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
      ((((funcall_cinfo_75_t) CREF(new1751_5671))->approx) = ((approx_t) approx_1117), BUNSPEC);
      ((((funcall_cinfo_75_t) CREF(new1751_5671))->va_approx_63) = ((approx_t) va_approx_63_1118), BUNSPEC);
      ((((funcall_cinfo_75_t) CREF(new1751_5671))->arity_error_noticed__118) = ((bool_t) arity_error_noticed__118_1119), BUNSPEC);
      ((((funcall_cinfo_75_t) CREF(new1751_5671))->type_error_noticed__36) = ((bool_t) type_error_noticed__36_1120), BUNSPEC);
      return new1751_5671;
   }
}


/* _widening1016-funcall/cinfo4300 */ obj_t 
_widening1016_funcall_cinfo4300_74_cfa_info(obj_t env_9645, obj_t approx_9646, obj_t va_approx_63_9647, obj_t arity_error_noticed__118_9648, obj_t type_error_noticed__36_9649)
{
   {
      funcall_cinfo_75_t aux_14616;
      aux_14616 = widening1016_funcall_cinfo_219_cfa_info((approx_t) (approx_9646), (approx_t) (va_approx_63_9647), CBOOL(arity_error_noticed__118_9648), CBOOL(type_error_noticed__36_9649));
      return (obj_t) (aux_14616);
   }
}


/* make-funcall/cinfo */ funcall_cinfo_75_t 
make_funcall_cinfo_132_cfa_info(obj_t loc_1121, type_t type_1122, node_t fun_1123, obj_t args_1124, obj_t strength_1125, approx_t approx_1126, approx_t va_approx_63_1127, bool_t arity_error_noticed__118_1128, bool_t type_error_noticed__36_1129)
{
   {
      funcall_t aux1757_5676;
      {
	 funcall_t res3740_5694;
	 {
	    funcall_t new1315_5685;
	    new1315_5685 = ((funcall_t) BREF(GC_MALLOC(sizeof(struct funcall))));
	    {
	       long arg2991_5686;
	       arg2991_5686 = class_num_218___object(funcall_ast_node);
	       {
		  obj_t obj_5692;
		  obj_5692 = (obj_t) (new1315_5685);
		  (((obj_t) CREF(obj_5692))->header = MAKE_HEADER(arg2991_5686, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14627;
	       aux_14627 = (object_t) (new1315_5685);
	       OBJECT_WIDENING_SET(aux_14627, BFALSE);
	    }
	    ((((funcall_t) CREF(new1315_5685))->loc) = ((obj_t) loc_1121), BUNSPEC);
	    ((((funcall_t) CREF(new1315_5685))->type) = ((type_t) type_1122), BUNSPEC);
	    ((((funcall_t) CREF(new1315_5685))->fun) = ((node_t) fun_1123), BUNSPEC);
	    ((((funcall_t) CREF(new1315_5685))->args) = ((obj_t) args_1124), BUNSPEC);
	    ((((funcall_t) CREF(new1315_5685))->strength) = ((obj_t) strength_1125), BUNSPEC);
	    res3740_5694 = new1315_5685;
	 }
	 aux1757_5676 = res3740_5694;
      }
      {
	 funcall_cinfo_75_t new1758_5677;
	 new1758_5677 = ((funcall_cinfo_75_t) (aux1757_5676));
	 {
	    long arg2912_5678;
	    arg2912_5678 = class_num_218___object(funcall_cinfo_75_cfa_info);
	    {
	       obj_t obj_5695;
	       obj_5695 = (obj_t) (new1758_5677);
	       (((obj_t) CREF(obj_5695))->header = MAKE_HEADER(arg2912_5678, 0), BUNSPEC);
	    }
	 }
	 {
	    funcall_cinfo_75_t arg2913_5679;
	    {
	       funcall_cinfo_75_t res3741_5706;
	       {
		  funcall_cinfo_75_t new1751_5701;
		  new1751_5701 = ((funcall_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
		  ((((funcall_cinfo_75_t) CREF(new1751_5701))->approx) = ((approx_t) approx_1126), BUNSPEC);
		  ((((funcall_cinfo_75_t) CREF(new1751_5701))->va_approx_63) = ((approx_t) va_approx_63_1127), BUNSPEC);
		  ((((funcall_cinfo_75_t) CREF(new1751_5701))->arity_error_noticed__118) = ((bool_t) arity_error_noticed__118_1128), BUNSPEC);
		  ((((funcall_cinfo_75_t) CREF(new1751_5701))->type_error_noticed__36) = ((bool_t) type_error_noticed__36_1129), BUNSPEC);
		  res3741_5706 = new1751_5701;
	       }
	       arg2913_5679 = res3741_5706;
	    }
	    {
	       obj_t aux_14646;
	       object_t aux_14644;
	       aux_14646 = (obj_t) (arg2913_5679);
	       aux_14644 = (object_t) (new1758_5677);
	       OBJECT_WIDENING_SET(aux_14644, aux_14646);
	    }
	 }
	 return new1758_5677;
      }
   }
}


/* _make-funcall/cinfo4301 */ obj_t 
_make_funcall_cinfo4301_147_cfa_info(obj_t env_9650, obj_t loc_9651, obj_t type_9652, obj_t fun_9653, obj_t args_9654, obj_t strength_9655, obj_t approx_9656, obj_t va_approx_63_9657, obj_t arity_error_noticed__118_9658, obj_t type_error_noticed__36_9659)
{
   {
      funcall_cinfo_75_t aux_14649;
      aux_14649 = make_funcall_cinfo_132_cfa_info(loc_9651, (type_t) (type_9652), (node_t) (fun_9653), args_9654, strength_9655, (approx_t) (approx_9656), (approx_t) (va_approx_63_9657), CBOOL(arity_error_noticed__118_9658), CBOOL(type_error_noticed__36_9659));
      return (obj_t) (aux_14649);
   }
}


/* funcall/cinfo-loc */ obj_t 
funcall_cinfo_loc_64_cfa_info(funcall_t obj_1130)
{
   return (((funcall_t) CREF(obj_1130))->loc);
}


/* _funcall/cinfo-loc4302 */ obj_t 
_funcall_cinfo_loc4302_189_cfa_info(obj_t env_9660, obj_t obj_9661)
{
   return funcall_cinfo_loc_64_cfa_info((funcall_t) (obj_9661));
}


/* funcall/cinfo-type-set! */ obj_t 
funcall_cinfo_type_set__85_cfa_info(funcall_t obj_1131, type_t val1759_1132)
{
   return ((((funcall_t) CREF(obj_1131))->type) = ((type_t) val1759_1132), BUNSPEC);
}


/* _funcall/cinfo-type-set!4303 */ obj_t 
_funcall_cinfo_type_set_4303_21_cfa_info(obj_t env_9662, obj_t obj_9663, obj_t val1759_9664)
{
   return funcall_cinfo_type_set__85_cfa_info((funcall_t) (obj_9663), (type_t) (val1759_9664));
}


/* funcall/cinfo-type */ type_t 
funcall_cinfo_type_26_cfa_info(funcall_t obj_1133)
{
   return (((funcall_t) CREF(obj_1133))->type);
}


/* _funcall/cinfo-type4304 */ obj_t 
_funcall_cinfo_type4304_241_cfa_info(obj_t env_9665, obj_t obj_9666)
{
   {
      type_t aux_14666;
      aux_14666 = funcall_cinfo_type_26_cfa_info((funcall_t) (obj_9666));
      return (obj_t) (aux_14666);
   }
}


/* funcall/cinfo-fun-set! */ obj_t 
funcall_cinfo_fun_set__87_cfa_info(funcall_t obj_1134, node_t val1760_1135)
{
   return ((((funcall_t) CREF(obj_1134))->fun) = ((node_t) val1760_1135), BUNSPEC);
}


/* _funcall/cinfo-fun-set!4305 */ obj_t 
_funcall_cinfo_fun_set_4305_215_cfa_info(obj_t env_9667, obj_t obj_9668, obj_t val1760_9669)
{
   return funcall_cinfo_fun_set__87_cfa_info((funcall_t) (obj_9668), (node_t) (val1760_9669));
}


/* funcall/cinfo-fun */ node_t 
funcall_cinfo_fun_73_cfa_info(funcall_t obj_1136)
{
   return (((funcall_t) CREF(obj_1136))->fun);
}


/* _funcall/cinfo-fun4306 */ obj_t 
_funcall_cinfo_fun4306_184_cfa_info(obj_t env_9670, obj_t obj_9671)
{
   {
      node_t aux_14675;
      aux_14675 = funcall_cinfo_fun_73_cfa_info((funcall_t) (obj_9671));
      return (obj_t) (aux_14675);
   }
}


/* funcall/cinfo-args-set! */ obj_t 
funcall_cinfo_args_set__97_cfa_info(funcall_t obj_1137, obj_t val1761_1138)
{
   return ((((funcall_t) CREF(obj_1137))->args) = ((obj_t) val1761_1138), BUNSPEC);
}


/* _funcall/cinfo-args-set!4307 */ obj_t 
_funcall_cinfo_args_set_4307_122_cfa_info(obj_t env_9672, obj_t obj_9673, obj_t val1761_9674)
{
   return funcall_cinfo_args_set__97_cfa_info((funcall_t) (obj_9673), val1761_9674);
}


/* funcall/cinfo-args */ obj_t 
funcall_cinfo_args_85_cfa_info(funcall_t obj_1139)
{
   return (((funcall_t) CREF(obj_1139))->args);
}


/* _funcall/cinfo-args4308 */ obj_t 
_funcall_cinfo_args4308_56_cfa_info(obj_t env_9675, obj_t obj_9676)
{
   return funcall_cinfo_args_85_cfa_info((funcall_t) (obj_9676));
}


/* funcall/cinfo-strength-set! */ obj_t 
funcall_cinfo_strength_set__61_cfa_info(funcall_t obj_1140, obj_t val1762_1141)
{
   return ((((funcall_t) CREF(obj_1140))->strength) = ((obj_t) val1762_1141), BUNSPEC);
}


/* _funcall/cinfo-strength-set!4309 */ obj_t 
_funcall_cinfo_strength_set_4309_38_cfa_info(obj_t env_9677, obj_t obj_9678, obj_t val1762_9679)
{
   return funcall_cinfo_strength_set__61_cfa_info((funcall_t) (obj_9678), val1762_9679);
}


/* funcall/cinfo-strength */ obj_t 
funcall_cinfo_strength_95_cfa_info(funcall_t obj_1142)
{
   return (((funcall_t) CREF(obj_1142))->strength);
}


/* _funcall/cinfo-strength4310 */ obj_t 
_funcall_cinfo_strength4310_166_cfa_info(obj_t env_9680, obj_t obj_9681)
{
   return funcall_cinfo_strength_95_cfa_info((funcall_t) (obj_9681));
}


/* funcall/cinfo-approx */ approx_t 
funcall_cinfo_approx_11_cfa_info(funcall_cinfo_75_t obj_1143)
{
   {
      obj_t aux_14691;
      {
	 object_t aux_14692;
	 aux_14692 = (object_t) (obj_1143);
	 aux_14691 = OBJECT_WIDENING(aux_14692);
      }
      return (((funcall_cinfo_75_t) CREF(aux_14691))->approx);
   }
}


/* _funcall/cinfo-approx4311 */ obj_t 
_funcall_cinfo_approx4311_125_cfa_info(obj_t env_9682, obj_t obj_9683)
{
   {
      approx_t aux_14696;
      aux_14696 = funcall_cinfo_approx_11_cfa_info((funcall_cinfo_75_t) (obj_9683));
      return (obj_t) (aux_14696);
   }
}


/* funcall/cinfo-va-approx */ approx_t 
funcall_cinfo_va_approx_93_cfa_info(funcall_cinfo_75_t obj_1144)
{
   {
      obj_t aux_14700;
      {
	 object_t aux_14701;
	 aux_14701 = (object_t) (obj_1144);
	 aux_14700 = OBJECT_WIDENING(aux_14701);
      }
      return (((funcall_cinfo_75_t) CREF(aux_14700))->va_approx_63);
   }
}


/* _funcall/cinfo-va-approx4312 */ obj_t 
_funcall_cinfo_va_approx4312_166_cfa_info(obj_t env_9684, obj_t obj_9685)
{
   {
      approx_t aux_14705;
      aux_14705 = funcall_cinfo_va_approx_93_cfa_info((funcall_cinfo_75_t) (obj_9685));
      return (obj_t) (aux_14705);
   }
}


/* funcall/cinfo-arity-error-noticed?-set! */ obj_t 
funcall_cinfo_arity_error_noticed__set__137_cfa_info(funcall_cinfo_75_t obj_1145, bool_t val1763_1146)
{
   {
      obj_t aux_14709;
      {
	 object_t aux_14710;
	 aux_14710 = (object_t) (obj_1145);
	 aux_14709 = OBJECT_WIDENING(aux_14710);
      }
      return ((((funcall_cinfo_75_t) CREF(aux_14709))->arity_error_noticed__118) = ((bool_t) val1763_1146), BUNSPEC);
   }
}


/* _funcall/cinfo-arity-error-noticed?-set!4313 */ obj_t 
_funcall_cinfo_arity_error_noticed__set_4313_165_cfa_info(obj_t env_9686, obj_t obj_9687, obj_t val1763_9688)
{
   return funcall_cinfo_arity_error_noticed__set__137_cfa_info((funcall_cinfo_75_t) (obj_9687), CBOOL(val1763_9688));
}


/* funcall/cinfo-arity-error-noticed? */ bool_t 
funcall_cinfo_arity_error_noticed__251_cfa_info(funcall_cinfo_75_t obj_1147)
{
   {
      obj_t aux_14717;
      {
	 object_t aux_14718;
	 aux_14718 = (object_t) (obj_1147);
	 aux_14717 = OBJECT_WIDENING(aux_14718);
      }
      return (((funcall_cinfo_75_t) CREF(aux_14717))->arity_error_noticed__118);
   }
}


/* _funcall/cinfo-arity-error-noticed?4314 */ obj_t 
_funcall_cinfo_arity_error_noticed_4314_220_cfa_info(obj_t env_9689, obj_t obj_9690)
{
   {
      bool_t aux_14722;
      aux_14722 = funcall_cinfo_arity_error_noticed__251_cfa_info((funcall_cinfo_75_t) (obj_9690));
      return BBOOL(aux_14722);
   }
}


/* funcall/cinfo-type-error-noticed?-set! */ obj_t 
funcall_cinfo_type_error_noticed__set__27_cfa_info(funcall_cinfo_75_t obj_1148, bool_t val1764_1149)
{
   {
      obj_t aux_14726;
      {
	 object_t aux_14727;
	 aux_14727 = (object_t) (obj_1148);
	 aux_14726 = OBJECT_WIDENING(aux_14727);
      }
      return ((((funcall_cinfo_75_t) CREF(aux_14726))->type_error_noticed__36) = ((bool_t) val1764_1149), BUNSPEC);
   }
}


/* _funcall/cinfo-type-error-noticed?-set!4315 */ obj_t 
_funcall_cinfo_type_error_noticed__set_4315_29_cfa_info(obj_t env_9691, obj_t obj_9692, obj_t val1764_9693)
{
   return funcall_cinfo_type_error_noticed__set__27_cfa_info((funcall_cinfo_75_t) (obj_9692), CBOOL(val1764_9693));
}


/* funcall/cinfo-type-error-noticed? */ bool_t 
funcall_cinfo_type_error_noticed__56_cfa_info(funcall_cinfo_75_t obj_1150)
{
   {
      obj_t aux_14734;
      {
	 object_t aux_14735;
	 aux_14735 = (object_t) (obj_1150);
	 aux_14734 = OBJECT_WIDENING(aux_14735);
      }
      return (((funcall_cinfo_75_t) CREF(aux_14734))->type_error_noticed__36);
   }
}


/* _funcall/cinfo-type-error-noticed?4316 */ obj_t 
_funcall_cinfo_type_error_noticed_4316_69_cfa_info(obj_t env_9694, obj_t obj_9695)
{
   {
      bool_t aux_14739;
      aux_14739 = funcall_cinfo_type_error_noticed__56_cfa_info((funcall_cinfo_75_t) (obj_9695));
      return BBOOL(aux_14739);
   }
}


/* allocate-app-ly/cinfo */ app_ly_162_t 
allocate_app_ly_cinfo_200_cfa_info()
{
   {
      app_ly_162_t new1744_2751;
      new1744_2751 = ((app_ly_162_t) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
      {
	 long arg2914_2752;
	 arg2914_2752 = class_num_218___object(app_ly_cinfo_234_cfa_info);
	 {
	    obj_t obj_5707;
	    obj_5707 = (obj_t) (new1744_2751);
	    (((obj_t) CREF(obj_5707))->header = MAKE_HEADER(arg2914_2752, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14747;
	 aux_14747 = (object_t) (new1744_2751);
	 OBJECT_WIDENING_SET(aux_14747, BFALSE);
      }
      return new1744_2751;
   }
}


/* _allocate-app-ly/cinfo */ obj_t 
_allocate_app_ly_cinfo_17_cfa_info(obj_t env_8035)
{
   {
      app_ly_162_t aux_14750;
      aux_14750 = allocate_app_ly_cinfo_200_cfa_info();
      return (obj_t) (aux_14750);
   }
}


/* app-ly/cinfo? */ bool_t 
app_ly_cinfo__179_cfa_info(obj_t obj_1154)
{
   return is_a__118___object(obj_1154, app_ly_cinfo_234_cfa_info);
}


/* _app-ly/cinfo? */ obj_t 
_app_ly_cinfo__202_cfa_info(obj_t env_9696, obj_t obj_9697)
{
   {
      bool_t aux_14754;
      aux_14754 = app_ly_cinfo__179_cfa_info(obj_9697);
      return BBOOL(aux_14754);
   }
}


/* widening1015-app-ly/cinfo */ app_ly_cinfo_234_t 
widening1015_app_ly_cinfo_53_cfa_info(approx_t approx_1155)
{
   {
      app_ly_cinfo_234_t new1736_5709;
      new1736_5709 = ((app_ly_cinfo_234_t) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
      ((((app_ly_cinfo_234_t) CREF(new1736_5709))->approx) = ((approx_t) approx_1155), BUNSPEC);
      return new1736_5709;
   }
}


/* _widening1015-app-ly/cinfo4317 */ obj_t 
_widening1015_app_ly_cinfo4317_127_cfa_info(obj_t env_9698, obj_t approx_9699)
{
   {
      app_ly_cinfo_234_t aux_14759;
      aux_14759 = widening1015_app_ly_cinfo_53_cfa_info((approx_t) (approx_9699));
      return (obj_t) (aux_14759);
   }
}


/* make-app-ly/cinfo */ app_ly_cinfo_234_t 
make_app_ly_cinfo_1_cfa_info(obj_t loc_1156, type_t type_1157, node_t fun_1158, node_t arg_1159, approx_t approx_1160)
{
   {
      app_ly_162_t aux1739_5711;
      {
	 app_ly_162_t res3742_5727;
	 {
	    app_ly_162_t new1305_5719;
	    new1305_5719 = ((app_ly_162_t) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
	    {
	       long arg2995_5720;
	       arg2995_5720 = class_num_218___object(app_ly_162_ast_node);
	       {
		  obj_t obj_5725;
		  obj_5725 = (obj_t) (new1305_5719);
		  (((obj_t) CREF(obj_5725))->header = MAKE_HEADER(arg2995_5720, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14767;
	       aux_14767 = (object_t) (new1305_5719);
	       OBJECT_WIDENING_SET(aux_14767, BFALSE);
	    }
	    ((((app_ly_162_t) CREF(new1305_5719))->loc) = ((obj_t) loc_1156), BUNSPEC);
	    ((((app_ly_162_t) CREF(new1305_5719))->type) = ((type_t) type_1157), BUNSPEC);
	    ((((app_ly_162_t) CREF(new1305_5719))->fun) = ((node_t) fun_1158), BUNSPEC);
	    ((((app_ly_162_t) CREF(new1305_5719))->arg) = ((node_t) arg_1159), BUNSPEC);
	    res3742_5727 = new1305_5719;
	 }
	 aux1739_5711 = res3742_5727;
      }
      {
	 app_ly_cinfo_234_t new1740_5712;
	 new1740_5712 = ((app_ly_cinfo_234_t) (aux1739_5711));
	 {
	    long arg2915_5713;
	    arg2915_5713 = class_num_218___object(app_ly_cinfo_234_cfa_info);
	    {
	       obj_t obj_5728;
	       obj_5728 = (obj_t) (new1740_5712);
	       (((obj_t) CREF(obj_5728))->header = MAKE_HEADER(arg2915_5713, 0), BUNSPEC);
	    }
	 }
	 {
	    app_ly_cinfo_234_t arg2916_5714;
	    {
	       app_ly_cinfo_234_t res3743_5733;
	       {
		  app_ly_cinfo_234_t new1736_5731;
		  new1736_5731 = ((app_ly_cinfo_234_t) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
		  ((((app_ly_cinfo_234_t) CREF(new1736_5731))->approx) = ((approx_t) approx_1160), BUNSPEC);
		  res3743_5733 = new1736_5731;
	       }
	       arg2916_5714 = res3743_5733;
	    }
	    {
	       obj_t aux_14782;
	       object_t aux_14780;
	       aux_14782 = (obj_t) (arg2916_5714);
	       aux_14780 = (object_t) (new1740_5712);
	       OBJECT_WIDENING_SET(aux_14780, aux_14782);
	    }
	 }
	 return new1740_5712;
      }
   }
}


/* _make-app-ly/cinfo4318 */ obj_t 
_make_app_ly_cinfo4318_157_cfa_info(obj_t env_9700, obj_t loc_9701, obj_t type_9702, obj_t fun_9703, obj_t arg_9704, obj_t approx_9705)
{
   {
      app_ly_cinfo_234_t aux_14785;
      aux_14785 = make_app_ly_cinfo_1_cfa_info(loc_9701, (type_t) (type_9702), (node_t) (fun_9703), (node_t) (arg_9704), (approx_t) (approx_9705));
      return (obj_t) (aux_14785);
   }
}


/* app-ly/cinfo-loc */ obj_t 
app_ly_cinfo_loc_252_cfa_info(app_ly_162_t obj_1161)
{
   return (((app_ly_162_t) CREF(obj_1161))->loc);
}


/* _app-ly/cinfo-loc4319 */ obj_t 
_app_ly_cinfo_loc4319_10_cfa_info(obj_t env_9706, obj_t obj_9707)
{
   return app_ly_cinfo_loc_252_cfa_info((app_ly_162_t) (obj_9707));
}


/* app-ly/cinfo-type-set! */ obj_t 
app_ly_cinfo_type_set__211_cfa_info(app_ly_162_t obj_1162, type_t val1741_1163)
{
   return ((((app_ly_162_t) CREF(obj_1162))->type) = ((type_t) val1741_1163), BUNSPEC);
}


/* _app-ly/cinfo-type-set!4320 */ obj_t 
_app_ly_cinfo_type_set_4320_179_cfa_info(obj_t env_9708, obj_t obj_9709, obj_t val1741_9710)
{
   return app_ly_cinfo_type_set__211_cfa_info((app_ly_162_t) (obj_9709), (type_t) (val1741_9710));
}


/* app-ly/cinfo-type */ type_t 
app_ly_cinfo_type_137_cfa_info(app_ly_162_t obj_1164)
{
   return (((app_ly_162_t) CREF(obj_1164))->type);
}


/* _app-ly/cinfo-type4321 */ obj_t 
_app_ly_cinfo_type4321_85_cfa_info(obj_t env_9711, obj_t obj_9712)
{
   {
      type_t aux_14800;
      aux_14800 = app_ly_cinfo_type_137_cfa_info((app_ly_162_t) (obj_9712));
      return (obj_t) (aux_14800);
   }
}


/* app-ly/cinfo-fun-set! */ obj_t 
app_ly_cinfo_fun_set__61_cfa_info(app_ly_162_t obj_1165, node_t val1742_1166)
{
   return ((((app_ly_162_t) CREF(obj_1165))->fun) = ((node_t) val1742_1166), BUNSPEC);
}


/* _app-ly/cinfo-fun-set!4322 */ obj_t 
_app_ly_cinfo_fun_set_4322_68_cfa_info(obj_t env_9713, obj_t obj_9714, obj_t val1742_9715)
{
   return app_ly_cinfo_fun_set__61_cfa_info((app_ly_162_t) (obj_9714), (node_t) (val1742_9715));
}


/* app-ly/cinfo-fun */ node_t 
app_ly_cinfo_fun_95_cfa_info(app_ly_162_t obj_1167)
{
   return (((app_ly_162_t) CREF(obj_1167))->fun);
}


/* _app-ly/cinfo-fun4323 */ obj_t 
_app_ly_cinfo_fun4323_133_cfa_info(obj_t env_9716, obj_t obj_9717)
{
   {
      node_t aux_14809;
      aux_14809 = app_ly_cinfo_fun_95_cfa_info((app_ly_162_t) (obj_9717));
      return (obj_t) (aux_14809);
   }
}


/* app-ly/cinfo-arg-set! */ obj_t 
app_ly_cinfo_arg_set__121_cfa_info(app_ly_162_t obj_1168, node_t val1743_1169)
{
   return ((((app_ly_162_t) CREF(obj_1168))->arg) = ((node_t) val1743_1169), BUNSPEC);
}


/* _app-ly/cinfo-arg-set!4324 */ obj_t 
_app_ly_cinfo_arg_set_4324_253_cfa_info(obj_t env_9718, obj_t obj_9719, obj_t val1743_9720)
{
   return app_ly_cinfo_arg_set__121_cfa_info((app_ly_162_t) (obj_9719), (node_t) (val1743_9720));
}


/* app-ly/cinfo-arg */ node_t 
app_ly_cinfo_arg_233_cfa_info(app_ly_162_t obj_1170)
{
   return (((app_ly_162_t) CREF(obj_1170))->arg);
}


/* _app-ly/cinfo-arg4325 */ obj_t 
_app_ly_cinfo_arg4325_242_cfa_info(obj_t env_9721, obj_t obj_9722)
{
   {
      node_t aux_14818;
      aux_14818 = app_ly_cinfo_arg_233_cfa_info((app_ly_162_t) (obj_9722));
      return (obj_t) (aux_14818);
   }
}


/* app-ly/cinfo-approx */ approx_t 
app_ly_cinfo_approx_252_cfa_info(app_ly_cinfo_234_t obj_1171)
{
   {
      obj_t aux_14822;
      {
	 object_t aux_14823;
	 aux_14823 = (object_t) (obj_1171);
	 aux_14822 = OBJECT_WIDENING(aux_14823);
      }
      return (((app_ly_cinfo_234_t) CREF(aux_14822))->approx);
   }
}


/* _app-ly/cinfo-approx4326 */ obj_t 
_app_ly_cinfo_approx4326_82_cfa_info(obj_t env_9723, obj_t obj_9724)
{
   {
      approx_t aux_14827;
      aux_14827 = app_ly_cinfo_approx_252_cfa_info((app_ly_cinfo_234_t) (obj_9724));
      return (obj_t) (aux_14827);
   }
}


/* allocate-kwote/cinfo */ kwote_t 
allocate_kwote_cinfo_134_cfa_info()
{
   {
      kwote_t new1729_2759;
      new1729_2759 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
      {
	 long arg2917_2760;
	 arg2917_2760 = class_num_218___object(kwote_cinfo_48_cfa_info);
	 {
	    obj_t obj_5734;
	    obj_5734 = (obj_t) (new1729_2759);
	    (((obj_t) CREF(obj_5734))->header = MAKE_HEADER(arg2917_2760, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14835;
	 aux_14835 = (object_t) (new1729_2759);
	 OBJECT_WIDENING_SET(aux_14835, BFALSE);
      }
      return new1729_2759;
   }
}


/* _allocate-kwote/cinfo */ obj_t 
_allocate_kwote_cinfo_178_cfa_info(obj_t env_8034)
{
   {
      kwote_t aux_14838;
      aux_14838 = allocate_kwote_cinfo_134_cfa_info();
      return (obj_t) (aux_14838);
   }
}


/* kwote/cinfo? */ bool_t 
kwote_cinfo__51_cfa_info(obj_t obj_1175)
{
   return is_a__118___object(obj_1175, kwote_cinfo_48_cfa_info);
}


/* _kwote/cinfo? */ obj_t 
_kwote_cinfo__102_cfa_info(obj_t env_9725, obj_t obj_9726)
{
   {
      bool_t aux_14842;
      aux_14842 = kwote_cinfo__51_cfa_info(obj_9726);
      return BBOOL(aux_14842);
   }
}


/* widening1014-kwote/cinfo */ kwote_cinfo_48_t 
widening1014_kwote_cinfo_146_cfa_info(approx_t approx_1176)
{
   {
      kwote_cinfo_48_t new1723_5736;
      new1723_5736 = ((kwote_cinfo_48_t) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
      ((((kwote_cinfo_48_t) CREF(new1723_5736))->approx) = ((approx_t) approx_1176), BUNSPEC);
      return new1723_5736;
   }
}


/* _widening1014-kwote/cinfo4327 */ obj_t 
_widening1014_kwote_cinfo4327_186_cfa_info(obj_t env_9727, obj_t approx_9728)
{
   {
      kwote_cinfo_48_t aux_14847;
      aux_14847 = widening1014_kwote_cinfo_146_cfa_info((approx_t) (approx_9728));
      return (obj_t) (aux_14847);
   }
}


/* make-kwote/cinfo */ kwote_cinfo_48_t 
make_kwote_cinfo_77_cfa_info(obj_t loc_1177, type_t type_1178, obj_t value_1179, approx_t approx_1180)
{
   {
      kwote_t aux1726_5738;
      {
	 kwote_t res3744_5752;
	 {
	    kwote_t new1271_5745;
	    new1271_5745 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
	    {
	       long arg3003_5746;
	       arg3003_5746 = class_num_218___object(kwote_ast_node);
	       {
		  obj_t obj_5750;
		  obj_5750 = (obj_t) (new1271_5745);
		  (((obj_t) CREF(obj_5750))->header = MAKE_HEADER(arg3003_5746, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14855;
	       aux_14855 = (object_t) (new1271_5745);
	       OBJECT_WIDENING_SET(aux_14855, BFALSE);
	    }
	    ((((kwote_t) CREF(new1271_5745))->loc) = ((obj_t) loc_1177), BUNSPEC);
	    ((((kwote_t) CREF(new1271_5745))->type) = ((type_t) type_1178), BUNSPEC);
	    ((((kwote_t) CREF(new1271_5745))->value) = ((obj_t) value_1179), BUNSPEC);
	    res3744_5752 = new1271_5745;
	 }
	 aux1726_5738 = res3744_5752;
      }
      {
	 kwote_cinfo_48_t new1727_5739;
	 new1727_5739 = ((kwote_cinfo_48_t) (aux1726_5738));
	 {
	    long arg2918_5740;
	    arg2918_5740 = class_num_218___object(kwote_cinfo_48_cfa_info);
	    {
	       obj_t obj_5753;
	       obj_5753 = (obj_t) (new1727_5739);
	       (((obj_t) CREF(obj_5753))->header = MAKE_HEADER(arg2918_5740, 0), BUNSPEC);
	    }
	 }
	 {
	    kwote_cinfo_48_t arg2919_5741;
	    {
	       kwote_cinfo_48_t res3745_5758;
	       {
		  kwote_cinfo_48_t new1723_5756;
		  new1723_5756 = ((kwote_cinfo_48_t) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
		  ((((kwote_cinfo_48_t) CREF(new1723_5756))->approx) = ((approx_t) approx_1180), BUNSPEC);
		  res3745_5758 = new1723_5756;
	       }
	       arg2919_5741 = res3745_5758;
	    }
	    {
	       obj_t aux_14869;
	       object_t aux_14867;
	       aux_14869 = (obj_t) (arg2919_5741);
	       aux_14867 = (object_t) (new1727_5739);
	       OBJECT_WIDENING_SET(aux_14867, aux_14869);
	    }
	 }
	 return new1727_5739;
      }
   }
}


/* _make-kwote/cinfo4328 */ obj_t 
_make_kwote_cinfo4328_235_cfa_info(obj_t env_9729, obj_t loc_9730, obj_t type_9731, obj_t value_9732, obj_t approx_9733)
{
   {
      kwote_cinfo_48_t aux_14872;
      aux_14872 = make_kwote_cinfo_77_cfa_info(loc_9730, (type_t) (type_9731), value_9732, (approx_t) (approx_9733));
      return (obj_t) (aux_14872);
   }
}


/* kwote/cinfo-loc */ obj_t 
kwote_cinfo_loc_185_cfa_info(kwote_t obj_1181)
{
   return (((kwote_t) CREF(obj_1181))->loc);
}


/* _kwote/cinfo-loc4329 */ obj_t 
_kwote_cinfo_loc4329_151_cfa_info(obj_t env_9734, obj_t obj_9735)
{
   return kwote_cinfo_loc_185_cfa_info((kwote_t) (obj_9735));
}


/* kwote/cinfo-type-set! */ obj_t 
kwote_cinfo_type_set__163_cfa_info(kwote_t obj_1182, type_t val1728_1183)
{
   return ((((kwote_t) CREF(obj_1182))->type) = ((type_t) val1728_1183), BUNSPEC);
}


/* _kwote/cinfo-type-set!4330 */ obj_t 
_kwote_cinfo_type_set_4330_243_cfa_info(obj_t env_9736, obj_t obj_9737, obj_t val1728_9738)
{
   return kwote_cinfo_type_set__163_cfa_info((kwote_t) (obj_9737), (type_t) (val1728_9738));
}


/* kwote/cinfo-type */ type_t 
kwote_cinfo_type_193_cfa_info(kwote_t obj_1184)
{
   return (((kwote_t) CREF(obj_1184))->type);
}


/* _kwote/cinfo-type4331 */ obj_t 
_kwote_cinfo_type4331_130_cfa_info(obj_t env_9739, obj_t obj_9740)
{
   {
      type_t aux_14885;
      aux_14885 = kwote_cinfo_type_193_cfa_info((kwote_t) (obj_9740));
      return (obj_t) (aux_14885);
   }
}


/* kwote/cinfo-value */ obj_t 
kwote_cinfo_value_171_cfa_info(kwote_t obj_1185)
{
   return (((kwote_t) CREF(obj_1185))->value);
}


/* _kwote/cinfo-value4332 */ obj_t 
_kwote_cinfo_value4332_237_cfa_info(obj_t env_9741, obj_t obj_9742)
{
   return kwote_cinfo_value_171_cfa_info((kwote_t) (obj_9742));
}


/* kwote/cinfo-approx */ approx_t 
kwote_cinfo_approx_226_cfa_info(kwote_cinfo_48_t obj_1186)
{
   {
      obj_t aux_14892;
      {
	 object_t aux_14893;
	 aux_14893 = (object_t) (obj_1186);
	 aux_14892 = OBJECT_WIDENING(aux_14893);
      }
      return (((kwote_cinfo_48_t) CREF(aux_14892))->approx);
   }
}


/* _kwote/cinfo-approx4333 */ obj_t 
_kwote_cinfo_approx4333_226_cfa_info(obj_t env_9743, obj_t obj_9744)
{
   {
      approx_t aux_14897;
      aux_14897 = kwote_cinfo_approx_226_cfa_info((kwote_cinfo_48_t) (obj_9744));
      return (obj_t) (aux_14897);
   }
}


/* allocate-kwote/node */ kwote_t 
allocate_kwote_node_139_cfa_info()
{
   {
      kwote_t new1716_2767;
      new1716_2767 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
      {
	 long arg2920_2768;
	 arg2920_2768 = class_num_218___object(kwote_node_102_cfa_info);
	 {
	    obj_t obj_5759;
	    obj_5759 = (obj_t) (new1716_2767);
	    (((obj_t) CREF(obj_5759))->header = MAKE_HEADER(arg2920_2768, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14905;
	 aux_14905 = (object_t) (new1716_2767);
	 OBJECT_WIDENING_SET(aux_14905, BFALSE);
      }
      return new1716_2767;
   }
}


/* _allocate-kwote/node */ obj_t 
_allocate_kwote_node_49_cfa_info(obj_t env_8033)
{
   {
      kwote_t aux_14908;
      aux_14908 = allocate_kwote_node_139_cfa_info();
      return (obj_t) (aux_14908);
   }
}


/* kwote/node? */ bool_t 
kwote_node__206_cfa_info(obj_t obj_1190)
{
   return is_a__118___object(obj_1190, kwote_node_102_cfa_info);
}


/* _kwote/node? */ obj_t 
_kwote_node__166_cfa_info(obj_t env_9745, obj_t obj_9746)
{
   {
      bool_t aux_14912;
      aux_14912 = kwote_node__206_cfa_info(obj_9746);
      return BBOOL(aux_14912);
   }
}


/* widening1013-kwote/node */ kwote_node_102_t 
widening1013_kwote_node_98_cfa_info(node_t node_1191)
{
   {
      kwote_node_102_t new1710_5761;
      new1710_5761 = ((kwote_node_102_t) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
      ((((kwote_node_102_t) CREF(new1710_5761))->node) = ((node_t) node_1191), BUNSPEC);
      return new1710_5761;
   }
}


/* _widening1013-kwote/node4334 */ obj_t 
_widening1013_kwote_node4334_113_cfa_info(obj_t env_9747, obj_t node_9748)
{
   {
      kwote_node_102_t aux_14917;
      aux_14917 = widening1013_kwote_node_98_cfa_info((node_t) (node_9748));
      return (obj_t) (aux_14917);
   }
}


/* make-kwote/node */ kwote_node_102_t 
make_kwote_node_13_cfa_info(obj_t loc_1192, type_t type_1193, obj_t value_1194, node_t node_1195)
{
   {
      kwote_t aux1713_5763;
      {
	 kwote_t res3746_5777;
	 {
	    kwote_t new1271_5770;
	    new1271_5770 = ((kwote_t) BREF(GC_MALLOC(sizeof(struct kwote))));
	    {
	       long arg3003_5771;
	       arg3003_5771 = class_num_218___object(kwote_ast_node);
	       {
		  obj_t obj_5775;
		  obj_5775 = (obj_t) (new1271_5770);
		  (((obj_t) CREF(obj_5775))->header = MAKE_HEADER(arg3003_5771, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14925;
	       aux_14925 = (object_t) (new1271_5770);
	       OBJECT_WIDENING_SET(aux_14925, BFALSE);
	    }
	    ((((kwote_t) CREF(new1271_5770))->loc) = ((obj_t) loc_1192), BUNSPEC);
	    ((((kwote_t) CREF(new1271_5770))->type) = ((type_t) type_1193), BUNSPEC);
	    ((((kwote_t) CREF(new1271_5770))->value) = ((obj_t) value_1194), BUNSPEC);
	    res3746_5777 = new1271_5770;
	 }
	 aux1713_5763 = res3746_5777;
      }
      {
	 kwote_node_102_t new1714_5764;
	 new1714_5764 = ((kwote_node_102_t) (aux1713_5763));
	 {
	    long arg2921_5765;
	    arg2921_5765 = class_num_218___object(kwote_node_102_cfa_info);
	    {
	       obj_t obj_5778;
	       obj_5778 = (obj_t) (new1714_5764);
	       (((obj_t) CREF(obj_5778))->header = MAKE_HEADER(arg2921_5765, 0), BUNSPEC);
	    }
	 }
	 {
	    kwote_node_102_t arg2922_5766;
	    {
	       kwote_node_102_t res3747_5783;
	       {
		  kwote_node_102_t new1710_5781;
		  new1710_5781 = ((kwote_node_102_t) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
		  ((((kwote_node_102_t) CREF(new1710_5781))->node) = ((node_t) node_1195), BUNSPEC);
		  res3747_5783 = new1710_5781;
	       }
	       arg2922_5766 = res3747_5783;
	    }
	    {
	       obj_t aux_14939;
	       object_t aux_14937;
	       aux_14939 = (obj_t) (arg2922_5766);
	       aux_14937 = (object_t) (new1714_5764);
	       OBJECT_WIDENING_SET(aux_14937, aux_14939);
	    }
	 }
	 return new1714_5764;
      }
   }
}


/* _make-kwote/node4335 */ obj_t 
_make_kwote_node4335_66_cfa_info(obj_t env_9749, obj_t loc_9750, obj_t type_9751, obj_t value_9752, obj_t node_9753)
{
   {
      kwote_node_102_t aux_14942;
      aux_14942 = make_kwote_node_13_cfa_info(loc_9750, (type_t) (type_9751), value_9752, (node_t) (node_9753));
      return (obj_t) (aux_14942);
   }
}


/* kwote/node-loc */ obj_t 
kwote_node_loc_4_cfa_info(kwote_t obj_1196)
{
   return (((kwote_t) CREF(obj_1196))->loc);
}


/* _kwote/node-loc4336 */ obj_t 
_kwote_node_loc4336_209_cfa_info(obj_t env_9754, obj_t obj_9755)
{
   return kwote_node_loc_4_cfa_info((kwote_t) (obj_9755));
}


/* kwote/node-type-set! */ obj_t 
kwote_node_type_set__67_cfa_info(kwote_t obj_1197, type_t val1715_1198)
{
   return ((((kwote_t) CREF(obj_1197))->type) = ((type_t) val1715_1198), BUNSPEC);
}


/* _kwote/node-type-set!4337 */ obj_t 
_kwote_node_type_set_4337_57_cfa_info(obj_t env_9756, obj_t obj_9757, obj_t val1715_9758)
{
   return kwote_node_type_set__67_cfa_info((kwote_t) (obj_9757), (type_t) (val1715_9758));
}


/* kwote/node-type */ type_t 
kwote_node_type_31_cfa_info(kwote_t obj_1199)
{
   return (((kwote_t) CREF(obj_1199))->type);
}


/* _kwote/node-type4338 */ obj_t 
_kwote_node_type4338_162_cfa_info(obj_t env_9759, obj_t obj_9760)
{
   {
      type_t aux_14955;
      aux_14955 = kwote_node_type_31_cfa_info((kwote_t) (obj_9760));
      return (obj_t) (aux_14955);
   }
}


/* kwote/node-value */ obj_t 
kwote_node_value_143_cfa_info(kwote_t obj_1200)
{
   return (((kwote_t) CREF(obj_1200))->value);
}


/* _kwote/node-value4339 */ obj_t 
_kwote_node_value4339_148_cfa_info(obj_t env_9761, obj_t obj_9762)
{
   return kwote_node_value_143_cfa_info((kwote_t) (obj_9762));
}


/* kwote/node-node */ node_t 
kwote_node_node_71_cfa_info(kwote_node_102_t obj_1201)
{
   {
      obj_t aux_14962;
      {
	 object_t aux_14963;
	 aux_14963 = (object_t) (obj_1201);
	 aux_14962 = OBJECT_WIDENING(aux_14963);
      }
      return (((kwote_node_102_t) CREF(aux_14962))->node);
   }
}


/* _kwote/node-node4340 */ obj_t 
_kwote_node_node4340_239_cfa_info(obj_t env_9763, obj_t obj_9764)
{
   {
      node_t aux_14967;
      aux_14967 = kwote_node_node_71_cfa_info((kwote_node_102_t) (obj_9764));
      return (obj_t) (aux_14967);
   }
}


/* allocate-atom/cinfo */ atom_t 
allocate_atom_cinfo_55_cfa_info()
{
   {
      atom_t new1703_2775;
      new1703_2775 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
      {
	 long arg2923_2776;
	 arg2923_2776 = class_num_218___object(atom_cinfo_155_cfa_info);
	 {
	    obj_t obj_5784;
	    obj_5784 = (obj_t) (new1703_2775);
	    (((obj_t) CREF(obj_5784))->header = MAKE_HEADER(arg2923_2776, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_14975;
	 aux_14975 = (object_t) (new1703_2775);
	 OBJECT_WIDENING_SET(aux_14975, BFALSE);
      }
      return new1703_2775;
   }
}


/* _allocate-atom/cinfo */ obj_t 
_allocate_atom_cinfo_64_cfa_info(obj_t env_8032)
{
   {
      atom_t aux_14978;
      aux_14978 = allocate_atom_cinfo_55_cfa_info();
      return (obj_t) (aux_14978);
   }
}


/* atom/cinfo? */ bool_t 
atom_cinfo__127_cfa_info(obj_t obj_1205)
{
   return is_a__118___object(obj_1205, atom_cinfo_155_cfa_info);
}


/* _atom/cinfo? */ obj_t 
_atom_cinfo__122_cfa_info(obj_t env_9765, obj_t obj_9766)
{
   {
      bool_t aux_14982;
      aux_14982 = atom_cinfo__127_cfa_info(obj_9766);
      return BBOOL(aux_14982);
   }
}


/* widening1012-atom/cinfo */ atom_cinfo_155_t 
widening1012_atom_cinfo_57_cfa_info(approx_t approx_1206)
{
   {
      atom_cinfo_155_t new1696_5786;
      new1696_5786 = ((atom_cinfo_155_t) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
      ((((atom_cinfo_155_t) CREF(new1696_5786))->approx) = ((approx_t) approx_1206), BUNSPEC);
      return new1696_5786;
   }
}


/* _widening1012-atom/cinfo4341 */ obj_t 
_widening1012_atom_cinfo4341_187_cfa_info(obj_t env_9767, obj_t approx_9768)
{
   {
      atom_cinfo_155_t aux_14987;
      aux_14987 = widening1012_atom_cinfo_57_cfa_info((approx_t) (approx_9768));
      return (obj_t) (aux_14987);
   }
}


/* make-atom/cinfo */ atom_cinfo_155_t 
make_atom_cinfo_25_cfa_info(obj_t loc_1207, type_t type_1208, obj_t value_1209, approx_t approx_1210)
{
   {
      atom_t aux1699_5788;
      {
	 atom_t res3748_5802;
	 {
	    atom_t new1247_5795;
	    new1247_5795 = ((atom_t) BREF(GC_MALLOC(sizeof(struct atom))));
	    {
	       long arg3009_5796;
	       arg3009_5796 = class_num_218___object(atom_ast_node);
	       {
		  obj_t obj_5800;
		  obj_5800 = (obj_t) (new1247_5795);
		  (((obj_t) CREF(obj_5800))->header = MAKE_HEADER(arg3009_5796, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_14995;
	       aux_14995 = (object_t) (new1247_5795);
	       OBJECT_WIDENING_SET(aux_14995, BFALSE);
	    }
	    ((((atom_t) CREF(new1247_5795))->loc) = ((obj_t) loc_1207), BUNSPEC);
	    ((((atom_t) CREF(new1247_5795))->type) = ((type_t) type_1208), BUNSPEC);
	    ((((atom_t) CREF(new1247_5795))->value) = ((obj_t) value_1209), BUNSPEC);
	    res3748_5802 = new1247_5795;
	 }
	 aux1699_5788 = res3748_5802;
      }
      {
	 atom_cinfo_155_t new1700_5789;
	 new1700_5789 = ((atom_cinfo_155_t) (aux1699_5788));
	 {
	    long arg2924_5790;
	    arg2924_5790 = class_num_218___object(atom_cinfo_155_cfa_info);
	    {
	       obj_t obj_5803;
	       obj_5803 = (obj_t) (new1700_5789);
	       (((obj_t) CREF(obj_5803))->header = MAKE_HEADER(arg2924_5790, 0), BUNSPEC);
	    }
	 }
	 {
	    atom_cinfo_155_t arg2925_5791;
	    {
	       atom_cinfo_155_t res3749_5808;
	       {
		  atom_cinfo_155_t new1696_5806;
		  new1696_5806 = ((atom_cinfo_155_t) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
		  ((((atom_cinfo_155_t) CREF(new1696_5806))->approx) = ((approx_t) approx_1210), BUNSPEC);
		  res3749_5808 = new1696_5806;
	       }
	       arg2925_5791 = res3749_5808;
	    }
	    {
	       obj_t aux_15009;
	       object_t aux_15007;
	       aux_15009 = (obj_t) (arg2925_5791);
	       aux_15007 = (object_t) (new1700_5789);
	       OBJECT_WIDENING_SET(aux_15007, aux_15009);
	    }
	 }
	 return new1700_5789;
      }
   }
}


/* _make-atom/cinfo4342 */ obj_t 
_make_atom_cinfo4342_156_cfa_info(obj_t env_9769, obj_t loc_9770, obj_t type_9771, obj_t value_9772, obj_t approx_9773)
{
   {
      atom_cinfo_155_t aux_15012;
      aux_15012 = make_atom_cinfo_25_cfa_info(loc_9770, (type_t) (type_9771), value_9772, (approx_t) (approx_9773));
      return (obj_t) (aux_15012);
   }
}


/* atom/cinfo-loc */ obj_t 
atom_cinfo_loc_162_cfa_info(atom_t obj_1211)
{
   return (((atom_t) CREF(obj_1211))->loc);
}


/* _atom/cinfo-loc4343 */ obj_t 
_atom_cinfo_loc4343_195_cfa_info(obj_t env_9774, obj_t obj_9775)
{
   return atom_cinfo_loc_162_cfa_info((atom_t) (obj_9775));
}


/* atom/cinfo-type-set! */ obj_t 
atom_cinfo_type_set__31_cfa_info(atom_t obj_1212, type_t val1701_1213)
{
   return ((((atom_t) CREF(obj_1212))->type) = ((type_t) val1701_1213), BUNSPEC);
}


/* _atom/cinfo-type-set!4344 */ obj_t 
_atom_cinfo_type_set_4344_128_cfa_info(obj_t env_9776, obj_t obj_9777, obj_t val1701_9778)
{
   return atom_cinfo_type_set__31_cfa_info((atom_t) (obj_9777), (type_t) (val1701_9778));
}


/* atom/cinfo-type */ type_t 
atom_cinfo_type_135_cfa_info(atom_t obj_1214)
{
   return (((atom_t) CREF(obj_1214))->type);
}


/* _atom/cinfo-type4345 */ obj_t 
_atom_cinfo_type4345_80_cfa_info(obj_t env_9779, obj_t obj_9780)
{
   {
      type_t aux_15025;
      aux_15025 = atom_cinfo_type_135_cfa_info((atom_t) (obj_9780));
      return (obj_t) (aux_15025);
   }
}


/* atom/cinfo-value-set! */ obj_t 
atom_cinfo_value_set__32_cfa_info(atom_t obj_1215, obj_t val1702_1216)
{
   return ((((atom_t) CREF(obj_1215))->value) = ((obj_t) val1702_1216), BUNSPEC);
}


/* _atom/cinfo-value-set!4346 */ obj_t 
_atom_cinfo_value_set_4346_19_cfa_info(obj_t env_9781, obj_t obj_9782, obj_t val1702_9783)
{
   return atom_cinfo_value_set__32_cfa_info((atom_t) (obj_9782), val1702_9783);
}


/* atom/cinfo-value */ obj_t 
atom_cinfo_value_110_cfa_info(atom_t obj_1217)
{
   return (((atom_t) CREF(obj_1217))->value);
}


/* _atom/cinfo-value4347 */ obj_t 
_atom_cinfo_value4347_202_cfa_info(obj_t env_9784, obj_t obj_9785)
{
   return atom_cinfo_value_110_cfa_info((atom_t) (obj_9785));
}


/* atom/cinfo-approx */ approx_t 
atom_cinfo_approx_215_cfa_info(atom_cinfo_155_t obj_1218)
{
   {
      obj_t aux_15035;
      {
	 object_t aux_15036;
	 aux_15036 = (object_t) (obj_1218);
	 aux_15035 = OBJECT_WIDENING(aux_15036);
      }
      return (((atom_cinfo_155_t) CREF(aux_15035))->approx);
   }
}


/* _atom/cinfo-approx4348 */ obj_t 
_atom_cinfo_approx4348_99_cfa_info(obj_t env_9786, obj_t obj_9787)
{
   {
      approx_t aux_15040;
      aux_15040 = atom_cinfo_approx_215_cfa_info((atom_cinfo_155_t) (obj_9787));
      return (obj_t) (aux_15040);
   }
}


/* allocate-reshaped-global */ global_t 
allocate_reshaped_global_131_cfa_info()
{
   {
      global_t new1689_2783;
      new1689_2783 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
      {
	 long arg2926_2784;
	 arg2926_2784 = class_num_218___object(reshaped_global_160_cfa_info);
	 {
	    obj_t obj_5809;
	    obj_5809 = (obj_t) (new1689_2783);
	    (((obj_t) CREF(obj_5809))->header = MAKE_HEADER(arg2926_2784, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15048;
	 aux_15048 = (object_t) (new1689_2783);
	 OBJECT_WIDENING_SET(aux_15048, BFALSE);
      }
      return new1689_2783;
   }
}


/* _allocate-reshaped-global */ obj_t 
_allocate_reshaped_global_82_cfa_info(obj_t env_8031)
{
   {
      global_t aux_15051;
      aux_15051 = allocate_reshaped_global_131_cfa_info();
      return (obj_t) (aux_15051);
   }
}


/* reshaped-global? */ bool_t 
reshaped_global__139_cfa_info(obj_t obj_1222)
{
   return is_a__118___object(obj_1222, reshaped_global_160_cfa_info);
}


/* _reshaped-global? */ obj_t 
_reshaped_global__169_cfa_info(obj_t env_9788, obj_t obj_9789)
{
   {
      bool_t aux_15055;
      aux_15055 = reshaped_global__139_cfa_info(obj_9789);
      return BBOOL(aux_15055);
   }
}


/* widening1011-reshaped-global */ reshaped_global_160_t 
widening1011_reshaped_global_190_cfa_info()
{
   {
      return ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
   }
}


/* _widening1011-reshaped-global */ obj_t 
_widening1011_reshaped_global_101_cfa_info(obj_t env_9790)
{
   {
      reshaped_global_160_t aux_15059;
      aux_15059 = widening1011_reshaped_global_190_cfa_info();
      return (obj_t) (aux_15059);
   }
}


/* make-reshaped-global */ reshaped_global_160_t 
make_reshaped_global_202_cfa_info(obj_t id_1223, obj_t name_1224, type_t type_1225, value_t value_1226, obj_t access_1227, obj_t fast_alpha_7_1228, obj_t removable_1229, long occurrence_1230, obj_t module_1231, obj_t import_1232, bool_t evaluable__248_1233, bool_t library__255_1234, bool_t user__32_1235, obj_t pragma_1236, obj_t src_1237)
{
   {
      global_t aux1675_5812;
      {
	 global_t res3750_5850;
	 {
	    global_t new1098_5831;
	    new1098_5831 = ((global_t) BREF(GC_MALLOC(sizeof(struct global))));
	    {
	       long arg3031_5832;
	       arg3031_5832 = class_num_218___object(global_ast_var);
	       {
		  obj_t obj_5848;
		  obj_5848 = (obj_t) (new1098_5831);
		  (((obj_t) CREF(obj_5848))->header = MAKE_HEADER(arg3031_5832, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15066;
	       aux_15066 = (object_t) (new1098_5831);
	       OBJECT_WIDENING_SET(aux_15066, BFALSE);
	    }
	    ((((global_t) CREF(new1098_5831))->id) = ((obj_t) id_1223), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->name) = ((obj_t) name_1224), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->type) = ((type_t) type_1225), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->value) = ((value_t) value_1226), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->access) = ((obj_t) access_1227), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->fast_alpha_7) = ((obj_t) fast_alpha_7_1228), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->removable) = ((obj_t) removable_1229), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->occurrence) = ((long) occurrence_1230), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->module) = ((obj_t) module_1231), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->import) = ((obj_t) import_1232), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->evaluable__248) = ((bool_t) evaluable__248_1233), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->library__255) = ((bool_t) library__255_1234), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->user__32) = ((bool_t) user__32_1235), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->pragma) = ((obj_t) pragma_1236), BUNSPEC);
	    ((((global_t) CREF(new1098_5831))->src) = ((obj_t) src_1237), BUNSPEC);
	    res3750_5850 = new1098_5831;
	 }
	 aux1675_5812 = res3750_5850;
      }
      {
	 reshaped_global_160_t new1676_5813;
	 new1676_5813 = ((reshaped_global_160_t) (aux1675_5812));
	 {
	    long arg2927_5814;
	    arg2927_5814 = class_num_218___object(reshaped_global_160_cfa_info);
	    {
	       obj_t obj_5851;
	       obj_5851 = (obj_t) (new1676_5813);
	       (((obj_t) CREF(obj_5851))->header = MAKE_HEADER(arg2927_5814, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_15090;
	    object_t aux_15088;
	    {
	       reshaped_global_160_t aux_15091;
	       {
		  aux_15091 = ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
	       }
	       aux_15090 = (obj_t) (aux_15091);
	    }
	    aux_15088 = (object_t) (new1676_5813);
	    OBJECT_WIDENING_SET(aux_15088, aux_15090);
	 }
	 return new1676_5813;
      }
   }
}


/* _make-reshaped-global4349 */ obj_t 
_make_reshaped_global4349_214_cfa_info(obj_t env_9791, obj_t id_9792, obj_t name_9793, obj_t type_9794, obj_t value_9795, obj_t access_9796, obj_t fast_alpha_7_9797, obj_t removable_9798, obj_t occurrence_9799, obj_t module_9800, obj_t import_9801, obj_t evaluable__248_9802, obj_t library__255_9803, obj_t user__32_9804, obj_t pragma_9805, obj_t src_9806)
{
   {
      reshaped_global_160_t aux_15095;
      aux_15095 = make_reshaped_global_202_cfa_info(id_9792, name_9793, (type_t) (type_9794), (value_t) (value_9795), access_9796, fast_alpha_7_9797, removable_9798, (long) CINT(occurrence_9799), module_9800, import_9801, CBOOL(evaluable__248_9802), CBOOL(library__255_9803), CBOOL(user__32_9804), pragma_9805, src_9806);
      return (obj_t) (aux_15095);
   }
}


/* reshaped-global-id */ obj_t 
reshaped_global_id_236_cfa_info(global_t obj_1238)
{
   return (((global_t) CREF(obj_1238))->id);
}


/* _reshaped-global-id4350 */ obj_t 
_reshaped_global_id4350_75_cfa_info(obj_t env_9807, obj_t obj_9808)
{
   return reshaped_global_id_236_cfa_info((global_t) (obj_9808));
}


/* reshaped-global-name-set! */ obj_t 
reshaped_global_name_set__33_cfa_info(global_t obj_1239, obj_t val1677_1240)
{
   return ((((global_t) CREF(obj_1239))->name) = ((obj_t) val1677_1240), BUNSPEC);
}


/* _reshaped-global-name-set!4351 */ obj_t 
_reshaped_global_name_set_4351_195_cfa_info(obj_t env_9809, obj_t obj_9810, obj_t val1677_9811)
{
   return reshaped_global_name_set__33_cfa_info((global_t) (obj_9810), val1677_9811);
}


/* reshaped-global-name */ obj_t 
reshaped_global_name_190_cfa_info(global_t obj_1241)
{
   return (((global_t) CREF(obj_1241))->name);
}


/* _reshaped-global-name4352 */ obj_t 
_reshaped_global_name4352_232_cfa_info(obj_t env_9812, obj_t obj_9813)
{
   return reshaped_global_name_190_cfa_info((global_t) (obj_9813));
}


/* reshaped-global-type-set! */ obj_t 
reshaped_global_type_set__56_cfa_info(global_t obj_1242, type_t val1678_1243)
{
   return ((((global_t) CREF(obj_1242))->type) = ((type_t) val1678_1243), BUNSPEC);
}


/* _reshaped-global-type-set!4353 */ obj_t 
_reshaped_global_type_set_4353_23_cfa_info(obj_t env_9814, obj_t obj_9815, obj_t val1678_9816)
{
   return reshaped_global_type_set__56_cfa_info((global_t) (obj_9815), (type_t) (val1678_9816));
}


/* reshaped-global-type */ type_t 
reshaped_global_type_121_cfa_info(global_t obj_1244)
{
   return (((global_t) CREF(obj_1244))->type);
}


/* _reshaped-global-type4354 */ obj_t 
_reshaped_global_type4354_0_cfa_info(obj_t env_9817, obj_t obj_9818)
{
   {
      type_t aux_15118;
      aux_15118 = reshaped_global_type_121_cfa_info((global_t) (obj_9818));
      return (obj_t) (aux_15118);
   }
}


/* reshaped-global-value-set! */ obj_t 
reshaped_global_value_set__202_cfa_info(global_t obj_1245, value_t val1679_1246)
{
   return ((((global_t) CREF(obj_1245))->value) = ((value_t) val1679_1246), BUNSPEC);
}


/* _reshaped-global-value-set!4355 */ obj_t 
_reshaped_global_value_set_4355_229_cfa_info(obj_t env_9819, obj_t obj_9820, obj_t val1679_9821)
{
   return reshaped_global_value_set__202_cfa_info((global_t) (obj_9820), (value_t) (val1679_9821));
}


/* reshaped-global-value */ value_t 
reshaped_global_value_27_cfa_info(global_t obj_1247)
{
   return (((global_t) CREF(obj_1247))->value);
}


/* _reshaped-global-value4356 */ obj_t 
_reshaped_global_value4356_90_cfa_info(obj_t env_9822, obj_t obj_9823)
{
   {
      value_t aux_15127;
      aux_15127 = reshaped_global_value_27_cfa_info((global_t) (obj_9823));
      return (obj_t) (aux_15127);
   }
}


/* reshaped-global-access-set! */ obj_t 
reshaped_global_access_set__53_cfa_info(global_t obj_1248, obj_t val1680_1249)
{
   return ((((global_t) CREF(obj_1248))->access) = ((obj_t) val1680_1249), BUNSPEC);
}


/* _reshaped-global-access-set!4357 */ obj_t 
_reshaped_global_access_set_4357_87_cfa_info(obj_t env_9824, obj_t obj_9825, obj_t val1680_9826)
{
   return reshaped_global_access_set__53_cfa_info((global_t) (obj_9825), val1680_9826);
}


/* reshaped-global-access */ obj_t 
reshaped_global_access_146_cfa_info(global_t obj_1250)
{
   return (((global_t) CREF(obj_1250))->access);
}


/* _reshaped-global-access4358 */ obj_t 
_reshaped_global_access4358_220_cfa_info(obj_t env_9827, obj_t obj_9828)
{
   return reshaped_global_access_146_cfa_info((global_t) (obj_9828));
}


/* reshaped-global-fast-alpha-set! */ obj_t 
reshaped_global_fast_alpha_set__126_cfa_info(global_t obj_1251, obj_t val1681_1252)
{
   return ((((global_t) CREF(obj_1251))->fast_alpha_7) = ((obj_t) val1681_1252), BUNSPEC);
}


/* _reshaped-global-fast-alpha-set!4359 */ obj_t 
_reshaped_global_fast_alpha_set_4359_174_cfa_info(obj_t env_9829, obj_t obj_9830, obj_t val1681_9831)
{
   return reshaped_global_fast_alpha_set__126_cfa_info((global_t) (obj_9830), val1681_9831);
}


/* reshaped-global-fast-alpha */ obj_t 
reshaped_global_fast_alpha_178_cfa_info(global_t obj_1253)
{
   return (((global_t) CREF(obj_1253))->fast_alpha_7);
}


/* _reshaped-global-fast-alpha4360 */ obj_t 
_reshaped_global_fast_alpha4360_7_cfa_info(obj_t env_9832, obj_t obj_9833)
{
   return reshaped_global_fast_alpha_178_cfa_info((global_t) (obj_9833));
}


/* reshaped-global-removable-set! */ obj_t 
reshaped_global_removable_set__53_cfa_info(global_t obj_1254, obj_t val1682_1255)
{
   return ((((global_t) CREF(obj_1254))->removable) = ((obj_t) val1682_1255), BUNSPEC);
}


/* _reshaped-global-removable-set!4361 */ obj_t 
_reshaped_global_removable_set_4361_50_cfa_info(obj_t env_9834, obj_t obj_9835, obj_t val1682_9836)
{
   return reshaped_global_removable_set__53_cfa_info((global_t) (obj_9835), val1682_9836);
}


/* reshaped-global-removable */ obj_t 
reshaped_global_removable_146_cfa_info(global_t obj_1256)
{
   return (((global_t) CREF(obj_1256))->removable);
}


/* _reshaped-global-removable4362 */ obj_t 
_reshaped_global_removable4362_127_cfa_info(obj_t env_9837, obj_t obj_9838)
{
   return reshaped_global_removable_146_cfa_info((global_t) (obj_9838));
}


/* reshaped-global-occurrence-set! */ obj_t 
reshaped_global_occurrence_set__92_cfa_info(global_t obj_1257, long val1683_1258)
{
   return ((((global_t) CREF(obj_1257))->occurrence) = ((long) val1683_1258), BUNSPEC);
}


/* _reshaped-global-occurrence-set!4363 */ obj_t 
_reshaped_global_occurrence_set_4363_110_cfa_info(obj_t env_9839, obj_t obj_9840, obj_t val1683_9841)
{
   return reshaped_global_occurrence_set__92_cfa_info((global_t) (obj_9840), (long) CINT(val1683_9841));
}


/* reshaped-global-occurrence */ long 
reshaped_global_occurrence_72_cfa_info(global_t obj_1259)
{
   return (((global_t) CREF(obj_1259))->occurrence);
}


/* _reshaped-global-occurrence4364 */ obj_t 
_reshaped_global_occurrence4364_159_cfa_info(obj_t env_9842, obj_t obj_9843)
{
   {
      long aux_15154;
      aux_15154 = reshaped_global_occurrence_72_cfa_info((global_t) (obj_9843));
      return BINT(aux_15154);
   }
}


/* reshaped-global-module */ obj_t 
reshaped_global_module_134_cfa_info(global_t obj_1260)
{
   return (((global_t) CREF(obj_1260))->module);
}


/* _reshaped-global-module4365 */ obj_t 
_reshaped_global_module4365_231_cfa_info(obj_t env_9844, obj_t obj_9845)
{
   return reshaped_global_module_134_cfa_info((global_t) (obj_9845));
}


/* reshaped-global-import-set! */ obj_t 
reshaped_global_import_set__167_cfa_info(global_t obj_1261, obj_t val1684_1262)
{
   return ((((global_t) CREF(obj_1261))->import) = ((obj_t) val1684_1262), BUNSPEC);
}


/* _reshaped-global-import-set!4366 */ obj_t 
_reshaped_global_import_set_4366_139_cfa_info(obj_t env_9846, obj_t obj_9847, obj_t val1684_9848)
{
   return reshaped_global_import_set__167_cfa_info((global_t) (obj_9847), val1684_9848);
}


/* reshaped-global-import */ obj_t 
reshaped_global_import_91_cfa_info(global_t obj_1263)
{
   return (((global_t) CREF(obj_1263))->import);
}


/* _reshaped-global-import4367 */ obj_t 
_reshaped_global_import4367_113_cfa_info(obj_t env_9849, obj_t obj_9850)
{
   return reshaped_global_import_91_cfa_info((global_t) (obj_9850));
}


/* reshaped-global-evaluable?-set! */ obj_t 
reshaped_global_evaluable__set__240_cfa_info(global_t obj_1264, bool_t val1685_1265)
{
   return ((((global_t) CREF(obj_1264))->evaluable__248) = ((bool_t) val1685_1265), BUNSPEC);
}


/* _reshaped-global-evaluable?-set!4368 */ obj_t 
_reshaped_global_evaluable__set_4368_13_cfa_info(obj_t env_9851, obj_t obj_9852, obj_t val1685_9853)
{
   return reshaped_global_evaluable__set__240_cfa_info((global_t) (obj_9852), CBOOL(val1685_9853));
}


/* reshaped-global-evaluable? */ bool_t 
reshaped_global_evaluable__213_cfa_info(global_t obj_1266)
{
   return (((global_t) CREF(obj_1266))->evaluable__248);
}


/* _reshaped-global-evaluable?4369 */ obj_t 
_reshaped_global_evaluable_4369_74_cfa_info(obj_t env_9854, obj_t obj_9855)
{
   {
      bool_t aux_15172;
      aux_15172 = reshaped_global_evaluable__213_cfa_info((global_t) (obj_9855));
      return BBOOL(aux_15172);
   }
}


/* reshaped-global-library?-set! */ obj_t 
reshaped_global_library__set__109_cfa_info(global_t obj_1267, bool_t val1686_1268)
{
   return ((((global_t) CREF(obj_1267))->library__255) = ((bool_t) val1686_1268), BUNSPEC);
}


/* _reshaped-global-library?-set!4370 */ obj_t 
_reshaped_global_library__set_4370_158_cfa_info(obj_t env_9856, obj_t obj_9857, obj_t val1686_9858)
{
   return reshaped_global_library__set__109_cfa_info((global_t) (obj_9857), CBOOL(val1686_9858));
}


/* reshaped-global-library? */ bool_t 
reshaped_global_library__243_cfa_info(global_t obj_1269)
{
   return (((global_t) CREF(obj_1269))->library__255);
}


/* _reshaped-global-library?4371 */ obj_t 
_reshaped_global_library_4371_56_cfa_info(obj_t env_9859, obj_t obj_9860)
{
   {
      bool_t aux_15181;
      aux_15181 = reshaped_global_library__243_cfa_info((global_t) (obj_9860));
      return BBOOL(aux_15181);
   }
}


/* reshaped-global-user?-set! */ obj_t 
reshaped_global_user__set__184_cfa_info(global_t obj_1270, bool_t val1687_1271)
{
   return ((((global_t) CREF(obj_1270))->user__32) = ((bool_t) val1687_1271), BUNSPEC);
}


/* _reshaped-global-user?-set!4372 */ obj_t 
_reshaped_global_user__set_4372_177_cfa_info(obj_t env_9861, obj_t obj_9862, obj_t val1687_9863)
{
   return reshaped_global_user__set__184_cfa_info((global_t) (obj_9862), CBOOL(val1687_9863));
}


/* reshaped-global-user? */ bool_t 
reshaped_global_user__181_cfa_info(global_t obj_1272)
{
   return (((global_t) CREF(obj_1272))->user__32);
}


/* _reshaped-global-user?4373 */ obj_t 
_reshaped_global_user_4373_223_cfa_info(obj_t env_9864, obj_t obj_9865)
{
   {
      bool_t aux_15190;
      aux_15190 = reshaped_global_user__181_cfa_info((global_t) (obj_9865));
      return BBOOL(aux_15190);
   }
}


/* reshaped-global-pragma */ obj_t 
reshaped_global_pragma_7_cfa_info(global_t obj_1273)
{
   return (((global_t) CREF(obj_1273))->pragma);
}


/* _reshaped-global-pragma4374 */ obj_t 
_reshaped_global_pragma4374_115_cfa_info(obj_t env_9866, obj_t obj_9867)
{
   return reshaped_global_pragma_7_cfa_info((global_t) (obj_9867));
}


/* reshaped-global-src-set! */ obj_t 
reshaped_global_src_set__220_cfa_info(global_t obj_1274, obj_t val1688_1275)
{
   return ((((global_t) CREF(obj_1274))->src) = ((obj_t) val1688_1275), BUNSPEC);
}


/* _reshaped-global-src-set!4375 */ obj_t 
_reshaped_global_src_set_4375_186_cfa_info(obj_t env_9868, obj_t obj_9869, obj_t val1688_9870)
{
   return reshaped_global_src_set__220_cfa_info((global_t) (obj_9869), val1688_9870);
}


/* reshaped-global-src */ obj_t 
reshaped_global_src_255_cfa_info(global_t obj_1276)
{
   return (((global_t) CREF(obj_1276))->src);
}


/* _reshaped-global-src4376 */ obj_t 
_reshaped_global_src4376_17_cfa_info(obj_t env_9871, obj_t obj_9872)
{
   return reshaped_global_src_255_cfa_info((global_t) (obj_9872));
}


/* allocate-reshaped-local */ local_t 
allocate_reshaped_local_100_cfa_info()
{
   {
      local_t new1666_2790;
      new1666_2790 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
      {
	 long arg2929_2791;
	 arg2929_2791 = class_num_218___object(reshaped_local_224_cfa_info);
	 {
	    obj_t obj_5855;
	    obj_5855 = (obj_t) (new1666_2790);
	    (((obj_t) CREF(obj_5855))->header = MAKE_HEADER(arg2929_2791, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15207;
	 aux_15207 = (object_t) (new1666_2790);
	 OBJECT_WIDENING_SET(aux_15207, BFALSE);
      }
      return new1666_2790;
   }
}


/* _allocate-reshaped-local */ obj_t 
_allocate_reshaped_local_17_cfa_info(obj_t env_8030)
{
   {
      local_t aux_15210;
      aux_15210 = allocate_reshaped_local_100_cfa_info();
      return (obj_t) (aux_15210);
   }
}


/* reshaped-local? */ bool_t 
reshaped_local__109_cfa_info(obj_t obj_1280)
{
   return is_a__118___object(obj_1280, reshaped_local_224_cfa_info);
}


/* _reshaped-local? */ obj_t 
_reshaped_local__93_cfa_info(obj_t env_9873, obj_t obj_9874)
{
   {
      bool_t aux_15214;
      aux_15214 = reshaped_local__109_cfa_info(obj_9874);
      return BBOOL(aux_15214);
   }
}


/* widening1010-reshaped-local */ reshaped_local_224_t 
widening1010_reshaped_local_53_cfa_info(obj_t binding_value_3_1281)
{
   {
      reshaped_local_224_t new1653_5857;
      new1653_5857 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
      ((((reshaped_local_224_t) CREF(new1653_5857))->binding_value_3) = ((obj_t) binding_value_3_1281), BUNSPEC);
      return new1653_5857;
   }
}


/* _widening1010-reshaped-local */ obj_t 
_widening1010_reshaped_local_27_cfa_info(obj_t env_9875, obj_t binding_value_3_9876)
{
   {
      reshaped_local_224_t aux_15219;
      aux_15219 = widening1010_reshaped_local_53_cfa_info(binding_value_3_9876);
      return (obj_t) (aux_15219);
   }
}


/* make-reshaped-local */ reshaped_local_224_t 
make_reshaped_local_12_cfa_info(obj_t id_1282, obj_t name_1283, type_t type_1284, value_t value_1285, obj_t access_1286, obj_t fast_alpha_7_1287, obj_t removable_1288, long occurrence_1289, bool_t user__32_1290, long key_1291, obj_t binding_value_3_1292)
{
   {
      local_t aux1656_5859;
      {
	 local_t res3752_5887;
	 {
	    local_t new1128_5873;
	    new1128_5873 = ((local_t) BREF(GC_MALLOC(sizeof(struct local))));
	    {
	       long arg3029_5874;
	       arg3029_5874 = class_num_218___object(local_ast_var);
	       {
		  obj_t obj_5885;
		  obj_5885 = (obj_t) (new1128_5873);
		  (((obj_t) CREF(obj_5885))->header = MAKE_HEADER(arg3029_5874, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15226;
	       aux_15226 = (object_t) (new1128_5873);
	       OBJECT_WIDENING_SET(aux_15226, BFALSE);
	    }
	    ((((local_t) CREF(new1128_5873))->id) = ((obj_t) id_1282), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->name) = ((obj_t) name_1283), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->type) = ((type_t) type_1284), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->value) = ((value_t) value_1285), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->access) = ((obj_t) access_1286), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->fast_alpha_7) = ((obj_t) fast_alpha_7_1287), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->removable) = ((obj_t) removable_1288), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->occurrence) = ((long) occurrence_1289), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->user__32) = ((bool_t) user__32_1290), BUNSPEC);
	    ((((local_t) CREF(new1128_5873))->key) = ((long) key_1291), BUNSPEC);
	    res3752_5887 = new1128_5873;
	 }
	 aux1656_5859 = res3752_5887;
      }
      {
	 reshaped_local_224_t new1657_5860;
	 new1657_5860 = ((reshaped_local_224_t) (aux1656_5859));
	 {
	    long arg2930_5861;
	    arg2930_5861 = class_num_218___object(reshaped_local_224_cfa_info);
	    {
	       obj_t obj_5888;
	       obj_5888 = (obj_t) (new1657_5860);
	       (((obj_t) CREF(obj_5888))->header = MAKE_HEADER(arg2930_5861, 0), BUNSPEC);
	    }
	 }
	 {
	    reshaped_local_224_t arg2931_5862;
	    {
	       reshaped_local_224_t res3753_5893;
	       {
		  reshaped_local_224_t new1653_5891;
		  new1653_5891 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
		  ((((reshaped_local_224_t) CREF(new1653_5891))->binding_value_3) = ((obj_t) binding_value_3_1292), BUNSPEC);
		  res3753_5893 = new1653_5891;
	       }
	       arg2931_5862 = res3753_5893;
	    }
	    {
	       obj_t aux_15247;
	       object_t aux_15245;
	       aux_15247 = (obj_t) (arg2931_5862);
	       aux_15245 = (object_t) (new1657_5860);
	       OBJECT_WIDENING_SET(aux_15245, aux_15247);
	    }
	 }
	 return new1657_5860;
      }
   }
}


/* _make-reshaped-local4377 */ obj_t 
_make_reshaped_local4377_222_cfa_info(obj_t env_9877, obj_t id_9878, obj_t name_9879, obj_t type_9880, obj_t value_9881, obj_t access_9882, obj_t fast_alpha_7_9883, obj_t removable_9884, obj_t occurrence_9885, obj_t user__32_9886, obj_t key_9887, obj_t binding_value_3_9888)
{
   {
      reshaped_local_224_t aux_15250;
      aux_15250 = make_reshaped_local_12_cfa_info(id_9878, name_9879, (type_t) (type_9880), (value_t) (value_9881), access_9882, fast_alpha_7_9883, removable_9884, (long) CINT(occurrence_9885), CBOOL(user__32_9886), (long) CINT(key_9887), binding_value_3_9888);
      return (obj_t) (aux_15250);
   }
}


/* reshaped-local-id */ obj_t 
reshaped_local_id_99_cfa_info(local_t obj_1293)
{
   return (((local_t) CREF(obj_1293))->id);
}


/* _reshaped-local-id4378 */ obj_t 
_reshaped_local_id4378_67_cfa_info(obj_t env_9889, obj_t obj_9890)
{
   return reshaped_local_id_99_cfa_info((local_t) (obj_9890));
}


/* reshaped-local-name-set! */ obj_t 
reshaped_local_name_set__115_cfa_info(local_t obj_1294, obj_t val1658_1295)
{
   return ((((local_t) CREF(obj_1294))->name) = ((obj_t) val1658_1295), BUNSPEC);
}


/* _reshaped-local-name-set!4379 */ obj_t 
_reshaped_local_name_set_4379_233_cfa_info(obj_t env_9891, obj_t obj_9892, obj_t val1658_9893)
{
   return reshaped_local_name_set__115_cfa_info((local_t) (obj_9892), val1658_9893);
}


/* reshaped-local-name */ obj_t 
reshaped_local_name_22_cfa_info(local_t obj_1296)
{
   return (((local_t) CREF(obj_1296))->name);
}


/* _reshaped-local-name4380 */ obj_t 
_reshaped_local_name4380_238_cfa_info(obj_t env_9894, obj_t obj_9895)
{
   return reshaped_local_name_22_cfa_info((local_t) (obj_9895));
}


/* reshaped-local-type-set! */ obj_t 
reshaped_local_type_set__241_cfa_info(local_t obj_1297, type_t val1659_1298)
{
   return ((((local_t) CREF(obj_1297))->type) = ((type_t) val1659_1298), BUNSPEC);
}


/* _reshaped-local-type-set!4381 */ obj_t 
_reshaped_local_type_set_4381_49_cfa_info(obj_t env_9896, obj_t obj_9897, obj_t val1659_9898)
{
   return reshaped_local_type_set__241_cfa_info((local_t) (obj_9897), (type_t) (val1659_9898));
}


/* reshaped-local-type */ type_t 
reshaped_local_type_195_cfa_info(local_t obj_1299)
{
   return (((local_t) CREF(obj_1299))->type);
}


/* _reshaped-local-type4382 */ obj_t 
_reshaped_local_type4382_168_cfa_info(obj_t env_9899, obj_t obj_9900)
{
   {
      type_t aux_15272;
      aux_15272 = reshaped_local_type_195_cfa_info((local_t) (obj_9900));
      return (obj_t) (aux_15272);
   }
}


/* reshaped-local-value-set! */ obj_t 
reshaped_local_value_set__28_cfa_info(local_t obj_1300, value_t val1660_1301)
{
   return ((((local_t) CREF(obj_1300))->value) = ((value_t) val1660_1301), BUNSPEC);
}


/* _reshaped-local-value-set!4383 */ obj_t 
_reshaped_local_value_set_4383_162_cfa_info(obj_t env_9901, obj_t obj_9902, obj_t val1660_9903)
{
   return reshaped_local_value_set__28_cfa_info((local_t) (obj_9902), (value_t) (val1660_9903));
}


/* reshaped-local-value */ value_t 
reshaped_local_value_240_cfa_info(local_t obj_1302)
{
   return (((local_t) CREF(obj_1302))->value);
}


/* _reshaped-local-value4384 */ obj_t 
_reshaped_local_value4384_82_cfa_info(obj_t env_9904, obj_t obj_9905)
{
   {
      value_t aux_15281;
      aux_15281 = reshaped_local_value_240_cfa_info((local_t) (obj_9905));
      return (obj_t) (aux_15281);
   }
}


/* reshaped-local-access-set! */ obj_t 
reshaped_local_access_set__128_cfa_info(local_t obj_1303, obj_t val1661_1304)
{
   return ((((local_t) CREF(obj_1303))->access) = ((obj_t) val1661_1304), BUNSPEC);
}


/* _reshaped-local-access-set!4385 */ obj_t 
_reshaped_local_access_set_4385_25_cfa_info(obj_t env_9906, obj_t obj_9907, obj_t val1661_9908)
{
   return reshaped_local_access_set__128_cfa_info((local_t) (obj_9907), val1661_9908);
}


/* reshaped-local-access */ obj_t 
reshaped_local_access_5_cfa_info(local_t obj_1305)
{
   return (((local_t) CREF(obj_1305))->access);
}


/* _reshaped-local-access4386 */ obj_t 
_reshaped_local_access4386_232_cfa_info(obj_t env_9909, obj_t obj_9910)
{
   return reshaped_local_access_5_cfa_info((local_t) (obj_9910));
}


/* reshaped-local-fast-alpha-set! */ obj_t 
reshaped_local_fast_alpha_set__175_cfa_info(local_t obj_1306, obj_t val1662_1307)
{
   return ((((local_t) CREF(obj_1306))->fast_alpha_7) = ((obj_t) val1662_1307), BUNSPEC);
}


/* _reshaped-local-fast-alpha-set!4387 */ obj_t 
_reshaped_local_fast_alpha_set_4387_79_cfa_info(obj_t env_9911, obj_t obj_9912, obj_t val1662_9913)
{
   return reshaped_local_fast_alpha_set__175_cfa_info((local_t) (obj_9912), val1662_9913);
}


/* reshaped-local-fast-alpha */ obj_t 
reshaped_local_fast_alpha_133_cfa_info(local_t obj_1308)
{
   return (((local_t) CREF(obj_1308))->fast_alpha_7);
}


/* _reshaped-local-fast-alpha4388 */ obj_t 
_reshaped_local_fast_alpha4388_156_cfa_info(obj_t env_9914, obj_t obj_9915)
{
   return reshaped_local_fast_alpha_133_cfa_info((local_t) (obj_9915));
}


/* reshaped-local-removable-set! */ obj_t 
reshaped_local_removable_set__25_cfa_info(local_t obj_1309, obj_t val1663_1310)
{
   return ((((local_t) CREF(obj_1309))->removable) = ((obj_t) val1663_1310), BUNSPEC);
}


/* _reshaped-local-removable-set!4389 */ obj_t 
_reshaped_local_removable_set_4389_217_cfa_info(obj_t env_9916, obj_t obj_9917, obj_t val1663_9918)
{
   return reshaped_local_removable_set__25_cfa_info((local_t) (obj_9917), val1663_9918);
}


/* reshaped-local-removable */ obj_t 
reshaped_local_removable_103_cfa_info(local_t obj_1311)
{
   return (((local_t) CREF(obj_1311))->removable);
}


/* _reshaped-local-removable4390 */ obj_t 
_reshaped_local_removable4390_108_cfa_info(obj_t env_9919, obj_t obj_9920)
{
   return reshaped_local_removable_103_cfa_info((local_t) (obj_9920));
}


/* reshaped-local-occurrence-set! */ obj_t 
reshaped_local_occurrence_set__7_cfa_info(local_t obj_1312, long val1664_1313)
{
   return ((((local_t) CREF(obj_1312))->occurrence) = ((long) val1664_1313), BUNSPEC);
}


/* _reshaped-local-occurrence-set!4391 */ obj_t 
_reshaped_local_occurrence_set_4391_31_cfa_info(obj_t env_9921, obj_t obj_9922, obj_t val1664_9923)
{
   return reshaped_local_occurrence_set__7_cfa_info((local_t) (obj_9922), (long) CINT(val1664_9923));
}


/* reshaped-local-occurrence */ long 
reshaped_local_occurrence_171_cfa_info(local_t obj_1314)
{
   return (((local_t) CREF(obj_1314))->occurrence);
}


/* _reshaped-local-occurrence4392 */ obj_t 
_reshaped_local_occurrence4392_74_cfa_info(obj_t env_9924, obj_t obj_9925)
{
   {
      long aux_15308;
      aux_15308 = reshaped_local_occurrence_171_cfa_info((local_t) (obj_9925));
      return BINT(aux_15308);
   }
}


/* reshaped-local-user?-set! */ obj_t 
reshaped_local_user__set__128_cfa_info(local_t obj_1315, bool_t val1665_1316)
{
   return ((((local_t) CREF(obj_1315))->user__32) = ((bool_t) val1665_1316), BUNSPEC);
}


/* _reshaped-local-user?-set!4393 */ obj_t 
_reshaped_local_user__set_4393_102_cfa_info(obj_t env_9926, obj_t obj_9927, obj_t val1665_9928)
{
   return reshaped_local_user__set__128_cfa_info((local_t) (obj_9927), CBOOL(val1665_9928));
}


/* reshaped-local-user? */ bool_t 
reshaped_local_user__5_cfa_info(local_t obj_1317)
{
   return (((local_t) CREF(obj_1317))->user__32);
}


/* _reshaped-local-user?4394 */ obj_t 
_reshaped_local_user_4394_145_cfa_info(obj_t env_9929, obj_t obj_9930)
{
   {
      bool_t aux_15317;
      aux_15317 = reshaped_local_user__5_cfa_info((local_t) (obj_9930));
      return BBOOL(aux_15317);
   }
}


/* reshaped-local-key */ long 
reshaped_local_key_22_cfa_info(local_t obj_1318)
{
   return (((local_t) CREF(obj_1318))->key);
}


/* _reshaped-local-key4395 */ obj_t 
_reshaped_local_key4395_20_cfa_info(obj_t env_9931, obj_t obj_9932)
{
   {
      long aux_15322;
      aux_15322 = reshaped_local_key_22_cfa_info((local_t) (obj_9932));
      return BINT(aux_15322);
   }
}


/* reshaped-local-binding-value */ obj_t 
reshaped_local_binding_value_248_cfa_info(reshaped_local_224_t obj_1319)
{
   {
      obj_t aux_15326;
      {
	 object_t aux_15327;
	 aux_15327 = (object_t) (obj_1319);
	 aux_15326 = OBJECT_WIDENING(aux_15327);
      }
      return (((reshaped_local_224_t) CREF(aux_15326))->binding_value_3);
   }
}


/* _reshaped-local-binding-value4396 */ obj_t 
_reshaped_local_binding_value4396_81_cfa_info(obj_t env_9933, obj_t obj_9934)
{
   return reshaped_local_binding_value_248_cfa_info((reshaped_local_224_t) (obj_9934));
}


/* allocate-sexit/cinfo */ sexit_t 
allocate_sexit_cinfo_160_cfa_info()
{
   {
      sexit_t new1646_2798;
      new1646_2798 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
      {
	 long arg2933_2799;
	 arg2933_2799 = class_num_218___object(sexit_cinfo_49_cfa_info);
	 {
	    obj_t obj_5894;
	    obj_5894 = (obj_t) (new1646_2798);
	    (((obj_t) CREF(obj_5894))->header = MAKE_HEADER(arg2933_2799, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15337;
	 aux_15337 = (object_t) (new1646_2798);
	 OBJECT_WIDENING_SET(aux_15337, BFALSE);
      }
      return new1646_2798;
   }
}


/* _allocate-sexit/cinfo */ obj_t 
_allocate_sexit_cinfo_64_cfa_info(obj_t env_8029)
{
   {
      sexit_t aux_15340;
      aux_15340 = allocate_sexit_cinfo_160_cfa_info();
      return (obj_t) (aux_15340);
   }
}


/* sexit/cinfo? */ bool_t 
sexit_cinfo__140_cfa_info(obj_t obj_1323)
{
   return is_a__118___object(obj_1323, sexit_cinfo_49_cfa_info);
}


/* _sexit/cinfo? */ obj_t 
_sexit_cinfo__68_cfa_info(obj_t env_9935, obj_t obj_9936)
{
   {
      bool_t aux_15344;
      aux_15344 = sexit_cinfo__140_cfa_info(obj_9936);
      return BBOOL(aux_15344);
   }
}


/* widening1009-sexit/cinfo */ sexit_cinfo_49_t 
widening1009_sexit_cinfo_132_cfa_info(approx_t approx_1324)
{
   {
      sexit_cinfo_49_t new1639_5896;
      new1639_5896 = ((sexit_cinfo_49_t) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
      ((((sexit_cinfo_49_t) CREF(new1639_5896))->approx) = ((approx_t) approx_1324), BUNSPEC);
      return new1639_5896;
   }
}


/* _widening1009-sexit/cinfo4397 */ obj_t 
_widening1009_sexit_cinfo4397_17_cfa_info(obj_t env_9937, obj_t approx_9938)
{
   {
      sexit_cinfo_49_t aux_15349;
      aux_15349 = widening1009_sexit_cinfo_132_cfa_info((approx_t) (approx_9938));
      return (obj_t) (aux_15349);
   }
}


/* make-sexit/cinfo */ sexit_cinfo_49_t 
make_sexit_cinfo_207_cfa_info(obj_t handler_1325, bool_t detached__120_1326, approx_t approx_1327)
{
   {
      sexit_t aux1642_5898;
      {
	 sexit_t res3754_5910;
	 {
	    sexit_t new1224_5904;
	    new1224_5904 = ((sexit_t) BREF(GC_MALLOC(sizeof(struct sexit))));
	    {
	       long arg3015_5905;
	       arg3015_5905 = class_num_218___object(sexit_ast_var);
	       {
		  obj_t obj_5908;
		  obj_5908 = (obj_t) (new1224_5904);
		  (((obj_t) CREF(obj_5908))->header = MAKE_HEADER(arg3015_5905, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15357;
	       aux_15357 = (object_t) (new1224_5904);
	       OBJECT_WIDENING_SET(aux_15357, BFALSE);
	    }
	    ((((sexit_t) CREF(new1224_5904))->handler) = ((obj_t) handler_1325), BUNSPEC);
	    ((((sexit_t) CREF(new1224_5904))->detached__120) = ((bool_t) detached__120_1326), BUNSPEC);
	    res3754_5910 = new1224_5904;
	 }
	 aux1642_5898 = res3754_5910;
      }
      {
	 sexit_cinfo_49_t new1643_5899;
	 new1643_5899 = ((sexit_cinfo_49_t) (aux1642_5898));
	 {
	    long arg2935_5900;
	    arg2935_5900 = class_num_218___object(sexit_cinfo_49_cfa_info);
	    {
	       obj_t obj_5911;
	       obj_5911 = (obj_t) (new1643_5899);
	       (((obj_t) CREF(obj_5911))->header = MAKE_HEADER(arg2935_5900, 0), BUNSPEC);
	    }
	 }
	 {
	    sexit_cinfo_49_t arg2936_5901;
	    {
	       sexit_cinfo_49_t res3755_5916;
	       {
		  sexit_cinfo_49_t new1639_5914;
		  new1639_5914 = ((sexit_cinfo_49_t) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
		  ((((sexit_cinfo_49_t) CREF(new1639_5914))->approx) = ((approx_t) approx_1327), BUNSPEC);
		  res3755_5916 = new1639_5914;
	       }
	       arg2936_5901 = res3755_5916;
	    }
	    {
	       obj_t aux_15370;
	       object_t aux_15368;
	       aux_15370 = (obj_t) (arg2936_5901);
	       aux_15368 = (object_t) (new1643_5899);
	       OBJECT_WIDENING_SET(aux_15368, aux_15370);
	    }
	 }
	 return new1643_5899;
      }
   }
}


/* _make-sexit/cinfo4398 */ obj_t 
_make_sexit_cinfo4398_253_cfa_info(obj_t env_9939, obj_t handler_9940, obj_t detached__120_9941, obj_t approx_9942)
{
   {
      sexit_cinfo_49_t aux_15373;
      aux_15373 = make_sexit_cinfo_207_cfa_info(handler_9940, CBOOL(detached__120_9941), (approx_t) (approx_9942));
      return (obj_t) (aux_15373);
   }
}


/* sexit/cinfo-handler-set! */ obj_t 
sexit_cinfo_handler_set__65_cfa_info(sexit_t obj_1328, obj_t val1644_1329)
{
   return ((((sexit_t) CREF(obj_1328))->handler) = ((obj_t) val1644_1329), BUNSPEC);
}


/* _sexit/cinfo-handler-set!4399 */ obj_t 
_sexit_cinfo_handler_set_4399_90_cfa_info(obj_t env_9943, obj_t obj_9944, obj_t val1644_9945)
{
   return sexit_cinfo_handler_set__65_cfa_info((sexit_t) (obj_9944), val1644_9945);
}


/* sexit/cinfo-handler */ obj_t 
sexit_cinfo_handler_23_cfa_info(sexit_t obj_1330)
{
   return (((sexit_t) CREF(obj_1330))->handler);
}


/* _sexit/cinfo-handler4400 */ obj_t 
_sexit_cinfo_handler4400_92_cfa_info(obj_t env_9946, obj_t obj_9947)
{
   return sexit_cinfo_handler_23_cfa_info((sexit_t) (obj_9947));
}


/* sexit/cinfo-detached?-set! */ obj_t 
sexit_cinfo_detached__set__246_cfa_info(sexit_t obj_1331, bool_t val1645_1332)
{
   return ((((sexit_t) CREF(obj_1331))->detached__120) = ((bool_t) val1645_1332), BUNSPEC);
}


/* _sexit/cinfo-detached?-set!4401 */ obj_t 
_sexit_cinfo_detached__set_4401_18_cfa_info(obj_t env_9948, obj_t obj_9949, obj_t val1645_9950)
{
   return sexit_cinfo_detached__set__246_cfa_info((sexit_t) (obj_9949), CBOOL(val1645_9950));
}


/* sexit/cinfo-detached? */ bool_t 
sexit_cinfo_detached__124_cfa_info(sexit_t obj_1333)
{
   return (((sexit_t) CREF(obj_1333))->detached__120);
}


/* _sexit/cinfo-detached?4402 */ obj_t 
_sexit_cinfo_detached_4402_213_cfa_info(obj_t env_9951, obj_t obj_9952)
{
   {
      bool_t aux_15389;
      aux_15389 = sexit_cinfo_detached__124_cfa_info((sexit_t) (obj_9952));
      return BBOOL(aux_15389);
   }
}


/* sexit/cinfo-approx */ approx_t 
sexit_cinfo_approx_118_cfa_info(sexit_cinfo_49_t obj_1334)
{
   {
      obj_t aux_15393;
      {
	 object_t aux_15394;
	 aux_15394 = (object_t) (obj_1334);
	 aux_15393 = OBJECT_WIDENING(aux_15394);
      }
      return (((sexit_cinfo_49_t) CREF(aux_15393))->approx);
   }
}


/* _sexit/cinfo-approx4403 */ obj_t 
_sexit_cinfo_approx4403_117_cfa_info(obj_t env_9953, obj_t obj_9954)
{
   {
      approx_t aux_15398;
      aux_15398 = sexit_cinfo_approx_118_cfa_info((sexit_cinfo_49_t) (obj_9954));
      return (obj_t) (aux_15398);
   }
}


/* allocate-cvar/cinfo */ cvar_t 
allocate_cvar_cinfo_69_cfa_info()
{
   {
      cvar_t new1632_2806;
      new1632_2806 = ((cvar_t) BREF(GC_MALLOC(sizeof(struct cvar))));
      {
	 long arg2937_2807;
	 arg2937_2807 = class_num_218___object(cvar_cinfo_53_cfa_info);
	 {
	    obj_t obj_5917;
	    obj_5917 = (obj_t) (new1632_2806);
	    (((obj_t) CREF(obj_5917))->header = MAKE_HEADER(arg2937_2807, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15406;
	 aux_15406 = (object_t) (new1632_2806);
	 OBJECT_WIDENING_SET(aux_15406, BFALSE);
      }
      return new1632_2806;
   }
}


/* _allocate-cvar/cinfo */ obj_t 
_allocate_cvar_cinfo_74_cfa_info(obj_t env_8028)
{
   {
      cvar_t aux_15409;
      aux_15409 = allocate_cvar_cinfo_69_cfa_info();
      return (obj_t) (aux_15409);
   }
}


/* cvar/cinfo? */ bool_t 
cvar_cinfo__125_cfa_info(obj_t obj_1338)
{
   return is_a__118___object(obj_1338, cvar_cinfo_53_cfa_info);
}


/* _cvar/cinfo? */ obj_t 
_cvar_cinfo__113_cfa_info(obj_t env_9955, obj_t obj_9956)
{
   {
      bool_t aux_15413;
      aux_15413 = cvar_cinfo__125_cfa_info(obj_9956);
      return BBOOL(aux_15413);
   }
}


/* widening1008-cvar/cinfo */ cvar_cinfo_53_t 
widening1008_cvar_cinfo_33_cfa_info(approx_t approx_1339)
{
   {
      cvar_cinfo_53_t new1627_5919;
      new1627_5919 = ((cvar_cinfo_53_t) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
      ((((cvar_cinfo_53_t) CREF(new1627_5919))->approx) = ((approx_t) approx_1339), BUNSPEC);
      return new1627_5919;
   }
}


/* _widening1008-cvar/cinfo4404 */ obj_t 
_widening1008_cvar_cinfo4404_111_cfa_info(obj_t env_9957, obj_t approx_9958)
{
   {
      cvar_cinfo_53_t aux_15418;
      aux_15418 = widening1008_cvar_cinfo_33_cfa_info((approx_t) (approx_9958));
      return (obj_t) (aux_15418);
   }
}


/* make-cvar/cinfo */ cvar_cinfo_53_t 
make_cvar_cinfo_209_cfa_info(bool_t macro__33_1340, approx_t approx_1341)
{
   {
      cvar_t aux1630_5921;
      {
	 cvar_t res3756_5931;
	 {
	    cvar_t new1220_5926;
	    new1220_5926 = ((cvar_t) BREF(GC_MALLOC(sizeof(struct cvar))));
	    {
	       long arg3017_5927;
	       arg3017_5927 = class_num_218___object(cvar_ast_var);
	       {
		  obj_t obj_5929;
		  obj_5929 = (obj_t) (new1220_5926);
		  (((obj_t) CREF(obj_5929))->header = MAKE_HEADER(arg3017_5927, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15426;
	       aux_15426 = (object_t) (new1220_5926);
	       OBJECT_WIDENING_SET(aux_15426, BFALSE);
	    }
	    ((((cvar_t) CREF(new1220_5926))->macro__33) = ((bool_t) macro__33_1340), BUNSPEC);
	    res3756_5931 = new1220_5926;
	 }
	 aux1630_5921 = res3756_5931;
      }
      {
	 cvar_cinfo_53_t new1631_5922;
	 new1631_5922 = ((cvar_cinfo_53_t) (aux1630_5921));
	 {
	    long arg2938_5923;
	    arg2938_5923 = class_num_218___object(cvar_cinfo_53_cfa_info);
	    {
	       obj_t obj_5932;
	       obj_5932 = (obj_t) (new1631_5922);
	       (((obj_t) CREF(obj_5932))->header = MAKE_HEADER(arg2938_5923, 0), BUNSPEC);
	    }
	 }
	 {
	    cvar_cinfo_53_t arg2939_5924;
	    {
	       cvar_cinfo_53_t res3757_5937;
	       {
		  cvar_cinfo_53_t new1627_5935;
		  new1627_5935 = ((cvar_cinfo_53_t) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
		  ((((cvar_cinfo_53_t) CREF(new1627_5935))->approx) = ((approx_t) approx_1341), BUNSPEC);
		  res3757_5937 = new1627_5935;
	       }
	       arg2939_5924 = res3757_5937;
	    }
	    {
	       obj_t aux_15438;
	       object_t aux_15436;
	       aux_15438 = (obj_t) (arg2939_5924);
	       aux_15436 = (object_t) (new1631_5922);
	       OBJECT_WIDENING_SET(aux_15436, aux_15438);
	    }
	 }
	 return new1631_5922;
      }
   }
}


/* _make-cvar/cinfo4405 */ obj_t 
_make_cvar_cinfo4405_180_cfa_info(obj_t env_9959, obj_t macro__33_9960, obj_t approx_9961)
{
   {
      cvar_cinfo_53_t aux_15441;
      aux_15441 = make_cvar_cinfo_209_cfa_info(CBOOL(macro__33_9960), (approx_t) (approx_9961));
      return (obj_t) (aux_15441);
   }
}


/* cvar/cinfo-macro? */ bool_t 
cvar_cinfo_macro__62_cfa_info(cvar_t obj_1342)
{
   return (((cvar_t) CREF(obj_1342))->macro__33);
}


/* _cvar/cinfo-macro?4406 */ obj_t 
_cvar_cinfo_macro_4406_52_cfa_info(obj_t env_9962, obj_t obj_9963)
{
   {
      bool_t aux_15447;
      aux_15447 = cvar_cinfo_macro__62_cfa_info((cvar_t) (obj_9963));
      return BBOOL(aux_15447);
   }
}


/* cvar/cinfo-approx */ approx_t 
cvar_cinfo_approx_12_cfa_info(cvar_cinfo_53_t obj_1343)
{
   {
      obj_t aux_15451;
      {
	 object_t aux_15452;
	 aux_15452 = (object_t) (obj_1343);
	 aux_15451 = OBJECT_WIDENING(aux_15452);
      }
      return (((cvar_cinfo_53_t) CREF(aux_15451))->approx);
   }
}


/* _cvar/cinfo-approx4407 */ obj_t 
_cvar_cinfo_approx4407_165_cfa_info(obj_t env_9964, obj_t obj_9965)
{
   {
      approx_t aux_15456;
      aux_15456 = cvar_cinfo_approx_12_cfa_info((cvar_cinfo_53_t) (obj_9965));
      return (obj_t) (aux_15456);
   }
}


/* allocate-svar/cinfo */ svar_t 
allocate_svar_cinfo_217_cfa_info()
{
   {
      svar_t new1620_2814;
      new1620_2814 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
      {
	 long arg2940_2815;
	 arg2940_2815 = class_num_218___object(svar_cinfo_166_cfa_info);
	 {
	    obj_t obj_5938;
	    obj_5938 = (obj_t) (new1620_2814);
	    (((obj_t) CREF(obj_5938))->header = MAKE_HEADER(arg2940_2815, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15464;
	 aux_15464 = (object_t) (new1620_2814);
	 OBJECT_WIDENING_SET(aux_15464, BFALSE);
      }
      return new1620_2814;
   }
}


/* _allocate-svar/cinfo */ obj_t 
_allocate_svar_cinfo_185_cfa_info(obj_t env_8027)
{
   {
      svar_t aux_15467;
      aux_15467 = allocate_svar_cinfo_217_cfa_info();
      return (obj_t) (aux_15467);
   }
}


/* svar/cinfo? */ bool_t 
svar_cinfo__59_cfa_info(obj_t obj_1347)
{
   return is_a__118___object(obj_1347, svar_cinfo_166_cfa_info);
}


/* _svar/cinfo? */ obj_t 
_svar_cinfo__163_cfa_info(obj_t env_9966, obj_t obj_9967)
{
   {
      bool_t aux_15471;
      aux_15471 = svar_cinfo__59_cfa_info(obj_9967);
      return BBOOL(aux_15471);
   }
}


/* widening1007-svar/cinfo */ svar_cinfo_166_t 
widening1007_svar_cinfo_145_cfa_info(approx_t approx_1348, bool_t clo_env__87_1349)
{
   {
      svar_cinfo_166_t new1612_5940;
      new1612_5940 = ((svar_cinfo_166_t) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
      ((((svar_cinfo_166_t) CREF(new1612_5940))->approx) = ((approx_t) approx_1348), BUNSPEC);
      ((((svar_cinfo_166_t) CREF(new1612_5940))->clo_env__87) = ((bool_t) clo_env__87_1349), BUNSPEC);
      return new1612_5940;
   }
}


/* _widening1007-svar/cinfo4408 */ obj_t 
_widening1007_svar_cinfo4408_80_cfa_info(obj_t env_9968, obj_t approx_9969, obj_t clo_env__87_9970)
{
   {
      svar_cinfo_166_t aux_15477;
      aux_15477 = widening1007_svar_cinfo_145_cfa_info((approx_t) (approx_9969), CBOOL(clo_env__87_9970));
      return (obj_t) (aux_15477);
   }
}


/* make-svar/cinfo */ svar_cinfo_166_t 
make_svar_cinfo_148_cfa_info(obj_t loc_1350, approx_t approx_1351, bool_t clo_env__87_1352)
{
   {
      svar_t aux1616_5943;
      {
	 svar_t res3758_5953;
	 {
	    svar_t new1207_5948;
	    new1207_5948 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
	    {
	       long arg3021_5949;
	       arg3021_5949 = class_num_218___object(svar_ast_var);
	       {
		  obj_t obj_5951;
		  obj_5951 = (obj_t) (new1207_5948);
		  (((obj_t) CREF(obj_5951))->header = MAKE_HEADER(arg3021_5949, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15486;
	       aux_15486 = (object_t) (new1207_5948);
	       OBJECT_WIDENING_SET(aux_15486, BFALSE);
	    }
	    ((((svar_t) CREF(new1207_5948))->loc) = ((obj_t) loc_1350), BUNSPEC);
	    res3758_5953 = new1207_5948;
	 }
	 aux1616_5943 = res3758_5953;
      }
      {
	 svar_cinfo_166_t new1617_5944;
	 new1617_5944 = ((svar_cinfo_166_t) (aux1616_5943));
	 {
	    long arg2941_5945;
	    arg2941_5945 = class_num_218___object(svar_cinfo_166_cfa_info);
	    {
	       obj_t obj_5954;
	       obj_5954 = (obj_t) (new1617_5944);
	       (((obj_t) CREF(obj_5954))->header = MAKE_HEADER(arg2941_5945, 0), BUNSPEC);
	    }
	 }
	 {
	    svar_cinfo_166_t arg2942_5946;
	    {
	       svar_cinfo_166_t res3759_5961;
	       {
		  svar_cinfo_166_t new1612_5958;
		  new1612_5958 = ((svar_cinfo_166_t) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
		  ((((svar_cinfo_166_t) CREF(new1612_5958))->approx) = ((approx_t) approx_1351), BUNSPEC);
		  ((((svar_cinfo_166_t) CREF(new1612_5958))->clo_env__87) = ((bool_t) clo_env__87_1352), BUNSPEC);
		  res3759_5961 = new1612_5958;
	       }
	       arg2942_5946 = res3759_5961;
	    }
	    {
	       obj_t aux_15499;
	       object_t aux_15497;
	       aux_15499 = (obj_t) (arg2942_5946);
	       aux_15497 = (object_t) (new1617_5944);
	       OBJECT_WIDENING_SET(aux_15497, aux_15499);
	    }
	 }
	 return new1617_5944;
      }
   }
}


/* _make-svar/cinfo4409 */ obj_t 
_make_svar_cinfo4409_207_cfa_info(obj_t env_9971, obj_t loc_9972, obj_t approx_9973, obj_t clo_env__87_9974)
{
   {
      svar_cinfo_166_t aux_15502;
      aux_15502 = make_svar_cinfo_148_cfa_info(loc_9972, (approx_t) (approx_9973), CBOOL(clo_env__87_9974));
      return (obj_t) (aux_15502);
   }
}


/* svar/cinfo-loc-set! */ obj_t 
svar_cinfo_loc_set__81_cfa_info(svar_t obj_1353, obj_t val1618_1354)
{
   return ((((svar_t) CREF(obj_1353))->loc) = ((obj_t) val1618_1354), BUNSPEC);
}


/* _svar/cinfo-loc-set!4410 */ obj_t 
_svar_cinfo_loc_set_4410_107_cfa_info(obj_t env_9975, obj_t obj_9976, obj_t val1618_9977)
{
   return svar_cinfo_loc_set__81_cfa_info((svar_t) (obj_9976), val1618_9977);
}


/* svar/cinfo-loc */ obj_t 
svar_cinfo_loc_67_cfa_info(svar_t obj_1355)
{
   return (((svar_t) CREF(obj_1355))->loc);
}


/* _svar/cinfo-loc4411 */ obj_t 
_svar_cinfo_loc4411_139_cfa_info(obj_t env_9978, obj_t obj_9979)
{
   return svar_cinfo_loc_67_cfa_info((svar_t) (obj_9979));
}


/* svar/cinfo-approx */ approx_t 
svar_cinfo_approx_144_cfa_info(svar_cinfo_166_t obj_1356)
{
   {
      obj_t aux_15513;
      {
	 object_t aux_15514;
	 aux_15514 = (object_t) (obj_1356);
	 aux_15513 = OBJECT_WIDENING(aux_15514);
      }
      return (((svar_cinfo_166_t) CREF(aux_15513))->approx);
   }
}


/* _svar/cinfo-approx4412 */ obj_t 
_svar_cinfo_approx4412_1_cfa_info(obj_t env_9980, obj_t obj_9981)
{
   {
      approx_t aux_15518;
      aux_15518 = svar_cinfo_approx_144_cfa_info((svar_cinfo_166_t) (obj_9981));
      return (obj_t) (aux_15518);
   }
}


/* svar/cinfo-clo-env?-set! */ obj_t 
svar_cinfo_clo_env__set__212_cfa_info(svar_cinfo_166_t obj_1357, bool_t val1619_1358)
{
   {
      obj_t aux_15522;
      {
	 object_t aux_15523;
	 aux_15523 = (object_t) (obj_1357);
	 aux_15522 = OBJECT_WIDENING(aux_15523);
      }
      return ((((svar_cinfo_166_t) CREF(aux_15522))->clo_env__87) = ((bool_t) val1619_1358), BUNSPEC);
   }
}


/* _svar/cinfo-clo-env?-set!4413 */ obj_t 
_svar_cinfo_clo_env__set_4413_164_cfa_info(obj_t env_9982, obj_t obj_9983, obj_t val1619_9984)
{
   return svar_cinfo_clo_env__set__212_cfa_info((svar_cinfo_166_t) (obj_9983), CBOOL(val1619_9984));
}


/* svar/cinfo-clo-env? */ bool_t 
svar_cinfo_clo_env__3_cfa_info(svar_cinfo_166_t obj_1359)
{
   {
      obj_t aux_15530;
      {
	 object_t aux_15531;
	 aux_15531 = (object_t) (obj_1359);
	 aux_15530 = OBJECT_WIDENING(aux_15531);
      }
      return (((svar_cinfo_166_t) CREF(aux_15530))->clo_env__87);
   }
}


/* _svar/cinfo-clo-env?4414 */ obj_t 
_svar_cinfo_clo_env_4414_89_cfa_info(obj_t env_9985, obj_t obj_9986)
{
   {
      bool_t aux_15535;
      aux_15535 = svar_cinfo_clo_env__3_cfa_info((svar_cinfo_166_t) (obj_9986));
      return BBOOL(aux_15535);
   }
}


/* allocate-pre-clo-env */ svar_t 
allocate_pre_clo_env_40_cfa_info()
{
   {
      svar_t new1605_2823;
      new1605_2823 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
      {
	 long arg2943_2824;
	 arg2943_2824 = class_num_218___object(pre_clo_env_191_cfa_info);
	 {
	    obj_t obj_5962;
	    obj_5962 = (obj_t) (new1605_2823);
	    (((obj_t) CREF(obj_5962))->header = MAKE_HEADER(arg2943_2824, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15543;
	 aux_15543 = (object_t) (new1605_2823);
	 OBJECT_WIDENING_SET(aux_15543, BFALSE);
      }
      return new1605_2823;
   }
}


/* _allocate-pre-clo-env */ obj_t 
_allocate_pre_clo_env_10_cfa_info(obj_t env_8026)
{
   {
      svar_t aux_15546;
      aux_15546 = allocate_pre_clo_env_40_cfa_info();
      return (obj_t) (aux_15546);
   }
}


/* pre-clo-env? */ bool_t 
pre_clo_env__121_cfa_info(obj_t obj_1363)
{
   return is_a__118___object(obj_1363, pre_clo_env_191_cfa_info);
}


/* _pre-clo-env? */ obj_t 
_pre_clo_env__150_cfa_info(obj_t env_9987, obj_t obj_9988)
{
   {
      bool_t aux_15550;
      aux_15550 = pre_clo_env__121_cfa_info(obj_9988);
      return BBOOL(aux_15550);
   }
}


/* widening1006-pre-clo-env */ pre_clo_env_191_t 
widening1006_pre_clo_env_44_cfa_info()
{
   {
      return ((pre_clo_env_191_t) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
   }
}


/* _widening1006-pre-clo-env */ obj_t 
_widening1006_pre_clo_env_70_cfa_info(obj_t env_9989)
{
   {
      pre_clo_env_191_t aux_15554;
      aux_15554 = widening1006_pre_clo_env_44_cfa_info();
      return (obj_t) (aux_15554);
   }
}


/* make-pre-clo-env */ pre_clo_env_191_t 
make_pre_clo_env_164_cfa_info(obj_t loc_1364)
{
   {
      svar_t aux1602_5965;
      {
	 svar_t res3760_5975;
	 {
	    svar_t new1207_5970;
	    new1207_5970 = ((svar_t) BREF(GC_MALLOC(sizeof(struct svar))));
	    {
	       long arg3021_5971;
	       arg3021_5971 = class_num_218___object(svar_ast_var);
	       {
		  obj_t obj_5973;
		  obj_5973 = (obj_t) (new1207_5970);
		  (((obj_t) CREF(obj_5973))->header = MAKE_HEADER(arg3021_5971, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15561;
	       aux_15561 = (object_t) (new1207_5970);
	       OBJECT_WIDENING_SET(aux_15561, BFALSE);
	    }
	    ((((svar_t) CREF(new1207_5970))->loc) = ((obj_t) loc_1364), BUNSPEC);
	    res3760_5975 = new1207_5970;
	 }
	 aux1602_5965 = res3760_5975;
      }
      {
	 pre_clo_env_191_t new1603_5966;
	 new1603_5966 = ((pre_clo_env_191_t) (aux1602_5965));
	 {
	    long arg2944_5967;
	    arg2944_5967 = class_num_218___object(pre_clo_env_191_cfa_info);
	    {
	       obj_t obj_5976;
	       obj_5976 = (obj_t) (new1603_5966);
	       (((obj_t) CREF(obj_5976))->header = MAKE_HEADER(arg2944_5967, 0), BUNSPEC);
	    }
	 }
	 {
	    obj_t aux_15571;
	    object_t aux_15569;
	    {
	       pre_clo_env_191_t aux_15572;
	       {
		  aux_15572 = ((pre_clo_env_191_t) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
	       }
	       aux_15571 = (obj_t) (aux_15572);
	    }
	    aux_15569 = (object_t) (new1603_5966);
	    OBJECT_WIDENING_SET(aux_15569, aux_15571);
	 }
	 return new1603_5966;
      }
   }
}


/* _make-pre-clo-env */ obj_t 
_make_pre_clo_env_110_cfa_info(obj_t env_9990, obj_t loc_9991)
{
   {
      pre_clo_env_191_t aux_15576;
      aux_15576 = make_pre_clo_env_164_cfa_info(loc_9991);
      return (obj_t) (aux_15576);
   }
}


/* pre-clo-env-loc-set! */ obj_t 
pre_clo_env_loc_set__78_cfa_info(svar_t obj_1365, obj_t val1604_1366)
{
   return ((((svar_t) CREF(obj_1365))->loc) = ((obj_t) val1604_1366), BUNSPEC);
}


/* _pre-clo-env-loc-set!4415 */ obj_t 
_pre_clo_env_loc_set_4415_110_cfa_info(obj_t env_9992, obj_t obj_9993, obj_t val1604_9994)
{
   return pre_clo_env_loc_set__78_cfa_info((svar_t) (obj_9993), val1604_9994);
}


/* pre-clo-env-loc */ obj_t 
pre_clo_env_loc_179_cfa_info(svar_t obj_1367)
{
   return (((svar_t) CREF(obj_1367))->loc);
}


/* _pre-clo-env-loc4416 */ obj_t 
_pre_clo_env_loc4416_146_cfa_info(obj_t env_9995, obj_t obj_9996)
{
   return pre_clo_env_loc_179_cfa_info((svar_t) (obj_9996));
}


/* allocate-scnst/cinfo */ scnst_t 
allocate_scnst_cinfo_156_cfa_info()
{
   {
      scnst_t new1593_2830;
      new1593_2830 = ((scnst_t) BREF(GC_MALLOC(sizeof(struct scnst))));
      {
	 long arg2946_2831;
	 arg2946_2831 = class_num_218___object(scnst_cinfo_0_cfa_info);
	 {
	    obj_t obj_5980;
	    obj_5980 = (obj_t) (new1593_2830);
	    (((obj_t) CREF(obj_5980))->header = MAKE_HEADER(arg2946_2831, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15589;
	 aux_15589 = (object_t) (new1593_2830);
	 OBJECT_WIDENING_SET(aux_15589, BFALSE);
      }
      return new1593_2830;
   }
}


/* _allocate-scnst/cinfo */ obj_t 
_allocate_scnst_cinfo_162_cfa_info(obj_t env_8025)
{
   {
      scnst_t aux_15592;
      aux_15592 = allocate_scnst_cinfo_156_cfa_info();
      return (obj_t) (aux_15592);
   }
}


/* scnst/cinfo? */ bool_t 
scnst_cinfo__144_cfa_info(obj_t obj_1371)
{
   return is_a__118___object(obj_1371, scnst_cinfo_0_cfa_info);
}


/* _scnst/cinfo? */ obj_t 
_scnst_cinfo__113_cfa_info(obj_t env_9997, obj_t obj_9998)
{
   {
      bool_t aux_15596;
      aux_15596 = scnst_cinfo__144_cfa_info(obj_9998);
      return BBOOL(aux_15596);
   }
}


/* widening1005-scnst/cinfo */ scnst_cinfo_0_t 
widening1005_scnst_cinfo_42_cfa_info(approx_t approx_1372)
{
   {
      scnst_cinfo_0_t new1586_5982;
      new1586_5982 = ((scnst_cinfo_0_t) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
      ((((scnst_cinfo_0_t) CREF(new1586_5982))->approx) = ((approx_t) approx_1372), BUNSPEC);
      return new1586_5982;
   }
}


/* _widening1005-scnst/cinfo4417 */ obj_t 
_widening1005_scnst_cinfo4417_213_cfa_info(obj_t env_9999, obj_t approx_10000)
{
   {
      scnst_cinfo_0_t aux_15601;
      aux_15601 = widening1005_scnst_cinfo_42_cfa_info((approx_t) (approx_10000));
      return (obj_t) (aux_15601);
   }
}


/* make-scnst/cinfo */ scnst_cinfo_0_t 
make_scnst_cinfo_57_cfa_info(obj_t node_1373, obj_t class_1374, obj_t loc_1375, approx_t approx_1376)
{
   {
      scnst_t aux1589_5984;
      {
	 scnst_t res3762_5998;
	 {
	    scnst_t new1212_5991;
	    new1212_5991 = ((scnst_t) BREF(GC_MALLOC(sizeof(struct scnst))));
	    {
	       long arg3019_5992;
	       arg3019_5992 = class_num_218___object(scnst_ast_var);
	       {
		  obj_t obj_5996;
		  obj_5996 = (obj_t) (new1212_5991);
		  (((obj_t) CREF(obj_5996))->header = MAKE_HEADER(arg3019_5992, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15609;
	       aux_15609 = (object_t) (new1212_5991);
	       OBJECT_WIDENING_SET(aux_15609, BFALSE);
	    }
	    ((((scnst_t) CREF(new1212_5991))->node) = ((obj_t) node_1373), BUNSPEC);
	    ((((scnst_t) CREF(new1212_5991))->class) = ((obj_t) class_1374), BUNSPEC);
	    ((((scnst_t) CREF(new1212_5991))->loc) = ((obj_t) loc_1375), BUNSPEC);
	    res3762_5998 = new1212_5991;
	 }
	 aux1589_5984 = res3762_5998;
      }
      {
	 scnst_cinfo_0_t new1590_5985;
	 new1590_5985 = ((scnst_cinfo_0_t) (aux1589_5984));
	 {
	    long arg2947_5986;
	    arg2947_5986 = class_num_218___object(scnst_cinfo_0_cfa_info);
	    {
	       obj_t obj_5999;
	       obj_5999 = (obj_t) (new1590_5985);
	       (((obj_t) CREF(obj_5999))->header = MAKE_HEADER(arg2947_5986, 0), BUNSPEC);
	    }
	 }
	 {
	    scnst_cinfo_0_t arg2948_5987;
	    {
	       scnst_cinfo_0_t res3763_6004;
	       {
		  scnst_cinfo_0_t new1586_6002;
		  new1586_6002 = ((scnst_cinfo_0_t) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
		  ((((scnst_cinfo_0_t) CREF(new1586_6002))->approx) = ((approx_t) approx_1376), BUNSPEC);
		  res3763_6004 = new1586_6002;
	       }
	       arg2948_5987 = res3763_6004;
	    }
	    {
	       obj_t aux_15623;
	       object_t aux_15621;
	       aux_15623 = (obj_t) (arg2948_5987);
	       aux_15621 = (object_t) (new1590_5985);
	       OBJECT_WIDENING_SET(aux_15621, aux_15623);
	    }
	 }
	 return new1590_5985;
      }
   }
}


/* _make-scnst/cinfo4418 */ obj_t 
_make_scnst_cinfo4418_0_cfa_info(obj_t env_10001, obj_t node_10002, obj_t class_10003, obj_t loc_10004, obj_t approx_10005)
{
   {
      scnst_cinfo_0_t aux_15626;
      aux_15626 = make_scnst_cinfo_57_cfa_info(node_10002, class_10003, loc_10004, (approx_t) (approx_10005));
      return (obj_t) (aux_15626);
   }
}


/* scnst/cinfo-node */ obj_t 
scnst_cinfo_node_230_cfa_info(scnst_t obj_1377)
{
   return (((scnst_t) CREF(obj_1377))->node);
}


/* _scnst/cinfo-node4419 */ obj_t 
_scnst_cinfo_node4419_234_cfa_info(obj_t env_10006, obj_t obj_10007)
{
   return scnst_cinfo_node_230_cfa_info((scnst_t) (obj_10007));
}


/* scnst/cinfo-class-set! */ obj_t 
scnst_cinfo_class_set__149_cfa_info(scnst_t obj_1378, obj_t val1591_1379)
{
   return ((((scnst_t) CREF(obj_1378))->class) = ((obj_t) val1591_1379), BUNSPEC);
}


/* _scnst/cinfo-class-set!4420 */ obj_t 
_scnst_cinfo_class_set_4420_88_cfa_info(obj_t env_10008, obj_t obj_10009, obj_t val1591_10010)
{
   return scnst_cinfo_class_set__149_cfa_info((scnst_t) (obj_10009), val1591_10010);
}


/* scnst/cinfo-class */ obj_t 
scnst_cinfo_class_89_cfa_info(scnst_t obj_1380)
{
   return (((scnst_t) CREF(obj_1380))->class);
}


/* _scnst/cinfo-class4421 */ obj_t 
_scnst_cinfo_class4421_86_cfa_info(obj_t env_10011, obj_t obj_10012)
{
   return scnst_cinfo_class_89_cfa_info((scnst_t) (obj_10012));
}


/* scnst/cinfo-loc-set! */ obj_t 
scnst_cinfo_loc_set__10_cfa_info(scnst_t obj_1381, obj_t val1592_1382)
{
   return ((((scnst_t) CREF(obj_1381))->loc) = ((obj_t) val1592_1382), BUNSPEC);
}


/* _scnst/cinfo-loc-set!4422 */ obj_t 
_scnst_cinfo_loc_set_4422_122_cfa_info(obj_t env_10013, obj_t obj_10014, obj_t val1592_10015)
{
   return scnst_cinfo_loc_set__10_cfa_info((scnst_t) (obj_10014), val1592_10015);
}


/* scnst/cinfo-loc */ obj_t 
scnst_cinfo_loc_35_cfa_info(scnst_t obj_1383)
{
   return (((scnst_t) CREF(obj_1383))->loc);
}


/* _scnst/cinfo-loc4423 */ obj_t 
_scnst_cinfo_loc4423_42_cfa_info(obj_t env_10016, obj_t obj_10017)
{
   return scnst_cinfo_loc_35_cfa_info((scnst_t) (obj_10017));
}


/* scnst/cinfo-approx */ approx_t 
scnst_cinfo_approx_162_cfa_info(scnst_cinfo_0_t obj_1384)
{
   {
      obj_t aux_15645;
      {
	 object_t aux_15646;
	 aux_15646 = (object_t) (obj_1384);
	 aux_15645 = OBJECT_WIDENING(aux_15646);
      }
      return (((scnst_cinfo_0_t) CREF(aux_15645))->approx);
   }
}


/* _scnst/cinfo-approx4424 */ obj_t 
_scnst_cinfo_approx4424_226_cfa_info(obj_t env_10018, obj_t obj_10019)
{
   {
      approx_t aux_15650;
      aux_15650 = scnst_cinfo_approx_162_cfa_info((scnst_cinfo_0_t) (obj_10019));
      return (obj_t) (aux_15650);
   }
}


/* allocate-intern-sfun/cinfo */ sfun_t 
allocate_intern_sfun_cinfo_151_cfa_info()
{
   {
      sfun_t new1579_2838;
      new1579_2838 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg2949_2839;
	 arg2949_2839 = class_num_218___object(intern_sfun_cinfo_192_cfa_info);
	 {
	    obj_t obj_6005;
	    obj_6005 = (obj_t) (new1579_2838);
	    (((obj_t) CREF(obj_6005))->header = MAKE_HEADER(arg2949_2839, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15658;
	 aux_15658 = (object_t) (new1579_2838);
	 OBJECT_WIDENING_SET(aux_15658, BFALSE);
      }
      return new1579_2838;
   }
}


/* _allocate-intern-sfun/cinfo */ obj_t 
_allocate_intern_sfun_cinfo_249_cfa_info(obj_t env_8024)
{
   {
      sfun_t aux_15661;
      aux_15661 = allocate_intern_sfun_cinfo_151_cfa_info();
      return (obj_t) (aux_15661);
   }
}


/* intern-sfun/cinfo? */ bool_t 
intern_sfun_cinfo__209_cfa_info(obj_t obj_1388)
{
   return is_a__118___object(obj_1388, intern_sfun_cinfo_192_cfa_info);
}


/* _intern-sfun/cinfo? */ obj_t 
_intern_sfun_cinfo__158_cfa_info(obj_t env_10020, obj_t obj_10021)
{
   {
      bool_t aux_15665;
      aux_15665 = intern_sfun_cinfo__209_cfa_info(obj_10021);
      return BBOOL(aux_15665);
   }
}


/* widening1004-intern-sfun/cinfo */ intern_sfun_cinfo_192_t 
widening1004_intern_sfun_cinfo_148_cfa_info(approx_t approx_1389, long stamp_1390)
{
   {
      intern_sfun_cinfo_192_t new1561_6007;
      new1561_6007 = ((intern_sfun_cinfo_192_t) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
      ((((intern_sfun_cinfo_192_t) CREF(new1561_6007))->approx) = ((approx_t) approx_1389), BUNSPEC);
      ((((intern_sfun_cinfo_192_t) CREF(new1561_6007))->stamp) = ((long) stamp_1390), BUNSPEC);
      return new1561_6007;
   }
}


/* _widening1004-intern-sfun/cinfo4425 */ obj_t 
_widening1004_intern_sfun_cinfo4425_56_cfa_info(obj_t env_10022, obj_t approx_10023, obj_t stamp_10024)
{
   {
      intern_sfun_cinfo_192_t aux_15671;
      aux_15671 = widening1004_intern_sfun_cinfo_148_cfa_info((approx_t) (approx_10023), (long) CINT(stamp_10024));
      return (obj_t) (aux_15671);
   }
}


/* make-intern-sfun/cinfo */ intern_sfun_cinfo_192_t 
make_intern_sfun_cinfo_198_cfa_info(long arity_1391, obj_t side_effect__165_1392, obj_t predicate_of_78_1393, obj_t stack_allocator_172_1394, bool_t top__138_1395, obj_t the_closure_238_1396, obj_t property_1397, obj_t args_1398, obj_t body_1399, obj_t class_1400, obj_t dsssl_keywords_243_1401, obj_t loc_1402, approx_t approx_1403, long stamp_1404)
{
   {
      sfun_t aux1565_6010;
      {
	 sfun_t res3764_6042;
	 {
	    sfun_t new1163_6026;
	    new1163_6026 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
	    {
	       long arg3025_6027;
	       arg3025_6027 = class_num_218___object(sfun_ast_var);
	       {
		  obj_t obj_6040;
		  obj_6040 = (obj_t) (new1163_6026);
		  (((obj_t) CREF(obj_6040))->header = MAKE_HEADER(arg3025_6027, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15680;
	       aux_15680 = (object_t) (new1163_6026);
	       OBJECT_WIDENING_SET(aux_15680, BFALSE);
	    }
	    ((((sfun_t) CREF(new1163_6026))->arity) = ((long) arity_1391), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->side_effect__165) = ((obj_t) side_effect__165_1392), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->predicate_of_78) = ((obj_t) predicate_of_78_1393), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->stack_allocator_172) = ((obj_t) stack_allocator_172_1394), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->top__138) = ((bool_t) top__138_1395), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->the_closure_238) = ((obj_t) the_closure_238_1396), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->property) = ((obj_t) property_1397), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->args) = ((obj_t) args_1398), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->body) = ((obj_t) body_1399), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->class) = ((obj_t) class_1400), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_1401), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6026))->loc) = ((obj_t) loc_1402), BUNSPEC);
	    res3764_6042 = new1163_6026;
	 }
	 aux1565_6010 = res3764_6042;
      }
      {
	 intern_sfun_cinfo_192_t new1566_6011;
	 new1566_6011 = ((intern_sfun_cinfo_192_t) (aux1565_6010));
	 {
	    long arg2950_6012;
	    arg2950_6012 = class_num_218___object(intern_sfun_cinfo_192_cfa_info);
	    {
	       obj_t obj_6043;
	       obj_6043 = (obj_t) (new1566_6011);
	       (((obj_t) CREF(obj_6043))->header = MAKE_HEADER(arg2950_6012, 0), BUNSPEC);
	    }
	 }
	 {
	    intern_sfun_cinfo_192_t arg2951_6013;
	    {
	       intern_sfun_cinfo_192_t res3765_6050;
	       {
		  intern_sfun_cinfo_192_t new1561_6047;
		  new1561_6047 = ((intern_sfun_cinfo_192_t) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
		  ((((intern_sfun_cinfo_192_t) CREF(new1561_6047))->approx) = ((approx_t) approx_1403), BUNSPEC);
		  ((((intern_sfun_cinfo_192_t) CREF(new1561_6047))->stamp) = ((long) stamp_1404), BUNSPEC);
		  res3765_6050 = new1561_6047;
	       }
	       arg2951_6013 = res3765_6050;
	    }
	    {
	       obj_t aux_15704;
	       object_t aux_15702;
	       aux_15704 = (obj_t) (arg2951_6013);
	       aux_15702 = (object_t) (new1566_6011);
	       OBJECT_WIDENING_SET(aux_15702, aux_15704);
	    }
	 }
	 return new1566_6011;
      }
   }
}


/* _make-intern-sfun/cinfo4426 */ obj_t 
_make_intern_sfun_cinfo4426_20_cfa_info(obj_t env_10025, obj_t arity_10026, obj_t side_effect__165_10027, obj_t predicate_of_78_10028, obj_t stack_allocator_172_10029, obj_t top__138_10030, obj_t the_closure_238_10031, obj_t property_10032, obj_t args_10033, obj_t body_10034, obj_t class_10035, obj_t dsssl_keywords_243_10036, obj_t loc_10037, obj_t approx_10038, obj_t stamp_10039)
{
   {
      intern_sfun_cinfo_192_t aux_15707;
      aux_15707 = make_intern_sfun_cinfo_198_cfa_info((long) CINT(arity_10026), side_effect__165_10027, predicate_of_78_10028, stack_allocator_172_10029, CBOOL(top__138_10030), the_closure_238_10031, property_10032, args_10033, body_10034, class_10035, dsssl_keywords_243_10036, loc_10037, (approx_t) (approx_10038), (long) CINT(stamp_10039));
      return (obj_t) (aux_15707);
   }
}


/* intern-sfun/cinfo-arity */ long 
intern_sfun_cinfo_arity_6_cfa_info(sfun_t obj_1405)
{
   return (((sfun_t) CREF(obj_1405))->arity);
}


/* _intern-sfun/cinfo-arity4427 */ obj_t 
_intern_sfun_cinfo_arity4427_65_cfa_info(obj_t env_10040, obj_t obj_10041)
{
   {
      long aux_15715;
      aux_15715 = intern_sfun_cinfo_arity_6_cfa_info((sfun_t) (obj_10041));
      return BINT(aux_15715);
   }
}


/* intern-sfun/cinfo-side-effect?-set! */ obj_t 
intern_sfun_cinfo_side_effect__set__189_cfa_info(sfun_t obj_1406, obj_t val1567_1407)
{
   return ((((sfun_t) CREF(obj_1406))->side_effect__165) = ((obj_t) val1567_1407), BUNSPEC);
}


/* _intern-sfun/cinfo-side-effect?-set!4428 */ obj_t 
_intern_sfun_cinfo_side_effect__set_4428_136_cfa_info(obj_t env_10042, obj_t obj_10043, obj_t val1567_10044)
{
   return intern_sfun_cinfo_side_effect__set__189_cfa_info((sfun_t) (obj_10043), val1567_10044);
}


/* intern-sfun/cinfo-side-effect? */ obj_t 
intern_sfun_cinfo_side_effect__206_cfa_info(sfun_t obj_1408)
{
   return (((sfun_t) CREF(obj_1408))->side_effect__165);
}


/* _intern-sfun/cinfo-side-effect?4429 */ obj_t 
_intern_sfun_cinfo_side_effect_4429_206_cfa_info(obj_t env_10045, obj_t obj_10046)
{
   return intern_sfun_cinfo_side_effect__206_cfa_info((sfun_t) (obj_10046));
}


/* intern-sfun/cinfo-predicate-of-set! */ obj_t 
intern_sfun_cinfo_predicate_of_set__1_cfa_info(sfun_t obj_1409, obj_t val1568_1410)
{
   return ((((sfun_t) CREF(obj_1409))->predicate_of_78) = ((obj_t) val1568_1410), BUNSPEC);
}


/* _intern-sfun/cinfo-predicate-of-set!4430 */ obj_t 
_intern_sfun_cinfo_predicate_of_set_4430_130_cfa_info(obj_t env_10047, obj_t obj_10048, obj_t val1568_10049)
{
   return intern_sfun_cinfo_predicate_of_set__1_cfa_info((sfun_t) (obj_10048), val1568_10049);
}


/* intern-sfun/cinfo-predicate-of */ obj_t 
intern_sfun_cinfo_predicate_of_250_cfa_info(sfun_t obj_1411)
{
   return (((sfun_t) CREF(obj_1411))->predicate_of_78);
}


/* _intern-sfun/cinfo-predicate-of4431 */ obj_t 
_intern_sfun_cinfo_predicate_of4431_196_cfa_info(obj_t env_10050, obj_t obj_10051)
{
   return intern_sfun_cinfo_predicate_of_250_cfa_info((sfun_t) (obj_10051));
}


/* intern-sfun/cinfo-stack-allocator-set! */ obj_t 
intern_sfun_cinfo_stack_allocator_set__130_cfa_info(sfun_t obj_1412, obj_t val1569_1413)
{
   return ((((sfun_t) CREF(obj_1412))->stack_allocator_172) = ((obj_t) val1569_1413), BUNSPEC);
}


/* _intern-sfun/cinfo-stack-allocator-set!4432 */ obj_t 
_intern_sfun_cinfo_stack_allocator_set_4432_140_cfa_info(obj_t env_10052, obj_t obj_10053, obj_t val1569_10054)
{
   return intern_sfun_cinfo_stack_allocator_set__130_cfa_info((sfun_t) (obj_10053), val1569_10054);
}


/* intern-sfun/cinfo-stack-allocator */ obj_t 
intern_sfun_cinfo_stack_allocator_82_cfa_info(sfun_t obj_1414)
{
   return (((sfun_t) CREF(obj_1414))->stack_allocator_172);
}


/* _intern-sfun/cinfo-stack-allocator4433 */ obj_t 
_intern_sfun_cinfo_stack_allocator4433_1_cfa_info(obj_t env_10055, obj_t obj_10056)
{
   return intern_sfun_cinfo_stack_allocator_82_cfa_info((sfun_t) (obj_10056));
}


/* intern-sfun/cinfo-top?-set! */ obj_t 
intern_sfun_cinfo_top__set__70_cfa_info(sfun_t obj_1415, bool_t val1570_1416)
{
   return ((((sfun_t) CREF(obj_1415))->top__138) = ((bool_t) val1570_1416), BUNSPEC);
}


/* _intern-sfun/cinfo-top?-set!4434 */ obj_t 
_intern_sfun_cinfo_top__set_4434_86_cfa_info(obj_t env_10057, obj_t obj_10058, obj_t val1570_10059)
{
   return intern_sfun_cinfo_top__set__70_cfa_info((sfun_t) (obj_10058), CBOOL(val1570_10059));
}


/* intern-sfun/cinfo-top? */ bool_t 
intern_sfun_cinfo_top__47_cfa_info(sfun_t obj_1417)
{
   return (((sfun_t) CREF(obj_1417))->top__138);
}


/* _intern-sfun/cinfo-top?4435 */ obj_t 
_intern_sfun_cinfo_top_4435_189_cfa_info(obj_t env_10060, obj_t obj_10061)
{
   {
      bool_t aux_15742;
      aux_15742 = intern_sfun_cinfo_top__47_cfa_info((sfun_t) (obj_10061));
      return BBOOL(aux_15742);
   }
}


/* intern-sfun/cinfo-the-closure-set! */ obj_t 
intern_sfun_cinfo_the_closure_set__54_cfa_info(sfun_t obj_1418, obj_t val1571_1419)
{
   return ((((sfun_t) CREF(obj_1418))->the_closure_238) = ((obj_t) val1571_1419), BUNSPEC);
}


/* _intern-sfun/cinfo-the-closure-set!4436 */ obj_t 
_intern_sfun_cinfo_the_closure_set_4436_80_cfa_info(obj_t env_10062, obj_t obj_10063, obj_t val1571_10064)
{
   return intern_sfun_cinfo_the_closure_set__54_cfa_info((sfun_t) (obj_10063), val1571_10064);
}


/* intern-sfun/cinfo-the-closure */ obj_t 
intern_sfun_cinfo_the_closure_231_cfa_info(sfun_t obj_1420)
{
   return (((sfun_t) CREF(obj_1420))->the_closure_238);
}


/* _intern-sfun/cinfo-the-closure4437 */ obj_t 
_intern_sfun_cinfo_the_closure4437_96_cfa_info(obj_t env_10065, obj_t obj_10066)
{
   return intern_sfun_cinfo_the_closure_231_cfa_info((sfun_t) (obj_10066));
}


/* intern-sfun/cinfo-property-set! */ obj_t 
intern_sfun_cinfo_property_set__111_cfa_info(sfun_t obj_1421, obj_t val1572_1422)
{
   return ((((sfun_t) CREF(obj_1421))->property) = ((obj_t) val1572_1422), BUNSPEC);
}


/* _intern-sfun/cinfo-property-set!4438 */ obj_t 
_intern_sfun_cinfo_property_set_4438_254_cfa_info(obj_t env_10067, obj_t obj_10068, obj_t val1572_10069)
{
   return intern_sfun_cinfo_property_set__111_cfa_info((sfun_t) (obj_10068), val1572_10069);
}


/* intern-sfun/cinfo-property */ obj_t 
intern_sfun_cinfo_property_154_cfa_info(sfun_t obj_1423)
{
   return (((sfun_t) CREF(obj_1423))->property);
}


/* _intern-sfun/cinfo-property4439 */ obj_t 
_intern_sfun_cinfo_property4439_34_cfa_info(obj_t env_10070, obj_t obj_10071)
{
   return intern_sfun_cinfo_property_154_cfa_info((sfun_t) (obj_10071));
}


/* intern-sfun/cinfo-args-set! */ obj_t 
intern_sfun_cinfo_args_set__79_cfa_info(sfun_t obj_1424, obj_t val1573_1425)
{
   return ((((sfun_t) CREF(obj_1424))->args) = ((obj_t) val1573_1425), BUNSPEC);
}


/* _intern-sfun/cinfo-args-set!4440 */ obj_t 
_intern_sfun_cinfo_args_set_4440_25_cfa_info(obj_t env_10072, obj_t obj_10073, obj_t val1573_10074)
{
   return intern_sfun_cinfo_args_set__79_cfa_info((sfun_t) (obj_10073), val1573_10074);
}


/* intern-sfun/cinfo-args */ obj_t 
intern_sfun_cinfo_args_90_cfa_info(sfun_t obj_1426)
{
   return (((sfun_t) CREF(obj_1426))->args);
}


/* _intern-sfun/cinfo-args4441 */ obj_t 
_intern_sfun_cinfo_args4441_113_cfa_info(obj_t env_10075, obj_t obj_10076)
{
   return intern_sfun_cinfo_args_90_cfa_info((sfun_t) (obj_10076));
}


/* intern-sfun/cinfo-body-set! */ obj_t 
intern_sfun_cinfo_body_set__86_cfa_info(sfun_t obj_1427, obj_t val1574_1428)
{
   return ((((sfun_t) CREF(obj_1427))->body) = ((obj_t) val1574_1428), BUNSPEC);
}


/* _intern-sfun/cinfo-body-set!4442 */ obj_t 
_intern_sfun_cinfo_body_set_4442_55_cfa_info(obj_t env_10077, obj_t obj_10078, obj_t val1574_10079)
{
   return intern_sfun_cinfo_body_set__86_cfa_info((sfun_t) (obj_10078), val1574_10079);
}


/* intern-sfun/cinfo-body */ obj_t 
intern_sfun_cinfo_body_52_cfa_info(sfun_t obj_1429)
{
   return (((sfun_t) CREF(obj_1429))->body);
}


/* _intern-sfun/cinfo-body4443 */ obj_t 
_intern_sfun_cinfo_body4443_134_cfa_info(obj_t env_10080, obj_t obj_10081)
{
   return intern_sfun_cinfo_body_52_cfa_info((sfun_t) (obj_10081));
}


/* intern-sfun/cinfo-class-set! */ obj_t 
intern_sfun_cinfo_class_set__85_cfa_info(sfun_t obj_1430, obj_t val1575_1431)
{
   return ((((sfun_t) CREF(obj_1430))->class) = ((obj_t) val1575_1431), BUNSPEC);
}


/* _intern-sfun/cinfo-class-set!4444 */ obj_t 
_intern_sfun_cinfo_class_set_4444_82_cfa_info(obj_t env_10082, obj_t obj_10083, obj_t val1575_10084)
{
   return intern_sfun_cinfo_class_set__85_cfa_info((sfun_t) (obj_10083), val1575_10084);
}


/* intern-sfun/cinfo-class */ obj_t 
intern_sfun_cinfo_class_26_cfa_info(sfun_t obj_1432)
{
   return (((sfun_t) CREF(obj_1432))->class);
}


/* _intern-sfun/cinfo-class4445 */ obj_t 
_intern_sfun_cinfo_class4445_4_cfa_info(obj_t env_10085, obj_t obj_10086)
{
   return intern_sfun_cinfo_class_26_cfa_info((sfun_t) (obj_10086));
}


/* intern-sfun/cinfo-dsssl-keywords-set! */ obj_t 
intern_sfun_cinfo_dsssl_keywords_set__175_cfa_info(sfun_t obj_1433, obj_t val1576_1434)
{
   return ((((sfun_t) CREF(obj_1433))->dsssl_keywords_243) = ((obj_t) val1576_1434), BUNSPEC);
}


/* _intern-sfun/cinfo-dsssl-keywords-set!4446 */ obj_t 
_intern_sfun_cinfo_dsssl_keywords_set_4446_68_cfa_info(obj_t env_10087, obj_t obj_10088, obj_t val1576_10089)
{
   return intern_sfun_cinfo_dsssl_keywords_set__175_cfa_info((sfun_t) (obj_10088), val1576_10089);
}


/* intern-sfun/cinfo-dsssl-keywords */ obj_t 
intern_sfun_cinfo_dsssl_keywords_133_cfa_info(sfun_t obj_1435)
{
   return (((sfun_t) CREF(obj_1435))->dsssl_keywords_243);
}


/* _intern-sfun/cinfo-dsssl-keywords4447 */ obj_t 
_intern_sfun_cinfo_dsssl_keywords4447_80_cfa_info(obj_t env_10090, obj_t obj_10091)
{
   return intern_sfun_cinfo_dsssl_keywords_133_cfa_info((sfun_t) (obj_10091));
}


/* intern-sfun/cinfo-loc-set! */ obj_t 
intern_sfun_cinfo_loc_set__209_cfa_info(sfun_t obj_1436, obj_t val1577_1437)
{
   return ((((sfun_t) CREF(obj_1436))->loc) = ((obj_t) val1577_1437), BUNSPEC);
}


/* _intern-sfun/cinfo-loc-set!4448 */ obj_t 
_intern_sfun_cinfo_loc_set_4448_214_cfa_info(obj_t env_10092, obj_t obj_10093, obj_t val1577_10094)
{
   return intern_sfun_cinfo_loc_set__209_cfa_info((sfun_t) (obj_10093), val1577_10094);
}


/* intern-sfun/cinfo-loc */ obj_t 
intern_sfun_cinfo_loc_54_cfa_info(sfun_t obj_1438)
{
   return (((sfun_t) CREF(obj_1438))->loc);
}


/* _intern-sfun/cinfo-loc4449 */ obj_t 
_intern_sfun_cinfo_loc4449_245_cfa_info(obj_t env_10095, obj_t obj_10096)
{
   return intern_sfun_cinfo_loc_54_cfa_info((sfun_t) (obj_10096));
}


/* intern-sfun/cinfo-approx */ approx_t 
intern_sfun_cinfo_approx_57_cfa_info(intern_sfun_cinfo_192_t obj_1439)
{
   {
      obj_t aux_15788;
      {
	 object_t aux_15789;
	 aux_15789 = (object_t) (obj_1439);
	 aux_15788 = OBJECT_WIDENING(aux_15789);
      }
      return (((intern_sfun_cinfo_192_t) CREF(aux_15788))->approx);
   }
}


/* _intern-sfun/cinfo-approx4450 */ obj_t 
_intern_sfun_cinfo_approx4450_186_cfa_info(obj_t env_10097, obj_t obj_10098)
{
   {
      approx_t aux_15793;
      aux_15793 = intern_sfun_cinfo_approx_57_cfa_info((intern_sfun_cinfo_192_t) (obj_10098));
      return (obj_t) (aux_15793);
   }
}


/* intern-sfun/cinfo-stamp-set! */ obj_t 
intern_sfun_cinfo_stamp_set__83_cfa_info(intern_sfun_cinfo_192_t obj_1440, long val1578_1441)
{
   {
      obj_t aux_15797;
      {
	 object_t aux_15798;
	 aux_15798 = (object_t) (obj_1440);
	 aux_15797 = OBJECT_WIDENING(aux_15798);
      }
      return ((((intern_sfun_cinfo_192_t) CREF(aux_15797))->stamp) = ((long) val1578_1441), BUNSPEC);
   }
}


/* _intern-sfun/cinfo-stamp-set!4451 */ obj_t 
_intern_sfun_cinfo_stamp_set_4451_82_cfa_info(obj_t env_10099, obj_t obj_10100, obj_t val1578_10101)
{
   return intern_sfun_cinfo_stamp_set__83_cfa_info((intern_sfun_cinfo_192_t) (obj_10100), (long) CINT(val1578_10101));
}


/* intern-sfun/cinfo-stamp */ long 
intern_sfun_cinfo_stamp_249_cfa_info(intern_sfun_cinfo_192_t obj_1442)
{
   {
      obj_t aux_15805;
      {
	 object_t aux_15806;
	 aux_15806 = (object_t) (obj_1442);
	 aux_15805 = OBJECT_WIDENING(aux_15806);
      }
      return (((intern_sfun_cinfo_192_t) CREF(aux_15805))->stamp);
   }
}


/* _intern-sfun/cinfo-stamp4452 */ obj_t 
_intern_sfun_cinfo_stamp4452_130_cfa_info(obj_t env_10102, obj_t obj_10103)
{
   {
      long aux_15810;
      aux_15810 = intern_sfun_cinfo_stamp_249_cfa_info((intern_sfun_cinfo_192_t) (obj_10103));
      return BINT(aux_15810);
   }
}


/* allocate-extern-sfun/cinfo */ sfun_t 
allocate_extern_sfun_cinfo_223_cfa_info()
{
   {
      sfun_t new1552_2847;
      new1552_2847 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
      {
	 long arg2952_2848;
	 arg2952_2848 = class_num_218___object(extern_sfun_cinfo_6_cfa_info);
	 {
	    obj_t obj_6051;
	    obj_6051 = (obj_t) (new1552_2847);
	    (((obj_t) CREF(obj_6051))->header = MAKE_HEADER(arg2952_2848, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15818;
	 aux_15818 = (object_t) (new1552_2847);
	 OBJECT_WIDENING_SET(aux_15818, BFALSE);
      }
      return new1552_2847;
   }
}


/* _allocate-extern-sfun/cinfo */ obj_t 
_allocate_extern_sfun_cinfo_234_cfa_info(obj_t env_8023)
{
   {
      sfun_t aux_15821;
      aux_15821 = allocate_extern_sfun_cinfo_223_cfa_info();
      return (obj_t) (aux_15821);
   }
}


/* extern-sfun/cinfo? */ bool_t 
extern_sfun_cinfo__167_cfa_info(obj_t obj_1446)
{
   return is_a__118___object(obj_1446, extern_sfun_cinfo_6_cfa_info);
}


/* _extern-sfun/cinfo? */ obj_t 
_extern_sfun_cinfo__255_cfa_info(obj_t env_10104, obj_t obj_10105)
{
   {
      bool_t aux_15825;
      aux_15825 = extern_sfun_cinfo__167_cfa_info(obj_10105);
      return BBOOL(aux_15825);
   }
}


/* widening1003-extern-sfun/cinfo */ extern_sfun_cinfo_6_t 
widening1003_extern_sfun_cinfo_159_cfa_info(approx_t approx_1447)
{
   {
      extern_sfun_cinfo_6_t new1536_6053;
      new1536_6053 = ((extern_sfun_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
      ((((extern_sfun_cinfo_6_t) CREF(new1536_6053))->approx) = ((approx_t) approx_1447), BUNSPEC);
      return new1536_6053;
   }
}


/* _widening1003-extern-sfun/cinfo4453 */ obj_t 
_widening1003_extern_sfun_cinfo4453_165_cfa_info(obj_t env_10106, obj_t approx_10107)
{
   {
      extern_sfun_cinfo_6_t aux_15830;
      aux_15830 = widening1003_extern_sfun_cinfo_159_cfa_info((approx_t) (approx_10107));
      return (obj_t) (aux_15830);
   }
}


/* make-extern-sfun/cinfo */ extern_sfun_cinfo_6_t 
make_extern_sfun_cinfo_180_cfa_info(long arity_1448, obj_t side_effect__165_1449, obj_t predicate_of_78_1450, obj_t stack_allocator_172_1451, bool_t top__138_1452, obj_t the_closure_238_1453, obj_t property_1454, obj_t args_1455, obj_t body_1456, obj_t class_1457, obj_t dsssl_keywords_243_1458, obj_t loc_1459, approx_t approx_1460)
{
   {
      sfun_t aux1539_6055;
      {
	 sfun_t res3766_6087;
	 {
	    sfun_t new1163_6071;
	    new1163_6071 = ((sfun_t) BREF(GC_MALLOC(sizeof(struct sfun))));
	    {
	       long arg3025_6072;
	       arg3025_6072 = class_num_218___object(sfun_ast_var);
	       {
		  obj_t obj_6085;
		  obj_6085 = (obj_t) (new1163_6071);
		  (((obj_t) CREF(obj_6085))->header = MAKE_HEADER(arg3025_6072, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15838;
	       aux_15838 = (object_t) (new1163_6071);
	       OBJECT_WIDENING_SET(aux_15838, BFALSE);
	    }
	    ((((sfun_t) CREF(new1163_6071))->arity) = ((long) arity_1448), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->side_effect__165) = ((obj_t) side_effect__165_1449), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->predicate_of_78) = ((obj_t) predicate_of_78_1450), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->stack_allocator_172) = ((obj_t) stack_allocator_172_1451), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->top__138) = ((bool_t) top__138_1452), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->the_closure_238) = ((obj_t) the_closure_238_1453), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->property) = ((obj_t) property_1454), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->args) = ((obj_t) args_1455), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->body) = ((obj_t) body_1456), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->class) = ((obj_t) class_1457), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_1458), BUNSPEC);
	    ((((sfun_t) CREF(new1163_6071))->loc) = ((obj_t) loc_1459), BUNSPEC);
	    res3766_6087 = new1163_6071;
	 }
	 aux1539_6055 = res3766_6087;
      }
      {
	 extern_sfun_cinfo_6_t new1540_6056;
	 new1540_6056 = ((extern_sfun_cinfo_6_t) (aux1539_6055));
	 {
	    long arg2953_6057;
	    arg2953_6057 = class_num_218___object(extern_sfun_cinfo_6_cfa_info);
	    {
	       obj_t obj_6088;
	       obj_6088 = (obj_t) (new1540_6056);
	       (((obj_t) CREF(obj_6088))->header = MAKE_HEADER(arg2953_6057, 0), BUNSPEC);
	    }
	 }
	 {
	    extern_sfun_cinfo_6_t arg2955_6058;
	    {
	       extern_sfun_cinfo_6_t res3767_6093;
	       {
		  extern_sfun_cinfo_6_t new1536_6091;
		  new1536_6091 = ((extern_sfun_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
		  ((((extern_sfun_cinfo_6_t) CREF(new1536_6091))->approx) = ((approx_t) approx_1460), BUNSPEC);
		  res3767_6093 = new1536_6091;
	       }
	       arg2955_6058 = res3767_6093;
	    }
	    {
	       obj_t aux_15861;
	       object_t aux_15859;
	       aux_15861 = (obj_t) (arg2955_6058);
	       aux_15859 = (object_t) (new1540_6056);
	       OBJECT_WIDENING_SET(aux_15859, aux_15861);
	    }
	 }
	 return new1540_6056;
      }
   }
}


/* _make-extern-sfun/cinfo4454 */ obj_t 
_make_extern_sfun_cinfo4454_19_cfa_info(obj_t env_10108, obj_t arity_10109, obj_t side_effect__165_10110, obj_t predicate_of_78_10111, obj_t stack_allocator_172_10112, obj_t top__138_10113, obj_t the_closure_238_10114, obj_t property_10115, obj_t args_10116, obj_t body_10117, obj_t class_10118, obj_t dsssl_keywords_243_10119, obj_t loc_10120, obj_t approx_10121)
{
   {
      extern_sfun_cinfo_6_t aux_15864;
      aux_15864 = make_extern_sfun_cinfo_180_cfa_info((long) CINT(arity_10109), side_effect__165_10110, predicate_of_78_10111, stack_allocator_172_10112, CBOOL(top__138_10113), the_closure_238_10114, property_10115, args_10116, body_10117, class_10118, dsssl_keywords_243_10119, loc_10120, (approx_t) (approx_10121));
      return (obj_t) (aux_15864);
   }
}


/* extern-sfun/cinfo-arity */ long 
extern_sfun_cinfo_arity_43_cfa_info(sfun_t obj_1461)
{
   return (((sfun_t) CREF(obj_1461))->arity);
}


/* _extern-sfun/cinfo-arity4455 */ obj_t 
_extern_sfun_cinfo_arity4455_205_cfa_info(obj_t env_10122, obj_t obj_10123)
{
   {
      long aux_15871;
      aux_15871 = extern_sfun_cinfo_arity_43_cfa_info((sfun_t) (obj_10123));
      return BINT(aux_15871);
   }
}


/* extern-sfun/cinfo-side-effect?-set! */ obj_t 
extern_sfun_cinfo_side_effect__set__111_cfa_info(sfun_t obj_1462, obj_t val1541_1463)
{
   return ((((sfun_t) CREF(obj_1462))->side_effect__165) = ((obj_t) val1541_1463), BUNSPEC);
}


/* _extern-sfun/cinfo-side-effect?-set!4456 */ obj_t 
_extern_sfun_cinfo_side_effect__set_4456_23_cfa_info(obj_t env_10124, obj_t obj_10125, obj_t val1541_10126)
{
   return extern_sfun_cinfo_side_effect__set__111_cfa_info((sfun_t) (obj_10125), val1541_10126);
}


/* extern-sfun/cinfo-side-effect? */ obj_t 
extern_sfun_cinfo_side_effect__154_cfa_info(sfun_t obj_1464)
{
   return (((sfun_t) CREF(obj_1464))->side_effect__165);
}


/* _extern-sfun/cinfo-side-effect?4457 */ obj_t 
_extern_sfun_cinfo_side_effect_4457_249_cfa_info(obj_t env_10127, obj_t obj_10128)
{
   return extern_sfun_cinfo_side_effect__154_cfa_info((sfun_t) (obj_10128));
}


/* extern-sfun/cinfo-predicate-of-set! */ obj_t 
extern_sfun_cinfo_predicate_of_set__5_cfa_info(sfun_t obj_1465, obj_t val1542_1466)
{
   return ((((sfun_t) CREF(obj_1465))->predicate_of_78) = ((obj_t) val1542_1466), BUNSPEC);
}


/* _extern-sfun/cinfo-predicate-of-set!4458 */ obj_t 
_extern_sfun_cinfo_predicate_of_set_4458_176_cfa_info(obj_t env_10129, obj_t obj_10130, obj_t val1542_10131)
{
   return extern_sfun_cinfo_predicate_of_set__5_cfa_info((sfun_t) (obj_10130), val1542_10131);
}


/* extern-sfun/cinfo-predicate-of */ obj_t 
extern_sfun_cinfo_predicate_of_245_cfa_info(sfun_t obj_1467)
{
   return (((sfun_t) CREF(obj_1467))->predicate_of_78);
}


/* _extern-sfun/cinfo-predicate-of4459 */ obj_t 
_extern_sfun_cinfo_predicate_of4459_42_cfa_info(obj_t env_10132, obj_t obj_10133)
{
   return extern_sfun_cinfo_predicate_of_245_cfa_info((sfun_t) (obj_10133));
}


/* extern-sfun/cinfo-stack-allocator-set! */ obj_t 
extern_sfun_cinfo_stack_allocator_set__23_cfa_info(sfun_t obj_1468, obj_t val1543_1469)
{
   return ((((sfun_t) CREF(obj_1468))->stack_allocator_172) = ((obj_t) val1543_1469), BUNSPEC);
}


/* _extern-sfun/cinfo-stack-allocator-set!4460 */ obj_t 
_extern_sfun_cinfo_stack_allocator_set_4460_90_cfa_info(obj_t env_10134, obj_t obj_10135, obj_t val1543_10136)
{
   return extern_sfun_cinfo_stack_allocator_set__23_cfa_info((sfun_t) (obj_10135), val1543_10136);
}


/* extern-sfun/cinfo-stack-allocator */ obj_t 
extern_sfun_cinfo_stack_allocator_17_cfa_info(sfun_t obj_1470)
{
   return (((sfun_t) CREF(obj_1470))->stack_allocator_172);
}


/* _extern-sfun/cinfo-stack-allocator4461 */ obj_t 
_extern_sfun_cinfo_stack_allocator4461_171_cfa_info(obj_t env_10137, obj_t obj_10138)
{
   return extern_sfun_cinfo_stack_allocator_17_cfa_info((sfun_t) (obj_10138));
}


/* extern-sfun/cinfo-top?-set! */ obj_t 
extern_sfun_cinfo_top__set__250_cfa_info(sfun_t obj_1471, bool_t val1544_1472)
{
   return ((((sfun_t) CREF(obj_1471))->top__138) = ((bool_t) val1544_1472), BUNSPEC);
}


/* _extern-sfun/cinfo-top?-set!4462 */ obj_t 
_extern_sfun_cinfo_top__set_4462_110_cfa_info(obj_t env_10139, obj_t obj_10140, obj_t val1544_10141)
{
   return extern_sfun_cinfo_top__set__250_cfa_info((sfun_t) (obj_10140), CBOOL(val1544_10141));
}


/* extern-sfun/cinfo-top? */ bool_t 
extern_sfun_cinfo_top__212_cfa_info(sfun_t obj_1473)
{
   return (((sfun_t) CREF(obj_1473))->top__138);
}


/* _extern-sfun/cinfo-top?4463 */ obj_t 
_extern_sfun_cinfo_top_4463_92_cfa_info(obj_t env_10142, obj_t obj_10143)
{
   {
      bool_t aux_15898;
      aux_15898 = extern_sfun_cinfo_top__212_cfa_info((sfun_t) (obj_10143));
      return BBOOL(aux_15898);
   }
}


/* extern-sfun/cinfo-the-closure-set! */ obj_t 
extern_sfun_cinfo_the_closure_set__203_cfa_info(sfun_t obj_1474, obj_t val1545_1475)
{
   return ((((sfun_t) CREF(obj_1474))->the_closure_238) = ((obj_t) val1545_1475), BUNSPEC);
}


/* _extern-sfun/cinfo-the-closure-set!4464 */ obj_t 
_extern_sfun_cinfo_the_closure_set_4464_103_cfa_info(obj_t env_10144, obj_t obj_10145, obj_t val1545_10146)
{
   return extern_sfun_cinfo_the_closure_set__203_cfa_info((sfun_t) (obj_10145), val1545_10146);
}


/* extern-sfun/cinfo-the-closure */ obj_t 
extern_sfun_cinfo_the_closure_159_cfa_info(sfun_t obj_1476)
{
   return (((sfun_t) CREF(obj_1476))->the_closure_238);
}


/* _extern-sfun/cinfo-the-closure4465 */ obj_t 
_extern_sfun_cinfo_the_closure4465_235_cfa_info(obj_t env_10147, obj_t obj_10148)
{
   return extern_sfun_cinfo_the_closure_159_cfa_info((sfun_t) (obj_10148));
}


/* extern-sfun/cinfo-property-set! */ obj_t 
extern_sfun_cinfo_property_set__166_cfa_info(sfun_t obj_1477, obj_t val1546_1478)
{
   return ((((sfun_t) CREF(obj_1477))->property) = ((obj_t) val1546_1478), BUNSPEC);
}


/* _extern-sfun/cinfo-property-set!4466 */ obj_t 
_extern_sfun_cinfo_property_set_4466_95_cfa_info(obj_t env_10149, obj_t obj_10150, obj_t val1546_10151)
{
   return extern_sfun_cinfo_property_set__166_cfa_info((sfun_t) (obj_10150), val1546_10151);
}


/* extern-sfun/cinfo-property */ obj_t 
extern_sfun_cinfo_property_112_cfa_info(sfun_t obj_1479)
{
   return (((sfun_t) CREF(obj_1479))->property);
}


/* _extern-sfun/cinfo-property4467 */ obj_t 
_extern_sfun_cinfo_property4467_53_cfa_info(obj_t env_10152, obj_t obj_10153)
{
   return extern_sfun_cinfo_property_112_cfa_info((sfun_t) (obj_10153));
}


/* extern-sfun/cinfo-args-set! */ obj_t 
extern_sfun_cinfo_args_set__187_cfa_info(sfun_t obj_1480, obj_t val1547_1481)
{
   return ((((sfun_t) CREF(obj_1480))->args) = ((obj_t) val1547_1481), BUNSPEC);
}


/* _extern-sfun/cinfo-args-set!4468 */ obj_t 
_extern_sfun_cinfo_args_set_4468_204_cfa_info(obj_t env_10154, obj_t obj_10155, obj_t val1547_10156)
{
   return extern_sfun_cinfo_args_set__187_cfa_info((sfun_t) (obj_10155), val1547_10156);
}


/* extern-sfun/cinfo-args */ obj_t 
extern_sfun_cinfo_args_4_cfa_info(sfun_t obj_1482)
{
   return (((sfun_t) CREF(obj_1482))->args);
}


/* _extern-sfun/cinfo-args4469 */ obj_t 
_extern_sfun_cinfo_args4469_187_cfa_info(obj_t env_10157, obj_t obj_10158)
{
   return extern_sfun_cinfo_args_4_cfa_info((sfun_t) (obj_10158));
}


/* extern-sfun/cinfo-body-set! */ obj_t 
extern_sfun_cinfo_body_set__15_cfa_info(sfun_t obj_1483, obj_t val1548_1484)
{
   return ((((sfun_t) CREF(obj_1483))->body) = ((obj_t) val1548_1484), BUNSPEC);
}


/* _extern-sfun/cinfo-body-set!4470 */ obj_t 
_extern_sfun_cinfo_body_set_4470_56_cfa_info(obj_t env_10159, obj_t obj_10160, obj_t val1548_10161)
{
   return extern_sfun_cinfo_body_set__15_cfa_info((sfun_t) (obj_10160), val1548_10161);
}


/* extern-sfun/cinfo-body */ obj_t 
extern_sfun_cinfo_body_232_cfa_info(sfun_t obj_1485)
{
   return (((sfun_t) CREF(obj_1485))->body);
}


/* _extern-sfun/cinfo-body4471 */ obj_t 
_extern_sfun_cinfo_body4471_1_cfa_info(obj_t env_10162, obj_t obj_10163)
{
   return extern_sfun_cinfo_body_232_cfa_info((sfun_t) (obj_10163));
}


/* extern-sfun/cinfo-class-set! */ obj_t 
extern_sfun_cinfo_class_set__12_cfa_info(sfun_t obj_1486, obj_t val1549_1487)
{
   return ((((sfun_t) CREF(obj_1486))->class) = ((obj_t) val1549_1487), BUNSPEC);
}


/* _extern-sfun/cinfo-class-set!4472 */ obj_t 
_extern_sfun_cinfo_class_set_4472_168_cfa_info(obj_t env_10164, obj_t obj_10165, obj_t val1549_10166)
{
   return extern_sfun_cinfo_class_set__12_cfa_info((sfun_t) (obj_10165), val1549_10166);
}


/* extern-sfun/cinfo-class */ obj_t 
extern_sfun_cinfo_class_204_cfa_info(sfun_t obj_1488)
{
   return (((sfun_t) CREF(obj_1488))->class);
}


/* _extern-sfun/cinfo-class4473 */ obj_t 
_extern_sfun_cinfo_class4473_67_cfa_info(obj_t env_10167, obj_t obj_10168)
{
   return extern_sfun_cinfo_class_204_cfa_info((sfun_t) (obj_10168));
}


/* extern-sfun/cinfo-dsssl-keywords-set! */ obj_t 
extern_sfun_cinfo_dsssl_keywords_set__212_cfa_info(sfun_t obj_1489, obj_t val1550_1490)
{
   return ((((sfun_t) CREF(obj_1489))->dsssl_keywords_243) = ((obj_t) val1550_1490), BUNSPEC);
}


/* _extern-sfun/cinfo-dsssl-keywords-set!4474 */ obj_t 
_extern_sfun_cinfo_dsssl_keywords_set_4474_11_cfa_info(obj_t env_10169, obj_t obj_10170, obj_t val1550_10171)
{
   return extern_sfun_cinfo_dsssl_keywords_set__212_cfa_info((sfun_t) (obj_10170), val1550_10171);
}


/* extern-sfun/cinfo-dsssl-keywords */ obj_t 
extern_sfun_cinfo_dsssl_keywords_3_cfa_info(sfun_t obj_1491)
{
   return (((sfun_t) CREF(obj_1491))->dsssl_keywords_243);
}


/* _extern-sfun/cinfo-dsssl-keywords4475 */ obj_t 
_extern_sfun_cinfo_dsssl_keywords4475_201_cfa_info(obj_t env_10172, obj_t obj_10173)
{
   return extern_sfun_cinfo_dsssl_keywords_3_cfa_info((sfun_t) (obj_10173));
}


/* extern-sfun/cinfo-loc-set! */ obj_t 
extern_sfun_cinfo_loc_set__83_cfa_info(sfun_t obj_1492, obj_t val1551_1493)
{
   return ((((sfun_t) CREF(obj_1492))->loc) = ((obj_t) val1551_1493), BUNSPEC);
}


/* _extern-sfun/cinfo-loc-set!4476 */ obj_t 
_extern_sfun_cinfo_loc_set_4476_26_cfa_info(obj_t env_10174, obj_t obj_10175, obj_t val1551_10176)
{
   return extern_sfun_cinfo_loc_set__83_cfa_info((sfun_t) (obj_10175), val1551_10176);
}


/* extern-sfun/cinfo-loc */ obj_t 
extern_sfun_cinfo_loc_249_cfa_info(sfun_t obj_1494)
{
   return (((sfun_t) CREF(obj_1494))->loc);
}


/* _extern-sfun/cinfo-loc4477 */ obj_t 
_extern_sfun_cinfo_loc4477_88_cfa_info(obj_t env_10177, obj_t obj_10178)
{
   return extern_sfun_cinfo_loc_249_cfa_info((sfun_t) (obj_10178));
}


/* extern-sfun/cinfo-approx */ approx_t 
extern_sfun_cinfo_approx_180_cfa_info(extern_sfun_cinfo_6_t obj_1495)
{
   {
      obj_t aux_15944;
      {
	 object_t aux_15945;
	 aux_15945 = (object_t) (obj_1495);
	 aux_15944 = OBJECT_WIDENING(aux_15945);
      }
      return (((extern_sfun_cinfo_6_t) CREF(aux_15944))->approx);
   }
}


/* _extern-sfun/cinfo-approx4478 */ obj_t 
_extern_sfun_cinfo_approx4478_97_cfa_info(obj_t env_10179, obj_t obj_10180)
{
   {
      approx_t aux_15949;
      aux_15949 = extern_sfun_cinfo_approx_180_cfa_info((extern_sfun_cinfo_6_t) (obj_10180));
      return (obj_t) (aux_15949);
   }
}


/* allocate-cfun/cinfo */ cfun_t 
allocate_cfun_cinfo_179_cfa_info()
{
   {
      cfun_t new1528_2855;
      new1528_2855 = ((cfun_t) BREF(GC_MALLOC(sizeof(struct cfun))));
      {
	 long arg2957_2856;
	 arg2957_2856 = class_num_218___object(cfun_cinfo_200_cfa_info);
	 {
	    obj_t obj_6094;
	    obj_6094 = (obj_t) (new1528_2855);
	    (((obj_t) CREF(obj_6094))->header = MAKE_HEADER(arg2957_2856, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_15957;
	 aux_15957 = (object_t) (new1528_2855);
	 OBJECT_WIDENING_SET(aux_15957, BFALSE);
      }
      return new1528_2855;
   }
}


/* _allocate-cfun/cinfo */ obj_t 
_allocate_cfun_cinfo_87_cfa_info(obj_t env_8022)
{
   {
      cfun_t aux_15960;
      aux_15960 = allocate_cfun_cinfo_179_cfa_info();
      return (obj_t) (aux_15960);
   }
}


/* cfun/cinfo? */ bool_t 
cfun_cinfo__10_cfa_info(obj_t obj_1499)
{
   return is_a__118___object(obj_1499, cfun_cinfo_200_cfa_info);
}


/* _cfun/cinfo? */ obj_t 
_cfun_cinfo__48_cfa_info(obj_t env_10181, obj_t obj_10182)
{
   {
      bool_t aux_15964;
      aux_15964 = cfun_cinfo__10_cfa_info(obj_10182);
      return BBOOL(aux_15964);
   }
}


/* widening1002-cfun/cinfo */ cfun_cinfo_200_t 
widening1002_cfun_cinfo_213_cfa_info(approx_t approx_1500)
{
   {
      cfun_cinfo_200_t new1517_6096;
      new1517_6096 = ((cfun_cinfo_200_t) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
      ((((cfun_cinfo_200_t) CREF(new1517_6096))->approx) = ((approx_t) approx_1500), BUNSPEC);
      return new1517_6096;
   }
}


/* _widening1002-cfun/cinfo4479 */ obj_t 
_widening1002_cfun_cinfo4479_45_cfa_info(obj_t env_10183, obj_t approx_10184)
{
   {
      cfun_cinfo_200_t aux_15969;
      aux_15969 = widening1002_cfun_cinfo_213_cfa_info((approx_t) (approx_10184));
      return (obj_t) (aux_15969);
   }
}


/* make-cfun/cinfo */ cfun_cinfo_200_t 
make_cfun_cinfo_44_cfa_info(long arity_1501, obj_t side_effect__165_1502, obj_t predicate_of_78_1503, obj_t stack_allocator_172_1504, bool_t top__138_1505, obj_t the_closure_238_1506, obj_t args_type_205_1507, bool_t macro__33_1508, bool_t infix__163_1509, approx_t approx_1510)
{
   {
      cfun_t aux1520_6098;
      {
	 cfun_t res3768_6124;
	 {
	    cfun_t new1189_6111;
	    new1189_6111 = ((cfun_t) BREF(GC_MALLOC(sizeof(struct cfun))));
	    {
	       long arg3023_6112;
	       arg3023_6112 = class_num_218___object(cfun_ast_var);
	       {
		  obj_t obj_6122;
		  obj_6122 = (obj_t) (new1189_6111);
		  (((obj_t) CREF(obj_6122))->header = MAKE_HEADER(arg3023_6112, 0), BUNSPEC);
	       }
	    }
	    {
	       object_t aux_15977;
	       aux_15977 = (object_t) (new1189_6111);
	       OBJECT_WIDENING_SET(aux_15977, BFALSE);
	    }
	    ((((cfun_t) CREF(new1189_6111))->arity) = ((long) arity_1501), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->side_effect__165) = ((obj_t) side_effect__165_1502), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->predicate_of_78) = ((obj_t) predicate_of_78_1503), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->stack_allocator_172) = ((obj_t) stack_allocator_172_1504), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->top__138) = ((bool_t) top__138_1505), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->the_closure_238) = ((obj_t) the_closure_238_1506), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->args_type_205) = ((obj_t) args_type_205_1507), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->macro__33) = ((bool_t) macro__33_1508), BUNSPEC);
	    ((((cfun_t) CREF(new1189_6111))->infix__163) = ((bool_t) infix__163_1509), BUNSPEC);
	    res3768_6124 = new1189_6111;
	 }
	 aux1520_6098 = res3768_6124;
      }
      {
	 cfun_cinfo_200_t new1521_6099;
	 new1521_6099 = ((cfun_cinfo_200_t) (aux1520_6098));
	 {
	    long arg2958_6100;
	    arg2958_6100 = class_num_218___object(cfun_cinfo_200_cfa_info);
	    {
	       obj_t obj_6125;
	       obj_6125 = (obj_t) (new1521_6099);
	       (((obj_t) CREF(obj_6125))->header = MAKE_HEADER(arg2958_6100, 0), BUNSPEC);
	    }
	 }
	 {
	    cfun_cinfo_200_t arg2959_6101;
	    {
	       cfun_cinfo_200_t res3769_6130;
	       {
		  cfun_cinfo_200_t new1517_6128;
		  new1517_6128 = ((cfun_cinfo_200_t) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
		  ((((cfun_cinfo_200_t) CREF(new1517_6128))->approx) = ((approx_t) approx_1510), BUNSPEC);
		  res3769_6130 = new1517_6128;
	       }
	       arg2959_6101 = res3769_6130;
	    }
	    {
	       obj_t aux_15997;
	       object_t aux_15995;
	       aux_15997 = (obj_t) (arg2959_6101);
	       aux_15995 = (object_t) (new1521_6099);
	       OBJECT_WIDENING_SET(aux_15995, aux_15997);
	    }
	 }
	 return new1521_6099;
      }
   }
}


/* _make-cfun/cinfo4480 */ obj_t 
_make_cfun_cinfo4480_68_cfa_info(obj_t env_10185, obj_t arity_10186, obj_t side_effect__165_10187, obj_t predicate_of_78_10188, obj_t stack_allocator_172_10189, obj_t top__138_10190, obj_t the_closure_238_10191, obj_t args_type_205_10192, obj_t macro__33_10193, obj_t infix__163_10194, obj_t approx_10195)
{
   {
      cfun_cinfo_200_t aux_16000;
      aux_16000 = make_cfun_cinfo_44_cfa_info((long) CINT(arity_10186), side_effect__165_10187, predicate_of_78_10188, stack_allocator_172_10189, CBOOL(top__138_10190), the_closure_238_10191, args_type_205_10192, CBOOL(macro__33_10193), CBOOL(infix__163_10194), (approx_t) (approx_10195));
      return (obj_t) (aux_16000);
   }
}


/* cfun/cinfo-arity */ long 
cfun_cinfo_arity_247_cfa_info(cfun_t obj_1511)
{
   return (((cfun_t) CREF(obj_1511))->arity);
}


/* _cfun/cinfo-arity4481 */ obj_t 
_cfun_cinfo_arity4481_7_cfa_info(obj_t env_10196, obj_t obj_10197)
{
   {
      long aux_16009;
      aux_16009 = cfun_cinfo_arity_247_cfa_info((cfun_t) (obj_10197));
      return BINT(aux_16009);
   }
}


/* cfun/cinfo-side-effect?-set! */ obj_t 
cfun_cinfo_side_effect__set__194_cfa_info(cfun_t obj_1512, obj_t val1522_1513)
{
   return ((((cfun_t) CREF(obj_1512))->side_effect__165) = ((obj_t) val1522_1513), BUNSPEC);
}


/* _cfun/cinfo-side-effect?-set!4482 */ obj_t 
_cfun_cinfo_side_effect__set_4482_56_cfa_info(obj_t env_10198, obj_t obj_10199, obj_t val1522_10200)
{
   return cfun_cinfo_side_effect__set__194_cfa_info((cfun_t) (obj_10199), val1522_10200);
}


/* cfun/cinfo-side-effect? */ obj_t 
cfun_cinfo_side_effect__165_cfa_info(cfun_t obj_1514)
{
   return (((cfun_t) CREF(obj_1514))->side_effect__165);
}


/* _cfun/cinfo-side-effect?4483 */ obj_t 
_cfun_cinfo_side_effect_4483_210_cfa_info(obj_t env_10201, obj_t obj_10202)
{
   return cfun_cinfo_side_effect__165_cfa_info((cfun_t) (obj_10202));
}


/* cfun/cinfo-predicate-of-set! */ obj_t 
cfun_cinfo_predicate_of_set__153_cfa_info(cfun_t obj_1515, obj_t val1523_1516)
{
   return ((((cfun_t) CREF(obj_1515))->predicate_of_78) = ((obj_t) val1523_1516), BUNSPEC);
}


/* _cfun/cinfo-predicate-of-set!4484 */ obj_t 
_cfun_cinfo_predicate_of_set_4484_6_cfa_info(obj_t env_10203, obj_t obj_10204, obj_t val1523_10205)
{
   return cfun_cinfo_predicate_of_set__153_cfa_info((cfun_t) (obj_10204), val1523_10205);
}


/* cfun/cinfo-predicate-of */ obj_t 
cfun_cinfo_predicate_of_78_cfa_info(cfun_t obj_1517)
{
   return (((cfun_t) CREF(obj_1517))->predicate_of_78);
}


/* _cfun/cinfo-predicate-of4485 */ obj_t 
_cfun_cinfo_predicate_of4485_174_cfa_info(obj_t env_10206, obj_t obj_10207)
{
   return cfun_cinfo_predicate_of_78_cfa_info((cfun_t) (obj_10207));
}


/* cfun/cinfo-stack-allocator-set! */ obj_t 
cfun_cinfo_stack_allocator_set__152_cfa_info(cfun_t obj_1518, obj_t val1524_1519)
{
   return ((((cfun_t) CREF(obj_1518))->stack_allocator_172) = ((obj_t) val1524_1519), BUNSPEC);
}


/* _cfun/cinfo-stack-allocator-set!4486 */ obj_t 
_cfun_cinfo_stack_allocator_set_4486_92_cfa_info(obj_t env_10208, obj_t obj_10209, obj_t val1524_10210)
{
   return cfun_cinfo_stack_allocator_set__152_cfa_info((cfun_t) (obj_10209), val1524_10210);
}


/* cfun/cinfo-stack-allocator */ obj_t 
cfun_cinfo_stack_allocator_172_cfa_info(cfun_t obj_1520)
{
   return (((cfun_t) CREF(obj_1520))->stack_allocator_172);
}


/* _cfun/cinfo-stack-allocator4487 */ obj_t 
_cfun_cinfo_stack_allocator4487_207_cfa_info(obj_t env_10211, obj_t obj_10212)
{
   return cfun_cinfo_stack_allocator_172_cfa_info((cfun_t) (obj_10212));
}


/* cfun/cinfo-top?-set! */ obj_t 
cfun_cinfo_top__set__172_cfa_info(cfun_t obj_1521, bool_t val1525_1522)
{
   return ((((cfun_t) CREF(obj_1521))->top__138) = ((bool_t) val1525_1522), BUNSPEC);
}


/* _cfun/cinfo-top?-set!4488 */ obj_t 
_cfun_cinfo_top__set_4488_176_cfa_info(obj_t env_10213, obj_t obj_10214, obj_t val1525_10215)
{
   return cfun_cinfo_top__set__172_cfa_info((cfun_t) (obj_10214), CBOOL(val1525_10215));
}


/* cfun/cinfo-top? */ bool_t 
cfun_cinfo_top__138_cfa_info(cfun_t obj_1523)
{
   return (((cfun_t) CREF(obj_1523))->top__138);
}


/* _cfun/cinfo-top?4489 */ obj_t 
_cfun_cinfo_top_4489_13_cfa_info(obj_t env_10216, obj_t obj_10217)
{
   {
      bool_t aux_16036;
      aux_16036 = cfun_cinfo_top__138_cfa_info((cfun_t) (obj_10217));
      return BBOOL(aux_16036);
   }
}


/* cfun/cinfo-the-closure-set! */ obj_t 
cfun_cinfo_the_closure_set__73_cfa_info(cfun_t obj_1524, obj_t val1526_1525)
{
   return ((((cfun_t) CREF(obj_1524))->the_closure_238) = ((obj_t) val1526_1525), BUNSPEC);
}


/* _cfun/cinfo-the-closure-set!4490 */ obj_t 
_cfun_cinfo_the_closure_set_4490_255_cfa_info(obj_t env_10218, obj_t obj_10219, obj_t val1526_10220)
{
   return cfun_cinfo_the_closure_set__73_cfa_info((cfun_t) (obj_10219), val1526_10220);
}


/* cfun/cinfo-the-closure */ obj_t 
cfun_cinfo_the_closure_238_cfa_info(cfun_t obj_1526)
{
   return (((cfun_t) CREF(obj_1526))->the_closure_238);
}


/* _cfun/cinfo-the-closure4491 */ obj_t 
_cfun_cinfo_the_closure4491_101_cfa_info(obj_t env_10221, obj_t obj_10222)
{
   return cfun_cinfo_the_closure_238_cfa_info((cfun_t) (obj_10222));
}


/* cfun/cinfo-args-type */ obj_t 
cfun_cinfo_args_type_205_cfa_info(cfun_t obj_1527)
{
   return (((cfun_t) CREF(obj_1527))->args_type_205);
}


/* _cfun/cinfo-args-type4492 */ obj_t 
_cfun_cinfo_args_type4492_112_cfa_info(obj_t env_10223, obj_t obj_10224)
{
   return cfun_cinfo_args_type_205_cfa_info((cfun_t) (obj_10224));
}


/* cfun/cinfo-macro? */ bool_t 
cfun_cinfo_macro__33_cfa_info(cfun_t obj_1528)
{
   return (((cfun_t) CREF(obj_1528))->macro__33);
}


/* _cfun/cinfo-macro?4493 */ obj_t 
_cfun_cinfo_macro_4493_246_cfa_info(obj_t env_10225, obj_t obj_10226)
{
   {
      bool_t aux_16050;
      aux_16050 = cfun_cinfo_macro__33_cfa_info((cfun_t) (obj_10226));
      return BBOOL(aux_16050);
   }
}


/* cfun/cinfo-infix?-set! */ obj_t 
cfun_cinfo_infix__set__3_cfa_info(cfun_t obj_1529, bool_t val1527_1530)
{
   return ((((cfun_t) CREF(obj_1529))->infix__163) = ((bool_t) val1527_1530), BUNSPEC);
}


/* _cfun/cinfo-infix?-set!4494 */ obj_t 
_cfun_cinfo_infix__set_4494_96_cfa_info(obj_t env_10227, obj_t obj_10228, obj_t val1527_10229)
{
   return cfun_cinfo_infix__set__3_cfa_info((cfun_t) (obj_10228), CBOOL(val1527_10229));
}


/* cfun/cinfo-infix? */ bool_t 
cfun_cinfo_infix__163_cfa_info(cfun_t obj_1531)
{
   return (((cfun_t) CREF(obj_1531))->infix__163);
}


/* _cfun/cinfo-infix?4495 */ obj_t 
_cfun_cinfo_infix_4495_55_cfa_info(obj_t env_10230, obj_t obj_10231)
{
   {
      bool_t aux_16059;
      aux_16059 = cfun_cinfo_infix__163_cfa_info((cfun_t) (obj_10231));
      return BBOOL(aux_16059);
   }
}


/* cfun/cinfo-approx */ approx_t 
cfun_cinfo_approx_232_cfa_info(cfun_cinfo_200_t obj_1532)
{
   {
      obj_t aux_16063;
      {
	 object_t aux_16064;
	 aux_16064 = (object_t) (obj_1532);
	 aux_16063 = OBJECT_WIDENING(aux_16064);
      }
      return (((cfun_cinfo_200_t) CREF(aux_16063))->approx);
   }
}


/* _cfun/cinfo-approx4496 */ obj_t 
_cfun_cinfo_approx4496_91_cfa_info(obj_t env_10232, obj_t obj_10233)
{
   {
      approx_t aux_16068;
      aux_16068 = cfun_cinfo_approx_232_cfa_info((cfun_cinfo_200_t) (obj_10233));
      return (obj_t) (aux_16068);
   }
}


/* allocate-approx */ approx_t 
allocate_approx_85_cfa_info()
{
   {
      approx_t new1494_2863;
      new1494_2863 = ((approx_t) BREF(GC_MALLOC(sizeof(struct approx))));
      {
	 long arg2960_2864;
	 arg2960_2864 = class_num_218___object(approx_cfa_info);
	 {
	    obj_t obj_6131;
	    obj_6131 = (obj_t) (new1494_2863);
	    (((obj_t) CREF(obj_6131))->header = MAKE_HEADER(arg2960_2864, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_16076;
	 aux_16076 = (object_t) (new1494_2863);
	 OBJECT_WIDENING_SET(aux_16076, BFALSE);
      }
      return new1494_2863;
   }
}


/* _allocate-approx */ obj_t 
_allocate_approx_254_cfa_info(obj_t env_8021)
{
   {
      approx_t aux_16079;
      aux_16079 = allocate_approx_85_cfa_info();
      return (obj_t) (aux_16079);
   }
}


/* approx? */ bool_t 
approx__114_cfa_info(obj_t obj_1536)
{
   return is_a__118___object(obj_1536, approx_cfa_info);
}


/* _approx? */ obj_t 
_approx__184_cfa_info(obj_t env_10234, obj_t obj_10235)
{
   {
      bool_t aux_16083;
      aux_16083 = approx__114_cfa_info(obj_10235);
      return BBOOL(aux_16083);
   }
}


/* make-approx */ approx_t 
make_approx_172_cfa_info(type_t type_1537, bool_t type_locked__184_1538, obj_t allocs_1539, bool_t top__138_1540, long lost_stamp_114_1541)
{
   {
      approx_t new1484_6133;
      new1484_6133 = ((approx_t) BREF(GC_MALLOC(sizeof(struct approx))));
      {
	 long arg2961_6134;
	 arg2961_6134 = class_num_218___object(approx_cfa_info);
	 {
	    obj_t obj_6140;
	    obj_6140 = (obj_t) (new1484_6133);
	    (((obj_t) CREF(obj_6140))->header = MAKE_HEADER(arg2961_6134, 0), BUNSPEC);
	 }
      }
      {
	 object_t aux_16090;
	 aux_16090 = (object_t) (new1484_6133);
	 OBJECT_WIDENING_SET(aux_16090, BFALSE);
      }
      ((((approx_t) CREF(new1484_6133))->type) = ((type_t) type_1537), BUNSPEC);
      ((((approx_t) CREF(new1484_6133))->type_locked__184) = ((bool_t) type_locked__184_1538), BUNSPEC);
      ((((approx_t) CREF(new1484_6133))->allocs) = ((obj_t) allocs_1539), BUNSPEC);
      ((((approx_t) CREF(new1484_6133))->top__138) = ((bool_t) top__138_1540), BUNSPEC);
      ((((approx_t) CREF(new1484_6133))->lost_stamp_114) = ((long) lost_stamp_114_1541), BUNSPEC);
      return new1484_6133;
   }
}


/* _make-approx4497 */ obj_t 
_make_approx4497_37_cfa_info(obj_t env_10236, obj_t type_10237, obj_t type_locked__184_10238, obj_t allocs_10239, obj_t top__138_10240, obj_t lost_stamp_114_10241)
{
   {
      approx_t aux_16098;
      aux_16098 = make_approx_172_cfa_info((type_t) (type_10237), CBOOL(type_locked__184_10238), allocs_10239, CBOOL(top__138_10240), (long) CINT(lost_stamp_114_10241));
      return (obj_t) (aux_16098);
   }
}


/* approx-type-set! */ obj_t 
approx_type_set__202_cfa_info(approx_t obj_1542, type_t val1491_1543)
{
   return ((((approx_t) CREF(obj_1542))->type) = ((type_t) val1491_1543), BUNSPEC);
}


/* _approx-type-set!4498 */ obj_t 
_approx_type_set_4498_139_cfa_info(obj_t env_10242, obj_t obj_10243, obj_t val1491_10244)
{
   return approx_type_set__202_cfa_info((approx_t) (obj_10243), (type_t) (val1491_10244));
}


/* approx-type */ type_t 
approx_type_27_cfa_info(approx_t obj_1544)
{
   return (((approx_t) CREF(obj_1544))->type);
}


/* _approx-type4499 */ obj_t 
_approx_type4499_248_cfa_info(obj_t env_10245, obj_t obj_10246)
{
   {
      type_t aux_16110;
      aux_16110 = approx_type_27_cfa_info((approx_t) (obj_10246));
      return (obj_t) (aux_16110);
   }
}


/* approx-type-locked? */ bool_t 
approx_type_locked__124_cfa_info(approx_t obj_1545)
{
   return (((approx_t) CREF(obj_1545))->type_locked__184);
}


/* _approx-type-locked?4500 */ obj_t 
_approx_type_locked_4500_170_cfa_info(obj_t env_10247, obj_t obj_10248)
{
   {
      bool_t aux_16115;
      aux_16115 = approx_type_locked__124_cfa_info((approx_t) (obj_10248));
      return BBOOL(aux_16115);
   }
}


/* approx-allocs */ obj_t 
approx_allocs_203_cfa_info(approx_t obj_1546)
{
   return (((approx_t) CREF(obj_1546))->allocs);
}


/* _approx-allocs4501 */ obj_t 
_approx_allocs4501_142_cfa_info(obj_t env_10249, obj_t obj_10250)
{
   return approx_allocs_203_cfa_info((approx_t) (obj_10250));
}


/* approx-top?-set! */ obj_t 
approx_top__set__151_cfa_info(approx_t obj_1547, bool_t val1492_1548)
{
   return ((((approx_t) CREF(obj_1547))->top__138) = ((bool_t) val1492_1548), BUNSPEC);
}


/* _approx-top?-set!4502 */ obj_t 
_approx_top__set_4502_59_cfa_info(obj_t env_10251, obj_t obj_10252, obj_t val1492_10253)
{
   return approx_top__set__151_cfa_info((approx_t) (obj_10252), CBOOL(val1492_10253));
}


/* approx-top? */ bool_t 
approx_top__34_cfa_info(approx_t obj_1549)
{
   return (((approx_t) CREF(obj_1549))->top__138);
}


/* _approx-top?4503 */ obj_t 
_approx_top_4503_87_cfa_info(obj_t env_10254, obj_t obj_10255)
{
   {
      bool_t aux_16127;
      aux_16127 = approx_top__34_cfa_info((approx_t) (obj_10255));
      return BBOOL(aux_16127);
   }
}


/* approx-lost-stamp-set! */ obj_t 
approx_lost_stamp_set__114_cfa_info(approx_t obj_1550, long val1493_1551)
{
   return ((((approx_t) CREF(obj_1550))->lost_stamp_114) = ((long) val1493_1551), BUNSPEC);
}


/* _approx-lost-stamp-set!4504 */ obj_t 
_approx_lost_stamp_set_4504_160_cfa_info(obj_t env_10256, obj_t obj_10257, obj_t val1493_10258)
{
   return approx_lost_stamp_set__114_cfa_info((approx_t) (obj_10257), (long) CINT(val1493_10258));
}


/* approx-lost-stamp */ long 
approx_lost_stamp_29_cfa_info(approx_t obj_1552)
{
   return (((approx_t) CREF(obj_1552))->lost_stamp_114);
}


/* _approx-lost-stamp4505 */ obj_t 
_approx_lost_stamp4505_172_cfa_info(obj_t env_10259, obj_t obj_10260)
{
   {
      long aux_16136;
      aux_16136 = approx_lost_stamp_29_cfa_info((approx_t) (obj_10260));
      return BINT(aux_16136);
   }
}


/* method-init */ obj_t 
method_init_76_cfa_info()
{
   {
      obj_t object__struct_struct_set__app_208_10365;
      object__struct_struct_set__app_208_10365 = proc4511_cfa_info;
      add_method__1___object(object__struct_env_210___object, struct_set__app_162_cfa_info, object__struct_struct_set__app_208_10365);
   }
   {
      obj_t struct_object__object_struct_set__app_209_10364;
      struct_object__object_struct_set__app_209_10364 = proc4512_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, struct_set__app_162_cfa_info, struct_object__object_struct_set__app_209_10364);
   }
   {
      obj_t object__struct_struct_ref_app_85_10363;
      object__struct_struct_ref_app_85_10363 = proc4513_cfa_info;
      add_method__1___object(object__struct_env_210___object, struct_ref_app_73_cfa_info, object__struct_struct_ref_app_85_10363);
   }
   {
      obj_t struct_object__object_struct_ref_app_176_10362;
      struct_object__object_struct_ref_app_176_10362 = proc4514_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, struct_ref_app_73_cfa_info, struct_object__object_struct_ref_app_176_10362);
   }
   {
      obj_t object__struct_make_struct_app_173_10361;
      object__struct_make_struct_app_173_10361 = proc4515_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_struct_app_214_cfa_info, object__struct_make_struct_app_173_10361);
   }
   {
      obj_t struct_object__object_make_struct_app_10_10360;
      struct_object__object_make_struct_app_10_10360 = proc4516_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_struct_app_214_cfa_info, struct_object__object_make_struct_app_10_10360);
   }
   {
      obj_t object__struct_pre_struct_set__app_44_10359;
      object__struct_pre_struct_set__app_44_10359 = proc4517_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_struct_set__app_116_cfa_info, object__struct_pre_struct_set__app_44_10359);
   }
   {
      obj_t struct_object__object_pre_struct_set__app_147_10358;
      struct_object__object_pre_struct_set__app_147_10358 = proc4518_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_struct_set__app_116_cfa_info, struct_object__object_pre_struct_set__app_147_10358);
   }
   {
      obj_t object__struct_pre_struct_ref_app_38_10357;
      object__struct_pre_struct_ref_app_38_10357 = proc4519_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_struct_ref_app_207_cfa_info, object__struct_pre_struct_ref_app_38_10357);
   }
   {
      obj_t struct_object__object_pre_struct_ref_app_167_10356;
      struct_object__object_pre_struct_ref_app_167_10356 = proc4520_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_struct_ref_app_207_cfa_info, struct_object__object_pre_struct_ref_app_167_10356);
   }
   {
      obj_t object__struct_pre_make_struct_app_244_10355;
      object__struct_pre_make_struct_app_244_10355 = proc4521_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_struct_app_218_cfa_info, object__struct_pre_make_struct_app_244_10355);
   }
   {
      obj_t struct_object__object_pre_make_struct_app_226_10354;
      struct_object__object_pre_make_struct_app_226_10354 = proc4522_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_struct_app_218_cfa_info, struct_object__object_pre_make_struct_app_226_10354);
   }
   {
      obj_t object__struct_vector_set__app_75_10353;
      object__struct_vector_set__app_75_10353 = proc4523_cfa_info;
      add_method__1___object(object__struct_env_210___object, vector_set__app_21_cfa_info, object__struct_vector_set__app_75_10353);
   }
   {
      obj_t struct_object__object_vector_set__app_246_10352;
      struct_object__object_vector_set__app_246_10352 = proc4524_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, vector_set__app_21_cfa_info, struct_object__object_vector_set__app_246_10352);
   }
   {
      obj_t object__struct_vector_ref_app_174_10351;
      object__struct_vector_ref_app_174_10351 = proc4525_cfa_info;
      add_method__1___object(object__struct_env_210___object, vector_ref_app_195_cfa_info, object__struct_vector_ref_app_174_10351);
   }
   {
      obj_t struct_object__object_vector_ref_app_116_10350;
      struct_object__object_vector_ref_app_116_10350 = proc4526_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, vector_ref_app_195_cfa_info, struct_object__object_vector_ref_app_116_10350);
   }
   {
      obj_t object__struct_create_vector_app_178_10349;
      object__struct_create_vector_app_178_10349 = proc4527_cfa_info;
      add_method__1___object(object__struct_env_210___object, create_vector_app_150_cfa_info, object__struct_create_vector_app_178_10349);
   }
   {
      obj_t struct_object__object_create_vector_app_49_10348;
      struct_object__object_create_vector_app_49_10348 = proc4528_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, create_vector_app_150_cfa_info, struct_object__object_create_vector_app_49_10348);
   }
   {
      obj_t object__struct_make_vector_app_114_10347;
      object__struct_make_vector_app_114_10347 = proc4529_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_vector_app_205_cfa_info, object__struct_make_vector_app_114_10347);
   }
   {
      obj_t struct_object__object_make_vector_app_26_10346;
      struct_object__object_make_vector_app_26_10346 = proc4530_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_vector_app_205_cfa_info, struct_object__object_make_vector_app_26_10346);
   }
   {
      obj_t object__struct_pre_vector_set__app_201_10345;
      object__struct_pre_vector_set__app_201_10345 = proc4531_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_vector_set__app_211_cfa_info, object__struct_pre_vector_set__app_201_10345);
   }
   {
      obj_t struct_object__object_pre_vector_set__app_122_10344;
      struct_object__object_pre_vector_set__app_122_10344 = proc4532_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_vector_set__app_211_cfa_info, struct_object__object_pre_vector_set__app_122_10344);
   }
   {
      obj_t object__struct_pre_vector_ref_app_11_10343;
      object__struct_pre_vector_ref_app_11_10343 = proc4533_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_vector_ref_app_208_cfa_info, object__struct_pre_vector_ref_app_11_10343);
   }
   {
      obj_t struct_object__object_pre_vector_ref_app_99_10342;
      struct_object__object_pre_vector_ref_app_99_10342 = proc4534_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_vector_ref_app_208_cfa_info, struct_object__object_pre_vector_ref_app_99_10342);
   }
   {
      obj_t object__struct_pre_create_vector_app_184_10341;
      object__struct_pre_create_vector_app_184_10341 = proc4535_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_create_vector_app_162_cfa_info, object__struct_pre_create_vector_app_184_10341);
   }
   {
      obj_t struct_object__object_pre_create_vector_app_213_10340;
      struct_object__object_pre_create_vector_app_213_10340 = proc4536_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_create_vector_app_162_cfa_info, struct_object__object_pre_create_vector_app_213_10340);
   }
   {
      obj_t object__struct_pre_make_vector_app_189_10339;
      object__struct_pre_make_vector_app_189_10339 = proc4537_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_vector_app_251_cfa_info, object__struct_pre_make_vector_app_189_10339);
   }
   {
      obj_t struct_object__object_pre_make_vector_app_45_10338;
      struct_object__object_pre_make_vector_app_45_10338 = proc4538_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_vector_app_251_cfa_info, struct_object__object_pre_make_vector_app_45_10338);
   }
   {
      obj_t object__struct_procedure_set__app_86_10337;
      object__struct_procedure_set__app_86_10337 = proc4539_cfa_info;
      add_method__1___object(object__struct_env_210___object, procedure_set__app_32_cfa_info, object__struct_procedure_set__app_86_10337);
   }
   {
      obj_t struct_object__object_procedure_set__app_110_10336;
      struct_object__object_procedure_set__app_110_10336 = proc4540_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, procedure_set__app_32_cfa_info, struct_object__object_procedure_set__app_110_10336);
   }
   {
      obj_t object__struct_procedure_ref_app_22_10335;
      object__struct_procedure_ref_app_22_10335 = proc4541_cfa_info;
      add_method__1___object(object__struct_env_210___object, procedure_ref_app_49_cfa_info, object__struct_procedure_ref_app_22_10335);
   }
   {
      obj_t struct_object__object_procedure_ref_app_161_10334;
      struct_object__object_procedure_ref_app_161_10334 = proc4542_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, procedure_ref_app_49_cfa_info, struct_object__object_procedure_ref_app_161_10334);
   }
   {
      obj_t object__struct_make_procedure_app_124_10333;
      object__struct_make_procedure_app_124_10333 = proc4543_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_procedure_app_48_cfa_info, object__struct_make_procedure_app_124_10333);
   }
   {
      obj_t struct_object__object_make_procedure_app_38_10332;
      struct_object__object_make_procedure_app_38_10332 = proc4544_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_procedure_app_48_cfa_info, struct_object__object_make_procedure_app_38_10332);
   }
   {
      obj_t object__struct_pre_procedure_set__app_130_10331;
      object__struct_pre_procedure_set__app_130_10331 = proc4545_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_procedure_set__app_208_cfa_info, object__struct_pre_procedure_set__app_130_10331);
   }
   {
      obj_t struct_object__object_pre_procedure_set__app_129_10330;
      struct_object__object_pre_procedure_set__app_129_10330 = proc4546_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_procedure_set__app_208_cfa_info, struct_object__object_pre_procedure_set__app_129_10330);
   }
   {
      obj_t object__struct_pre_procedure_ref_app_223_10329;
      object__struct_pre_procedure_ref_app_223_10329 = proc4547_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_procedure_ref_app_85_cfa_info, object__struct_pre_procedure_ref_app_223_10329);
   }
   {
      obj_t struct_object__object_pre_procedure_ref_app_139_10328;
      struct_object__object_pre_procedure_ref_app_139_10328 = proc4548_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_procedure_ref_app_85_cfa_info, struct_object__object_pre_procedure_ref_app_139_10328);
   }
   {
      obj_t object__struct_pre_make_procedure_app_202_10327;
      object__struct_pre_make_procedure_app_202_10327 = proc4549_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_procedure_app_60_cfa_info, object__struct_pre_make_procedure_app_202_10327);
   }
   {
      obj_t struct_object__object_pre_make_procedure_app_51_10326;
      struct_object__object_pre_make_procedure_app_51_10326 = proc4550_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_procedure_app_60_cfa_info, struct_object__object_pre_make_procedure_app_51_10326);
   }
   {
      obj_t object__struct_box_ref_o_cinfo_174_10325;
      object__struct_box_ref_o_cinfo_174_10325 = proc4551_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_ref_o_cinfo_98_cfa_info, object__struct_box_ref_o_cinfo_174_10325);
   }
   {
      obj_t struct_object__object_box_ref_o_cinfo_19_10324;
      struct_object__object_box_ref_o_cinfo_19_10324 = proc4552_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_ref_o_cinfo_98_cfa_info, struct_object__object_box_ref_o_cinfo_19_10324);
   }
   {
      obj_t object__struct_box_set__o_cinfo_141_10323;
      object__struct_box_set__o_cinfo_141_10323 = proc4553_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_set__o_cinfo_6_cfa_info, object__struct_box_set__o_cinfo_141_10323);
   }
   {
      obj_t struct_object__object_box_set__o_cinfo_219_10322;
      struct_object__object_box_set__o_cinfo_219_10322 = proc4554_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_set__o_cinfo_6_cfa_info, struct_object__object_box_set__o_cinfo_219_10322);
   }
   {
      obj_t object__struct_box_ref_cinfo_171_10321;
      object__struct_box_ref_cinfo_171_10321 = proc4555_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_ref_cinfo_214_cfa_info, object__struct_box_ref_cinfo_171_10321);
   }
   {
      obj_t struct_object__object_box_ref_cinfo_78_10320;
      struct_object__object_box_ref_cinfo_78_10320 = proc4556_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_ref_cinfo_214_cfa_info, struct_object__object_box_ref_cinfo_78_10320);
   }
   {
      obj_t object__struct_box_set__cinfo_66_10319;
      object__struct_box_set__cinfo_66_10319 = proc4557_cfa_info;
      add_method__1___object(object__struct_env_210___object, box_set__cinfo_94_cfa_info, object__struct_box_set__cinfo_66_10319);
   }
   {
      obj_t struct_object__object_box_set__cinfo_119_10318;
      struct_object__object_box_set__cinfo_119_10318 = proc4558_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, box_set__cinfo_94_cfa_info, struct_object__object_box_set__cinfo_119_10318);
   }
   {
      obj_t object__struct_make_box_o_cinfo_104_10317;
      object__struct_make_box_o_cinfo_104_10317 = proc4559_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_box_o_cinfo_96_cfa_info, object__struct_make_box_o_cinfo_104_10317);
   }
   {
      obj_t struct_object__object_make_box_o_cinfo_100_10316;
      struct_object__object_make_box_o_cinfo_100_10316 = proc4560_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_box_o_cinfo_96_cfa_info, struct_object__object_make_box_o_cinfo_100_10316);
   }
   {
      obj_t object__struct_make_box_cinfo_186_10315;
      object__struct_make_box_cinfo_186_10315 = proc4561_cfa_info;
      add_method__1___object(object__struct_env_210___object, make_box_cinfo_127_cfa_info, object__struct_make_box_cinfo_186_10315);
   }
   {
      obj_t struct_object__object_make_box_cinfo_10_10314;
      struct_object__object_make_box_cinfo_10_10314 = proc4562_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, make_box_cinfo_127_cfa_info, struct_object__object_make_box_cinfo_10_10314);
   }
   {
      obj_t object__struct_pre_make_box_150_10313;
      object__struct_pre_make_box_150_10313 = proc4563_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_make_box_186_cfa_info, object__struct_pre_make_box_150_10313);
   }
   {
      obj_t struct_object__object_pre_make_box_16_10312;
      struct_object__object_pre_make_box_16_10312 = proc4564_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_make_box_186_cfa_info, struct_object__object_pre_make_box_16_10312);
   }
   {
      obj_t object__struct_jump_ex_it_cinfo_111_10311;
      object__struct_jump_ex_it_cinfo_111_10311 = proc4565_cfa_info;
      add_method__1___object(object__struct_env_210___object, jump_ex_it_cinfo_139_cfa_info, object__struct_jump_ex_it_cinfo_111_10311);
   }
   {
      obj_t struct_object__object_jump_ex_it_cinfo_82_10310;
      struct_object__object_jump_ex_it_cinfo_82_10310 = proc4566_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, jump_ex_it_cinfo_139_cfa_info, struct_object__object_jump_ex_it_cinfo_82_10310);
   }
   {
      obj_t object__struct_set_ex_it_cinfo_216_10309;
      object__struct_set_ex_it_cinfo_216_10309 = proc4567_cfa_info;
      add_method__1___object(object__struct_env_210___object, set_ex_it_cinfo_168_cfa_info, object__struct_set_ex_it_cinfo_216_10309);
   }
   {
      obj_t struct_object__object_set_ex_it_cinfo_254_10308;
      struct_object__object_set_ex_it_cinfo_254_10308 = proc4568_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, set_ex_it_cinfo_168_cfa_info, struct_object__object_set_ex_it_cinfo_254_10308);
   }
   {
      obj_t object__struct_select_cinfo_146_10307;
      object__struct_select_cinfo_146_10307 = proc4569_cfa_info;
      add_method__1___object(object__struct_env_210___object, select_cinfo_150_cfa_info, object__struct_select_cinfo_146_10307);
   }
   {
      obj_t struct_object__object_select_cinfo_79_10306;
      struct_object__object_select_cinfo_79_10306 = proc4570_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, select_cinfo_150_cfa_info, struct_object__object_select_cinfo_79_10306);
   }
   {
      obj_t object__struct_fail_cinfo_130_10305;
      object__struct_fail_cinfo_130_10305 = proc4571_cfa_info;
      add_method__1___object(object__struct_env_210___object, fail_cinfo_75_cfa_info, object__struct_fail_cinfo_130_10305);
   }
   {
      obj_t struct_object__object_fail_cinfo_67_10304;
      struct_object__object_fail_cinfo_67_10304 = proc4572_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, fail_cinfo_75_cfa_info, struct_object__object_fail_cinfo_67_10304);
   }
   {
      obj_t object__struct_conditional_cinfo_223_10303;
      object__struct_conditional_cinfo_223_10303 = proc4573_cfa_info;
      add_method__1___object(object__struct_env_210___object, conditional_cinfo_212_cfa_info, object__struct_conditional_cinfo_223_10303);
   }
   {
      obj_t struct_object__object_conditional_cinfo_141_10302;
      struct_object__object_conditional_cinfo_141_10302 = proc4574_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, conditional_cinfo_212_cfa_info, struct_object__object_conditional_cinfo_141_10302);
   }
   {
      obj_t object__struct_setq_cinfo_111_10301;
      object__struct_setq_cinfo_111_10301 = proc4575_cfa_info;
      add_method__1___object(object__struct_env_210___object, setq_cinfo_191_cfa_info, object__struct_setq_cinfo_111_10301);
   }
   {
      obj_t struct_object__object_setq_cinfo_26_10300;
      struct_object__object_setq_cinfo_26_10300 = proc4576_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, setq_cinfo_191_cfa_info, struct_object__object_setq_cinfo_26_10300);
   }
   {
      obj_t object__struct_pragma_cinfo_175_10299;
      object__struct_pragma_cinfo_175_10299 = proc4577_cfa_info;
      add_method__1___object(object__struct_env_210___object, pragma_cinfo_220_cfa_info, object__struct_pragma_cinfo_175_10299);
   }
   {
      obj_t struct_object__object_pragma_cinfo_100_10298;
      struct_object__object_pragma_cinfo_100_10298 = proc4578_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pragma_cinfo_220_cfa_info, struct_object__object_pragma_cinfo_100_10298);
   }
   {
      obj_t object__struct_funcall_cinfo_250_10297;
      object__struct_funcall_cinfo_250_10297 = proc4579_cfa_info;
      add_method__1___object(object__struct_env_210___object, funcall_cinfo_75_cfa_info, object__struct_funcall_cinfo_250_10297);
   }
   {
      obj_t struct_object__object_funcall_cinfo_97_10296;
      struct_object__object_funcall_cinfo_97_10296 = proc4580_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, funcall_cinfo_75_cfa_info, struct_object__object_funcall_cinfo_97_10296);
   }
   {
      obj_t object__struct_app_ly_cinfo_39_10295;
      object__struct_app_ly_cinfo_39_10295 = proc4581_cfa_info;
      add_method__1___object(object__struct_env_210___object, app_ly_cinfo_234_cfa_info, object__struct_app_ly_cinfo_39_10295);
   }
   {
      obj_t struct_object__object_app_ly_cinfo_255_10294;
      struct_object__object_app_ly_cinfo_255_10294 = proc4582_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, app_ly_cinfo_234_cfa_info, struct_object__object_app_ly_cinfo_255_10294);
   }
   {
      obj_t object__struct_kwote_cinfo_203_10293;
      object__struct_kwote_cinfo_203_10293 = proc4583_cfa_info;
      add_method__1___object(object__struct_env_210___object, kwote_cinfo_48_cfa_info, object__struct_kwote_cinfo_203_10293);
   }
   {
      obj_t struct_object__object_kwote_cinfo_192_10292;
      struct_object__object_kwote_cinfo_192_10292 = proc4584_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, kwote_cinfo_48_cfa_info, struct_object__object_kwote_cinfo_192_10292);
   }
   {
      obj_t object__struct_kwote_node_184_10291;
      object__struct_kwote_node_184_10291 = proc4585_cfa_info;
      add_method__1___object(object__struct_env_210___object, kwote_node_102_cfa_info, object__struct_kwote_node_184_10291);
   }
   {
      obj_t struct_object__object_kwote_node_133_10290;
      struct_object__object_kwote_node_133_10290 = proc4586_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, kwote_node_102_cfa_info, struct_object__object_kwote_node_133_10290);
   }
   {
      obj_t object__struct_atom_cinfo_211_10289;
      object__struct_atom_cinfo_211_10289 = proc4587_cfa_info;
      add_method__1___object(object__struct_env_210___object, atom_cinfo_155_cfa_info, object__struct_atom_cinfo_211_10289);
   }
   {
      obj_t struct_object__object_atom_cinfo_113_10288;
      struct_object__object_atom_cinfo_113_10288 = proc4588_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, atom_cinfo_155_cfa_info, struct_object__object_atom_cinfo_113_10288);
   }
   {
      obj_t object__struct_reshaped_global_19_10287;
      object__struct_reshaped_global_19_10287 = proc4589_cfa_info;
      add_method__1___object(object__struct_env_210___object, reshaped_global_160_cfa_info, object__struct_reshaped_global_19_10287);
   }
   {
      obj_t struct_object__object_reshaped_global_132_10286;
      struct_object__object_reshaped_global_132_10286 = proc4590_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, reshaped_global_160_cfa_info, struct_object__object_reshaped_global_132_10286);
   }
   {
      obj_t object__struct_reshaped_local_22_10285;
      object__struct_reshaped_local_22_10285 = proc4591_cfa_info;
      add_method__1___object(object__struct_env_210___object, reshaped_local_224_cfa_info, object__struct_reshaped_local_22_10285);
   }
   {
      obj_t struct_object__object_reshaped_local_214_10284;
      struct_object__object_reshaped_local_214_10284 = proc4592_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, reshaped_local_224_cfa_info, struct_object__object_reshaped_local_214_10284);
   }
   {
      obj_t object__struct_sexit_cinfo_98_10283;
      object__struct_sexit_cinfo_98_10283 = proc4593_cfa_info;
      add_method__1___object(object__struct_env_210___object, sexit_cinfo_49_cfa_info, object__struct_sexit_cinfo_98_10283);
   }
   {
      obj_t struct_object__object_sexit_cinfo_74_10282;
      struct_object__object_sexit_cinfo_74_10282 = proc4594_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, sexit_cinfo_49_cfa_info, struct_object__object_sexit_cinfo_74_10282);
   }
   {
      obj_t object__struct_cvar_cinfo_219_10281;
      object__struct_cvar_cinfo_219_10281 = proc4595_cfa_info;
      add_method__1___object(object__struct_env_210___object, cvar_cinfo_53_cfa_info, object__struct_cvar_cinfo_219_10281);
   }
   {
      obj_t struct_object__object_cvar_cinfo_125_10280;
      struct_object__object_cvar_cinfo_125_10280 = proc4596_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, cvar_cinfo_53_cfa_info, struct_object__object_cvar_cinfo_125_10280);
   }
   {
      obj_t object__struct_svar_cinfo_7_10279;
      object__struct_svar_cinfo_7_10279 = proc4597_cfa_info;
      add_method__1___object(object__struct_env_210___object, svar_cinfo_166_cfa_info, object__struct_svar_cinfo_7_10279);
   }
   {
      obj_t struct_object__object_svar_cinfo_24_10278;
      struct_object__object_svar_cinfo_24_10278 = proc4598_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, svar_cinfo_166_cfa_info, struct_object__object_svar_cinfo_24_10278);
   }
   {
      obj_t object__struct_pre_clo_env_226_10277;
      object__struct_pre_clo_env_226_10277 = proc4599_cfa_info;
      add_method__1___object(object__struct_env_210___object, pre_clo_env_191_cfa_info, object__struct_pre_clo_env_226_10277);
   }
   {
      obj_t struct_object__object_pre_clo_env_30_10276;
      struct_object__object_pre_clo_env_30_10276 = proc4600_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, pre_clo_env_191_cfa_info, struct_object__object_pre_clo_env_30_10276);
   }
   {
      obj_t object__struct_scnst_cinfo_225_10275;
      object__struct_scnst_cinfo_225_10275 = proc4601_cfa_info;
      add_method__1___object(object__struct_env_210___object, scnst_cinfo_0_cfa_info, object__struct_scnst_cinfo_225_10275);
   }
   {
      obj_t struct_object__object_scnst_cinfo_187_10274;
      struct_object__object_scnst_cinfo_187_10274 = proc4602_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, scnst_cinfo_0_cfa_info, struct_object__object_scnst_cinfo_187_10274);
   }
   {
      obj_t object__struct_intern_sfun_cinfo_28_10273;
      object__struct_intern_sfun_cinfo_28_10273 = proc4603_cfa_info;
      add_method__1___object(object__struct_env_210___object, intern_sfun_cinfo_192_cfa_info, object__struct_intern_sfun_cinfo_28_10273);
   }
   {
      obj_t struct_object__object_intern_sfun_cinfo_38_10272;
      struct_object__object_intern_sfun_cinfo_38_10272 = proc4604_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, intern_sfun_cinfo_192_cfa_info, struct_object__object_intern_sfun_cinfo_38_10272);
   }
   {
      obj_t object__struct_extern_sfun_cinfo_81_10271;
      object__struct_extern_sfun_cinfo_81_10271 = proc4605_cfa_info;
      add_method__1___object(object__struct_env_210___object, extern_sfun_cinfo_6_cfa_info, object__struct_extern_sfun_cinfo_81_10271);
   }
   {
      obj_t struct_object__object_extern_sfun_cinfo_23_10270;
      struct_object__object_extern_sfun_cinfo_23_10270 = proc4606_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, extern_sfun_cinfo_6_cfa_info, struct_object__object_extern_sfun_cinfo_23_10270);
   }
   {
      obj_t object__struct_cfun_cinfo_76_10267;
      object__struct_cfun_cinfo_76_10267 = proc4607_cfa_info;
      add_method__1___object(object__struct_env_210___object, cfun_cinfo_200_cfa_info, object__struct_cfun_cinfo_76_10267);
   }
   {
      obj_t struct_object__object_cfun_cinfo_204_10263;
      struct_object__object_cfun_cinfo_204_10263 = proc4608_cfa_info;
      add_method__1___object(struct_object__object_env_209___object, cfun_cinfo_200_cfa_info, struct_object__object_cfun_cinfo_204_10263);
   }
   {
      obj_t object__struct_approx_119_10262;
      object__struct_approx_119_10262 = proc4609_cfa_info;
      add_method__1___object(object__struct_env_210___object, approx_cfa_info, object__struct_approx_119_10262);
   }
   {
      obj_t struct_object__object_approx_184_10261;
      struct_object__object_approx_184_10261 = proc4610_cfa_info;
      return add_method__1___object(struct_object__object_env_209___object, approx_cfa_info, struct_object__object_approx_184_10261);
   }
}


/* struct+object->object-approx */ obj_t 
struct_object__object_approx_184_cfa_info(obj_t env_10366, obj_t o_10367, obj_t s_10368)
{
   {
      approx_t o_4515;
      obj_t s_4516;
      {
	 approx_t aux_16240;
	 o_4515 = (approx_t) (o_10367);
	 s_4516 = s_10368;
	 {
	    obj_t aux_16243;
	    object_t aux_16241;
	    aux_16243 = STRUCT_REF(s_4516, ((long) 0));
	    aux_16241 = (object_t) (o_4515);
	    OBJECT_WIDENING_SET(aux_16241, aux_16243);
	 }
	 {
	    type_t v1499_4520;
	    {
	       obj_t aux_16246;
	       aux_16246 = STRUCT_REF(s_4516, ((long) 1));
	       v1499_4520 = (type_t) (aux_16246);
	    }
	    ((((approx_t) CREF(o_4515))->type) = ((type_t) v1499_4520), BUNSPEC);
	 }
	 {
	    bool_t v1503_4521;
	    {
	       obj_t aux_16250;
	       aux_16250 = STRUCT_REF(s_4516, ((long) 2));
	       v1503_4521 = CBOOL(aux_16250);
	    }
	    ((((approx_t) CREF(o_4515))->type_locked__184) = ((bool_t) v1503_4521), BUNSPEC);
	 }
	 {
	    obj_t v1507_4522;
	    v1507_4522 = STRUCT_REF(s_4516, ((long) 3));
	    ((((approx_t) CREF(o_4515))->allocs) = ((obj_t) v1507_4522), BUNSPEC);
	 }
	 {
	    bool_t v1511_4523;
	    {
	       obj_t aux_16256;
	       aux_16256 = STRUCT_REF(s_4516, ((long) 4));
	       v1511_4523 = CBOOL(aux_16256);
	    }
	    ((((approx_t) CREF(o_4515))->top__138) = ((bool_t) v1511_4523), BUNSPEC);
	 }
	 {
	    long v1515_4524;
	    {
	       obj_t aux_16260;
	       aux_16260 = STRUCT_REF(s_4516, ((long) 5));
	       v1515_4524 = (long) CINT(aux_16260);
	    }
	    ((((approx_t) CREF(o_4515))->lost_stamp_114) = ((long) v1515_4524), BUNSPEC);
	 }
	 aux_16240 = o_4515;
	 return (obj_t) (aux_16240);
      }
   }
}


/* object->struct-approx */ obj_t 
object__struct_approx_119_cfa_info(obj_t env_10369, obj_t obj1495_10370)
{
   {
      approx_t obj1495_4497;
      obj1495_4497 = (approx_t) (obj1495_10370);
      {
	 obj_t res1496_4500;
	 {
	    obj_t aux_16266;
	    aux_16266 = CNST_TABLE_REF(((long) 0));
	    res1496_4500 = make_struct(aux_16266, ((long) 6), BUNSPEC);
	 }
	 STRUCT_SET(res1496_4500, ((long) 0), BFALSE);
	 {
	    obj_t aux_16270;
	    {
	       type_t aux_16271;
	       aux_16271 = (((approx_t) CREF(obj1495_4497))->type);
	       aux_16270 = (obj_t) (aux_16271);
	    }
	    STRUCT_SET(res1496_4500, ((long) 1), aux_16270);
	 }
	 {
	    obj_t aux_16275;
	    {
	       bool_t aux_16276;
	       aux_16276 = (((approx_t) CREF(obj1495_4497))->type_locked__184);
	       aux_16275 = BBOOL(aux_16276);
	    }
	    STRUCT_SET(res1496_4500, ((long) 2), aux_16275);
	 }
	 {
	    obj_t aux_16280;
	    aux_16280 = (((approx_t) CREF(obj1495_4497))->allocs);
	    STRUCT_SET(res1496_4500, ((long) 3), aux_16280);
	 }
	 {
	    obj_t aux_16283;
	    {
	       bool_t aux_16284;
	       aux_16284 = (((approx_t) CREF(obj1495_4497))->top__138);
	       aux_16283 = BBOOL(aux_16284);
	    }
	    STRUCT_SET(res1496_4500, ((long) 4), aux_16283);
	 }
	 {
	    obj_t aux_16288;
	    {
	       long aux_16289;
	       aux_16289 = (((approx_t) CREF(obj1495_4497))->lost_stamp_114);
	       aux_16288 = BINT(aux_16289);
	    }
	    STRUCT_SET(res1496_4500, ((long) 5), aux_16288);
	 }
	 return res1496_4500;
      }
   }
}


/* struct+object->object-cfun/cinfo */ obj_t 
struct_object__object_cfun_cinfo_204_cfa_info(obj_t env_10371, obj_t o_10372, obj_t s_10373)
{
   {
      cfun_cinfo_200_t o_4485;
      obj_t s_4486;
      {
	 cfun_cinfo_200_t aux_16294;
	 o_4485 = (cfun_cinfo_200_t) (o_10372);
	 s_4486 = s_10373;
	 {
	    {
	       obj_t old1533_4489;
	       obj_t aux1534_4490;
	       {
		  obj_t next_method2592_22_4495;
		  next_method2592_22_4495 = find_super_class_method_167___object((object_t) (o_4485), struct_object__object_env_209___object, cfun_cinfo_200_cfa_info);
		  if (PROCEDUREP(next_method2592_22_4495))
		    {
		       old1533_4489 = PROCEDURE_ENTRY(next_method2592_22_4495) (next_method2592_22_4495, (obj_t) (o_4485), s_4486, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2592_22_4495);
		       {
			  object_t aux_16303;
			  aux_16303 = struct_object__object_93___object((object_t) (o_4485), s_4486);
			  old1533_4489 = (obj_t) (aux_16303);
		       }
		    }
	       }
	       aux1534_4490 = STRUCT_REF(s_4486, ((long) 0));
	       {
		  cfun_cinfo_200_t new1535_4491;
		  new1535_4491 = ((cfun_cinfo_200_t) (old1533_4489));
		  {
		     long arg3653_4492;
		     arg3653_4492 = class_num_218___object(cfun_cinfo_200_cfa_info);
		     {
			obj_t obj_7973;
			obj_7973 = (obj_t) (new1535_4491);
			(((obj_t) CREF(obj_7973))->header = MAKE_HEADER(arg3653_4492, 0), BUNSPEC);
		     }
		  }
		  {
		     cfun_cinfo_200_t arg3654_4493;
		     {
			cfun_cinfo_200_t res3819_7980;
			{
			   approx_t approx_7977;
			   {
			      obj_t aux_16312;
			      aux_16312 = STRUCT_REF(aux1534_4490, ((long) 0));
			      approx_7977 = (approx_t) (aux_16312);
			   }
			   {
			      cfun_cinfo_200_t new1517_7978;
			      new1517_7978 = ((cfun_cinfo_200_t) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
			      ((((cfun_cinfo_200_t) CREF(new1517_7978))->approx) = ((approx_t) approx_7977), BUNSPEC);
			      res3819_7980 = new1517_7978;
			   }
			}
			arg3654_4493 = res3819_7980;
		     }
		     {
			obj_t aux_16319;
			object_t aux_16317;
			aux_16319 = (obj_t) (arg3654_4493);
			aux_16317 = (object_t) (new1535_4491);
			OBJECT_WIDENING_SET(aux_16317, aux_16319);
		     }
		  }
		  aux_16294 = new1535_4491;
	       }
	    }
	 }
	 return (obj_t) (aux_16294);
      }
   }
}


/* object->struct-cfun/cinfo */ obj_t 
object__struct_cfun_cinfo_76_cfa_info(obj_t env_10374, obj_t obj1530_10375)
{
   {
      cfun_cinfo_200_t obj1530_4472;
      obj1530_4472 = (cfun_cinfo_200_t) (obj1530_10375);
      {
	 {
	    obj_t res1531_4475;
	    {
	       obj_t next_method2591_78_4483;
	       next_method2591_78_4483 = find_super_class_method_167___object((object_t) (obj1530_4472), object__struct_env_210___object, cfun_cinfo_200_cfa_info);
	       if (PROCEDUREP(next_method2591_78_4483))
		 {
		    res1531_4475 = PROCEDURE_ENTRY(next_method2591_78_4483) (next_method2591_78_4483, (obj_t) (obj1530_4472), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2591_78_4483);
		    res1531_4475 = object__struct_50___object((object_t) (obj1530_4472));
		 }
	    }
	    {
	       obj_t aux1532_4476;
	       {
		  obj_t aux_16334;
		  aux_16334 = CNST_TABLE_REF(((long) 1));
		  aux1532_4476 = make_struct(aux_16334, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16337;
		  {
		     approx_t aux_16338;
		     {
			obj_t aux_16339;
			{
			   object_t aux_16340;
			   aux_16340 = (object_t) (obj1530_4472);
			   aux_16339 = OBJECT_WIDENING(aux_16340);
			}
			aux_16338 = (((cfun_cinfo_200_t) CREF(aux_16339))->approx);
		     }
		     aux_16337 = (obj_t) (aux_16338);
		  }
		  STRUCT_SET(aux1532_4476, ((long) 0), aux_16337);
	       }
	       STRUCT_SET(res1531_4475, ((long) 0), aux1532_4476);
	       {
		  obj_t aux_16347;
		  aux_16347 = STRUCT_KEY(res1531_4475);
		  STRUCT_KEY_SET(aux1532_4476, aux_16347);
	       }
	       {
		  obj_t aux_16350;
		  aux_16350 = CNST_TABLE_REF(((long) 1));
		  STRUCT_KEY_SET(res1531_4475, aux_16350);
	       }
	       return res1531_4475;
	    }
	 }
      }
   }
}


/* struct+object->object-extern-sfun/cinfo */ obj_t 
struct_object__object_extern_sfun_cinfo_23_cfa_info(obj_t env_10376, obj_t o_10377, obj_t s_10378)
{
   {
      extern_sfun_cinfo_6_t o_4460;
      obj_t s_4461;
      {
	 extern_sfun_cinfo_6_t aux_16354;
	 o_4460 = (extern_sfun_cinfo_6_t) (o_10377);
	 s_4461 = s_10378;
	 {
	    {
	       obj_t old1558_4464;
	       obj_t aux1559_4465;
	       {
		  obj_t next_method2590_75_4470;
		  next_method2590_75_4470 = find_super_class_method_167___object((object_t) (o_4460), struct_object__object_env_209___object, extern_sfun_cinfo_6_cfa_info);
		  if (PROCEDUREP(next_method2590_75_4470))
		    {
		       old1558_4464 = PROCEDURE_ENTRY(next_method2590_75_4470) (next_method2590_75_4470, (obj_t) (o_4460), s_4461, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2590_75_4470);
		       {
			  object_t aux_16363;
			  aux_16363 = struct_object__object_93___object((object_t) (o_4460), s_4461);
			  old1558_4464 = (obj_t) (aux_16363);
		       }
		    }
	       }
	       aux1559_4465 = STRUCT_REF(s_4461, ((long) 0));
	       {
		  extern_sfun_cinfo_6_t new1560_4466;
		  new1560_4466 = ((extern_sfun_cinfo_6_t) (old1558_4464));
		  {
		     long arg3642_4467;
		     arg3642_4467 = class_num_218___object(extern_sfun_cinfo_6_cfa_info);
		     {
			obj_t obj_7944;
			obj_7944 = (obj_t) (new1560_4466);
			(((obj_t) CREF(obj_7944))->header = MAKE_HEADER(arg3642_4467, 0), BUNSPEC);
		     }
		  }
		  {
		     extern_sfun_cinfo_6_t arg3643_4468;
		     {
			extern_sfun_cinfo_6_t res3818_7951;
			{
			   approx_t approx_7948;
			   {
			      obj_t aux_16372;
			      aux_16372 = STRUCT_REF(aux1559_4465, ((long) 0));
			      approx_7948 = (approx_t) (aux_16372);
			   }
			   {
			      extern_sfun_cinfo_6_t new1536_7949;
			      new1536_7949 = ((extern_sfun_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
			      ((((extern_sfun_cinfo_6_t) CREF(new1536_7949))->approx) = ((approx_t) approx_7948), BUNSPEC);
			      res3818_7951 = new1536_7949;
			   }
			}
			arg3643_4468 = res3818_7951;
		     }
		     {
			obj_t aux_16379;
			object_t aux_16377;
			aux_16379 = (obj_t) (arg3643_4468);
			aux_16377 = (object_t) (new1560_4466);
			OBJECT_WIDENING_SET(aux_16377, aux_16379);
		     }
		  }
		  aux_16354 = new1560_4466;
	       }
	    }
	 }
	 return (obj_t) (aux_16354);
      }
   }
}


/* object->struct-extern-sfun/cinfo */ obj_t 
object__struct_extern_sfun_cinfo_81_cfa_info(obj_t env_10379, obj_t obj1555_10380)
{
   {
      extern_sfun_cinfo_6_t obj1555_4447;
      obj1555_4447 = (extern_sfun_cinfo_6_t) (obj1555_10380);
      {
	 {
	    obj_t res1556_4450;
	    {
	       obj_t next_method2589_213_4458;
	       next_method2589_213_4458 = find_super_class_method_167___object((object_t) (obj1555_4447), object__struct_env_210___object, extern_sfun_cinfo_6_cfa_info);
	       if (PROCEDUREP(next_method2589_213_4458))
		 {
		    res1556_4450 = PROCEDURE_ENTRY(next_method2589_213_4458) (next_method2589_213_4458, (obj_t) (obj1555_4447), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2589_213_4458);
		    res1556_4450 = object__struct_50___object((object_t) (obj1555_4447));
		 }
	    }
	    {
	       obj_t aux1557_4451;
	       {
		  obj_t aux_16394;
		  aux_16394 = CNST_TABLE_REF(((long) 2));
		  aux1557_4451 = make_struct(aux_16394, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16397;
		  {
		     approx_t aux_16398;
		     {
			obj_t aux_16399;
			{
			   object_t aux_16400;
			   aux_16400 = (object_t) (obj1555_4447);
			   aux_16399 = OBJECT_WIDENING(aux_16400);
			}
			aux_16398 = (((extern_sfun_cinfo_6_t) CREF(aux_16399))->approx);
		     }
		     aux_16397 = (obj_t) (aux_16398);
		  }
		  STRUCT_SET(aux1557_4451, ((long) 0), aux_16397);
	       }
	       STRUCT_SET(res1556_4450, ((long) 0), aux1557_4451);
	       {
		  obj_t aux_16407;
		  aux_16407 = STRUCT_KEY(res1556_4450);
		  STRUCT_KEY_SET(aux1557_4451, aux_16407);
	       }
	       {
		  obj_t aux_16410;
		  aux_16410 = CNST_TABLE_REF(((long) 2));
		  STRUCT_KEY_SET(res1556_4450, aux_16410);
	       }
	       return res1556_4450;
	    }
	 }
      }
   }
}


/* struct+object->object-intern-sfun/cinfo */ obj_t 
struct_object__object_intern_sfun_cinfo_38_cfa_info(obj_t env_10381, obj_t o_10382, obj_t s_10383)
{
   {
      intern_sfun_cinfo_192_t o_4434;
      obj_t s_4435;
      {
	 intern_sfun_cinfo_192_t aux_16414;
	 o_4434 = (intern_sfun_cinfo_192_t) (o_10382);
	 s_4435 = s_10383;
	 {
	    {
	       obj_t old1583_4438;
	       obj_t aux1584_4439;
	       {
		  obj_t next_method2588_49_4445;
		  next_method2588_49_4445 = find_super_class_method_167___object((object_t) (o_4434), struct_object__object_env_209___object, intern_sfun_cinfo_192_cfa_info);
		  if (PROCEDUREP(next_method2588_49_4445))
		    {
		       old1583_4438 = PROCEDURE_ENTRY(next_method2588_49_4445) (next_method2588_49_4445, (obj_t) (o_4434), s_4435, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2588_49_4445);
		       {
			  object_t aux_16423;
			  aux_16423 = struct_object__object_93___object((object_t) (o_4434), s_4435);
			  old1583_4438 = (obj_t) (aux_16423);
		       }
		    }
	       }
	       aux1584_4439 = STRUCT_REF(s_4435, ((long) 0));
	       {
		  intern_sfun_cinfo_192_t new1585_4440;
		  new1585_4440 = ((intern_sfun_cinfo_192_t) (old1583_4438));
		  {
		     long arg3630_4441;
		     arg3630_4441 = class_num_218___object(intern_sfun_cinfo_192_cfa_info);
		     {
			obj_t obj_7911;
			obj_7911 = (obj_t) (new1585_4440);
			(((obj_t) CREF(obj_7911))->header = MAKE_HEADER(arg3630_4441, 0), BUNSPEC);
		     }
		  }
		  {
		     intern_sfun_cinfo_192_t arg3631_4442;
		     {
			intern_sfun_cinfo_192_t res3817_7922;
			{
			   approx_t approx_7917;
			   long stamp_7918;
			   {
			      obj_t aux_16432;
			      aux_16432 = STRUCT_REF(aux1584_4439, ((long) 0));
			      approx_7917 = (approx_t) (aux_16432);
			   }
			   {
			      obj_t aux_16435;
			      aux_16435 = STRUCT_REF(aux1584_4439, ((long) 1));
			      stamp_7918 = (long) CINT(aux_16435);
			   }
			   {
			      intern_sfun_cinfo_192_t new1561_7919;
			      new1561_7919 = ((intern_sfun_cinfo_192_t) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
			      ((((intern_sfun_cinfo_192_t) CREF(new1561_7919))->approx) = ((approx_t) approx_7917), BUNSPEC);
			      ((((intern_sfun_cinfo_192_t) CREF(new1561_7919))->stamp) = ((long) stamp_7918), BUNSPEC);
			      res3817_7922 = new1561_7919;
			   }
			}
			arg3631_4442 = res3817_7922;
		     }
		     {
			obj_t aux_16443;
			object_t aux_16441;
			aux_16443 = (obj_t) (arg3631_4442);
			aux_16441 = (object_t) (new1585_4440);
			OBJECT_WIDENING_SET(aux_16441, aux_16443);
		     }
		  }
		  aux_16414 = new1585_4440;
	       }
	    }
	 }
	 return (obj_t) (aux_16414);
      }
   }
}


/* object->struct-intern-sfun/cinfo */ obj_t 
object__struct_intern_sfun_cinfo_28_cfa_info(obj_t env_10384, obj_t obj1580_10385)
{
   {
      intern_sfun_cinfo_192_t obj1580_4419;
      obj1580_4419 = (intern_sfun_cinfo_192_t) (obj1580_10385);
      {
	 {
	    obj_t res1581_4422;
	    {
	       obj_t next_method2587_28_4432;
	       next_method2587_28_4432 = find_super_class_method_167___object((object_t) (obj1580_4419), object__struct_env_210___object, intern_sfun_cinfo_192_cfa_info);
	       if (PROCEDUREP(next_method2587_28_4432))
		 {
		    res1581_4422 = PROCEDURE_ENTRY(next_method2587_28_4432) (next_method2587_28_4432, (obj_t) (obj1580_4419), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2587_28_4432);
		    res1581_4422 = object__struct_50___object((object_t) (obj1580_4419));
		 }
	    }
	    {
	       obj_t aux1582_4423;
	       {
		  obj_t aux_16458;
		  aux_16458 = CNST_TABLE_REF(((long) 3));
		  aux1582_4423 = make_struct(aux_16458, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_16461;
		  {
		     approx_t aux_16462;
		     {
			obj_t aux_16463;
			{
			   object_t aux_16464;
			   aux_16464 = (object_t) (obj1580_4419);
			   aux_16463 = OBJECT_WIDENING(aux_16464);
			}
			aux_16462 = (((intern_sfun_cinfo_192_t) CREF(aux_16463))->approx);
		     }
		     aux_16461 = (obj_t) (aux_16462);
		  }
		  STRUCT_SET(aux1582_4423, ((long) 0), aux_16461);
	       }
	       {
		  obj_t aux_16470;
		  {
		     long aux_16471;
		     {
			obj_t aux_16472;
			{
			   object_t aux_16473;
			   aux_16473 = (object_t) (obj1580_4419);
			   aux_16472 = OBJECT_WIDENING(aux_16473);
			}
			aux_16471 = (((intern_sfun_cinfo_192_t) CREF(aux_16472))->stamp);
		     }
		     aux_16470 = BINT(aux_16471);
		  }
		  STRUCT_SET(aux1582_4423, ((long) 1), aux_16470);
	       }
	       STRUCT_SET(res1581_4422, ((long) 0), aux1582_4423);
	       {
		  obj_t aux_16480;
		  aux_16480 = STRUCT_KEY(res1581_4422);
		  STRUCT_KEY_SET(aux1582_4423, aux_16480);
	       }
	       {
		  obj_t aux_16483;
		  aux_16483 = CNST_TABLE_REF(((long) 3));
		  STRUCT_KEY_SET(res1581_4422, aux_16483);
	       }
	       return res1581_4422;
	    }
	 }
      }
   }
}


/* struct+object->object-scnst/cinfo */ obj_t 
struct_object__object_scnst_cinfo_187_cfa_info(obj_t env_10386, obj_t o_10387, obj_t s_10388)
{
   {
      scnst_cinfo_0_t o_4407;
      obj_t s_4408;
      {
	 scnst_cinfo_0_t aux_16487;
	 o_4407 = (scnst_cinfo_0_t) (o_10387);
	 s_4408 = s_10388;
	 {
	    {
	       obj_t old1597_4411;
	       obj_t aux1598_4412;
	       {
		  obj_t next_method2586_210_4417;
		  next_method2586_210_4417 = find_super_class_method_167___object((object_t) (o_4407), struct_object__object_env_209___object, scnst_cinfo_0_cfa_info);
		  if (PROCEDUREP(next_method2586_210_4417))
		    {
		       old1597_4411 = PROCEDURE_ENTRY(next_method2586_210_4417) (next_method2586_210_4417, (obj_t) (o_4407), s_4408, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2586_210_4417);
		       {
			  object_t aux_16496;
			  aux_16496 = struct_object__object_93___object((object_t) (o_4407), s_4408);
			  old1597_4411 = (obj_t) (aux_16496);
		       }
		    }
	       }
	       aux1598_4412 = STRUCT_REF(s_4408, ((long) 0));
	       {
		  scnst_cinfo_0_t new1599_4413;
		  new1599_4413 = ((scnst_cinfo_0_t) (old1597_4411));
		  {
		     long arg3617_4414;
		     arg3617_4414 = class_num_218___object(scnst_cinfo_0_cfa_info);
		     {
			obj_t obj_7878;
			obj_7878 = (obj_t) (new1599_4413);
			(((obj_t) CREF(obj_7878))->header = MAKE_HEADER(arg3617_4414, 0), BUNSPEC);
		     }
		  }
		  {
		     scnst_cinfo_0_t arg3618_4415;
		     {
			scnst_cinfo_0_t res3816_7885;
			{
			   approx_t approx_7882;
			   {
			      obj_t aux_16505;
			      aux_16505 = STRUCT_REF(aux1598_4412, ((long) 0));
			      approx_7882 = (approx_t) (aux_16505);
			   }
			   {
			      scnst_cinfo_0_t new1586_7883;
			      new1586_7883 = ((scnst_cinfo_0_t) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
			      ((((scnst_cinfo_0_t) CREF(new1586_7883))->approx) = ((approx_t) approx_7882), BUNSPEC);
			      res3816_7885 = new1586_7883;
			   }
			}
			arg3618_4415 = res3816_7885;
		     }
		     {
			obj_t aux_16512;
			object_t aux_16510;
			aux_16512 = (obj_t) (arg3618_4415);
			aux_16510 = (object_t) (new1599_4413);
			OBJECT_WIDENING_SET(aux_16510, aux_16512);
		     }
		  }
		  aux_16487 = new1599_4413;
	       }
	    }
	 }
	 return (obj_t) (aux_16487);
      }
   }
}


/* object->struct-scnst/cinfo */ obj_t 
object__struct_scnst_cinfo_225_cfa_info(obj_t env_10389, obj_t obj1594_10390)
{
   {
      scnst_cinfo_0_t obj1594_4394;
      obj1594_4394 = (scnst_cinfo_0_t) (obj1594_10390);
      {
	 {
	    obj_t res1595_4397;
	    {
	       obj_t next_method2585_186_4405;
	       next_method2585_186_4405 = find_super_class_method_167___object((object_t) (obj1594_4394), object__struct_env_210___object, scnst_cinfo_0_cfa_info);
	       if (PROCEDUREP(next_method2585_186_4405))
		 {
		    res1595_4397 = PROCEDURE_ENTRY(next_method2585_186_4405) (next_method2585_186_4405, (obj_t) (obj1594_4394), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2585_186_4405);
		    res1595_4397 = object__struct_50___object((object_t) (obj1594_4394));
		 }
	    }
	    {
	       obj_t aux1596_4398;
	       {
		  obj_t aux_16527;
		  aux_16527 = CNST_TABLE_REF(((long) 4));
		  aux1596_4398 = make_struct(aux_16527, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16530;
		  {
		     approx_t aux_16531;
		     {
			obj_t aux_16532;
			{
			   object_t aux_16533;
			   aux_16533 = (object_t) (obj1594_4394);
			   aux_16532 = OBJECT_WIDENING(aux_16533);
			}
			aux_16531 = (((scnst_cinfo_0_t) CREF(aux_16532))->approx);
		     }
		     aux_16530 = (obj_t) (aux_16531);
		  }
		  STRUCT_SET(aux1596_4398, ((long) 0), aux_16530);
	       }
	       STRUCT_SET(res1595_4397, ((long) 0), aux1596_4398);
	       {
		  obj_t aux_16540;
		  aux_16540 = STRUCT_KEY(res1595_4397);
		  STRUCT_KEY_SET(aux1596_4398, aux_16540);
	       }
	       {
		  obj_t aux_16543;
		  aux_16543 = CNST_TABLE_REF(((long) 4));
		  STRUCT_KEY_SET(res1595_4397, aux_16543);
	       }
	       return res1595_4397;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-clo-env */ obj_t 
struct_object__object_pre_clo_env_30_cfa_info(obj_t env_10391, obj_t o_10392, obj_t s_10393)
{
   {
      pre_clo_env_191_t o_4383;
      obj_t s_4384;
      {
	 pre_clo_env_191_t aux_16547;
	 o_4383 = (pre_clo_env_191_t) (o_10392);
	 s_4384 = s_10393;
	 {
	    {
	       obj_t old1609_4387;
	       {
		  obj_t next_method2584_67_4392;
		  next_method2584_67_4392 = find_super_class_method_167___object((object_t) (o_4383), struct_object__object_env_209___object, pre_clo_env_191_cfa_info);
		  if (PROCEDUREP(next_method2584_67_4392))
		    {
		       old1609_4387 = PROCEDURE_ENTRY(next_method2584_67_4392) (next_method2584_67_4392, (obj_t) (o_4383), s_4384, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2584_67_4392);
		       {
			  object_t aux_16556;
			  aux_16556 = struct_object__object_93___object((object_t) (o_4383), s_4384);
			  old1609_4387 = (obj_t) (aux_16556);
		       }
		    }
	       }
	       {
		  pre_clo_env_191_t new1611_4389;
		  new1611_4389 = ((pre_clo_env_191_t) (old1609_4387));
		  {
		     long arg3607_4390;
		     arg3607_4390 = class_num_218___object(pre_clo_env_191_cfa_info);
		     {
			obj_t obj_7853;
			obj_7853 = (obj_t) (new1611_4389);
			(((obj_t) CREF(obj_7853))->header = MAKE_HEADER(arg3607_4390, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_16566;
		     object_t aux_16564;
		     {
			pre_clo_env_191_t aux_16567;
			{
			   aux_16567 = ((pre_clo_env_191_t) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
			}
			aux_16566 = (obj_t) (aux_16567);
		     }
		     aux_16564 = (object_t) (new1611_4389);
		     OBJECT_WIDENING_SET(aux_16564, aux_16566);
		  }
		  aux_16547 = new1611_4389;
	       }
	    }
	 }
	 return (obj_t) (aux_16547);
      }
   }
}


/* object->struct-pre-clo-env */ obj_t 
object__struct_pre_clo_env_226_cfa_info(obj_t env_10394, obj_t obj1606_10395)
{
   {
      pre_clo_env_191_t obj1606_4372;
      obj1606_4372 = (pre_clo_env_191_t) (obj1606_10395);
      {
	 {
	    obj_t res1607_4375;
	    {
	       obj_t next_method2583_2_4381;
	       next_method2583_2_4381 = find_super_class_method_167___object((object_t) (obj1606_4372), object__struct_env_210___object, pre_clo_env_191_cfa_info);
	       if (PROCEDUREP(next_method2583_2_4381))
		 {
		    res1607_4375 = PROCEDURE_ENTRY(next_method2583_2_4381) (next_method2583_2_4381, (obj_t) (obj1606_4372), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2583_2_4381);
		    res1607_4375 = object__struct_50___object((object_t) (obj1606_4372));
		 }
	    }
	    {
	       obj_t aux1608_4376;
	       {
		  obj_t aux_16583;
		  aux_16583 = CNST_TABLE_REF(((long) 5));
		  aux1608_4376 = make_struct(aux_16583, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1607_4375, ((long) 0), aux1608_4376);
	       {
		  obj_t aux_16587;
		  aux_16587 = STRUCT_KEY(res1607_4375);
		  STRUCT_KEY_SET(aux1608_4376, aux_16587);
	       }
	       {
		  obj_t aux_16590;
		  aux_16590 = CNST_TABLE_REF(((long) 5));
		  STRUCT_KEY_SET(res1607_4375, aux_16590);
	       }
	       return res1607_4375;
	    }
	 }
      }
   }
}


/* struct+object->object-svar/cinfo */ obj_t 
struct_object__object_svar_cinfo_24_cfa_info(obj_t env_10396, obj_t o_10397, obj_t s_10398)
{
   {
      svar_cinfo_166_t o_4359;
      obj_t s_4360;
      {
	 svar_cinfo_166_t aux_16594;
	 o_4359 = (svar_cinfo_166_t) (o_10397);
	 s_4360 = s_10398;
	 {
	    {
	       obj_t old1624_4363;
	       obj_t aux1625_4364;
	       {
		  obj_t next_method2582_15_4370;
		  next_method2582_15_4370 = find_super_class_method_167___object((object_t) (o_4359), struct_object__object_env_209___object, svar_cinfo_166_cfa_info);
		  if (PROCEDUREP(next_method2582_15_4370))
		    {
		       old1624_4363 = PROCEDURE_ENTRY(next_method2582_15_4370) (next_method2582_15_4370, (obj_t) (o_4359), s_4360, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2582_15_4370);
		       {
			  object_t aux_16603;
			  aux_16603 = struct_object__object_93___object((object_t) (o_4359), s_4360);
			  old1624_4363 = (obj_t) (aux_16603);
		       }
		    }
	       }
	       aux1625_4364 = STRUCT_REF(s_4360, ((long) 0));
	       {
		  svar_cinfo_166_t new1626_4365;
		  new1626_4365 = ((svar_cinfo_166_t) (old1624_4363));
		  {
		     long arg3597_4366;
		     arg3597_4366 = class_num_218___object(svar_cinfo_166_cfa_info);
		     {
			obj_t obj_7824;
			obj_7824 = (obj_t) (new1626_4365);
			(((obj_t) CREF(obj_7824))->header = MAKE_HEADER(arg3597_4366, 0), BUNSPEC);
		     }
		  }
		  {
		     svar_cinfo_166_t arg3598_4367;
		     {
			svar_cinfo_166_t res3814_7835;
			{
			   approx_t approx_7830;
			   bool_t clo_env__87_7831;
			   {
			      obj_t aux_16612;
			      aux_16612 = STRUCT_REF(aux1625_4364, ((long) 0));
			      approx_7830 = (approx_t) (aux_16612);
			   }
			   {
			      obj_t aux_16615;
			      aux_16615 = STRUCT_REF(aux1625_4364, ((long) 1));
			      clo_env__87_7831 = CBOOL(aux_16615);
			   }
			   {
			      svar_cinfo_166_t new1612_7832;
			      new1612_7832 = ((svar_cinfo_166_t) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
			      ((((svar_cinfo_166_t) CREF(new1612_7832))->approx) = ((approx_t) approx_7830), BUNSPEC);
			      ((((svar_cinfo_166_t) CREF(new1612_7832))->clo_env__87) = ((bool_t) clo_env__87_7831), BUNSPEC);
			      res3814_7835 = new1612_7832;
			   }
			}
			arg3598_4367 = res3814_7835;
		     }
		     {
			obj_t aux_16623;
			object_t aux_16621;
			aux_16623 = (obj_t) (arg3598_4367);
			aux_16621 = (object_t) (new1626_4365);
			OBJECT_WIDENING_SET(aux_16621, aux_16623);
		     }
		  }
		  aux_16594 = new1626_4365;
	       }
	    }
	 }
	 return (obj_t) (aux_16594);
      }
   }
}


/* object->struct-svar/cinfo */ obj_t 
object__struct_svar_cinfo_7_cfa_info(obj_t env_10399, obj_t obj1621_10400)
{
   {
      svar_cinfo_166_t obj1621_4344;
      obj1621_4344 = (svar_cinfo_166_t) (obj1621_10400);
      {
	 {
	    obj_t res1622_4347;
	    {
	       obj_t next_method2581_115_4357;
	       next_method2581_115_4357 = find_super_class_method_167___object((object_t) (obj1621_4344), object__struct_env_210___object, svar_cinfo_166_cfa_info);
	       if (PROCEDUREP(next_method2581_115_4357))
		 {
		    res1622_4347 = PROCEDURE_ENTRY(next_method2581_115_4357) (next_method2581_115_4357, (obj_t) (obj1621_4344), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2581_115_4357);
		    res1622_4347 = object__struct_50___object((object_t) (obj1621_4344));
		 }
	    }
	    {
	       obj_t aux1623_4348;
	       {
		  obj_t aux_16638;
		  aux_16638 = CNST_TABLE_REF(((long) 6));
		  aux1623_4348 = make_struct(aux_16638, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_16641;
		  {
		     approx_t aux_16642;
		     {
			obj_t aux_16643;
			{
			   object_t aux_16644;
			   aux_16644 = (object_t) (obj1621_4344);
			   aux_16643 = OBJECT_WIDENING(aux_16644);
			}
			aux_16642 = (((svar_cinfo_166_t) CREF(aux_16643))->approx);
		     }
		     aux_16641 = (obj_t) (aux_16642);
		  }
		  STRUCT_SET(aux1623_4348, ((long) 0), aux_16641);
	       }
	       {
		  obj_t aux_16650;
		  {
		     bool_t aux_16651;
		     {
			obj_t aux_16652;
			{
			   object_t aux_16653;
			   aux_16653 = (object_t) (obj1621_4344);
			   aux_16652 = OBJECT_WIDENING(aux_16653);
			}
			aux_16651 = (((svar_cinfo_166_t) CREF(aux_16652))->clo_env__87);
		     }
		     aux_16650 = BBOOL(aux_16651);
		  }
		  STRUCT_SET(aux1623_4348, ((long) 1), aux_16650);
	       }
	       STRUCT_SET(res1622_4347, ((long) 0), aux1623_4348);
	       {
		  obj_t aux_16660;
		  aux_16660 = STRUCT_KEY(res1622_4347);
		  STRUCT_KEY_SET(aux1623_4348, aux_16660);
	       }
	       {
		  obj_t aux_16663;
		  aux_16663 = CNST_TABLE_REF(((long) 6));
		  STRUCT_KEY_SET(res1622_4347, aux_16663);
	       }
	       return res1622_4347;
	    }
	 }
      }
   }
}


/* struct+object->object-cvar/cinfo */ obj_t 
struct_object__object_cvar_cinfo_125_cfa_info(obj_t env_10401, obj_t o_10402, obj_t s_10403)
{
   {
      cvar_cinfo_53_t o_4332;
      obj_t s_4333;
      {
	 cvar_cinfo_53_t aux_16667;
	 o_4332 = (cvar_cinfo_53_t) (o_10402);
	 s_4333 = s_10403;
	 {
	    {
	       obj_t old1636_4336;
	       obj_t aux1637_4337;
	       {
		  obj_t next_method2580_48_4342;
		  next_method2580_48_4342 = find_super_class_method_167___object((object_t) (o_4332), struct_object__object_env_209___object, cvar_cinfo_53_cfa_info);
		  if (PROCEDUREP(next_method2580_48_4342))
		    {
		       old1636_4336 = PROCEDURE_ENTRY(next_method2580_48_4342) (next_method2580_48_4342, (obj_t) (o_4332), s_4333, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2580_48_4342);
		       {
			  object_t aux_16676;
			  aux_16676 = struct_object__object_93___object((object_t) (o_4332), s_4333);
			  old1636_4336 = (obj_t) (aux_16676);
		       }
		    }
	       }
	       aux1637_4337 = STRUCT_REF(s_4333, ((long) 0));
	       {
		  cvar_cinfo_53_t new1638_4338;
		  new1638_4338 = ((cvar_cinfo_53_t) (old1636_4336));
		  {
		     long arg3584_4339;
		     arg3584_4339 = class_num_218___object(cvar_cinfo_53_cfa_info);
		     {
			obj_t obj_7791;
			obj_7791 = (obj_t) (new1638_4338);
			(((obj_t) CREF(obj_7791))->header = MAKE_HEADER(arg3584_4339, 0), BUNSPEC);
		     }
		  }
		  {
		     cvar_cinfo_53_t arg3585_4340;
		     {
			cvar_cinfo_53_t res3813_7798;
			{
			   approx_t approx_7795;
			   {
			      obj_t aux_16685;
			      aux_16685 = STRUCT_REF(aux1637_4337, ((long) 0));
			      approx_7795 = (approx_t) (aux_16685);
			   }
			   {
			      cvar_cinfo_53_t new1627_7796;
			      new1627_7796 = ((cvar_cinfo_53_t) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
			      ((((cvar_cinfo_53_t) CREF(new1627_7796))->approx) = ((approx_t) approx_7795), BUNSPEC);
			      res3813_7798 = new1627_7796;
			   }
			}
			arg3585_4340 = res3813_7798;
		     }
		     {
			obj_t aux_16692;
			object_t aux_16690;
			aux_16692 = (obj_t) (arg3585_4340);
			aux_16690 = (object_t) (new1638_4338);
			OBJECT_WIDENING_SET(aux_16690, aux_16692);
		     }
		  }
		  aux_16667 = new1638_4338;
	       }
	    }
	 }
	 return (obj_t) (aux_16667);
      }
   }
}


/* object->struct-cvar/cinfo */ obj_t 
object__struct_cvar_cinfo_219_cfa_info(obj_t env_10404, obj_t obj1633_10405)
{
   {
      cvar_cinfo_53_t obj1633_4319;
      obj1633_4319 = (cvar_cinfo_53_t) (obj1633_10405);
      {
	 {
	    obj_t res1634_4322;
	    {
	       obj_t next_method2579_156_4330;
	       next_method2579_156_4330 = find_super_class_method_167___object((object_t) (obj1633_4319), object__struct_env_210___object, cvar_cinfo_53_cfa_info);
	       if (PROCEDUREP(next_method2579_156_4330))
		 {
		    res1634_4322 = PROCEDURE_ENTRY(next_method2579_156_4330) (next_method2579_156_4330, (obj_t) (obj1633_4319), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2579_156_4330);
		    res1634_4322 = object__struct_50___object((object_t) (obj1633_4319));
		 }
	    }
	    {
	       obj_t aux1635_4323;
	       {
		  obj_t aux_16707;
		  aux_16707 = CNST_TABLE_REF(((long) 7));
		  aux1635_4323 = make_struct(aux_16707, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16710;
		  {
		     approx_t aux_16711;
		     {
			obj_t aux_16712;
			{
			   object_t aux_16713;
			   aux_16713 = (object_t) (obj1633_4319);
			   aux_16712 = OBJECT_WIDENING(aux_16713);
			}
			aux_16711 = (((cvar_cinfo_53_t) CREF(aux_16712))->approx);
		     }
		     aux_16710 = (obj_t) (aux_16711);
		  }
		  STRUCT_SET(aux1635_4323, ((long) 0), aux_16710);
	       }
	       STRUCT_SET(res1634_4322, ((long) 0), aux1635_4323);
	       {
		  obj_t aux_16720;
		  aux_16720 = STRUCT_KEY(res1634_4322);
		  STRUCT_KEY_SET(aux1635_4323, aux_16720);
	       }
	       {
		  obj_t aux_16723;
		  aux_16723 = CNST_TABLE_REF(((long) 7));
		  STRUCT_KEY_SET(res1634_4322, aux_16723);
	       }
	       return res1634_4322;
	    }
	 }
      }
   }
}


/* struct+object->object-sexit/cinfo */ obj_t 
struct_object__object_sexit_cinfo_74_cfa_info(obj_t env_10406, obj_t o_10407, obj_t s_10408)
{
   {
      sexit_cinfo_49_t o_4307;
      obj_t s_4308;
      {
	 sexit_cinfo_49_t aux_16727;
	 o_4307 = (sexit_cinfo_49_t) (o_10407);
	 s_4308 = s_10408;
	 {
	    {
	       obj_t old1650_4311;
	       obj_t aux1651_4312;
	       {
		  obj_t next_method2578_241_4317;
		  next_method2578_241_4317 = find_super_class_method_167___object((object_t) (o_4307), struct_object__object_env_209___object, sexit_cinfo_49_cfa_info);
		  if (PROCEDUREP(next_method2578_241_4317))
		    {
		       old1650_4311 = PROCEDURE_ENTRY(next_method2578_241_4317) (next_method2578_241_4317, (obj_t) (o_4307), s_4308, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2578_241_4317);
		       {
			  object_t aux_16736;
			  aux_16736 = struct_object__object_93___object((object_t) (o_4307), s_4308);
			  old1650_4311 = (obj_t) (aux_16736);
		       }
		    }
	       }
	       aux1651_4312 = STRUCT_REF(s_4308, ((long) 0));
	       {
		  sexit_cinfo_49_t new1652_4313;
		  new1652_4313 = ((sexit_cinfo_49_t) (old1650_4311));
		  {
		     long arg3573_4314;
		     arg3573_4314 = class_num_218___object(sexit_cinfo_49_cfa_info);
		     {
			obj_t obj_7762;
			obj_7762 = (obj_t) (new1652_4313);
			(((obj_t) CREF(obj_7762))->header = MAKE_HEADER(arg3573_4314, 0), BUNSPEC);
		     }
		  }
		  {
		     sexit_cinfo_49_t arg3574_4315;
		     {
			sexit_cinfo_49_t res3812_7769;
			{
			   approx_t approx_7766;
			   {
			      obj_t aux_16745;
			      aux_16745 = STRUCT_REF(aux1651_4312, ((long) 0));
			      approx_7766 = (approx_t) (aux_16745);
			   }
			   {
			      sexit_cinfo_49_t new1639_7767;
			      new1639_7767 = ((sexit_cinfo_49_t) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
			      ((((sexit_cinfo_49_t) CREF(new1639_7767))->approx) = ((approx_t) approx_7766), BUNSPEC);
			      res3812_7769 = new1639_7767;
			   }
			}
			arg3574_4315 = res3812_7769;
		     }
		     {
			obj_t aux_16752;
			object_t aux_16750;
			aux_16752 = (obj_t) (arg3574_4315);
			aux_16750 = (object_t) (new1652_4313);
			OBJECT_WIDENING_SET(aux_16750, aux_16752);
		     }
		  }
		  aux_16727 = new1652_4313;
	       }
	    }
	 }
	 return (obj_t) (aux_16727);
      }
   }
}


/* object->struct-sexit/cinfo */ obj_t 
object__struct_sexit_cinfo_98_cfa_info(obj_t env_10409, obj_t obj1647_10410)
{
   {
      sexit_cinfo_49_t obj1647_4294;
      obj1647_4294 = (sexit_cinfo_49_t) (obj1647_10410);
      {
	 {
	    obj_t res1648_4297;
	    {
	       obj_t next_method2577_128_4305;
	       next_method2577_128_4305 = find_super_class_method_167___object((object_t) (obj1647_4294), object__struct_env_210___object, sexit_cinfo_49_cfa_info);
	       if (PROCEDUREP(next_method2577_128_4305))
		 {
		    res1648_4297 = PROCEDURE_ENTRY(next_method2577_128_4305) (next_method2577_128_4305, (obj_t) (obj1647_4294), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2577_128_4305);
		    res1648_4297 = object__struct_50___object((object_t) (obj1647_4294));
		 }
	    }
	    {
	       obj_t aux1649_4298;
	       {
		  obj_t aux_16767;
		  aux_16767 = CNST_TABLE_REF(((long) 8));
		  aux1649_4298 = make_struct(aux_16767, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16770;
		  {
		     approx_t aux_16771;
		     {
			obj_t aux_16772;
			{
			   object_t aux_16773;
			   aux_16773 = (object_t) (obj1647_4294);
			   aux_16772 = OBJECT_WIDENING(aux_16773);
			}
			aux_16771 = (((sexit_cinfo_49_t) CREF(aux_16772))->approx);
		     }
		     aux_16770 = (obj_t) (aux_16771);
		  }
		  STRUCT_SET(aux1649_4298, ((long) 0), aux_16770);
	       }
	       STRUCT_SET(res1648_4297, ((long) 0), aux1649_4298);
	       {
		  obj_t aux_16780;
		  aux_16780 = STRUCT_KEY(res1648_4297);
		  STRUCT_KEY_SET(aux1649_4298, aux_16780);
	       }
	       {
		  obj_t aux_16783;
		  aux_16783 = CNST_TABLE_REF(((long) 8));
		  STRUCT_KEY_SET(res1648_4297, aux_16783);
	       }
	       return res1648_4297;
	    }
	 }
      }
   }
}


/* struct+object->object-reshaped-local */ obj_t 
struct_object__object_reshaped_local_214_cfa_info(obj_t env_10411, obj_t o_10412, obj_t s_10413)
{
   {
      reshaped_local_224_t o_4282;
      obj_t s_4283;
      {
	 reshaped_local_224_t aux_16787;
	 o_4282 = (reshaped_local_224_t) (o_10412);
	 s_4283 = s_10413;
	 {
	    {
	       obj_t old1670_4286;
	       obj_t aux1671_4287;
	       {
		  obj_t next_method2576_83_4292;
		  next_method2576_83_4292 = find_super_class_method_167___object((object_t) (o_4282), struct_object__object_env_209___object, reshaped_local_224_cfa_info);
		  if (PROCEDUREP(next_method2576_83_4292))
		    {
		       old1670_4286 = PROCEDURE_ENTRY(next_method2576_83_4292) (next_method2576_83_4292, (obj_t) (o_4282), s_4283, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2576_83_4292);
		       {
			  object_t aux_16796;
			  aux_16796 = struct_object__object_93___object((object_t) (o_4282), s_4283);
			  old1670_4286 = (obj_t) (aux_16796);
		       }
		    }
	       }
	       aux1671_4287 = STRUCT_REF(s_4283, ((long) 0));
	       {
		  reshaped_local_224_t new1672_4288;
		  new1672_4288 = ((reshaped_local_224_t) (old1670_4286));
		  {
		     long arg3562_4289;
		     arg3562_4289 = class_num_218___object(reshaped_local_224_cfa_info);
		     {
			obj_t obj_7733;
			obj_7733 = (obj_t) (new1672_4288);
			(((obj_t) CREF(obj_7733))->header = MAKE_HEADER(arg3562_4289, 0), BUNSPEC);
		     }
		  }
		  {
		     reshaped_local_224_t arg3563_4290;
		     {
			obj_t arg3564_4291;
			arg3564_4291 = STRUCT_REF(aux1671_4287, ((long) 0));
			{
			   reshaped_local_224_t res3811_7740;
			   {
			      reshaped_local_224_t new1653_7738;
			      new1653_7738 = ((reshaped_local_224_t) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
			      ((((reshaped_local_224_t) CREF(new1653_7738))->binding_value_3) = ((obj_t) arg3564_4291), BUNSPEC);
			      res3811_7740 = new1653_7738;
			   }
			   arg3563_4290 = res3811_7740;
			}
		     }
		     {
			obj_t aux_16810;
			object_t aux_16808;
			aux_16810 = (obj_t) (arg3563_4290);
			aux_16808 = (object_t) (new1672_4288);
			OBJECT_WIDENING_SET(aux_16808, aux_16810);
		     }
		  }
		  aux_16787 = new1672_4288;
	       }
	    }
	 }
	 return (obj_t) (aux_16787);
      }
   }
}


/* object->struct-reshaped-local */ obj_t 
object__struct_reshaped_local_22_cfa_info(obj_t env_10414, obj_t obj1667_10415)
{
   {
      reshaped_local_224_t obj1667_4269;
      obj1667_4269 = (reshaped_local_224_t) (obj1667_10415);
      {
	 {
	    obj_t res1668_4272;
	    {
	       obj_t next_method2575_60_4280;
	       next_method2575_60_4280 = find_super_class_method_167___object((object_t) (obj1667_4269), object__struct_env_210___object, reshaped_local_224_cfa_info);
	       if (PROCEDUREP(next_method2575_60_4280))
		 {
		    res1668_4272 = PROCEDURE_ENTRY(next_method2575_60_4280) (next_method2575_60_4280, (obj_t) (obj1667_4269), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2575_60_4280);
		    res1668_4272 = object__struct_50___object((object_t) (obj1667_4269));
		 }
	    }
	    {
	       obj_t aux1669_4273;
	       {
		  obj_t aux_16825;
		  aux_16825 = CNST_TABLE_REF(((long) 9));
		  aux1669_4273 = make_struct(aux_16825, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16828;
		  {
		     obj_t aux_16829;
		     {
			object_t aux_16830;
			aux_16830 = (object_t) (obj1667_4269);
			aux_16829 = OBJECT_WIDENING(aux_16830);
		     }
		     aux_16828 = (((reshaped_local_224_t) CREF(aux_16829))->binding_value_3);
		  }
		  STRUCT_SET(aux1669_4273, ((long) 0), aux_16828);
	       }
	       STRUCT_SET(res1668_4272, ((long) 0), aux1669_4273);
	       {
		  obj_t aux_16836;
		  aux_16836 = STRUCT_KEY(res1668_4272);
		  STRUCT_KEY_SET(aux1669_4273, aux_16836);
	       }
	       {
		  obj_t aux_16839;
		  aux_16839 = CNST_TABLE_REF(((long) 9));
		  STRUCT_KEY_SET(res1668_4272, aux_16839);
	       }
	       return res1668_4272;
	    }
	 }
      }
   }
}


/* struct+object->object-reshaped-global */ obj_t 
struct_object__object_reshaped_global_132_cfa_info(obj_t env_10416, obj_t o_10417, obj_t s_10418)
{
   {
      reshaped_global_160_t o_4258;
      obj_t s_4259;
      {
	 reshaped_global_160_t aux_16843;
	 o_4258 = (reshaped_global_160_t) (o_10417);
	 s_4259 = s_10418;
	 {
	    {
	       obj_t old1693_4262;
	       {
		  obj_t next_method2574_66_4267;
		  next_method2574_66_4267 = find_super_class_method_167___object((object_t) (o_4258), struct_object__object_env_209___object, reshaped_global_160_cfa_info);
		  if (PROCEDUREP(next_method2574_66_4267))
		    {
		       old1693_4262 = PROCEDURE_ENTRY(next_method2574_66_4267) (next_method2574_66_4267, (obj_t) (o_4258), s_4259, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2574_66_4267);
		       {
			  object_t aux_16852;
			  aux_16852 = struct_object__object_93___object((object_t) (o_4258), s_4259);
			  old1693_4262 = (obj_t) (aux_16852);
		       }
		    }
	       }
	       {
		  reshaped_global_160_t new1695_4264;
		  new1695_4264 = ((reshaped_global_160_t) (old1693_4262));
		  {
		     long arg3552_4265;
		     arg3552_4265 = class_num_218___object(reshaped_global_160_cfa_info);
		     {
			obj_t obj_7708;
			obj_7708 = (obj_t) (new1695_4264);
			(((obj_t) CREF(obj_7708))->header = MAKE_HEADER(arg3552_4265, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_16862;
		     object_t aux_16860;
		     {
			reshaped_global_160_t aux_16863;
			{
			   aux_16863 = ((reshaped_global_160_t) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
			}
			aux_16862 = (obj_t) (aux_16863);
		     }
		     aux_16860 = (object_t) (new1695_4264);
		     OBJECT_WIDENING_SET(aux_16860, aux_16862);
		  }
		  aux_16843 = new1695_4264;
	       }
	    }
	 }
	 return (obj_t) (aux_16843);
      }
   }
}


/* object->struct-reshaped-global */ obj_t 
object__struct_reshaped_global_19_cfa_info(obj_t env_10419, obj_t obj1690_10420)
{
   {
      reshaped_global_160_t obj1690_4247;
      obj1690_4247 = (reshaped_global_160_t) (obj1690_10420);
      {
	 {
	    obj_t res1691_4250;
	    {
	       obj_t next_method2573_141_4256;
	       next_method2573_141_4256 = find_super_class_method_167___object((object_t) (obj1690_4247), object__struct_env_210___object, reshaped_global_160_cfa_info);
	       if (PROCEDUREP(next_method2573_141_4256))
		 {
		    res1691_4250 = PROCEDURE_ENTRY(next_method2573_141_4256) (next_method2573_141_4256, (obj_t) (obj1690_4247), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2573_141_4256);
		    res1691_4250 = object__struct_50___object((object_t) (obj1690_4247));
		 }
	    }
	    {
	       obj_t aux1692_4251;
	       {
		  obj_t aux_16879;
		  aux_16879 = CNST_TABLE_REF(((long) 10));
		  aux1692_4251 = make_struct(aux_16879, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1691_4250, ((long) 0), aux1692_4251);
	       {
		  obj_t aux_16883;
		  aux_16883 = STRUCT_KEY(res1691_4250);
		  STRUCT_KEY_SET(aux1692_4251, aux_16883);
	       }
	       {
		  obj_t aux_16886;
		  aux_16886 = CNST_TABLE_REF(((long) 10));
		  STRUCT_KEY_SET(res1691_4250, aux_16886);
	       }
	       return res1691_4250;
	    }
	 }
      }
   }
}


/* struct+object->object-atom/cinfo */ obj_t 
struct_object__object_atom_cinfo_113_cfa_info(obj_t env_10421, obj_t o_10422, obj_t s_10423)
{
   {
      atom_cinfo_155_t o_4235;
      obj_t s_4236;
      {
	 atom_cinfo_155_t aux_16890;
	 o_4235 = (atom_cinfo_155_t) (o_10422);
	 s_4236 = s_10423;
	 {
	    {
	       obj_t old1707_4239;
	       obj_t aux1708_4240;
	       {
		  obj_t next_method2572_86_4245;
		  next_method2572_86_4245 = find_super_class_method_167___object((object_t) (o_4235), struct_object__object_env_209___object, atom_cinfo_155_cfa_info);
		  if (PROCEDUREP(next_method2572_86_4245))
		    {
		       old1707_4239 = PROCEDURE_ENTRY(next_method2572_86_4245) (next_method2572_86_4245, (obj_t) (o_4235), s_4236, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2572_86_4245);
		       {
			  object_t aux_16899;
			  aux_16899 = struct_object__object_93___object((object_t) (o_4235), s_4236);
			  old1707_4239 = (obj_t) (aux_16899);
		       }
		    }
	       }
	       aux1708_4240 = STRUCT_REF(s_4236, ((long) 0));
	       {
		  atom_cinfo_155_t new1709_4241;
		  new1709_4241 = ((atom_cinfo_155_t) (old1707_4239));
		  {
		     long arg3543_4242;
		     arg3543_4242 = class_num_218___object(atom_cinfo_155_cfa_info);
		     {
			obj_t obj_7683;
			obj_7683 = (obj_t) (new1709_4241);
			(((obj_t) CREF(obj_7683))->header = MAKE_HEADER(arg3543_4242, 0), BUNSPEC);
		     }
		  }
		  {
		     atom_cinfo_155_t arg3544_4243;
		     {
			atom_cinfo_155_t res3809_7690;
			{
			   approx_t approx_7687;
			   {
			      obj_t aux_16908;
			      aux_16908 = STRUCT_REF(aux1708_4240, ((long) 0));
			      approx_7687 = (approx_t) (aux_16908);
			   }
			   {
			      atom_cinfo_155_t new1696_7688;
			      new1696_7688 = ((atom_cinfo_155_t) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
			      ((((atom_cinfo_155_t) CREF(new1696_7688))->approx) = ((approx_t) approx_7687), BUNSPEC);
			      res3809_7690 = new1696_7688;
			   }
			}
			arg3544_4243 = res3809_7690;
		     }
		     {
			obj_t aux_16915;
			object_t aux_16913;
			aux_16915 = (obj_t) (arg3544_4243);
			aux_16913 = (object_t) (new1709_4241);
			OBJECT_WIDENING_SET(aux_16913, aux_16915);
		     }
		  }
		  aux_16890 = new1709_4241;
	       }
	    }
	 }
	 return (obj_t) (aux_16890);
      }
   }
}


/* object->struct-atom/cinfo */ obj_t 
object__struct_atom_cinfo_211_cfa_info(obj_t env_10424, obj_t obj1704_10425)
{
   {
      atom_cinfo_155_t obj1704_4222;
      obj1704_4222 = (atom_cinfo_155_t) (obj1704_10425);
      {
	 {
	    obj_t res1705_4225;
	    {
	       obj_t next_method2571_176_4233;
	       next_method2571_176_4233 = find_super_class_method_167___object((object_t) (obj1704_4222), object__struct_env_210___object, atom_cinfo_155_cfa_info);
	       if (PROCEDUREP(next_method2571_176_4233))
		 {
		    res1705_4225 = PROCEDURE_ENTRY(next_method2571_176_4233) (next_method2571_176_4233, (obj_t) (obj1704_4222), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2571_176_4233);
		    res1705_4225 = object__struct_50___object((object_t) (obj1704_4222));
		 }
	    }
	    {
	       obj_t aux1706_4226;
	       {
		  obj_t aux_16930;
		  aux_16930 = CNST_TABLE_REF(((long) 11));
		  aux1706_4226 = make_struct(aux_16930, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16933;
		  {
		     approx_t aux_16934;
		     {
			obj_t aux_16935;
			{
			   object_t aux_16936;
			   aux_16936 = (object_t) (obj1704_4222);
			   aux_16935 = OBJECT_WIDENING(aux_16936);
			}
			aux_16934 = (((atom_cinfo_155_t) CREF(aux_16935))->approx);
		     }
		     aux_16933 = (obj_t) (aux_16934);
		  }
		  STRUCT_SET(aux1706_4226, ((long) 0), aux_16933);
	       }
	       STRUCT_SET(res1705_4225, ((long) 0), aux1706_4226);
	       {
		  obj_t aux_16943;
		  aux_16943 = STRUCT_KEY(res1705_4225);
		  STRUCT_KEY_SET(aux1706_4226, aux_16943);
	       }
	       {
		  obj_t aux_16946;
		  aux_16946 = CNST_TABLE_REF(((long) 11));
		  STRUCT_KEY_SET(res1705_4225, aux_16946);
	       }
	       return res1705_4225;
	    }
	 }
      }
   }
}


/* struct+object->object-kwote/node */ obj_t 
struct_object__object_kwote_node_133_cfa_info(obj_t env_10426, obj_t o_10427, obj_t s_10428)
{
   {
      kwote_node_102_t o_4210;
      obj_t s_4211;
      {
	 kwote_node_102_t aux_16950;
	 o_4210 = (kwote_node_102_t) (o_10427);
	 s_4211 = s_10428;
	 {
	    {
	       obj_t old1720_4214;
	       obj_t aux1721_4215;
	       {
		  obj_t next_method2570_161_4220;
		  next_method2570_161_4220 = find_super_class_method_167___object((object_t) (o_4210), struct_object__object_env_209___object, kwote_node_102_cfa_info);
		  if (PROCEDUREP(next_method2570_161_4220))
		    {
		       old1720_4214 = PROCEDURE_ENTRY(next_method2570_161_4220) (next_method2570_161_4220, (obj_t) (o_4210), s_4211, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2570_161_4220);
		       {
			  object_t aux_16959;
			  aux_16959 = struct_object__object_93___object((object_t) (o_4210), s_4211);
			  old1720_4214 = (obj_t) (aux_16959);
		       }
		    }
	       }
	       aux1721_4215 = STRUCT_REF(s_4211, ((long) 0));
	       {
		  kwote_node_102_t new1722_4216;
		  new1722_4216 = ((kwote_node_102_t) (old1720_4214));
		  {
		     long arg3532_4217;
		     arg3532_4217 = class_num_218___object(kwote_node_102_cfa_info);
		     {
			obj_t obj_7654;
			obj_7654 = (obj_t) (new1722_4216);
			(((obj_t) CREF(obj_7654))->header = MAKE_HEADER(arg3532_4217, 0), BUNSPEC);
		     }
		  }
		  {
		     kwote_node_102_t arg3533_4218;
		     {
			kwote_node_102_t res3808_7661;
			{
			   node_t node_7658;
			   {
			      obj_t aux_16968;
			      aux_16968 = STRUCT_REF(aux1721_4215, ((long) 0));
			      node_7658 = (node_t) (aux_16968);
			   }
			   {
			      kwote_node_102_t new1710_7659;
			      new1710_7659 = ((kwote_node_102_t) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
			      ((((kwote_node_102_t) CREF(new1710_7659))->node) = ((node_t) node_7658), BUNSPEC);
			      res3808_7661 = new1710_7659;
			   }
			}
			arg3533_4218 = res3808_7661;
		     }
		     {
			obj_t aux_16975;
			object_t aux_16973;
			aux_16975 = (obj_t) (arg3533_4218);
			aux_16973 = (object_t) (new1722_4216);
			OBJECT_WIDENING_SET(aux_16973, aux_16975);
		     }
		  }
		  aux_16950 = new1722_4216;
	       }
	    }
	 }
	 return (obj_t) (aux_16950);
      }
   }
}


/* object->struct-kwote/node */ obj_t 
object__struct_kwote_node_184_cfa_info(obj_t env_10429, obj_t obj1717_10430)
{
   {
      kwote_node_102_t obj1717_4197;
      obj1717_4197 = (kwote_node_102_t) (obj1717_10430);
      {
	 {
	    obj_t res1718_4200;
	    {
	       obj_t next_method2569_241_4208;
	       next_method2569_241_4208 = find_super_class_method_167___object((object_t) (obj1717_4197), object__struct_env_210___object, kwote_node_102_cfa_info);
	       if (PROCEDUREP(next_method2569_241_4208))
		 {
		    res1718_4200 = PROCEDURE_ENTRY(next_method2569_241_4208) (next_method2569_241_4208, (obj_t) (obj1717_4197), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2569_241_4208);
		    res1718_4200 = object__struct_50___object((object_t) (obj1717_4197));
		 }
	    }
	    {
	       obj_t aux1719_4201;
	       {
		  obj_t aux_16990;
		  aux_16990 = CNST_TABLE_REF(((long) 12));
		  aux1719_4201 = make_struct(aux_16990, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_16993;
		  {
		     node_t aux_16994;
		     {
			obj_t aux_16995;
			{
			   object_t aux_16996;
			   aux_16996 = (object_t) (obj1717_4197);
			   aux_16995 = OBJECT_WIDENING(aux_16996);
			}
			aux_16994 = (((kwote_node_102_t) CREF(aux_16995))->node);
		     }
		     aux_16993 = (obj_t) (aux_16994);
		  }
		  STRUCT_SET(aux1719_4201, ((long) 0), aux_16993);
	       }
	       STRUCT_SET(res1718_4200, ((long) 0), aux1719_4201);
	       {
		  obj_t aux_17003;
		  aux_17003 = STRUCT_KEY(res1718_4200);
		  STRUCT_KEY_SET(aux1719_4201, aux_17003);
	       }
	       {
		  obj_t aux_17006;
		  aux_17006 = CNST_TABLE_REF(((long) 12));
		  STRUCT_KEY_SET(res1718_4200, aux_17006);
	       }
	       return res1718_4200;
	    }
	 }
      }
   }
}


/* struct+object->object-kwote/cinfo */ obj_t 
struct_object__object_kwote_cinfo_192_cfa_info(obj_t env_10431, obj_t o_10432, obj_t s_10433)
{
   {
      kwote_cinfo_48_t o_4185;
      obj_t s_4186;
      {
	 kwote_cinfo_48_t aux_17010;
	 o_4185 = (kwote_cinfo_48_t) (o_10432);
	 s_4186 = s_10433;
	 {
	    {
	       obj_t old1733_4189;
	       obj_t aux1734_4190;
	       {
		  obj_t next_method2568_156_4195;
		  next_method2568_156_4195 = find_super_class_method_167___object((object_t) (o_4185), struct_object__object_env_209___object, kwote_cinfo_48_cfa_info);
		  if (PROCEDUREP(next_method2568_156_4195))
		    {
		       old1733_4189 = PROCEDURE_ENTRY(next_method2568_156_4195) (next_method2568_156_4195, (obj_t) (o_4185), s_4186, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2568_156_4195);
		       {
			  object_t aux_17019;
			  aux_17019 = struct_object__object_93___object((object_t) (o_4185), s_4186);
			  old1733_4189 = (obj_t) (aux_17019);
		       }
		    }
	       }
	       aux1734_4190 = STRUCT_REF(s_4186, ((long) 0));
	       {
		  kwote_cinfo_48_t new1735_4191;
		  new1735_4191 = ((kwote_cinfo_48_t) (old1733_4189));
		  {
		     long arg3521_4192;
		     arg3521_4192 = class_num_218___object(kwote_cinfo_48_cfa_info);
		     {
			obj_t obj_7625;
			obj_7625 = (obj_t) (new1735_4191);
			(((obj_t) CREF(obj_7625))->header = MAKE_HEADER(arg3521_4192, 0), BUNSPEC);
		     }
		  }
		  {
		     kwote_cinfo_48_t arg3522_4193;
		     {
			kwote_cinfo_48_t res3807_7632;
			{
			   approx_t approx_7629;
			   {
			      obj_t aux_17028;
			      aux_17028 = STRUCT_REF(aux1734_4190, ((long) 0));
			      approx_7629 = (approx_t) (aux_17028);
			   }
			   {
			      kwote_cinfo_48_t new1723_7630;
			      new1723_7630 = ((kwote_cinfo_48_t) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
			      ((((kwote_cinfo_48_t) CREF(new1723_7630))->approx) = ((approx_t) approx_7629), BUNSPEC);
			      res3807_7632 = new1723_7630;
			   }
			}
			arg3522_4193 = res3807_7632;
		     }
		     {
			obj_t aux_17035;
			object_t aux_17033;
			aux_17035 = (obj_t) (arg3522_4193);
			aux_17033 = (object_t) (new1735_4191);
			OBJECT_WIDENING_SET(aux_17033, aux_17035);
		     }
		  }
		  aux_17010 = new1735_4191;
	       }
	    }
	 }
	 return (obj_t) (aux_17010);
      }
   }
}


/* object->struct-kwote/cinfo */ obj_t 
object__struct_kwote_cinfo_203_cfa_info(obj_t env_10434, obj_t obj1730_10435)
{
   {
      kwote_cinfo_48_t obj1730_4172;
      obj1730_4172 = (kwote_cinfo_48_t) (obj1730_10435);
      {
	 {
	    obj_t res1731_4175;
	    {
	       obj_t next_method2567_83_4183;
	       next_method2567_83_4183 = find_super_class_method_167___object((object_t) (obj1730_4172), object__struct_env_210___object, kwote_cinfo_48_cfa_info);
	       if (PROCEDUREP(next_method2567_83_4183))
		 {
		    res1731_4175 = PROCEDURE_ENTRY(next_method2567_83_4183) (next_method2567_83_4183, (obj_t) (obj1730_4172), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2567_83_4183);
		    res1731_4175 = object__struct_50___object((object_t) (obj1730_4172));
		 }
	    }
	    {
	       obj_t aux1732_4176;
	       {
		  obj_t aux_17050;
		  aux_17050 = CNST_TABLE_REF(((long) 13));
		  aux1732_4176 = make_struct(aux_17050, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17053;
		  {
		     approx_t aux_17054;
		     {
			obj_t aux_17055;
			{
			   object_t aux_17056;
			   aux_17056 = (object_t) (obj1730_4172);
			   aux_17055 = OBJECT_WIDENING(aux_17056);
			}
			aux_17054 = (((kwote_cinfo_48_t) CREF(aux_17055))->approx);
		     }
		     aux_17053 = (obj_t) (aux_17054);
		  }
		  STRUCT_SET(aux1732_4176, ((long) 0), aux_17053);
	       }
	       STRUCT_SET(res1731_4175, ((long) 0), aux1732_4176);
	       {
		  obj_t aux_17063;
		  aux_17063 = STRUCT_KEY(res1731_4175);
		  STRUCT_KEY_SET(aux1732_4176, aux_17063);
	       }
	       {
		  obj_t aux_17066;
		  aux_17066 = CNST_TABLE_REF(((long) 13));
		  STRUCT_KEY_SET(res1731_4175, aux_17066);
	       }
	       return res1731_4175;
	    }
	 }
      }
   }
}


/* struct+object->object-app-ly/cinfo */ obj_t 
struct_object__object_app_ly_cinfo_255_cfa_info(obj_t env_10436, obj_t o_10437, obj_t s_10438)
{
   {
      app_ly_cinfo_234_t o_4160;
      obj_t s_4161;
      {
	 app_ly_cinfo_234_t aux_17070;
	 o_4160 = (app_ly_cinfo_234_t) (o_10437);
	 s_4161 = s_10438;
	 {
	    {
	       obj_t old1748_4164;
	       obj_t aux1749_4165;
	       {
		  obj_t next_method2566_128_4170;
		  next_method2566_128_4170 = find_super_class_method_167___object((object_t) (o_4160), struct_object__object_env_209___object, app_ly_cinfo_234_cfa_info);
		  if (PROCEDUREP(next_method2566_128_4170))
		    {
		       old1748_4164 = PROCEDURE_ENTRY(next_method2566_128_4170) (next_method2566_128_4170, (obj_t) (o_4160), s_4161, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2566_128_4170);
		       {
			  object_t aux_17079;
			  aux_17079 = struct_object__object_93___object((object_t) (o_4160), s_4161);
			  old1748_4164 = (obj_t) (aux_17079);
		       }
		    }
	       }
	       aux1749_4165 = STRUCT_REF(s_4161, ((long) 0));
	       {
		  app_ly_cinfo_234_t new1750_4166;
		  new1750_4166 = ((app_ly_cinfo_234_t) (old1748_4164));
		  {
		     long arg3510_4167;
		     arg3510_4167 = class_num_218___object(app_ly_cinfo_234_cfa_info);
		     {
			obj_t obj_7596;
			obj_7596 = (obj_t) (new1750_4166);
			(((obj_t) CREF(obj_7596))->header = MAKE_HEADER(arg3510_4167, 0), BUNSPEC);
		     }
		  }
		  {
		     app_ly_cinfo_234_t arg3511_4168;
		     {
			app_ly_cinfo_234_t res3806_7603;
			{
			   approx_t approx_7600;
			   {
			      obj_t aux_17088;
			      aux_17088 = STRUCT_REF(aux1749_4165, ((long) 0));
			      approx_7600 = (approx_t) (aux_17088);
			   }
			   {
			      app_ly_cinfo_234_t new1736_7601;
			      new1736_7601 = ((app_ly_cinfo_234_t) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
			      ((((app_ly_cinfo_234_t) CREF(new1736_7601))->approx) = ((approx_t) approx_7600), BUNSPEC);
			      res3806_7603 = new1736_7601;
			   }
			}
			arg3511_4168 = res3806_7603;
		     }
		     {
			obj_t aux_17095;
			object_t aux_17093;
			aux_17095 = (obj_t) (arg3511_4168);
			aux_17093 = (object_t) (new1750_4166);
			OBJECT_WIDENING_SET(aux_17093, aux_17095);
		     }
		  }
		  aux_17070 = new1750_4166;
	       }
	    }
	 }
	 return (obj_t) (aux_17070);
      }
   }
}


/* object->struct-app-ly/cinfo */ obj_t 
object__struct_app_ly_cinfo_39_cfa_info(obj_t env_10439, obj_t obj1745_10440)
{
   {
      app_ly_cinfo_234_t obj1745_4147;
      obj1745_4147 = (app_ly_cinfo_234_t) (obj1745_10440);
      {
	 {
	    obj_t res1746_4150;
	    {
	       obj_t next_method2565_66_4158;
	       next_method2565_66_4158 = find_super_class_method_167___object((object_t) (obj1745_4147), object__struct_env_210___object, app_ly_cinfo_234_cfa_info);
	       if (PROCEDUREP(next_method2565_66_4158))
		 {
		    res1746_4150 = PROCEDURE_ENTRY(next_method2565_66_4158) (next_method2565_66_4158, (obj_t) (obj1745_4147), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2565_66_4158);
		    res1746_4150 = object__struct_50___object((object_t) (obj1745_4147));
		 }
	    }
	    {
	       obj_t aux1747_4151;
	       {
		  obj_t aux_17110;
		  aux_17110 = CNST_TABLE_REF(((long) 14));
		  aux1747_4151 = make_struct(aux_17110, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17113;
		  {
		     approx_t aux_17114;
		     {
			obj_t aux_17115;
			{
			   object_t aux_17116;
			   aux_17116 = (object_t) (obj1745_4147);
			   aux_17115 = OBJECT_WIDENING(aux_17116);
			}
			aux_17114 = (((app_ly_cinfo_234_t) CREF(aux_17115))->approx);
		     }
		     aux_17113 = (obj_t) (aux_17114);
		  }
		  STRUCT_SET(aux1747_4151, ((long) 0), aux_17113);
	       }
	       STRUCT_SET(res1746_4150, ((long) 0), aux1747_4151);
	       {
		  obj_t aux_17123;
		  aux_17123 = STRUCT_KEY(res1746_4150);
		  STRUCT_KEY_SET(aux1747_4151, aux_17123);
	       }
	       {
		  obj_t aux_17126;
		  aux_17126 = CNST_TABLE_REF(((long) 14));
		  STRUCT_KEY_SET(res1746_4150, aux_17126);
	       }
	       return res1746_4150;
	    }
	 }
      }
   }
}


/* struct+object->object-funcall/cinfo */ obj_t 
struct_object__object_funcall_cinfo_97_cfa_info(obj_t env_10441, obj_t o_10442, obj_t s_10443)
{
   {
      funcall_cinfo_75_t o_4132;
      obj_t s_4133;
      {
	 funcall_cinfo_75_t aux_17130;
	 o_4132 = (funcall_cinfo_75_t) (o_10442);
	 s_4133 = s_10443;
	 {
	    {
	       obj_t old1769_4136;
	       obj_t aux1770_4137;
	       {
		  obj_t next_method2564_60_4145;
		  next_method2564_60_4145 = find_super_class_method_167___object((object_t) (o_4132), struct_object__object_env_209___object, funcall_cinfo_75_cfa_info);
		  if (PROCEDUREP(next_method2564_60_4145))
		    {
		       old1769_4136 = PROCEDURE_ENTRY(next_method2564_60_4145) (next_method2564_60_4145, (obj_t) (o_4132), s_4133, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2564_60_4145);
		       {
			  object_t aux_17139;
			  aux_17139 = struct_object__object_93___object((object_t) (o_4132), s_4133);
			  old1769_4136 = (obj_t) (aux_17139);
		       }
		    }
	       }
	       aux1770_4137 = STRUCT_REF(s_4133, ((long) 0));
	       {
		  funcall_cinfo_75_t new1771_4138;
		  new1771_4138 = ((funcall_cinfo_75_t) (old1769_4136));
		  {
		     long arg3496_4139;
		     arg3496_4139 = class_num_218___object(funcall_cinfo_75_cfa_info);
		     {
			obj_t obj_7555;
			obj_7555 = (obj_t) (new1771_4138);
			(((obj_t) CREF(obj_7555))->header = MAKE_HEADER(arg3496_4139, 0), BUNSPEC);
		     }
		  }
		  {
		     funcall_cinfo_75_t arg3497_4140;
		     {
			funcall_cinfo_75_t res3805_7574;
			{
			   approx_t approx_7565;
			   approx_t va_approx_63_7566;
			   bool_t arity_error_noticed__118_7567;
			   bool_t type_error_noticed__36_7568;
			   {
			      obj_t aux_17148;
			      aux_17148 = STRUCT_REF(aux1770_4137, ((long) 0));
			      approx_7565 = (approx_t) (aux_17148);
			   }
			   {
			      obj_t aux_17151;
			      aux_17151 = STRUCT_REF(aux1770_4137, ((long) 1));
			      va_approx_63_7566 = (approx_t) (aux_17151);
			   }
			   {
			      obj_t aux_17154;
			      aux_17154 = STRUCT_REF(aux1770_4137, ((long) 2));
			      arity_error_noticed__118_7567 = CBOOL(aux_17154);
			   }
			   {
			      obj_t aux_17157;
			      aux_17157 = STRUCT_REF(aux1770_4137, ((long) 3));
			      type_error_noticed__36_7568 = CBOOL(aux_17157);
			   }
			   {
			      funcall_cinfo_75_t new1751_7569;
			      new1751_7569 = ((funcall_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
			      ((((funcall_cinfo_75_t) CREF(new1751_7569))->approx) = ((approx_t) approx_7565), BUNSPEC);
			      ((((funcall_cinfo_75_t) CREF(new1751_7569))->va_approx_63) = ((approx_t) va_approx_63_7566), BUNSPEC);
			      ((((funcall_cinfo_75_t) CREF(new1751_7569))->arity_error_noticed__118) = ((bool_t) arity_error_noticed__118_7567), BUNSPEC);
			      ((((funcall_cinfo_75_t) CREF(new1751_7569))->type_error_noticed__36) = ((bool_t) type_error_noticed__36_7568), BUNSPEC);
			      res3805_7574 = new1751_7569;
			   }
			}
			arg3497_4140 = res3805_7574;
		     }
		     {
			obj_t aux_17167;
			object_t aux_17165;
			aux_17167 = (obj_t) (arg3497_4140);
			aux_17165 = (object_t) (new1771_4138);
			OBJECT_WIDENING_SET(aux_17165, aux_17167);
		     }
		  }
		  aux_17130 = new1771_4138;
	       }
	    }
	 }
	 return (obj_t) (aux_17130);
      }
   }
}


/* object->struct-funcall/cinfo */ obj_t 
object__struct_funcall_cinfo_250_cfa_info(obj_t env_10444, obj_t obj1766_10445)
{
   {
      funcall_cinfo_75_t obj1766_4113;
      obj1766_4113 = (funcall_cinfo_75_t) (obj1766_10445);
      {
	 {
	    obj_t res1767_4116;
	    {
	       obj_t next_method2563_86_4130;
	       next_method2563_86_4130 = find_super_class_method_167___object((object_t) (obj1766_4113), object__struct_env_210___object, funcall_cinfo_75_cfa_info);
	       if (PROCEDUREP(next_method2563_86_4130))
		 {
		    res1767_4116 = PROCEDURE_ENTRY(next_method2563_86_4130) (next_method2563_86_4130, (obj_t) (obj1766_4113), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2563_86_4130);
		    res1767_4116 = object__struct_50___object((object_t) (obj1766_4113));
		 }
	    }
	    {
	       obj_t aux1768_4117;
	       {
		  obj_t aux_17182;
		  aux_17182 = CNST_TABLE_REF(((long) 15));
		  aux1768_4117 = make_struct(aux_17182, ((long) 4), BUNSPEC);
	       }
	       {
		  obj_t aux_17185;
		  {
		     approx_t aux_17186;
		     {
			obj_t aux_17187;
			{
			   object_t aux_17188;
			   aux_17188 = (object_t) (obj1766_4113);
			   aux_17187 = OBJECT_WIDENING(aux_17188);
			}
			aux_17186 = (((funcall_cinfo_75_t) CREF(aux_17187))->approx);
		     }
		     aux_17185 = (obj_t) (aux_17186);
		  }
		  STRUCT_SET(aux1768_4117, ((long) 0), aux_17185);
	       }
	       {
		  obj_t aux_17194;
		  {
		     approx_t aux_17195;
		     {
			obj_t aux_17196;
			{
			   object_t aux_17197;
			   aux_17197 = (object_t) (obj1766_4113);
			   aux_17196 = OBJECT_WIDENING(aux_17197);
			}
			aux_17195 = (((funcall_cinfo_75_t) CREF(aux_17196))->va_approx_63);
		     }
		     aux_17194 = (obj_t) (aux_17195);
		  }
		  STRUCT_SET(aux1768_4117, ((long) 1), aux_17194);
	       }
	       {
		  obj_t aux_17203;
		  {
		     bool_t aux_17204;
		     {
			obj_t aux_17205;
			{
			   object_t aux_17206;
			   aux_17206 = (object_t) (obj1766_4113);
			   aux_17205 = OBJECT_WIDENING(aux_17206);
			}
			aux_17204 = (((funcall_cinfo_75_t) CREF(aux_17205))->arity_error_noticed__118);
		     }
		     aux_17203 = BBOOL(aux_17204);
		  }
		  STRUCT_SET(aux1768_4117, ((long) 2), aux_17203);
	       }
	       {
		  obj_t aux_17212;
		  {
		     bool_t aux_17213;
		     {
			obj_t aux_17214;
			{
			   object_t aux_17215;
			   aux_17215 = (object_t) (obj1766_4113);
			   aux_17214 = OBJECT_WIDENING(aux_17215);
			}
			aux_17213 = (((funcall_cinfo_75_t) CREF(aux_17214))->type_error_noticed__36);
		     }
		     aux_17212 = BBOOL(aux_17213);
		  }
		  STRUCT_SET(aux1768_4117, ((long) 3), aux_17212);
	       }
	       STRUCT_SET(res1767_4116, ((long) 0), aux1768_4117);
	       {
		  obj_t aux_17222;
		  aux_17222 = STRUCT_KEY(res1767_4116);
		  STRUCT_KEY_SET(aux1768_4117, aux_17222);
	       }
	       {
		  obj_t aux_17225;
		  aux_17225 = CNST_TABLE_REF(((long) 15));
		  STRUCT_KEY_SET(res1767_4116, aux_17225);
	       }
	       return res1767_4116;
	    }
	 }
      }
   }
}


/* struct+object->object-pragma/cinfo */ obj_t 
struct_object__object_pragma_cinfo_100_cfa_info(obj_t env_10446, obj_t o_10447, obj_t s_10448)
{
   {
      pragma_cinfo_220_t o_4101;
      obj_t s_4102;
      {
	 pragma_cinfo_220_t aux_17229;
	 o_4101 = (pragma_cinfo_220_t) (o_10447);
	 s_4102 = s_10448;
	 {
	    {
	       obj_t old1785_4105;
	       obj_t aux1786_4106;
	       {
		  obj_t next_method2562_141_4111;
		  next_method2562_141_4111 = find_super_class_method_167___object((object_t) (o_4101), struct_object__object_env_209___object, pragma_cinfo_220_cfa_info);
		  if (PROCEDUREP(next_method2562_141_4111))
		    {
		       old1785_4105 = PROCEDURE_ENTRY(next_method2562_141_4111) (next_method2562_141_4111, (obj_t) (o_4101), s_4102, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2562_141_4111);
		       {
			  object_t aux_17238;
			  aux_17238 = struct_object__object_93___object((object_t) (o_4101), s_4102);
			  old1785_4105 = (obj_t) (aux_17238);
		       }
		    }
	       }
	       aux1786_4106 = STRUCT_REF(s_4102, ((long) 0));
	       {
		  pragma_cinfo_220_t new1787_4107;
		  new1787_4107 = ((pragma_cinfo_220_t) (old1785_4105));
		  {
		     long arg3479_4108;
		     arg3479_4108 = class_num_218___object(pragma_cinfo_220_cfa_info);
		     {
			obj_t obj_7514;
			obj_7514 = (obj_t) (new1787_4107);
			(((obj_t) CREF(obj_7514))->header = MAKE_HEADER(arg3479_4108, 0), BUNSPEC);
		     }
		  }
		  {
		     pragma_cinfo_220_t arg3480_4109;
		     {
			pragma_cinfo_220_t res3804_7521;
			{
			   approx_t approx_7518;
			   {
			      obj_t aux_17247;
			      aux_17247 = STRUCT_REF(aux1786_4106, ((long) 0));
			      approx_7518 = (approx_t) (aux_17247);
			   }
			   {
			      pragma_cinfo_220_t new1772_7519;
			      new1772_7519 = ((pragma_cinfo_220_t) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
			      ((((pragma_cinfo_220_t) CREF(new1772_7519))->approx) = ((approx_t) approx_7518), BUNSPEC);
			      res3804_7521 = new1772_7519;
			   }
			}
			arg3480_4109 = res3804_7521;
		     }
		     {
			obj_t aux_17254;
			object_t aux_17252;
			aux_17254 = (obj_t) (arg3480_4109);
			aux_17252 = (object_t) (new1787_4107);
			OBJECT_WIDENING_SET(aux_17252, aux_17254);
		     }
		  }
		  aux_17229 = new1787_4107;
	       }
	    }
	 }
	 return (obj_t) (aux_17229);
      }
   }
}


/* object->struct-pragma/cinfo */ obj_t 
object__struct_pragma_cinfo_175_cfa_info(obj_t env_10449, obj_t obj1782_10450)
{
   {
      pragma_cinfo_220_t obj1782_4088;
      obj1782_4088 = (pragma_cinfo_220_t) (obj1782_10450);
      {
	 {
	    obj_t res1783_4091;
	    {
	       obj_t next_method2561_161_4099;
	       next_method2561_161_4099 = find_super_class_method_167___object((object_t) (obj1782_4088), object__struct_env_210___object, pragma_cinfo_220_cfa_info);
	       if (PROCEDUREP(next_method2561_161_4099))
		 {
		    res1783_4091 = PROCEDURE_ENTRY(next_method2561_161_4099) (next_method2561_161_4099, (obj_t) (obj1782_4088), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2561_161_4099);
		    res1783_4091 = object__struct_50___object((object_t) (obj1782_4088));
		 }
	    }
	    {
	       obj_t aux1784_4092;
	       {
		  obj_t aux_17269;
		  aux_17269 = CNST_TABLE_REF(((long) 16));
		  aux1784_4092 = make_struct(aux_17269, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17272;
		  {
		     approx_t aux_17273;
		     {
			obj_t aux_17274;
			{
			   object_t aux_17275;
			   aux_17275 = (object_t) (obj1782_4088);
			   aux_17274 = OBJECT_WIDENING(aux_17275);
			}
			aux_17273 = (((pragma_cinfo_220_t) CREF(aux_17274))->approx);
		     }
		     aux_17272 = (obj_t) (aux_17273);
		  }
		  STRUCT_SET(aux1784_4092, ((long) 0), aux_17272);
	       }
	       STRUCT_SET(res1783_4091, ((long) 0), aux1784_4092);
	       {
		  obj_t aux_17282;
		  aux_17282 = STRUCT_KEY(res1783_4091);
		  STRUCT_KEY_SET(aux1784_4092, aux_17282);
	       }
	       {
		  obj_t aux_17285;
		  aux_17285 = CNST_TABLE_REF(((long) 16));
		  STRUCT_KEY_SET(res1783_4091, aux_17285);
	       }
	       return res1783_4091;
	    }
	 }
      }
   }
}


/* struct+object->object-setq/cinfo */ obj_t 
struct_object__object_setq_cinfo_26_cfa_info(obj_t env_10451, obj_t o_10452, obj_t s_10453)
{
   {
      setq_cinfo_191_t o_4076;
      obj_t s_4077;
      {
	 setq_cinfo_191_t aux_17289;
	 o_4076 = (setq_cinfo_191_t) (o_10452);
	 s_4077 = s_10453;
	 {
	    {
	       obj_t old1800_4080;
	       obj_t aux1801_4081;
	       {
		  obj_t next_method2560_176_4086;
		  next_method2560_176_4086 = find_super_class_method_167___object((object_t) (o_4076), struct_object__object_env_209___object, setq_cinfo_191_cfa_info);
		  if (PROCEDUREP(next_method2560_176_4086))
		    {
		       old1800_4080 = PROCEDURE_ENTRY(next_method2560_176_4086) (next_method2560_176_4086, (obj_t) (o_4076), s_4077, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2560_176_4086);
		       {
			  object_t aux_17298;
			  aux_17298 = struct_object__object_93___object((object_t) (o_4076), s_4077);
			  old1800_4080 = (obj_t) (aux_17298);
		       }
		    }
	       }
	       aux1801_4081 = STRUCT_REF(s_4077, ((long) 0));
	       {
		  setq_cinfo_191_t new1802_4082;
		  new1802_4082 = ((setq_cinfo_191_t) (old1800_4080));
		  {
		     long arg3468_4083;
		     arg3468_4083 = class_num_218___object(setq_cinfo_191_cfa_info);
		     {
			obj_t obj_7485;
			obj_7485 = (obj_t) (new1802_4082);
			(((obj_t) CREF(obj_7485))->header = MAKE_HEADER(arg3468_4083, 0), BUNSPEC);
		     }
		  }
		  {
		     setq_cinfo_191_t arg3469_4084;
		     {
			setq_cinfo_191_t res3803_7492;
			{
			   approx_t approx_7489;
			   {
			      obj_t aux_17307;
			      aux_17307 = STRUCT_REF(aux1801_4081, ((long) 0));
			      approx_7489 = (approx_t) (aux_17307);
			   }
			   {
			      setq_cinfo_191_t new1788_7490;
			      new1788_7490 = ((setq_cinfo_191_t) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
			      ((((setq_cinfo_191_t) CREF(new1788_7490))->approx) = ((approx_t) approx_7489), BUNSPEC);
			      res3803_7492 = new1788_7490;
			   }
			}
			arg3469_4084 = res3803_7492;
		     }
		     {
			obj_t aux_17314;
			object_t aux_17312;
			aux_17314 = (obj_t) (arg3469_4084);
			aux_17312 = (object_t) (new1802_4082);
			OBJECT_WIDENING_SET(aux_17312, aux_17314);
		     }
		  }
		  aux_17289 = new1802_4082;
	       }
	    }
	 }
	 return (obj_t) (aux_17289);
      }
   }
}


/* object->struct-setq/cinfo */ obj_t 
object__struct_setq_cinfo_111_cfa_info(obj_t env_10454, obj_t obj1797_10455)
{
   {
      setq_cinfo_191_t obj1797_4063;
      obj1797_4063 = (setq_cinfo_191_t) (obj1797_10455);
      {
	 {
	    obj_t res1798_4066;
	    {
	       obj_t next_method2559_67_4074;
	       next_method2559_67_4074 = find_super_class_method_167___object((object_t) (obj1797_4063), object__struct_env_210___object, setq_cinfo_191_cfa_info);
	       if (PROCEDUREP(next_method2559_67_4074))
		 {
		    res1798_4066 = PROCEDURE_ENTRY(next_method2559_67_4074) (next_method2559_67_4074, (obj_t) (obj1797_4063), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2559_67_4074);
		    res1798_4066 = object__struct_50___object((object_t) (obj1797_4063));
		 }
	    }
	    {
	       obj_t aux1799_4067;
	       {
		  obj_t aux_17329;
		  aux_17329 = CNST_TABLE_REF(((long) 17));
		  aux1799_4067 = make_struct(aux_17329, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17332;
		  {
		     approx_t aux_17333;
		     {
			obj_t aux_17334;
			{
			   object_t aux_17335;
			   aux_17335 = (object_t) (obj1797_4063);
			   aux_17334 = OBJECT_WIDENING(aux_17335);
			}
			aux_17333 = (((setq_cinfo_191_t) CREF(aux_17334))->approx);
		     }
		     aux_17332 = (obj_t) (aux_17333);
		  }
		  STRUCT_SET(aux1799_4067, ((long) 0), aux_17332);
	       }
	       STRUCT_SET(res1798_4066, ((long) 0), aux1799_4067);
	       {
		  obj_t aux_17342;
		  aux_17342 = STRUCT_KEY(res1798_4066);
		  STRUCT_KEY_SET(aux1799_4067, aux_17342);
	       }
	       {
		  obj_t aux_17345;
		  aux_17345 = CNST_TABLE_REF(((long) 17));
		  STRUCT_KEY_SET(res1798_4066, aux_17345);
	       }
	       return res1798_4066;
	    }
	 }
      }
   }
}


/* struct+object->object-conditional/cinfo */ obj_t 
struct_object__object_conditional_cinfo_141_cfa_info(obj_t env_10456, obj_t o_10457, obj_t s_10458)
{
   {
      conditional_cinfo_212_t o_4051;
      obj_t s_4052;
      {
	 conditional_cinfo_212_t aux_17349;
	 o_4051 = (conditional_cinfo_212_t) (o_10457);
	 s_4052 = s_10458;
	 {
	    {
	       obj_t old1818_4055;
	       obj_t aux1819_4056;
	       {
		  obj_t next_method2558_186_4061;
		  next_method2558_186_4061 = find_super_class_method_167___object((object_t) (o_4051), struct_object__object_env_209___object, conditional_cinfo_212_cfa_info);
		  if (PROCEDUREP(next_method2558_186_4061))
		    {
		       old1818_4055 = PROCEDURE_ENTRY(next_method2558_186_4061) (next_method2558_186_4061, (obj_t) (o_4051), s_4052, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2558_186_4061);
		       {
			  object_t aux_17358;
			  aux_17358 = struct_object__object_93___object((object_t) (o_4051), s_4052);
			  old1818_4055 = (obj_t) (aux_17358);
		       }
		    }
	       }
	       aux1819_4056 = STRUCT_REF(s_4052, ((long) 0));
	       {
		  conditional_cinfo_212_t new1820_4057;
		  new1820_4057 = ((conditional_cinfo_212_t) (old1818_4055));
		  {
		     long arg3457_4058;
		     arg3457_4058 = class_num_218___object(conditional_cinfo_212_cfa_info);
		     {
			obj_t obj_7456;
			obj_7456 = (obj_t) (new1820_4057);
			(((obj_t) CREF(obj_7456))->header = MAKE_HEADER(arg3457_4058, 0), BUNSPEC);
		     }
		  }
		  {
		     conditional_cinfo_212_t arg3458_4059;
		     {
			conditional_cinfo_212_t res3802_7463;
			{
			   approx_t approx_7460;
			   {
			      obj_t aux_17367;
			      aux_17367 = STRUCT_REF(aux1819_4056, ((long) 0));
			      approx_7460 = (approx_t) (aux_17367);
			   }
			   {
			      conditional_cinfo_212_t new1803_7461;
			      new1803_7461 = ((conditional_cinfo_212_t) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
			      ((((conditional_cinfo_212_t) CREF(new1803_7461))->approx) = ((approx_t) approx_7460), BUNSPEC);
			      res3802_7463 = new1803_7461;
			   }
			}
			arg3458_4059 = res3802_7463;
		     }
		     {
			obj_t aux_17374;
			object_t aux_17372;
			aux_17374 = (obj_t) (arg3458_4059);
			aux_17372 = (object_t) (new1820_4057);
			OBJECT_WIDENING_SET(aux_17372, aux_17374);
		     }
		  }
		  aux_17349 = new1820_4057;
	       }
	    }
	 }
	 return (obj_t) (aux_17349);
      }
   }
}


/* object->struct-conditional/cinfo */ obj_t 
object__struct_conditional_cinfo_223_cfa_info(obj_t env_10459, obj_t obj1815_10460)
{
   {
      conditional_cinfo_212_t obj1815_4038;
      obj1815_4038 = (conditional_cinfo_212_t) (obj1815_10460);
      {
	 {
	    obj_t res1816_4041;
	    {
	       obj_t next_method2557_104_4049;
	       next_method2557_104_4049 = find_super_class_method_167___object((object_t) (obj1815_4038), object__struct_env_210___object, conditional_cinfo_212_cfa_info);
	       if (PROCEDUREP(next_method2557_104_4049))
		 {
		    res1816_4041 = PROCEDURE_ENTRY(next_method2557_104_4049) (next_method2557_104_4049, (obj_t) (obj1815_4038), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2557_104_4049);
		    res1816_4041 = object__struct_50___object((object_t) (obj1815_4038));
		 }
	    }
	    {
	       obj_t aux1817_4042;
	       {
		  obj_t aux_17389;
		  aux_17389 = CNST_TABLE_REF(((long) 18));
		  aux1817_4042 = make_struct(aux_17389, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17392;
		  {
		     approx_t aux_17393;
		     {
			obj_t aux_17394;
			{
			   object_t aux_17395;
			   aux_17395 = (object_t) (obj1815_4038);
			   aux_17394 = OBJECT_WIDENING(aux_17395);
			}
			aux_17393 = (((conditional_cinfo_212_t) CREF(aux_17394))->approx);
		     }
		     aux_17392 = (obj_t) (aux_17393);
		  }
		  STRUCT_SET(aux1817_4042, ((long) 0), aux_17392);
	       }
	       STRUCT_SET(res1816_4041, ((long) 0), aux1817_4042);
	       {
		  obj_t aux_17402;
		  aux_17402 = STRUCT_KEY(res1816_4041);
		  STRUCT_KEY_SET(aux1817_4042, aux_17402);
	       }
	       {
		  obj_t aux_17405;
		  aux_17405 = CNST_TABLE_REF(((long) 18));
		  STRUCT_KEY_SET(res1816_4041, aux_17405);
	       }
	       return res1816_4041;
	    }
	 }
      }
   }
}


/* struct+object->object-fail/cinfo */ obj_t 
struct_object__object_fail_cinfo_67_cfa_info(obj_t env_10461, obj_t o_10462, obj_t s_10463)
{
   {
      fail_cinfo_75_t o_4026;
      obj_t s_4027;
      {
	 fail_cinfo_75_t aux_17409;
	 o_4026 = (fail_cinfo_75_t) (o_10462);
	 s_4027 = s_10463;
	 {
	    {
	       obj_t old1834_4030;
	       obj_t aux1835_4031;
	       {
		  obj_t next_method2556_190_4036;
		  next_method2556_190_4036 = find_super_class_method_167___object((object_t) (o_4026), struct_object__object_env_209___object, fail_cinfo_75_cfa_info);
		  if (PROCEDUREP(next_method2556_190_4036))
		    {
		       old1834_4030 = PROCEDURE_ENTRY(next_method2556_190_4036) (next_method2556_190_4036, (obj_t) (o_4026), s_4027, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2556_190_4036);
		       {
			  object_t aux_17418;
			  aux_17418 = struct_object__object_93___object((object_t) (o_4026), s_4027);
			  old1834_4030 = (obj_t) (aux_17418);
		       }
		    }
	       }
	       aux1835_4031 = STRUCT_REF(s_4027, ((long) 0));
	       {
		  fail_cinfo_75_t new1836_4032;
		  new1836_4032 = ((fail_cinfo_75_t) (old1834_4030));
		  {
		     long arg3446_4033;
		     arg3446_4033 = class_num_218___object(fail_cinfo_75_cfa_info);
		     {
			obj_t obj_7427;
			obj_7427 = (obj_t) (new1836_4032);
			(((obj_t) CREF(obj_7427))->header = MAKE_HEADER(arg3446_4033, 0), BUNSPEC);
		     }
		  }
		  {
		     fail_cinfo_75_t arg3447_4034;
		     {
			fail_cinfo_75_t res3801_7434;
			{
			   approx_t approx_7431;
			   {
			      obj_t aux_17427;
			      aux_17427 = STRUCT_REF(aux1835_4031, ((long) 0));
			      approx_7431 = (approx_t) (aux_17427);
			   }
			   {
			      fail_cinfo_75_t new1821_7432;
			      new1821_7432 = ((fail_cinfo_75_t) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
			      ((((fail_cinfo_75_t) CREF(new1821_7432))->approx) = ((approx_t) approx_7431), BUNSPEC);
			      res3801_7434 = new1821_7432;
			   }
			}
			arg3447_4034 = res3801_7434;
		     }
		     {
			obj_t aux_17434;
			object_t aux_17432;
			aux_17434 = (obj_t) (arg3447_4034);
			aux_17432 = (object_t) (new1836_4032);
			OBJECT_WIDENING_SET(aux_17432, aux_17434);
		     }
		  }
		  aux_17409 = new1836_4032;
	       }
	    }
	 }
	 return (obj_t) (aux_17409);
      }
   }
}


/* object->struct-fail/cinfo */ obj_t 
object__struct_fail_cinfo_130_cfa_info(obj_t env_10464, obj_t obj1831_10465)
{
   {
      fail_cinfo_75_t obj1831_4013;
      obj1831_4013 = (fail_cinfo_75_t) (obj1831_10465);
      {
	 {
	    obj_t res1832_4016;
	    {
	       obj_t next_method2555_49_4024;
	       next_method2555_49_4024 = find_super_class_method_167___object((object_t) (obj1831_4013), object__struct_env_210___object, fail_cinfo_75_cfa_info);
	       if (PROCEDUREP(next_method2555_49_4024))
		 {
		    res1832_4016 = PROCEDURE_ENTRY(next_method2555_49_4024) (next_method2555_49_4024, (obj_t) (obj1831_4013), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2555_49_4024);
		    res1832_4016 = object__struct_50___object((object_t) (obj1831_4013));
		 }
	    }
	    {
	       obj_t aux1833_4017;
	       {
		  obj_t aux_17449;
		  aux_17449 = CNST_TABLE_REF(((long) 19));
		  aux1833_4017 = make_struct(aux_17449, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17452;
		  {
		     approx_t aux_17453;
		     {
			obj_t aux_17454;
			{
			   object_t aux_17455;
			   aux_17455 = (object_t) (obj1831_4013);
			   aux_17454 = OBJECT_WIDENING(aux_17455);
			}
			aux_17453 = (((fail_cinfo_75_t) CREF(aux_17454))->approx);
		     }
		     aux_17452 = (obj_t) (aux_17453);
		  }
		  STRUCT_SET(aux1833_4017, ((long) 0), aux_17452);
	       }
	       STRUCT_SET(res1832_4016, ((long) 0), aux1833_4017);
	       {
		  obj_t aux_17462;
		  aux_17462 = STRUCT_KEY(res1832_4016);
		  STRUCT_KEY_SET(aux1833_4017, aux_17462);
	       }
	       {
		  obj_t aux_17465;
		  aux_17465 = CNST_TABLE_REF(((long) 19));
		  STRUCT_KEY_SET(res1832_4016, aux_17465);
	       }
	       return res1832_4016;
	    }
	 }
      }
   }
}


/* struct+object->object-select/cinfo */ obj_t 
struct_object__object_select_cinfo_79_cfa_info(obj_t env_10466, obj_t o_10467, obj_t s_10468)
{
   {
      select_cinfo_150_t o_4001;
      obj_t s_4002;
      {
	 select_cinfo_150_t aux_17469;
	 o_4001 = (select_cinfo_150_t) (o_10467);
	 s_4002 = s_10468;
	 {
	    {
	       obj_t old1850_4005;
	       obj_t aux1851_4006;
	       {
		  obj_t next_method2554_213_4011;
		  next_method2554_213_4011 = find_super_class_method_167___object((object_t) (o_4001), struct_object__object_env_209___object, select_cinfo_150_cfa_info);
		  if (PROCEDUREP(next_method2554_213_4011))
		    {
		       old1850_4005 = PROCEDURE_ENTRY(next_method2554_213_4011) (next_method2554_213_4011, (obj_t) (o_4001), s_4002, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2554_213_4011);
		       {
			  object_t aux_17478;
			  aux_17478 = struct_object__object_93___object((object_t) (o_4001), s_4002);
			  old1850_4005 = (obj_t) (aux_17478);
		       }
		    }
	       }
	       aux1851_4006 = STRUCT_REF(s_4002, ((long) 0));
	       {
		  select_cinfo_150_t new1852_4007;
		  new1852_4007 = ((select_cinfo_150_t) (old1850_4005));
		  {
		     long arg3435_4008;
		     arg3435_4008 = class_num_218___object(select_cinfo_150_cfa_info);
		     {
			obj_t obj_7398;
			obj_7398 = (obj_t) (new1852_4007);
			(((obj_t) CREF(obj_7398))->header = MAKE_HEADER(arg3435_4008, 0), BUNSPEC);
		     }
		  }
		  {
		     select_cinfo_150_t arg3436_4009;
		     {
			select_cinfo_150_t res3800_7405;
			{
			   approx_t approx_7402;
			   {
			      obj_t aux_17487;
			      aux_17487 = STRUCT_REF(aux1851_4006, ((long) 0));
			      approx_7402 = (approx_t) (aux_17487);
			   }
			   {
			      select_cinfo_150_t new1837_7403;
			      new1837_7403 = ((select_cinfo_150_t) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
			      ((((select_cinfo_150_t) CREF(new1837_7403))->approx) = ((approx_t) approx_7402), BUNSPEC);
			      res3800_7405 = new1837_7403;
			   }
			}
			arg3436_4009 = res3800_7405;
		     }
		     {
			obj_t aux_17494;
			object_t aux_17492;
			aux_17494 = (obj_t) (arg3436_4009);
			aux_17492 = (object_t) (new1852_4007);
			OBJECT_WIDENING_SET(aux_17492, aux_17494);
		     }
		  }
		  aux_17469 = new1852_4007;
	       }
	    }
	 }
	 return (obj_t) (aux_17469);
      }
   }
}


/* object->struct-select/cinfo */ obj_t 
object__struct_select_cinfo_146_cfa_info(obj_t env_10469, obj_t obj1847_10470)
{
   {
      select_cinfo_150_t obj1847_3988;
      obj1847_3988 = (select_cinfo_150_t) (obj1847_10470);
      {
	 {
	    obj_t res1848_3991;
	    {
	       obj_t next_method2553_148_3999;
	       next_method2553_148_3999 = find_super_class_method_167___object((object_t) (obj1847_3988), object__struct_env_210___object, select_cinfo_150_cfa_info);
	       if (PROCEDUREP(next_method2553_148_3999))
		 {
		    res1848_3991 = PROCEDURE_ENTRY(next_method2553_148_3999) (next_method2553_148_3999, (obj_t) (obj1847_3988), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2553_148_3999);
		    res1848_3991 = object__struct_50___object((object_t) (obj1847_3988));
		 }
	    }
	    {
	       obj_t aux1849_3992;
	       {
		  obj_t aux_17509;
		  aux_17509 = CNST_TABLE_REF(((long) 20));
		  aux1849_3992 = make_struct(aux_17509, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17512;
		  {
		     approx_t aux_17513;
		     {
			obj_t aux_17514;
			{
			   object_t aux_17515;
			   aux_17515 = (object_t) (obj1847_3988);
			   aux_17514 = OBJECT_WIDENING(aux_17515);
			}
			aux_17513 = (((select_cinfo_150_t) CREF(aux_17514))->approx);
		     }
		     aux_17512 = (obj_t) (aux_17513);
		  }
		  STRUCT_SET(aux1849_3992, ((long) 0), aux_17512);
	       }
	       STRUCT_SET(res1848_3991, ((long) 0), aux1849_3992);
	       {
		  obj_t aux_17522;
		  aux_17522 = STRUCT_KEY(res1848_3991);
		  STRUCT_KEY_SET(aux1849_3992, aux_17522);
	       }
	       {
		  obj_t aux_17525;
		  aux_17525 = CNST_TABLE_REF(((long) 20));
		  STRUCT_KEY_SET(res1848_3991, aux_17525);
	       }
	       return res1848_3991;
	    }
	 }
      }
   }
}


/* struct+object->object-set-ex-it/cinfo */ obj_t 
struct_object__object_set_ex_it_cinfo_254_cfa_info(obj_t env_10471, obj_t o_10472, obj_t s_10473)
{
   {
      set_ex_it_cinfo_168_t o_3976;
      obj_t s_3977;
      {
	 set_ex_it_cinfo_168_t aux_17529;
	 o_3976 = (set_ex_it_cinfo_168_t) (o_10472);
	 s_3977 = s_10473;
	 {
	    {
	       obj_t old1865_3980;
	       obj_t aux1866_3981;
	       {
		  obj_t next_method2552_223_3986;
		  next_method2552_223_3986 = find_super_class_method_167___object((object_t) (o_3976), struct_object__object_env_209___object, set_ex_it_cinfo_168_cfa_info);
		  if (PROCEDUREP(next_method2552_223_3986))
		    {
		       old1865_3980 = PROCEDURE_ENTRY(next_method2552_223_3986) (next_method2552_223_3986, (obj_t) (o_3976), s_3977, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2552_223_3986);
		       {
			  object_t aux_17538;
			  aux_17538 = struct_object__object_93___object((object_t) (o_3976), s_3977);
			  old1865_3980 = (obj_t) (aux_17538);
		       }
		    }
	       }
	       aux1866_3981 = STRUCT_REF(s_3977, ((long) 0));
	       {
		  set_ex_it_cinfo_168_t new1867_3982;
		  new1867_3982 = ((set_ex_it_cinfo_168_t) (old1865_3980));
		  {
		     long arg3424_3983;
		     arg3424_3983 = class_num_218___object(set_ex_it_cinfo_168_cfa_info);
		     {
			obj_t obj_7369;
			obj_7369 = (obj_t) (new1867_3982);
			(((obj_t) CREF(obj_7369))->header = MAKE_HEADER(arg3424_3983, 0), BUNSPEC);
		     }
		  }
		  {
		     set_ex_it_cinfo_168_t arg3425_3984;
		     {
			set_ex_it_cinfo_168_t res3799_7376;
			{
			   approx_t approx_7373;
			   {
			      obj_t aux_17547;
			      aux_17547 = STRUCT_REF(aux1866_3981, ((long) 0));
			      approx_7373 = (approx_t) (aux_17547);
			   }
			   {
			      set_ex_it_cinfo_168_t new1853_7374;
			      new1853_7374 = ((set_ex_it_cinfo_168_t) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
			      ((((set_ex_it_cinfo_168_t) CREF(new1853_7374))->approx) = ((approx_t) approx_7373), BUNSPEC);
			      res3799_7376 = new1853_7374;
			   }
			}
			arg3425_3984 = res3799_7376;
		     }
		     {
			obj_t aux_17554;
			object_t aux_17552;
			aux_17554 = (obj_t) (arg3425_3984);
			aux_17552 = (object_t) (new1867_3982);
			OBJECT_WIDENING_SET(aux_17552, aux_17554);
		     }
		  }
		  aux_17529 = new1867_3982;
	       }
	    }
	 }
	 return (obj_t) (aux_17529);
      }
   }
}


/* object->struct-set-ex-it/cinfo */ obj_t 
object__struct_set_ex_it_cinfo_216_cfa_info(obj_t env_10474, obj_t obj1862_10475)
{
   {
      set_ex_it_cinfo_168_t obj1862_3963;
      obj1862_3963 = (set_ex_it_cinfo_168_t) (obj1862_10475);
      {
	 {
	    obj_t res1863_3966;
	    {
	       obj_t next_method2551_57_3974;
	       next_method2551_57_3974 = find_super_class_method_167___object((object_t) (obj1862_3963), object__struct_env_210___object, set_ex_it_cinfo_168_cfa_info);
	       if (PROCEDUREP(next_method2551_57_3974))
		 {
		    res1863_3966 = PROCEDURE_ENTRY(next_method2551_57_3974) (next_method2551_57_3974, (obj_t) (obj1862_3963), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2551_57_3974);
		    res1863_3966 = object__struct_50___object((object_t) (obj1862_3963));
		 }
	    }
	    {
	       obj_t aux1864_3967;
	       {
		  obj_t aux_17569;
		  aux_17569 = CNST_TABLE_REF(((long) 21));
		  aux1864_3967 = make_struct(aux_17569, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17572;
		  {
		     approx_t aux_17573;
		     {
			obj_t aux_17574;
			{
			   object_t aux_17575;
			   aux_17575 = (object_t) (obj1862_3963);
			   aux_17574 = OBJECT_WIDENING(aux_17575);
			}
			aux_17573 = (((set_ex_it_cinfo_168_t) CREF(aux_17574))->approx);
		     }
		     aux_17572 = (obj_t) (aux_17573);
		  }
		  STRUCT_SET(aux1864_3967, ((long) 0), aux_17572);
	       }
	       STRUCT_SET(res1863_3966, ((long) 0), aux1864_3967);
	       {
		  obj_t aux_17582;
		  aux_17582 = STRUCT_KEY(res1863_3966);
		  STRUCT_KEY_SET(aux1864_3967, aux_17582);
	       }
	       {
		  obj_t aux_17585;
		  aux_17585 = CNST_TABLE_REF(((long) 21));
		  STRUCT_KEY_SET(res1863_3966, aux_17585);
	       }
	       return res1863_3966;
	    }
	 }
      }
   }
}


/* struct+object->object-jump-ex-it/cinfo */ obj_t 
struct_object__object_jump_ex_it_cinfo_82_cfa_info(obj_t env_10476, obj_t o_10477, obj_t s_10478)
{
   {
      jump_ex_it_cinfo_139_t o_3951;
      obj_t s_3952;
      {
	 jump_ex_it_cinfo_139_t aux_17589;
	 o_3951 = (jump_ex_it_cinfo_139_t) (o_10477);
	 s_3952 = s_10478;
	 {
	    {
	       obj_t old1880_3955;
	       obj_t aux1881_3956;
	       {
		  obj_t next_method2550_211_3961;
		  next_method2550_211_3961 = find_super_class_method_167___object((object_t) (o_3951), struct_object__object_env_209___object, jump_ex_it_cinfo_139_cfa_info);
		  if (PROCEDUREP(next_method2550_211_3961))
		    {
		       old1880_3955 = PROCEDURE_ENTRY(next_method2550_211_3961) (next_method2550_211_3961, (obj_t) (o_3951), s_3952, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2550_211_3961);
		       {
			  object_t aux_17598;
			  aux_17598 = struct_object__object_93___object((object_t) (o_3951), s_3952);
			  old1880_3955 = (obj_t) (aux_17598);
		       }
		    }
	       }
	       aux1881_3956 = STRUCT_REF(s_3952, ((long) 0));
	       {
		  jump_ex_it_cinfo_139_t new1882_3957;
		  new1882_3957 = ((jump_ex_it_cinfo_139_t) (old1880_3955));
		  {
		     long arg3413_3958;
		     arg3413_3958 = class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
		     {
			obj_t obj_7340;
			obj_7340 = (obj_t) (new1882_3957);
			(((obj_t) CREF(obj_7340))->header = MAKE_HEADER(arg3413_3958, 0), BUNSPEC);
		     }
		  }
		  {
		     jump_ex_it_cinfo_139_t arg3414_3959;
		     {
			jump_ex_it_cinfo_139_t res3798_7347;
			{
			   approx_t approx_7344;
			   {
			      obj_t aux_17607;
			      aux_17607 = STRUCT_REF(aux1881_3956, ((long) 0));
			      approx_7344 = (approx_t) (aux_17607);
			   }
			   {
			      jump_ex_it_cinfo_139_t new1868_7345;
			      new1868_7345 = ((jump_ex_it_cinfo_139_t) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
			      ((((jump_ex_it_cinfo_139_t) CREF(new1868_7345))->approx) = ((approx_t) approx_7344), BUNSPEC);
			      res3798_7347 = new1868_7345;
			   }
			}
			arg3414_3959 = res3798_7347;
		     }
		     {
			obj_t aux_17614;
			object_t aux_17612;
			aux_17614 = (obj_t) (arg3414_3959);
			aux_17612 = (object_t) (new1882_3957);
			OBJECT_WIDENING_SET(aux_17612, aux_17614);
		     }
		  }
		  aux_17589 = new1882_3957;
	       }
	    }
	 }
	 return (obj_t) (aux_17589);
      }
   }
}


/* object->struct-jump-ex-it/cinfo */ obj_t 
object__struct_jump_ex_it_cinfo_111_cfa_info(obj_t env_10479, obj_t obj1877_10480)
{
   {
      jump_ex_it_cinfo_139_t obj1877_3938;
      obj1877_3938 = (jump_ex_it_cinfo_139_t) (obj1877_10480);
      {
	 {
	    obj_t res1878_3941;
	    {
	       obj_t next_method2549_116_3949;
	       next_method2549_116_3949 = find_super_class_method_167___object((object_t) (obj1877_3938), object__struct_env_210___object, jump_ex_it_cinfo_139_cfa_info);
	       if (PROCEDUREP(next_method2549_116_3949))
		 {
		    res1878_3941 = PROCEDURE_ENTRY(next_method2549_116_3949) (next_method2549_116_3949, (obj_t) (obj1877_3938), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2549_116_3949);
		    res1878_3941 = object__struct_50___object((object_t) (obj1877_3938));
		 }
	    }
	    {
	       obj_t aux1879_3942;
	       {
		  obj_t aux_17629;
		  aux_17629 = CNST_TABLE_REF(((long) 22));
		  aux1879_3942 = make_struct(aux_17629, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17632;
		  {
		     approx_t aux_17633;
		     {
			obj_t aux_17634;
			{
			   object_t aux_17635;
			   aux_17635 = (object_t) (obj1877_3938);
			   aux_17634 = OBJECT_WIDENING(aux_17635);
			}
			aux_17633 = (((jump_ex_it_cinfo_139_t) CREF(aux_17634))->approx);
		     }
		     aux_17632 = (obj_t) (aux_17633);
		  }
		  STRUCT_SET(aux1879_3942, ((long) 0), aux_17632);
	       }
	       STRUCT_SET(res1878_3941, ((long) 0), aux1879_3942);
	       {
		  obj_t aux_17642;
		  aux_17642 = STRUCT_KEY(res1878_3941);
		  STRUCT_KEY_SET(aux1879_3942, aux_17642);
	       }
	       {
		  obj_t aux_17645;
		  aux_17645 = CNST_TABLE_REF(((long) 22));
		  STRUCT_KEY_SET(res1878_3941, aux_17645);
	       }
	       return res1878_3941;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-make-box */ obj_t 
struct_object__object_pre_make_box_16_cfa_info(obj_t env_10481, obj_t o_10482, obj_t s_10483)
{
   {
      pre_make_box_186_t o_3927;
      obj_t s_3928;
      {
	 pre_make_box_186_t aux_17649;
	 o_3927 = (pre_make_box_186_t) (o_10482);
	 s_3928 = s_10483;
	 {
	    {
	       obj_t old1895_3931;
	       {
		  obj_t next_method2548_95_3936;
		  next_method2548_95_3936 = find_super_class_method_167___object((object_t) (o_3927), struct_object__object_env_209___object, pre_make_box_186_cfa_info);
		  if (PROCEDUREP(next_method2548_95_3936))
		    {
		       old1895_3931 = PROCEDURE_ENTRY(next_method2548_95_3936) (next_method2548_95_3936, (obj_t) (o_3927), s_3928, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2548_95_3936);
		       {
			  object_t aux_17658;
			  aux_17658 = struct_object__object_93___object((object_t) (o_3927), s_3928);
			  old1895_3931 = (obj_t) (aux_17658);
		       }
		    }
	       }
	       {
		  pre_make_box_186_t new1897_3933;
		  new1897_3933 = ((pre_make_box_186_t) (old1895_3931));
		  {
		     long arg3403_3934;
		     arg3403_3934 = class_num_218___object(pre_make_box_186_cfa_info);
		     {
			obj_t obj_7315;
			obj_7315 = (obj_t) (new1897_3933);
			(((obj_t) CREF(obj_7315))->header = MAKE_HEADER(arg3403_3934, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_17668;
		     object_t aux_17666;
		     {
			pre_make_box_186_t aux_17669;
			{
			   aux_17669 = ((pre_make_box_186_t) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
			}
			aux_17668 = (obj_t) (aux_17669);
		     }
		     aux_17666 = (object_t) (new1897_3933);
		     OBJECT_WIDENING_SET(aux_17666, aux_17668);
		  }
		  aux_17649 = new1897_3933;
	       }
	    }
	 }
	 return (obj_t) (aux_17649);
      }
   }
}


/* object->struct-pre-make-box */ obj_t 
object__struct_pre_make_box_150_cfa_info(obj_t env_10484, obj_t obj1892_10485)
{
   {
      pre_make_box_186_t obj1892_3916;
      obj1892_3916 = (pre_make_box_186_t) (obj1892_10485);
      {
	 {
	    obj_t res1893_3919;
	    {
	       obj_t next_method2547_154_3925;
	       next_method2547_154_3925 = find_super_class_method_167___object((object_t) (obj1892_3916), object__struct_env_210___object, pre_make_box_186_cfa_info);
	       if (PROCEDUREP(next_method2547_154_3925))
		 {
		    res1893_3919 = PROCEDURE_ENTRY(next_method2547_154_3925) (next_method2547_154_3925, (obj_t) (obj1892_3916), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2547_154_3925);
		    res1893_3919 = object__struct_50___object((object_t) (obj1892_3916));
		 }
	    }
	    {
	       obj_t aux1894_3920;
	       {
		  obj_t aux_17685;
		  aux_17685 = CNST_TABLE_REF(((long) 23));
		  aux1894_3920 = make_struct(aux_17685, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res1893_3919, ((long) 0), aux1894_3920);
	       {
		  obj_t aux_17689;
		  aux_17689 = STRUCT_KEY(res1893_3919);
		  STRUCT_KEY_SET(aux1894_3920, aux_17689);
	       }
	       {
		  obj_t aux_17692;
		  aux_17692 = CNST_TABLE_REF(((long) 23));
		  STRUCT_KEY_SET(res1893_3919, aux_17692);
	       }
	       return res1893_3919;
	    }
	 }
      }
   }
}


/* struct+object->object-make-box/cinfo */ obj_t 
struct_object__object_make_box_cinfo_10_cfa_info(obj_t env_10486, obj_t o_10487, obj_t s_10488)
{
   {
      make_box_cinfo_127_t o_3904;
      obj_t s_3905;
      {
	 make_box_cinfo_127_t aux_17696;
	 o_3904 = (make_box_cinfo_127_t) (o_10487);
	 s_3905 = s_10488;
	 {
	    {
	       obj_t old1911_3908;
	       obj_t aux1912_3909;
	       {
		  obj_t next_method2546_250_3914;
		  next_method2546_250_3914 = find_super_class_method_167___object((object_t) (o_3904), struct_object__object_env_209___object, make_box_cinfo_127_cfa_info);
		  if (PROCEDUREP(next_method2546_250_3914))
		    {
		       old1911_3908 = PROCEDURE_ENTRY(next_method2546_250_3914) (next_method2546_250_3914, (obj_t) (o_3904), s_3905, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2546_250_3914);
		       {
			  object_t aux_17705;
			  aux_17705 = struct_object__object_93___object((object_t) (o_3904), s_3905);
			  old1911_3908 = (obj_t) (aux_17705);
		       }
		    }
	       }
	       aux1912_3909 = STRUCT_REF(s_3905, ((long) 0));
	       {
		  make_box_cinfo_127_t new1913_3910;
		  new1913_3910 = ((make_box_cinfo_127_t) (old1911_3908));
		  {
		     long arg3393_3911;
		     arg3393_3911 = class_num_218___object(make_box_cinfo_127_cfa_info);
		     {
			obj_t obj_7290;
			obj_7290 = (obj_t) (new1913_3910);
			(((obj_t) CREF(obj_7290))->header = MAKE_HEADER(arg3393_3911, 0), BUNSPEC);
		     }
		  }
		  {
		     make_box_cinfo_127_t arg3394_3912;
		     {
			make_box_cinfo_127_t res3796_7297;
			{
			   approx_t approx_7294;
			   {
			      obj_t aux_17714;
			      aux_17714 = STRUCT_REF(aux1912_3909, ((long) 0));
			      approx_7294 = (approx_t) (aux_17714);
			   }
			   {
			      make_box_cinfo_127_t new1898_7295;
			      new1898_7295 = ((make_box_cinfo_127_t) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
			      ((((make_box_cinfo_127_t) CREF(new1898_7295))->approx) = ((approx_t) approx_7294), BUNSPEC);
			      res3796_7297 = new1898_7295;
			   }
			}
			arg3394_3912 = res3796_7297;
		     }
		     {
			obj_t aux_17721;
			object_t aux_17719;
			aux_17721 = (obj_t) (arg3394_3912);
			aux_17719 = (object_t) (new1913_3910);
			OBJECT_WIDENING_SET(aux_17719, aux_17721);
		     }
		  }
		  aux_17696 = new1913_3910;
	       }
	    }
	 }
	 return (obj_t) (aux_17696);
      }
   }
}


/* object->struct-make-box/cinfo */ obj_t 
object__struct_make_box_cinfo_186_cfa_info(obj_t env_10489, obj_t obj1908_10490)
{
   {
      make_box_cinfo_127_t obj1908_3891;
      obj1908_3891 = (make_box_cinfo_127_t) (obj1908_10490);
      {
	 {
	    obj_t res1909_3894;
	    {
	       obj_t next_method2545_88_3902;
	       next_method2545_88_3902 = find_super_class_method_167___object((object_t) (obj1908_3891), object__struct_env_210___object, make_box_cinfo_127_cfa_info);
	       if (PROCEDUREP(next_method2545_88_3902))
		 {
		    res1909_3894 = PROCEDURE_ENTRY(next_method2545_88_3902) (next_method2545_88_3902, (obj_t) (obj1908_3891), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2545_88_3902);
		    res1909_3894 = object__struct_50___object((object_t) (obj1908_3891));
		 }
	    }
	    {
	       obj_t aux1910_3895;
	       {
		  obj_t aux_17736;
		  aux_17736 = CNST_TABLE_REF(((long) 24));
		  aux1910_3895 = make_struct(aux_17736, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17739;
		  {
		     approx_t aux_17740;
		     {
			obj_t aux_17741;
			{
			   object_t aux_17742;
			   aux_17742 = (object_t) (obj1908_3891);
			   aux_17741 = OBJECT_WIDENING(aux_17742);
			}
			aux_17740 = (((make_box_cinfo_127_t) CREF(aux_17741))->approx);
		     }
		     aux_17739 = (obj_t) (aux_17740);
		  }
		  STRUCT_SET(aux1910_3895, ((long) 0), aux_17739);
	       }
	       STRUCT_SET(res1909_3894, ((long) 0), aux1910_3895);
	       {
		  obj_t aux_17749;
		  aux_17749 = STRUCT_KEY(res1909_3894);
		  STRUCT_KEY_SET(aux1910_3895, aux_17749);
	       }
	       {
		  obj_t aux_17752;
		  aux_17752 = CNST_TABLE_REF(((long) 24));
		  STRUCT_KEY_SET(res1909_3894, aux_17752);
	       }
	       return res1909_3894;
	    }
	 }
      }
   }
}


/* struct+object->object-make-box/o-cinfo */ obj_t 
struct_object__object_make_box_o_cinfo_100_cfa_info(obj_t env_10491, obj_t o_10492, obj_t s_10493)
{
   {
      make_box_o_cinfo_96_t o_3878;
      obj_t s_3879;
      {
	 make_box_o_cinfo_96_t aux_17756;
	 o_3878 = (make_box_o_cinfo_96_t) (o_10492);
	 s_3879 = s_10493;
	 {
	    {
	       obj_t old1929_3882;
	       obj_t aux1930_3883;
	       {
		  obj_t next_method2544_133_3889;
		  next_method2544_133_3889 = find_super_class_method_167___object((object_t) (o_3878), struct_object__object_env_209___object, make_box_o_cinfo_96_cfa_info);
		  if (PROCEDUREP(next_method2544_133_3889))
		    {
		       old1929_3882 = PROCEDURE_ENTRY(next_method2544_133_3889) (next_method2544_133_3889, (obj_t) (o_3878), s_3879, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2544_133_3889);
		       {
			  object_t aux_17765;
			  aux_17765 = struct_object__object_93___object((object_t) (o_3878), s_3879);
			  old1929_3882 = (obj_t) (aux_17765);
		       }
		    }
	       }
	       aux1930_3883 = STRUCT_REF(s_3879, ((long) 0));
	       {
		  make_box_o_cinfo_96_t new1931_3884;
		  new1931_3884 = ((make_box_o_cinfo_96_t) (old1929_3882));
		  {
		     long arg3381_3885;
		     arg3381_3885 = class_num_218___object(make_box_o_cinfo_96_cfa_info);
		     {
			obj_t obj_7257;
			obj_7257 = (obj_t) (new1931_3884);
			(((obj_t) CREF(obj_7257))->header = MAKE_HEADER(arg3381_3885, 0), BUNSPEC);
		     }
		  }
		  {
		     make_box_o_cinfo_96_t arg3382_3886;
		     {
			make_box_o_cinfo_96_t res3795_7268;
			{
			   approx_t approx_7263;
			   approx_t value_approx_19_7264;
			   {
			      obj_t aux_17774;
			      aux_17774 = STRUCT_REF(aux1930_3883, ((long) 0));
			      approx_7263 = (approx_t) (aux_17774);
			   }
			   {
			      obj_t aux_17777;
			      aux_17777 = STRUCT_REF(aux1930_3883, ((long) 1));
			      value_approx_19_7264 = (approx_t) (aux_17777);
			   }
			   {
			      make_box_o_cinfo_96_t new1914_7265;
			      new1914_7265 = ((make_box_o_cinfo_96_t) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
			      ((((make_box_o_cinfo_96_t) CREF(new1914_7265))->approx) = ((approx_t) approx_7263), BUNSPEC);
			      ((((make_box_o_cinfo_96_t) CREF(new1914_7265))->value_approx_19) = ((approx_t) value_approx_19_7264), BUNSPEC);
			      res3795_7268 = new1914_7265;
			   }
			}
			arg3382_3886 = res3795_7268;
		     }
		     {
			obj_t aux_17785;
			object_t aux_17783;
			aux_17785 = (obj_t) (arg3382_3886);
			aux_17783 = (object_t) (new1931_3884);
			OBJECT_WIDENING_SET(aux_17783, aux_17785);
		     }
		  }
		  aux_17756 = new1931_3884;
	       }
	    }
	 }
	 return (obj_t) (aux_17756);
      }
   }
}


/* object->struct-make-box/o-cinfo */ obj_t 
object__struct_make_box_o_cinfo_104_cfa_info(obj_t env_10494, obj_t obj1926_10495)
{
   {
      make_box_o_cinfo_96_t obj1926_3863;
      obj1926_3863 = (make_box_o_cinfo_96_t) (obj1926_10495);
      {
	 {
	    obj_t res1927_3866;
	    {
	       obj_t next_method2543_85_3876;
	       next_method2543_85_3876 = find_super_class_method_167___object((object_t) (obj1926_3863), object__struct_env_210___object, make_box_o_cinfo_96_cfa_info);
	       if (PROCEDUREP(next_method2543_85_3876))
		 {
		    res1927_3866 = PROCEDURE_ENTRY(next_method2543_85_3876) (next_method2543_85_3876, (obj_t) (obj1926_3863), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2543_85_3876);
		    res1927_3866 = object__struct_50___object((object_t) (obj1926_3863));
		 }
	    }
	    {
	       obj_t aux1928_3867;
	       {
		  obj_t aux_17800;
		  aux_17800 = CNST_TABLE_REF(((long) 25));
		  aux1928_3867 = make_struct(aux_17800, ((long) 2), BUNSPEC);
	       }
	       {
		  obj_t aux_17803;
		  {
		     approx_t aux_17804;
		     {
			obj_t aux_17805;
			{
			   object_t aux_17806;
			   aux_17806 = (object_t) (obj1926_3863);
			   aux_17805 = OBJECT_WIDENING(aux_17806);
			}
			aux_17804 = (((make_box_o_cinfo_96_t) CREF(aux_17805))->approx);
		     }
		     aux_17803 = (obj_t) (aux_17804);
		  }
		  STRUCT_SET(aux1928_3867, ((long) 0), aux_17803);
	       }
	       {
		  obj_t aux_17812;
		  {
		     approx_t aux_17813;
		     {
			obj_t aux_17814;
			{
			   object_t aux_17815;
			   aux_17815 = (object_t) (obj1926_3863);
			   aux_17814 = OBJECT_WIDENING(aux_17815);
			}
			aux_17813 = (((make_box_o_cinfo_96_t) CREF(aux_17814))->value_approx_19);
		     }
		     aux_17812 = (obj_t) (aux_17813);
		  }
		  STRUCT_SET(aux1928_3867, ((long) 1), aux_17812);
	       }
	       STRUCT_SET(res1927_3866, ((long) 0), aux1928_3867);
	       {
		  obj_t aux_17822;
		  aux_17822 = STRUCT_KEY(res1927_3866);
		  STRUCT_KEY_SET(aux1928_3867, aux_17822);
	       }
	       {
		  obj_t aux_17825;
		  aux_17825 = CNST_TABLE_REF(((long) 25));
		  STRUCT_KEY_SET(res1927_3866, aux_17825);
	       }
	       return res1927_3866;
	    }
	 }
      }
   }
}


/* struct+object->object-box-set!/cinfo */ obj_t 
struct_object__object_box_set__cinfo_119_cfa_info(obj_t env_10496, obj_t o_10497, obj_t s_10498)
{
   {
      box_set__cinfo_94_t o_3851;
      obj_t s_3852;
      {
	 box_set__cinfo_94_t aux_17829;
	 o_3851 = (box_set__cinfo_94_t) (o_10497);
	 s_3852 = s_10498;
	 {
	    {
	       obj_t old1944_3855;
	       obj_t aux1945_3856;
	       {
		  obj_t next_method2542_178_3861;
		  next_method2542_178_3861 = find_super_class_method_167___object((object_t) (o_3851), struct_object__object_env_209___object, box_set__cinfo_94_cfa_info);
		  if (PROCEDUREP(next_method2542_178_3861))
		    {
		       old1944_3855 = PROCEDURE_ENTRY(next_method2542_178_3861) (next_method2542_178_3861, (obj_t) (o_3851), s_3852, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2542_178_3861);
		       {
			  object_t aux_17838;
			  aux_17838 = struct_object__object_93___object((object_t) (o_3851), s_3852);
			  old1944_3855 = (obj_t) (aux_17838);
		       }
		    }
	       }
	       aux1945_3856 = STRUCT_REF(s_3852, ((long) 0));
	       {
		  box_set__cinfo_94_t new1946_3857;
		  new1946_3857 = ((box_set__cinfo_94_t) (old1944_3855));
		  {
		     long arg3365_3858;
		     arg3365_3858 = class_num_218___object(box_set__cinfo_94_cfa_info);
		     {
			obj_t obj_7224;
			obj_7224 = (obj_t) (new1946_3857);
			(((obj_t) CREF(obj_7224))->header = MAKE_HEADER(arg3365_3858, 0), BUNSPEC);
		     }
		  }
		  {
		     box_set__cinfo_94_t arg3367_3859;
		     {
			box_set__cinfo_94_t res3794_7231;
			{
			   approx_t approx_7228;
			   {
			      obj_t aux_17847;
			      aux_17847 = STRUCT_REF(aux1945_3856, ((long) 0));
			      approx_7228 = (approx_t) (aux_17847);
			   }
			   {
			      box_set__cinfo_94_t new1932_7229;
			      new1932_7229 = ((box_set__cinfo_94_t) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
			      ((((box_set__cinfo_94_t) CREF(new1932_7229))->approx) = ((approx_t) approx_7228), BUNSPEC);
			      res3794_7231 = new1932_7229;
			   }
			}
			arg3367_3859 = res3794_7231;
		     }
		     {
			obj_t aux_17854;
			object_t aux_17852;
			aux_17854 = (obj_t) (arg3367_3859);
			aux_17852 = (object_t) (new1946_3857);
			OBJECT_WIDENING_SET(aux_17852, aux_17854);
		     }
		  }
		  aux_17829 = new1946_3857;
	       }
	    }
	 }
	 return (obj_t) (aux_17829);
      }
   }
}


/* object->struct-box-set!/cinfo */ obj_t 
object__struct_box_set__cinfo_66_cfa_info(obj_t env_10499, obj_t obj1941_10500)
{
   {
      box_set__cinfo_94_t obj1941_3838;
      obj1941_3838 = (box_set__cinfo_94_t) (obj1941_10500);
      {
	 {
	    obj_t res1942_3841;
	    {
	       obj_t next_method2541_237_3849;
	       next_method2541_237_3849 = find_super_class_method_167___object((object_t) (obj1941_3838), object__struct_env_210___object, box_set__cinfo_94_cfa_info);
	       if (PROCEDUREP(next_method2541_237_3849))
		 {
		    res1942_3841 = PROCEDURE_ENTRY(next_method2541_237_3849) (next_method2541_237_3849, (obj_t) (obj1941_3838), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2541_237_3849);
		    res1942_3841 = object__struct_50___object((object_t) (obj1941_3838));
		 }
	    }
	    {
	       obj_t aux1943_3842;
	       {
		  obj_t aux_17869;
		  aux_17869 = CNST_TABLE_REF(((long) 26));
		  aux1943_3842 = make_struct(aux_17869, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17872;
		  {
		     approx_t aux_17873;
		     {
			obj_t aux_17874;
			{
			   object_t aux_17875;
			   aux_17875 = (object_t) (obj1941_3838);
			   aux_17874 = OBJECT_WIDENING(aux_17875);
			}
			aux_17873 = (((box_set__cinfo_94_t) CREF(aux_17874))->approx);
		     }
		     aux_17872 = (obj_t) (aux_17873);
		  }
		  STRUCT_SET(aux1943_3842, ((long) 0), aux_17872);
	       }
	       STRUCT_SET(res1942_3841, ((long) 0), aux1943_3842);
	       {
		  obj_t aux_17882;
		  aux_17882 = STRUCT_KEY(res1942_3841);
		  STRUCT_KEY_SET(aux1943_3842, aux_17882);
	       }
	       {
		  obj_t aux_17885;
		  aux_17885 = CNST_TABLE_REF(((long) 26));
		  STRUCT_KEY_SET(res1942_3841, aux_17885);
	       }
	       return res1942_3841;
	    }
	 }
      }
   }
}


/* struct+object->object-box-ref/cinfo */ obj_t 
struct_object__object_box_ref_cinfo_78_cfa_info(obj_t env_10501, obj_t o_10502, obj_t s_10503)
{
   {
      box_ref_cinfo_214_t o_3826;
      obj_t s_3827;
      {
	 box_ref_cinfo_214_t aux_17889;
	 o_3826 = (box_ref_cinfo_214_t) (o_10502);
	 s_3827 = s_10503;
	 {
	    {
	       obj_t old1960_3830;
	       obj_t aux1961_3831;
	       {
		  obj_t next_method2540_253_3836;
		  next_method2540_253_3836 = find_super_class_method_167___object((object_t) (o_3826), struct_object__object_env_209___object, box_ref_cinfo_214_cfa_info);
		  if (PROCEDUREP(next_method2540_253_3836))
		    {
		       old1960_3830 = PROCEDURE_ENTRY(next_method2540_253_3836) (next_method2540_253_3836, (obj_t) (o_3826), s_3827, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2540_253_3836);
		       {
			  object_t aux_17898;
			  aux_17898 = struct_object__object_93___object((object_t) (o_3826), s_3827);
			  old1960_3830 = (obj_t) (aux_17898);
		       }
		    }
	       }
	       aux1961_3831 = STRUCT_REF(s_3827, ((long) 0));
	       {
		  box_ref_cinfo_214_t new1962_3832;
		  new1962_3832 = ((box_ref_cinfo_214_t) (old1960_3830));
		  {
		     long arg3354_3833;
		     arg3354_3833 = class_num_218___object(box_ref_cinfo_214_cfa_info);
		     {
			obj_t obj_7195;
			obj_7195 = (obj_t) (new1962_3832);
			(((obj_t) CREF(obj_7195))->header = MAKE_HEADER(arg3354_3833, 0), BUNSPEC);
		     }
		  }
		  {
		     box_ref_cinfo_214_t arg3355_3834;
		     {
			box_ref_cinfo_214_t res3793_7202;
			{
			   approx_t approx_7199;
			   {
			      obj_t aux_17907;
			      aux_17907 = STRUCT_REF(aux1961_3831, ((long) 0));
			      approx_7199 = (approx_t) (aux_17907);
			   }
			   {
			      box_ref_cinfo_214_t new1947_7200;
			      new1947_7200 = ((box_ref_cinfo_214_t) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
			      ((((box_ref_cinfo_214_t) CREF(new1947_7200))->approx) = ((approx_t) approx_7199), BUNSPEC);
			      res3793_7202 = new1947_7200;
			   }
			}
			arg3355_3834 = res3793_7202;
		     }
		     {
			obj_t aux_17914;
			object_t aux_17912;
			aux_17914 = (obj_t) (arg3355_3834);
			aux_17912 = (object_t) (new1962_3832);
			OBJECT_WIDENING_SET(aux_17912, aux_17914);
		     }
		  }
		  aux_17889 = new1962_3832;
	       }
	    }
	 }
	 return (obj_t) (aux_17889);
      }
   }
}


/* object->struct-box-ref/cinfo */ obj_t 
object__struct_box_ref_cinfo_171_cfa_info(obj_t env_10504, obj_t obj1957_10505)
{
   {
      box_ref_cinfo_214_t obj1957_3813;
      obj1957_3813 = (box_ref_cinfo_214_t) (obj1957_10505);
      {
	 {
	    obj_t res1958_3816;
	    {
	       obj_t next_method2539_162_3824;
	       next_method2539_162_3824 = find_super_class_method_167___object((object_t) (obj1957_3813), object__struct_env_210___object, box_ref_cinfo_214_cfa_info);
	       if (PROCEDUREP(next_method2539_162_3824))
		 {
		    res1958_3816 = PROCEDURE_ENTRY(next_method2539_162_3824) (next_method2539_162_3824, (obj_t) (obj1957_3813), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2539_162_3824);
		    res1958_3816 = object__struct_50___object((object_t) (obj1957_3813));
		 }
	    }
	    {
	       obj_t aux1959_3817;
	       {
		  obj_t aux_17929;
		  aux_17929 = CNST_TABLE_REF(((long) 27));
		  aux1959_3817 = make_struct(aux_17929, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17932;
		  {
		     approx_t aux_17933;
		     {
			obj_t aux_17934;
			{
			   object_t aux_17935;
			   aux_17935 = (object_t) (obj1957_3813);
			   aux_17934 = OBJECT_WIDENING(aux_17935);
			}
			aux_17933 = (((box_ref_cinfo_214_t) CREF(aux_17934))->approx);
		     }
		     aux_17932 = (obj_t) (aux_17933);
		  }
		  STRUCT_SET(aux1959_3817, ((long) 0), aux_17932);
	       }
	       STRUCT_SET(res1958_3816, ((long) 0), aux1959_3817);
	       {
		  obj_t aux_17942;
		  aux_17942 = STRUCT_KEY(res1958_3816);
		  STRUCT_KEY_SET(aux1959_3817, aux_17942);
	       }
	       {
		  obj_t aux_17945;
		  aux_17945 = CNST_TABLE_REF(((long) 27));
		  STRUCT_KEY_SET(res1958_3816, aux_17945);
	       }
	       return res1958_3816;
	    }
	 }
      }
   }
}


/* struct+object->object-box-set!/o-cinfo */ obj_t 
struct_object__object_box_set__o_cinfo_219_cfa_info(obj_t env_10506, obj_t o_10507, obj_t s_10508)
{
   {
      box_set__o_cinfo_6_t o_3801;
      obj_t s_3802;
      {
	 box_set__o_cinfo_6_t aux_17949;
	 o_3801 = (box_set__o_cinfo_6_t) (o_10507);
	 s_3802 = s_10508;
	 {
	    {
	       obj_t old1975_3805;
	       obj_t aux1976_3806;
	       {
		  obj_t next_method2538_53_3811;
		  next_method2538_53_3811 = find_super_class_method_167___object((object_t) (o_3801), struct_object__object_env_209___object, box_set__o_cinfo_6_cfa_info);
		  if (PROCEDUREP(next_method2538_53_3811))
		    {
		       old1975_3805 = PROCEDURE_ENTRY(next_method2538_53_3811) (next_method2538_53_3811, (obj_t) (o_3801), s_3802, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2538_53_3811);
		       {
			  object_t aux_17958;
			  aux_17958 = struct_object__object_93___object((object_t) (o_3801), s_3802);
			  old1975_3805 = (obj_t) (aux_17958);
		       }
		    }
	       }
	       aux1976_3806 = STRUCT_REF(s_3802, ((long) 0));
	       {
		  box_set__o_cinfo_6_t new1977_3807;
		  new1977_3807 = ((box_set__o_cinfo_6_t) (old1975_3805));
		  {
		     long arg3343_3808;
		     arg3343_3808 = class_num_218___object(box_set__o_cinfo_6_cfa_info);
		     {
			obj_t obj_7166;
			obj_7166 = (obj_t) (new1977_3807);
			(((obj_t) CREF(obj_7166))->header = MAKE_HEADER(arg3343_3808, 0), BUNSPEC);
		     }
		  }
		  {
		     box_set__o_cinfo_6_t arg3344_3809;
		     {
			box_set__o_cinfo_6_t res3792_7173;
			{
			   approx_t approx_7170;
			   {
			      obj_t aux_17967;
			      aux_17967 = STRUCT_REF(aux1976_3806, ((long) 0));
			      approx_7170 = (approx_t) (aux_17967);
			   }
			   {
			      box_set__o_cinfo_6_t new1963_7171;
			      new1963_7171 = ((box_set__o_cinfo_6_t) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
			      ((((box_set__o_cinfo_6_t) CREF(new1963_7171))->approx) = ((approx_t) approx_7170), BUNSPEC);
			      res3792_7173 = new1963_7171;
			   }
			}
			arg3344_3809 = res3792_7173;
		     }
		     {
			obj_t aux_17974;
			object_t aux_17972;
			aux_17974 = (obj_t) (arg3344_3809);
			aux_17972 = (object_t) (new1977_3807);
			OBJECT_WIDENING_SET(aux_17972, aux_17974);
		     }
		  }
		  aux_17949 = new1977_3807;
	       }
	    }
	 }
	 return (obj_t) (aux_17949);
      }
   }
}


/* object->struct-box-set!/o-cinfo */ obj_t 
object__struct_box_set__o_cinfo_141_cfa_info(obj_t env_10509, obj_t obj1972_10510)
{
   {
      box_set__o_cinfo_6_t obj1972_3788;
      obj1972_3788 = (box_set__o_cinfo_6_t) (obj1972_10510);
      {
	 {
	    obj_t res1973_3791;
	    {
	       obj_t next_method2537_246_3799;
	       next_method2537_246_3799 = find_super_class_method_167___object((object_t) (obj1972_3788), object__struct_env_210___object, box_set__o_cinfo_6_cfa_info);
	       if (PROCEDUREP(next_method2537_246_3799))
		 {
		    res1973_3791 = PROCEDURE_ENTRY(next_method2537_246_3799) (next_method2537_246_3799, (obj_t) (obj1972_3788), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2537_246_3799);
		    res1973_3791 = object__struct_50___object((object_t) (obj1972_3788));
		 }
	    }
	    {
	       obj_t aux1974_3792;
	       {
		  obj_t aux_17989;
		  aux_17989 = CNST_TABLE_REF(((long) 28));
		  aux1974_3792 = make_struct(aux_17989, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_17992;
		  {
		     approx_t aux_17993;
		     {
			obj_t aux_17994;
			{
			   object_t aux_17995;
			   aux_17995 = (object_t) (obj1972_3788);
			   aux_17994 = OBJECT_WIDENING(aux_17995);
			}
			aux_17993 = (((box_set__o_cinfo_6_t) CREF(aux_17994))->approx);
		     }
		     aux_17992 = (obj_t) (aux_17993);
		  }
		  STRUCT_SET(aux1974_3792, ((long) 0), aux_17992);
	       }
	       STRUCT_SET(res1973_3791, ((long) 0), aux1974_3792);
	       {
		  obj_t aux_18002;
		  aux_18002 = STRUCT_KEY(res1973_3791);
		  STRUCT_KEY_SET(aux1974_3792, aux_18002);
	       }
	       {
		  obj_t aux_18005;
		  aux_18005 = CNST_TABLE_REF(((long) 28));
		  STRUCT_KEY_SET(res1973_3791, aux_18005);
	       }
	       return res1973_3791;
	    }
	 }
      }
   }
}


/* struct+object->object-box-ref/o-cinfo */ obj_t 
struct_object__object_box_ref_o_cinfo_19_cfa_info(obj_t env_10511, obj_t o_10512, obj_t s_10513)
{
   {
      box_ref_o_cinfo_98_t o_3776;
      obj_t s_3777;
      {
	 box_ref_o_cinfo_98_t aux_18009;
	 o_3776 = (box_ref_o_cinfo_98_t) (o_10512);
	 s_3777 = s_10513;
	 {
	    {
	       obj_t old1991_3780;
	       obj_t aux1992_3781;
	       {
		  obj_t next_method2536_114_3786;
		  next_method2536_114_3786 = find_super_class_method_167___object((object_t) (o_3776), struct_object__object_env_209___object, box_ref_o_cinfo_98_cfa_info);
		  if (PROCEDUREP(next_method2536_114_3786))
		    {
		       old1991_3780 = PROCEDURE_ENTRY(next_method2536_114_3786) (next_method2536_114_3786, (obj_t) (o_3776), s_3777, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2536_114_3786);
		       {
			  object_t aux_18018;
			  aux_18018 = struct_object__object_93___object((object_t) (o_3776), s_3777);
			  old1991_3780 = (obj_t) (aux_18018);
		       }
		    }
	       }
	       aux1992_3781 = STRUCT_REF(s_3777, ((long) 0));
	       {
		  box_ref_o_cinfo_98_t new1993_3782;
		  new1993_3782 = ((box_ref_o_cinfo_98_t) (old1991_3780));
		  {
		     long arg3332_3783;
		     arg3332_3783 = class_num_218___object(box_ref_o_cinfo_98_cfa_info);
		     {
			obj_t obj_7137;
			obj_7137 = (obj_t) (new1993_3782);
			(((obj_t) CREF(obj_7137))->header = MAKE_HEADER(arg3332_3783, 0), BUNSPEC);
		     }
		  }
		  {
		     box_ref_o_cinfo_98_t arg3333_3784;
		     {
			box_ref_o_cinfo_98_t res3791_7144;
			{
			   approx_t approx_7141;
			   {
			      obj_t aux_18027;
			      aux_18027 = STRUCT_REF(aux1992_3781, ((long) 0));
			      approx_7141 = (approx_t) (aux_18027);
			   }
			   {
			      box_ref_o_cinfo_98_t new1978_7142;
			      new1978_7142 = ((box_ref_o_cinfo_98_t) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
			      ((((box_ref_o_cinfo_98_t) CREF(new1978_7142))->approx) = ((approx_t) approx_7141), BUNSPEC);
			      res3791_7144 = new1978_7142;
			   }
			}
			arg3333_3784 = res3791_7144;
		     }
		     {
			obj_t aux_18034;
			object_t aux_18032;
			aux_18034 = (obj_t) (arg3333_3784);
			aux_18032 = (object_t) (new1993_3782);
			OBJECT_WIDENING_SET(aux_18032, aux_18034);
		     }
		  }
		  aux_18009 = new1993_3782;
	       }
	    }
	 }
	 return (obj_t) (aux_18009);
      }
   }
}


/* object->struct-box-ref/o-cinfo */ obj_t 
object__struct_box_ref_o_cinfo_174_cfa_info(obj_t env_10514, obj_t obj1988_10515)
{
   {
      box_ref_o_cinfo_98_t obj1988_3763;
      obj1988_3763 = (box_ref_o_cinfo_98_t) (obj1988_10515);
      {
	 {
	    obj_t res1989_3766;
	    {
	       obj_t next_method2535_62_3774;
	       next_method2535_62_3774 = find_super_class_method_167___object((object_t) (obj1988_3763), object__struct_env_210___object, box_ref_o_cinfo_98_cfa_info);
	       if (PROCEDUREP(next_method2535_62_3774))
		 {
		    res1989_3766 = PROCEDURE_ENTRY(next_method2535_62_3774) (next_method2535_62_3774, (obj_t) (obj1988_3763), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2535_62_3774);
		    res1989_3766 = object__struct_50___object((object_t) (obj1988_3763));
		 }
	    }
	    {
	       obj_t aux1990_3767;
	       {
		  obj_t aux_18049;
		  aux_18049 = CNST_TABLE_REF(((long) 29));
		  aux1990_3767 = make_struct(aux_18049, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_18052;
		  {
		     approx_t aux_18053;
		     {
			obj_t aux_18054;
			{
			   object_t aux_18055;
			   aux_18055 = (object_t) (obj1988_3763);
			   aux_18054 = OBJECT_WIDENING(aux_18055);
			}
			aux_18053 = (((box_ref_o_cinfo_98_t) CREF(aux_18054))->approx);
		     }
		     aux_18052 = (obj_t) (aux_18053);
		  }
		  STRUCT_SET(aux1990_3767, ((long) 0), aux_18052);
	       }
	       STRUCT_SET(res1989_3766, ((long) 0), aux1990_3767);
	       {
		  obj_t aux_18062;
		  aux_18062 = STRUCT_KEY(res1989_3766);
		  STRUCT_KEY_SET(aux1990_3767, aux_18062);
	       }
	       {
		  obj_t aux_18065;
		  aux_18065 = CNST_TABLE_REF(((long) 29));
		  STRUCT_KEY_SET(res1989_3766, aux_18065);
	       }
	       return res1989_3766;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-make-procedure-app */ obj_t 
struct_object__object_pre_make_procedure_app_51_cfa_info(obj_t env_10516, obj_t o_10517, obj_t s_10518)
{
   {
      pre_make_procedure_app_60_t o_3751;
      obj_t s_3752;
      {
	 pre_make_procedure_app_60_t aux_18069;
	 o_3751 = (pre_make_procedure_app_60_t) (o_10517);
	 s_3752 = s_10518;
	 {
	    {
	       obj_t old2009_3755;
	       obj_t aux2010_3756;
	       {
		  obj_t next_method2534_179_3761;
		  next_method2534_179_3761 = find_super_class_method_167___object((object_t) (o_3751), struct_object__object_env_209___object, pre_make_procedure_app_60_cfa_info);
		  if (PROCEDUREP(next_method2534_179_3761))
		    {
		       old2009_3755 = PROCEDURE_ENTRY(next_method2534_179_3761) (next_method2534_179_3761, (obj_t) (o_3751), s_3752, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2534_179_3761);
		       {
			  object_t aux_18078;
			  aux_18078 = struct_object__object_93___object((object_t) (o_3751), s_3752);
			  old2009_3755 = (obj_t) (aux_18078);
		       }
		    }
	       }
	       aux2010_3756 = STRUCT_REF(s_3752, ((long) 0));
	       {
		  pre_make_procedure_app_60_t new2011_3757;
		  new2011_3757 = ((pre_make_procedure_app_60_t) (old2009_3755));
		  {
		     long arg3321_3758;
		     arg3321_3758 = class_num_218___object(pre_make_procedure_app_60_cfa_info);
		     {
			obj_t obj_7108;
			obj_7108 = (obj_t) (new2011_3757);
			(((obj_t) CREF(obj_7108))->header = MAKE_HEADER(arg3321_3758, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_make_procedure_app_60_t arg3322_3759;
		     {
			pre_make_procedure_app_60_t res3790_7115;
			{
			   variable_t owner_7112;
			   {
			      obj_t aux_18087;
			      aux_18087 = STRUCT_REF(aux2010_3756, ((long) 0));
			      owner_7112 = (variable_t) (aux_18087);
			   }
			   {
			      pre_make_procedure_app_60_t new1994_7113;
			      new1994_7113 = ((pre_make_procedure_app_60_t) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
			      ((((pre_make_procedure_app_60_t) CREF(new1994_7113))->owner) = ((variable_t) owner_7112), BUNSPEC);
			      res3790_7115 = new1994_7113;
			   }
			}
			arg3322_3759 = res3790_7115;
		     }
		     {
			obj_t aux_18094;
			object_t aux_18092;
			aux_18094 = (obj_t) (arg3322_3759);
			aux_18092 = (object_t) (new2011_3757);
			OBJECT_WIDENING_SET(aux_18092, aux_18094);
		     }
		  }
		  aux_18069 = new2011_3757;
	       }
	    }
	 }
	 return (obj_t) (aux_18069);
      }
   }
}


/* object->struct-pre-make-procedure-app */ obj_t 
object__struct_pre_make_procedure_app_202_cfa_info(obj_t env_10519, obj_t obj2006_10520)
{
   {
      pre_make_procedure_app_60_t obj2006_3738;
      obj2006_3738 = (pre_make_procedure_app_60_t) (obj2006_10520);
      {
	 {
	    obj_t res2007_3741;
	    {
	       obj_t next_method2533_96_3749;
	       next_method2533_96_3749 = find_super_class_method_167___object((object_t) (obj2006_3738), object__struct_env_210___object, pre_make_procedure_app_60_cfa_info);
	       if (PROCEDUREP(next_method2533_96_3749))
		 {
		    res2007_3741 = PROCEDURE_ENTRY(next_method2533_96_3749) (next_method2533_96_3749, (obj_t) (obj2006_3738), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2533_96_3749);
		    res2007_3741 = object__struct_50___object((object_t) (obj2006_3738));
		 }
	    }
	    {
	       obj_t aux2008_3742;
	       {
		  obj_t aux_18109;
		  aux_18109 = CNST_TABLE_REF(((long) 30));
		  aux2008_3742 = make_struct(aux_18109, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_18112;
		  {
		     variable_t aux_18113;
		     {
			obj_t aux_18114;
			{
			   object_t aux_18115;
			   aux_18115 = (object_t) (obj2006_3738);
			   aux_18114 = OBJECT_WIDENING(aux_18115);
			}
			aux_18113 = (((pre_make_procedure_app_60_t) CREF(aux_18114))->owner);
		     }
		     aux_18112 = (obj_t) (aux_18113);
		  }
		  STRUCT_SET(aux2008_3742, ((long) 0), aux_18112);
	       }
	       STRUCT_SET(res2007_3741, ((long) 0), aux2008_3742);
	       {
		  obj_t aux_18122;
		  aux_18122 = STRUCT_KEY(res2007_3741);
		  STRUCT_KEY_SET(aux2008_3742, aux_18122);
	       }
	       {
		  obj_t aux_18125;
		  aux_18125 = CNST_TABLE_REF(((long) 30));
		  STRUCT_KEY_SET(res2007_3741, aux_18125);
	       }
	       return res2007_3741;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-procedure-ref-app */ obj_t 
struct_object__object_pre_procedure_ref_app_139_cfa_info(obj_t env_10521, obj_t o_10522, obj_t s_10523)
{
   {
      pre_procedure_ref_app_85_t o_3727;
      obj_t s_3728;
      {
	 pre_procedure_ref_app_85_t aux_18129;
	 o_3727 = (pre_procedure_ref_app_85_t) (o_10522);
	 s_3728 = s_10523;
	 {
	    {
	       obj_t old2026_3731;
	       {
		  obj_t next_method2532_227_3736;
		  next_method2532_227_3736 = find_super_class_method_167___object((object_t) (o_3727), struct_object__object_env_209___object, pre_procedure_ref_app_85_cfa_info);
		  if (PROCEDUREP(next_method2532_227_3736))
		    {
		       old2026_3731 = PROCEDURE_ENTRY(next_method2532_227_3736) (next_method2532_227_3736, (obj_t) (o_3727), s_3728, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2532_227_3736);
		       {
			  object_t aux_18138;
			  aux_18138 = struct_object__object_93___object((object_t) (o_3727), s_3728);
			  old2026_3731 = (obj_t) (aux_18138);
		       }
		    }
	       }
	       {
		  pre_procedure_ref_app_85_t new2028_3733;
		  new2028_3733 = ((pre_procedure_ref_app_85_t) (old2026_3731));
		  {
		     long arg3311_3734;
		     arg3311_3734 = class_num_218___object(pre_procedure_ref_app_85_cfa_info);
		     {
			obj_t obj_7083;
			obj_7083 = (obj_t) (new2028_3733);
			(((obj_t) CREF(obj_7083))->header = MAKE_HEADER(arg3311_3734, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_18148;
		     object_t aux_18146;
		     {
			pre_procedure_ref_app_85_t aux_18149;
			{
			   aux_18149 = ((pre_procedure_ref_app_85_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
			}
			aux_18148 = (obj_t) (aux_18149);
		     }
		     aux_18146 = (object_t) (new2028_3733);
		     OBJECT_WIDENING_SET(aux_18146, aux_18148);
		  }
		  aux_18129 = new2028_3733;
	       }
	    }
	 }
	 return (obj_t) (aux_18129);
      }
   }
}


/* object->struct-pre-procedure-ref-app */ obj_t 
object__struct_pre_procedure_ref_app_223_cfa_info(obj_t env_10524, obj_t obj2023_10525)
{
   {
      pre_procedure_ref_app_85_t obj2023_3716;
      obj2023_3716 = (pre_procedure_ref_app_85_t) (obj2023_10525);
      {
	 {
	    obj_t res2024_3719;
	    {
	       obj_t next_method2531_230_3725;
	       next_method2531_230_3725 = find_super_class_method_167___object((object_t) (obj2023_3716), object__struct_env_210___object, pre_procedure_ref_app_85_cfa_info);
	       if (PROCEDUREP(next_method2531_230_3725))
		 {
		    res2024_3719 = PROCEDURE_ENTRY(next_method2531_230_3725) (next_method2531_230_3725, (obj_t) (obj2023_3716), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2531_230_3725);
		    res2024_3719 = object__struct_50___object((object_t) (obj2023_3716));
		 }
	    }
	    {
	       obj_t aux2025_3720;
	       {
		  obj_t aux_18165;
		  aux_18165 = CNST_TABLE_REF(((long) 31));
		  aux2025_3720 = make_struct(aux_18165, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2024_3719, ((long) 0), aux2025_3720);
	       {
		  obj_t aux_18169;
		  aux_18169 = STRUCT_KEY(res2024_3719);
		  STRUCT_KEY_SET(aux2025_3720, aux_18169);
	       }
	       {
		  obj_t aux_18172;
		  aux_18172 = CNST_TABLE_REF(((long) 31));
		  STRUCT_KEY_SET(res2024_3719, aux_18172);
	       }
	       return res2024_3719;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-procedure-set!-app */ obj_t 
struct_object__object_pre_procedure_set__app_129_cfa_info(obj_t env_10526, obj_t o_10527, obj_t s_10528)
{
   {
      pre_procedure_set__app_208_t o_3705;
      obj_t s_3706;
      {
	 pre_procedure_set__app_208_t aux_18176;
	 o_3705 = (pre_procedure_set__app_208_t) (o_10527);
	 s_3706 = s_10528;
	 {
	    {
	       obj_t old2043_3709;
	       {
		  obj_t next_method2530_142_3714;
		  next_method2530_142_3714 = find_super_class_method_167___object((object_t) (o_3705), struct_object__object_env_209___object, pre_procedure_set__app_208_cfa_info);
		  if (PROCEDUREP(next_method2530_142_3714))
		    {
		       old2043_3709 = PROCEDURE_ENTRY(next_method2530_142_3714) (next_method2530_142_3714, (obj_t) (o_3705), s_3706, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2530_142_3714);
		       {
			  object_t aux_18185;
			  aux_18185 = struct_object__object_93___object((object_t) (o_3705), s_3706);
			  old2043_3709 = (obj_t) (aux_18185);
		       }
		    }
	       }
	       {
		  pre_procedure_set__app_208_t new2045_3711;
		  new2045_3711 = ((pre_procedure_set__app_208_t) (old2043_3709));
		  {
		     long arg3303_3712;
		     arg3303_3712 = class_num_218___object(pre_procedure_set__app_208_cfa_info);
		     {
			obj_t obj_7062;
			obj_7062 = (obj_t) (new2045_3711);
			(((obj_t) CREF(obj_7062))->header = MAKE_HEADER(arg3303_3712, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_18195;
		     object_t aux_18193;
		     {
			pre_procedure_set__app_208_t aux_18196;
			{
			   aux_18196 = ((pre_procedure_set__app_208_t) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
			}
			aux_18195 = (obj_t) (aux_18196);
		     }
		     aux_18193 = (object_t) (new2045_3711);
		     OBJECT_WIDENING_SET(aux_18193, aux_18195);
		  }
		  aux_18176 = new2045_3711;
	       }
	    }
	 }
	 return (obj_t) (aux_18176);
      }
   }
}


/* object->struct-pre-procedure-set!-app */ obj_t 
object__struct_pre_procedure_set__app_130_cfa_info(obj_t env_10529, obj_t obj2040_10530)
{
   {
      pre_procedure_set__app_208_t obj2040_3694;
      obj2040_3694 = (pre_procedure_set__app_208_t) (obj2040_10530);
      {
	 {
	    obj_t res2041_3697;
	    {
	       obj_t next_method2529_219_3703;
	       next_method2529_219_3703 = find_super_class_method_167___object((object_t) (obj2040_3694), object__struct_env_210___object, pre_procedure_set__app_208_cfa_info);
	       if (PROCEDUREP(next_method2529_219_3703))
		 {
		    res2041_3697 = PROCEDURE_ENTRY(next_method2529_219_3703) (next_method2529_219_3703, (obj_t) (obj2040_3694), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2529_219_3703);
		    res2041_3697 = object__struct_50___object((object_t) (obj2040_3694));
		 }
	    }
	    {
	       obj_t aux2042_3698;
	       {
		  obj_t aux_18212;
		  aux_18212 = CNST_TABLE_REF(((long) 32));
		  aux2042_3698 = make_struct(aux_18212, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2041_3697, ((long) 0), aux2042_3698);
	       {
		  obj_t aux_18216;
		  aux_18216 = STRUCT_KEY(res2041_3697);
		  STRUCT_KEY_SET(aux2042_3698, aux_18216);
	       }
	       {
		  obj_t aux_18219;
		  aux_18219 = CNST_TABLE_REF(((long) 32));
		  STRUCT_KEY_SET(res2041_3697, aux_18219);
	       }
	       return res2041_3697;
	    }
	 }
      }
   }
}


/* struct+object->object-make-procedure-app */ obj_t 
struct_object__object_make_procedure_app_38_cfa_info(obj_t env_10531, obj_t o_10532, obj_t s_10533)
{
   {
      make_procedure_app_48_t o_3673;
      obj_t s_3674;
      {
	 make_procedure_app_48_t aux_18223;
	 o_3673 = (make_procedure_app_48_t) (o_10532);
	 s_3674 = s_10533;
	 {
	    {
	       obj_t old2082_3677;
	       obj_t aux2083_3678;
	       {
		  obj_t next_method2528_10_3692;
		  next_method2528_10_3692 = find_super_class_method_167___object((object_t) (o_3673), struct_object__object_env_209___object, make_procedure_app_48_cfa_info);
		  if (PROCEDUREP(next_method2528_10_3692))
		    {
		       old2082_3677 = PROCEDURE_ENTRY(next_method2528_10_3692) (next_method2528_10_3692, (obj_t) (o_3673), s_3674, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2528_10_3692);
		       {
			  object_t aux_18232;
			  aux_18232 = struct_object__object_93___object((object_t) (o_3673), s_3674);
			  old2082_3677 = (obj_t) (aux_18232);
		       }
		    }
	       }
	       aux2083_3678 = STRUCT_REF(s_3674, ((long) 0));
	       {
		  make_procedure_app_48_t new2084_3679;
		  new2084_3679 = ((make_procedure_app_48_t) (old2082_3677));
		  {
		     long arg3285_3680;
		     arg3285_3680 = class_num_218___object(make_procedure_app_48_cfa_info);
		     {
			obj_t obj_6993;
			obj_6993 = (obj_t) (new2084_3679);
			(((obj_t) CREF(obj_6993))->header = MAKE_HEADER(arg3285_3680, 0), BUNSPEC);
		     }
		  }
		  {
		     make_procedure_app_48_t arg3286_3681;
		     {
			obj_t arg3296_3691;
			arg3296_3691 = STRUCT_REF(aux2083_3678, ((long) 9));
			{
			   make_procedure_app_48_t res3787_7044;
			   {
			      approx_t approx_7015;
			      long values_approx_len_106_7016;
			      approx_t values_approx_79_7017;
			      long lost_stamp_114_7018;
			      bool_t x_t__142_7019;
			      bool_t x_7020;
			      bool_t t_7021;
			      variable_t owner_7022;
			      bool_t stackable__42_7023;
			      {
				 obj_t aux_18242;
				 aux_18242 = STRUCT_REF(aux2083_3678, ((long) 0));
				 approx_7015 = (approx_t) (aux_18242);
			      }
			      {
				 obj_t aux_18245;
				 aux_18245 = STRUCT_REF(aux2083_3678, ((long) 1));
				 values_approx_len_106_7016 = (long) CINT(aux_18245);
			      }
			      {
				 obj_t aux_18248;
				 aux_18248 = STRUCT_REF(aux2083_3678, ((long) 2));
				 values_approx_79_7017 = (approx_t) (aux_18248);
			      }
			      {
				 obj_t aux_18251;
				 aux_18251 = STRUCT_REF(aux2083_3678, ((long) 3));
				 lost_stamp_114_7018 = (long) CINT(aux_18251);
			      }
			      {
				 obj_t aux_18254;
				 aux_18254 = STRUCT_REF(aux2083_3678, ((long) 4));
				 x_t__142_7019 = CBOOL(aux_18254);
			      }
			      {
				 obj_t aux_18257;
				 aux_18257 = STRUCT_REF(aux2083_3678, ((long) 5));
				 x_7020 = CBOOL(aux_18257);
			      }
			      {
				 obj_t aux_18260;
				 aux_18260 = STRUCT_REF(aux2083_3678, ((long) 6));
				 t_7021 = CBOOL(aux_18260);
			      }
			      {
				 obj_t aux_18263;
				 aux_18263 = STRUCT_REF(aux2083_3678, ((long) 7));
				 owner_7022 = (variable_t) (aux_18263);
			      }
			      {
				 obj_t aux_18266;
				 aux_18266 = STRUCT_REF(aux2083_3678, ((long) 8));
				 stackable__42_7023 = CBOOL(aux_18266);
			      }
			      {
				 make_procedure_app_48_t new2046_7025;
				 new2046_7025 = ((make_procedure_app_48_t) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->approx) = ((approx_t) approx_7015), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->values_approx_len_106) = ((long) values_approx_len_106_7016), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->values_approx_79) = ((approx_t *) GC_MALLOC(sizeof(struct approx) * values_approx_len_106_7016)), BUNSPEC);
				 {
				    long i2047_7037;
				    i2047_7037 = ((long) 0);
				  loop2050_7036:
				    if ((i2047_7037 == values_approx_len_106_7016))
				      {
					 CNST_TABLE_REF(((long) 50));
				      }
				    else
				      {
					 ((((make_procedure_app_48_t) CREF(new2046_7025))->values_approx_79)[i2047_7037] = ((approx_t) values_approx_79_7017), BUNSPEC);
					 {
					    long i2047_18278;
					    i2047_18278 = (i2047_7037 + ((long) 1));
					    i2047_7037 = i2047_18278;
					    goto loop2050_7036;
					 }
				      }
				 }
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->lost_stamp_114) = ((long) lost_stamp_114_7018), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->x_t__142) = ((bool_t) x_t__142_7019), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->x) = ((bool_t) x_7020), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->t) = ((bool_t) t_7021), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->owner) = ((variable_t) owner_7022), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->stackable__42) = ((bool_t) stackable__42_7023), BUNSPEC);
				 ((((make_procedure_app_48_t) CREF(new2046_7025))->stack_stamp_31) = ((obj_t) arg3296_3691), BUNSPEC);
				 res3787_7044 = new2046_7025;
			      }
			   }
			   arg3286_3681 = res3787_7044;
			}
		     }
		     {
			obj_t aux_18289;
			object_t aux_18287;
			aux_18289 = (obj_t) (arg3286_3681);
			aux_18287 = (object_t) (new2084_3679);
			OBJECT_WIDENING_SET(aux_18287, aux_18289);
		     }
		  }
		  aux_18223 = new2084_3679;
	       }
	    }
	 }
	 return (obj_t) (aux_18223);
      }
   }
}


/* object->struct-make-procedure-app */ obj_t 
object__struct_make_procedure_app_124_cfa_info(obj_t env_10534, obj_t obj2075_10535)
{
   {
      make_procedure_app_48_t obj2075_3636;
      obj2075_3636 = (make_procedure_app_48_t) (obj2075_10535);
      {
	 {
	    obj_t res2076_3639;
	    {
	       obj_t next_method2527_152_3671;
	       next_method2527_152_3671 = find_super_class_method_167___object((object_t) (obj2075_3636), object__struct_env_210___object, make_procedure_app_48_cfa_info);
	       if (PROCEDUREP(next_method2527_152_3671))
		 {
		    res2076_3639 = PROCEDURE_ENTRY(next_method2527_152_3671) (next_method2527_152_3671, (obj_t) (obj2075_3636), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2527_152_3671);
		    res2076_3639 = object__struct_50___object((object_t) (obj2075_3636));
		 }
	    }
	    {
	       obj_t aux2077_3640;
	       {
		  obj_t aux_18304;
		  aux_18304 = CNST_TABLE_REF(((long) 33));
		  aux2077_3640 = make_struct(aux_18304, ((long) 10), BUNSPEC);
	       }
	       {
		  obj_t aux_18307;
		  {
		     approx_t aux_18308;
		     {
			obj_t aux_18309;
			{
			   object_t aux_18310;
			   aux_18310 = (object_t) (obj2075_3636);
			   aux_18309 = OBJECT_WIDENING(aux_18310);
			}
			aux_18308 = (((make_procedure_app_48_t) CREF(aux_18309))->approx);
		     }
		     aux_18307 = (obj_t) (aux_18308);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 0), aux_18307);
	       }
	       {
		  obj_t aux_18316;
		  {
		     long aux_18317;
		     {
			obj_t aux_18318;
			{
			   object_t aux_18319;
			   aux_18319 = (object_t) (obj2075_3636);
			   aux_18318 = OBJECT_WIDENING(aux_18319);
			}
			aux_18317 = (((make_procedure_app_48_t) CREF(aux_18318))->values_approx_len_106);
		     }
		     aux_18316 = BINT(aux_18317);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 1), aux_18316);
	       }
	       {
		  long len2081_3645;
		  {
		     obj_t aux_18325;
		     {
			object_t aux_18326;
			aux_18326 = (object_t) (obj2075_3636);
			aux_18325 = OBJECT_WIDENING(aux_18326);
		     }
		     len2081_3645 = (((make_procedure_app_48_t) CREF(aux_18325))->values_approx_len_106);
		  }
		  {
		     obj_t vec2078_3646;
		     vec2078_3646 = make_vector(len2081_3645, BUNSPEC);
		     {
			long j2079_3647;
			j2079_3647 = ((long) 0);
		      loop2080_3648:
			if ((j2079_3647 == len2081_3645))
			  {
			     obj_t x_10617;
			     x_10617 = STRUCT_SET(aux2077_3640, ((long) 2), vec2078_3646);
			     BUNSPEC;
			  }
			else
			  {
			     {
				obj_t aux_18334;
				{
				   approx_t aux_18335;
				   {
				      obj_t aux_18336;
				      {
					 object_t aux_18337;
					 aux_18337 = (object_t) (obj2075_3636);
					 aux_18336 = OBJECT_WIDENING(aux_18337);
				      }
				      aux_18335 = (((make_procedure_app_48_t) CREF(aux_18336))->values_approx_79)[j2079_3647];
				   }
				   aux_18334 = (obj_t) (aux_18335);
				}
				VECTOR_SET(vec2078_3646, j2079_3647, aux_18334);
			     }
			     {
				long j2079_18343;
				j2079_18343 = (j2079_3647 + ((long) 1));
				j2079_3647 = j2079_18343;
				goto loop2080_3648;
			     }
			  }
		     }
		  }
	       }
	       {
		  obj_t aux_18345;
		  {
		     long aux_18346;
		     {
			obj_t aux_18347;
			{
			   object_t aux_18348;
			   aux_18348 = (object_t) (obj2075_3636);
			   aux_18347 = OBJECT_WIDENING(aux_18348);
			}
			aux_18346 = (((make_procedure_app_48_t) CREF(aux_18347))->lost_stamp_114);
		     }
		     aux_18345 = BINT(aux_18346);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 3), aux_18345);
	       }
	       {
		  obj_t aux_18354;
		  {
		     bool_t aux_18355;
		     {
			obj_t aux_18356;
			{
			   object_t aux_18357;
			   aux_18357 = (object_t) (obj2075_3636);
			   aux_18356 = OBJECT_WIDENING(aux_18357);
			}
			aux_18355 = (((make_procedure_app_48_t) CREF(aux_18356))->x_t__142);
		     }
		     aux_18354 = BBOOL(aux_18355);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 4), aux_18354);
	       }
	       {
		  obj_t aux_18363;
		  {
		     bool_t aux_18364;
		     {
			obj_t aux_18365;
			{
			   object_t aux_18366;
			   aux_18366 = (object_t) (obj2075_3636);
			   aux_18365 = OBJECT_WIDENING(aux_18366);
			}
			aux_18364 = (((make_procedure_app_48_t) CREF(aux_18365))->x);
		     }
		     aux_18363 = BBOOL(aux_18364);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 5), aux_18363);
	       }
	       {
		  obj_t aux_18372;
		  {
		     bool_t aux_18373;
		     {
			obj_t aux_18374;
			{
			   object_t aux_18375;
			   aux_18375 = (object_t) (obj2075_3636);
			   aux_18374 = OBJECT_WIDENING(aux_18375);
			}
			aux_18373 = (((make_procedure_app_48_t) CREF(aux_18374))->t);
		     }
		     aux_18372 = BBOOL(aux_18373);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 6), aux_18372);
	       }
	       {
		  obj_t aux_18381;
		  {
		     variable_t aux_18382;
		     {
			obj_t aux_18383;
			{
			   object_t aux_18384;
			   aux_18384 = (object_t) (obj2075_3636);
			   aux_18383 = OBJECT_WIDENING(aux_18384);
			}
			aux_18382 = (((make_procedure_app_48_t) CREF(aux_18383))->owner);
		     }
		     aux_18381 = (obj_t) (aux_18382);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 7), aux_18381);
	       }
	       {
		  obj_t aux_18390;
		  {
		     bool_t aux_18391;
		     {
			obj_t aux_18392;
			{
			   object_t aux_18393;
			   aux_18393 = (object_t) (obj2075_3636);
			   aux_18392 = OBJECT_WIDENING(aux_18393);
			}
			aux_18391 = (((make_procedure_app_48_t) CREF(aux_18392))->stackable__42);
		     }
		     aux_18390 = BBOOL(aux_18391);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 8), aux_18390);
	       }
	       {
		  obj_t aux_18399;
		  {
		     obj_t aux_18400;
		     {
			object_t aux_18401;
			aux_18401 = (object_t) (obj2075_3636);
			aux_18400 = OBJECT_WIDENING(aux_18401);
		     }
		     aux_18399 = (((make_procedure_app_48_t) CREF(aux_18400))->stack_stamp_31);
		  }
		  STRUCT_SET(aux2077_3640, ((long) 9), aux_18399);
	       }
	       STRUCT_SET(res2076_3639, ((long) 0), aux2077_3640);
	       {
		  obj_t aux_18407;
		  aux_18407 = STRUCT_KEY(res2076_3639);
		  STRUCT_KEY_SET(aux2077_3640, aux_18407);
	       }
	       {
		  obj_t aux_18410;
		  aux_18410 = CNST_TABLE_REF(((long) 33));
		  STRUCT_KEY_SET(res2076_3639, aux_18410);
	       }
	       return res2076_3639;
	    }
	 }
      }
   }
}


/* struct+object->object-procedure-ref-app */ obj_t 
struct_object__object_procedure_ref_app_161_cfa_info(obj_t env_10536, obj_t o_10537, obj_t s_10538)
{
   {
      procedure_ref_app_49_t o_3624;
      obj_t s_3625;
      {
	 procedure_ref_app_49_t aux_18414;
	 o_3624 = (procedure_ref_app_49_t) (o_10537);
	 s_3625 = s_10538;
	 {
	    {
	       obj_t old2100_3628;
	       obj_t aux2101_3629;
	       {
		  obj_t next_method2526_131_3634;
		  next_method2526_131_3634 = find_super_class_method_167___object((object_t) (o_3624), struct_object__object_env_209___object, procedure_ref_app_49_cfa_info);
		  if (PROCEDUREP(next_method2526_131_3634))
		    {
		       old2100_3628 = PROCEDURE_ENTRY(next_method2526_131_3634) (next_method2526_131_3634, (obj_t) (o_3624), s_3625, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2526_131_3634);
		       {
			  object_t aux_18423;
			  aux_18423 = struct_object__object_93___object((object_t) (o_3624), s_3625);
			  old2100_3628 = (obj_t) (aux_18423);
		       }
		    }
	       }
	       aux2101_3629 = STRUCT_REF(s_3625, ((long) 0));
	       {
		  procedure_ref_app_49_t new2102_3630;
		  new2102_3630 = ((procedure_ref_app_49_t) (old2100_3628));
		  {
		     long arg3252_3631;
		     arg3252_3631 = class_num_218___object(procedure_ref_app_49_cfa_info);
		     {
			obj_t obj_6918;
			obj_6918 = (obj_t) (new2102_3630);
			(((obj_t) CREF(obj_6918))->header = MAKE_HEADER(arg3252_3631, 0), BUNSPEC);
		     }
		  }
		  {
		     procedure_ref_app_49_t arg3253_3632;
		     {
			procedure_ref_app_49_t res3785_6925;
			{
			   approx_t approx_6922;
			   {
			      obj_t aux_18432;
			      aux_18432 = STRUCT_REF(aux2101_3629, ((long) 0));
			      approx_6922 = (approx_t) (aux_18432);
			   }
			   {
			      procedure_ref_app_49_t new2085_6923;
			      new2085_6923 = ((procedure_ref_app_49_t) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
			      ((((procedure_ref_app_49_t) CREF(new2085_6923))->approx) = ((approx_t) approx_6922), BUNSPEC);
			      res3785_6925 = new2085_6923;
			   }
			}
			arg3253_3632 = res3785_6925;
		     }
		     {
			obj_t aux_18439;
			object_t aux_18437;
			aux_18439 = (obj_t) (arg3253_3632);
			aux_18437 = (object_t) (new2102_3630);
			OBJECT_WIDENING_SET(aux_18437, aux_18439);
		     }
		  }
		  aux_18414 = new2102_3630;
	       }
	    }
	 }
	 return (obj_t) (aux_18414);
      }
   }
}


/* object->struct-procedure-ref-app */ obj_t 
object__struct_procedure_ref_app_22_cfa_info(obj_t env_10539, obj_t obj2097_10540)
{
   {
      procedure_ref_app_49_t obj2097_3611;
      obj2097_3611 = (procedure_ref_app_49_t) (obj2097_10540);
      {
	 {
	    obj_t res2098_3614;
	    {
	       obj_t next_method2525_123_3622;
	       next_method2525_123_3622 = find_super_class_method_167___object((object_t) (obj2097_3611), object__struct_env_210___object, procedure_ref_app_49_cfa_info);
	       if (PROCEDUREP(next_method2525_123_3622))
		 {
		    res2098_3614 = PROCEDURE_ENTRY(next_method2525_123_3622) (next_method2525_123_3622, (obj_t) (obj2097_3611), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2525_123_3622);
		    res2098_3614 = object__struct_50___object((object_t) (obj2097_3611));
		 }
	    }
	    {
	       obj_t aux2099_3615;
	       {
		  obj_t aux_18454;
		  aux_18454 = CNST_TABLE_REF(((long) 34));
		  aux2099_3615 = make_struct(aux_18454, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_18457;
		  {
		     approx_t aux_18458;
		     {
			obj_t aux_18459;
			{
			   object_t aux_18460;
			   aux_18460 = (object_t) (obj2097_3611);
			   aux_18459 = OBJECT_WIDENING(aux_18460);
			}
			aux_18458 = (((procedure_ref_app_49_t) CREF(aux_18459))->approx);
		     }
		     aux_18457 = (obj_t) (aux_18458);
		  }
		  STRUCT_SET(aux2099_3615, ((long) 0), aux_18457);
	       }
	       STRUCT_SET(res2098_3614, ((long) 0), aux2099_3615);
	       {
		  obj_t aux_18467;
		  aux_18467 = STRUCT_KEY(res2098_3614);
		  STRUCT_KEY_SET(aux2099_3615, aux_18467);
	       }
	       {
		  obj_t aux_18470;
		  aux_18470 = CNST_TABLE_REF(((long) 34));
		  STRUCT_KEY_SET(res2098_3614, aux_18470);
	       }
	       return res2098_3614;
	    }
	 }
      }
   }
}


/* struct+object->object-procedure-set!-app */ obj_t 
struct_object__object_procedure_set__app_110_cfa_info(obj_t env_10541, obj_t o_10542, obj_t s_10543)
{
   {
      procedure_set__app_32_t o_3599;
      obj_t s_3600;
      {
	 procedure_set__app_32_t aux_18474;
	 o_3599 = (procedure_set__app_32_t) (o_10542);
	 s_3600 = s_10543;
	 {
	    {
	       obj_t old2118_3603;
	       obj_t aux2119_3604;
	       {
		  obj_t next_method2524_229_3609;
		  next_method2524_229_3609 = find_super_class_method_167___object((object_t) (o_3599), struct_object__object_env_209___object, procedure_set__app_32_cfa_info);
		  if (PROCEDUREP(next_method2524_229_3609))
		    {
		       old2118_3603 = PROCEDURE_ENTRY(next_method2524_229_3609) (next_method2524_229_3609, (obj_t) (o_3599), s_3600, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2524_229_3609);
		       {
			  object_t aux_18483;
			  aux_18483 = struct_object__object_93___object((object_t) (o_3599), s_3600);
			  old2118_3603 = (obj_t) (aux_18483);
		       }
		    }
	       }
	       aux2119_3604 = STRUCT_REF(s_3600, ((long) 0));
	       {
		  procedure_set__app_32_t new2120_3605;
		  new2120_3605 = ((procedure_set__app_32_t) (old2118_3603));
		  {
		     long arg3241_3606;
		     arg3241_3606 = class_num_218___object(procedure_set__app_32_cfa_info);
		     {
			obj_t obj_6889;
			obj_6889 = (obj_t) (new2120_3605);
			(((obj_t) CREF(obj_6889))->header = MAKE_HEADER(arg3241_3606, 0), BUNSPEC);
		     }
		  }
		  {
		     procedure_set__app_32_t arg3242_3607;
		     {
			procedure_set__app_32_t res3784_6896;
			{
			   approx_t approx_6893;
			   {
			      obj_t aux_18492;
			      aux_18492 = STRUCT_REF(aux2119_3604, ((long) 0));
			      approx_6893 = (approx_t) (aux_18492);
			   }
			   {
			      procedure_set__app_32_t new2103_6894;
			      new2103_6894 = ((procedure_set__app_32_t) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
			      ((((procedure_set__app_32_t) CREF(new2103_6894))->approx) = ((approx_t) approx_6893), BUNSPEC);
			      res3784_6896 = new2103_6894;
			   }
			}
			arg3242_3607 = res3784_6896;
		     }
		     {
			obj_t aux_18499;
			object_t aux_18497;
			aux_18499 = (obj_t) (arg3242_3607);
			aux_18497 = (object_t) (new2120_3605);
			OBJECT_WIDENING_SET(aux_18497, aux_18499);
		     }
		  }
		  aux_18474 = new2120_3605;
	       }
	    }
	 }
	 return (obj_t) (aux_18474);
      }
   }
}


/* object->struct-procedure-set!-app */ obj_t 
object__struct_procedure_set__app_86_cfa_info(obj_t env_10544, obj_t obj2115_10545)
{
   {
      procedure_set__app_32_t obj2115_3586;
      obj2115_3586 = (procedure_set__app_32_t) (obj2115_10545);
      {
	 {
	    obj_t res2116_3589;
	    {
	       obj_t next_method2523_203_3597;
	       next_method2523_203_3597 = find_super_class_method_167___object((object_t) (obj2115_3586), object__struct_env_210___object, procedure_set__app_32_cfa_info);
	       if (PROCEDUREP(next_method2523_203_3597))
		 {
		    res2116_3589 = PROCEDURE_ENTRY(next_method2523_203_3597) (next_method2523_203_3597, (obj_t) (obj2115_3586), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2523_203_3597);
		    res2116_3589 = object__struct_50___object((object_t) (obj2115_3586));
		 }
	    }
	    {
	       obj_t aux2117_3590;
	       {
		  obj_t aux_18514;
		  aux_18514 = CNST_TABLE_REF(((long) 35));
		  aux2117_3590 = make_struct(aux_18514, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_18517;
		  {
		     approx_t aux_18518;
		     {
			obj_t aux_18519;
			{
			   object_t aux_18520;
			   aux_18520 = (object_t) (obj2115_3586);
			   aux_18519 = OBJECT_WIDENING(aux_18520);
			}
			aux_18518 = (((procedure_set__app_32_t) CREF(aux_18519))->approx);
		     }
		     aux_18517 = (obj_t) (aux_18518);
		  }
		  STRUCT_SET(aux2117_3590, ((long) 0), aux_18517);
	       }
	       STRUCT_SET(res2116_3589, ((long) 0), aux2117_3590);
	       {
		  obj_t aux_18527;
		  aux_18527 = STRUCT_KEY(res2116_3589);
		  STRUCT_KEY_SET(aux2117_3590, aux_18527);
	       }
	       {
		  obj_t aux_18530;
		  aux_18530 = CNST_TABLE_REF(((long) 35));
		  STRUCT_KEY_SET(res2116_3589, aux_18530);
	       }
	       return res2116_3589;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-make-vector-app */ obj_t 
struct_object__object_pre_make_vector_app_45_cfa_info(obj_t env_10546, obj_t o_10547, obj_t s_10548)
{
   {
      pre_make_vector_app_251_t o_3574;
      obj_t s_3575;
      {
	 pre_make_vector_app_251_t aux_18534;
	 o_3574 = (pre_make_vector_app_251_t) (o_10547);
	 s_3575 = s_10548;
	 {
	    {
	       obj_t old2136_3578;
	       obj_t aux2137_3579;
	       {
		  obj_t next_method2522_76_3584;
		  next_method2522_76_3584 = find_super_class_method_167___object((object_t) (o_3574), struct_object__object_env_209___object, pre_make_vector_app_251_cfa_info);
		  if (PROCEDUREP(next_method2522_76_3584))
		    {
		       old2136_3578 = PROCEDURE_ENTRY(next_method2522_76_3584) (next_method2522_76_3584, (obj_t) (o_3574), s_3575, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2522_76_3584);
		       {
			  object_t aux_18543;
			  aux_18543 = struct_object__object_93___object((object_t) (o_3574), s_3575);
			  old2136_3578 = (obj_t) (aux_18543);
		       }
		    }
	       }
	       aux2137_3579 = STRUCT_REF(s_3575, ((long) 0));
	       {
		  pre_make_vector_app_251_t new2138_3580;
		  new2138_3580 = ((pre_make_vector_app_251_t) (old2136_3578));
		  {
		     long arg3229_3581;
		     arg3229_3581 = class_num_218___object(pre_make_vector_app_251_cfa_info);
		     {
			obj_t obj_6860;
			obj_6860 = (obj_t) (new2138_3580);
			(((obj_t) CREF(obj_6860))->header = MAKE_HEADER(arg3229_3581, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_make_vector_app_251_t arg3230_3582;
		     {
			pre_make_vector_app_251_t res3783_6867;
			{
			   variable_t owner_6864;
			   {
			      obj_t aux_18552;
			      aux_18552 = STRUCT_REF(aux2137_3579, ((long) 0));
			      owner_6864 = (variable_t) (aux_18552);
			   }
			   {
			      pre_make_vector_app_251_t new2121_6865;
			      new2121_6865 = ((pre_make_vector_app_251_t) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
			      ((((pre_make_vector_app_251_t) CREF(new2121_6865))->owner) = ((variable_t) owner_6864), BUNSPEC);
			      res3783_6867 = new2121_6865;
			   }
			}
			arg3230_3582 = res3783_6867;
		     }
		     {
			obj_t aux_18559;
			object_t aux_18557;
			aux_18559 = (obj_t) (arg3230_3582);
			aux_18557 = (object_t) (new2138_3580);
			OBJECT_WIDENING_SET(aux_18557, aux_18559);
		     }
		  }
		  aux_18534 = new2138_3580;
	       }
	    }
	 }
	 return (obj_t) (aux_18534);
      }
   }
}


/* object->struct-pre-make-vector-app */ obj_t 
object__struct_pre_make_vector_app_189_cfa_info(obj_t env_10549, obj_t obj2133_10550)
{
   {
      pre_make_vector_app_251_t obj2133_3561;
      obj2133_3561 = (pre_make_vector_app_251_t) (obj2133_10550);
      {
	 {
	    obj_t res2134_3564;
	    {
	       obj_t next_method2521_120_3572;
	       next_method2521_120_3572 = find_super_class_method_167___object((object_t) (obj2133_3561), object__struct_env_210___object, pre_make_vector_app_251_cfa_info);
	       if (PROCEDUREP(next_method2521_120_3572))
		 {
		    res2134_3564 = PROCEDURE_ENTRY(next_method2521_120_3572) (next_method2521_120_3572, (obj_t) (obj2133_3561), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2521_120_3572);
		    res2134_3564 = object__struct_50___object((object_t) (obj2133_3561));
		 }
	    }
	    {
	       obj_t aux2135_3565;
	       {
		  obj_t aux_18574;
		  aux_18574 = CNST_TABLE_REF(((long) 36));
		  aux2135_3565 = make_struct(aux_18574, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_18577;
		  {
		     variable_t aux_18578;
		     {
			obj_t aux_18579;
			{
			   object_t aux_18580;
			   aux_18580 = (object_t) (obj2133_3561);
			   aux_18579 = OBJECT_WIDENING(aux_18580);
			}
			aux_18578 = (((pre_make_vector_app_251_t) CREF(aux_18579))->owner);
		     }
		     aux_18577 = (obj_t) (aux_18578);
		  }
		  STRUCT_SET(aux2135_3565, ((long) 0), aux_18577);
	       }
	       STRUCT_SET(res2134_3564, ((long) 0), aux2135_3565);
	       {
		  obj_t aux_18587;
		  aux_18587 = STRUCT_KEY(res2134_3564);
		  STRUCT_KEY_SET(aux2135_3565, aux_18587);
	       }
	       {
		  obj_t aux_18590;
		  aux_18590 = CNST_TABLE_REF(((long) 36));
		  STRUCT_KEY_SET(res2134_3564, aux_18590);
	       }
	       return res2134_3564;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-create-vector-app */ obj_t 
struct_object__object_pre_create_vector_app_213_cfa_info(obj_t env_10551, obj_t o_10552, obj_t s_10553)
{
   {
      pre_create_vector_app_162_t o_3549;
      obj_t s_3550;
      {
	 pre_create_vector_app_162_t aux_18594;
	 o_3549 = (pre_create_vector_app_162_t) (o_10552);
	 s_3550 = s_10553;
	 {
	    {
	       obj_t old2154_3553;
	       obj_t aux2155_3554;
	       {
		  obj_t next_method2520_209_3559;
		  next_method2520_209_3559 = find_super_class_method_167___object((object_t) (o_3549), struct_object__object_env_209___object, pre_create_vector_app_162_cfa_info);
		  if (PROCEDUREP(next_method2520_209_3559))
		    {
		       old2154_3553 = PROCEDURE_ENTRY(next_method2520_209_3559) (next_method2520_209_3559, (obj_t) (o_3549), s_3550, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2520_209_3559);
		       {
			  object_t aux_18603;
			  aux_18603 = struct_object__object_93___object((object_t) (o_3549), s_3550);
			  old2154_3553 = (obj_t) (aux_18603);
		       }
		    }
	       }
	       aux2155_3554 = STRUCT_REF(s_3550, ((long) 0));
	       {
		  pre_create_vector_app_162_t new2156_3555;
		  new2156_3555 = ((pre_create_vector_app_162_t) (old2154_3553));
		  {
		     long arg3218_3556;
		     arg3218_3556 = class_num_218___object(pre_create_vector_app_162_cfa_info);
		     {
			obj_t obj_6831;
			obj_6831 = (obj_t) (new2156_3555);
			(((obj_t) CREF(obj_6831))->header = MAKE_HEADER(arg3218_3556, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_create_vector_app_162_t arg3219_3557;
		     {
			pre_create_vector_app_162_t res3782_6838;
			{
			   variable_t owner_6835;
			   {
			      obj_t aux_18612;
			      aux_18612 = STRUCT_REF(aux2155_3554, ((long) 0));
			      owner_6835 = (variable_t) (aux_18612);
			   }
			   {
			      pre_create_vector_app_162_t new2139_6836;
			      new2139_6836 = ((pre_create_vector_app_162_t) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
			      ((((pre_create_vector_app_162_t) CREF(new2139_6836))->owner) = ((variable_t) owner_6835), BUNSPEC);
			      res3782_6838 = new2139_6836;
			   }
			}
			arg3219_3557 = res3782_6838;
		     }
		     {
			obj_t aux_18619;
			object_t aux_18617;
			aux_18619 = (obj_t) (arg3219_3557);
			aux_18617 = (object_t) (new2156_3555);
			OBJECT_WIDENING_SET(aux_18617, aux_18619);
		     }
		  }
		  aux_18594 = new2156_3555;
	       }
	    }
	 }
	 return (obj_t) (aux_18594);
      }
   }
}


/* object->struct-pre-create-vector-app */ obj_t 
object__struct_pre_create_vector_app_184_cfa_info(obj_t env_10554, obj_t obj2151_10555)
{
   {
      pre_create_vector_app_162_t obj2151_3536;
      obj2151_3536 = (pre_create_vector_app_162_t) (obj2151_10555);
      {
	 {
	    obj_t res2152_3539;
	    {
	       obj_t next_method2519_45_3547;
	       next_method2519_45_3547 = find_super_class_method_167___object((object_t) (obj2151_3536), object__struct_env_210___object, pre_create_vector_app_162_cfa_info);
	       if (PROCEDUREP(next_method2519_45_3547))
		 {
		    res2152_3539 = PROCEDURE_ENTRY(next_method2519_45_3547) (next_method2519_45_3547, (obj_t) (obj2151_3536), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2519_45_3547);
		    res2152_3539 = object__struct_50___object((object_t) (obj2151_3536));
		 }
	    }
	    {
	       obj_t aux2153_3540;
	       {
		  obj_t aux_18634;
		  aux_18634 = CNST_TABLE_REF(((long) 37));
		  aux2153_3540 = make_struct(aux_18634, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_18637;
		  {
		     variable_t aux_18638;
		     {
			obj_t aux_18639;
			{
			   object_t aux_18640;
			   aux_18640 = (object_t) (obj2151_3536);
			   aux_18639 = OBJECT_WIDENING(aux_18640);
			}
			aux_18638 = (((pre_create_vector_app_162_t) CREF(aux_18639))->owner);
		     }
		     aux_18637 = (obj_t) (aux_18638);
		  }
		  STRUCT_SET(aux2153_3540, ((long) 0), aux_18637);
	       }
	       STRUCT_SET(res2152_3539, ((long) 0), aux2153_3540);
	       {
		  obj_t aux_18647;
		  aux_18647 = STRUCT_KEY(res2152_3539);
		  STRUCT_KEY_SET(aux2153_3540, aux_18647);
	       }
	       {
		  obj_t aux_18650;
		  aux_18650 = CNST_TABLE_REF(((long) 37));
		  STRUCT_KEY_SET(res2152_3539, aux_18650);
	       }
	       return res2152_3539;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-vector-ref-app */ obj_t 
struct_object__object_pre_vector_ref_app_99_cfa_info(obj_t env_10556, obj_t o_10557, obj_t s_10558)
{
   {
      pre_vector_ref_app_208_t o_3525;
      obj_t s_3526;
      {
	 pre_vector_ref_app_208_t aux_18654;
	 o_3525 = (pre_vector_ref_app_208_t) (o_10557);
	 s_3526 = s_10558;
	 {
	    {
	       obj_t old2171_3529;
	       {
		  obj_t next_method2518_244_3534;
		  next_method2518_244_3534 = find_super_class_method_167___object((object_t) (o_3525), struct_object__object_env_209___object, pre_vector_ref_app_208_cfa_info);
		  if (PROCEDUREP(next_method2518_244_3534))
		    {
		       old2171_3529 = PROCEDURE_ENTRY(next_method2518_244_3534) (next_method2518_244_3534, (obj_t) (o_3525), s_3526, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2518_244_3534);
		       {
			  object_t aux_18663;
			  aux_18663 = struct_object__object_93___object((object_t) (o_3525), s_3526);
			  old2171_3529 = (obj_t) (aux_18663);
		       }
		    }
	       }
	       {
		  pre_vector_ref_app_208_t new2173_3531;
		  new2173_3531 = ((pre_vector_ref_app_208_t) (old2171_3529));
		  {
		     long arg3208_3532;
		     arg3208_3532 = class_num_218___object(pre_vector_ref_app_208_cfa_info);
		     {
			obj_t obj_6806;
			obj_6806 = (obj_t) (new2173_3531);
			(((obj_t) CREF(obj_6806))->header = MAKE_HEADER(arg3208_3532, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_18673;
		     object_t aux_18671;
		     {
			pre_vector_ref_app_208_t aux_18674;
			{
			   aux_18674 = ((pre_vector_ref_app_208_t) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
			}
			aux_18673 = (obj_t) (aux_18674);
		     }
		     aux_18671 = (object_t) (new2173_3531);
		     OBJECT_WIDENING_SET(aux_18671, aux_18673);
		  }
		  aux_18654 = new2173_3531;
	       }
	    }
	 }
	 return (obj_t) (aux_18654);
      }
   }
}


/* object->struct-pre-vector-ref-app */ obj_t 
object__struct_pre_vector_ref_app_11_cfa_info(obj_t env_10559, obj_t obj2168_10560)
{
   {
      pre_vector_ref_app_208_t obj2168_3514;
      obj2168_3514 = (pre_vector_ref_app_208_t) (obj2168_10560);
      {
	 {
	    obj_t res2169_3517;
	    {
	       obj_t next_method2517_19_3523;
	       next_method2517_19_3523 = find_super_class_method_167___object((object_t) (obj2168_3514), object__struct_env_210___object, pre_vector_ref_app_208_cfa_info);
	       if (PROCEDUREP(next_method2517_19_3523))
		 {
		    res2169_3517 = PROCEDURE_ENTRY(next_method2517_19_3523) (next_method2517_19_3523, (obj_t) (obj2168_3514), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2517_19_3523);
		    res2169_3517 = object__struct_50___object((object_t) (obj2168_3514));
		 }
	    }
	    {
	       obj_t aux2170_3518;
	       {
		  obj_t aux_18690;
		  aux_18690 = CNST_TABLE_REF(((long) 38));
		  aux2170_3518 = make_struct(aux_18690, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2169_3517, ((long) 0), aux2170_3518);
	       {
		  obj_t aux_18694;
		  aux_18694 = STRUCT_KEY(res2169_3517);
		  STRUCT_KEY_SET(aux2170_3518, aux_18694);
	       }
	       {
		  obj_t aux_18697;
		  aux_18697 = CNST_TABLE_REF(((long) 38));
		  STRUCT_KEY_SET(res2169_3517, aux_18697);
	       }
	       return res2169_3517;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-vector-set!-app */ obj_t 
struct_object__object_pre_vector_set__app_122_cfa_info(obj_t env_10561, obj_t o_10562, obj_t s_10563)
{
   {
      pre_vector_set__app_211_t o_3503;
      obj_t s_3504;
      {
	 pre_vector_set__app_211_t aux_18701;
	 o_3503 = (pre_vector_set__app_211_t) (o_10562);
	 s_3504 = s_10563;
	 {
	    {
	       obj_t old2188_3507;
	       {
		  obj_t next_method2516_165_3512;
		  next_method2516_165_3512 = find_super_class_method_167___object((object_t) (o_3503), struct_object__object_env_209___object, pre_vector_set__app_211_cfa_info);
		  if (PROCEDUREP(next_method2516_165_3512))
		    {
		       old2188_3507 = PROCEDURE_ENTRY(next_method2516_165_3512) (next_method2516_165_3512, (obj_t) (o_3503), s_3504, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2516_165_3512);
		       {
			  object_t aux_18710;
			  aux_18710 = struct_object__object_93___object((object_t) (o_3503), s_3504);
			  old2188_3507 = (obj_t) (aux_18710);
		       }
		    }
	       }
	       {
		  pre_vector_set__app_211_t new2190_3509;
		  new2190_3509 = ((pre_vector_set__app_211_t) (old2188_3507));
		  {
		     long arg3200_3510;
		     arg3200_3510 = class_num_218___object(pre_vector_set__app_211_cfa_info);
		     {
			obj_t obj_6785;
			obj_6785 = (obj_t) (new2190_3509);
			(((obj_t) CREF(obj_6785))->header = MAKE_HEADER(arg3200_3510, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_18720;
		     object_t aux_18718;
		     {
			pre_vector_set__app_211_t aux_18721;
			{
			   aux_18721 = ((pre_vector_set__app_211_t) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
			}
			aux_18720 = (obj_t) (aux_18721);
		     }
		     aux_18718 = (object_t) (new2190_3509);
		     OBJECT_WIDENING_SET(aux_18718, aux_18720);
		  }
		  aux_18701 = new2190_3509;
	       }
	    }
	 }
	 return (obj_t) (aux_18701);
      }
   }
}


/* object->struct-pre-vector-set!-app */ obj_t 
object__struct_pre_vector_set__app_201_cfa_info(obj_t env_10564, obj_t obj2185_10565)
{
   {
      pre_vector_set__app_211_t obj2185_3492;
      obj2185_3492 = (pre_vector_set__app_211_t) (obj2185_10565);
      {
	 {
	    obj_t res2186_3495;
	    {
	       obj_t next_method2515_231_3501;
	       next_method2515_231_3501 = find_super_class_method_167___object((object_t) (obj2185_3492), object__struct_env_210___object, pre_vector_set__app_211_cfa_info);
	       if (PROCEDUREP(next_method2515_231_3501))
		 {
		    res2186_3495 = PROCEDURE_ENTRY(next_method2515_231_3501) (next_method2515_231_3501, (obj_t) (obj2185_3492), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2515_231_3501);
		    res2186_3495 = object__struct_50___object((object_t) (obj2185_3492));
		 }
	    }
	    {
	       obj_t aux2187_3496;
	       {
		  obj_t aux_18737;
		  aux_18737 = CNST_TABLE_REF(((long) 39));
		  aux2187_3496 = make_struct(aux_18737, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2186_3495, ((long) 0), aux2187_3496);
	       {
		  obj_t aux_18741;
		  aux_18741 = STRUCT_KEY(res2186_3495);
		  STRUCT_KEY_SET(aux2187_3496, aux_18741);
	       }
	       {
		  obj_t aux_18744;
		  aux_18744 = CNST_TABLE_REF(((long) 39));
		  STRUCT_KEY_SET(res2186_3495, aux_18744);
	       }
	       return res2186_3495;
	    }
	 }
      }
   }
}


/* struct+object->object-make-vector-app */ obj_t 
struct_object__object_make_vector_app_26_cfa_info(obj_t env_10566, obj_t o_10567, obj_t s_10568)
{
   {
      make_vector_app_205_t o_3474;
      obj_t s_3475;
      {
	 make_vector_app_205_t aux_18748;
	 o_3474 = (make_vector_app_205_t) (o_10567);
	 s_3475 = s_10568;
	 {
	    {
	       obj_t old2217_3478;
	       obj_t aux2218_3479;
	       {
		  obj_t next_method2514_71_3490;
		  next_method2514_71_3490 = find_super_class_method_167___object((object_t) (o_3474), struct_object__object_env_209___object, make_vector_app_205_cfa_info);
		  if (PROCEDUREP(next_method2514_71_3490))
		    {
		       old2217_3478 = PROCEDURE_ENTRY(next_method2514_71_3490) (next_method2514_71_3490, (obj_t) (o_3474), s_3475, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2514_71_3490);
		       {
			  object_t aux_18757;
			  aux_18757 = struct_object__object_93___object((object_t) (o_3474), s_3475);
			  old2217_3478 = (obj_t) (aux_18757);
		       }
		    }
	       }
	       aux2218_3479 = STRUCT_REF(s_3475, ((long) 0));
	       {
		  make_vector_app_205_t new2219_3480;
		  new2219_3480 = ((make_vector_app_205_t) (old2217_3478));
		  {
		     long arg3185_3481;
		     arg3185_3481 = class_num_218___object(make_vector_app_205_cfa_info);
		     {
			obj_t obj_6736;
			obj_6736 = (obj_t) (new2219_3480);
			(((obj_t) CREF(obj_6736))->header = MAKE_HEADER(arg3185_3481, 0), BUNSPEC);
		     }
		  }
		  {
		     make_vector_app_205_t arg3186_3482;
		     {
			obj_t arg3192_3488;
			arg3192_3488 = STRUCT_REF(aux2218_3479, ((long) 5));
			{
			   make_vector_app_205_t res3779_6767;
			   {
			      approx_t approx_6752;
			      approx_t value_approx_19_6753;
			      long lost_stamp_114_6754;
			      variable_t owner_6755;
			      bool_t stackable__42_6756;
			      bool_t seen__39_6758;
			      {
				 obj_t aux_18767;
				 aux_18767 = STRUCT_REF(aux2218_3479, ((long) 0));
				 approx_6752 = (approx_t) (aux_18767);
			      }
			      {
				 obj_t aux_18770;
				 aux_18770 = STRUCT_REF(aux2218_3479, ((long) 1));
				 value_approx_19_6753 = (approx_t) (aux_18770);
			      }
			      {
				 obj_t aux_18773;
				 aux_18773 = STRUCT_REF(aux2218_3479, ((long) 2));
				 lost_stamp_114_6754 = (long) CINT(aux_18773);
			      }
			      {
				 obj_t aux_18776;
				 aux_18776 = STRUCT_REF(aux2218_3479, ((long) 3));
				 owner_6755 = (variable_t) (aux_18776);
			      }
			      {
				 obj_t aux_18779;
				 aux_18779 = STRUCT_REF(aux2218_3479, ((long) 4));
				 stackable__42_6756 = CBOOL(aux_18779);
			      }
			      {
				 obj_t aux_18782;
				 aux_18782 = STRUCT_REF(aux2218_3479, ((long) 6));
				 seen__39_6758 = CBOOL(aux_18782);
			      }
			      {
				 make_vector_app_205_t new2191_6759;
				 new2191_6759 = ((make_vector_app_205_t) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
				 ((((make_vector_app_205_t) CREF(new2191_6759))->approx) = ((approx_t) approx_6752), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2191_6759))->value_approx_19) = ((approx_t) value_approx_19_6753), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2191_6759))->lost_stamp_114) = ((long) lost_stamp_114_6754), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2191_6759))->owner) = ((variable_t) owner_6755), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2191_6759))->stackable__42) = ((bool_t) stackable__42_6756), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2191_6759))->stack_stamp_31) = ((obj_t) arg3192_3488), BUNSPEC);
				 ((((make_vector_app_205_t) CREF(new2191_6759))->seen__39) = ((bool_t) seen__39_6758), BUNSPEC);
				 res3779_6767 = new2191_6759;
			      }
			   }
			   arg3186_3482 = res3779_6767;
			}
		     }
		     {
			obj_t aux_18795;
			object_t aux_18793;
			aux_18795 = (obj_t) (arg3186_3482);
			aux_18793 = (object_t) (new2219_3480);
			OBJECT_WIDENING_SET(aux_18793, aux_18795);
		     }
		  }
		  aux_18748 = new2219_3480;
	       }
	    }
	 }
	 return (obj_t) (aux_18748);
      }
   }
}


/* object->struct-make-vector-app */ obj_t 
object__struct_make_vector_app_114_cfa_info(obj_t env_10569, obj_t obj2214_10570)
{
   {
      make_vector_app_205_t obj2214_3449;
      obj2214_3449 = (make_vector_app_205_t) (obj2214_10570);
      {
	 {
	    obj_t res2215_3452;
	    {
	       obj_t next_method2513_129_3472;
	       next_method2513_129_3472 = find_super_class_method_167___object((object_t) (obj2214_3449), object__struct_env_210___object, make_vector_app_205_cfa_info);
	       if (PROCEDUREP(next_method2513_129_3472))
		 {
		    res2215_3452 = PROCEDURE_ENTRY(next_method2513_129_3472) (next_method2513_129_3472, (obj_t) (obj2214_3449), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2513_129_3472);
		    res2215_3452 = object__struct_50___object((object_t) (obj2214_3449));
		 }
	    }
	    {
	       obj_t aux2216_3453;
	       {
		  obj_t aux_18810;
		  aux_18810 = CNST_TABLE_REF(((long) 40));
		  aux2216_3453 = make_struct(aux_18810, ((long) 7), BUNSPEC);
	       }
	       {
		  obj_t aux_18813;
		  {
		     approx_t aux_18814;
		     {
			obj_t aux_18815;
			{
			   object_t aux_18816;
			   aux_18816 = (object_t) (obj2214_3449);
			   aux_18815 = OBJECT_WIDENING(aux_18816);
			}
			aux_18814 = (((make_vector_app_205_t) CREF(aux_18815))->approx);
		     }
		     aux_18813 = (obj_t) (aux_18814);
		  }
		  STRUCT_SET(aux2216_3453, ((long) 0), aux_18813);
	       }
	       {
		  obj_t aux_18822;
		  {
		     approx_t aux_18823;
		     {
			obj_t aux_18824;
			{
			   object_t aux_18825;
			   aux_18825 = (object_t) (obj2214_3449);
			   aux_18824 = OBJECT_WIDENING(aux_18825);
			}
			aux_18823 = (((make_vector_app_205_t) CREF(aux_18824))->value_approx_19);
		     }
		     aux_18822 = (obj_t) (aux_18823);
		  }
		  STRUCT_SET(aux2216_3453, ((long) 1), aux_18822);
	       }
	       {
		  obj_t aux_18831;
		  {
		     long aux_18832;
		     {
			obj_t aux_18833;
			{
			   object_t aux_18834;
			   aux_18834 = (object_t) (obj2214_3449);
			   aux_18833 = OBJECT_WIDENING(aux_18834);
			}
			aux_18832 = (((make_vector_app_205_t) CREF(aux_18833))->lost_stamp_114);
		     }
		     aux_18831 = BINT(aux_18832);
		  }
		  STRUCT_SET(aux2216_3453, ((long) 2), aux_18831);
	       }
	       {
		  obj_t aux_18840;
		  {
		     variable_t aux_18841;
		     {
			obj_t aux_18842;
			{
			   object_t aux_18843;
			   aux_18843 = (object_t) (obj2214_3449);
			   aux_18842 = OBJECT_WIDENING(aux_18843);
			}
			aux_18841 = (((make_vector_app_205_t) CREF(aux_18842))->owner);
		     }
		     aux_18840 = (obj_t) (aux_18841);
		  }
		  STRUCT_SET(aux2216_3453, ((long) 3), aux_18840);
	       }
	       {
		  obj_t aux_18849;
		  {
		     bool_t aux_18850;
		     {
			obj_t aux_18851;
			{
			   object_t aux_18852;
			   aux_18852 = (object_t) (obj2214_3449);
			   aux_18851 = OBJECT_WIDENING(aux_18852);
			}
			aux_18850 = (((make_vector_app_205_t) CREF(aux_18851))->stackable__42);
		     }
		     aux_18849 = BBOOL(aux_18850);
		  }
		  STRUCT_SET(aux2216_3453, ((long) 4), aux_18849);
	       }
	       {
		  obj_t aux_18858;
		  {
		     obj_t aux_18859;
		     {
			object_t aux_18860;
			aux_18860 = (object_t) (obj2214_3449);
			aux_18859 = OBJECT_WIDENING(aux_18860);
		     }
		     aux_18858 = (((make_vector_app_205_t) CREF(aux_18859))->stack_stamp_31);
		  }
		  STRUCT_SET(aux2216_3453, ((long) 5), aux_18858);
	       }
	       {
		  obj_t aux_18865;
		  {
		     bool_t aux_18866;
		     {
			obj_t aux_18867;
			{
			   object_t aux_18868;
			   aux_18868 = (object_t) (obj2214_3449);
			   aux_18867 = OBJECT_WIDENING(aux_18868);
			}
			aux_18866 = (((make_vector_app_205_t) CREF(aux_18867))->seen__39);
		     }
		     aux_18865 = BBOOL(aux_18866);
		  }
		  STRUCT_SET(aux2216_3453, ((long) 6), aux_18865);
	       }
	       STRUCT_SET(res2215_3452, ((long) 0), aux2216_3453);
	       {
		  obj_t aux_18875;
		  aux_18875 = STRUCT_KEY(res2215_3452);
		  STRUCT_KEY_SET(aux2216_3453, aux_18875);
	       }
	       {
		  obj_t aux_18878;
		  aux_18878 = CNST_TABLE_REF(((long) 40));
		  STRUCT_KEY_SET(res2215_3452, aux_18878);
	       }
	       return res2215_3452;
	    }
	 }
      }
   }
}


/* struct+object->object-create-vector-app */ obj_t 
struct_object__object_create_vector_app_49_cfa_info(obj_t env_10571, obj_t o_10572, obj_t s_10573)
{
   {
      create_vector_app_150_t o_3431;
      obj_t s_3432;
      {
	 create_vector_app_150_t aux_18882;
	 o_3431 = (create_vector_app_150_t) (o_10572);
	 s_3432 = s_10573;
	 {
	    {
	       obj_t old2246_3435;
	       obj_t aux2247_3436;
	       {
		  obj_t next_method2512_90_3447;
		  next_method2512_90_3447 = find_super_class_method_167___object((object_t) (o_3431), struct_object__object_env_209___object, create_vector_app_150_cfa_info);
		  if (PROCEDUREP(next_method2512_90_3447))
		    {
		       old2246_3435 = PROCEDURE_ENTRY(next_method2512_90_3447) (next_method2512_90_3447, (obj_t) (o_3431), s_3432, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2512_90_3447);
		       {
			  object_t aux_18891;
			  aux_18891 = struct_object__object_93___object((object_t) (o_3431), s_3432);
			  old2246_3435 = (obj_t) (aux_18891);
		       }
		    }
	       }
	       aux2247_3436 = STRUCT_REF(s_3432, ((long) 0));
	       {
		  create_vector_app_150_t new2248_3437;
		  new2248_3437 = ((create_vector_app_150_t) (old2246_3435));
		  {
		     long arg3156_3438;
		     arg3156_3438 = class_num_218___object(create_vector_app_150_cfa_info);
		     {
			obj_t obj_6659;
			obj_6659 = (obj_t) (new2248_3437);
			(((obj_t) CREF(obj_6659))->header = MAKE_HEADER(arg3156_3438, 0), BUNSPEC);
		     }
		  }
		  {
		     create_vector_app_150_t arg3157_3439;
		     {
			obj_t arg3163_3445;
			arg3163_3445 = STRUCT_REF(aux2247_3436, ((long) 5));
			{
			   create_vector_app_150_t res3778_6690;
			   {
			      approx_t approx_6675;
			      approx_t value_approx_19_6676;
			      long lost_stamp_114_6677;
			      variable_t owner_6678;
			      bool_t stackable__42_6679;
			      bool_t seen__39_6681;
			      {
				 obj_t aux_18901;
				 aux_18901 = STRUCT_REF(aux2247_3436, ((long) 0));
				 approx_6675 = (approx_t) (aux_18901);
			      }
			      {
				 obj_t aux_18904;
				 aux_18904 = STRUCT_REF(aux2247_3436, ((long) 1));
				 value_approx_19_6676 = (approx_t) (aux_18904);
			      }
			      {
				 obj_t aux_18907;
				 aux_18907 = STRUCT_REF(aux2247_3436, ((long) 2));
				 lost_stamp_114_6677 = (long) CINT(aux_18907);
			      }
			      {
				 obj_t aux_18910;
				 aux_18910 = STRUCT_REF(aux2247_3436, ((long) 3));
				 owner_6678 = (variable_t) (aux_18910);
			      }
			      {
				 obj_t aux_18913;
				 aux_18913 = STRUCT_REF(aux2247_3436, ((long) 4));
				 stackable__42_6679 = CBOOL(aux_18913);
			      }
			      {
				 obj_t aux_18916;
				 aux_18916 = STRUCT_REF(aux2247_3436, ((long) 6));
				 seen__39_6681 = CBOOL(aux_18916);
			      }
			      {
				 create_vector_app_150_t new2220_6682;
				 new2220_6682 = ((create_vector_app_150_t) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
				 ((((create_vector_app_150_t) CREF(new2220_6682))->approx) = ((approx_t) approx_6675), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2220_6682))->value_approx_19) = ((approx_t) value_approx_19_6676), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2220_6682))->lost_stamp_114) = ((long) lost_stamp_114_6677), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2220_6682))->owner) = ((variable_t) owner_6678), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2220_6682))->stackable__42) = ((bool_t) stackable__42_6679), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2220_6682))->stack_stamp_31) = ((obj_t) arg3163_3445), BUNSPEC);
				 ((((create_vector_app_150_t) CREF(new2220_6682))->seen__39) = ((bool_t) seen__39_6681), BUNSPEC);
				 res3778_6690 = new2220_6682;
			      }
			   }
			   arg3157_3439 = res3778_6690;
			}
		     }
		     {
			obj_t aux_18929;
			object_t aux_18927;
			aux_18929 = (obj_t) (arg3157_3439);
			aux_18927 = (object_t) (new2248_3437);
			OBJECT_WIDENING_SET(aux_18927, aux_18929);
		     }
		  }
		  aux_18882 = new2248_3437;
	       }
	    }
	 }
	 return (obj_t) (aux_18882);
      }
   }
}


/* object->struct-create-vector-app */ obj_t 
object__struct_create_vector_app_178_cfa_info(obj_t env_10574, obj_t obj2243_10575)
{
   {
      create_vector_app_150_t obj2243_3406;
      obj2243_3406 = (create_vector_app_150_t) (obj2243_10575);
      {
	 {
	    obj_t res2244_3409;
	    {
	       obj_t next_method2511_217_3429;
	       next_method2511_217_3429 = find_super_class_method_167___object((object_t) (obj2243_3406), object__struct_env_210___object, create_vector_app_150_cfa_info);
	       if (PROCEDUREP(next_method2511_217_3429))
		 {
		    res2244_3409 = PROCEDURE_ENTRY(next_method2511_217_3429) (next_method2511_217_3429, (obj_t) (obj2243_3406), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2511_217_3429);
		    res2244_3409 = object__struct_50___object((object_t) (obj2243_3406));
		 }
	    }
	    {
	       obj_t aux2245_3410;
	       {
		  obj_t aux_18944;
		  aux_18944 = CNST_TABLE_REF(((long) 41));
		  aux2245_3410 = make_struct(aux_18944, ((long) 7), BUNSPEC);
	       }
	       {
		  obj_t aux_18947;
		  {
		     approx_t aux_18948;
		     {
			obj_t aux_18949;
			{
			   object_t aux_18950;
			   aux_18950 = (object_t) (obj2243_3406);
			   aux_18949 = OBJECT_WIDENING(aux_18950);
			}
			aux_18948 = (((create_vector_app_150_t) CREF(aux_18949))->approx);
		     }
		     aux_18947 = (obj_t) (aux_18948);
		  }
		  STRUCT_SET(aux2245_3410, ((long) 0), aux_18947);
	       }
	       {
		  obj_t aux_18956;
		  {
		     approx_t aux_18957;
		     {
			obj_t aux_18958;
			{
			   object_t aux_18959;
			   aux_18959 = (object_t) (obj2243_3406);
			   aux_18958 = OBJECT_WIDENING(aux_18959);
			}
			aux_18957 = (((create_vector_app_150_t) CREF(aux_18958))->value_approx_19);
		     }
		     aux_18956 = (obj_t) (aux_18957);
		  }
		  STRUCT_SET(aux2245_3410, ((long) 1), aux_18956);
	       }
	       {
		  obj_t aux_18965;
		  {
		     long aux_18966;
		     {
			obj_t aux_18967;
			{
			   object_t aux_18968;
			   aux_18968 = (object_t) (obj2243_3406);
			   aux_18967 = OBJECT_WIDENING(aux_18968);
			}
			aux_18966 = (((create_vector_app_150_t) CREF(aux_18967))->lost_stamp_114);
		     }
		     aux_18965 = BINT(aux_18966);
		  }
		  STRUCT_SET(aux2245_3410, ((long) 2), aux_18965);
	       }
	       {
		  obj_t aux_18974;
		  {
		     variable_t aux_18975;
		     {
			obj_t aux_18976;
			{
			   object_t aux_18977;
			   aux_18977 = (object_t) (obj2243_3406);
			   aux_18976 = OBJECT_WIDENING(aux_18977);
			}
			aux_18975 = (((create_vector_app_150_t) CREF(aux_18976))->owner);
		     }
		     aux_18974 = (obj_t) (aux_18975);
		  }
		  STRUCT_SET(aux2245_3410, ((long) 3), aux_18974);
	       }
	       {
		  obj_t aux_18983;
		  {
		     bool_t aux_18984;
		     {
			obj_t aux_18985;
			{
			   object_t aux_18986;
			   aux_18986 = (object_t) (obj2243_3406);
			   aux_18985 = OBJECT_WIDENING(aux_18986);
			}
			aux_18984 = (((create_vector_app_150_t) CREF(aux_18985))->stackable__42);
		     }
		     aux_18983 = BBOOL(aux_18984);
		  }
		  STRUCT_SET(aux2245_3410, ((long) 4), aux_18983);
	       }
	       {
		  obj_t aux_18992;
		  {
		     obj_t aux_18993;
		     {
			object_t aux_18994;
			aux_18994 = (object_t) (obj2243_3406);
			aux_18993 = OBJECT_WIDENING(aux_18994);
		     }
		     aux_18992 = (((create_vector_app_150_t) CREF(aux_18993))->stack_stamp_31);
		  }
		  STRUCT_SET(aux2245_3410, ((long) 5), aux_18992);
	       }
	       {
		  obj_t aux_18999;
		  {
		     bool_t aux_19000;
		     {
			obj_t aux_19001;
			{
			   object_t aux_19002;
			   aux_19002 = (object_t) (obj2243_3406);
			   aux_19001 = OBJECT_WIDENING(aux_19002);
			}
			aux_19000 = (((create_vector_app_150_t) CREF(aux_19001))->seen__39);
		     }
		     aux_18999 = BBOOL(aux_19000);
		  }
		  STRUCT_SET(aux2245_3410, ((long) 6), aux_18999);
	       }
	       STRUCT_SET(res2244_3409, ((long) 0), aux2245_3410);
	       {
		  obj_t aux_19009;
		  aux_19009 = STRUCT_KEY(res2244_3409);
		  STRUCT_KEY_SET(aux2245_3410, aux_19009);
	       }
	       {
		  obj_t aux_19012;
		  aux_19012 = CNST_TABLE_REF(((long) 41));
		  STRUCT_KEY_SET(res2244_3409, aux_19012);
	       }
	       return res2244_3409;
	    }
	 }
      }
   }
}


/* struct+object->object-vector-ref-app */ obj_t 
struct_object__object_vector_ref_app_116_cfa_info(obj_t env_10576, obj_t o_10577, obj_t s_10578)
{
   {
      vector_ref_app_195_t o_3394;
      obj_t s_3395;
      {
	 vector_ref_app_195_t aux_19016;
	 o_3394 = (vector_ref_app_195_t) (o_10577);
	 s_3395 = s_10578;
	 {
	    {
	       obj_t old2264_3398;
	       obj_t aux2265_3399;
	       {
		  obj_t next_method2510_202_3404;
		  next_method2510_202_3404 = find_super_class_method_167___object((object_t) (o_3394), struct_object__object_env_209___object, vector_ref_app_195_cfa_info);
		  if (PROCEDUREP(next_method2510_202_3404))
		    {
		       old2264_3398 = PROCEDURE_ENTRY(next_method2510_202_3404) (next_method2510_202_3404, (obj_t) (o_3394), s_3395, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2510_202_3404);
		       {
			  object_t aux_19025;
			  aux_19025 = struct_object__object_93___object((object_t) (o_3394), s_3395);
			  old2264_3398 = (obj_t) (aux_19025);
		       }
		    }
	       }
	       aux2265_3399 = STRUCT_REF(s_3395, ((long) 0));
	       {
		  vector_ref_app_195_t new2266_3400;
		  new2266_3400 = ((vector_ref_app_195_t) (old2264_3398));
		  {
		     long arg3133_3401;
		     arg3133_3401 = class_num_218___object(vector_ref_app_195_cfa_info);
		     {
			obj_t obj_6606;
			obj_6606 = (obj_t) (new2266_3400);
			(((obj_t) CREF(obj_6606))->header = MAKE_HEADER(arg3133_3401, 0), BUNSPEC);
		     }
		  }
		  {
		     vector_ref_app_195_t arg3134_3402;
		     {
			vector_ref_app_195_t res3777_6613;
			{
			   approx_t approx_6610;
			   {
			      obj_t aux_19034;
			      aux_19034 = STRUCT_REF(aux2265_3399, ((long) 0));
			      approx_6610 = (approx_t) (aux_19034);
			   }
			   {
			      vector_ref_app_195_t new2249_6611;
			      new2249_6611 = ((vector_ref_app_195_t) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
			      ((((vector_ref_app_195_t) CREF(new2249_6611))->approx) = ((approx_t) approx_6610), BUNSPEC);
			      res3777_6613 = new2249_6611;
			   }
			}
			arg3134_3402 = res3777_6613;
		     }
		     {
			obj_t aux_19041;
			object_t aux_19039;
			aux_19041 = (obj_t) (arg3134_3402);
			aux_19039 = (object_t) (new2266_3400);
			OBJECT_WIDENING_SET(aux_19039, aux_19041);
		     }
		  }
		  aux_19016 = new2266_3400;
	       }
	    }
	 }
	 return (obj_t) (aux_19016);
      }
   }
}


/* object->struct-vector-ref-app */ obj_t 
object__struct_vector_ref_app_174_cfa_info(obj_t env_10579, obj_t obj2261_10580)
{
   {
      vector_ref_app_195_t obj2261_3381;
      obj2261_3381 = (vector_ref_app_195_t) (obj2261_10580);
      {
	 {
	    obj_t res2262_3384;
	    {
	       obj_t next_method2509_113_3392;
	       next_method2509_113_3392 = find_super_class_method_167___object((object_t) (obj2261_3381), object__struct_env_210___object, vector_ref_app_195_cfa_info);
	       if (PROCEDUREP(next_method2509_113_3392))
		 {
		    res2262_3384 = PROCEDURE_ENTRY(next_method2509_113_3392) (next_method2509_113_3392, (obj_t) (obj2261_3381), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2509_113_3392);
		    res2262_3384 = object__struct_50___object((object_t) (obj2261_3381));
		 }
	    }
	    {
	       obj_t aux2263_3385;
	       {
		  obj_t aux_19056;
		  aux_19056 = CNST_TABLE_REF(((long) 42));
		  aux2263_3385 = make_struct(aux_19056, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_19059;
		  {
		     approx_t aux_19060;
		     {
			obj_t aux_19061;
			{
			   object_t aux_19062;
			   aux_19062 = (object_t) (obj2261_3381);
			   aux_19061 = OBJECT_WIDENING(aux_19062);
			}
			aux_19060 = (((vector_ref_app_195_t) CREF(aux_19061))->approx);
		     }
		     aux_19059 = (obj_t) (aux_19060);
		  }
		  STRUCT_SET(aux2263_3385, ((long) 0), aux_19059);
	       }
	       STRUCT_SET(res2262_3384, ((long) 0), aux2263_3385);
	       {
		  obj_t aux_19069;
		  aux_19069 = STRUCT_KEY(res2262_3384);
		  STRUCT_KEY_SET(aux2263_3385, aux_19069);
	       }
	       {
		  obj_t aux_19072;
		  aux_19072 = CNST_TABLE_REF(((long) 42));
		  STRUCT_KEY_SET(res2262_3384, aux_19072);
	       }
	       return res2262_3384;
	    }
	 }
      }
   }
}


/* struct+object->object-vector-set!-app */ obj_t 
struct_object__object_vector_set__app_246_cfa_info(obj_t env_10581, obj_t o_10582, obj_t s_10583)
{
   {
      vector_set__app_21_t o_3369;
      obj_t s_3370;
      {
	 vector_set__app_21_t aux_19076;
	 o_3369 = (vector_set__app_21_t) (o_10582);
	 s_3370 = s_10583;
	 {
	    {
	       obj_t old2282_3373;
	       obj_t aux2283_3374;
	       {
		  obj_t next_method2508_112_3379;
		  next_method2508_112_3379 = find_super_class_method_167___object((object_t) (o_3369), struct_object__object_env_209___object, vector_set__app_21_cfa_info);
		  if (PROCEDUREP(next_method2508_112_3379))
		    {
		       old2282_3373 = PROCEDURE_ENTRY(next_method2508_112_3379) (next_method2508_112_3379, (obj_t) (o_3369), s_3370, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2508_112_3379);
		       {
			  object_t aux_19085;
			  aux_19085 = struct_object__object_93___object((object_t) (o_3369), s_3370);
			  old2282_3373 = (obj_t) (aux_19085);
		       }
		    }
	       }
	       aux2283_3374 = STRUCT_REF(s_3370, ((long) 0));
	       {
		  vector_set__app_21_t new2284_3375;
		  new2284_3375 = ((vector_set__app_21_t) (old2282_3373));
		  {
		     long arg3120_3376;
		     arg3120_3376 = class_num_218___object(vector_set__app_21_cfa_info);
		     {
			obj_t obj_6577;
			obj_6577 = (obj_t) (new2284_3375);
			(((obj_t) CREF(obj_6577))->header = MAKE_HEADER(arg3120_3376, 0), BUNSPEC);
		     }
		  }
		  {
		     vector_set__app_21_t arg3121_3377;
		     {
			vector_set__app_21_t res3776_6584;
			{
			   approx_t approx_6581;
			   {
			      obj_t aux_19094;
			      aux_19094 = STRUCT_REF(aux2283_3374, ((long) 0));
			      approx_6581 = (approx_t) (aux_19094);
			   }
			   {
			      vector_set__app_21_t new2267_6582;
			      new2267_6582 = ((vector_set__app_21_t) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
			      ((((vector_set__app_21_t) CREF(new2267_6582))->approx) = ((approx_t) approx_6581), BUNSPEC);
			      res3776_6584 = new2267_6582;
			   }
			}
			arg3121_3377 = res3776_6584;
		     }
		     {
			obj_t aux_19101;
			object_t aux_19099;
			aux_19101 = (obj_t) (arg3121_3377);
			aux_19099 = (object_t) (new2284_3375);
			OBJECT_WIDENING_SET(aux_19099, aux_19101);
		     }
		  }
		  aux_19076 = new2284_3375;
	       }
	    }
	 }
	 return (obj_t) (aux_19076);
      }
   }
}


/* object->struct-vector-set!-app */ obj_t 
object__struct_vector_set__app_75_cfa_info(obj_t env_10584, obj_t obj2279_10585)
{
   {
      vector_set__app_21_t obj2279_3356;
      obj2279_3356 = (vector_set__app_21_t) (obj2279_10585);
      {
	 {
	    obj_t res2280_3359;
	    {
	       obj_t next_method2507_6_3367;
	       next_method2507_6_3367 = find_super_class_method_167___object((object_t) (obj2279_3356), object__struct_env_210___object, vector_set__app_21_cfa_info);
	       if (PROCEDUREP(next_method2507_6_3367))
		 {
		    res2280_3359 = PROCEDURE_ENTRY(next_method2507_6_3367) (next_method2507_6_3367, (obj_t) (obj2279_3356), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2507_6_3367);
		    res2280_3359 = object__struct_50___object((object_t) (obj2279_3356));
		 }
	    }
	    {
	       obj_t aux2281_3360;
	       {
		  obj_t aux_19116;
		  aux_19116 = CNST_TABLE_REF(((long) 43));
		  aux2281_3360 = make_struct(aux_19116, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_19119;
		  {
		     approx_t aux_19120;
		     {
			obj_t aux_19121;
			{
			   object_t aux_19122;
			   aux_19122 = (object_t) (obj2279_3356);
			   aux_19121 = OBJECT_WIDENING(aux_19122);
			}
			aux_19120 = (((vector_set__app_21_t) CREF(aux_19121))->approx);
		     }
		     aux_19119 = (obj_t) (aux_19120);
		  }
		  STRUCT_SET(aux2281_3360, ((long) 0), aux_19119);
	       }
	       STRUCT_SET(res2280_3359, ((long) 0), aux2281_3360);
	       {
		  obj_t aux_19129;
		  aux_19129 = STRUCT_KEY(res2280_3359);
		  STRUCT_KEY_SET(aux2281_3360, aux_19129);
	       }
	       {
		  obj_t aux_19132;
		  aux_19132 = CNST_TABLE_REF(((long) 43));
		  STRUCT_KEY_SET(res2280_3359, aux_19132);
	       }
	       return res2280_3359;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-make-struct-app */ obj_t 
struct_object__object_pre_make_struct_app_226_cfa_info(obj_t env_10586, obj_t o_10587, obj_t s_10588)
{
   {
      pre_make_struct_app_218_t o_3344;
      obj_t s_3345;
      {
	 pre_make_struct_app_218_t aux_19136;
	 o_3344 = (pre_make_struct_app_218_t) (o_10587);
	 s_3345 = s_10588;
	 {
	    {
	       obj_t old2300_3348;
	       obj_t aux2301_3349;
	       {
		  obj_t next_method2506_24_3354;
		  next_method2506_24_3354 = find_super_class_method_167___object((object_t) (o_3344), struct_object__object_env_209___object, pre_make_struct_app_218_cfa_info);
		  if (PROCEDUREP(next_method2506_24_3354))
		    {
		       old2300_3348 = PROCEDURE_ENTRY(next_method2506_24_3354) (next_method2506_24_3354, (obj_t) (o_3344), s_3345, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2506_24_3354);
		       {
			  object_t aux_19145;
			  aux_19145 = struct_object__object_93___object((object_t) (o_3344), s_3345);
			  old2300_3348 = (obj_t) (aux_19145);
		       }
		    }
	       }
	       aux2301_3349 = STRUCT_REF(s_3345, ((long) 0));
	       {
		  pre_make_struct_app_218_t new2302_3350;
		  new2302_3350 = ((pre_make_struct_app_218_t) (old2300_3348));
		  {
		     long arg3109_3351;
		     arg3109_3351 = class_num_218___object(pre_make_struct_app_218_cfa_info);
		     {
			obj_t obj_6548;
			obj_6548 = (obj_t) (new2302_3350);
			(((obj_t) CREF(obj_6548))->header = MAKE_HEADER(arg3109_3351, 0), BUNSPEC);
		     }
		  }
		  {
		     pre_make_struct_app_218_t arg3110_3352;
		     {
			pre_make_struct_app_218_t res3775_6555;
			{
			   variable_t owner_6552;
			   {
			      obj_t aux_19154;
			      aux_19154 = STRUCT_REF(aux2301_3349, ((long) 0));
			      owner_6552 = (variable_t) (aux_19154);
			   }
			   {
			      pre_make_struct_app_218_t new2285_6553;
			      new2285_6553 = ((pre_make_struct_app_218_t) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
			      ((((pre_make_struct_app_218_t) CREF(new2285_6553))->owner) = ((variable_t) owner_6552), BUNSPEC);
			      res3775_6555 = new2285_6553;
			   }
			}
			arg3110_3352 = res3775_6555;
		     }
		     {
			obj_t aux_19161;
			object_t aux_19159;
			aux_19161 = (obj_t) (arg3110_3352);
			aux_19159 = (object_t) (new2302_3350);
			OBJECT_WIDENING_SET(aux_19159, aux_19161);
		     }
		  }
		  aux_19136 = new2302_3350;
	       }
	    }
	 }
	 return (obj_t) (aux_19136);
      }
   }
}


/* object->struct-pre-make-struct-app */ obj_t 
object__struct_pre_make_struct_app_244_cfa_info(obj_t env_10589, obj_t obj2297_10590)
{
   {
      pre_make_struct_app_218_t obj2297_3331;
      obj2297_3331 = (pre_make_struct_app_218_t) (obj2297_10590);
      {
	 {
	    obj_t res2298_3334;
	    {
	       obj_t next_method2505_81_3342;
	       next_method2505_81_3342 = find_super_class_method_167___object((object_t) (obj2297_3331), object__struct_env_210___object, pre_make_struct_app_218_cfa_info);
	       if (PROCEDUREP(next_method2505_81_3342))
		 {
		    res2298_3334 = PROCEDURE_ENTRY(next_method2505_81_3342) (next_method2505_81_3342, (obj_t) (obj2297_3331), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2505_81_3342);
		    res2298_3334 = object__struct_50___object((object_t) (obj2297_3331));
		 }
	    }
	    {
	       obj_t aux2299_3335;
	       {
		  obj_t aux_19176;
		  aux_19176 = CNST_TABLE_REF(((long) 44));
		  aux2299_3335 = make_struct(aux_19176, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_19179;
		  {
		     variable_t aux_19180;
		     {
			obj_t aux_19181;
			{
			   object_t aux_19182;
			   aux_19182 = (object_t) (obj2297_3331);
			   aux_19181 = OBJECT_WIDENING(aux_19182);
			}
			aux_19180 = (((pre_make_struct_app_218_t) CREF(aux_19181))->owner);
		     }
		     aux_19179 = (obj_t) (aux_19180);
		  }
		  STRUCT_SET(aux2299_3335, ((long) 0), aux_19179);
	       }
	       STRUCT_SET(res2298_3334, ((long) 0), aux2299_3335);
	       {
		  obj_t aux_19189;
		  aux_19189 = STRUCT_KEY(res2298_3334);
		  STRUCT_KEY_SET(aux2299_3335, aux_19189);
	       }
	       {
		  obj_t aux_19192;
		  aux_19192 = CNST_TABLE_REF(((long) 44));
		  STRUCT_KEY_SET(res2298_3334, aux_19192);
	       }
	       return res2298_3334;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-struct-ref-app */ obj_t 
struct_object__object_pre_struct_ref_app_167_cfa_info(obj_t env_10591, obj_t o_10592, obj_t s_10593)
{
   {
      pre_struct_ref_app_207_t o_3320;
      obj_t s_3321;
      {
	 pre_struct_ref_app_207_t aux_19196;
	 o_3320 = (pre_struct_ref_app_207_t) (o_10592);
	 s_3321 = s_10593;
	 {
	    {
	       obj_t old2317_3324;
	       {
		  obj_t next_method2504_20_3329;
		  next_method2504_20_3329 = find_super_class_method_167___object((object_t) (o_3320), struct_object__object_env_209___object, pre_struct_ref_app_207_cfa_info);
		  if (PROCEDUREP(next_method2504_20_3329))
		    {
		       old2317_3324 = PROCEDURE_ENTRY(next_method2504_20_3329) (next_method2504_20_3329, (obj_t) (o_3320), s_3321, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2504_20_3329);
		       {
			  object_t aux_19205;
			  aux_19205 = struct_object__object_93___object((object_t) (o_3320), s_3321);
			  old2317_3324 = (obj_t) (aux_19205);
		       }
		    }
	       }
	       {
		  pre_struct_ref_app_207_t new2319_3326;
		  new2319_3326 = ((pre_struct_ref_app_207_t) (old2317_3324));
		  {
		     long arg3099_3327;
		     arg3099_3327 = class_num_218___object(pre_struct_ref_app_207_cfa_info);
		     {
			obj_t obj_6523;
			obj_6523 = (obj_t) (new2319_3326);
			(((obj_t) CREF(obj_6523))->header = MAKE_HEADER(arg3099_3327, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_19215;
		     object_t aux_19213;
		     {
			pre_struct_ref_app_207_t aux_19216;
			{
			   aux_19216 = ((pre_struct_ref_app_207_t) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
			}
			aux_19215 = (obj_t) (aux_19216);
		     }
		     aux_19213 = (object_t) (new2319_3326);
		     OBJECT_WIDENING_SET(aux_19213, aux_19215);
		  }
		  aux_19196 = new2319_3326;
	       }
	    }
	 }
	 return (obj_t) (aux_19196);
      }
   }
}


/* object->struct-pre-struct-ref-app */ obj_t 
object__struct_pre_struct_ref_app_38_cfa_info(obj_t env_10594, obj_t obj2314_10595)
{
   {
      pre_struct_ref_app_207_t obj2314_3309;
      obj2314_3309 = (pre_struct_ref_app_207_t) (obj2314_10595);
      {
	 {
	    obj_t res2315_3312;
	    {
	       obj_t next_method2503_127_3318;
	       next_method2503_127_3318 = find_super_class_method_167___object((object_t) (obj2314_3309), object__struct_env_210___object, pre_struct_ref_app_207_cfa_info);
	       if (PROCEDUREP(next_method2503_127_3318))
		 {
		    res2315_3312 = PROCEDURE_ENTRY(next_method2503_127_3318) (next_method2503_127_3318, (obj_t) (obj2314_3309), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2503_127_3318);
		    res2315_3312 = object__struct_50___object((object_t) (obj2314_3309));
		 }
	    }
	    {
	       obj_t aux2316_3313;
	       {
		  obj_t aux_19232;
		  aux_19232 = CNST_TABLE_REF(((long) 45));
		  aux2316_3313 = make_struct(aux_19232, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2315_3312, ((long) 0), aux2316_3313);
	       {
		  obj_t aux_19236;
		  aux_19236 = STRUCT_KEY(res2315_3312);
		  STRUCT_KEY_SET(aux2316_3313, aux_19236);
	       }
	       {
		  obj_t aux_19239;
		  aux_19239 = CNST_TABLE_REF(((long) 45));
		  STRUCT_KEY_SET(res2315_3312, aux_19239);
	       }
	       return res2315_3312;
	    }
	 }
      }
   }
}


/* struct+object->object-pre-struct-set!-app */ obj_t 
struct_object__object_pre_struct_set__app_147_cfa_info(obj_t env_10596, obj_t o_10597, obj_t s_10598)
{
   {
      pre_struct_set__app_116_t o_3298;
      obj_t s_3299;
      {
	 pre_struct_set__app_116_t aux_19243;
	 o_3298 = (pre_struct_set__app_116_t) (o_10597);
	 s_3299 = s_10598;
	 {
	    {
	       obj_t old2334_3302;
	       {
		  obj_t next_method2502_17_3307;
		  next_method2502_17_3307 = find_super_class_method_167___object((object_t) (o_3298), struct_object__object_env_209___object, pre_struct_set__app_116_cfa_info);
		  if (PROCEDUREP(next_method2502_17_3307))
		    {
		       old2334_3302 = PROCEDURE_ENTRY(next_method2502_17_3307) (next_method2502_17_3307, (obj_t) (o_3298), s_3299, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2502_17_3307);
		       {
			  object_t aux_19252;
			  aux_19252 = struct_object__object_93___object((object_t) (o_3298), s_3299);
			  old2334_3302 = (obj_t) (aux_19252);
		       }
		    }
	       }
	       {
		  pre_struct_set__app_116_t new2336_3304;
		  new2336_3304 = ((pre_struct_set__app_116_t) (old2334_3302));
		  {
		     long arg3091_3305;
		     arg3091_3305 = class_num_218___object(pre_struct_set__app_116_cfa_info);
		     {
			obj_t obj_6502;
			obj_6502 = (obj_t) (new2336_3304);
			(((obj_t) CREF(obj_6502))->header = MAKE_HEADER(arg3091_3305, 0), BUNSPEC);
		     }
		  }
		  {
		     obj_t aux_19262;
		     object_t aux_19260;
		     {
			pre_struct_set__app_116_t aux_19263;
			{
			   aux_19263 = ((pre_struct_set__app_116_t) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
			}
			aux_19262 = (obj_t) (aux_19263);
		     }
		     aux_19260 = (object_t) (new2336_3304);
		     OBJECT_WIDENING_SET(aux_19260, aux_19262);
		  }
		  aux_19243 = new2336_3304;
	       }
	    }
	 }
	 return (obj_t) (aux_19243);
      }
   }
}


/* object->struct-pre-struct-set!-app */ obj_t 
object__struct_pre_struct_set__app_44_cfa_info(obj_t env_10599, obj_t obj2331_10600)
{
   {
      pre_struct_set__app_116_t obj2331_3287;
      obj2331_3287 = (pre_struct_set__app_116_t) (obj2331_10600);
      {
	 {
	    obj_t res2332_3290;
	    {
	       obj_t next_method2501_91_3296;
	       next_method2501_91_3296 = find_super_class_method_167___object((object_t) (obj2331_3287), object__struct_env_210___object, pre_struct_set__app_116_cfa_info);
	       if (PROCEDUREP(next_method2501_91_3296))
		 {
		    res2332_3290 = PROCEDURE_ENTRY(next_method2501_91_3296) (next_method2501_91_3296, (obj_t) (obj2331_3287), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2501_91_3296);
		    res2332_3290 = object__struct_50___object((object_t) (obj2331_3287));
		 }
	    }
	    {
	       obj_t aux2333_3291;
	       {
		  obj_t aux_19279;
		  aux_19279 = CNST_TABLE_REF(((long) 46));
		  aux2333_3291 = make_struct(aux_19279, ((long) 0), BUNSPEC);
	       }
	       STRUCT_SET(res2332_3290, ((long) 0), aux2333_3291);
	       {
		  obj_t aux_19283;
		  aux_19283 = STRUCT_KEY(res2332_3290);
		  STRUCT_KEY_SET(aux2333_3291, aux_19283);
	       }
	       {
		  obj_t aux_19286;
		  aux_19286 = CNST_TABLE_REF(((long) 46));
		  STRUCT_KEY_SET(res2332_3290, aux_19286);
	       }
	       return res2332_3290;
	    }
	 }
      }
   }
}


/* struct+object->object-make-struct-app */ obj_t 
struct_object__object_make_struct_app_10_cfa_info(obj_t env_10601, obj_t o_10602, obj_t s_10603)
{
   {
      make_struct_app_214_t o_3270;
      obj_t s_3271;
      {
	 make_struct_app_214_t aux_19290;
	 o_3270 = (make_struct_app_214_t) (o_10602);
	 s_3271 = s_10603;
	 {
	    {
	       obj_t old2361_3274;
	       obj_t aux2362_3275;
	       {
		  obj_t next_method2500_92_3285;
		  next_method2500_92_3285 = find_super_class_method_167___object((object_t) (o_3270), struct_object__object_env_209___object, make_struct_app_214_cfa_info);
		  if (PROCEDUREP(next_method2500_92_3285))
		    {
		       old2361_3274 = PROCEDURE_ENTRY(next_method2500_92_3285) (next_method2500_92_3285, (obj_t) (o_3270), s_3271, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2500_92_3285);
		       {
			  object_t aux_19299;
			  aux_19299 = struct_object__object_93___object((object_t) (o_3270), s_3271);
			  old2361_3274 = (obj_t) (aux_19299);
		       }
		    }
	       }
	       aux2362_3275 = STRUCT_REF(s_3271, ((long) 0));
	       {
		  make_struct_app_214_t new2363_3276;
		  new2363_3276 = ((make_struct_app_214_t) (old2361_3274));
		  {
		     long arg3077_3277;
		     arg3077_3277 = class_num_218___object(make_struct_app_214_cfa_info);
		     {
			obj_t obj_6457;
			obj_6457 = (obj_t) (new2363_3276);
			(((obj_t) CREF(obj_6457))->header = MAKE_HEADER(arg3077_3277, 0), BUNSPEC);
		     }
		  }
		  {
		     make_struct_app_214_t arg3078_3278;
		     {
			obj_t arg3084_3284;
			arg3084_3284 = STRUCT_REF(aux2362_3275, ((long) 5));
			{
			   make_struct_app_214_t res3772_6484;
			   {
			      approx_t approx_6471;
			      approx_t value_approx_19_6472;
			      long lost_stamp_114_6473;
			      variable_t owner_6474;
			      bool_t stackable__42_6475;
			      {
				 obj_t aux_19309;
				 aux_19309 = STRUCT_REF(aux2362_3275, ((long) 0));
				 approx_6471 = (approx_t) (aux_19309);
			      }
			      {
				 obj_t aux_19312;
				 aux_19312 = STRUCT_REF(aux2362_3275, ((long) 1));
				 value_approx_19_6472 = (approx_t) (aux_19312);
			      }
			      {
				 obj_t aux_19315;
				 aux_19315 = STRUCT_REF(aux2362_3275, ((long) 2));
				 lost_stamp_114_6473 = (long) CINT(aux_19315);
			      }
			      {
				 obj_t aux_19318;
				 aux_19318 = STRUCT_REF(aux2362_3275, ((long) 3));
				 owner_6474 = (variable_t) (aux_19318);
			      }
			      {
				 obj_t aux_19321;
				 aux_19321 = STRUCT_REF(aux2362_3275, ((long) 4));
				 stackable__42_6475 = CBOOL(aux_19321);
			      }
			      {
				 make_struct_app_214_t new2337_6477;
				 new2337_6477 = ((make_struct_app_214_t) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
				 ((((make_struct_app_214_t) CREF(new2337_6477))->approx) = ((approx_t) approx_6471), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2337_6477))->value_approx_19) = ((approx_t) value_approx_19_6472), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2337_6477))->lost_stamp_114) = ((long) lost_stamp_114_6473), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2337_6477))->owner) = ((variable_t) owner_6474), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2337_6477))->stackable__42) = ((bool_t) stackable__42_6475), BUNSPEC);
				 ((((make_struct_app_214_t) CREF(new2337_6477))->stack_stamp_31) = ((obj_t) arg3084_3284), BUNSPEC);
				 res3772_6484 = new2337_6477;
			      }
			   }
			   arg3078_3278 = res3772_6484;
			}
		     }
		     {
			obj_t aux_19333;
			object_t aux_19331;
			aux_19333 = (obj_t) (arg3078_3278);
			aux_19331 = (object_t) (new2363_3276);
			OBJECT_WIDENING_SET(aux_19331, aux_19333);
		     }
		  }
		  aux_19290 = new2363_3276;
	       }
	    }
	 }
	 return (obj_t) (aux_19290);
      }
   }
}


/* object->struct-make-struct-app */ obj_t 
object__struct_make_struct_app_173_cfa_info(obj_t env_10604, obj_t obj2358_10605)
{
   {
      make_struct_app_214_t obj2358_3247;
      obj2358_3247 = (make_struct_app_214_t) (obj2358_10605);
      {
	 {
	    obj_t res2359_3250;
	    {
	       obj_t next_method2499_215_3268;
	       next_method2499_215_3268 = find_super_class_method_167___object((object_t) (obj2358_3247), object__struct_env_210___object, make_struct_app_214_cfa_info);
	       if (PROCEDUREP(next_method2499_215_3268))
		 {
		    res2359_3250 = PROCEDURE_ENTRY(next_method2499_215_3268) (next_method2499_215_3268, (obj_t) (obj2358_3247), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2499_215_3268);
		    res2359_3250 = object__struct_50___object((object_t) (obj2358_3247));
		 }
	    }
	    {
	       obj_t aux2360_3251;
	       {
		  obj_t aux_19348;
		  aux_19348 = CNST_TABLE_REF(((long) 47));
		  aux2360_3251 = make_struct(aux_19348, ((long) 6), BUNSPEC);
	       }
	       {
		  obj_t aux_19351;
		  {
		     approx_t aux_19352;
		     {
			obj_t aux_19353;
			{
			   object_t aux_19354;
			   aux_19354 = (object_t) (obj2358_3247);
			   aux_19353 = OBJECT_WIDENING(aux_19354);
			}
			aux_19352 = (((make_struct_app_214_t) CREF(aux_19353))->approx);
		     }
		     aux_19351 = (obj_t) (aux_19352);
		  }
		  STRUCT_SET(aux2360_3251, ((long) 0), aux_19351);
	       }
	       {
		  obj_t aux_19360;
		  {
		     approx_t aux_19361;
		     {
			obj_t aux_19362;
			{
			   object_t aux_19363;
			   aux_19363 = (object_t) (obj2358_3247);
			   aux_19362 = OBJECT_WIDENING(aux_19363);
			}
			aux_19361 = (((make_struct_app_214_t) CREF(aux_19362))->value_approx_19);
		     }
		     aux_19360 = (obj_t) (aux_19361);
		  }
		  STRUCT_SET(aux2360_3251, ((long) 1), aux_19360);
	       }
	       {
		  obj_t aux_19369;
		  {
		     long aux_19370;
		     {
			obj_t aux_19371;
			{
			   object_t aux_19372;
			   aux_19372 = (object_t) (obj2358_3247);
			   aux_19371 = OBJECT_WIDENING(aux_19372);
			}
			aux_19370 = (((make_struct_app_214_t) CREF(aux_19371))->lost_stamp_114);
		     }
		     aux_19369 = BINT(aux_19370);
		  }
		  STRUCT_SET(aux2360_3251, ((long) 2), aux_19369);
	       }
	       {
		  obj_t aux_19378;
		  {
		     variable_t aux_19379;
		     {
			obj_t aux_19380;
			{
			   object_t aux_19381;
			   aux_19381 = (object_t) (obj2358_3247);
			   aux_19380 = OBJECT_WIDENING(aux_19381);
			}
			aux_19379 = (((make_struct_app_214_t) CREF(aux_19380))->owner);
		     }
		     aux_19378 = (obj_t) (aux_19379);
		  }
		  STRUCT_SET(aux2360_3251, ((long) 3), aux_19378);
	       }
	       {
		  obj_t aux_19387;
		  {
		     bool_t aux_19388;
		     {
			obj_t aux_19389;
			{
			   object_t aux_19390;
			   aux_19390 = (object_t) (obj2358_3247);
			   aux_19389 = OBJECT_WIDENING(aux_19390);
			}
			aux_19388 = (((make_struct_app_214_t) CREF(aux_19389))->stackable__42);
		     }
		     aux_19387 = BBOOL(aux_19388);
		  }
		  STRUCT_SET(aux2360_3251, ((long) 4), aux_19387);
	       }
	       {
		  obj_t aux_19396;
		  {
		     obj_t aux_19397;
		     {
			object_t aux_19398;
			aux_19398 = (object_t) (obj2358_3247);
			aux_19397 = OBJECT_WIDENING(aux_19398);
		     }
		     aux_19396 = (((make_struct_app_214_t) CREF(aux_19397))->stack_stamp_31);
		  }
		  STRUCT_SET(aux2360_3251, ((long) 5), aux_19396);
	       }
	       STRUCT_SET(res2359_3250, ((long) 0), aux2360_3251);
	       {
		  obj_t aux_19404;
		  aux_19404 = STRUCT_KEY(res2359_3250);
		  STRUCT_KEY_SET(aux2360_3251, aux_19404);
	       }
	       {
		  obj_t aux_19407;
		  aux_19407 = CNST_TABLE_REF(((long) 47));
		  STRUCT_KEY_SET(res2359_3250, aux_19407);
	       }
	       return res2359_3250;
	    }
	 }
      }
   }
}


/* struct+object->object-struct-ref-app */ obj_t 
struct_object__object_struct_ref_app_176_cfa_info(obj_t env_10606, obj_t o_10607, obj_t s_10608)
{
   {
      struct_ref_app_73_t o_3235;
      obj_t s_3236;
      {
	 struct_ref_app_73_t aux_19411;
	 o_3235 = (struct_ref_app_73_t) (o_10607);
	 s_3236 = s_10608;
	 {
	    {
	       obj_t old2379_3239;
	       obj_t aux2380_3240;
	       {
		  obj_t next_method2498_160_3245;
		  next_method2498_160_3245 = find_super_class_method_167___object((object_t) (o_3235), struct_object__object_env_209___object, struct_ref_app_73_cfa_info);
		  if (PROCEDUREP(next_method2498_160_3245))
		    {
		       old2379_3239 = PROCEDURE_ENTRY(next_method2498_160_3245) (next_method2498_160_3245, (obj_t) (o_3235), s_3236, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2498_160_3245);
		       {
			  object_t aux_19420;
			  aux_19420 = struct_object__object_93___object((object_t) (o_3235), s_3236);
			  old2379_3239 = (obj_t) (aux_19420);
		       }
		    }
	       }
	       aux2380_3240 = STRUCT_REF(s_3236, ((long) 0));
	       {
		  struct_ref_app_73_t new2381_3241;
		  new2381_3241 = ((struct_ref_app_73_t) (old2379_3239));
		  {
		     long arg3056_3242;
		     arg3056_3242 = class_num_218___object(struct_ref_app_73_cfa_info);
		     {
			obj_t obj_6408;
			obj_6408 = (obj_t) (new2381_3241);
			(((obj_t) CREF(obj_6408))->header = MAKE_HEADER(arg3056_3242, 0), BUNSPEC);
		     }
		  }
		  {
		     struct_ref_app_73_t arg3057_3243;
		     {
			struct_ref_app_73_t res3771_6415;
			{
			   approx_t approx_6412;
			   {
			      obj_t aux_19429;
			      aux_19429 = STRUCT_REF(aux2380_3240, ((long) 0));
			      approx_6412 = (approx_t) (aux_19429);
			   }
			   {
			      struct_ref_app_73_t new2364_6413;
			      new2364_6413 = ((struct_ref_app_73_t) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
			      ((((struct_ref_app_73_t) CREF(new2364_6413))->approx) = ((approx_t) approx_6412), BUNSPEC);
			      res3771_6415 = new2364_6413;
			   }
			}
			arg3057_3243 = res3771_6415;
		     }
		     {
			obj_t aux_19436;
			object_t aux_19434;
			aux_19436 = (obj_t) (arg3057_3243);
			aux_19434 = (object_t) (new2381_3241);
			OBJECT_WIDENING_SET(aux_19434, aux_19436);
		     }
		  }
		  aux_19411 = new2381_3241;
	       }
	    }
	 }
	 return (obj_t) (aux_19411);
      }
   }
}


/* object->struct-struct-ref-app */ obj_t 
object__struct_struct_ref_app_85_cfa_info(obj_t env_10609, obj_t obj2376_10610)
{
   {
      struct_ref_app_73_t obj2376_3222;
      obj2376_3222 = (struct_ref_app_73_t) (obj2376_10610);
      {
	 {
	    obj_t res2377_3225;
	    {
	       obj_t next_method2497_179_3233;
	       next_method2497_179_3233 = find_super_class_method_167___object((object_t) (obj2376_3222), object__struct_env_210___object, struct_ref_app_73_cfa_info);
	       if (PROCEDUREP(next_method2497_179_3233))
		 {
		    res2377_3225 = PROCEDURE_ENTRY(next_method2497_179_3233) (next_method2497_179_3233, (obj_t) (obj2376_3222), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2497_179_3233);
		    res2377_3225 = object__struct_50___object((object_t) (obj2376_3222));
		 }
	    }
	    {
	       obj_t aux2378_3226;
	       {
		  obj_t aux_19451;
		  aux_19451 = CNST_TABLE_REF(((long) 48));
		  aux2378_3226 = make_struct(aux_19451, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_19454;
		  {
		     approx_t aux_19455;
		     {
			obj_t aux_19456;
			{
			   object_t aux_19457;
			   aux_19457 = (object_t) (obj2376_3222);
			   aux_19456 = OBJECT_WIDENING(aux_19457);
			}
			aux_19455 = (((struct_ref_app_73_t) CREF(aux_19456))->approx);
		     }
		     aux_19454 = (obj_t) (aux_19455);
		  }
		  STRUCT_SET(aux2378_3226, ((long) 0), aux_19454);
	       }
	       STRUCT_SET(res2377_3225, ((long) 0), aux2378_3226);
	       {
		  obj_t aux_19464;
		  aux_19464 = STRUCT_KEY(res2377_3225);
		  STRUCT_KEY_SET(aux2378_3226, aux_19464);
	       }
	       {
		  obj_t aux_19467;
		  aux_19467 = CNST_TABLE_REF(((long) 48));
		  STRUCT_KEY_SET(res2377_3225, aux_19467);
	       }
	       return res2377_3225;
	    }
	 }
      }
   }
}


/* struct+object->object-struct-set!-app */ obj_t 
struct_object__object_struct_set__app_209_cfa_info(obj_t env_10611, obj_t o_10612, obj_t s_10613)
{
   {
      struct_set__app_162_t o_3210;
      obj_t s_3211;
      {
	 struct_set__app_162_t aux_19471;
	 o_3210 = (struct_set__app_162_t) (o_10612);
	 s_3211 = s_10613;
	 {
	    {
	       obj_t old2397_3214;
	       obj_t aux2398_3215;
	       {
		  obj_t next_method2496_62_3220;
		  next_method2496_62_3220 = find_super_class_method_167___object((object_t) (o_3210), struct_object__object_env_209___object, struct_set__app_162_cfa_info);
		  if (PROCEDUREP(next_method2496_62_3220))
		    {
		       old2397_3214 = PROCEDURE_ENTRY(next_method2496_62_3220) (next_method2496_62_3220, (obj_t) (o_3210), s_3211, BEOA);
		    }
		  else
		    {
		       PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2496_62_3220);
		       {
			  object_t aux_19480;
			  aux_19480 = struct_object__object_93___object((object_t) (o_3210), s_3211);
			  old2397_3214 = (obj_t) (aux_19480);
		       }
		    }
	       }
	       aux2398_3215 = STRUCT_REF(s_3211, ((long) 0));
	       {
		  struct_set__app_162_t new2399_3216;
		  new2399_3216 = ((struct_set__app_162_t) (old2397_3214));
		  {
		     long arg3045_3217;
		     arg3045_3217 = class_num_218___object(struct_set__app_162_cfa_info);
		     {
			obj_t obj_6379;
			obj_6379 = (obj_t) (new2399_3216);
			(((obj_t) CREF(obj_6379))->header = MAKE_HEADER(arg3045_3217, 0), BUNSPEC);
		     }
		  }
		  {
		     struct_set__app_162_t arg3046_3218;
		     {
			struct_set__app_162_t res3770_6386;
			{
			   approx_t approx_6383;
			   {
			      obj_t aux_19489;
			      aux_19489 = STRUCT_REF(aux2398_3215, ((long) 0));
			      approx_6383 = (approx_t) (aux_19489);
			   }
			   {
			      struct_set__app_162_t new2382_6384;
			      new2382_6384 = ((struct_set__app_162_t) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
			      ((((struct_set__app_162_t) CREF(new2382_6384))->approx) = ((approx_t) approx_6383), BUNSPEC);
			      res3770_6386 = new2382_6384;
			   }
			}
			arg3046_3218 = res3770_6386;
		     }
		     {
			obj_t aux_19496;
			object_t aux_19494;
			aux_19496 = (obj_t) (arg3046_3218);
			aux_19494 = (object_t) (new2399_3216);
			OBJECT_WIDENING_SET(aux_19494, aux_19496);
		     }
		  }
		  aux_19471 = new2399_3216;
	       }
	    }
	 }
	 return (obj_t) (aux_19471);
      }
   }
}


/* object->struct-struct-set!-app */ obj_t 
object__struct_struct_set__app_208_cfa_info(obj_t env_10614, obj_t obj2394_10615)
{
   {
      struct_set__app_162_t obj2394_3197;
      obj2394_3197 = (struct_set__app_162_t) (obj2394_10615);
      {
	 {
	    obj_t res2395_3200;
	    {
	       obj_t next_method2495_114_3208;
	       next_method2495_114_3208 = find_super_class_method_167___object((object_t) (obj2394_3197), object__struct_env_210___object, struct_set__app_162_cfa_info);
	       if (PROCEDUREP(next_method2495_114_3208))
		 {
		    res2395_3200 = PROCEDURE_ENTRY(next_method2495_114_3208) (next_method2495_114_3208, (obj_t) (obj2394_3197), BEOA);
		 }
	       else
		 {
		    PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2495_114_3208);
		    res2395_3200 = object__struct_50___object((object_t) (obj2394_3197));
		 }
	    }
	    {
	       obj_t aux2396_3201;
	       {
		  obj_t aux_19511;
		  aux_19511 = CNST_TABLE_REF(((long) 49));
		  aux2396_3201 = make_struct(aux_19511, ((long) 1), BUNSPEC);
	       }
	       {
		  obj_t aux_19514;
		  {
		     approx_t aux_19515;
		     {
			obj_t aux_19516;
			{
			   object_t aux_19517;
			   aux_19517 = (object_t) (obj2394_3197);
			   aux_19516 = OBJECT_WIDENING(aux_19517);
			}
			aux_19515 = (((struct_set__app_162_t) CREF(aux_19516))->approx);
		     }
		     aux_19514 = (obj_t) (aux_19515);
		  }
		  STRUCT_SET(aux2396_3201, ((long) 0), aux_19514);
	       }
	       STRUCT_SET(res2395_3200, ((long) 0), aux2396_3201);
	       {
		  obj_t aux_19524;
		  aux_19524 = STRUCT_KEY(res2395_3200);
		  STRUCT_KEY_SET(aux2396_3201, aux_19524);
	       }
	       {
		  obj_t aux_19527;
		  aux_19527 = CNST_TABLE_REF(((long) 49));
		  STRUCT_KEY_SET(res2395_3200, aux_19527);
	       }
	       return res2395_3200;
	    }
	 }
      }
   }
}


/* imported-modules-init */ obj_t 
imported_modules_init_94_cfa_info()
{
   module_initialization_70_type_type(((long) 0), "CFA_INFO");
   module_initialization_70_type_cache(((long) 0), "CFA_INFO");
   module_initialization_70_ast_var(((long) 0), "CFA_INFO");
   return module_initialization_70_ast_node(((long) 0), "CFA_INFO");
}
